#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
mt19937 rnd(time(NULL));
const int inf = 1e18, MAXN = 2e6+10, mod = 998244353, b1 = 29, b2 = 31, mod1 = (int)1e9+7, mod2 = 1e9+1011, K = 330;
const long double eps = 1e-9;
vector<vector<pair<int, int>>> g;
vector<int> w, dst;

void dijkstra_set(int st) {
    dst[st] = 0;
    set<pair<int, int>> q;
    q.insert({0, st});
    while (!q.empty()) {
        auto u = q.begin()->second;
        q.erase(q.begin());
        for (auto [v, wt] : g[u]) {
            if (dst[u]+wt < dst[v]) {
                q.erase({dst[v], v});
                dst[v] = dst[u]+wt;
                q.insert({dst[v], v});
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, p, G; cin >> n >> m >> p >> G;
    g.resize(n);
    w.resize(n);
    dst.resize(n, inf);
    input(w);
    vector<int> dst2(n);
    dst2[0] = 0;
    for (int i = 0; i<m; ++i) {
        int u, v, wt; cin >> u >> v >> wt;
        dst2[i+1] = dst2[i]+wt;
        g[u-1].emplace_back(v-1, wt);
    }
    if (G == 1) {
        dijkstra_set(0);
        if (dst[n-1] == inf) {
            cout << "-1\n";
            return 0;
        }
        cout << (p >= dst[n-1] ? 0 : dst[n-1]-p) << '\n';
        return 0;
    }
    if (G == 2) {
        int mx = w[0];
        int pos = 0, res = 0;
        while (pos+1 < n) {
            while (pos+1 < n && dst[pos+1] <= p) {
                pos++;
                assign_max(mx, w[pos]);
            }
            if (pos == n-1) break;
            int add = dst[pos+1]-p;
            res += (add+mx-1)/mx;
            p += ((add+mx-1)/mx)*mx;
        }
        cout << res << '\n';
        return 0;
    }
    return 0;
}
