#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

vector<vector<pair<int, int> > > g;
vector<vector<ll> > d;

void djkstra(int s) {
    priority_queue<pair<ll, int> > q;
    q.push({0, s});
    d[s][s] = 0;
    while (!q.empty()) {
        ll cur_l = -q.top().first;
        int v = q.top().second;
        q.pop();
        if (cur_l > d[s][v]) {
            continue;
        }
        for (auto to : g[v]) {
            if (d[s][to.first] > d[s][v] + to.second) {
                d[s][to.first] = d[s][v] + to.second;
                q.push({-d[s][to.first], to.first});
            }
        }
    }
}

void solve() {
    int n, m, p, t;
    cin >> n >> m >> p >> t;
    g.resize(n);
    vector<pair<int, int> > w_tmp(n);
    vector<int> old_w(n);
    d.resize(n, vector<ll>(n, INF));
    for (int i = 0; i < n; i++) {
        cin >> w_tmp[i].first;
        old_w[i] = w_tmp[i].first;
        w_tmp[i].second = i;
    }
    sort(w_tmp.begin(), w_tmp.end());
    vector<int> w(n), id(n);
    for (int i = 0; i < n; i++) {
        w[i] = w_tmp[i].first;
        id[i] = w_tmp[i].second;
    }
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a - 1].push_back({b - 1, s});
    }
    for (int i = 0; i < n; i++) {
        djkstra(i);
    }
    if (d[0][n - 1] == INF) {
        cout << -1;
    } else {
        if (t == 1) {
            cout << max(0ll, d[0][n - 1] - p);
        } else if (t == 2) {
            vector<int> a(n);
            for (int i = 0; i < n; i++) {
                a[i] = i;
            }
            ll cur_p = 0;
            int mx = 0;
            ll ans = 0;
            for (int i = 0; i < n; i++) {
                if (a[i] == n - 1) {
                    break;
                }
                mx = max(mx, old_w[a[i]]);
                if (cur_p < d[a[i]][a[i + 1]]) {
                    ans += (d[a[i]][a[i + 1]] - cur_p + mx - 1) / mx;
                    cur_p = cur_p + (d[a[i]][a[i + 1]] - cur_p + mx - 1) / mx * mx - d[a[i]][a[i + 1]];
                } else {
                    cur_p -= d[a[i]][a[i + 1]];
                }
            }
            cout << ans;
        } else if (t == 3) {
            vector<int> a(n);
            for (int i = 0; i < n; i++) {
                a[i] = i;
            }
            ll res = 1e18;
            do {
                if (a[0] != 0) {
                    continue;
                }
                ll cur_p = 0;
                int mx = 0;
                ll ans = 0;
                for (int i = 0; i < n; i++) {
                    if (a[i] == n - 1) {
                        break;
                    }
                    mx = max(mx, old_w[a[i]]);
                    if (cur_p < d[a[i]][a[i + 1]]) {
                        ans += (d[a[i]][a[i + 1]] - cur_p + mx - 1) / mx;
                        cur_p = cur_p + (d[a[i]][a[i + 1]] - cur_p + mx - 1) / mx * mx - d[a[i]][a[i + 1]];
                    } else {
                        cur_p -= d[a[i]][a[i + 1]];
                    }
                }
                res = min(res, ans);
            } while (next_permutation(a.begin(), a.end()));
            cout << res;
        } else if (t == 4) {
            if (p > 10000) {
                cout << 0;
            } else {
                vector<vector<ll> > dp(n, vector<ll>(10001));
                for (int i = n - 1; i >= 0; i--) {
                    for (int j = 0; j < 10001; j++) {
                        dp[i][j] = max(0ll, (d[id[i]][n - 1] - j + w[i] - 1) / w[i]);
                        for (int k = i + 1; k < n; k++) {
                            ll c = (d[id[i]][id[k]] - j + w[i] - 1) / w[i];
                            ll new_gas = c * j - d[id[i]][id[k]];
                            if (new_gas > 10000) {
                                dp[i][j] = c;
                            } else {
                                dp[i][j] = min(dp[i][j], (d[id[i]][id[k]] - j + w[i] - 1) / w[i] + dp[j][new_gas]);
                            }
                        }
                    }
                    if (id[i] == 0) {
                        cout << dp[i][p];
                        return;
                    }
                }
            }
        }
    }
}

int main() {
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\input.txt", "r", stdin);
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << setprecision(20) << fixed;
    solve();
}
