#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

const ll INF = 1e18 + 7;
const int INFi = 1e9 + 7;

typedef pair<long long, long long> pii;

bool cmp(pii a, pii b) {
    if (a.first < b.first)
        return true;
    if (a.first > b.first)
        return false;
    if (a.second > b.second)
        return true;
    return false;
}

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;

    vector<vector<pair<int, int>>> g(n);
    vector<int> ws(n);
    for (auto &el : ws) cin >> el;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c, --a, --b;
        g[a].emplace_back(b, c);
    }


    auto best = [&] (pii a, pii b) {
        if (a.first < b.first)
            return a;
        if (a.first > b.first)
            return b;
        if (a.second >= b.second)
            return a;
        return b;
    };

    vector<vector<int>> dist(n, vector<int>(n, INFi));
    for (int i = 0; i < n; ++i) {
        for (auto [to, w] : g[i])
            dist[i][to] = min(dist[i][to], w);
    }

    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
    }

    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    vector<pii> dp(n, {INF, -INF});
    dp[0] = {0, p};
    vector<bool> vis(n, false);
    for (int i = 0; i < n; ++i) {
        int ind = -1;
        pii b = {INF + 1, -INF};
        for (int curr = 0; curr < n; ++curr) {
            if (vis[curr])
                continue;
            if (cmp(dp[curr], b)) {
                b = dp[curr];
                ind = curr;
            }
        }

        vis[ind] = true;

        for (auto [to, w] : g[ind]) {
            for (int j = 0; j < n; ++j) {
                int d = dist[j][to];
                if (d >= INFi)
                    continue;
                pii f = dp[j];
                if (f.first >= INF)
                    continue;
                int need = d - f.second;
                if (need <= 0) {
                    dp[to] = best(dp[to], pii{f.first, f.second - d});
                } else {
                    int need_iterations = (need - 1) / ws[j] + 1;
                    ll bal = f.second;
                    bal -= d;
                    bal += 1LL * need_iterations * ws[j];
                    dp[to] = best(dp[to], pii{f.first + need_iterations, bal});
                }
            }
        }
    }

    ll answer = dp[n - 1].first;
    if (answer >= INF) {
        cout << -1;
    } else {
        cout << answer;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}