#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

#define int ll

typedef pair<int, int> pii;
const int INF = 1e18 + 7;

bool cmp(pii a, pii b) {
    if (a.first < b.first)
        return true;
    if (a.first > b.first)
        return false;
    if (a.second > b.second)
        return true;
    return false;
}

struct Comparator {
    bool operator()(pii a, pii b) {
        if (a.first < b.first)
            return true;
        if (a.first > b.first)
            return false;
        if (a.second > b.second)
            return true;
        return false;
    }
};

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;

    vector<vector<pair<int, int>>> g(n);
    vector<int> ws(n);
    for (auto &el: ws) cin >> el;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c, --a, --b;
        g[a].emplace_back(b, c);
    }


    if (G == 1) { // все веса единичка
        auto dijkstra = [&]() {
            vector<int> dist(n, INF);
            dist[0] = 0;
            set<pair<int, int>> q;
            q.insert({0, 0});

            while (!q.empty()) {
                int v = q.begin()->second;
                q.erase(q.begin());
                for (auto [to, w]: g[v]) {
                    if (dist[to] > dist[v] + w) {
                        q.erase({dist[to], to});
                        dist[to] = dist[v] + w;
                        q.insert({dist[to], to});
                    }
                }
            }

            return dist[n - 1];
        };

        int res = dijkstra();
        if (res < INF) {
            res = max(0LL, res - p);
            cout << res;
        } else {
            cout << -1;
        }
    } else if (G == 2) {
        vector<pii> dp(n, {INF, -INF});
        dp[0] = {0, p};
        vector<long long> sm(n);
        sm[0] = 0;

        for (int i = 1; i < n; ++i) {
            sm[i] = sm[i - 1] + g[i - 1][0].second;
        }

        auto best = [&](pii a, pii b) {
            if (a.first < b.first)
                return a;
            if (a.first > b.first)
                return b;
            if (a.second >= b.second)
                return a;
            return b;
        };

        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                long long dist = sm[i] - sm[j];
                pair<int, int> f = dp[j];
                int need = dist - f.second;
                if (need <= 0) {
                    dp[i] = best(dp[i], pii{f.first, f.second - dist});
                } else {
                    int need_iterations = (need - 1) / ws[j] + 1;
                    int bal = f.second;
                    bal += need_iterations * ws[j];
                    int nw = bal - dist;
                    dp[i] = best(dp[i], pii{f.first + need_iterations, nw});
                }
            }
        }

        int ans = dp.back().first;
        if (ans < INF) {
            cout << ans;
        } else {
            assert(false);
            cout << -1;
        }
    } else if (G == 3) {
        vector<vector<int>> dist(n, vector<int>(n, INF));
        for (int i = 0; i < n; ++i) {
            for (auto [to, w]: g[i])
                dist[i][to] = min(dist[i][to], w);
        }

        for (int i = 0; i < n; ++i) {
            dist[i][i] = 0;
        }

        vector<int> need1;
        vector<int> need2;
        for (int i = 0; i < n; ++i) {
            need1.push_back(i);
        }
        for (int k = 0; k < n; ++k) {
            for (int i = 0; i < n; ++i) {
                for (auto j : need1) {
                    if (dist[i][j] > dist[i][k] + dist[k][j]) {
                        dist[i][j] = dist[i][k] + dist[k][j];
                        if (need2.empty() || need2.back() != i)
                            need2.push_back(i);
                    }
                }
            }

            swap(need1, need2);
            need2.clear();
        }

        auto best = [&](pii a, pii b) {
            if (a.first < b.first)
                return a;
            if (a.first > b.first)
                return b;
            if (a.second >= b.second)
                return a;
            return b;
        };

        vector<vector<pii>> dp(1 << n, vector<pii>(n, {INF, -INF}));
        dp[1][0] = {0, p};

        for (int mask = 1; mask < (1 << n); ++mask) {
            for (int bit = 0; bit < n; ++bit) {
                if ((1 << bit) & mask) {
                    for (int nxt = 0; nxt < n; ++nxt) {
                        int nw_mask = mask | (1 << nxt);
                        int d = dist[bit][nxt];
                        if (d >= INF)
                            continue;
                        pair<int, int> f = dp[mask][bit];
                        int need = d - f.second;
                        if (need <= 0) {
                            dp[nw_mask][nxt] = best(dp[nw_mask][nxt], pii{f.first, f.second - d});
                        } else {
                            int need_iterations = (need - 1) / ws[bit] + 1;
                            int bal = dp[mask][bit].second;
                            bal += need_iterations * ws[bit];
                            bal -= d;
                            dp[nw_mask][nxt] = best(dp[nw_mask][nxt], pii{f.first + need_iterations, bal});
                        }
                    }
                }
            }
        }

        int answer = INF;

        for (int mask = 0; mask < (1 << n); ++mask) {
            answer = min(answer, dp[mask][n - 1].first);
        }

        if (answer >= INF) {
            cout << -1;
        } else {
            cout << answer;
        }
    } else {
        auto best = [&](pii a, pii b) {
            if (a.first < b.first)
                return a;
            if (a.first > b.first)
                return b;
            if (a.second >= b.second)
                return a;
            return b;
        };
        vector<vector<int>> dist(n, vector<int>(n, INF));
        for (int i = 0; i < n; ++i) {
            for (auto [to, w]: g[i])
                dist[i][to] = min(dist[i][to], w);
        }

        for (int i = 0; i < n; ++i) {
            dist[i][i] = 0;
        }

        for (int k = 0; k < n; ++k) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }

        vector<pii> dp(n, {INF, -INF});
        dp[0] = {0, p};
        vector<bool> vis(n, false);
        for (int i = 0; i < n; ++i) {
            int ind = -1;
            pair<int, int> b = {INF + 1, -INF};
            for (int curr = 0; curr < n; ++curr) {
                if (vis[curr])
                    continue;
                if (cmp(dp[curr], b)) {
                    b = dp[curr];
                    ind = curr;
                }
            }

            vis[ind] = true;

            for (auto [to, w]: g[ind]) {
                for (int j = 0; j < n; ++j) {
                    int d = dist[j][to];
                    if (d >= INF)
                        continue;
                    pair<int, int> f = dp[j];
                    if (f.first >= INF)
                        continue;
                    int need = d - f.second;
                    if (need <= 0) {
                        dp[to] = best(dp[to], pii{f.first, f.second - d});
                    } else {
                        int need_iterations = (need - 1) / ws[j] + 1;
                        int bal = dp[j].second;
                        bal += need_iterations * ws[j];
                        bal -= d;
                        dp[to] = best(dp[to], pii{f.first + need_iterations, bal});
                    }
                }
            }
        }

        int answer = dp[n - 1].first;
        if (answer >= INF) {
            cout << -1;
        } else {
            cout << answer;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}