#include <bits/stdc++.h>
using namespace std;
const int maxn = 800, infd = 1e9 + 10;
const long long infll = 1e18;
vector<pair<int, int>> g[maxn];
int w[maxn];

void solve() {
    int n, m, stbal, group;
    cin >> n >> m >> stbal >> group;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        --v, --u;
        g[v].emplace_back(u, s);
    }
    if (group == 1) {
        vector<long long> dist(n, infll);
        vector<char> vis(n);
        dist[0] = 0;
        priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<pair<long long, int>>> q;
        q.push(make_pair(0ll, 0));
        while (!q.empty()) {
            int v = q.top().second;
            q.pop();
            if (vis[v]) {
                continue;
            }
            vis[v] = true;
            for (const auto& [u, s] : g[v]) {
                if (dist[u] > dist[v] + s) {
                    dist[u] = dist[v] + s;
                    q.push(make_pair(dist[u], u));
                }
            }
        }
        long long ans = dist[n - 1];
        if (ans == infll) {
            ans = -1;
        } else {
            ans = max(0ll, ans - stbal);
        }
        cout << ans << '\n';
    } else if (group == 2 || group == 3) {
        vector<int> a;
    } else if (group == 4 || group == 0) {
        int maxbal = (n - 1) * 100;
        vector<vector<int>> dist(n, vector<int>(maxbal + 1, infd));
        vector<vector<char>> vis(n, vector<char>(maxbal + 1));
        deque<pair<int, int>> q;
        dist[0][min(stbal, maxbal)] = 0;
        q.push_back(make_pair(0, min(stbal, maxbal)));
        while (!q.empty()) {
            auto [v, bal] = q.front();
            q.pop_front();
            if (vis[v][bal]) {
                continue;
            }
            vis[v][bal] = true;
            for (const auto& [u, s] : g[v]) {
                if (bal >= s && dist[u][bal - s] > dist[v][bal]) {
                    dist[u][bal - s] = dist[v][bal];
                    q.push_front(make_pair(u, bal - s));
                }
            }
            if (dist[v][min(bal + w[v], maxbal)] > dist[v][bal] + 1) {
                dist[v][min(bal + w[v], maxbal)] = dist[v][bal] + 1;
                q.push_back(make_pair(v, min(bal + w[v], maxbal)));
            }
        }
        int ans = infd;
        for (int bal = 0; bal <= maxbal; ++bal) {
            ans = min(ans, dist[n - 1][bal]);
        }
        if (ans == infd) {
            ans = -1;
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
