#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

long long zr = 0;

struct way{
    long long a, b, s;
    way () {}
    way (long long a, long long b, long long s) {
        this->a = a;
        this->b = b;
        this->s = s;
    }
};

vector<vector<pair<long long, long long>>> gr;
vector<long long> dist;
set<pair<long long, long long>> st;
vector<long long> w;

void dijkstra(long long str) {
    dist[str] = 0;
    st.insert({0, str});
    while (st.size() != 0) {
        auto [t, v] = *(st.begin());
        st.erase(st.begin());
        for (auto [u, w] : gr[v]) {
            if (dist[v] + w < dist[u]) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                st.insert({dist[u], u});
            }
        }
    }
}

long long n;

long long dfs(long long v, long long inc, long long p) {
    if (v == n - 1) {
        return 0;
    }
    inc = max(inc, w[v]);
    auto [u, s] = gr[v][0];
    long long add = 0;
    if (s > p) {
        long long t = (s - p + inc - 1) / inc;
        add += t;
        p += t * inc;
    }
    return dfs(u, inc, p - s) + add;
}

int main()
{
    long long m, p, g;
    cin >> n >> m >> p >> g;
    gr.resize(n);
    dist.resize(n, 1e15);
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        long long a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        gr[a].push_back({b, s});
    }
    if (g == 1) {
        dijkstra(0);
        if (dist[n - 1] == 1e15) {
            cout<<"-1";
        } else {
            cout << max(dist[n - 1] - p, zr);
        }
    } else {
        cout <<dfs(0, w[0], p);
    }
    return 0;
}
