#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct way{
    long long a, b, s;
    way () {}
    way (long long a, long long b, long long s) {
        this->a = a;
        this->b = b;
        this->s = s;
    }
};

void sol3(long long n, long long m, long long p) {
    vector<long long> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<way> v(m);
    for (int i = 0; i < m; i++) {
        long long a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        v[i] = way(a, b, w);
    }
    vector<vector<vector<tuple<long long, long long, long long>>>> dist(2, vector<vector<tuple<long long, long long, long long>>> (n));
    long long id = 0, id2 = 1;
    dist[0][0].push_back({0, w[0], p});
    long long ans = 1e9;
    for (int i = 0; i < 2 * n; i++) {
        for (auto [b, e, d] : v) {
            for (auto [cur, inc, mn] : dist[id][b]) {
                long long t = 0;
                inc = max(inc, w[b]);
                if (d > mn) {
                    t = (d - mn + inc - 1) / inc;
                    mn += t * inc;
                }
                dist[id2][e].push_back({cur + t, inc, mn - d});
            }
        }
        for (auto [a, b, c] : dist[id2][n - 1]) {
            if (a < ans) {
                ans = a;
            }
        }
        for (int j = 0; j < n; j++) {
            dist[id][j].clear();
        }
        swap(id, id2);
    }
    cout << ans;
}

long long zr = 0;



vector<vector<pair<long long, long long>>> gr;
vector<long long> dist;
set<pair<long long, long long>> st;
vector<long long> w;

void dijkstra(long long str) {
    dist[str] = 0;
    st.insert({0, str});
    while (st.size() != 0) {
        auto [t, v] = *(st.begin());
        st.erase(st.begin());
        for (auto [u, w] : gr[v]) {
            if (dist[v] + w < dist[u]) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                st.insert({dist[u], u});
            }
        }
    }
}

long long n;

long long dfs(long long v, long long inc, long long p) {
    if (v == n - 1) {
        return 0;
    }
    inc = max(inc, w[v]);
    auto [u, s] = gr[v][0];
    long long add = 0;
    if (s > p) {
        long long t = (s - p + inc - 1) / inc;
        add += t;
        p += t * inc;
    }
    return dfs(u, inc, p - s) + add;
}

int main()
{
    long long m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 3) {
        sol3(n, m, p);
        return 0;
    }
    gr.resize(n);
    dist.resize(n, 1e15);
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        long long a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        gr[a].push_back({b, s});
    }
    if (g == 1) {
        dijkstra(0);
        if (dist[n - 1] == 1e15) {
            cout<<"-1";
        } else {
            cout << max(dist[n - 1] - p, zr);
        }
    } else if (g == 2){
        cout <<dfs(0, w[0], p);
    }
    return 0;
}

/*
4 4 2 3
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
*/
