#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    if (group == 1) {
        vector<ll> w(n);
        for (ll i = 0; i < n; ++i) cin >> w[i];
        vector<pair<ll, ll>> g[n];
        for (ll i = 0; i < m; ++i) {
            ll a, b, s;
            cin >> a >> b >> s;
            a--, b--;
            g[a].push_back({b, s});
        }
        vector<ll> d(n, INF * n);
        d[0] = 0;
        vector<bool> used(n);
        for (ll i = 0; i < n; ++i) {
            ll ind = -1;
            for (ll j = 0; j < n; ++j) {
                if (!used[j] && (ind == -1 || d[j] < d[ind])) ind = j;
            }
            if (ind == -1) break;
            used[ind] = true;
            for (auto [u, wei] : g[ind]) {
                if (d[u] > d[ind] + wei) d[u] = d[ind] + wei;
            }
        }
        if (d[n - 1] == INF * n) cout << -1 << '\n';
        else cout << max(0LL, d[n - 1] - p) << '\n';
    } else if (group == 2) {
        vector<ll> w(n);
        for (ll i = 0; i < n; ++i) cin >> w[i];
        vector<pair<ll, ll>> g[n];
        for (ll i = 0; i < m; ++i) {
            ll a, b, s;
            cin >> a >> b >> s;
            a--, b--;
            g[a].push_back({b, s});
        }
        ll ver = 0, mx = w[0], dop = 0;
        for (ll i = 1; i < n; ++i) {
            if (g[ver][0].second > p) {
                dop += (g[ver][0].second - p + mx - 1) / mx;
                p += mx * ((g[ver][0].second - p + mx - 1) / mx);
            }
            p -= g[ver][0].second;
            mx = max(mx, w[i]);
            ver++;
        }
        cout << dop << '\n';
    } else {
        vector<int> w(n);
        for (int i = 0; i < n; ++i) cin >> w[i];
        int g[n][n];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                g[i][j] = INF;
            }
        }
        for (int i = 0; i < m; ++i) {
            int a, b, s;
            cin >> a >> b >> s;
            a--, b--;
            g[a][b] = min(g[a][b], s);
        }
        vector<int> versh;
        for (int i = 1; i < n - 1; ++i) {
            versh.push_back(i);
        }
        int ans = INF;
        for (int i = 0; i < 22000; ++i) {
            random_shuffle(versh.begin(), versh.end());
            for (int mask = 0; mask < (1 << versh.size()); ++mask) {
                vector<int> path = {0};
                for (int j = 0; j < versh.size(); ++j) {
                    if (mask & (1 << j)) path.push_back(versh[j]);
                }
                path.emplace_back(n - 1);
                bool flag = true;
                for (int j = 0; j < path.size() - 1; ++j) {
                    if (g[path[j]][path[j + 1]] == INF) flag = false;
                }
                if (flag) {
                    int ver = 0;
                    int mx = w[0], dop = 0, cur = p;
                    for (int j = 1; j < path.size(); ++j) {
                        if (cur < g[ver][path[j]]) {
                            int k = (g[ver][path[j]] - cur + mx - 1) / mx;
                            dop += k;
                            cur += mx * k;
                        }
                        cur -= g[ver][path[j]];
                        mx = max(mx, w[path[j]]);
                        ver = path[j];
                    }
                    ans = min(ans, dop);
                }
            }
        }
        if (ans == INF) cout << -1 << '\n';
        else cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}