#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = 1e18 + 7;

const int maxn = 805;

long long cost[maxn][maxn];

vector<pair<long long, long long>> dp[maxn];

void solve() {
    long long n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cost[i][j] = inf;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        cost[i][i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        cost[a][b] = min(cost[a][b], (long long)s);
    }
    for (int mid = 0; mid < n; ++mid) {
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                cost[a][b] = min(cost[a][b], cost[a][mid] + cost[mid][b]);
            }
        }
    }
    if (cost[0][n - 1] == inf) {
        cout << -1 << '\n';
        return;
    }
    if (p >= cost[0][n - 1]) {
        cout << 0 << '\n';
        return;
    }
    if (false && g == 2) {
        vector<long long> pr_sum(n);
        for (int i = 1; i < n; ++i) {
            pr_sum[i] = pr_sum[i - 1] + cost[i - 1][i];
        }
        long long ans = 0;
        for (int i = 0; i + 1 < n; ++i) {
            int nxt = n - 1;
            for (int j = i + 1; j < n; ++j) {
                if (w[j] > w[i]) {
                    nxt = j;
                    break;
                }
            }
            long long len = pr_sum[nxt] - pr_sum[i];
            if (p < len) {
                long long val = (len - p - 1) / w[i] + 1;
                ans += val;
                p += val * 1LL * w[i];
            }
            p -= cost[i][i + 1];
        }
        cout << ans << '\n';
        return;
    }
    vector<pair<int, int>> ord;
    for (int i = 1; i + 1 < n; ++i) {
        ord.emplace_back(w[i], i);
    }
    sort(ord.begin(), ord.end());
    dp[0] = {{0, p}};
    for (int nxt = 1; nxt < n; ++nxt) {
        if (cost[0][nxt] != inf) {
            if (cost[0][nxt] <= p) {
                dp[nxt].push_back({0, p - cost[0][nxt]});
            } else {
                long long vl = (cost[0][nxt] - p - 1) / w[0] + 1;
                dp[nxt].push_back({vl, p + w[0] * vl - cost[0][nxt]});
            }
        }
    }
    for (auto [ww, v] : ord) {
        sort(dp[v].begin(), dp[v].end());
        vector<pair<long long, long long>> dp_nw;
        for (auto [ans, p] : dp[v]) {
            if (dp_nw.empty() || (dp_nw.size() < 30 && dp_nw.back().first != ans)) {
                dp_nw.emplace_back(ans, p);
            } else if (dp_nw.back().first == ans) {
                dp_nw.back().second = p;
            }
        }
        dp[v] = dp_nw;
        for (auto [ans, p] : dp[v]) {
            for (int nxt = 1; nxt < n; ++nxt) {
                if (nxt != v && cost[v][nxt] != inf) {
                    if (cost[v][nxt] <= p) {
                        dp[nxt].push_back({ans, p - cost[v][nxt]});
                    } else {
                        long long vl = (cost[v][nxt] - p - 1) / w[v] + 1;
                        dp[nxt].push_back({ans + vl, p + w[v] * vl - cost[v][nxt]});
                    }
                }
            }
        }
    }
    sort(dp[n - 1].begin(), dp[n - 1].end());
    cout << dp[n - 1][0].first << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
