#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MOD = 1e9 + 7;
const int MAXN = 800;
const int logn = 17;
const int INF = 2e9;

vector<pair<int, int>> g[MAXN];
int w[MAXN];
int used[MAXN];

void dfs(int v) {
    used[v] = 1;

    for (auto [to, s] : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    int W = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        W = max(W, w[i]);
    }

    int S = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a, --b;
        g[a].emplace_back(b, s);
        S += s;
    }
    dfs(0);

    if (used[n - 1]) {
        int x = S / (p * W);
        if (p + W * x < S) {
            ++x;
        }
        cout << x << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int T = 1;
    //cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
