#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1e9 + 9;
const ll MAXN = 800;

vector<pair<int, int>> g[MAXN];
int used[MAXN];
int w[MAXN], pref[MAXN];
vector<int> tmp;

void dfs(int v, int mx) {
    used[v] = 1;
    if (w[v] > mx) {
        tmp.push_back(v);
    }

    for (auto [to, s] : g[v]) {
        if (!used[to]) {
            pref[to] = pref[v] + s;
            dfs(to, max(mx, w[v]));
        }
    }
}

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }

    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a, --b;
        g[a].emplace_back(b, s);
    }
    dfs(0, 0);
    if (tmp.back() != n - 1) {
        tmp.push_back(n - 1);
    }

    int kek = p;
    int now = 0, it = 1, mx = w[0];
    int ans = 0;
    while (now != n - 1) {
        //cout << (pref[it] - pref[it - 1] - kek) << ' ' << mx << '\n';
        int next = tmp[it];
        int x = (pref[next] - pref[now] - kek) / mx;
        if (mx * x < pref[next] - pref[now] - kek) {
            ++x;
        }
        ans += x;

        kek = mx * x + kek - (pref[next] - pref[now]);
        now = next;
        mx = w[now];
        ++it;
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    ll T = 1;
    //cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
