#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;

using namespace std;

pair<ll, ll> dp[800][800];
ll w[800];
vector<vector<pair<int, ll>>> edge;

void solve() {
    int n, m, g; ll p;
    cin >> n >> m >> p >> g;
    edge.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b; ll s;
        cin >> a >> b >> s;
        edge[a - 1].push_back({ b - 1, s });
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dp[i][j] = { MOD * MOD, 0 };
        }
    }
    dp[0][0] = { 0, -p };
    set<pair<pair<ll, ll>, pair<int, int>>> st;
    st.insert({ {0, -p}, {0, 0} });
    while (st.size()) {
        auto f = (*st.begin());
        st.erase(f);
        ll hm = f.first.first;
        ll b = -f.first.second;
        int now = f.second.first;
        int was = f.second.second;
        if (f.first < dp[now][now]) {
            st.erase({ dp[now][now], {now, now} });
            dp[now][now] = f.first;
            st.insert({ f.first, {now, now} });
        }
        for (auto pr : edge[now]) {
            int to = pr.first;
            ll cost = pr.second;
            ll hmw = 0;
            ll bw = b - cost;
            if (cost > b) {
                hmw = (cost - b + w[was] - 1) / w[was];
                bw += hmw * w[was];
            }
            hmw += hm;
            if (make_pair(hmw, -bw) < dp[to][was]) {
                st.erase({ dp[to][was], {to, was} });
                dp[to][was] = { hmw, -bw };
                st.insert({ dp[to][was], {to, was} });
            }
        }
    }
    if (dp[n - 1][n - 1].first == MOD * MOD) {
        cout << "-1\n";
    } else {
        cout << dp[n - 1][n - 1].first << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}