#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

constexpr ll INF64 = 0x3f3f3f3f3f3f3f3f;

bool ckmin(pair<ll, ll> &to, pair<ll, ll> w) {
    if (to > w) {
        to = w;
        return true;
    }
    return false;
}

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    if (g == 2) {
        ll ans = 0;
        ll maxwi = 0;
        for (int i = 0; i < n - 1; ++i) {
            maxwi = max(maxwi, w[i]);
            ll cost;
            cin >> cost >> cost >> cost;
            if (cost <= p) {
                p -= cost;
                continue;
            }
            ll need = cost - p;
            ll ww = (need + maxwi - 1) / maxwi;
            ans += ww;
            p = (p - cost + ww * maxwi);
        }
        cout << ans << '\n';
    } else if (g == 1) {
        vector<ll> dist(n, INF64);
        dist[0] = 0;
        vector<vector<pair<int, int>>> graph(n);
        for (int i = 0; i < m; ++i) {
            int u, v, cw;
            cin >> u >> v >> cw;
            graph[u - 1].emplace_back(v - 1, cw);
        }
        priority_queue<pair<int, int>> pq;
        pq.emplace(0, 0);
        while (!pq.empty()) {
            auto [md, v] = pq.top();
            pq.pop();
            md = -md;
            for (const auto &[u, c] : graph[v]) {
                if (dist[u] > dist[v] + c) {
                    dist[u] = dist[v] + c;
                    pq.emplace(-dist[u], u);
                }
            }
        }
        if (dist[n - 1] == INF64) {
            cout << "-1\n";
        } else {
            cout << max(0ll, dist[n - 1] - p)  << '\n';
        }
    } else {
        vector<vector<pair<ll, ll>>> graph(n);
        for (int i = 0; i < m; ++i) {
            int u, v, cw;
            cin >> u >> v >> cw;
            graph[u - 1].emplace_back(v - 1, cw);
        }
        ll ans = INF64;
        vector<vector<pair<ll, ll>>> dp(1 << n, vector<pair<ll, ll>>(n, {INF64, 0}));
        dp[1][0] = {0, -p};
        priority_queue<pair<pair<ll, ll>, pair<ll, ll>>> pq; // value & key dp
        pq.push({{0, p}, {1, 0}});
        while (!pq.empty()) {
            auto [_, masklast] = pq.top();
            int mask = masklast.first, last = masklast.second;
//            cerr << hex << mask << dec << ' ' << last << '\n';
            pq.pop();
            ll max_w = 0;
            for (int i = 0; i < n; ++i) {
                if (mask >> i & 1) {
                    max_w = max(max_w, w[i]);
                }
            }
            if (dp[mask][last].first == INF64) {
                continue;
            }
            for (const auto &[u, c] : graph[last]) {
//                    if (mask >> u & 1) continue;
                ll need_money = max(0ll, c + dp[mask][last].second);
                ll add_vystup = (need_money + max_w - 1) / max_w;
                if (ckmin(dp[mask | (1 << u)][u], {dp[mask][last].first + add_vystup, -(-dp[mask][last].second + add_vystup * max_w - c)})) {
                    pq.push({{-dp[mask | (1 << u)][u].first, -dp[mask | (1 << u)][u].second}, {mask | (1 << u), u}});
                }
            }
        }
        for (int mask = 1 << (n - 1); mask < (1 << n); ++mask) {
            ans = min(ans, dp[mask][n - 1].first);
        }
        ll v = ans;
        if (v == INF64) {
            cout << "-1\n";
        }
        else {
            cout << v << '\n';
        }
    }
    return 0;
}