#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define LL __int128
#define F first
#define S second
mt19937 rnd(100);

struct Node {
    Node *L, *R;
    ll y, v, c;
};

ll size(Node *r) {
    return r == nullptr ? 0 : r->c;
}

void update(Node *r) {
    r->c = size(r->L) + 1 + size(r->R);
}

pair<Node *, Node *> split(Node *r, ll k) {
    if (r == nullptr)
        return {nullptr, nullptr};
    else if (size(r->L) >= k) {
        auto p = split(r->L, k);
        r->L = p.S;
        update(r);
        return {p.F, r};
    } else {
        auto p = split(r->R, k - size(r->L) - 1);
        r->R = p.F;
        update(r);
        return {r, p.S};
    }
}

Node *merge(Node *r1, Node *r2) {
    if (r1 == nullptr)
        return r2;
    else if (r2 == nullptr)
        return r1;
    else if (r1->y <= r2->y) {
        r1->R = merge(r1->R, r2);
        update(r1);
        return r1;
    } else {
        r2->L = merge(r1, r2->L);
        update(r2);
        return r2;
    }
}

/*
struct mst {
    vector<vector<pair<ll, ll>>> arr;
    ll size;

    mst(vector<pair<ll, ll>> &inp) {
        ll k = 1;
        while (k < inp.size())
            k *= 2;
        size = k * 2;
        arr.resize(size);
        for (int i = 0; i < inp.size(); ++i)
            arr[i + k] = {inp[i]};
        while (--k)
            merge(k);
    }

    void merge(ll x) {
        ll s1 = arr[x * 2].size();
        ll s2 = arr[x * 2 + 1].size();
        ll p1 = 0, p2 = 0;
        arr[x].resize(s1 + s2);

        while (p1 + p2 < s1 + s2)
            if (p2 == s2 || p1 != s1 && arr[x * 2][p1] < arr[x * 2 + 1][p2])
                arr[x][p1 + p2] = arr[x * 2][p1], p1++;
            else
                arr[x][p1 + p2] = arr[x * 2 + 1][p2], p2++;
    }

    ll l1, r1, l2, r2, ans;

    ll ask(ll _l1, ll _r1, ll _l2, ll _r2) {
        l1 = _l1, r1 = _r1, l2 = _l2, r2 = _r2, ans = 0;
        ask(0, size / 2, 1);
        return ans;
    }

    void ask(ll L, ll R, ll now) {
        if (L >= l1 && R <= r1) {
            ll l = -1, r = arr[now].size(), mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (arr[now][mid] < l2)
                    l = mid;
                else
                    r = mid;
            }
            ll le = -1, ri = arr[now].size();
            while (ri - le > 1) {
                mid = (ri + le) / 2;
                if (arr[now][mid] >= r2)
                    ri = mid;
                else
                    le = mid;
            }
            ans += le - l;
        } else if (L >= r1 || R <= l1)
            return;
        else
            ask(L, (R + L) / 2, now * 2), ask((R + L) / 2, R, now * 2 + 1);
    }
};
*/
/*
unordered_map<ll, ll> dp;
ll sum(ll l, ll r) {
    ll h1, h2;
    if (!dp.count(r)) {
        cout << "? " << r << endl;
        cin >> h1;
        if (h1 == -1)
            ::exit(0);
        dp[r] = h1;
    } else
        h1 = dp[r];
    if (!dp.count(l - 1)) {
        cout << "? " << l - 1 << endl;
        cin >> h2;
        if (h2 == -1)
            ::exit(0);
        dp[l - 1] = h2;
    } else
        h2 = dp[l - 1];
    return (r * (r + 1) / 2 - h1) - (l * (l - 1) / 2 - h2);
} // Сумма живых чисел на отрезке. 2 операции
vector<ll> ans;
ll find(ll l, ll r, ll kmi, ll kma) {
    if (kmi == r - l + 1) {
        for (int i = l; i <= r; ++i)
            ans.push_back(i);
        return r - l + 1;
    }
    if (kmi == kma && kma == 1) {
        if (l != r)
            ans.push_back(sum(l, r));
        else
            ans.push_back(l);
        return 1;
    }
    if (!kma || l >= r)
        return 0;

    ll su = sum(l, r);

    ll l1 = kmi, r1 = kma + 1, mid;
    while (r1 - l1 > 1) {
        mid = (r1 + l1) / 2;
        if ((l + mid - 1) * (l + mid) / 2 - l * (l - 1) / 2 <= su)
            l1 = mid;
        else
            r1 = mid;
    }
    kma = min(kma, l1);

    l1 = kmi - 1, r1 = kma;
    while (r1 - l1 > 1) {
        mid = (r1 + l1) / 2;
        if (r * (r + 1) / 2 - (r - mid) * (r - mid + 1) / 2 >= su)
            r1 = mid;
        else
            l1 = mid;
    }
    kmi = max(kmi, r1);

    if (!su)
        return 0;
    if (!kma || l >= r)
        return 0;
    if (kmi == r - l + 1) {
        for (int i = l; i <= r; ++i)
            ans.push_back(i);
        return r - l + 1;
    }
    if (kmi == kma && kma == 1) {
        ans.push_back(su);
        return 1;
    }

    ll h1 = find(l, (r + l) / 2, max(0ll, kmi - (r - (r + l) / 2)), min(kma, (r + l) / 2 - l + 1));
    ll h2 = find((r + l) / 2 + 1, r, max(0ll, kmi - h1), kma - h1);
    return h1 + h2;
}
*/

ll W;
vector<ll> w;
vector<vector<pair<ll, ll>>> g;
vector<pair<ll, ll>> dist;

pair<bool, pair<ll, ll>> better(ll a, ll b, ll len) {
    auto p1 = dist[a];
    auto p2 = dist[b];

    if (p1.S < len) {
        p1.F += (len - p1.S + W - 1) / W;
        p1.S = (len - p1.S + W - 1) / W * W + p1.S - len;
    } else
        p1.S -= len;

    return {p1.F < p2.F || p1.F == p2.F && p1.S > p2.S, p1};
}


struct cmp {
    bool operator()(ll a, ll b) {
        return !better(a, b, 0).F;
    }
};


int main() {
    cin.tie(0), ios_base::sync_with_stdio(0);


    /*ll _, a;
    cin >> _;
    while (_--) {
        dp.clear();
        dp[0] = 0;
        ans.clear();

        ll n, k;
        cin >> n >> k;
        find(1, n, k, k);

        sort(ans.begin(), ans.end());
        cout << "! ";
        for (ll i: ans)
            cout << i << ' ';
        cout << endl;
        cin >> a;
        if (a == -1)
            return 0;
    }*/

    ll n, m, p, gr;
    cin >> n >> m >> p >> gr;
    w.resize(n);
    for (ll &i: w)
        cin >> i;
    g.resize(n);
    ll a, b, c;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c;
        g[a - 1].emplace_back(b - 1, c);
    }
    vector<pair<ll, ll>> help;
    for (int i = 0; i < n; ++i) {
        help.emplace_back(w[i], i);
        sort(help.begin(), help.end());
    }

    dist.assign(n, {LLONG_MAX, 0});
    dist[0] = {0, p};

    for (auto h: help) {
        if (dist[h.S].F == LLONG_MAX)
            continue;
        ll u = h.S;
        W = h.F;

        priority_queue<ll, vector<ll>, cmp> pq;
        pq.push(u);
        while (!pq.empty()) {
            ll v = pq.top();
            pq.pop();
            for (auto v1: g[v]) {
                auto hh = better(v, v1.F, v1.S);
                if (hh.F) {
                    dist[v1.F] = hh.S;
                    pq.push(v1.F);
                }
            }
        }
    }

    cout << (dist[n - 1].F == LLONG_MAX ? -1 : dist[n - 1].F);

    return 0;
}
/*
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

4 4 10 0
1 2 10 1
1 2 20
2 4 30
1 3 25
3 4 89

4 4 7 0
5 1 6 2
1 2 5
2 3 10
3 4 50
3 4 70

 */
/*
Он посетит каждый город не более 1 раза

 Для каждого города ищем мин расстояние если он будет максимальным
 Для этого стартуем из всех городов расстояние до которых мы нашли в порядке возростания w
    и от них ищем кратчайшие расстояния до каждого из городов у которых w больше


4324332
4 2
5
2

 */
/*
1 3 4 5  7  9
1 4 8 13 20 29
 */
/*
D-шка бфс
 Переберем города по возостанию прибыли как максимальные города в которых мы будем быть.
 Для каждого такого города мы попав туда смотрим сколько макс денег мы можем к этому моменту получить за минимальное количество выступлений
 Так как этот город максимальный то даже выигрыш в один ход полезнее любого излишка денег
 Дальше просто смотрим расстояние от этого города до конца и то сколько денег нам еще надо заработать и зарабатываем

Как найти расстояние до города если он наш макс город

Мы уже нашли расстояние до всех меньших городов
 Мы можем идти только по ним. Из каждого из них пробуем дойти до нашего по городам не большего чем текущий размера

B
 Нужно выбрать 2 различные точки а остальные разделить на множества чтобы одна точка была правее всех в своем множестве, а другая выше чтобы abs(x1 - y2) был минимальным
Допустим мы берем какую-то точку
 Изначально пишаем все точки ниже ее в одно множество
 Среди остальных берем самую правую

 Если вторая нужная точка в том множестве то она самая правая
 иначе она в первом множестве и правее всех точек во втором
 Среди всех точек первого множества которые правее второго берем ту у которой ближе всего к нужному

 1. Отсортим пары
 Певое множество всегда будет префиксом
 Будем хранить верхнюю точку первого множества
 Нужно уметь находить максимум по второй координате в правом множестве с ближайшей к нашей
 Для этого для правого множества будем хранить сет сетов

 Нужно уметь среди точек первого множества находить ближайшую по значению к конкретному
 и при этом чтобы другой параметр был больше или равен максимуму в правом множестве. СЕТ
 */