#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 1e16;

vector<ll> w;
int n, m;
ll p;

void solve1() {
    vector<vector<pair<int, ll> > > g(n);
    for (int i = 0; i < m; i++) {
        int u, v, s; cin >> u >> v >> s;
        u--, v--;
        g[u].pb(mp(v, s));
    }
    vector<ll> d(n, INF);
    d[0] = 0;
    set<pair<ll, int> > s;
    s.insert(mp(0, 0));
    for (int i = 1; i < n; i++) s.insert(mp(INF, i));
    while (!s.empty()) {
        auto pp = s.begin();
        s.erase(pp);
        int v = (*pp).S;
        for (auto to : g[v]) {
            int u = to.F;
            ll len = to.S;
            if (d[v] + len < d[u]) {
                s.erase(mp(d[u], u));
                d[u] = d[v] + len;
                s.insert(mp(d[u], u));
            }
        } 
    }
    ll ans = d[n - 1];
    if (ans == INF) {
        cout << -1;
        return;
    }
    if (ans > p) ans -= p;
    else ans = 0;
    cout << ans;
}

void solve2() {
    vector<int> s(n);
    int x;
    for (int i = 0; i < m; i++) cin >> x >> x >> s[i];
    ll sum = p, mx = 0, ans = 0;
    for (int i = 0; i < m; i++) {
        mx = max(mx, w[i]);
        //cout << i << " " << w[i] << " " << sum << " " << s[i] << endl;
        if (sum < s[i]) {
            int cnt = (s[i] - sum + mx - 1) / mx;
            //cout << cnt << " " << mx << endl;
            ans += cnt;
            sum += cnt * mx;
        }
        sum -= s[i];
    }
    cout << ans;
}

const int D = 20;

void solve4() {
    vector<vector<pair<int, ll> > > g(n);
    for (int i = 0; i < m; i++) {
        int u, v, s; cin >> u >> v >> s;
        u--, v--;
        g[u].pb(mp(v, s));
    }
    vector<vector<ll> > dp(n, vector<ll> (D, -INF));
    set<pair<ll, pair<int, int> > > s;
    for (int d = 0; d < D; d++) {
        dp[0][d] = d * w[0] + p;
        s.insert(mp(dp[0][d], mp(0, d)));
    }
    for (int i = 1; i < n; i++) 
        for (int d = 0; d < D; d++) 
            s.insert(mp(-INF, mp(i, d)));
    while (!s.empty()) {
        auto pp = s.begin();
        s.erase(pp);
        int v = (*pp).S.F, d = (*pp).S.S;
        //cout << "!" << v << " " << d << endl;
        for (auto to : g[v]) {
            int u = to.F;
            ll len = to.S;
            ll res = INF;
            if (dp[v][d] >= len){
                res = dp[v][d] - len;
                if (dp[u][d] < res) {
                    s.erase(mp(dp[u][d], mp(u, d)));
                    dp[u][d] = res;
                    s.insert(mp(dp[u][d], mp(u, d)));
                }
            } else {
                ll cnt = (len - dp[v][d] + w[v] - 1) / w[v];
                if (d + cnt < D) {
                    res = dp[v][d] + cnt * w[v] - len;
                    if (dp[u][d + cnt] < res) {
                        s.erase(mp(dp[u][d + cnt], mp(u, d + cnt)));
                        dp[u][d + cnt] = res;
                        s.insert(mp(dp[u][d + cnt], mp(u, d + cnt)));
                    }
                }
            }
        } 
    }
    for (int d = 0; d < D; d++) {
        if (dp[n - 1][d] != -INF) {
            cout << d;
            return;
        }
    }
}

int main() {
    int tt; cin >> n >> m >> p >> tt;
    w.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    if (tt == 1) solve1();
    if (tt == 2) solve2();
    if (tt == 4) solve4();
    return 0;
}