#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

vector<vector<ll>> graph;
vector<int> cur_way;
set<int> used;
vector<ll> w;
int n; ll p;
ll ans = 1e18;
void my_gen() {
    if (cur_way.back() == n - 1) {
        int N = cur_way.size();
        vector<ll> pref_sum(N);
        pref_sum[0] = 0;
        for (int i = 1; i < N; ++i) {
            if (graph[cur_way[i - 1]][cur_way[i]] == -1) return;
            pref_sum[i] = pref_sum[i - 1] + graph[cur_way[i - 1]][cur_way[i]];
        }
        vector<ll> pref_max(N, 0);
        for (int i = 1; i < N; ++i) {
            if (w[cur_way[i]] > w[cur_way[pref_max[i - 1]]])
                pref_max[i] = i;
            else
                pref_max[i] = pref_max[i - 1];
        }
        vector<int> way;
        way.push_back(N - 1);
        while (way.back() != 0) {
            way.push_back(pref_max[way.back() - 1]);
        }
        reverse(way.begin(), way.end());
        ll cur_ans = 0; ll ost = p;
        for (int i = 1; i < way.size(); ++i) {
            ll way_len = pref_sum[way[i]] - pref_sum[way[i - 1]];
            if (ost >= way_len) {
                ost -= way_len;
            }
            else {
                way_len -= ost;
                cur_ans += (way_len + w[cur_way[way[i - 1]]] - 1) / w[cur_way[way[i - 1]]];
                ost = (way_len + w[cur_way[way[i - 1]]] - 1) / w[cur_way[way[i - 1]]] * w[cur_way[way[i - 1]]] - way_len;
            }
        }
        ans = min(ans, cur_ans);
        return;
    }
    for (int u = 0; u < n; ++u) {
        if (used.find(u) == used.end()) {
            cur_way.push_back(u);
            used.insert(u);
            my_gen();
            cur_way.pop_back();
            used.erase(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m;
    cin >> n >> m >> p;
    int gr; cin >> gr;
    w.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    vector<vector<pair<int, ll>>> g(n);
    for (int _ = 0; _ < m; ++_) {
        int a, b; ll s;
        cin >> a >> b >> s;
        a--; b--;
        g[a].push_back({b, s});
    }
    if (gr == 1) {
        vector<bool> visit(n, false);
        vector<ll> dist(n, INF);
        dist[0] = 0;
        set<pair<ll, int>> queue;
        queue.insert({0, 0});
        while (!queue.empty()) {
            int u = queue.begin()->second;
            queue.erase(queue.begin());
            visit[u] = true;
            for (auto el: g[u]) {
                int v = el.first;
                ll s = el.second;
                if (!visit[v] && dist[v] > dist[u] + s) {
                    queue.erase({dist[v], v});
                    dist[v] = dist[u] + s;
                    queue.insert({dist[v], v});
                }
            }
        }
        if (dist[n - 1] == INF) cout << -1;
        else cout << max((ll) 0, dist[n - 1] - p);
    }
    else if (gr == 2) {
        vector<ll> pref_sum(n);
        pref_sum[0] = 0;
        for (int i = 1; i < n; ++i) {
            pref_sum[i] = pref_sum[i - 1] + g[i - 1][0].second;
        }
        vector<ll> pref_max(n, 0);
        for (int i = 1; i < n; ++i) {
            if (w[i] > w[pref_max[i - 1]])
                pref_max[i] = i;
            else
                pref_max[i] = pref_max[i - 1];
        }
        vector<int> way;
        way.push_back(n - 1);
        while (way.back() != 0) {
            way.push_back(pref_max[way.back() - 1]);
        }
         reverse(way.begin(), way.end());
        ll ans = 0, ost = p;
        for (int i = 1; i < way.size(); ++i) {
            ll way_len = pref_sum[way[i]] - pref_sum[way[i - 1]];
           if (ost >= way_len) {
                ost -= way_len;
            }
            else {
                way_len -= ost;
                ans += (way_len + w[way[i - 1]] - 1) / w[way[i - 1]];
                ost = (way_len + w[way[i - 1]] - 1) / w[way[i - 1]] * w[way[i - 1]] - way_len;
            }
        }
        cout << ans;
    }
    else {
        graph.resize(n, vector<ll>(n, -1));
        for (int u = 0; u < n; ++u) {
            for (auto el: g[u]) {
                int v = el.first; ll s = el.second;
                if (graph[u][v] == -1) graph[u][v] = s;
                else graph[u][v] = min(graph[u][v], s);
            }
        }
        used.insert(0);
        cur_way.push_back(0);
        my_gen();
        if (ans == 1e18) cout << -1;
        else cout << ans;
    }

    return 0;
}