// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <ranges>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

#define int ll

using ll = long long;
using ld = long double;
// using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

int n, m;
ll lft;
vector<ll> w;
vector<vector<pll>> g;

int cnt = 0;
const ll inf = LLONG_MAX / 100;
ll ans = inf;

void dfs_ans(int v, ll money, int done, vector<vector<ll>> &dist) {
    cnt++;
    if (cnt >= n * n * 100)
        return;
    if (v == n - 1) {
        ans = min(ans, done);
        return;
    }
    for (auto [to, len] : g[v]) {
        for (int it = 0; it < n; it++) {
            if (it == v || len + dist[to][it] >= inf)
                continue;
            ll need = len + dist[to][it];
            ll pay = need - money;
            if (pay <= 0)   
                dfs_ans(to, money - need, done, dist);
            else {
                int opers = pay / w[v] + (pay % w[v] != 0);
                ll next_money = opers * w[v] - len + money;
                dfs_ans(to, next_money, done + opers, dist);
            }
        }
    }
}

void dijk(vector<vector<ll>> &dist, int it) {
    dist[it][it] = 0;
    set<pll> st;
    st.insert({0, it});
    while (!st.empty()) {
        int v = st.begin()->S;
        st.erase(st.begin());
        for (auto [to, cost] : g[v]) {
            if (dist[it][to] > dist[it][v] + cost) {
                st.erase({dist[it][to], to});
                dist[it][to] = dist[it][v] + cost;
                st.insert({dist[it][to], to});
            }
        }
    }
}

void group023() {
    vector<vector<ll>> dist(n, vector<ll>(n, inf));
    for (int i = 0; i < n; i++)
        dijk(dist, i);
    if (dist[0][n - 1] == inf) {
        cout << -1 << "\n";
        return;
    }
    dfs_ans(0, lft, 0, dist);
    cout << ans << "\n";
}

void group1() {
    vector<ll> dist(n, inf);
    dist[0] = 0;
    set<pll> st;
    st.insert({0, 0});
    while (!st.empty()) {
        int v = st.begin()->S;
        st.erase(st.begin());
        for (auto [to, cost] : g[v]) {
            if (dist[to] > dist[v] + cost) {
                st.erase({dist[to], to});
                dist[to] = dist[v] + cost;
                st.insert({dist[to], to});
            }
        }
    }
    if (dist[n - 1] == inf) {
        cout << -1 << "\n";
        return;
    }
    cout << max(dist[n - 1] - lft, 0LL) << "\n";
}

void solve() {
    int test;
    cin >> n >> m >> lft >> test;
    w.resize(n);
    g.resize(n);
    for (auto &i : w)
        cin >> i;
    for (int i = 0; i < m; i++) {
        int a, b, cost;
        cin >> a >> b >> cost;
        g[--a].pb({--b, cost});
    }
    if (test != 1) {
        group023();
    } else
        group1();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}