#include <iostream>
#include <algorithm>
#include <fstream>

#include <vector>
#include <map>
#include <set>

#include <stack>
#include <queue>
#include <deque>

using namespace std;

using ll = long long;
using ld = long double;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;
using vvpll = vector<vector<pair<ll, ll>>>;

void dfs(ll p, vvpll& Graph, vl& good){
    good[p] = 1;
    for (auto u : Graph[p]){
        if (!good[u.first]){
            dfs(u.first, Graph, good);
        }
    }
}

vl d(ll start, ll n, vvpll& Graph, vl& good){
    vl ans(n, 1e15);
    ans[start] = 0;
    vl used(n);
    set<pair<ll, ll>> vert;
    for (ll i = 0; i < n; i++){
        if (good[i]){
            vert.insert(make_pair(ans[i], i));
        }
    }
    while (!vert.empty()){
        pair<ll, ll> v = *vert.begin();
        vert.erase(v);
        used[v.second] = 1;
        for (auto u : Graph[v.second]){
            if (!used[u.first]){
                if (ans[u.first] > v.first + u.second){
                    vert.erase(make_pair(ans[u.first], u.first));
                    ans[u.first] = v.first + u.second;
                    vert.insert(make_pair(ans[u.first], u.first));
                }
            }
        }
    }
    return ans;
}

int main(){
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 2){
        vl W(n);
        for (ll i = 0; i < n; i++){
            cin >> W[i];
            if (i != 0){
                W[i] = max(W[i], W[i - 1]);
            }
        }
        ll a, b;
        vl S(n);
        for (ll i = 0; i < m; i++){
            cin >> a >> b >> S[i];
        }

        vl ans(n);
        ans[0] = 0;
        ll curr_p = p;
        for (ll i = 1; i < n; i++){
            if (curr_p - S[i - 1] >= 0){
                ans[i] = ans[i - 1];
                curr_p -= S[i - 1];
                continue;
            }
            ll delta = S[i - 1] - curr_p;
            ans[i] = ans[i - 1] + (delta + W[i - 1] - 1) / W[i - 1];
            curr_p -= S[i - 1];
            curr_p += ((delta + W[i - 1] - 1) / W[i - 1]) * W[i - 1];
        }
        cout << ans.back();
    }
    if (g == 1){
        ll w;
        for (ll i = 0; i < n; i++){
            cin >> w;
        }
        ll a, b;
        vvpll Graph(n);
        ll s;
        for (ll i = 0; i < m; i++){
            cin >> a >> b >> s;
            if (a == b){
                continue;
            }
            Graph[a - 1].push_back(make_pair(b - 1, s));
        }

        vl good(n);
        dfs(0, Graph, good);
        vl ans = d(0, n, Graph, good);
        if (ans.back() == 1e15){
            cout << -1;
        }
        else{
            if (p >= ans.back()){
                cout << 0;
            }
            else{
                cout << ans.back() - p;
            }
        }
        return 0;
    }
    return 0;
}