#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<int> w(n);
	for (int& i : w)
		cin >> i;

	vector<unordered_map<int, long long int>> adj(n);
	for (int i = 0; i < m; ++i)
	{
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		adj[a][b] = c;
	}

	vector<unsigned long long int> field(n, 1ull<<63);
	vector<int> from(n, -1);
	field[0] = 0;
	vector<bool> used(n);
	while (true)
	{
		unsigned long long int min_v = 1ull << 63;
		int ind_min = -1;
		for (int i = 0; i < n; ++i) if (!used[i])
		{
			if (field[i] < min_v)
			{
				min_v = field[i];
				ind_min = i;
			}
		}

		if (ind_min == -1)
			break;

		used[ind_min] = true;

		for (const pair<int, int>& u : adj[ind_min])
		{
			if (!used[u.first] && field[u.first] > field[ind_min] + u.second)
			{
				field[u.first] = field[ind_min] + u.second;
				from[u.first] = ind_min;
			}
		}
	}

	if (field[n - 1] == 1ull << 63)
	{
		cout << -1;
		return 0;
	}

	vector<int> way;
	int v = n - 1;
	while (from[v] != -1)
	{
		way.push_back(v);
		v = from[v];
	}
	way.push_back(0);
	reverse(way.begin(), way.end());

	long long int total = 0;
	for (int i = 0; i < way.size() - 1; ++i)
		total += adj[way[i]][way[i + 1]];

	cout << total - p;
}
