#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}
void solve_case() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<int> w(n);
    vector<vector<ll>> dist(n, vector<ll>(n, infll));
    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
    }
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        chmin(dist[a][b], s);
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                chmin(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    if (dist[0][n - 1] == infll) {
        cout << -1 << "\n";
        return;
    }
    vector<map<ll, ll>> dp(n);
    vector<set<ll>> poss(n);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int left, int right){
        return w[left] < w[right];
    });
    function<void(int, ll, ll)> relax = [&](int v, ll bal, ll val) {
        if (poss[v].empty()) {
            poss[v].insert(bal);
            dp[v][bal] = val;
        } else if (poss[v].count(bal)) {
            chmin(dp[v][bal], val);
            auto it = poss[v].lower_bound(bal);
            vector<int> rem;
            while (it != poss[v].begin()) {
                it = prev(it);
                if (dp[v][*it] >= val) {
                    rem.push_back(*it);
                } else {
                    break;
                }
            }
            for (int i : rem) {
                dp[v].erase(i);
                poss[v].erase(i);
            }
        } else {
            auto it = poss[v].upper_bound(bal);
            if (it != poss[v].end() && dp[v][*it] <= val) {
                return;
            }
            poss[v].insert(bal);
            dp[v][bal] = val;
            it = poss[v].lower_bound(bal);
            vector<int> rem;
            while (it != poss[v].begin()) {
                it = prev(it);
                if (dp[v][*it] >= val) {
                    rem.push_back(*it);
                } else {
                    break;
                }
            }
            for (int i : rem) {
                dp[v].erase(i);
                poss[v].erase(i);
            }
        }
    };
    function<pair<ll, ll>(int, int, ll, ll)> calc_new = [&](int i, int j, ll b, ll v) {
        if (dist[i][j] > b) {
            ll add = (dist[i][j] - b + w[i] - 1) / w[i];
            v += add;
            b += add * w[i];
        }
        b -= dist[i][j];
        return make_pair(b,  v);
    };
    relax(0, p, 0);
    for (int i = 0; i < n; i++) {
        for (ll b : poss[ord[i]]) {
            ll v = dp[ord[i]][b];
            for (int j = i + 1; j < n; j++) {
                auto nw = calc_new(ord[i], ord[j], b, v);
                relax(ord[j], nw.fi, nw.se);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (ll b : poss[ord[i]]) {
            ll v = dp[ord[i]][b];
            auto nw = calc_new(ord[i], n - 1, b, v);
            relax(n - 1, nw.fi, nw.se);
        }
    }
    cout << dp[n - 1][*poss[n - 1].lower_bound(0)];
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
    return 0;
}