#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

template <typename T>
struct decr : T {
    decr() : T() {
        --(*this);
    }
};

using namespace std;

struct solve {
    in<int> n, m, p, g;
    vector<in<int>> w;
    struct edge {
        decr<in<int>> a, b;
        in<int> s;
    };
    vector<edge> edges;
    vector<vector<pair<int, int>>> graph;

    solve() : w(n), edges(m), graph(n) {
        for (auto [a, b, s] : edges) {
            graph[a].emplace_back(b, s);
        }

        switch (g) {
            case 1:
                solve_dijk();
                break;
            case 2:
                solve_bambuk();
                break;
            default:
                throw logic_error("Not implemented");
        }
    }

    void solve_dijk() {
        const long long INF = 1'000'000'000'000'000'001LL;
        vector<long long> dist(n, INF);

        auto cmp = [&](int i, int j) { return dist[i] < dist[j] || (dist[i] == dist[j] && i < j); };
        set<int, decltype(cmp)> queue(cmp);

        dist[0] = 0;
        for (int i = 0; i < n; ++i) {
            queue.insert(i);
        }
        while (!queue.empty()) {
            int v = *queue.begin();
            queue.erase(queue.begin());
            for (auto [u, s] : graph[v]) {
                if (dist[u] > dist[v] + s) {
                    auto it = queue.find(u);
                    if (it != queue.end()) {
                        queue.erase(it);
                    }
                    dist[u] = dist[v] + s;
                    queue.insert(u);
                }
            }
        }
        if (dist[n - 1] > INF / 2) {
            cout << "-1\n";
        } else {
            cout << max(0LL, dist[n - 1] - p) << "\n";
        }
    }

    void solve_bambuk() {
        long long cur_money = p;
        long long cnt = 0;
        for (int i = 0; i < n - 1; ++i) {
            long long new_predst = max(0LL, edges[i].s - cur_money + w[i] - 1) / w[i];
            cnt += new_predst;
            cur_money += w[i] * new_predst;
            cur_money -= edges[i].s;
        }
        cout << cnt << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
