#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

const int inf = 1e18;

void solve1(int n, int m, int p) {
	vector<vector<pair<int, int>>> g(n, vector<pair<int, int>>());
	vector<int> ww(n);
	for (int &x: ww) cin >> x;
	for (int i = 0; i < m; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		--a;
		--b;
		g[a].push_back({b, w});
	}
	vector<int> dist(n, inf);
	dist[0] = 0;
	set<pair<int, int>> s;
	s.insert({0, 0});
	for (int i = 1; i < n; ++i) s.insert({dist[i], i});
	while (s.size()) {
		auto [d, v] = (*(s.begin()));
		s.erase(s.begin());
		for (auto [u, w]: g[v]) {
			if (dist[u] > d + w) {
				s.erase({dist[u], u});
				dist[u] = d + w;
				s.insert({dist[u], u});
			}
		}
	}
	if (dist[n - 1] == inf) {
		cout << -1 << endl;
		return;
	}
	cout << max(dist[n - 1] - p, 0ll) << endl; 
}

void solve2(int n, int m, int p) {
	vector<vector<int>> g(n, vector<int>(n, inf));
	vector<int> w(n);
	for (int &x: w) cin >> x;
	for (int i = 0; i < m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		--a;
		--b;
		g[a][b] = min(g[a][b], c);
	}
	vector<int> perm(n);
	iota(perm.begin(), perm.end(), 0);
	int ans = inf;
	do {
		if (perm[0] != 0) continue;
		bool ban = 0;
		int maxw = w[0];
		int money = p;
		int ansn = 0;
		for (int i = 1; perm[i - 1] != n - 1; ++i) {
			int c = g[perm[i - 1]][perm[i]];
			if (c == inf) {
				ban = 1;
				break;
			}
			if (money >= c) {
				money -= c;
			}
			else {
				int now = (c - money + maxw - 1) / maxw;
				money = maxw * now + money - c;
				ansn += now;
			}
			maxw = max(maxw, w[perm[i]]);
		}
		if (ban) continue;
		ans = min(ans, ansn);
	} while (0);
	if (ans != inf)	cout << ans << endl;
	else cout << -1 << endl;
}

void solve3(int n, int m, int p) {
	vector<vector<int>> g(n, vector<int>(n, inf));
	vector<int> w(n);
	for (int &x: w) cin >> x;
	for (int i = 0; i < m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		--a;
		--b;
		g[a][b] = min(g[a][b], c);
	}
	vector<int> perm(n);
	iota(perm.begin(), perm.end(), 0);

	int ans = inf;
	do {
		if (perm[0] != 0) break;
		for (int add = 1; add < n - 1; ++add) {
			for (int ind = 0; ind <= n; ++ind) {
				vector<int> nperm;
				for (int i = 0; i < ind; ++i) {
					nperm.push_back(perm[i]);
				}
				nperm.push_back(add);
				for (int i = ind; i < n; ++i) {
					nperm.push_back(perm[i]);
				}
				bool ban = 0;
				int maxw = w[0];
				int money = p;
				int ansn = 0;
				for (int i = 1; perm[i - 1] != n - 1; ++i) {
					int c = g[perm[i - 1]][perm[i]];
					if (c == inf) {
						ban = 1;
						break;
					}
					if (money >= c) {
						money -= c;
					}
					else {
						int now = (c - money + maxw - 1) / maxw;
						money = maxw * now + money - c;
						ansn += now;
					}
					maxw = max(maxw, w[perm[i]]);
				}
				if (ban) continue;
				ans = min(ans, ansn);
			}	
		}
		bool ban = 0;
		int maxw = w[0];
		int money = p;
		int ansn = 0;
		for (int i = 1; perm[i - 1] != n - 1; ++i) {
			int c = g[perm[i - 1]][perm[i]];
			if (c == inf) {
				ban = 1;
				break;
			}
			if (money >= c) {
				money -= c;
			}
			else {
				int now = (c - money + maxw - 1) / maxw;
				money = maxw * now + money - c;
				ansn += now;
			}
			maxw = max(maxw, w[perm[i]]);
		}
		if (ban) continue;
		ans = min(ans, ansn);
	} while (next_permutation(perm.begin(), perm.end()));
	if (ans != inf)	cout << ans << endl;
	else cout << -1 << endl;
}

signed main() {
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	if (g == 1) {
		solve1(n, m, p);
	}
	if (g == 2) {
		solve2(n, m, p);
	}
	if (g == 3 || g == 0) {
		solve3(n, m, p);
	}
}

/*
4 4 2 3
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

4 4 10 3
1 2 10 1
1 2 20
2 4 30
1 3 25
3 4 89

4 4 7 3
5 1 6 2
1 2 5
2 3 10
3 4 50
3 4 70

4 1 2 3
1 1 1 1
1 3 2

*/