#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

const ll inf = ll(1e18);

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m, p, G;
  cin >> n >> m >> p >> G;
  vector<ll> w(n);
  for (int i = 0; i < n; ++i) cin >> w[i];
  vector<vector<tuple<int, ll, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int x, y; ll z;
    cin >> x >> y >> z;
    assert(x != y);
    --x, --y;
    g[x].emplace_back(y, z, i);
  }
  if (G == 1) {
    vector<ll> d(n, inf);
    vector<int> used(n);
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
    q.emplace(0, 0);
    d[0] = 0;
    while (!q.empty()) {
      auto [dv, v] = q.top();
      q.pop();
      if (used[v]) continue;
      used[v] = 1;
      for (auto [u, z, id] : g[v]) {
        if (d[u] > d[v] + z) {
          d[u] = d[v] + z;
          q.emplace(d[u], u);
        }
      }
    }
    if (d.back() == inf) {
      cout << -1;
    } else {
      cout << max(0ll, d.back() - p);
    }
    return 0;
  }
  assert(G == 0 || G == 3);
  vector<vector<ll>> dist(n, vector<ll>(n, inf));
  for (int x = 0; x < n; ++x) {
    dist[x][x] = 0;
    for (auto [y, z, id] : g[x]) {
      dist[x][y] = min(dist[x][y], z);
    }
  }
  for (int k = 0; k < n; ++k) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
        dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
      }
    }
  }
  vector<unordered_map<ll, ll>> dp(n);
  dp[0][p] = 0;
  bool can = false;
  function<void(int, vector<int>, vector<int>)> Dfs = [&](int v, vector<int> used, vector<int> usedE) {
    //cout << v << endl;
    for (int u = 0; u < n; ++u) if (u != v && used[u] && dist[u][v] != inf) {
      for (auto [money, cnt] : dp[u]) {
        ll add = 0;
        if (money < dist[u][v]) add = (dist[u][v] - money + w[u] - 1) / w[u];
        ll nmoney = money + w[u] * add - dist[u][v];
        if (dp[v].find(nmoney) == dp[v].end()) dp[v][nmoney] = cnt + add;
        else dp[v][nmoney] = min(dp[v][nmoney], cnt + add);
      }
    }
    used[v] = 1;
    can |= v == n - 1;
    for (auto [u, z, id] : g[v]) {
      if (!usedE[id]) {
        usedE[id] = 1;
        Dfs(u, used, usedE);
      }
    }
  };
  Dfs(0, vector<int>(n, 0), vector<int>(m, 0));
  if (!can) {
    cout << -1;
    return 0;
  }
  ll ans = inf;
  for (auto [money, cnt] : dp[n - 1]) {
    ans = min(ans, cnt);
  }
  cout << ans;
  return 0;
}