#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define int long long
#define str string

const int INF = 1e14 + 10;

vector<int> dijkstra(int n, int s, vector<vector<pii>> &g) {
    vector<int> dist(n, INF), used(n, 0);
    dist[s] = 0;
    set<pair<int, int>> D;
    f (i, 0, n) D.insert({dist[i], i});

    f (iter, 0, n) {
        auto it = D.begin();
        auto p = *it;
        //cout << p.ff << ' ' << p.sc << '\n';
        D.erase(it);
        used[p.sc] = 1;
        for (auto &u : g[p.sc]) {
            if (!used[u.ff] && dist[u.ff] > p.ff + u.sc) {
                D.erase(D.find({dist[u.ff], u.ff}));
                dist[u.ff] = p.ff + u.sc;
                D.insert({dist[u.ff], u.ff});
            }
        }
    }
    return dist;
}

vector<vector<int>> gen(int n, int k) {
    if (k == 0) return {{}};
    auto res = gen(n, k - 1);
    vector<vector<int>> ans;
    for (auto &u : res) {
        vector<int> used(n + 1, 0);
        f(i,0,k-1)used[u[i]] = 1;
        f (i, 1, n + 1) {
            u.pb(i);
            ans.pb(u);
            u.pop_back();
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr); cin.tie(nullptr);
    cout << fixed << setprecision(10);

    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    bool flag = true;
    f (i, 0, n) {
        cin >> w[i];
        if (w[i] != 1) {
            flag = false;
        }
    }
    map<pii, int> cost;
    vector<vector<pii>> g(n);
    f (i, 0, m) {
        int a, b, s;
        cin >> a >> b >> s;
        if(cost.find({a-1, b-1}) == cost.end()) {
            cost[{a-1,b-1}]=s;
        }else{
            cost[{a-1,b-1}]=min(cost[{a-1,b-1}],s);
        }
        g[a-1].pb({b-1, s});
    }

    if (group == 1) {
        auto res = dijkstra(n, 0, g);
        if (res[n - 1] == INF) {
            cout << "-1\n";
        } else {
            cout << max(0ll, res[n - 1] - p) << '\n';
        }
        return 0;
    }
    else if (group == 2) {
        vector<int> c(n - 1);
        f(i, 0, n - 1)c[i] = g[i][0].sc;

        vector<int> pref(n, 0);
        f (i, 1, n) {
            pref[i] = pref[i - 1] + c[i - 1];
        }

        vector<int> right(n, n - 1);
        f (i, 0, n) {
            f (j, i + 1, n) {
                if (w[j] > w[i]) {
                    right[i] = j;
                    break;
                }
            }
        }

        int i = 0, ans = 0;
        while (i != n - 1) {
            int ostat = pref[right[i]] - pref[i];
            int need = ceil((double) max(0ll, ostat - p) / w[i]);
            ans += need;
            p -= ostat;
            p += need * w[i];
            i = right[i];
        }
        cout << ans << '\n';
        return 0;
    }

    else if (group == 3) {
        int ans = INF;
        for (int i = 0; i <= n - 2; i++) {
            auto res = gen(n - 2, i);
            for(auto&u:res){
                bool flagg = true;
                vector<int>path={0};
                f(j,0,i)path.pb(u[j]-1);
                path.pb(n-1);

                vector<int> c(i+1);
                f(j, 0, i+1){
                    if(cost.find({path[j], path[j+1]})==cost.end()){
                        flagg=false;
                    }
                    c[j] = cost[{path[j], path[j+1]}];
                }
                if(!flagg)continue;

                vector<int> pref(i+2, 0);
                f (j, 1, i+2) {
                    pref[j] = pref[j - 1] + c[j - 1];
                }

                vector<int> right(i+2, i+1);
                f (j, 0, i+2) {
                    f (j1, j + 1, i+2) {
                        if (w[path[j1]] > w[path[j]]) {
                            right[j] = j1;
                            break;
                        }
                    }
                }

                int ind = 0, answerr = 0, p2=p;
                while (ind != i+1) {
                    int ostat = pref[right[ind]] - pref[ind];
                    int need = ceil((double) max(0ll, ostat - p2) / w[path[ind]]);
                    answerr += need;
                    p2 -= ostat;
                    p2 += need * w[path[ind]];
                    ind = right[ind];
                }
                ans = min(ans, answerr);
            }

        }
        cout<<(ans==INF?-1:ans)<<'\n';
    }

    return 0;
}