#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 800, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator+ (const Mod_int& m) const
	{
		return ans + m.ans;
	}
	Mod_int operator+= (const Mod_int& m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int& m) const
	{
		return int32_t(ans) - int32_t(m.ans) + int32_t(MOD);
	}
	Mod_int operator-= (const Mod_int& m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
	bool operator== (const Mod_int& m) const
	{
		return ans == m.ans;
	}
};

vector <pair <int, int64_t>> mas[MAXN];
int64_t dist[MAXN], val[MAXN];
int nxt_more[MAXN];
int64_t edg[10][10];
bool used[10];
int n;
int64_t answ = 1E18, p;
vector <int> path;

void per(int x)
{
	used[x] = true;
	path.push_back(x);
	if (x == n - 1)
	{
		dist[path[0]] = 0;
		for (int i = 0; i < path.size() - 1; i++)
		{
			dist[path[i + 1]] = dist[path[i]] + edg[path[i]][path[i + 1]];
		}

		val[n - 1] = 1E9 + 1;
		vector <int> q;
		q.push_back(n - 1);
		for (int i = path.size() - 1; i >= 0; i--)
		{
			while (val[q.back()] < val[path[i]])
			{
				q.pop_back();
			}
			nxt_more[path[i]] = q.back();
			q.push_back(path[i]);
		}

		int t = 0;
		int64_t bal = p, ans = 0;
		while (t < n - 1)
		{
			if (dist[nxt_more[t]] - dist[t] > bal)
			{
				ans += (dist[nxt_more[t]] - dist[t] - bal + val[t] - 1) / val[t];
				bal += (dist[nxt_more[t]] - dist[t] - bal + val[t] - 1) / val[t] * val[t];
			}
			bal -= dist[nxt_more[t]] - dist[t];
			t = nxt_more[t];
		}
		rmin(answ, ans);
		used[x] = false;
		path.pop_back();
		return;
	}

	for (int i = 0; i < n; i++)
	{
		if (!used[i] and edg[x][i] != 1E12)
		{
			per(i);
		}
	}
	path.pop_back();
	used[x] = false;
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int m, g;
	cin >> n >> m >> p >> g;

	for (int i = 0; i < n; i++)
	{
		cin >> val[i];
	}

	if (g == 1)
	{
		for (int i = 0; i < m; i++)
		{
			int u, v;
			int64_t s;
			cin >> u >> v >> s;
			mas[u - 1].push_back({ v - 1,s });
		}

		fill(dist, dist + n, 1E18);
		set <pair <int64_t, int>> d;
		dist[0] = 0;
		d.insert({ 0,0 });
		while (!d.empty())
		{
			auto f = *d.begin();
			d.erase(d.begin());

			for (int i = 0; i < mas[f.second].size(); i++)
			{
				int nxt = mas[f.second][i].first;
				if (dist[nxt] > f.first + mas[f.second][i].second)
				{
					if (d.count({ dist[nxt],nxt }))
					{
						d.erase({ dist[nxt],nxt });
					}
					dist[nxt] = f.first + mas[f.second][i].second;
					d.insert({ dist[nxt],nxt });
				}
			}
		}

		if (dist[n - 1] == 1E18)
		{
			cout << -1;
		}
		else
		{
			cout << max(int64_t(0), dist[n - 1] - p);
		}
	}
	else if (g == 2)
	{
		for (int i = 0; i < n - 1; i++)
		{
			int u, v, x;
			cin >> u >> v >> x;
			dist[i + 1] = dist[i] + x;
		}

		val[n - 1] = 1E9 + 1;
		vector <int> q;
		q.push_back(n - 1);
		for (int i = n - 2; i >= 0; i--)
		{
			while (val[q.back()] < val[i])
			{
				q.pop_back();
			}
			nxt_more[i] = q.back();
			q.push_back(i);
		}

		int t = 0;
		int64_t bal = p, ans = 0;
		while (t < n - 1)
		{
			if (dist[nxt_more[t]] - dist[t] > bal)
			{
				ans += (dist[nxt_more[t]] - dist[t] - bal + val[t] - 1) / val[t];
				bal += (dist[nxt_more[t]] - dist[t] - bal + val[t] - 1) / val[t] * val[t];
			}
			bal -= dist[nxt_more[t]] - dist[t];
			t = nxt_more[t];
		}
		cout << ans;
	}
	else if (g == 3 or g == 0)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				edg[i][j] = 1E12;
			}
		}

		for (int i = 0; i < m; i++)
		{
			int u, v;
			int64_t s;
			cin >> u >> v >> s;
			rmin(edg[u - 1][v - 1], s);
		}
		per(0);
		if (answ == 1E18)
		{
			cout << -1;
		}
		else
			cout << answ;
	}
}