#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pp;

struct Edge {
    ll to, w;
};

ll n, m, p, g;
vector<ll> w;
vector<vector<Edge>> graph;

void solve1() {
    const ll inf = 1e16;
    vector<ll> ans(n, inf);
    ans[0] = 0;
    set<pp> choice;
    for (ll i = 0; i < n; i++) {
        choice.insert({ans[i], i});
    }
    vector<bool> used(n);
    for (ll i = 0; i < n; i++) {
        pp fr = *choice.begin();
        used[fr.second] = true;
        choice.erase(choice.begin());
        for (Edge edg:graph[fr.second]) {
            ll to = edg.to;
            ll wt = edg.w;
            if (!used[to]) {
                choice.erase({ans[to], to});
                ans[to] = min(ans[to], ans[fr.second] + wt);
                choice.insert({ans[to], to});
            }
        }
    }
    if (ans[n - 1] == inf) {
        cout << -1;
    } else {
        cout << max(0ll, ans[n - 1] - p);
    }
}

ll splt(ll a, ll b) {
    if (a % b == 0) {
        return a / b;
    }
    return a / b + 1;
}

void solve2() {
    vector<ll> next_more_me(n, n - 1);
    vector<ll> st;
    for (ll i = 0; i < n; i++) {
        while (!st.empty() && w[i] > w[st.back()]) {
            next_more_me[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    ll ans = 0;
    ll i = 0;
    while (i != n - 1) {
        ll vrt = i;
        ll cost = 0;
        while (vrt != next_more_me[i]) {
            cost += graph[vrt][0].w;
            vrt = graph[vrt][0].to;
        }
        ll need = max(0ll, cost - p);
        ll buy = splt(need, w[i]);
        p = p + buy * w[i] - cost;
        ans += buy;
        i = next_more_me[i];
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> p >> g;
    w.assign(n, 0);
    graph.assign(n, {});
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (ll i = 0; i < m; i++) {
        ll a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        graph[a].push_back(Edge{b, s});
    }
    if (g == 1) {
        solve1();
    } else if (g == 2) {
        solve2();
    }

}