#include <iostream>
#include <vector>

#if !defined LOCAL && !defined DEBUG
#define USE_FAST_IO
#endif

#ifdef USE_FAST_IO
#define endl '\n'
#endif

using namespace std;

struct Edge {
    int to, weight;
    explicit Edge() = default;
    Edge(int to_, int weight_) : to(to_), weight(weight_) {

    }
};

using Graph = vector<vector<Edge>>;

void solve_line(Graph &graph, vector<int> &earnings, int p) {
    int n = graph.size();
    int64_t ans = 0;
    int64_t cur = p;
    int earning = 0;
    for (int i = 0; i < n - 1; i++) {
        earning = max(earning, earnings[i]);
        int next_weight = graph[i][0].weight;
        int64_t needed = max((int64_t) 0, next_weight - cur);
        int64_t delta = (needed + earning - 1) / earning;
        ans += delta;
        cur += delta * earning;
        cur -= next_weight;
    }
    cout << ans << endl;
}

int main() {
#ifdef USE_FAST_IO
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m, p, g; cin >> n >> m >> p >> g;
    vector<int> earnings(n);
    for (int &i : earnings) {
        cin >> i;
    }
    Graph graph(n);
    for (int i = 0; i < m; i++) {
        int a, b, w; cin >> a >> b >> w;
        a--; b--;
        graph[a].emplace_back(b, w);
    }
    if (g == 2) {
        solve_line(graph, earnings, p);
    } else {
        cerr << "Not implemented" << endl;
        return 1;
    }
}
