#include <iostream>
#include <vector>


using namespace std;
using ll = long long;


ll ans = 1000000000000000001;
vector<vector<pair<int, ll>>> graph;
vector<ll> money;
int num_of_vertices;


void DFS(int vertex, vector<int> &used, ll money_now, ll vast, ll maxx) {
    if (vertex == num_of_vertices - 1) {
        ans = min(ans, vast);
    } else {
        for (auto kid: graph[vertex]) {
            if (used[kid.first] != 2) {
                ++used[kid.first];
                if (money_now >= kid.second) {
                    DFS(kid.first, used, money_now - kid.second, vast, max(maxx, money[kid.first]));
                } else {
                    ll c = (kid.second - money_now + maxx - 1) / maxx;
                    DFS(kid.first, used, money_now + c * maxx - kid.second, vast + c, max(maxx, money[kid.first]));
                }
                --used[kid.first];
            }
        }
    }
}

int main() {
    int num_of_edges, money_start, group;
    cin >> num_of_vertices >> num_of_edges >> money_start >> group;
    money.resize(num_of_vertices);
    for (int i = 0; i < num_of_vertices; ++i) {
        cin >> money[i];
    }
    graph.resize(num_of_vertices);
    for (int i = 0; i < num_of_edges; ++i) {
        int v, u;
        ll w;
        cin >> v >> u >> w;
        --v;
        --u;
        graph[v].push_back({u, w});
    }
    vector<int> used(num_of_vertices, 0);
    ++used[0];
    DFS(0, used, money_start, 0, money[0]);
    if (ans == 1000000000000000001) {
        cout << -1;
    } else {
        cout << ans;
    }
    return 0;
}
