#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;
#define int long long

const int N = 810;
int n, m, p, G;
int w[N];
int g[N][N];

const int inf = 1e18;

vector <pair <int, int>> a;/*
pair <int, int> cst[N];

pair <int, int> pay(pair <int, int> x, int u, int v)
{
	if (g[u][v] == inf) return { inf, inf };

	int need = max(0ll, (g[u][v] - x.second) / w[u]);
	x.first += need;
	x.second += w[u] * need;
	x.second -= g[u][v];
	return x;
}*/

const int K = 10010;

pair <int, int> dp[N];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n >> m >> p >> G;

	for (int i = 1; i <= n; ++i) cin >> w[i];
	for (int i = 1; i <= n; ++i) for (int j = 1; j <= n; ++j) g[i][j] = i == j ? 0 : inf;
	for (int i = 1; i <= m; ++i)
	{
		int u, v, c;
		cin >> u >> v >> c;
		g[u][v] = min(g[u][v], c);
	}

	for (int k = 1; k <= n; ++k)
	{
		for (int i = 1; i <= n; ++i)
		{
			for (int j = 1; j <= n; ++j)
			{
				g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
			}
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		a.push_back({ w[i], i });
	}

	sort(a.begin(), a.end());

	for (int _ = 0; _ < n; ++_)
	{
		auto u = a[_].second;

		dp[_] = { inf, inf };

		if (u == 1)
		{
			dp[_] = { 0, p + 1 };
		}
		else
		{
			int mi = inf;
			for (int __ = 0; __ < _; ++__)
			{
				auto v = a[__].second;

				if (g[v][u] == inf) continue;
				mi = min(mi, (dp[__].second >= g[v][u] ? dp[__].first : dp[__].first + (g[v][u] - dp[__].second - 1) / w[v] + 1));
			}

			int l = 1, r = inf;
			if (mi == inf)
			{
				l = inf;
			}
			else
			{
				while (l + 1 < r)
				{
					int mid = (l + r) >> 1;

					int nmi = inf;
					for (int __ = 0; __ < _; ++__)
					{
						auto v = a[__].second;

						if (g[v][u] == inf) continue;
						nmi = min(nmi, (dp[__].second >= g[v][u] + mid - 1 ? dp[__].first : dp[__].first + (g[v][u] + mid - 1 - dp[__].second - 1) / w[v] + 1));
					}

					if (nmi == mi) l = mid;
					else r = mid;
				}
			}
			
			dp[_] = { mi, l };
		}
	}

	int ans = inf;
	for (int i = 0; i < n; ++i)
	{
		if (g[a[i].second][n] == inf) continue;
		ans = min(ans, (dp[i].second >= g[a[i].second][n] ? dp[i].first : dp[i].first + (g[a[i].second][n] - dp[i].second - 1) / w[a[i].second] + 1));
	}

	cout << (ans == inf ? (ll)(-1) : ans);

	return 0;
}