#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <climits>
#include <deque>

using namespace std;

#define ll long long
#define lll __int128
#define ld long double
#define lld __float128
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

struct interactor {
    ll ans(vector<ll> what) {
        cout << '!' << " ";
        for (int i = 0; i < what.size(); ++i) cout << what[i] << " ";
        cout << endl;
        ll res;
        cin >> res;
        return res;
    }

    ll ask(ll what) {
        cout << "?" << " " << what << endl;
        ll ans;
        cin >> ans;
        if (ans == -1) exit(0);
        return ans;
    }
};

ll formulo(ll index) {
    return ((index + 1) * index) / 2;
}

struct border {
    ll a, b, w;
};

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> plus(n);
    for (int i = 0; i < n; ++i) cin >> plus[i];
    vector<vector<border>> graph(n);
    for (int i = 0; i < m; ++i) {
        border br;
        cin >> br.a >> br.b >> br.w;
        br.a--;
        br.b--;
        graph[br.a].push_back(br);
    }
    set<pair<ll, int>> mindist;
    mindist.insert(0, 0);
    vector<ll> md(n, 1e17);
    md[0] = 0;
    while (mindist.size() > 0) {
        auto now = (*mindist.begin());
        mindist.erase(mindist.begin());
        for (auto bb : graph[now.second]) {
            ll newy = bb.w + now.first;
            if (newy < md[bb.b]) {
                mindist.erase({bb.b, md[bb.b]});
                md[bb.b] = newy;
                mindist.insert({bb.b, newy});
            }
        }
    }
    if (md[n - 1] > 1e13) {
        cout << -1 << endl;
    }
    else {
        cout << max((ll)0, p - md[n - 1]) << endl;
    }
}

int main() {
    fast;
    srand((int)time(nullptr));
    int t = 1;
    while (t--) solve();
    return 0;
}