#include <iostream>
#include <utility>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

//struct LCA{
//    int n, k;
//    vector<int> depths, parents;
//    vector<vector<int>> dp;
//
//    void dfs(int v, int par, vector<vector<int>>& g, vector<bool>& used){
//        used[v] = true;
//        parents[v] = par;
//        for(auto to : g[v]){
//            if(!used[to])
//                dfs(to, v, g, used);
//        }
//        if(par != -1)
//            depths[v] = depths[par] + 1;
//
//    }
//
//    int get_log2(int n){
//        ll num = 1;
//        k = 0;
//        while (num < n) {
//            num *= 2;
//            k++;
//        }
//        return k;
//    }
//
//    void LA(){
//        for(int i = 0; i < n; i++)
//            dp[0][i] = parents[i];
//        for(int i = 1; i <= k; i++){
//            for(int j = 0; j < n; j++){
//                dp[k][i] = dp[k - 1][dp[k - 1][i]];
//            }
//        }
//    }
//
//    void build(vector<vector<int>>& g){
//        n = g.size();
//        vector<bool> used(n);
//        depths.assign(n, 0);
//        parents.assign(n, 0);
//        dfs(0,-1,g,used);
//
//        int k = get_log2(n);
//        dp.assign(k + 1, vector<int>(n));
//        LA();
//    }
//
//    int up(int v, int level){
//        for(int i = k; i >= 0; i--){
//            if(depths[v] - (1ll << i) >= level){
//                v = dp[i][v];
//            }
//        }
//        return v;
//    }
//
//    int lca(int v, int u){
//        if(depths[v] < depths[u])
//            u = up(u, depths[v]);
//        if (depths[u] < depths[v])
//            v = up(v, depths[u]);
//
//
//    }
//
//
//};
//
const ll INF = 1e18;
struct segtree{
    vector<int> tree;
    int size;

    int init(int n){
        size = 1;
        while(size < n)
            size *= 2;
        tree.assign(2 * size - 1, -INF);
    }


};

int timer;
//void dfs1(int v, vector<vector<pair<int, int>>>& g, vector<int>& used, vector<int>& tout){
//    used[v] = true;
//
//    for(auto e : g[v]){
//        int to = e.first;
//        if(!used[to]){
//            dfs1(to, g, used, tout);
//        }
//    }
//    tout[v] = timer++;
//}

void condense(int v, vector<vector<int>>& g, vector<vector<int>>& cond,vector<int>&used){
    used[v] = true;
    cond.back().push_back(v);

    for(auto to : g[v]){
        if(!used[to])
            condense(to, g, cond, used);
    }
}

//void solve1(){
//    timer = 0;
//    int n, m;
//    cin >> n >> m;
//
//    vector<vector<pair<int, int>>> g(n);
//    for(int i = 0;  i < m; i++){
//        int v,u,w;
//        cin >> v >> u >> w;
//        v--, u--;
//        g[v].push_back({u, w});
//    }
//
//    vector<int> tout(n), used(n);
//    for(int i = 0; i < n; i++){
//        if(!used[i]){
//            dfs(i,g, used, tout);
//        }
//    }
//
//    vector<vector<int>> cond, inv_g(n);
//    used.assign(n, 0);
//    for(int i = 0; i < n; i++){
//        for(auto e : g[i]){
//            inv_g[e.first].push_back(i);
//        }
//    }
//    for(int i = 0; i < n; i++){
//        if(!used[i])
//            condense(i, inv_g, cond, used);
//    }
//
//    for(int i = 0;  i< cond.size(); i++){
//        cout<<i <<"\n";
//        for(auto j : cond[i])
//            cout<<j << ' ';
//        cout<<"\n";
//    }
//
//}

//const ll P = {29, 31, 179, 239}, MODS = {1000000007, 1000000009, 1000000003};
const ll P = 29, MOD = 1e9 + 7;

ll summ(ll a, ll b, ll m){
    if(a + b > m)
        return a + b - m;
    return a + b;
}

ll get_minus(ll a, ll b, ll m){
    if (a < b)
        return a - b + m;
    return a - b;
}

ll product(ll a, ll b, ll m){
    return a * b % m;
}

struct Hash{
    vector<ll> h, powers;

    void build(string& s){
        int n = s.length();

            powers.push_back({1});
            h.push_back({0});


            for(int j = 0; j < n; j++){
                powers.push_back(product(powers.back(), P, MOD));
        }

            for(int j = 0; j < n; j++){
                ll sym = s[j] - 'a' + 1;
                h.push_back(summ(product(h.back(), P, MOD), sym,MOD));
            }

    }

    ll get_sub(int l, int r){
        l--;
        return product(get_minus(h[r], h[l], MOD), powers[r - l], MOD);
    }
};

ll dijkstra( vector<vector<pair<ll, ll>>> &g){
      set <pair<ll, int>> q;
      q.insert({0, 0});
      vector<ll> d(g.size(), INF);
      d[0] = 0;
      while(!q.empty()){
          auto pr = *q.begin();
          int v = pr.second;
          q.erase(pr);
          if (v == g.size() - 1)
              break;
          for(auto pr1 : g[v]){
              int to = pr1.first;
              ll w = pr1.second;
              if(d[v] + w < d[to]){
                  q.erase({d[to], to});
                  d[to] = d[v] + w;
                  q.insert({d[to], to});
              }
          }
      }
      return d[g.size() - 1];
}

void solve1(int n, int m, ll p){
    vector<ll> w(n);
    for(auto& i : w)
        cin >> i;
    vector<vector<pair<ll, ll>>> g(n);
    for(int i = 0; i < m; i++){
        int a, b;
        ll s;
        cin >> a >> b >> s;
        a--, b--;
        g[a].push_back({b, s});
    }

    ll len = dijkstra(g);
    if(len == INF)
        cout<<-1;
    else
        cout<<max(0ll, len - p);
}

ll pos_ans = INF;
void rec(int v, ll p1, ll mx1, ll ans1, vector<ll>& w,vector<vector<ll>>& g, vector<bool>& used){
    if(v == g.size() - 1){
        pos_ans = min(ans1, pos_ans);
        return;
    }
    used[v] = true;
    mx1 = max(mx1, w[v]);
    for(int i = 0; i < g.size(); i++){
        ll p = p1;
        ll ans = ans1;
        if((g[v][i] != INF && !used[i]) || (g[v][i] != INF && !used[i] && w[i] < w[v])){
            if (g[v][i] > p){
                ll add = 0;
                add += (g[v][i] - p) / mx1;
                if ((g[v][i] - p) % mx1 != 0)
                    add++;
                p += add * mx1;
                ans += add;
            }
            p -= g[v][i];
            rec(i, p, mx1, ans, w, g, used);
        }
    }
    used[v] = false;
}

void solve3(int n, int m, ll p){
    vector<ll> w(n);
    for(auto& i : w)
        cin >> i;
    vector<vector<ll>> g(n, vector<ll>(n, INF));
    for(int i = 0; i < m; i++){
        int a, b;
        ll s;
        cin >> a >> b >> s;
        a--, b--;
        if(a == b)
            continue;
        g[a][b] = min(g[a][b], s);
    }
    vector<bool>used(n);
    rec(0,p,w[0],0,w,g,used);
    if(pos_ans == INF)
        cout<<-1;
    else
        cout<<pos_ans;
}

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, m, g;
    ll p;
    cin >> n >> m >> p >> g;
    if(g == 1){
        solve1(n,m,p);
        return 0;
    }
    else if(g == 2){
        vector<ll> w(n);
        for(auto& i : w)
            cin >> i;
        vector<ll> g(n - 1);
        for(int i = 0; i < m; i++){
            int a, b;
            ll s;
            cin >> a >> b >> s;
            a--, b--;
            g[a] = s;
        }

        ll ans = 0;
        ll mx = w[0];
        for(int i = 0; i < n - 1; i++){
            mx = max(mx, w[i]);
            if (g[i] > p){
                ll add = 0;
                add += (g[i] - p) / mx;
                if ((g[i] - p) % mx != 0)
                    add++;
                p += add * mx;
                ans += add;
            }
            p -= g[i];
        }
        cout<<ans;
        return 0;
    }
    solve3(n,m,p);

    return 0;
}