#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

struct edge {
    int to, w;
};
vector<vector<edge>> gr;

vector<vector<ll>> dists;

void get(int i) {
    dists[i][i] = 0;
    set<pair<ll, ll>> had;
    had.insert({0, i});
    while (!had.empty()) {
        int v = had.begin()->second;
        had.erase(had.begin());
        for (auto el: gr[v]) {
            if (dists[i][el.to] > dists[i][v] + el.w) {
                had.erase({dists[i][el.to], el.to});
                dists[i][el.to] = dists[i][v] + el.w;
                had.insert({dists[i][el.to], el.to});
            }
        }
    }
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    gr.resize(n);
    dists.resize(n, vector<ll>(n, 1e16));
    vector<ll> w(n);
    cin >> w;
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--;
        v--;
        gr[u].push_back({v, s});
    }
    for (int i = 0; i < n; i++) {
        get(i);
    }
    if (dists[0][n - 1] == 1e16) {
        cout << -1 << "\n";
        return;
    }
    vector<pair<ll, ll>> real_dist(n, {1e16, -1});
    vector<pair<ll, ll>> my_real_wi;
    for (int i = 0; i < n; i++) {
        my_real_wi.push_back({w[i], i});
    }
    std::sort(my_real_wi.begin(), my_real_wi.end());
    for (int i = 0; i < n; i++) {
        if (dists[0][i] != 1e16 && dists[0][i] <= p) {
            real_dist[i] = {0, dists[0][i] - p};
        }
    }
    for (auto el: my_real_wi) {
        if (real_dist[el.second].first != 1e16) {
            for (int i = 0; i < n; i++) {
                if (dists[el.second][i] != 1e16) {
                    ll len = dists[el.second][i];
                    if (len <= -real_dist[el.second].second) {
                        real_dist[i] = min(real_dist[i],
                                           {real_dist[el.second].first, -real_dist[el.second].second - len});
                    } else {
                        len += real_dist[el.second].second;
                        ll cn = len / el.first;
                        len -= cn * el.first;
                        ll p2 =0;
                        if (len > 0){
                            cn ++;
                            p2 += el.first - len;
                        }
                        real_dist[i] = min(real_dist[i],
                                           {cn + real_dist[el.second].first, -p2});
                    }
                }
            }
        }
    }
    cout << real_dist[n - 1].first << "\n";


}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
