#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

struct Edge{
    int v, c;
};

int n, m, p, test_group;
vector<int> a;
vector<vector<Edge> > g;

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> p >> test_group;
    a.resize(n);
    g.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> a[i];
    for(int i = 0; i < m; i ++){
        int v, u, c;
        cin >> v >> u >> c;
        v --; u --;
        g[v].push_back({u, c});
    }

    if (test_group == 1){
        priority_queue<pair<int, int> > bfs;
        vector<int> d(n, inf);
        d[0] = 0;
        bfs.push({0, 0});
        while(!bfs.empty()){
            int w = -bfs.top().first;
            int v = bfs.top().second;
            bfs.pop();
            if (w != d[v])
                continue;
            for(auto u : g[v])
                if (w + u.c < d[u.v]){
                    d[u.v] = w + u.c;
                    bfs.push({-d[u.v], u.v});
                }
        }
        if (d[n - 1] == inf)
            cout << -1;
        else
            cout << max(0LL, d[n - 1] - p);
        return 0;
    }

    if (test_group == 2){
        int ma = a[0];
        int now = p;
        int ans = 0;
        for(int i = 0; i < n - 1; i ++){
            ma = max(ma, a[i]);
            int need = g[i][0].c;
            if (need <= p){
                p -= need;
                continue;
            }
            int k = (need - p) / ma + ((need - p) % ma == 0 ? 0 : 1);
            int salary = k * ma;
            p += salary - need;
            ans += k;
        }

        cout << ans;
        return 0;
    }
}

/*
4 2 2 1
1 1 1 1
1 3 2
3 4 5

4 4 2 1
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
*/
