#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

struct Edge{
    int v, c;
};

int n, m, p, test_group, ans = inf;
vector<int> a, can, used;
vector<vector<Edge> > g;

void dfs(int v, int ma = -inf, int now = 0, int have = p){
    if (v == n - 1){
        ans = min(ans, now);
        return;
    }
    used[v] ++;
    ma = max(ma, a[v]);
    for(auto i : g[v]){
        if (used[i.v] < can[i.v] + 10){
            int now_go = now, have_go = have;
            if (i.c <= have_go)
                have_go -= i.c;
            else {
                int k = (i.c - have_go) / ma + ((i.c - have_go) % ma == 0 ? 0 : 1);
                int salary = k * ma;
                have_go += salary - i.c;
                now_go += k;
            }
            dfs(i.v, ma, now_go, have_go);
        }
    }
//    used[v] --;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> p >> test_group;
    a.resize(n);
    g.resize(n);
    can.resize(n);
    used.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> a[i];
    for(int i = 0; i < m; i ++){
        int v, u, c;
        cin >> v >> u >> c;
        v --; u --;
        bool already_have = false;
        for(int j = 0; j < sz(g[v]); j ++)
            if (g[v][j].v == u){
                g[v][j].c = min(g[v][j].c, c);
                already_have = true;
            }
        if (!already_have){
            can[u] ++;
            g[v].push_back({u, c});
        }
    }

    if (test_group == 1){
        priority_queue<pair<int, int> > bfs;
        vector<int> d(n, inf);
        d[0] = 0;
        bfs.push({0, 0});
        while(!bfs.empty()){
            int w = -bfs.top().first;
            int v = bfs.top().second;
            bfs.pop();
            if (w != d[v])
                continue;
            for(auto u : g[v])
                if (w + u.c < d[u.v]){
                    d[u.v] = w + u.c;
                    bfs.push({-d[u.v], u.v});
                }
        }
        if (d[n - 1] == inf)
            cout << -1;
        else
            cout << max(0LL, d[n - 1] - p);
        return 0;
    }

    if (test_group == 2){
        int ma = a[0];
        int now = p;
        int ans = 0;
        for(int i = 0; i < n - 1; i ++){
            ma = max(ma, a[i]);
            int need = g[i][0].c;
            if (need <= p){
                p -= need;
                continue;
            }
            int k = (need - p) / ma + ((need - p) % ma == 0 ? 0 : 1);
            int salary = k * ma;
            p += salary - need;
            ans += k;
        }

        cout << ans;
        return 0;
    }

    dfs(0);

    if (ans == inf)
        cout << -1;
    else
        cout << ans;
}

/*
4 2 2 1
1 1 1 1
1 3 2
3 4 5

4 4 2 1
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

5 6 0 -1
1 5 50 500 0
1 2 5
2 3 5
3 2 5
2 4 100
4 2 100
2 5 1000
*/
