#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500500;
const ll mod = 1e13;

ll w[sz];
vector <pair <int, ll> > g[sz];
ll dist[sz];
bool used[sz];
bool fl = 0;

ll stupid(int n, ll p) {
	ll ans = 0, mx = w[1];
	for (int i = 2; i <= n; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		mx = max(mx, w[i - 1]);
		if (p >= s) {
			p -= s;
			continue;
		}
		ll need = (s - p + mx - 1) / mx;
		ans += need;
		p += need * mx;
		p -= s;
	}
	return ans;
}

ll dk(int n, int m, ll p) {
	dist[1] = 0;
	for (int i = 0; i < m; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		g[a].push_back({ b, s });
	}
	set <pair <ll, int> > s;
	for (int i = 2; i <= n; ++i) {
		dist[i] = mod;
	}
	for (int i = 1; i <= n; ++i) {
		s.insert({ dist[i], i });
	}
	while (!s.empty() && (*s.begin()).first != mod) {
		int p = (*s.begin()).second;
		s.erase(s.begin());
		for (auto u : g[p]) {
			ll nd = dist[p] + u.second;
			if (dist[u.first] > nd) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = nd;
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	if (dist[n] == mod) return -1;
	if (dist[n] <= p) return 0;
	return dist[n] - p;
}

void check(int u) {
	if (used[u]) return;
	used[u] = 1;
	for (auto i : g[u]) {
		check(i.first);
	}
}

ll f(int u, ll p, ll mx, int n) {
	if (u == n) return 0;
	ll ans = mod;
	mx = max(mx, w[u]);
	for (auto t : g[u]) {
		if (t.second <= p) {
			ans = min(ans, f(t.first, p - t.second, mx, n));
		}
		else {
			ll need = (t.second - p + mx - 1) / mx;
			ans = min(ans, need + f(t.first, p + need * mx - t.second, mx, n));
		}
	}
	return ans;
}

ll best[100][100];

int main() {
	int n, m, t;
	ll p;
	cin >> n >> m >> p >> t;
	for (int i = 1; i <= n; ++i) {
		cin >> w[i];
	}
	if (t == 1) {
		cout << dk(n, m, p);
		return 0;
	}
	if (t == 2) {
		cout << stupid(n, p);
		return 0;
	}
	for (int i = 0; i < m; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		g[a].push_back({ b, s });
	}
	check(1);
	if (!used[n]) {
		cout << -1;
		return 0;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			best[i][j] = mod;
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (auto p : g[i]) {
			if (p.first != i) best[i][p.first] = min(best[i][p.first], p.second);
		}
		g[i].resize(0);
		for (int j = 1; j <= n; ++j) {
			if (best[i][j] != mod) {
				g[i].push_back({ j, best[i][j] });
			}
		}
	}
	cout << f(1, p, w[1], n);
}