#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

void solve() {
	int n, m, p, group; cin >> n >> m >> p >> group;
	vector <int> prib(n); for (auto& x : prib) cin >> x;
	vector <vector <pair <int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}

	if (group == 1) {
		vector <int> dp(n, 1e18); dp[0] = 0;
		for (int iter = 0; iter < n; ++iter) {
			for (int v = 0; v < n; ++v) {
				for (auto [u, w] : g[v]) {
					dp[u] = min(dp[u], dp[v] + w);
				}
			}
		}

		if (dp[n - 1] > 1e17) cout << -1;
		else cout << max(dp[n - 1] - p, 0ll);
	}
	if (group == 2) {
		vector <int> ls(n, n - 1);
		{
			vector <int> st;
			for (int i = n - 2; i >= 0; --i) {
				while (!st.empty() && g[st.back()][0].second >= g[i][0].second) {
					st.pop_back();
				}
				if (!st.empty()) {
					ls[i] = st.back();
				}
				st.push_back(i);
			}
		}

		vector <int> prs(n, 0);
		for (int i = 1; i < n; ++i) {
			prs[i] = prs[i - 1] + g[i - 1][0].second;
		}

		int cur = p;
		int ans = 0;
		for (int i = 0; i < n - 1; ++i) {
			int need = prs[ls[i]] - prs[i];
			if (need > cur) {
				ans += (need - cur + prib[i] - 1) / prib[i];
				cur += prib[i] * ((need - cur + prib[i] - 1) / prib[i]);
			}
		}

		cout << ans;
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}