#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll INF = 1e18;

void solve1(int n, int m, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> st;
    st.insert({0, 0});
    while (not st.empty()) {
        auto x = *st.begin();
        int v = x.second;
        for (auto el: g[v]) {
            if (dist[el.first] > dist[v] + el.second) {
                st.erase({dist[el.first], el.first});
                dist[el.first] = dist[v] + el.second;
                st.insert({dist[el.first], el.first});
            }
        }
        st.erase(x);
    }
    if (dist[n - 1] == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << max(0ll, dist[n - 1] - (ll)p) << '\n';
}

void solve2(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    ll ans = 0, mx = 0, now = p;
    for (int i = 0; i < n - 1; ++i) {
        mx = max(mx, a[i]);
        if (g[i][0].second > now) {
            ll num = (g[i][0].second - now + mx - 1) / mx;
            ans += num;
            now += num * mx;
        }
        now -= g[i][0].second;
    }
    cout << ans << '\n';
}

vector<bool> used;

ll tryy(int v, ll mx, ll bal, vector<vector<pair<int, ll>>> &g, vector<ll> &a) {
    if (v == used.size() - 1) return 0;
    mx = max(mx, a[v]);
    used[v] = true;
    ll res = INF;
    for (auto el: g[v]) {
        if (used[el.first]) continue;
        ll tr = 0, num = 0;
        if (el.second > bal) {
            num = (el.second - bal + mx - 1) / mx;
            tr += num;
        }
        tr += tryy(el.first, mx, bal + num * mx - el.second, g, a);
        res = min(res, tr);
    }
    used[v] = false;
    return res;
}

void solve3(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    used.assign(n, false);
    ll ans = tryy(0, 0, p, g, a);
    if (ans == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, m, p, g; cin >> n >> m >> p >> g;
    if (g == 1) {
        solve1(n, m, p);
    } else if (g == 2) {
        solve2(n, m, p);
    } else if (g == 3 or g == 0) {
        solve3(n, m, p);
    }
}