#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll INF = 1e18;

void solve1(int n, int m, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> st;
    st.insert({0, 0});
    while (not st.empty()) {
        auto x = *st.begin();
        int v = x.second;
        for (auto el: g[v]) {
            if (dist[el.first] > dist[v] + el.second) {
                st.erase({dist[el.first], el.first});
                dist[el.first] = dist[v] + el.second;
                st.insert({dist[el.first], el.first});
            }
        }
        st.erase(x);
    }
    if (dist[n - 1] == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << max(0ll, dist[n - 1] - (ll)p) << '\n';
}

void solve2(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    ll ans = 0, mx = 0, now = p;
    for (int i = 0; i < n - 1; ++i) {
        mx = max(mx, a[i]);
        if (g[i][0].second > now) {
            ll num = (g[i][0].second - now + mx - 1) / mx;
            ans += num;
            now += num * mx;
        }
        now -= g[i][0].second;
    }
    cout << ans << '\n';
}

struct edge {
    int to;
    ll w;
    int i;
};

vector<bool> used;
vector<int> pathn;
vector<vector<int>> vars;

void dfs(int v, int n, vector<vector<edge>> &g) {
    if (v == n - 1) {
        vars.push_back(pathn);
        return;
    }
    for (auto e: g[v]) {
        if (used[e.i]) continue;
        used[e.i] = true;
        pathn.push_back(e.i);
        dfs(e.to, n, g);
        pathn.pop_back();
        used[e.i] = false;
    }
}

void solve3(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<ll>> tab(n, vector<ll>(n, INF));
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        tab[u][v] = min(tab[u][v], (ll)w);
    }
    ll ans = INF;
    vector<vector<edge>> g(n);
    int cnt = 0;
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (tab[i][j] != INF) {
                g[i].push_back({j, tab[i][j], cnt});
                cnt++;
                edges.push_back({i, j});
            }
        }
    }
    used.resize(cnt, false);
    dfs(0, n, g);
    for (auto &path: vars) {
        int now = 0;
        ll bal = p, tr = 0;
        ll mx = a[0];
        for (auto i: path) {
            int v = edges[i].second;
            if (tab[now][v] > bal) {
                ll num = (tab[now][v] - bal + mx - 1) / mx;
                tr += num;
                bal += num * mx;
            }
            bal -= tab[now][v];
            mx = max(mx, a[v]);
            now = v;
        }
        ans = min(ans, tr);
    }
    if (ans == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, m, p, g; cin >> n >> m >> p >> g;
    if (g == 1) {
        solve1(n, m, p);
    } else if (g == 2) {
        solve2(n, m, p);
    } else if (g == 3 or g == 0) {
        solve3(n, m, p);
    }
}