#include <bits/stdc++.h>

#define ll long long

using namespace std;

const ll INF = 1e18;

vector<vector<pair<int, ll>>> g;

ll dijkstra(int v, ll r) {
    vector<bool> used(g.size(), false);
    priority_queue<pair<ll, int>> q;
    q.push({0, v});
    while(!q.empty()) {
        auto [d, s] = q.top();
        q.pop();
        if (s == r) return -d;
        if (used[s]) continue;

        used[s] = true;
        d = -d;
        for (auto u : g[s]) {
            if (!used[u.first]) {
                q.push({-(d + u.second), u.first});
            }
        }
    }
    return INF;
}

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie();
    //cout.tie();
    ll n, m, t;
    ll p;
    cin >> n >> m >> p >> t;
    vector<ll> w(n);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    g.assign(n + 1, {});
    for (ll i = 0; i < m; i++) {
        ll a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
        g[b].push_back({a, s});
    }

    if (t == 1) {
        ll d = dijkstra(1, n);
        if (d == INF) {
            cout << -1;
        } else {
            cout << max(0 * 1LL, (d - p));
        }
    }
    return 0;
}

/*
4 4 0 1
1 1 1 1
1 2 1
1 3 2
2 4 10
4 3 3
*/
