#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF_L = (1ll << 60);

struct edge {
    ll u, w;
};

ll n, m, p, gr;
vector<vector<edge>> g;
vector<ll> w;

void solve1() {
    vector<ll> d(n, INF_L);
    vector<bool> used(n);

    set<pair<ll, ll>> q;
    d[0] = 0;
    q.insert({0, 0});

    while (!q.empty()) {
        auto [dv, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;

        for (auto [ui, wi]: g[v]) {
            if (!used[ui] && dv + wi < d[ui]) {
                q.erase({d[ui], ui});
                d[ui] = dv + wi;
                q.insert({d[ui], ui});
            }
        }
    }

    if (d[n - 1] == INF_L) {
        cout << "-1\n";
    } else {
        cout << max(0ll, d[n - 1] - p);
    }
}

void solve2() {
    vector<ll> s(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll t;
        cin >> t >> t >> s[i];
    }

    ll ans = 0;
    ll ma = 0;
    for (ll i = 0; i < n - 1; ++i) {
        ma = max(ma, w[i]);
        ll z = (max(0ll, s[i] - p) + ma - 1) / ma;
        ans += z;
        p = p + z * 1ll * ma - s[i];
    }
    cout << ans << "\n";
}

pair<ll, ll> best(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first == b.first) {
        if (a.second > b.first) {
            return a;
        }
        return b;
    }
    if (a.first < b.first) {
        return a;
    }
    return b;
}

void solve345() {
    vector<vector<ll>> mat(n, vector<ll>(n, INF_L));
    for (ll i = 0; i < m; ++i) {
        ll vi, ui, wi;
        cin >> vi >> ui >> wi;
        mat[vi - 1][ui - 1] = min(mat[vi - 1][ui - 1], wi);
    }

    vector<ll> fg(w.begin(), w.end());
    sort(fg.begin(), fg.end());
    fg.resize(unique(fg.begin(), fg.end()) - fg.begin());
    for (ll i = 0; i < n; ++i) {
        w[i] = (ll) (lower_bound(fg.begin(), fg.end(), w[i]) - fg.begin());
    }
    int km = (int) fg.size();

    ll ans = INF_L;

    vector<vector<pair<ll, ll>>> dp0(n, vector<pair<ll, ll>>(km, {INF_L, 0})),
        dp1(n, vector<pair<ll, ll>>(km, {INF_L, 0}));
    dp0[0][w[0]] = {0, p};
    for (ll z = 0; z < 2 * n; ++z) {
        for (ll i = 0; i < n - 1; ++i) {
            for (ll j = 0; j < n; ++j) {
                if (i == j || mat[i][j] == INF_L) continue;

                for (ll kz = 0; kz < km; ++kz) {
                    if (dp0[i][kz].first == INF_L) continue;

                    ll k = fg[kz];
                    auto v = dp0[i][kz];
                    ll k2 = max(kz, w[j]);

                    ll cost = (max(0ll, mat[i][j] - v.second) + k - 1) / k;
                    ll r = v.second + cost * 1ll * k - mat[i][j];

                    dp1[j][k2] = best(dp1[j][k2], {v.first + cost, r});

                    if (j == n - 1) {
                        ans = min(ans, dp1[j][k2].first);
                    }
                }
            }
        }
        dp0.swap(dp1);
    }

    if (ans >= INF_L) {
        cout << "-1\n";
    } else {
        cout << ans << "\n";
    }
}

void solve() {
    cin >> n >> m >> p >> gr;

    w.resize(n);
    g.resize(n);

    for (ll i = 0; i < n; ++i) {
        cin >> w[i];
    }

    if (gr == 1) {
        for (ll i = 0; i < m; ++i) {
            ll vi, ui, wi;
            cin >> vi >> ui >> wi;
            g[vi - 1].push_back({ui - 1, wi});
        }
    }

    if (gr == 1) {
        solve1();
    } else if (gr == 2) {
        solve2();
    } else if (gr == 0 || gr >= 3) {
        solve345();
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    for (ll i = 0; i < t; ++i) {
        solve();
    }
}