#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("Ofast") // O3 maybe
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int n, m, p, g;
vector<int> w;

const int N = 1e3 + 10;

vector<pair<int, int>> G[N];


void read () {
    cin >> n >> m >> p >> g;
    w.resize(n);
    cin >> w;
    for (int i = 0; i < m; i++) {
        int u, v, weight;
        cin >> u >> v >> weight;
        u--;v--;
        G[u].emplace_back(v, weight);
    }
}

const int infll = 1e18;

void solve_zero() {
    vector<int> dist(n, infll);
    set<pair<int, int>> st;
    st.insert({0, 0});
    dist[0] = 0;
    while (!st.empty()) {
        auto it = *st.begin();
        st.erase(st.begin());
        int u = it.second;
        for (auto v : G[u]) {
            if (dist[v.first] > dist[u] + v.second) {
                st.erase({dist[v.first], v.first});
                dist[v.first] = dist[u] + v.second;
                st.insert({dist[v.first], v.first});
            }
        }
    }
    if (dist[n - 1] == infll) {
        cout << "-1\n";
        return;
    }
    cout << max(0ll, dist[n - 1] - p) << '\n';
}

void solve_greedy() {
    int mx = 0;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int need = G[i][0].second;
        if (p < need) {
            int can = (need - p + mx - 1) / mx;
            p += can * mx;
            ans += can;
        }
        p -= need;
        mx = max(mx, w[i]);
    }
    cout << ans << '\n';
}

void solve() {
    read();
    if (g == 1) {
        solve_zero();
        return;
    }
    if (g == 2) {
        solve_greedy();
        return;
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}
/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */