#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const db eps = 1e-9;

struct Edge {
    int from, to, w;
};

void solve1(int p, vector<int> w, vector<Edge> e) {
    int n = (int)w.size();
    int m = (int)e.size();
    vector<vector<Edge>> g(n);
    for (auto [from, to, s] : e) {
        g[from].push_back({from, to, s});
    }
    vector<int> d(n, INT64_MAX), used(n);
    d[0] = 0;
    for (int i = 0; i < n; ++i) {
        int v = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (v == -1 || d[j] < d[v])) v = j;
        }
        if (d[v] == INT64_MAX) break;
        used[v] = 1;
        for (auto [from, to, s] : g[v]) {
            if (d[to] > d[v] + s) {
                d[to] = d[v] + s;
            }
        }
    }
    if (!used[n - 1]) {
        cout << "-1\n";
        return;
    }
    cout << d[n - 1] - p << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, p, g; cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector<Edge> e(m);
    for (int i = 0; i < m; ++i) {
        int u, v, s; cin >> u >> v >> s;
        u--; v--;
        e[i] = {u, v, s};
    }
    if (g == 1) {
        solve1(p, w, e);
    }
    return 0;
}