#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const db eps = 1e-9;

struct Edge {
    int from, to, w;
};

int solve1(int p, vector<int> w, vector<Edge> e) {
    int n = (int)w.size();
    int m = (int)e.size();
    vector<vector<Edge>> g(n);
    for (auto [from, to, s] : e) {
        g[from].push_back({from, to, s});
    }
    vector<int> d(n, INT64_MAX), used(n);
    d[0] = 0;
    for (int i = 0; i < n; ++i) {
        int v = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (v == -1 || d[j] < d[v])) v = j;
        }
        if (d[v] == INT64_MAX) break;
        used[v] = 1;
        for (auto [from, to, s] : g[v]) {
            if (d[to] > d[v] + s) {
                d[to] = d[v] + s;
            }
        }
    }
    if (!used[n - 1]) {
        return -1;
    }
    return max(0ll, d[n - 1] - p);
}

int solve2(int p, vector<int> w, vector<Edge> e) {
    int n = (int)w.size();
    vector<tuple<int, int, int>> dp(n);
    dp[0] = {0, p, w[0]};
    for (int i = 1; i < n; ++i) {
        auto [prevD, prevM, prevE] = dp[i - 1];
        int earn = max(prevE, w[i]);
        int days = prevD + (max(0ll, (e[i - 1].w - prevM)) + prevE - 1) / prevE;
        int money = prevM + prevE * (days - prevD) - e[i - 1].w;
        dp[i] = {days, money, earn};
    }
    return get<0>(dp[n - 1]);
}

int solve3(int p, vector<int> w, vector<Edge> e) {
    int n = w.size();
    vector<vector<int>> g(n, vector<int>(n, -1));
    for (auto [from, to, s] : e) {
        if (g[from][to] == -1 || g[from][to] > s) {
            g[from][to] = s;
        }
    }
    vector<int> perm(n);
    for (int i = 0; i < n; ++i) perm[i] = i;
    int ans = INT64_MAX;
    do {
        if (perm[0] != 0) break;
        bool ok = true;
        vector<Edge> newE;
        int cnt = 1;
        for (int i = 0; i < n - 1; ++i) {
            if (g[perm[i]][perm[i + 1]] == -1) {
                ok = false;
                break;
            }
            cnt++;
            newE.push_back({i, i + 1, g[perm[i]][perm[i + 1]]});
            if (perm[i + 1] == n - 1) break;
        }
        if (!ok) continue;
        vector<int> newW(cnt);
        for (int i = 0; i < cnt; ++i) {
            newW[i] = w[perm[i]];
        }
        ans = min(ans, solve2(p, newW, newE));
    } while (next_permutation(all(perm)));
    if (ans == INT64_MAX) return -1;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, p, g; cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector<Edge> e(m);
    for (int i = 0; i < m; ++i) {
        int u, v, s; cin >> u >> v >> s;
        u--; v--;
        e[i] = {u, v, s};
    }
    int ans = 0;
    if (g == 1) {
        ans = solve1(p, w, e);
    } else if (g == 2) {
        ans = solve2(p, w, e);
    } else if (g == 3 || g == 0) {
        ans = solve3(p, w, e);
    }
    cout << ans;
    return 0;
}