#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const int INF = 1e16;
const db eps = 1e-9;

struct Edge {
    int from, to, w;
};

int solve1(int p, vector<int> w, vector<Edge> e) {
    int n = (int)w.size();
    int m = (int)e.size();
    vector<vector<Edge>> g(n);
    for (auto [from, to, s] : e) {
        g[from].push_back({from, to, s});
    }
    vector<int> d(n, INT64_MAX), used(n);
    d[0] = 0;
    for (int i = 0; i < n; ++i) {
        int v = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (v == -1 || d[j] < d[v])) v = j;
        }
        if (d[v] == INT64_MAX) break;
        used[v] = 1;
        for (auto [from, to, s] : g[v]) {
            if (d[to] > d[v] + s) {
                d[to] = d[v] + s;
            }
        }
    }
    if (!used[n - 1]) {
        return -1;
    }
    return max(0ll, d[n - 1] - p);
}

int solve2(int p, vector<int> w, vector<Edge> e) {
    int n = (int)w.size();
    vector<tuple<int, int, int>> dp(n);
    dp[0] = {0, p, w[0]};
    for (int i = 1; i < n; ++i) {
        auto [prevD, prevM, prevE] = dp[i - 1];
        int earn = max(prevE, w[i]);
        int days = prevD + (max(0ll, (e[i - 1].w - prevM)) + prevE - 1) / prevE;
        int money = prevM + prevE * (days - prevD) - e[i - 1].w;
        dp[i] = {days, money, earn};
    }
    return get<0>(dp[n - 1]);
}

struct Sost {
    int day, money;

    bool operator<(const Sost& other) const {
        if (day == other.day) return money > other.money;
        return day < other.day;
    }
};

int solve3(int p, vector<int> w, vector<Edge> e) {
    int n = w.size();
    vector<vector<int>> matr(n, vector<int>(n, -1));
    for (auto [from, to, s] : e) {
        if (matr[from][to] == -1 || matr[from][to] > s) {
            matr[from][to] = s;
        }
    }
    vector<vector<Edge>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if (matr[i][j] != -1) {
                g[i].push_back({i, j, matr[i][j]});
            }
        }
    }
    vector<int> mx(1 << n, 0);
    for (int mask = 0; mask < (1 << n); ++mask) {
        int mxNow = 0;
        for (int j = 0; j < n; ++j) {
            if (mask & (1 << j)) {
                mxNow = max(mxNow, w[j]);
            }
        }
        mx[mask] = mxNow;
    }
    vector<vector<Sost>> dp((1 << n), vector<Sost>(n, {INF, 0}));
    dp[1][0] = {0, p};
    for (int mask = 1; mask < (1 << n); ++mask) {
        for (int last = 0; last < n; ++last) {
            if (!(mask & (1 << last))) continue;
            for (auto [from, to, s] : g[last]) {
                auto [prevD, prevM] = dp[mask][last];
                int prevE = mx[mask];
                int days = prevD + (max(0ll, (s - prevM)) + prevE - 1) / prevE;
                int money = prevM + prevE * (days - prevD) - s;
                Sost relax = {days, money};
                if (relax < dp[mask | (1 << to)][to]) {
                    dp[mask | (1 << to)][to] = relax;
                }
            }
        }
        for (int last = 0; last < n; ++last) {
            if (!(mask & (1 << last))) continue;
            for (auto [from, to, s] : g[last]) {
                auto [prevD, prevM] = dp[mask][last];
                int prevE = mx[mask];
                int days = prevD + (max(0ll, (s - prevM)) + prevE - 1) / prevE;
                int money = prevM + prevE * (days - prevD) - s;
                Sost relax = {days, money};
                if (relax < dp[mask | (1 << to)][to]) {
                    dp[mask | (1 << to)][to] = relax;
                }
            }
        }
    }
    int ans = INF;
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (dp[mask][n - 1].day < ans) {
            ans = dp[mask][n - 1].day;
        }
    }
    if (ans >= INF) return -1;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, p, g; cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector<Edge> e(m);
    for (int i = 0; i < m; ++i) {
        int u, v, s; cin >> u >> v >> s;
        u--; v--;
        e[i] = {u, v, s};
    }
    int ans = 0;
    if (g == 1) {
        ans = solve1(p, w, e);
    } else if (g == 2) {
        ans = solve2(p, w, e);
    } else if (g == 3 || g == 0) {
        ans = solve3(p, w, e);
    }
    cout << ans;
    return 0;
}