#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e17 + 2;

vector<vector<pair<int, int>>> g;
vector<int> w;

int dijkstra(int n) {
    vector<int> used(n), dist(n, INF);
    dist[0] = 0;
    set<pair<int, int>> q = {{0, 0}};
    while (!q.empty()) {
        auto[d, u] = *q.begin();
        q.erase(q.begin());
        used[u] = 1;
        for (auto[v, c] : g[u]) {
            if (used[v]) continue;
            q.erase({dist[v], v});
            dist[v] = min(dist[v], d + c);
            q.insert({dist[v], v});
        }
    }
    return dist[n - 1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    w.resize(n), g.resize(n);
    vector<int> nxt(m);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        nxt[i] = c;
        g[a].emplace_back(b, c);
    }
    int ans = dijkstra(n);
    if (ans == INF) {
        cout << -1 << endl;
        return 0;
    }
    if (G == 1) {
       // cout << ans << endl;
        cout << max(0ll, ans - p) << endl;
        return 0;
    }
    if (G == 2) {
        vector<int> best_right(n), st;
        for (int i = n - 1; i >= 0; --i) {
            while (!st.empty() && w[st.back()] <= w[i]) st.pop_back();
            if (st.empty()) best_right[i] = n - 1;
            else best_right[i] = st.back();
            st.push_back(i);
        }
        vector<int> prevs(n + 1);
        for (int i = 1; i < n; ++i) prevs[i] = prevs[i - 1] + nxt[i - 1];
        ans = 0;
        for (int i = 0; i < n; ++i) {
          //  cout << i << " "<< prevs[best_right[i]] << " " << p << endl;
            int c = (prevs[best_right[i]] - prevs[i] - p + w[i] - 1) / w[i];
            p = max(p, p + c * w[i]);
            ans += max(0ll, c);
            p -= nxt[i];
        }
        cout << ans << endl;
        return 0;
    }


}