#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e17 + 2;

vector<vector<pair<int, int>>> g;
vector<int> w;

int dijkstra(int n) {
    vector<int> used(n), dist(n, INF);
    dist[0] = 0;
    set<pair<int, int>> q = {{0, 0}};
    while (!q.empty()) {
        auto[d, u] = *q.begin();
        q.erase(q.begin());
        used[u] = 1;
        for (auto[v, c] : g[u]) {
            if (used[v]) continue;
            q.erase({dist[v], v});
            dist[v] = min(dist[v], d + c);
            q.insert({dist[v], v});
        }
    }
    return dist[n - 1];
}

vector<int> dijkstra_start(int start, int n) {
    vector<int> used(n), dist(n, INF);
    dist[start] = 0;
    set<pair<int, int>> q = {{0, start}};
    while (!q.empty()) {
        auto[d, u] = *q.begin();
        q.erase(q.begin());
        used[u] = 1;
        for (auto[v, c] : g[u]) {
            if (used[v]) continue;
            q.erase({dist[v], v});
            dist[v] = min(dist[v], d + c);
            q.insert({dist[v], v});
        }
    }
    return dist;
}

vector<int> now = {0}, US;
vector<vector<int>> Dists;
int n, ANS = INF, P0;

void gen(int z) {
    if (now.size() == z) {
        now.push_back(n - 1);
        vector<int> inds;
        for (int i : now) {
            if (Dists[0][i] != INF) inds.push_back(i);
        }
        vector<int> best_right(n), st;
        for (int i = 0; i < inds.size(); ++i) {
            best_right[inds[i]] = n - 1;
            for (int j = i + 1; j < inds.size(); ++j) {
                if (w[inds[j]] > w[best_right[i]]) best_right[inds[i]] = inds[j];
            }
        }
        int ans = 0, p = P0;
        int i = 0;
        while (i != n - 1) {
            int c = (Dists[i][best_right[i]] - p + w[i] - 1) / w[i];
            p = max(p, p + c * w[i]);
            ans += max(0ll, c);
            p -= Dists[i][best_right[i]];
            i = best_right[i];
        }
        ANS = min(ANS, ans);
        now.pop_back();
        return;
    }
    for (int i = 1; i + 1 < n; ++i) {
        if (US[i]) continue;
        US[i] = 1;
        now.push_back(i);
        gen(z);
        US[i] = 0;
        now.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int m, p, G;
    cin >> n >> m >> p >> G;
    P0 = p;
    w.resize(n), g.resize(n);
    vector<int> nxt(m);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        nxt[i] = c;
        g[a].emplace_back(b, c);
    }
    int ans = dijkstra(n);
    if (ans == INF) {
        cout << -1 << endl;
        return 0;
    }
    if (G == 1) {
       // cout << ans << endl;
        cout << max(0ll, ans - p) << endl;
        return 0;
    }
    if (G == 2) {
        vector<int> best_right(n), st;
        for (int i = n - 1; i >= 0; --i) {
            while (!st.empty() && w[st.back()] <= w[i]) st.pop_back();
            if (st.empty()) best_right[i] = n - 1;
            else best_right[i] = st.back();
            st.push_back(i);
        }
        vector<int> prevs(n + 1);
        for (int i = 1; i < n; ++i) prevs[i] = prevs[i - 1] + nxt[i - 1];
        ans = 0;
        for (int i = 0; i < n; ++i) {
          //  cout << i << " "<< prevs[best_right[i]] << " " << p << endl;
            int c = (prevs[best_right[i]] - prevs[i] - p + w[i] - 1) / w[i];
            p = max(p, p + c * w[i]);
            ans += max(0ll, c);
            p -= nxt[i];
        }
        cout << ans << endl;
        return 0;
    }
    if (G == 3 || G == 0) {
        Dists.resize(n);
        US.resize(n);
        for (int i = 0; i < n; ++i) Dists[i] = dijkstra_start(i, n);
        for (int i = 1; i < n; ++i) gen(i);
        cout << ANS << endl;
    }

}