#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

#define int long long

const ll INF = 1e18;

vector<vector<pair<int, int>>> gr, gr_t;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    gr.resize(n);
    gr_t.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        gr[u].emplace_back(v, c);
        gr_t[v].emplace_back(u, c);
    }

    if (g == 1) {
        vector<ll> dist(n, INF);
        dist[0] = 0;
        set<pair<ll, int>> s;
        for (int i = 0; i < n; ++i) {
            s.emplace(dist[i], i);
        }
        while (!s.empty()) {
            auto [d, i] = *s.begin();
            s.erase(s.begin());
            for (auto [to, c] : gr[i]) {
                if (dist[to] > dist[i] + c) {
                    s.erase({dist[to], to});
                    dist[to] = dist[i] + c;
                    s.insert({dist[to], to});
                }
            }
        }
        if (dist[n - 1] == INF) {
            cout << -1 << '\n';
        } else {
            cout << max(dist[n - 1] - p, 0ll) << '\n';
        }
    } else if (g == 2) {
        ll res = 0;
        ll cur = p;
        ll max_w = 0;
        for (int i = 0; i < n - 1; ++i) {
            max_w = max(max_w, (ll)w[i]);
            if (cur < gr[i][0].second) {
                res += (gr[i][0].second - cur + max_w - 1) / max_w;
                cur += (gr[i][0].second - cur + max_w - 1) / max_w * max_w;
            }
            cur -= gr[i][0].second;
        }
        cout << res << '\n';
    } else {
        vector<vector<ll>> dist(n, vector<ll> (n, INF));
        for (int i = 0; i < n; ++i) {
            dist[i][i] = 0;
        }
        for (int i = 0; i < n; ++i) {
            for (auto [to, c] : gr[i]) {
                dist[i][to] = min(dist[i][to], c);
            }
        }
        for (int k = 0; k < n; ++k) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }
        if (dist[0][n - 1] == INF) {
            cout << -1 << '\n';
            return;
        }
        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        ll ans = INF;
        do {
            ll res = 0;
            ll cur = p;
            ll max_w = 0;
            for (int idx = 0; idx < n; ++idx) {
                int i = order[idx];
                max_w = max(max_w, w[i]);
                if (dist[i][n - 1] != INF) {
                    if (dist[i][n - 1] <= cur) {
                        ans = min(ans, res);
                    } else {
                        ans = min(ans, res + (dist[i][n - 1] - cur + max_w - 1) / max_w);
                    }
                }
                int j = order[idx + 1];
                ll cost = dist[i][j];
                if (cost == INF) {
                    break;
                }
                if (cur < cost) {
                    res += (cost - cur + max_w - 1) / max_w;
                    cur += (cost - cur + max_w - 1) / max_w * max_w;
                }
                cur -= cost;
            }
        } while (next_permutation(order.begin() + 1, order.end()));
        cout << ans << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}