#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

#define ll long long

int n, m, p, g;

vector<int> w;

vector<vector<pair<int, int>>> r;


void djktra(int s, vector<ll> &dist) {
	dist.resize(n, 1e18);
	dist[s] = 0;

	priority_queue <pair<ll, int>> q;
	q.push({ 0, s });

	while (!q.empty()) {
		int v = q.top().second;
		ll w = -q.top().first;
		q.pop();
		if (dist[v] != w) continue;

		for (auto p : r[v]) {
			if (dist[p.second] > w + p.first) {
				dist[p.second] = w + p.first;
				q.push({ -dist[p.second], p.second });
			}
		}
	}
}

int main() {
	
	cin >> n >> m >> p >> g;
	r.resize(n);
	w.resize(n);
	for (int i = 0; i < n; i++) cin >> w[i];
	int a, b, c;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> c;
		a--;
		b--;
		r[a].push_back({ c, b });
	}

	vector<ll> d;
	djktra(0, d);
	if (d[n - 1] == 1e18) cout << -1;
	else {
		if (d[n - 1] <= p) cout << 0;
		else cout << d[n - 1] - p;
	}

	return 0;
}