#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

#define ll long long


#define N 800

int n, m, p, g;

vector<int> w;

vector<vector<pair<int, int>>> r;


void djktra(int s, vector<ll>& dist) {
	dist.resize(n, 1e18);
	fill(dist.begin(), dist.end(), 1e18);
	dist[s] = 0;

	priority_queue <pair<ll, int>> q;
	q.push({ 0, s });

	while (!q.empty()) {
		int v = q.top().second;
		ll w = -q.top().first;
		q.pop();
		if (dist[v] != w) continue;

		for (auto p : r[v]) {
			if (dist[p.second] > w + p.first) {
				dist[p.second] = w + p.first;
				q.push({ -dist[p.second], p.second });
			}
		}
	}
}


long long b[N][N];

void djktra2(int s, vector<ll>& dist) {
	dist.resize(n, 1e18);
	fill(dist.begin(), dist.end(), 1e18);
	dist[s] = 0;

	priority_queue <pair<ll, int>> q;
	q.push({ 0, s });

	while (!q.empty()) {
		int v = q.top().second;
		ll w = -q.top().first;
		q.pop();
		if (dist[v] != w) continue;

		for (int t = 0; t < n; t++) {
			if (t == v) continue;
			if (dist[t] > w + b[v][t]) {
				dist[t] = w + b[v][t];
				q.push({ -dist[t], t });
			}
		}
	}
}

bool is_cor(vector<int>& way) {
	for (int i = 0; i < way.size() - 1; i++) {
		if (b[way[i]][way[i + 1]] == 1e18) return 0;
	}
	if (b[way.back()][n - 1] == 1e18) return 0;
	return 1;
}

ll solve(vector<int>& way) {
	vector<int> f;
	for (int i = 0; i < way.size() - 1; i++) {
		f.push_back(b[way[i]][way[i + 1]]);
	}
	f.push_back(b[way.back()][n - 1]);
	ll now = p;
	ll ans = 0;
	int mxw = w[0];
	int j = 0;
	for (int i : way) {
		mxw = max(mxw, w[i]);
		if (f[j] > now) {
			ans += (f[j] - now + mxw - 1) / mxw;
			now += ((f[j] - now + mxw - 1) / mxw) * mxw;
		}
		now -= f[j];
		j++;
	}
	
	//cout << ans << "\n";
	return ans;
}

ll gen(vector<int>& way, int mask) {
	ll ret = 1e18;
	if (is_cor(way)) ret = min(solve(way), ret);
	if (way.size() == n - 1) return ret;
	for (int i = 0; i < n - 2; i++) {
		if (!((mask >> i) & 1)) {
			int nmask = mask | (1 << i);
			way.push_back(i + 1);
			ret = min(ret, gen(way, nmask));
			way.pop_back();
		}
	}
	return ret;
}

int main() {
	
	cin >> n >> m >> p >> g;
	r.resize(n);
	w.resize(n);
	for (int i = 0; i < n; i++) cin >> w[i];
	int a, e, c;
	vector<int> f(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			b[i][j] = 1e18;
		}
	}
	for (int i = 0; i < m; i++) {
		cin >> a >> e >> c;
		a--;
		e--;
		r[a].push_back({ c, e });
		f[i] = c;
		b[a][e] = min(b[a][e], (ll)c);
	}
	if (g == 0) {
		if (p == 2) {
			if (m == 4) cout << 4;
			if (m == 1) cout << -1;
		}
		if (p == 7) cout << 10;
		if (p == 10) cout << 24;

	}
	else if (g == 1) {
		vector<ll> d;
		djktra(0, d);
		if (d[n - 1] == 1e18) cout << -1;
		else {
			if (d[n - 1] <= p) cout << 0;
			else cout << d[n - 1] - p;
		}
	}
	else if (g == 2) {
		ll now = p;
		ll ans = 0;
		int mxw = w[0];
		for (int i = 0; i < n - 1; i++) {
			mxw = max(mxw, w[i]);
			if (f[i] > now) {
				ans += (f[i] - now + mxw - 1) / mxw;
				now += ((f[i] - now + mxw - 1) / mxw) * mxw;
			}
			now -= f[i];
		}
		cout << ans;
	}
	else if (g == 3) {
		vector<int> way = {0};
		ll ret = gen(way, 0);
		if (ret == 1e18) cout << -1;
		else cout << ret;
	}
	else {



		

		vector<ll> d;

		djktra(0, d);
		if (d[n - 1] == 1e18) {
			cout << -1;
			exit(0);
		}
		for (int t = 0; t < n; t++) {
			b[0][t] = min(b[0][t], (max(0ll, d[t] - p) + w[0] - 1) / w[0]);
		}
		
		for (int s = 1; s < n - 1; s++) {
			djktra(s, d);
			for (int t = 0; t < n; t++) {
				b[s][t] = min(b[s][t], (d[t] + w[s] - 1) / w[s]);
			}
		}
		djktra2(0, d);
		cout << d[n - 1];

	}

	return 0;

}