#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

constexpr long long INF = 100000000000000000ll;

vector<vector<pair<int, int>>> gr;
vector<int> w;

namespace Solveg1 {
    void solve(int n, int m, int p) {
        vector<long long> dists(n, INF);
        dists[0] = 0;
        set<pair<long long, int>> q;
        q.insert({0, 0});
        while (!q.empty()) {
            auto [cc, cv] = *q.begin();
            q.erase(q.begin());
            for (auto [to, c] : gr[cv]) {
                if (dists[to] > cc + c) {
                    q.erase({dists[to], to});
                    dists[to] = cc + c;
                    q.insert({dists[to], to});
                }
            }
        }

        long long cdst = dists[n - 1];
        if (cdst == INF) {
            cout << "-1\n";
        } else {
            long long ck = max(0ll, cdst - p);
            cout << ck << "\n";
        }
    }
} // namespace Solveg1

int main() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
    }
    if (g == 1) {
        Solveg1::solve(n, m, p);
    }
    return 0;
}
