#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll

const int maxn = 1000;
const int inf = 1e14;
int n, m, p, gr;
int g[maxn][maxn];
vector<pair<int, int>> t[maxn];
int w[maxn];
int used[maxn];

void dfs(int v) {
	used[v] = 1;
	for (auto& [u, s] : t[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
}

pair<int, int> opt(pair<int, int> a, pair<int, int> b) {
	if (a.first != b.first) return min(a, b);
	return max(a, b);
}

void solve() {
	cin >> n >> m >> p >> gr;
	vector < pair<int, int>> kek(n);
	for (int i = 0; i < n; i++) {
		cin >> w[i];
		kek[i] = { w[i], i };
	}
	sort(kek.begin(), kek.end());
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			g[i][j] = inf;
		}
	}
	for (int i = 0; i < m; i++) {
		int v, u, s;
		cin >> v >> u >> s;
		g[v - 1][u - 1] = min(s, g[v - 1][u - 1]);
		t[v - 1].push_back({ u - 1, s });
	}
	for (int k = 0; k < n; k++) {
		for (int v = 0; v < n; v++) {
			for (int u = 0; u < n; u++) {
				if (g[v][k] != inf && g[k][u] != inf) {
					g[v][u] = min(g[v][u], g[v][k] + g[k][u]);
				}
			}
		}
	}
	dfs(0);
	if (!used[n - 1]) {
		cout << "-1\n";
		return;
	}

	vector<pair<int, int>> dp(n, { inf, -inf });
	dp[0] = { 0, p };
	for (int _ = 0; _ < n; _++) {
		int i = kek[_].second;
		for (int lol = _ - 1; lol >= 0; lol--) {
			int j = kek[lol].second;
			int sm = g[j][i];
			if (w[j] >= w[i]) continue;
			int need = max(0ll, sm - dp[j].second);
			int times = (need + w[j] - 1) / w[j];
			dp[i] = opt(dp[i], { dp[j].first + times, dp[j].second + times * w[j] - sm });
		}
	}

	int ans = dp[n - 1].first;
	for (int i = n - 2; i >= 0; i--) {
		int sm = g[i][n - 1];
		int need = max(0ll, sm - dp[i].second);
		int times = (need + w[i] - 1) / w[i];
		ans = min(ans, dp[i].first + times);
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}