#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;
const int inf = 1000000000000000000;

ll binpow(ll n, ll k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

struct seg_tree{
    vector <int> t;
    vector <int> p;

    void push(int v){
        if(p[v] != 0){
            t[v * 2] += p[v];
            t[v * 2 + 1] += p[v];
            p[v * 2] += p[v];
            p[v * 2 + 1] += p[v];
            p[v] = 0;
        }
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return 0;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

void solve1(int n, int m, int p){
    vector < vector < pair <int, int> > > a(n);
    vector <int> w(n);
    for(int i = 0; i < n; ++i){
        cin >> w[i];
    }
    for(int i = 0; i < m; ++i){
        int x, y, z;
        cin >> x >> y >> z;
        --x; --y;

        a[x].push_back({y, z});
    }

    vector <int> dist(n);
    auto deixtra = [&](int v){
        dist.assign(n, inf);
        vector <int> used(n);
        priority_queue < pair <int, int> > q;

        dist[v] = 0;
        used[v] = 1;
        q.push({0, v});
        while(!q.empty()){
            while(!q.empty() && used[v]){
                v = q.top().second;
                q.pop();
            }

            used[v] = 1;

            for(auto to : a[v]){
                if(dist[to.first] > dist[v] + to.second){
                    dist[to.first] = dist[v] + to.second;
                    q.push({-dist[to.first], to.first});
                }
            }
        }
    };

    deixtra(0);

    if(dist[n - 1] == inf){
        cout << -1;
    }else{
        cout << max(0ll, dist[n - 1] - p);
    }
}

void solve2(int n, int m, int p){
    vector < vector < pair <int, int> > > a(n);
    vector <int> w(n);
    for(int i = 0; i < n; ++i){
        cin >> w[i];
    }
    for(int i = 0; i < m; ++i){
        int x, y, z;
        cin >> x >> y >> z;
        --x; --y;

        a[x].push_back({y, z});
    }

    vector < pair <int, int> > dp(n);
    dp[0] = {0, p};
    int mx = w[0], j = 0, cost = a[0][0].second;
    for(int i = 1; i < n; ++i){
        int x = (max(0ll, cost - dp[j].second) + w[j] - 1) / w[j];
        dp[i] = {dp[j].first + x, dp[j].second - cost + x * w[j]};
        if(mx <= w[i]){
            mx = w[i];
            j = i;
            cost = 0;
        }
        if(i != n - 1) {
            cost += a[i][0].second;
        }
    }

    cout << dp[n - 1].first;
}

void solve(){
    int n, m, p, g;
    cin >> n >> m >> p >> g;

    /*if(g == 1){
        solve1(n, m, p);
        return;
    }
    if(g == 2){
        solve2(n, m, p);
        return;
    }*/


    vector < vector < pair <int, int> > > a(n);
    vector <int> w(n);
    for(int i = 0; i < n; ++i){
        cin >> w[i];
    }
    for(int i = 0; i < m; ++i){
        int x, y, z;
        cin >> x >> y >> z;
        --x; --y;

        a[x].push_back({y, z});
    }


    vector <int> dist(n);
    auto deixtra = [&](int v){
        dist.assign(n, inf);
        vector <int> used(n);
        priority_queue < pair <int, int> > q;

        dist[v] = 0;
        used[v] = 1;
        q.push({0, v});
        while(!q.empty()){
            while(!q.empty() && used[v]){
                v = q.top().second;
                q.pop();
            }

            used[v] = 1;

            for(auto to : a[v]){
                if(dist[to.first] > dist[v] + to.second){
                    dist[to.first] = dist[v] + to.second;
                    q.push({-dist[to.first], to.first});
                }
            }
        }
    };

    vector < vector <int> > d(n, vector <int> (n));
    for(int i = 0; i < n; ++i){
        deixtra(i);

        d[i] = dist;
    }

    if(d[0][n - 1] == inf){
        cout << -1;
        return;
    }

    vector < pair <int, int> > dp(n, {inf, 0});
    dp[0] = {0, p};

    for(int _ = 0; _ < n; ++_){
        for(int i = 0; i < n; ++i){
            if(d[0][i] == inf){
                continue;
            }
            for(int j = 0; j < n; ++j){
                if(i == j){
                    continue;
                }

                int cost = d[j][i];
                if(cost == inf){
                    continue;
                }

                int x = (max(0ll, cost - dp[j].second) + w[j] - 1) / w[j];
                dp[i] = min(dp[i], {dp[j].first + x, dp[j].second - cost + x * w[j]});
            }
        }
    }

    cout << dp[n - 1].first;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}