#include<bits/stdc++.h>

using namespace std;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

struct Point
{
    long long ch,br;
    Point(){};
    Point(long long chi, long long bri)
    {
        ch = chi;
        br = bri;
    }
};

const int maxn = 805;
int n,m,p,g;
int w[maxn];
int c[maxn];
int used[maxn];
long long sumc[maxn];
long long dp[maxn][maxn],sum[maxn][maxn];
unsigned long long d[maxn],inf = -1;
vector<edge>v[maxn];

void read()
{
    cin >> n >> m >> p >> g;
    for(int i=1;i<=n;i++) cin >> w[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        if(x+1==y) c[y] = z;
        v[x].push_back({y,z});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    q.push({beg,0});
    edge e,nb;
    int sz;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}

void solve1()
{
    dijkstra(1);
    if(d[n]==inf) cout << -1 << endl;
    else
    {
        if(p>=d[n]) cout << 0 << endl;
        else
        {
            long long res = p;
            res -= d[n];
            cout << (-res) << endl;
        }
    }
}

pair<long long,long long> rec(int l, int r)
{
    pair<long long,long long> res;
    if(l==r)
    {
        res.first = 0;
        res.second = 0;
        return res;
    }
    int idx = l;
    for(int i=l;i<r;i++)
    {
        if(w[i]>w[idx]) idx = i;
    }
    pair<long long,long long> pom = rec(l,idx);
    l = idx;
    long long path = sumc[r] - sumc[l];
    //cout << idx << endl;
    //cout << pom.first << " " << pom.second << endl;
    //cout << "+++++" << endl;
    long long ch1,ch2;
    ch1 = pom.first;
    ch2 = 0;
    if(path<=pom.second)
    {
        pom.second -= path;
        path = 0;
        ch2 = pom.second;
    }
    else path -= pom.second;
    ch1 += (path/w[l]);
    if(path%w[l]) ch1++;
    ch2 += (path%w[l]);
    res.first = ch1;
    res.second = ch2;
    //cout << l << " " << r << " " << ch1 << " " << ch2 <<endl;
    return res;
}

void solve2()
{
    for(int i=2;i<=n;i++)
    {
        if(p==0) break;
        if(p>=c[i])
        {
            p -= c[i];
            c[i] = 0;
        }
        else
        {
            c[i] -= p;
            p = 0;
        }
    }
    for(int i=1;i<=n;i++)
    {
        sumc[i] = sumc[i-1] + c[i];
        //cout << c[i] << " ";
    }
    //cout << "yeye" << endl;
    //memset(dp,-1,sizeof(dp));
    cout << rec(1,n).first << endl;
}

void dfs(int beg)
{
//    if(beg==n) check();
    used[beg] = 1;
    int sz = v[beg].size();
    edge nb;
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(!used[nb.ver])
        {

            dfs(nb.ver);
        }
    }
    used[beg] = 0;
}

void solve3()
{
    dfs(1);

}

void solve()
{
    if(g==1) solve1();
    if(g==2) solve2();
    if(g==3) solve3();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

/*
10 9 3 2
5 5 4 7 9 2 1 9 9 9
1 2 5
2 3 5
3 4 5
4 5 5
5 6 5
6 7 5
7 8 5
8 9 5
9 10 5
*/
