#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

const int maxn = 800;

int w[maxn + 1];

vector<pair<int, int>> g[maxn + 1];

struct State {
    int u;
    int mx = 1;
    int steps;
    int money;

    bool operator<(State other) const {
        if (steps != other.steps)
            return steps < other.steps;
        if (money != other.money)
            return money < other.money;
        if (mx != other.mx)
            return mx < other.mx;
        return u < other.u;
    }
};

int test_g;

bool is_better(State a, State b) {
    if (b.steps < a.steps)
        return false;
    if ((test_g == 3 or test_g == 5) and b.mx > a.mx)
        return false;
    if (b.steps == a.steps)
        return a.money >= b.money;
    int add = b.steps - a.steps;
    return a.money + add * a.mx >= b.money;
}

void check_path(int n) {
    deque<int> d;
    d.push_back(1);
    vector<bool> used(n + 1);
    used[1] = true;
    while (d.size()) {
        int u = d[0];
        d.pop_front();

        for (auto [to, c] : g[u]) {
            if (!used[to]) {
                used[to] = true;
                d.push_back(to);
            }
        }
    }
    if (!used[n]) {
        cout << -1 << endl;
        exit(0);
    }
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p >> test_g;
    for (int i = 1; i <= n; ++i)
        cin >> w[i];

    for (int i = 1; i <= m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
    }

    check_path(n);

    set<State> s;

    vector<State> bests(n + 1);
    vector<int> ans(n + 1, INF);

    for (int i = 1; i <= n; ++i) {
        bests[i].steps = INF;
        bests[i].money = -INF;
    }

    auto add = [&](int u, int mx, int steps, int money) {
        State new_state = {u, mx, steps, money};
        ans[u] = min(ans[u], steps);

        if (steps <= bests[u].steps and money >= bests[u].money and mx >= bests[u].mx) {
            s.erase(bests[u]);
            bests[u] = new_state;
            s.insert(bests[u]);
            return;
        }

        if (is_better(bests[u], new_state))
            return;

        bests[u] = new_state;
        s.insert({u, mx, steps, money});
    };

    add(1, w[1], 0, p);

    while (s.size() > 0) {
        auto e = *s.begin();
        s.erase(s.begin());
        if (e.u == n) {
            cout << e.steps << endl;
            return;
        }

        for (auto [to, cost] : g[e.u]) {
            if (e.money >= cost) {
                add(to, max(e.mx, w[to]), e.steps, e.money - cost);
            } else {
                int add_steps = (cost - e.money + e.mx - 1) /  e.mx;
                add(to, max(e.mx, w[to]), e.steps + add_steps, e.money + add_steps * e.mx - cost);
            }
        }
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}