#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 1e3 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int n, m, p, G;
int a[MAX];
vector<pair<int, int>> g[MAX];

void solve_1() {
    vector<ll> d(n + 1, inf);
    d[1] = 0;
    set<pair<ll, int>> q;
    for(int i = 1; i <= n; i++) {
        q.insert({d[i], i});
    }
    while(sz(q)) {
        auto [dst, v] = *q.begin(); q.erase(q.begin());
        for(auto [to, w] : g[v]) {
            if(d[to] > dst + w) {
                q.erase({d[to], to});
                d[to] = dst + w;
                q.insert({d[to], to});
            }
        }
    }
    ll ans = max(d[n] - p, 0LL);
    if(d[n] == inf) ans = -1;
    cout << ans << '\n';
}

/*
6 5 0 3
3 2 3 2 5 4
1 2 3
2 3 4
3 4 5
4 5 6
5 6 7
*/

ll get(int k, vector<ll> &pref, vector<ll> &w) {
    vector<int> nxt(k + 1, k);
    stack<int> st;
    for(int i = k; i; i--) {
        while(sz(st) && w[st.top()] <= w[i]) st.pop();
        if(sz(st)) nxt[i] = st.top();
        st.push(i);
    }
    ll ans = 0;
    ll money = p;
    for(int i = 1; i < k;) {
        int go = nxt[i];
        ll need = max(pref[go] - money, 0LL);
        ll add = (need + w[i] - 1) / w[i];
        ans += add;
        money += add * w[i];
        i = go;
    }
    return ans;
}

void solve_2() {
    vector<ll> c(n + 2);
    for(int i = 1; i < n; i++) {
        c[i] = g[i][0].s;
    }
    vector<ll> pref(n + 2);
    for(int i = 1; i < n; i++) {
        pref[i + 1] = pref[i] + c[i];
    }
    vector<ll> w(n + 1);
    for(int i = 1; i <= n; i++) w[i] = a[i];
    cout << get(n, pref, w) << '\n';
}

void solve_3() {
    vector<vector<ll>> adj(n + 1, vector<ll>(n + 1, inf));
    for(int v = 1; v <= n; v++) {
        for(auto [to, w] : g[v]) {
            umin(adj[v][to], (ll) w);
            assert(w);
        }
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= n; j++) {
            if(adj[i][j] == inf) adj[i][j] = 0;
        }
    }
    ll ans = inf;
    vector<int> p(n - 1);
    iota(all(p), 2);
    do {

        vector<int> order = {0, 1};
        for(auto v : p) {
            order.pb(v);
            if(v == n) break;
        }
        int k = sz(order) - 1;
        int ok = 1;
        vector<ll> pref(k + 1);
        for(int i = 1; i < k; i++) {
            ll c = adj[order[i]][order[i + 1]];
            if(!c) {
                ok = 0;
                break;
            }
            pref[i + 1] = pref[i] + c;
        }
        if(!ok) continue;
        vector<ll> w(k + 1);
        for(int i = 1; i <= k; i++) {
            w[i] = a[order[i]];
        }
        ll val = get(k, pref, w);
//        for(int i = 1; i <= k; i++) cout << order[i] << " ";
//        cout << ": " << val << endl;
        umin(ans, val);
    }
    while(next_permutation(all(p)));
    if(ans == inf) ans = -1;
    cout << ans << '\n';
}

void solve_4() {
    ///:((
    const int buben = 1e4 + 5;
    ///d[v][cnt] - go to v with cnt times
    vector<vector<ll>> d(n + 1, vector<ll>(buben, inf));
    d[1][0] = -p;
    set<array<ll, 3>> q;
    for(int i = 1; i <= n; i++) {
        for(int j = 0; j < buben; j++) {
            q.insert({d[i][j], i, j});
        }
    }
    int mn = n + 1;
    while(sz(q)) {
        auto [dst, v, cnt] = *q.begin(); q.erase(q.begin());
        if(dst == inf) break;
        if(v == n && cnt >= mn) continue;
        if(v == n) umin(mn, (int) cnt);
        if(cnt + 1 < buben) {
            ll ndst = dst + a[v];
            if(ndst > 0 || d[v][cnt + 1] > ndst) {
                q.erase({d[v][cnt + 1], v, cnt + 1});
                d[v][cnt + 1] = ndst;
                q.insert({d[v][cnt + 1], v, cnt + 1});
            }
        }
        for(auto [to, w] : g[v]) {
            ll ndst = dst + w;
            if(d[to][cnt] > ndst) {
                q.erase({d[to][cnt], to, cnt});
                d[to][cnt] = ndst;
                q.insert({d[to][cnt], to, cnt});
            }
        }
    }
    cout << mn << '\n';
}

void solve() {
    cin >> n >> m >> p >> G;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }
//    if(G == 1) solve_1(); ///OK
//    if(G == 2) solve_2(); ///OK
    if(G == 0 || G == 3) solve_3(); ///???
//    if(G == 4) solve_4(); ///:((
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
