#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 1e3 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int n, m, p, G;
int a[MAX];
vector<pair<int, int>> g[MAX];

void solve_1() {
    vector<ll> d(n + 1, inf);
    d[1] = 0;
    set<pair<ll, int>> q;
    for(int i = 1; i <= n; i++) {
        q.insert({d[i], i});
    }
    while(sz(q)) {
        auto [dst, v] = *q.begin(); q.erase(q.begin());
        for(auto [to, w] : g[v]) {
            if(d[to] > dst + w) {
                q.erase({d[to], to});
                d[to] = dst + w;
                q.insert({d[to], to});
            }
        }
    }
    ll ans = max(d[n] - p, 0LL);
    if(d[n] == inf) ans = -1;
    cout << ans << '\n';
}

/*
6 5 0 3
3 2 3 2 5 4
1 2 3
2 3 4
3 4 5
4 5 6
5 6 7
*/

ll get(int k, vector<ll> &pref, vector<ll> &w) {
    vector<int> nxt(k + 1, k);
    stack<int> st;
    for(int i = k; i; i--) {
        while(sz(st) && w[st.top()] <= w[i]) st.pop();
        if(sz(st)) nxt[i] = st.top();
        st.push(i);
    }
    ll ans = 0;
    ll money = p;
    for(int i = 1; i < k;) {
        int go = nxt[i];
        ll need = max(pref[go] - money, 0LL);
        ll add = (need + w[i] - 1) / w[i];
        ans += add;
        money += add * w[i];
        i = go;
    }
    return ans;
}

void solve_2() {
    vector<ll> c(n + 2);
    for(int i = 1; i < n; i++) {
        c[i] = g[i][0].s;
    }
    vector<ll> pref(n + 2);
    for(int i = 1; i < n; i++) {
        pref[i + 1] = pref[i] + c[i];
    }
    vector<ll> w(n + 1);
    for(int i = 1; i <= n; i++) w[i] = a[i];
    cout << get(n, pref, w) << '\n';
}

void solve_3_5() {
    vector<vector<ll>> adj(n + 1, vector<ll>(n + 1, inf));
    for(int v = 1; v <= n; v++) {
        for(auto [to, w] : g[v]) {
            umin(adj[v][to], (ll) w);
            assert(w);
        }
    }
    for(int k = 1; k <= n; k++) {
        for(int i = 1; i <= n; i++) {
            for(int j = 1; j <= n; j++) {
                umin(adj[i][j], adj[i][k] + adj[k][j]);
            }
        }
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= n; j++) {
            if(adj[i][j] == inf) adj[i][j] = 0;
        }
    }
    vector<vector<int>> order(n + 1);
    for(int i = 1; i <= n; i++) {
        vector<pair<ll, int>> curr;
        for(int j = 1; j <= n; j++) {
            if(adj[i][j] && (a[i] < a[j] || j == n)) curr.pb({adj[i][j], j});
        }
        sort(all(curr));
        for(auto [useless, j] : curr) order[i].pb(j);
    }
    ll ans = inf;
    vector<int> used(n + 1);
    function<void(int, ll, ll)> rec = [&](int lst, ll curr, ll money) {
        if(curr >= ans) return;
        if(lst == n) {
            umin(ans, curr);
            return;
        }
        for(auto i : order[lst]) {
            if(used[i]) continue;
            used[i] = 1;
            ll need = max(adj[lst][i] - money, 0LL);
            ll add = (need + a[lst] - 1) / a[lst];
            rec(i, curr + add, money + add * a[lst] - adj[lst][i]);
            used[i] = 0;
        }
    };
    rec(1, 0, p);
    if(ans == inf) ans = -1;
    cout << ans << '\n';
}

void solve_4() {
    const int buben = 1e4 + 5;
    ///d[v][cnt] - go to v with cnt times
    vector<vector<ll>> d(n + 1, vector<ll>(buben, inf));
    d[1][0] = -p;
    int mn = buben;
    while(1) {
        int ok = 0;
        for(int cnt = 0; cnt < mn; cnt++) {
            for(int v = 1; v <= n; v++) {
                if(d[v][cnt] > 0) continue;
                if(v == n && cnt >= mn) break;
//                cout << v << ' ' << cnt << " " << d[v][cnt] << endl;
                if(v == n) umin(mn, cnt);
                for(auto [to, w] : g[v]) {
                    ll ndst = d[v][cnt] + w;
                    if(ndst <= 0 && umin(d[to][cnt], ndst)) ok = 1;
                }
                if(cnt + 1 == buben) continue;
                ll ndst = d[v][cnt] - a[v];
                if(umin(d[v][cnt + 1], ndst)) ok = 1;
            }
        }
        if(!ok) break;
    }
    if(mn == buben) mn = -1;
    cout << mn << '\n';
}

void solve() {
    cin >> n >> m >> p >> G;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
    }
//    if(G == 1) solve_1(); ///OK!
//    if(G == 2) solve_2(); ///OK!!
    if(G == 0 || G == 3 || G == 5) solve_3_5(); ///OK!!!
    if(G == 4) solve_4(); ///OK!!!!
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
