#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

const long long N = 805;

long long n, m, p, G;
vector<edge> g[N];
vector<long long> w;

void sub1()
{
	vector<long long> dist(n, INF);
	set<pair<long long, long long>> q;
	q.insert({ 0, 0 });
	while (q.size())
	{
		auto [d, ver] = *q.begin();
		q.erase(q.begin());
		for (auto& i : g[ver])
		{
			if (d + i.w < dist[i.to])
			{
				q.erase({ dist[i.to], i.to });
				dist[i.to] = d + i.w;
				q.insert({ dist[i.to], i.to });
			}
		}
	}
	if (dist[n - 1] == INF)
	{
		cout << -1 << "\n";
		return;
	}

	cout << max(0ll, dist[n - 1] - p) << "\n";
}

void solve()
{
	cin >> n >> m >> p >> G;
	w.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> w[i];
	}
	for (long long i = 0; i < m; i++)
	{
		long long a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c });
	}
	if (G <= 1)
	{
		sub1();
		return;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/
