#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e17, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

const long long N = 805;

long long n, m, p, G;
vector<edge> g[N];
vector<long long> w;

void sub1()
{
	vector<long long> dist(n, INF);
	set<pair<long long, long long>> q;
	q.insert({ 0, 0 });
	while (q.size())
	{
		auto [d, ver] = *q.begin();
		q.erase(q.begin());
		for (auto& i : g[ver])
		{
			if (d + i.w < dist[i.to])
			{
				q.erase({ dist[i.to], i.to });
				dist[i.to] = d + i.w;
				q.insert({ dist[i.to], i.to });
			}
		}
	}
	if (dist[n - 1] == INF)
	{
		cout << -1 << "\n";
		return;
	}

	cout << max(0ll, dist[n - 1] - p) << "\n";
}

void sub2()
{
	long long mxw = w[0];
	long long cur = 0;
	long long ans = 0;
	while (cur < n - 1)
	{
		mxw = max(mxw, w[cur]);
		long long nd = g[cur][0].w;
		if (nd <= p)
		{
			p -= nd;
		}
		else
		{
			nd -= p;
			p = 0;
			long long times = (nd + mxw - 1) / mxw;
			p = times * mxw;
			p -= nd;
			ans += times;
		}
		cur++;
	}
	cout << ans << "\n";
}

void sub3()
{
	vector<vector<long long>> gr(n, vector<long long>(n, INF));
	for (long long i = 0; i < n; i++)
	{
		gr[i][i] = 0;
		for (auto& j : g[i])
		{
			gr[i][j.to] = min(gr[i][j.to], j.w);
		}
	}
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			for (long long k = 0; k < n; k++)
			{
				gr[i][j] = min(gr[i][j], gr[i][k] + gr[k][j]);
			}
		}
	}
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			for (long long k = 0; k < n; k++)
			{
				gr[j][k] = min(gr[j][k], gr[j][i] + gr[i][k]);
			}
		}
	}
	for (long long i = 0; i < n; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			for (long long k = 0; k < n; k++)
			{
				gr[i][k] = min(gr[i][k], gr[i][j] + gr[j][k]);
			}
		}
	}

	vector<long long> order(n - 1);
	iota(order.begin(), order.end(), 1);
	long long ans = INF;
	while (true)
	{
		long long cur = 0;
		long long res = 0;
		long long pp = p;
		long long mxw = w[0];
		bool ok = true;
		for (auto& i : order)
		{
			if (gr[cur][i] >= INF)
			{
				ok = false;
				break;
			}

			mxw = max(mxw, w[cur]);
			long long nd = gr[cur][i];
			if (nd <= pp)
			{
				pp -= nd;
			}
			else
			{
				nd -= pp;
				pp = 0;
				long long times = (nd + mxw - 1) / mxw;
				pp = times * mxw;
				pp -= nd;
				res += times;
			}
			cur = i;
			if (cur == n - 1)
			{
				break;
			}
		}
		if (ok)
		{
			ans = min(ans, res);
		}

		next_permutation(order.begin(), order.end());
		if (is_sorted(order.begin(), order.end()))
		{
			break;
		}
	}
	if (ans >= INF)
	{
		cout << -1 << "\n";
	}
	else
	{
		cout << ans << "\n";
	}
}

void solve()
{
	cin >> n >> m >> p >> G;
	w.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> w[i];
	}
	for (long long i = 0; i < m; i++)
	{
		long long a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c });
	}
	if (G == 1)
	{
		sub1();
		return;
	}
	if (G == 2)
	{
		sub2();
		return;
	}
	sub3();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/