#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <algorithm>
#include <deque>
#include <queue>

using namespace std;

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcp(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    if (g <= 1) {
        vector<vector<pair<int, int>>> gr(n);
        for (int i = 0; i < m; ++i) {
            int v, u, c;
            cin >> v >> u >> c;
            --v;
            --u;
            gr[v].push_back({u, c});
        }
        vector<int> d(n, 1e18);
        d[0] = 0;
        set<pair<int, int>> now = {{0, 0}};
        while (now.size()) {
            auto v = *now.begin();
            now.erase(v);
            if (d[v.second] == v.first) {
                for (auto u: gr[v.second]) {
                    if (d[u.first] > d[v.second] + u.second) {
                        d[u.first] = d[v.second] + u.second;
                        now.insert({d[u.first], u.first});
                    }
                }
            }
        }
        if (d[n - 1] > 1e14){
            cout << -1 << "\n";
        }else {
            cout << max(0ll, d[n - 1] - p) << "\n";
        }
    }
}