//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,tune=native")

#include <queue>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const ll inf = 1e18;


int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    if (gr == 1) {
        vector<vector<pair<int, int>>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b, s;
            cin >> a >> b >> s;
            --a; --b;
            g[a].push_back({b, s});
            g[b].push_back({a, s});
        }
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
        vector<ll> d(n, inf);
        d[0] = 0;
        q.push({0, 0});
        while (!q.empty()){
            auto [v, ww] = q.top();
//            cout << v << endl;
            q.pop();
            if (d[v] != ww){
                continue;
            }
            for (auto [u, s] : g[v]){
//                cout << u << ' ' << s << endl;
                if (d[u] > d[v] + s){
//                    cout << u << endl;
                    d[u] = d[v] + s;
                    q.push({d[u], u});
                }
//                cout << endl;
            }
        }
        if (d[n - 1] == inf){
            cout << -1 << endl;
            return 0;
        }
        cout << max((ll)0, d[n - 1] - p) << endl;
    }

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}