#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

void solve() {
	int n, m, p, o;
	cin >> n >> m >> p >> o;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<int>> g(n, vector<int>(n, (int) 1e18));
	for (int i = 0; i < n; ++i) {
		g[i][i] = 0;
	}
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		ckmin(g[u][v], w);
	}
	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				ckmin(g[i][j], g[i][k] + g[k][j]);
			}
		}
	}
	vector<pair<int, int>> b;
	for (int i = 0; i < n; ++i) {
		b.emplace_back(a[i], i);
	}
	sort(b.begin(), b.end());
	vector<pair<int, int>> dp(n, make_pair((int) 1e18, (int) -1e18));
	dp[0] = make_pair(0, p);
	for (const pair<int, int> &e : b) {
		int i = e.second;
		for (int j = 0; j < n; ++j) {
			if (a[j] < a[i] && g[j][i] < (int) 1e18 && dp[j].first < (int) 1e18) {
				int x = max(0ll, g[j][i] - dp[j].second);
				int y = (x + a[j] - 1) / a[j];
				ckmin(dp[i], make_pair(dp[j].first + y, dp[j].second + y * a[j] - g[j][i]));
			}
		}
	}
	int ans = (int) 1e18;
	for (int i = 0; i < n; ++i) {
		if (g[i].back() < (int) 1e18 && dp[i].first < (int) 1e18) {
			int x = max(0ll, g[i].back() - dp[i].second);
			int y = (x + a[i] - 1) / a[i];
			ckmin(ans, dp[i].first + y);
		}
	}
	if (ans == (int) 1e18) {
		cout << -1 << endl;
	} else {
		cout << ans << endl;
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
