#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

vector<vector<pair<int, ll>>> g;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        g[u].emplace_back(v, s);
    }

    if (group == 1) {
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> pq;
        vector<ll> dist(n, 1e18);
        dist[0] = 0;
        pq.push({0, 0});
        while (!pq.empty()) {
            auto [d, v] = pq.top();
            pq.pop();
            if (dist[v] != d) continue;

            for (auto [u, s] : g[v]) {
                if (dist[v] + s < dist[u]) {
                    dist[u] = dist[v] + s;
                    pq.push({dist[u], u});
                }
            }
        }

        if (dist[n - 1] == 1e18) {
            cout << -1;
        } else {
            cout << max(0LL, dist[n - 1] - p);
        }
    } else if (group == 2) {
        ll ans = 0;
        ll mx = w[0];
        for (int i = 0; i < n - 1; i++) {
            ll cur = g[i][0].second;
            if (p < cur) {
                int need = cur - p;
                int cnt = (need - 1) / mx + 1;
                ans += cnt;
                p += mx * cnt;
            }
            p -= cur;
            mx = max(mx, w[i + 1]);
        }
        cout << ans;
    } else if (group == 0 || group == 3) {
        vector<vector<ll>> mg(n, vector<ll>(n, 1e18));
        for (int v = 0; v < n; v++) {
            for (auto [u, s] : g[v]) {
                mg[v][u] = min(mg[v][u], s);
            }
        }

        ll ans = 1e18;
        vector<int> a(n);
        iota(all(a), 0);
        for (int _ = 0; _ < 24; _++) {
            ll cur = p, mx = w[0], nw = 0;
            for (int i = 1; i < n; i++) {
                ll e = mg[a[i - 1]][a[i]];
                if (e == 1e18) {
                    break;
                }

                if (cur < e) {
                    int need = e - cur;
                    int cnt = (need - 1) / mx + 1;
                    nw += cnt;
                    cur += mx * cnt;
                }
                cur -= e;

                mx = max(mx, w[a[i]]);
                if (a[i] == n - 1) {
                    ans = min(ans, nw);
                    break;
                }
            }

            next_permutation(a.begin() + 1, a.end());
        }

        if (ans == 1e18) {
            cout << -1 << '\n';
        } else {
            cout << ans << '\n';
        }
    }

    return 0;
}