#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<bool> used;

void dfs(int v, vector<vector<pair<int, ll>>> &g) {
    used[v] = true;
    for (auto &[u, w] : g[v]) {
        if (!used[u]) {
            dfs(u, g);
        }
    }
}

struct trp{
    ll c, p;
    int v;

    trp() {
        c = 0;
        p = 0;
        v = 0;
    }

    trp(ll c_, ll p_, int v_) {
        c = c_;
        p = p_;
        v = v_;
    }
};

bool operator<(trp a, trp b) {
    if (a.c < b.c) {
        return true;
    }
    return a.c == b.c && a.p < b.p;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    ll p;
    cin >> n >> m >> p;
    int G;
    cin >> G;
    vector<ll> weight(n);
    for (auto &i : weight) cin >> i;
    vector<vector<pair<int, ll>>> g(n);
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        ll s;
        cin >> s;
        g[a].push_back({b, s});
    }
    dfs(0, g);
    if (!used[n - 1]) {
        cout << -1;
        return 0;
    }
    vector<ll> dist(n, LONG_LONG_MAX);
    dist[0] = 0;
    used.assign(n, false);
    while (true) {
        int ind = -1;
        ll mind = LONG_LONG_MAX;
        for (int i = 0; i < n; ++i) {
            if (!used[i] && dist[i] < mind) {
                mind = dist[i];
                ind = i;
            }
        }
        if (ind == -1) {
            break;
        }
        for (auto &[u, w] : g[ind]) {
            if (dist[u] > dist[ind] + w) {
                dist[u] = dist[ind] + w;
            }
        }
        used[ind] = true;
    }
    cout << dist[n - 1] - p;
    /*vector<map<ll, ll>> vis(n);
    set<trp> q;
    q.insert({0, p, 0});
    while (!q.empty()) {
        auto v = *q.begin();
        q.erase(q.begin());
        if (v.v == n - 1) {
            cout << v.c;
            return 0;
        }
//        if (vis[v.v][v.c] >= v.p) {
//            continue;
//        }
        //vis[v.v][v.c] = v.p;
        for (auto &[u, w] : g[v.v]) {
            auto v2 = v;
            if (w > v2.p) {
                ll add = (w - v2.p) / weight[v2.v];
                if ((w - v2.p) % weight[v2.v] != 0) {
                    ++add;
                }
                v2.p += add * weight[v2.v] - w;
                v2.c += add;
                v2.v = u;
                q.insert(v2);
            } else {
                v2.p -= w;
                v2.v = u;
                q.insert(v2);
            }
        }
        ++v.c;
        v.p += weight[v.v];
        q.insert(v);
    }*/
    return 0;
}