#include <bits/stdc++.h>
#include <cmath>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'
#define double long double

vector<vector<pair<int, int>>> gr(1000);

void solve1(int n, int m, int p) {
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    for (int i = 0; i < m; i++) {
        int u, v, ww;
        cin >> u >> v >> ww;

        gr[u].push_back({v, ww});
    }

    vector<int> dist(n + 1, 1e15);
    dist[1] = 0;

    set<pair<int, int>> st;

    st.insert({0, 1});

    while (!st.empty()) {
        int v = st.begin()->S;
        st.erase(st.begin());

        for (auto &[u, ww] : gr[v]) {
            if (dist[u] > dist[v] + ww) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + ww;
                st.insert({dist[u], u});
            }
        }
    }

    if (dist[n] > 1e14) {
        cout << -1;
        return;
    }

    cout << max(0LL, dist[n] - p);
}

void solve2(int n, int m, int p) {
    vector<int> w(n + 1);

    for (int i = 0; i < n; i++) {
        cin >> w[i + 1];
    }

    int mx = w[1];
    int ans = 0;

    for (int i = 0; i < m; i++) {
        int u, v, ww;
        cin >> u >> v >> ww;

        if (p < ww) {
            ww -= p;
            int ff = (ww + mx - 1) / mx;
            p = ff * mx - ww;

            ans += ff;
        }

        else {
            p -= ww;
        }

        mx = max(mx, w[v]);
    }

    cout << ans;

}

void solve3(int n, int m, int p) {
    vector<int> ww(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> ww[i + 1];
    }

    vector<vector<int>> g(n + 1, vector<int> (n + 1, 1e15));

    for (int i = 0; i < m ;i++) {
        int u, v, w;
        cin >> u >> v >> w;

        g[u][v] = w;
        gr[u].push_back({v, w});
    }

    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (n + 1, {1e16, 0}));

    queue<int> q;

    q.push(1);

    dp[1][1] = {0, p};

    for (int y = 0; y < 200; y++) {
        for (int v = 1; v <= n; v++) {
            for (int w = 1; w <= n; w++) {
                for (auto &[u, w1]: gr[v]) {
                    if (dp[v][w].F != 1e16) {
                        if (dp[v][w].S >= w1 and
                            (dp[v][w].F < dp[u][w].F or (dp[v][w].F == dp[u][w].F and dp[v][w].S > dp[u][w].S))) {
                            dp[u][w] = dp[v][w];
                            dp[u][w].S -= w1;
                        } else if (dp[v][w].S < w1) {
                            int w2 = w1 - dp[v][w].S;
                            int mx = ww[w];
                            int ff = (w2 + mx - 1) / mx;

                            int p1 = ff * mx - w2;

                            if (dp[v][w].F + ff < dp[u][w].F or (dp[v][w].F + ff == dp[u][w].F and p1 > dp[u][w].S)) {
                                dp[u][w] = {dp[v][w].F + ff, p1};
                            }
                        }

                        if (dp[u][w].F < dp[u][u].F or (dp[u][w].F == dp[u][u].F and dp[u][w].S > dp[u][u].S)) {
                            dp[u][u] = dp[u][w];
                        }
                    }
                }
            }
        }
    }

    int ans = 1e16;
    for (int i = 0; i < n; i++) {
        ans = min(ans, dp[n][i + 1].F);
    }

    if (ans > 1e14) {
        cout << -1;
        return;
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout << setprecision(17);

    int n, m, p, g;
    cin >> n >> m >> p >> g;

    if (g == 1) {
        solve1(n, m, p);
    }

    else if (g == 2) {
        solve2(n, m, p);
    }

    else {
        solve3(n, m, p);
    }

    return 0;
}

/*
 4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11



 4 4 10 0
1 2 10 1
1 2 20
2 4 30
1 3 25
3 4 89




 4 4 7 0
5 1 6 2
1 2 5
2 3 10
3 4 50
3 4 70
 */

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
 */

/*
 4 4
abcdca
ab
ca
bcd
opedrftghyj
1 5
2 2
2 6
1 6
 */