#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

ll inf = 1e18;

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n, m, p, group;
	cin >> n >> m >> p >> group;
	vector<int>w(n);
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	vector<vector<pair<int, int>>>g(n);
	for (int i = 0; i < m; i++) {
		int v, u, c;
		cin >> v >> u >> c;
		v--, u--;
		g[v].push_back({ u, c });
	}
	vector<vector<pair<ll, ll>>>d(n, vector<pair<ll, ll>>(n, { inf, 0 }));
	d[0][0] = { 0, -p };
	set<pair<pair<ll, ll>, pair<int, int>>>q;
	q.insert({ d[0][0], {0, 0} });
	while (!q.empty()) {
		pair<int, int> me = q.begin()->second;
		int v = me.first, best = me.second;
		q.erase(q.begin());
		for (auto u : g[v]) {
			ll days = d[v][best].first, money = -d[v][best].second;
			int will_best = best;
			if (w[u.first] > w[best]) {
				will_best = u.first;
			}
			if (money < u.second) {
				ll dopd = (u.second - money + w[best] - 1) / w[best];
				days += dopd;
				money += w[best] * dopd;
			}
			money -= u.second;
			money = -money;
			if (d[u.first][will_best] > make_pair(days, money)) {
				q.erase({ d[u.first][will_best], {u.first, will_best} });
				d[u.first][will_best] = { days, money };
				q.insert({ d[u.first][will_best], {u.first, will_best} });
			}
		}
	}
	ll ans = inf;
	for (int i = 0; i < n; i++)
		ans = min(ans, d[n - 1][i].first);
	if (ans == inf)
		ans = -1;
	cout << ans;
	return 0;
}
