#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
//  freopen("../in.txt", "r", stdin);
//  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

//  ll t;
//  cin >> t;
//  while (t--)
  solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

vvii gr;

void solve() {
  ll n, m, p, g;
  cin >> n >> m >> p >> g;
  vi w(n);
  cin >> w;

  gr.assign(n, {});
  for (int i = 0; i < m; ++i) {
    ll a, b, s;
    cin >> a >> b >> s;
    --a, --b;
    gr[a].emplace_back(b, s);
  }

  {
    set<ii> q;
    vi dist(n, 1e18);
    dist[0] = 0;
    q.insert({dist[0], 0});

    while (!q.empty()) {
      ll v = q.begin()->second;
      q.erase(q.begin());
      for (auto [u, s] : gr[v]) {
        ll d = dist[v] + s;
        if (d < dist[u]) {
          q.erase({dist[u], u});
          dist[u] = d;
          q.insert({dist[u], u});
        }
      }
    }

    if (dist[n - 1] == 1e18) {
      cout << -1 << endl;
      return;
    }
    cout << max(0ll, dist[n - 1] - p) << endl;
  }
}