#include<bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18 + 100;

int n;
vector<vector<pair<int, ll>>> g;

void dijkstra(vector<ll> &d, int st) {
    d[st] = 0;
    set<pair<ll, int>> s;
    for (int i = 0; i < n; ++i)
        s.emplace(d[i], i);
    for (int i = 0; i < n; ++i) {
        int u = s.begin()->second;
        s.erase(s.begin());
        if (d[u] == INF)
            break;
        for (auto to: g[u]) {
            if (d[u] + to.second < d[to.first]) {
                s.erase({d[to.first], to.first});
                d[to.first] = d[u] + to.second;
                s.emplace(d[to.first], to.first);
            }
        }
    }
}

int main() {
    fast;
    int m, gr;
    ll p;
    cin >> n >> m >> p >> gr;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        g[u - 1].emplace_back(v - 1, w);
    }
    vector<vector<ll>> d(n, vector<ll>(n, INF));
    for (int i = 0; i < n; ++i)
        dijkstra(d[i], i);
    if (d[0][n - 1] == INF) {
        cout << "-1\n";
        return 0;
    }
    vector<pair<ll, int>> b(n - 1);
    for (int i = 0; i < n - 1; ++i)
        b[i] = {a[i], i};
    sort(all(b));
    vector<vector<pair<int, ll>>> ng(n);
    for (int i = 0; i < n - 1; ++i) {
        for (int j = n - 2; j > i; --j) {
            if (b[j].first == b[i].first)
                break;
            if (d[b[i].second][b[j].second] != INF)
                ng[b[i].second].emplace_back(b[j].second, d[b[i].second][b[j].second]);
        }
        if (d[b[i].second][n - 1] != INF)
            ng[b[i].second].emplace_back(n - 1, d[b[i].second][n - 1]);
    }
    vector<ll> x(n, -1), y(n, INF);
    x[0] = p;
    y[0] = 0;
    for (int i = 0; i < n - 1; ++i) {
        int u = b[i].second;
        if (x[u] == -1)
            continue;
        for (auto to: ng[u]) {
            ll z = max((to.second - x[u] + a[u] - 1) / a[u], (ll)0);
            if (y[u] + z < y[to.first] || y[u] + z == y[to.first] && x[u] - to.second + z * a[u] > x[to.first]) {
                x[to.first] = x[u] - to.second + z * a[u];
                y[to.first] = y[u] + z;
            }
        }
    }
    cout << y[n - 1] << '\n';
}
