#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
ll n, m, p, tc;
vector<vector<pair<ll, ll>>> g;
vector<ll> w;
void solve1() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        ll u, v, c;
        cin >> u >> v >> c;
        --u; --v;
        g[u].push_back({ v, c });
    }
    vector<ll> d(n, 1e17);
    d[0] = 0;
    set<pair<ll, ll>> s;
    s.insert({ 0, 0 });
    while (!s.empty()) {
        ll v = s.begin()->second;
        s.erase(s.begin());
        for (auto to : g[v]) {
            if (d[v] + to.second < d[to.first]) {
                s.erase({ d[to.first], to.first });
                d[to.first] = d[v] + to.second;
                s.insert({ d[to.first], to.first });
            }
        }
    }
    cout << (d[n- 1] < 1e17 ? max(0LL, d[n - 1] - p) : -1);
}

void solve2() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector<ll> a(n - 1);
    for (int i = 0; i < m; ++i) {
        ll x;
        cin >> x >> x >> a[i];
    }
    vector<ll> pref(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        pref[i] = w[i];
        if (i) pref[i] = max(pref[i], pref[i - 1]);
    }
    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        if (p >= a[i]) {
            p -= a[i];
            continue;
        }
        ll need = a[i] - p;
        ans += (need + pref[i] - 1) / pref[i];
        p += ((need + pref[i] - 1) / pref[i]) * pref[i];
        p -= a[i];
    }
    cout << ans << '\n';
}

vector<ll> order, used;

void dfs(ll v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to.first]) {
            dfs(to.first);
        }
    }
    order.push_back(v);
}
ll ress = 1e18;

void rec(ll v, ll c, ll cnt, ll mx, set<ll>& path) {
    if (v == n - 1) {
        ress = min(ress, cnt);
        return;
    }
    for (auto& to : g[v]) {
        if (path.find(to.first) != path.end()) continue;
        ll need = to.second - c;
        ll was = cnt;
        ll was2 = c;
        if (need > 0) {
            was += (need + mx - 1) / mx;
            was2 += ((need + mx - 1) / mx * mx);
        }
        path.insert(to.first);
        rec(to.first, was2 - to.second, was, max(mx, w[to.first]), path);
        path.erase(to.first);
    }
}

void solve3() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        ll u, v, c;
        cin >> u >> v >> c;
        --u; --v;
        g[u].push_back({ v, c });
    }
    set<ll> path = { 0 };
    rec(0, p, 0, w[0], path);
    if (ress == 1e18) cout << -1;
    else cout << ress;
}

void solve() {
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        ll u, v, c;
        cin >> u >> v >> c;
        --u; --v;
        g[u].push_back({ v, c });
    }
    used.assign(n, 0);
    dfs(0);
    if (!used[n - 1]) {
        cout << "-1";
        return;
    }
    reverse(order.begin(), order.end());
    ll ln = order.size();
    vector<vector<pair<pair<ll, ll>, ll>>> dp(n);
    used.assign(n, 0);
    dp[0].push_back({ {p, 0}, w[0] });
    for (int i = 0; i < ln; ++i) {
        used[order[i]] = 1;
        ll v = order[i];
        for (auto& to : g[v]) {
            if (used[to.first]) continue;
            for (auto w2 : dp[v]) {
                ll now = w2.first.first;
                ll cnt = w2.first.second;
                ll mx = w2.second;
                if (now < to.second) {
                    cnt += (to.second - now + mx - 1) / mx;
                    now += ((to.second - now + mx - 1) / mx * mx);
                }
                dp[to.first].push_back({ {now - to.second, cnt}, max(mx, w[to.first])});
            }
        }
    }
    ll ans = 1e18;
    for (auto w2 : dp[n - 1]) {
        ans = min(ans, w2.first.second);
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m >> p >> tc;
    if (tc == 1) {
        solve1();
    }
    else if (tc == 2) {
        solve2();
    }
    else if (tc == 3 || tc == 0) {
        solve3();
    }
    else {
        solve();
    }
}