/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
// #define int ll


int n, m, p, group;
vector <int> w;
vector<vector<pii>> g;
vector <bool> used;

void dfs (int k) {
    used[k] = true;
    for (auto i : g[k]) {
        if (!used[i.first]) {
            dfs(i.first);
        }
    }
}

void solve() {
    cin >> n >> m >> p >> group;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, s; cin >> a >> b >> s;
        --a; --b;
        g[a].pb({b, s});
        // g[b].pb({a, s});
    }
    used.assign(n, false);
    dfs(0);
    if (!used[n - 1]) {
        cout << -1 << endl; return;
    }
    if (group == 1) {
        // dijkstra
        set <pll> s;
        vector <ll> dist(n, 1e15);
        dist[0] = 0;
        s.insert({dist[0], 0});
        while (!s.empty()) {
            auto t = *s.begin();
            s.erase(s.begin());
            for (auto i : g[t.second]) {
                if (dist[i.first] > i.second + dist[t.second]) {
                    s.erase({dist[i.first], i.first});
                    dist[i.first] = i.second + dist[t.second];
                    s.insert({dist[i.first], i.first});
                }
            }
        }
        cout << max(0ll, dist[n - 1] - p) << endl;
        return;
    }
    else if (group == 2) {
        vector <int> right(n, n);
        stack <int> st;
        for (int i = n - 1; i >= 0; --i) {
            while (!st.empty() && w[st.top()] <= w[i]) {
                st.pop();
            }
            if (!st.empty()) {
                right[i] = st.top();
            }
            st.push(i);
        }
        int curr = 0, ans = 0, money = p;
        while (curr < n - 1) {
            if (right[curr] < n) {
                int need = 0;
                for (int i = curr; i < right[curr]; ++i) {
                    need += g[i][0].second;
                }
                if (need <= money) {
                    money -= need;
                }
                else {
                    ans += (need - money + w[curr] - 1) / w[curr];
                    money += (need - money + w[curr] - 1) / w[curr] * w[curr];
                    money -= need;
                }
                curr = right[curr];
            }
            else {
                int need = 0;
                for (int i = curr; i < n - 1; ++i) {
                    need += g[i][0].second;
                }
                if (need <= money) {
                    money -= need;
                }
                else {
                    ans += (need - money + w[curr] - 1) / w[curr];
                }
                break;
            }
        }
        cout << ans << endl;
        return;
    }
    else if (group == 3) {
        vector<vector<int>> G(n, vector<int>(n, 1e15));
        for (int i = 0; i < n; ++i) {
            for (auto j : g[i]) {
                g[i][j.first] = min(g[i][j.first], g[i][j.second]);
            }
        }
        int ANS = 1e15;
        vector <int> v(n); iota(all(v), 0);
        while (next_permutation(all(v))) {
            int pos1 = -1, pos2 = -1;
            for (int i = 0; i < n; ++i) {
                if (v[i] == 0) {
                    pos1 = i;
                }
                if (v[i] == n - 1) {
                    pos2 = i;
                }
            }
            if (pos1 < pos2) {

            }
        }
        cout << ANS << endl;
    }
    else if (group == 4 || group == 0) {
        int mx = 1e4 + 1;
        vector<vector<pii>> g1(n * mx);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < mx; ++j) {
                if (j + w[i] < mx) {
                    g1[i * mx + j].pb({i * mx + j + w[i], 1});
                }
                else if (j != mx - 1) {
                    g1[i * mx + j].pb({i * mx + mx - 1, 1});
                }
                for (auto edge : g[i]) {
                    if (j - edge.second >= 0) {
                        g1[i * mx + j].pb({edge.first * mx + j - edge.second, 0});
                    }
                }
            }
        }
        set <pll> s;
        vector <ll> dist(n * mx, 1e15);
        dist[min(mx - 1, p)] = 0;
        s.insert({0, min(mx - 1, p)});
        while (!s.empty()) {
            auto t = *s.begin();
            s.erase(s.begin());
            for (auto i : g1[t.second]) {
                if (dist[i.first] > i.second + dist[t.second]) {
                    s.erase({dist[i.first], i.first});
                    dist[i.first] = i.second + dist[t.second];
                    s.insert({dist[i.first], i.first});
                }
            }
        }
        int ANS = 1e15;
        for (int j = 0; j < mx; ++j) {
            ANS = min(ANS, dist[(n - 1) * mx + j]);
        }
        cout << ANS << endl;
        return;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}