#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

vector <vector <pair<int, int> > > graph;

const int mod = 1000000007;

int n;

vector <int> dejkstra (int s) {
    vector <int> dl(n, 1e10);
    vector <int> used(n);
    set<pair<int, int> > q;
    dl[s] = 0;
    used[s] = 1;
    q.insert({0, s});
    while(!q.empty()) {
        pair <int, int> p = *q.begin();
        int v = p.second;
        q.erase(p);
        for (int i = 0; i < graph[v].size(); ++i) {
            int u = graph[v][i].first, w = graph[v][i].second;
            if (!used[u]) {
                q.erase({dl[u], u});
                dl[u] = min(dl[u], dl[v] + w);
                q.insert({dl[u], u});
            }
        }
        used[v] = 1;
    }
    return dl;

}

void solve(int m, int p) {
    graph.resize(n);
    vector <int> w(n);
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        graph[a].push_back({b, s});
    }
    vector <int> dl = dejkstra(0);
    if (dl[n - 1] == 1e10) {
        cout << -1;
        return;
    }
    cout << max(0ll, dl[n - 1] - p);
}

signed main() {

    int m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 1) {
        solve(m, p);
        return 0;
    }
    vector <int> w(n);
    vector <pair<int, int> > mx(n + 1);
    mx[0] = {0, -1};
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        if (mx[i].first < w[i]) {
            mx[i + 1] = {w[i], i};
        } else {
            mx[i + 1] = mx[i];
        }
    }
    vector <int> s(n - 1);
    vector <int> put(n);
    put[0] = 0;
    for (int i = 1; i < n; ++i) {
        int qwe, rty;
        cin >> qwe >> rty >> s[i - 1];
        put[i] = put[i - 1] + s[i - 1];
    }

    vector <int> pr;
    int cur = mx[n].second;
    pr.push_back(n - 1);
    while(cur > 0) {
        pr.push_back(cur);
        cur = mx[cur].second;
    }
    pr.push_back(cur);
    reverse(pr.begin(), pr.end());
    int ans = 0;
    cur = 0;
    while(pr[cur] < n - 1) {
        int x = put[pr[cur + 1]] - put[pr[cur]];
        int zx = (max(0ll, (x - p + w[pr[cur]] - 1))) / w[pr[cur]];
        p += zx * w[pr[cur]];
        p -= x;
        cur++;
        ans += zx;
    }
    cout << ans;
}
