#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

ll n, ans = -1;

void gen(vector<bool>&used, int u, ll mx, ll p, ll res, vector<vector<pair<ll, ll>>>&gr, vector<ll>& w) {
	if (u == n-1) {
		if (ans == -1) {
			ans = res;
		}
		ans = min(ans, res);
		return;
	}
	for (auto v : gr[u]) {
		if (!used[v.first]) {
			used[v.first] = 1;
			ll cnt = 0;
			if (p < v.second) {
				cnt = (v.second - p - 1 + mx) / mx;
			}
			gen(used, v.first, max(mx, w[v.first]), p + cnt * mx - v.second, res + cnt, gr, w);
			used[v.first] = 0;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll m, p, g;
	cin >> n >> m >> p >> g;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	vector<vector<pair<ll, ll>>> gr(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		ll s;
		cin >> a >> b >> s;
		--a;
		--b;
		gr[a].push_back({ b, s });
	}
	if (g == 1) {
		vector<ll> dst(n, -1);
		dst[0] = 0;
		set<pair<ll, ll>> st = { {0, 0} };
		vector<bool> used(n);
		while (!st.empty()) {
			int u = (*st.begin()).second;
			st.erase(st.begin());
			used[u] = 1;
			for (auto v : gr[u]) {
				if (dst[v.first] == -1 || dst[v.first] > dst[u] + v.second) {
					if (dst[v.first] != -1) {
						st.erase({ dst[v.first], v.first });
					}
					dst[v.first] = dst[u] + v.second;
					st.insert({ dst[v.first], v.first });
				}
			}
		}
		if (dst[n - 1] == -1) {
			cout << -1;
		}
		else {
			cout << max(0ll, dst[n - 1] - p);
		}
	}
	else if (g == 2) {
		ll mx = w[0];
		ll res = 0;
		for (int i = 1; i < n; ++i) {
			ll k = gr[i - 1][0].second;
			if (k > p) {
				res += (k - p + mx - 1) / mx;
				p += (k - p + mx - 1) / mx * mx;
			}
			p -= k;
			mx = max(w[i], mx);
		}
		cout << res;
	}
	else {
		vector<bool> used(n);
		used[0] = 1;
		gen(used, 0, w[0], p, 0, gr, w);
		cout << ans;
	}
	return 0;
}