#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 807;
#define int long long

long long g[MAXN][MAXN];
int w[MAXN];

void solve1(int n, int p) {
	set < pair <long long, pair <int, int>>> se;
	vector <map <int, long long>> dp(n);
	se.insert({ 0, {p, 0} });
	long long ans = 1e18;
	while (se.size()) {
		int v = se.begin()->second.second;
		int c = se.begin()->second.first;
		long long d = se.begin()->first;
		se.erase(se.begin());
		if (v == n - 1) {
			ans = min(ans, d);
			continue;
		}
		for (int to = 0; to < n; to++) {
			if (w[to] < w[v] && to != n - 1)
				continue;
			long long need = max(0ll, g[v][to] - c);
			long long take = need / w[v];
			if (need % w[v])
				take++;
			int r = take * w[v] + c - g[v][to];
			if (dp[to].find(r) == dp[to].end()) {
				se.erase({ dp[to][r], {r, to} });
				dp[to][r] = d + take;
				se.insert({ dp[to][r], {r, to} });
			}
			else if (dp[to][r] > d + take) {
				se.erase({ dp[to][r], {r, to} });
				dp[to][r] = d + take;
				se.insert({ dp[to][r], {r, to} });
			}
		}
	}
	if (ans >= 1e18)
		ans = -1;
	cout << ans << "\n";
}

vector <bool> used;
vector <int> taken;

int ans2 = 1e18;

void check(int n, int p) {
	int sz = (int)taken.size();
	int res = 0;
	for (int i = 0; i < sz - 1; i++) {
		int need = max(0ll, g[taken[i]][taken[i + 1]] - p);
		int take = need / w[taken[i]];
		if (need % w[taken[i]])
			take++;
		res += take;
		p = take * w[taken[i]] - need;
	}
	ans2 = min(ans2, res);
}

void f(int n, int p, int pos = 1) {
	if (pos == n) {
		check(n, p);
		return;
	}
	if (pos == n - 1) {
		taken.push_back(n - 1);
		f(n, p, pos + 1);
		taken.pop_back();
		return;
	}
	for (int i = 0; i < n - 1; i++) {
		if (!used[i]) {
			used[i] = true;
			if (taken.empty() || w[taken.back()] < w[i])
				taken.push_back(i);
			f(n, p, pos + 1);
			if (taken.back() == i)
				taken.pop_back();
			used[i] = false;
		}
	}
}

void solve2(int n, int p) {
	used.assign(n, false);
	taken.push_back(0);
	used[0] = true;
	f(n, p);
	if (ans2 == 1e18) {
		cout << "-1\n";
		return;
	}
	cout << ans2 << "\n";
}

void solve3(int n, int p) {
	taken.push_back(0);
	for (int i = 1; i < n - 1; i++)
		if (w[i] > w[taken.back()])
			taken.push_back(i);
	taken.push_back(n - 1);
	check(n, p);
	if (ans2 == 1e18)
		ans2 = -1;
	cout << ans2 << "\n";
}

void solve() {
	int n, m, p, gr;
	cin >> n >> m >> p >> gr;
	int v, u, s;
	for (int i = 0; i < n; i++)
		cin >> w[i];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			g[i][j] = 1e18;
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> s;
		v--; u--;
		g[v][u] = min(g[v][u], 1ll * s);
	}
	for (int t = 0; t < n; t++)
		for (int s = 0; s < n; s++)
			for (int f = 0; f < n; f++)
				g[s][f] = min(g[s][f], g[s][t] + g[t][f]);
	if (n <= 10) {
		solve2(n, p);
	}
	else {
		solve3(n, p);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}