#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
#endif

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m, p, gruppa;
    cin >> n >> m >> p >> gruppa;
    vector<ll> w(n);
    cin >> w;
    vector<array<int, 3>> e(m);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, s;
        cin >> u >> v >> s;
        --u;
        --v;
        g[u].push_back({v, s});
        e[i] = {u, v, s};
    }
    if (gruppa == 1) {
        vector<ll> dp(n, INFLL);
        dp[0] = 0;
        for (int _ = 0; _ < n; ++_) {
            for (auto [u, v, s] : e) {
                dp[v] = min(dp[v], dp[u] + s);
            }
        }
        if (dp[n - 1] == INFLL) {
            cout << "-1\n";
        } else if (p >= dp[n - 1]) {
            cout << "0\n";
        } else {
            cout << dp[n - 1] - p << "\n";
        }
        return 0;
    } else if (gruppa == 2) {
        ll cur = p, ans = 0;
        ll ww = 0;
        for (int i = 0; i + 1 < n; ++i) {
            ww = max(ww, w[i]);
            auto [u, v, s] = e[i];
            assert(u == i && v == i + 1);
            if (cur < s) {
                ll c = (s - cur + ww - 1) / ww;
                ans += c;
                cur += ww * c;
            }
            cur -= s;
        }
        cout << ans << "\n";
        return 0;
    }
    vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>>(n, {INFLL, -INFLL}));
    dp[0][0] = {0, p};
//    set<pair<pair<ll, ll>, pair<int, int>>> q;
//    q.insert({dp[0][0], {0, 0}});
//    while (!q.empty()) {
//        auto [d, _] = *q.begin();
//        auto [u, pu] = _;
//        q.erase(q.begin());
//        for (auto [v, s] : g[u]) {
//            int pv = (w[pu] > w[v] ? pu : v);
//            auto cur = d;
//            if (cur.second < s) {
//                ll c = (s - cur.second + w[pu] - 1) / w[pu];
//                cur.first += c;
//                cur.second += c * 1ll * w[pu];
//            }
//            cur.second -= s;
//            if (cur.first < dp[v][pv].first || (cur.first == dp[v][pv].first && cur.second > dp[v][pv].second)) {
//                q.erase({dp[v][pv], {v, pv}});
//                dp[v][pv] = cur;
//                q.insert({dp[v][pv], {v, pv}});
//            }
//        }
//    }
    for (int _ = 0; _ < n; ++_) {
        for (auto [u, v, s] : e) {
            for (int pu = 0; pu < n; ++pu) {
                int pv = (w[pu] > w[v] ? pu : v);
                auto cur = dp[u][pu];
                if (cur.first == INFLL || cur.second < 0) {
                    continue;
                }
                if (cur.second < s) {
                    ll c = (s - cur.second + w[pu] - 1) / w[pu];
                    cur.first += c;
                    cur.second += c * 1ll * w[pu];
                }
                cur.second -= s;
                if (cur.first < dp[v][pv].first || (cur.first == dp[v][pv].first && cur.second > dp[v][pv].second)) {
                    dp[v][pv] = cur;
                }
            }
        }
    }
    ll ans = INFLL;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[n - 1][i].first);
    }
    if (ans == INFLL) {
        cout << "-1\n";
    } else {
        cout << ans << "\n";
    }
}
