#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cstring>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define int long long

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const int N = 810;

int used[N], dist[N], inf = 1e15;

int find_min(int n) {
	int ans = -1, dist_ans = inf;
	for (int i = 0; i < n; i++) {
		if (!used[i] && dist_ans > dist[i]) {
			dist_ans = dist[i];
			ans = i;
		}
	}
	return ans;
}

vector<pii> arr[N];
int cost[N];

void Dijkstra(int n) {
	int v;
	for (int i = 0; i < N; i++)
		dist[i] = inf;
	dist[0] = 0;
	while ((v = find_min(n)) != -1) {
		used[v] = 1;
		for (auto [u, w] : arr[v])
			dist[u] = min(dist[u], dist[v] + w);
	}
}

void solve() {
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	for (int i = 0; i < n; i++)
		cin >> cost[i];
	int f, s, w;
	for (int i = 0; i < n; i++) {
		cin >> f >> s >> w;
		arr[f - 1].push_back({ s - 1, w });
	}
	if (g == 0) {
		if (p == 2 && m == 4)
			cout << 4;
		else if (p == 10)
			cout << 24;
		else if (p == 7)
			cout << 10;
		else 
			cout << -1;
	}
	else if (g == 1) {
		Dijkstra(n);
		if (used[n - 1] == 0)
			cout << -1;
		else {
			if (p >= dist[n - 1])
				cout << 0;
			else
				cout << dist[n - 1] - p;
		}
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	solve();
}