#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <random>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	if (p == 1) return a;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}
ll get_hash(ll l, ll r, vector <ll>& h, vector <ll>& p, ll mod)
{
	return ((h[r + 1] - h[l] * p[r - l + 1]) % mod + mod) % mod;
}

/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N], tout[N], p[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
	tout[v] = timer++;
}
bool upper(ll a, ll b)
{
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
void up(ll& a, ll& b, ll& ans)
{
	while (!upper(head[a], b))
	{
		ans = min(ans, get(1, 0, n - 1, tin[head[a]], tin[a]));
		a = p[head[a]];
	}
}
ll get(ll a, ll b)
{
	ll ans = 1e18;
	up(a, b, ans);
	up(b, a, ans);
	if (upper(b, a)) swap(a, b);
	ans = min(ans, get(1, 0, n - 1, tin[a], tin[b]));
	return ans;
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/

ll ask(ll a)
{
	cout << "? " << a << endl;
	cin >> a;
	return a;
}
void answ(vector <ll>& a)
{
	cout << "! ";
	for (auto i : a) cout << i << " ";
	cout << endl;
}

vector <ll> k;
ll answer = 1e18;
void f(ll n, ll p, vector <bool>& used, vector <ll>& w, vector <vector <ll>>& g)
{
	if (k.back() == n - 1)
	{
		ll sz = k.size(), dist = 0, ww = 0;
		for (ll i = 0; i + 1 < sz; i++)
		{
			ww = max(ww, w[k[i]]);
			ll c = g[k[i]][k[i + 1]];
			if (p < c)
			{
				ll d = (c - p + ww - 1) / ww;
				p += d * ww;
				dist += d;
			}
			p -= c;
		}
		answer = min(answer, dist);
		return;
	}
	for (ll i = 1; i < n; i++)
	{
		if (!used[i] && g[k.back()][i] != 1e18)
		{
			k.push_back(i);
			used[i] = true;
			f(n, p, used, w, g);
			used[i] = false;
			k.pop_back();
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//random_device rd;
	//mt19937 gen(rd());

	ll n, m, p, gr;
	cin >> n >> m >> p >> gr;
	vector <ll> w(n);
	for (ll i = 0; i < n; i++) cin >> w[i];
	vector <vector <pair <ll, ll>>> g(n);
	for (ll i = 0; i < m; i++)
	{
		ll a, b, s;
		cin >> a >> b >> s;
		a--;
		b--;
		g[a].push_back({ b, s });
	}
	if (gr == 1)
	{
		vector <ll> dist(n, 1e18);
		set <pair <ll, ll>> f;
		dist[0] = 0;
		for (ll i = 0; i < n; i++) f.insert({ dist[i], i });
		while (!f.empty())
		{
			auto v = (*f.begin()).second;
			f.erase(f.begin());
			for (auto [i, w] : g[v])
			{
				if (dist[i] > dist[v] + w)
				{
					f.erase({ dist[i], i });
					dist[i] = dist[v] + w;
					f.insert({ dist[i], i });
				}
			}
		}
		if (dist[n - 1] == 1e18) cout << -1;
		else cout << max(0ll, dist[n - 1] - p);
	}
	if (gr == 2)
	{
		vector <ll> dist(n);
		ll ww = 0;
		for (ll i = 0; i + 1 < n; i++)
		{
			ww = max(ww, w[i]);
			if (p >= g[i][0].second)
			{
				p -= g[i][0].second;
				dist[i + 1] = dist[i];
			}
			else
			{
				ll d = (g[i][0].second - p + ww - 1) / ww;
				p += d * ww;
				p -= g[i][0].second;
				dist[i + 1] = dist[i] + d;
			}
		}
		cout << dist[n - 1];
	}
	if (gr >= 3 || gr == 0)
	{
		vector <vector <ll>> gg(n, vector <ll>(n, 1e18));
		for (ll i = 0; i < n; i++)
		{
			for (auto [j, w] : g[i])
			{
				gg[i][j] = min(gg[i][j], w);
			}
		}
		vector <bool> used(n);
		used[0] = true;
		k.push_back(0);
		f(n, p, used, w, gg);
		if (answer == 1e18) cout << -1;
		else cout << answer;
	}

	/*ll t;
	cin >> t;
	while (t--)
	{
		ll n, k, sum = 0;
		cin >> n >> k;
		if (k == 3)
		{
			ll all = ask(n), a1, a2, a3;
			ll sum = n * (n + 1) / 2 - all;
			ll l = 1, r = n;
			while (r - l > 1)
			{
				ll mid = (l + r) / 2;
				ll a = ask(mid);
				if (mid * (mid + 1) / 2 - a < sum) l = mid;
				else r = mid;
			}
			a3 = r;
			sum -= r;
			ll a = ask(sum / 2);
			a1 = (sum / 2) * (sum / 2 + 1) / 2 - a;
			a2 = sum - a1;
			cout << "! " << a1 << " " << a2 << " " << a3 << endl;
			cin >> k;
			continue;
		}
		vector <ll> ans;
		ll last = 0;
		map <ll, ll> mp;
		for (ll i = 0; i < k; i++)
		{
			ll l = last, r = n;
			while (r - l > 1)
			{
				ll mid = (l + r) / 2, a;
				if (mp.find(mid) == mp.end())
				{
					a = ask(mid);
					mp[mid] = a;
				}
				else a = mp[mid];
				if (a < mid * (mid + 1) / 2 - sum) r = mid;
				else l = mid;
			}
			sum += r;
			ans.push_back(r);
			last = r;
		}
		answ(ans);
		cin >> n;
	}*/

	/*ll n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector <string> s(n);
	for (ll i = 0; i < n; i++) cin >> s[i];
	ll p = 31, mod = 1e9 + 7, sz = t.size();
	vector <vector <ll>> d(sz);
	vector <ll> hs(n);
	for (ll i = 0; i < n; i++)
	{
		ll h = 0;
		for (ll j = 0; j < s[i].size(); j++)
		{
			h *= p;
			h += s[i][j] - 'a' + 1;
			h %= mod;
		}
		hs[i] = h;
	}
	vector <ll> h(sz + 1), pw(sz + 1, 1);
	for (ll i = 0; i < sz; i++)
	{
		h[i + 1] = (h[i] * p + t[i] - 'a' + 1) % mod;
		pw[i + 1] = pw[i] * p % mod;
	}
	for (ll i = 0; i < n; i++)
	{
		for (ll j = 0; j + s[i].size() - 1 < sz; j++)
		{
			if (hs[i] == get_hash(j, j + s[i].size() - 1, h, pw, mod))
			{
				d[j].push_back(j + s[i].size() - 1);
			}
		}
	}
	for (ll j = 0; j < sz; j++)
	{
		sort(d[j].begin(), d[j].end());
	}
	while (m--)
	{
		ll l, r;
		cin >> l >> r;
		l--;
		r--;
		ll ans = 0;
		for (ll i = l; i <= r; i++)
		{
			ans += upper_bound(d[i].begin(), d[i].end(), r) - d[i].begin();
		}
		cout << ans << "\n";
	}*/

	return 0;
}
/*
4 1 2 1
1 1 1 1
1 3 2

4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
*/