#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

void solve1(int n, int m, ll p, vector<vector<pair<int, ll>>>& v) {
	set<pair<ll, ll>> st;
	vector<ll> len(n, inf);
	len[0] = 0;
	st.insert({ 0, 0 });
	while (st.size() > 0) {
		int x = st.begin()->second;
		st.erase(st.begin());

		for (auto i : v[x]) {
			if (len[x] + i.second < len[i.first]) {
				if (len[i.first] < 1e12) {
					st.erase({ len[i.first], i.first });
				}

				st.insert({ len[i.first], i.first });
				len[i.first] = len[x] + i.second;
			}
		}
	}

	if (len[n - 1] > 1e12)cout << "-1\n";
	else cout << max(0ll, len[n - 1] - p) << "\n";
}

void solve2(int n, int m, ll p, vector<vector<pair<int, ll>>>& v, vector<ll>& w) {
	ll mx = 0;
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		mx = max(mx, w[i]);
		if (p > v[i][0].second)
			p -= v[i][0].second;
		else {
			ll need = v[i][0].second - p;
			ans += (need + mx - 1) / mx;
			p = p + ((need + mx - 1) / mx) * mx - v[i][0].second;
		}
	}

	cout << ans << "\n";
}

ll ans = inf;

void dfs(int i, vector<vector<pair<int, ll>>>& v, vector<ll>& w, vector<bool>& was, ll mx, ll cnt, ll p) {
	if (i == v.size() - 1) {
		ans = min(ans, cnt);
		re;
	}

	if (was[i]) {
		for (auto j : v[i]) {
			if (!was[j.first]) {
				ll need = max(0ll, v[i][0].second - p);
				ll t_cnt = cnt + (need + mx - 1) / mx;
				ll t_p = p + ((need + mx - 1) / mx) * mx - j.second;

				dfs(j.first, v, w, was, mx, t_cnt, t_p);
			}
		}

		re;
	}

	mx = max(w[i], mx);
	was[i] = true;
	for (auto j : v[i]) {
		ll need = max(0ll, j.second - p);
		ll t_cnt = cnt + (need + mx - 1) / mx;
		ll t_p = p + ((need + mx - 1) / mx) * mx - j.second;

		dfs(j.first, v, w, was, mx, t_cnt, t_p);
	}
	was[i] = false;
}

void solve3(int n, int m, ll p, vector<vector<pair<int, ll>>>& v, vector<ll>& w) {
	vector<bool> was(n);
	dfs(0, v, w, was, 0, 0, p);

	if (ans < 1e12)cout << ans;
	else cout << -1;
}

int main() {
	preproc; fast_io;

	ll n, m, p, g; cin >> n >> m >> p >> g;
	vector<ll> w(n);
	cin >> w;
	vector<vector<pair<int, ll>>> v(n);

	fori(m) {
		ll a, b, c;
		cin >> a >> b >> c; 
		v[a - 1].push_back({ b - 1, c });
	}
	if (g == 1) solve1(n, m, p, v);
	if (g == 2) solve2(n, m, p, v, w);
	else solve3(n, m, p, v, w);
}