#include <iostream>
#include <set>
#include <vector>
#include <string>
#include <tuple>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

const int INF = 2e9;


template<typename T>
istream &operator>>(istream &in, pair<T, T> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (T &value: v) {
        out << value << " ";
    }
    return out;
}


int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    cin >> w;
    vector<vector<pair<int, int>>> g(n);
    loop(m) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a].emplace_back(b, s);
    }
    if (group == 1) {
        set<pair<int, int>> q;
        vector<int> min_dist(n, INF);
        q.insert({0, 0});
        while (!q.empty()) {
            auto [v, d] = *q.begin();
            q.erase(q.begin());
            for (auto [u, s] : g[v]) {
                if (min_dist[u] > d + s) {
                    q.erase({min_dist[u], u});
                    min_dist[u] = d + s;
                    q.insert({min_dist[u], u});
                }
            }
        }
        if (min_dist[n - 1] == INF) {
            cout << -1 << endline;
        } else {
            cout << max(0, min_dist[n - 1] - p) << endline;
        }
    }
}