#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5+7;
const long long inf = 1e18+7;
int n, m, p, g;
bool used[maxn];
long long d[maxn];

struct edge
{
    int ver, dist;
    edge() {}
    edge(int vr, int dst)
    {
        ver = vr;
        dist = dst;
    }
    bool operator <(const edge &ed)const
    {
        return dist > ed.dist;
    }
};

vector<edge>v[maxn];

void dijkstra(int s)
{
    for(int i = 0; i<=n; ++i)
    {
        used[i] = 0;
        d[i] = inf;
    }
    d[s] = 0;
    priority_queue<edge> q;
    q.push({s, 0});
    while(!q.empty())
    {
        edge u = q.top();
        q.pop();
        if(u.dist <= d[u.ver])
        {
            if(!used[u.ver])
            {
                used[u.ver] = true;
                int sz = v[u.ver].size();
                for(int i = 0; i<sz; ++i)
                {
                    edge nb = v[u.ver][i];
                    if(nb.dist + u.dist < d[nb.ver])
                    {
                        nb.dist = nb.dist + u.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void read()
{
    cin>>n>>m>>p>>g;
    for(int i = 1; i<=n; ++i)
    {
        int w;
        cin>>w;
    }
    for(int i = 1; i<=m; ++i)
    {
        int a, b, s;
        cin>>a>>b>>s;
        v[a].push_back({b, s});
        v[b].push_back({a, s});
    }
    dijkstra(1);
    if(d[n] != inf)
    {
        if(d[n] > p) cout<<d[n] - p<<endl;
        else cout<<0<<endl;
    }
    else cout<<-1<<endl;
}

int main()
{
    read();
    return 0;
}
