#include<bits/stdc++.h>
#define endl '\n'
#define ll long long
using namespace std;

const int MAXN=805;
const ll INF=1e18+5;

struct Edge
{
    ll v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};
bool operator< (Edge a,Edge b)
{
    return a.w>b.w;
}

ll n,m,p,g;
ll a[MAXN];
vector<Edge> adj[MAXN];
ll d[MAXN];
priority_queue<Edge> pq;
bool used[MAXN];
vector<int> path;
int vis[MAXN];
ll mx[MAXN];
ll ans=INF;

void FordBellman(int s)
{
    for(int i=1;i<=n;i++) d[i]=INF;
    d[s]=0;
    for(int i=0;i<adj[s].size();i++) d[adj[s][i].v]=adj[s][i].w;
    for(int i=0;i<n-2;i++)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<adj[i].size();j++)
            {
                if(d[i]+adj[i][j].w<d[adj[i][j].v])
                {
                    d[adj[i][j].v]=d[i]+adj[i][j].w;
                }
            }
        }
    }
}

bool cmp(Edge a,Edge b)
{
    if(a.v==b.v) return a.w<b.w;
    return a.v<b.v;
}

int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

cin>>n>>m>>p>>g;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<m;i++)
{
    ll u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back(Edge(v,w));
}

if(g==1)
{
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
   for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
        for(int j=1;j<adj[i].size();j++)
        {
            if(adj[i][j].v==adj[i][j-1].v)
            {
                adj[i].erase(adj[i].begin()+j);
                j--;
            }
        }
    }
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
    FordBellman(1);
    if(d[n]==INF) cout<<-1<<endl;
    else cout<<max(0LL, d[n]-p)<<endl;
    return 0;
}

if(g==2)
{
    int last=a[1];
    ll currM=p;
    ll currS=0;
    ll ans=0;
    for(int i=2;i<=n;i++)
    {
        currS+=adj[i-1][0].w;
        if(a[i]>last || i==n)
        {
            if(currS>currM)
            {
                ll tmp=(currS-currM+last-1)/last;
                ans+=tmp;
                currM=currM+tmp*last-currS;
                currS=0;
            }
            else
            {
                currM-=currS;
                currS=0;
            }
            last=a[i];
        }
    }
    cout<<ans<<endl;
    return 0;
}

return 0;
}
