/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 810;
const ll inf = 1e18;

struct edge
{
    int u;
    ll s;

    edge(int _u = 0, ll _s = 0)
    {
        u = _u;
        s = _s;
    }

    bool operator < (const edge &e) const
    {
        return s > e.s;
    }
};

vector < edge > graph[maxn];
int n, m, p, g, used[maxn];
ll d[maxn], w[maxn];

void djikstra()
{
    for (int i = 1; i <= n; i ++)
    {
        d[i] = inf;
        used[i] = 0;
    }

    d[1] = 0;
    priority_queue < edge > q;
    q.push(edge(1, 0));
    while(!q.empty())
    {
        edge cur = q.top();
        q.pop();
        if (!used[cur.u])
        {
            used[cur.u] = 1;
            for (int i = 0; i < graph[cur.u].size(); i ++)
            {
                edge ed = graph[cur.u][i];
                ed.s += cur.s;
                if (ed.s < d[ed.u])
                {
                    d[ed.u] = ed.s;
                    q.push(ed);
                }
            }
        }
    }
}

void solve_first_subtask()
{

    int v, u;
    ll s;
    for (int i = 1; i <= m; i ++)
    {
        cin >> v >> u >> s;
        edge e(u, s);
        graph[v].push_back(e);
    }

    djikstra();

    if (d[n] == inf)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << d[n] - p << endl;
    }

}
void solve()
{
    cin >> n >> m >> p >> g;
    for (int i = 1; i <= n; i ++)
        cin >> w[i];
    if (g == 1)
    {
        solve_first_subtask();
    }

}

int main()
{
    solve();
    return 0;
}
/*
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
*/
