/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 810;
const ll inf = 1e18;

struct edge
{
    int u;
    ll s;

    edge(int _u = 0, ll _s = 0)
    {
        u = _u;
        s = _s;
    }

    bool operator < (const edge &e) const
    {
        return s > e.s;
    }
};

vector < edge > graph[maxn];
int n, m, p, g, used[maxn];
ll d[maxn], w[maxn];

void djikstra()
{
    for (int i = 1; i <= n; i ++)
    {
        d[i] = inf;
        used[i] = 0;
    }

    d[1] = 0;
    priority_queue < edge > q;
    q.push(edge(1, 0));
    while(!q.empty())
    {
        edge cur = q.top();
        q.pop();
        if (!used[cur.u])
        {
            used[cur.u] = 1;
            for (int i = 0; i < graph[cur.u].size(); i ++)
            {
                edge ed = graph[cur.u][i];
                ed.s += cur.s;
                if (ed.s < d[ed.u])
                {
                    d[ed.u] = ed.s;
                    q.push(ed);
                }
            }
        }
    }
}

void solve_first_subtask()
{

    int v, u;
    ll s;
    for (int i = 1; i <= m; i ++)
    {
        cin >> v >> u >> s;
        edge e(u, s);
        graph[v].push_back(e);
    }

    djikstra();

    if (d[n] == inf)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << max((ll)0, d[n] - p) << endl;
    }

}

ll price[maxn], nxt[maxn];
void solve_second_subtask()
{
    int v, u;
    ll s;
    for (int i = 1; i <= m; i ++)
    {
        cin >> v >> u >> s;
        price[i] = s;
        edge e(u, s);
        graph[v].push_back(e);
    }
    w[n] = inf;
    stack < int > st;
    st.push(n);
    for (int i = n - 1; i >= 0; i --)
    {
        while(w[st.top()] <= w[i])
            st.pop();
            nxt[i] = st.top();
        st.push(i);
    }

    ll ans = 0;
    int pos = 1;
    while(pos != n)
    {
        ll cost = 0;
        for (int i = pos; i < nxt[pos]; i ++)
        {
            cost = cost + price[i];
        }

        if (cost <= p)
        {
            p -= cost;
            pos = nxt[pos];
            continue;
        }

        ll nec = cost - p;
        ll trips = nec / w[pos];
        if (nec % w[pos] != 0)
            trips ++;
        ans = ans + trips;
        p = p + trips * w[pos] - cost;
        pos = nxt[pos];
    }

    cout << ans << endl;

}
void solve()
{
    cin >> n >> m >> p >> g;
    for (int i = 1; i <= n; i ++)
        cin >> w[i];
    if (g == 1)
    {
        solve_first_subtask();
    }
    else
    if (g == 2)
    {
        solve_second_subtask();
    }

}

int main()
{
    solve();
    return 0;
}
/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50


*/
