#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 800;
const long long INF = 1000000000000000001;

int n, m, g;
long long p;
long long s[MAXN + 5];
long long ww[MAXN + 5];
long long dist[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

void Dijkstra()
{
    for (int i = 1; i <= n; ++ i)
    {
        dist[i] = INF;
    }

    dist[1] = 0;
    priority_queue< pair<int, int> > pq;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int u = pq.top().second, d = -pq.top().first;
        pq.pop();
        if (d > dist[u]) continue;
        for (auto [v, w] : G[u])
        {
            if (dist[u] + w < dist[v])
            {
                dist[v] = dist[u] + w;
                pq.push({-dist[v], v});
            }
        }
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> p >> g;

    if (g == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cin >> ww[i];
        }
        for (int i = 1; i <= m; ++ i)
        {
            int u, v, w;
            cin >> u >> v >> w;
            G[u].push_back({v, w});
        }

        Dijkstra();

        if (dist[n] == INF) cout << -1 << endl;
        else cout << max(0ll, dist[n] - p) << endl;
    }

    if (g == 2)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cin >> ww[i];
        }

        for (int i = 1; i <= m; ++ i)
        {
            int u, v;
            cin >> u >> v >> s[i];
        }

        long long cnt = 0, mx = 0;
        for (int i = 1; i <= n; ++ i)
        {
            mx = max(mx, ww[i]);
            if (s[i] > p)
            {
                long long t = (s[i] - p - 1) / mx + 1;
                cnt += t;
                p += t * mx;
            }
            p -= s[i];
        }
        cout << cnt << endl;
    }

    return 0;
}
