#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

vector<ll> w;

bool cmp(ll a, ll b) {
    return w[a] < w[b];
}

tuple<ll, ll, ll> min(tuple<ll, ll, ll> a, tuple<ll, ll, ll> b) {
    if (get<0>(a) == get<0>(b) && get<1>(a) == get<1>(b)) {
        if (get<2>(a) < get<2>(b))
            return a;
        else
            return b;
    }
    if (get<0>(a) == get<0>(b)) {
        if (get<1>(a) < get<1>(b))
            return a;
        else
            return b;
    }
    if (get<0>(a) < get<0>(b))
        return a;
    else
        return b;
}

void solve() {
    ll n, m, p, G;
    cin >> n >> m >> p >> G;
    w.resize(n);
    for (ll &i: w)
        cin >> i;
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> dist(n, vector<ll>(n, 1e13));
    for (int i = 0; i < n; i++)
        dist[i][i] = 0;
    for (ll i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        g[a].push_back({b, w});
        dist[a][b] = min(dist[a][b], w);
    }
    for (ll q = 0; q < n; q++) {
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][q] + dist[q][j]);
            }
        }
    }
    vector<tuple<ll, ll, ll>> ans(n, {1e13, 1e13, 1e13});
    ans[0] = {0, w[0], p};
    vector<ll> ndx(n);
    for (ll i = 0; i < n; i++)
        ndx[i] = i;
    sort(ndx.begin(), ndx.end(), cmp);
    for (ll i: ndx) {
        auto[d, pl, p] = ans[i];
        for (ll j = 0; j < n; j++) {
            if (dist[i][j] > p)
                ans[j] = min(ans[j], tuple<ll, ll, ll>{d + (dist[i][j] - p + pl - 1) / pl, w[j],
                                                       (pl - (dist[i][j] - p) % pl) % pl});
            else
                ans[j] = min(ans[j], tuple<ll, ll, ll>{d, w[j], p - dist[i][j]});
        }
    }
    if (get<0>(ans[n - 1]) > 1e9)
        get<0>(ans[n - 1]) = -1;
    cout << get<0>(ans[n - 1]);


}