#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

vector<ll> dist1(ll s, vector<vector<pair<ll, ll>>> &g) {
    vector<ll> d(g.size(), 1e18);
    d[s] = 0;
    set<pair<ll, ll>> k{{0, s}};
    while (!k.empty()) {
        auto[di, x] = *k.begin();
        k.erase(k.begin());
        for (auto[i, w]: g[x]) {
            if (d[i] > d[x] + w) {
                k.erase({d[i], i});
                d[i] = d[x] + w;
                k.insert({d[i], i});
            }
        }
    }
    return d;
}

void solve() {
    ll n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<ll> w;
    w.resize(n);
    for (ll &i: w)
        cin >> i;
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> dist(n, vector<ll>(n, 1e18));
    for (ll i = 0; i < n; i++)
        dist[i][i] = 0;
    for (ll i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        g[a].push_back({b, w});
        dist[a][b] = min(dist[a][b], w);
    }
    for (ll i = 0; i < n; i++) {
        dist[i] = dist1(i, g);
    }
    vector<pair<ll, ll>> ans(n, {1e18, 0});
    ans[0] = {0, p};
    set<pair<ll, ll>> s;
    vector<bool> is(n);
    is[0] = 1;
    s.insert({0, 0});
    for (ll i = 0; i < n; i++) {
        auto d = ans[i].first;
        auto p1 = ans[i].second;
        for (ll j = i + 1; j < n; j++) {
            if (dist[i][j] >= p1)
                ans[j] = min(ans[j], {d + (dist[i][j] - p1 + w[i] - 1) / w[i],
                                      p1 + ((dist[i][j] - p1 + w[i] - 1) / w[i]) * w[i] - dist[i][j]});
            else
                ans[j] = min(ans[j], {d, p1 - dist[i][j]});
        }
    }
    if (ans[n - 1].first == 1e18)
        cout << -1;
    else
        cout << ans[n - 1].first;

}