#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;

ll n;
vector<vector<ll>> a;

bool cmp(ll cur1, ll cur2) {
	if (a[cur1][0] == a[cur2][0])
		return a[cur1].back() == a[cur2].back();
	return a[cur1][0] < a[cur2][0];
}

struct edge {
	ll cur, next, w;
};

bool operator<(edge A, edge B) {
	return A.cur < B.cur;
}

const ll MAXN = 2e5 + 10;

ll tree[4 * MAXN];
ll push[4 * MAXN];

void Push(ll v) {
	if (2 * v + 2 < 4 * MAXN) {
		push[v * 2 + 1] = max(push[v * 2 + 1], push[v]);
		push[v * 2 + 2] = max(push[v * 2 + 2], push[v]);
	}
	tree[v] = max(push[v], tree[v]);
	push[v] = 0;
}

void upd(ll v, ll l, ll r, ll ql, ll qr, ll x) {
	Push(v);
	if (ql <= l && r <= qr) {
		push[v] += x;
		Push(v);
		return;
	}
	if (qr <= l || r <= ql) {
		return;
	}
	ll mid = (l + r) / 2;
	upd(v * 2 + 1, l, mid, ql, qr, x);
	upd(v * 2 + 2, mid, r, ql, qr, x);
	tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

ll rs(ll v, ll l, ll r, ll i) {
	Push(v);
	if (l + 1 == r) {
		return tree[v];
	}
	ll mid = (l + r) / 2;
	if (i < mid) {
		return rs(v * 2 + 1, l, mid, i);
	}
	else {
		return rs(v * 2 + 2, mid, r, i);
	}
}

int main() {
	ll x;
	cin >> n;
	a.assign(n, {});
	vector<edge> ind;
	for (ll i = 0; i < n; i++) {
		ll k;
		cin >> k;
		cin >> x;
		a[i].push_back(x);
		for (ll j = 1; j < k; j++) {
			cin >> x;
			if (a[i].back() < x) {
				a[i].push_back(x);
			}
		}
		ll cnt = a[i].size();
		for (auto elem : a[i]) {
			ind.push_back({ elem, a[i].back() + 1, cnt });
			cnt--;
		}
	}
	sort(ind.begin(), ind.end());
	vector<ll> ans;
	for (edge cur : ind) {
		ll w = rs(0, 0, MAXN, cur.cur) + cur.w;
		ans.push_back(w);
		upd(0, 0, MAXN, cur.next, MAXN, w);
	}
	ans.push_back(rs(0, 0, MAXN, MAXN - 1));
	cout << ans.back();
}

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1

4
2
3 4
2
1 8
2
2 8
2
7 9
*/