#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

void update(vector<ll> &t, ll i, ll x, ll v, ll vl, ll vr) {
    if (i < vl || vr <= i) return;
    if (vl + 1 == vr) t[i] = x;
    else {
        ll vm = (vl + vr) / 2;
        update(t, i, x, LC(v), vl, vm);
        update(t, i, x, RC(v), vm, vr);
        t[v] = max(t[LC(v)], t[RC(v)]);
    }
}

ll query(const vector<ll> &t, ll l, ll r, ll v, ll vl, ll vr) {
    if (r <= vl || vr <= l) return -INF;
    if (l <= vl && vr <= r) return t[v];
    else {
        ll vm = (vl + vr) / 2;
        ll x = query(t, l, r, LC(v), vl, vm);
        ll y = query(t, l, r, RC(v), vm, vr);
        return max(x, y);
    }
}

const ll N = 200000;

int main() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    for (auto &b: a) {
        ll k;
        cin >> k;
        b.resize(k);
        for (ll &e: b) cin >> e;
        vector<ll> b1;
        for (ll e: b) if (b1.empty() || e > b1.back()) b1.push_back(e);
        b = b1;
    }
    sort(a.begin(), a.end(), [](const vector<ll> &a, const vector<ll> &b) -> bool {
        return a.back() < b.back();
    });
    vector<ll> d(N + 1);
    for (ll i = 0; i < n; i++) {
        ll e = a[i].back();
        d[e] = max(d[e], ll(a[i].size()));
        for (ll pos = 0; pos < ll(a[i].size()); pos++) {
            for (ll e0 = 0; e0 < a[i][pos]; e0++) {
                d[e] = max(d[e], d[e0] + ll(a[i].size() - pos));
            }
        }
    }
    cout << *max_element(d.begin(), d.end()) << '\n';
}