use std::io::{self, prelude::*};

fn solve<R: BufRead, W: Write>(scan: &mut Scanner<R>, w: &mut W) -> io::Result<()> {
    let n = scan.token();
    let albs = (0..n)
        .map(|_| {
            (0..scan.token())
                .map(|_| scan.token())
                .collect::<Vec<i32>>()
        })
        .collect::<Vec<_>>();

    let mut albs = albs
        .iter()
        .map(|alb| {
            alb.iter()
                .scan(i32::MIN, |max, &x| {
                    if x > *max {
                        *max = x;
                        Some(Some(x))
                    } else {
                        Some(None)
                    }
                })
                .flatten()
                .collect::<Vec<_>>()
        })
        .collect::<Vec<_>>();
    albs.sort_unstable_by_key(|a| a.last().cloned());
    let ans: usize = albs.into_iter().scan(i32::MIN, |end, alb| {
        let prend = *end;
        *end = *alb.last().unwrap();
        Some(alb.into_iter().filter(|&x| x > prend).count())
    }).sum();

    writeln!(w, "{ans}")
}

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());
    solve(&mut scan, &mut w)
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
