use std::{
    collections::BTreeMap,
    io::{self, prelude::*},
};

fn solve<R: BufRead, W: Write>(scan: &mut Scanner<R>, w: &mut W) -> io::Result<()> {
    let n = scan.token();
    let albs = (0..n)
        .map(|_| {
            (0..scan.token())
                .map(|_| scan.token())
                .collect::<Vec<i32>>()
        })
        .collect::<Vec<_>>();

    let albs = albs
        .into_iter()
        .map(|alb| {
            alb.into_iter().fold(vec![], |mut acc, x| {
                if acc.is_empty() || acc.last() < Some(&x) {
                    acc.push(x);
                }
                acc
            })
        })
        .collect::<Vec<_>>();
    let mut ends = BTreeMap::new();
    ends.insert(0, vec![]);
    for alb in albs {
        ends.entry(*alb.last().unwrap()).or_insert(vec![]).push(alb);
    }

    let ends = ends.into_iter().collect::<Vec<_>>();
    let mut ans: usize = 0;
    for i in 1..ends.len() {
        let mut cur = 0;
        for j in &ends[i].1 {
            let cnt = j.iter().filter(|&&x| x > ends[i - 1].0).count();
            cur = cur.max(cnt);
        }
        ans += cur;
    }

    writeln!(w, "{ans}")
}

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());
    solve(&mut scan, &mut w)
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
