#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

void solve() {
	ll n;
	std::cin >> n;
	v<v<ll>> list(n);
	ll max = 0, maxk = 0;
	for (int i = 0; i < n; ++i) {
		ll k;
		std::cin >> k;
		maxk = std::max(k, maxk);
		for (int j = 0; j < k; ++j) {
			ll now;
			std::cin >> now;
			if (list[i].empty() || now > list[i].back()) {
				list[i].push_back(now);
			}
			max = std::max(max, now);
		}
	}
	std::sort(all(list), [](const v<ll>& a, const v<ll>& b) {
		return a.back() < b.back();
		});
	v<ll> dp(n + 1, 0);
	dp[0] = 0;
	ll ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (j != 0) {
				dp[i] = std::max(dp[i], dp[j] + (ll)list[i - 1].size() - (std::upper_bound(all(list[i - 1]), list[j - 1].back()) - list[i - 1].begin()));
			}
			else {
				dp[i] = std::max(dp[i], (ll)list[i - 1].size());
			}
		}
	}
	for (int i = 0; i <= n; ++i) {
		ans = std::max(ans, dp[i]);
	}
	std::cout << ans;
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}