#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

struct node {
    int val;

    node (int val = 0) {
        this->val = val;
    }
};

node merge(node a, node b) {
    if (a.val > b.val) {
        return a;
    }
    return b;
}

struct segtree {
    int n;
    vector<node> tree;
    vector<int> a;
    int iq, xq;
    int lq, rq;

    segtree (vector<int> v) {
        n = v.size();
        a = v;
        tree.resize(n * 4);
        build();
    }

    void build() {
        build(0, 0, n);
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v].val = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    void update(int i, int x) {
        iq = i;
        xq = x;
        upd(0, 0, n);
    }

    void upd(int v, int l, int r) {
        if (l > iq || r <= iq) {
            return;
        }
        if (r - l == 1) {
            tree[v].val = xq;
            return;
        }
        int m = (l + r) / 2;
        upd(v * 2 + 1, l, m);
        upd(v * 2 + 2, m, r);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    int get(int l, int r) {
        lq = l;
        rq = r;
        return get(0, 0, n).val;
    }

    node get(int v, int l, int r) {
        if (l >= rq || r <= lq) {
            return node();
        }
        if (lq <= l && r <= rq) {
            return tree[v];
        }
        int m = (l + r) / 2;
        auto la = get(v * 2 + 1, l, m);
        auto ra = get(v * 2 + 2, m, r);
        return merge(la, ra);
    }
};

int n;

bool cmp(vector<int> a, vector<int> b) {
    return a.back() < b.back();
}

void solve() {
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> w(k);
        for (int j = 0; j < k; ++j) {
            cin >> w[j];
        }
        int mx = -1;
        for (int j = 0; j < k; ++j) {
            if (w[j] > mx) {
                v[i].push_back(w[j]);
            }
            mx = max(mx, w[j]);
        }
    }
    vector<int> ans(2e5 + 1, 0);
    segtree pref_ans(ans);
    sort(v.begin(), v.end(), cmp);
    for (int i = 0; i < n; ++i) {
        int x = v[i].back();
        for (int j = v[i].size() - 1; j >= 0; --j) {
            ans[x] = max(ans[x], pref_ans.get(0, v[i][j]));
        }
        ans[x] += 1;
        pref_ans.update(x, ans[x]);
    }
    int mx = 1;
    for (auto i : ans) {
        mx = max(mx, i);
    }
    cout << mx;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}
