#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7;
const ld eps = 1e-9;

struct segment_tree {
	vector<ll> promise;
	vector<ll> sum;
	ll sz = 1;
	void dub(ll n) {
		while (sz < n) sz *= 2;
	}
	segment_tree(vector<ll>& arr) {
		dub(arr.size());
		sum.resize(2 * sz);
		promise.resize(2 * sz);
		build(1, 0, sz, arr);
	}
	void build(ll id, ll l, ll r, vector<ll>& arr) {
		if (r - l == 1 && l < arr.size()) {
			sum[id] = arr[l];
			return;
		}
		if (r - l == 1) {
			sum[id] = INF;
			return;
		}
		ll m = (r + l) / 2;
		build(2 * id, l, m, arr);
		build(2 * id, m, r, arr);
		sum[id] = min(sum[2 * id], sum[2 * id + 1]);
	}
	void push(ll id, ll l, ll r) {
		sum[id] += promise[id];
		if (r - l > 1) {
			promise[2 * id] += promise[id];
			promise[2 * id] += promise[id];
		}
		promise[id] = 0;
	}
	void upd(ll id, ll l, ll r, ll l_q, ll r_q, ll val) {
		push(id, l, r);
		if (l_q <= l && r <= r_q) {
			promise[id] += val;
			push(id, l, r);
			return;
		}
		if (l_q >= r || l >= r_q) return;
		
	}
};


vector<vector<ll>> help;


ll count(ll l, ll r) {
	return help[l].size() + help[r].size() - (upper_bound(help[r].begin(), help[r].end(), help[l].back()) - help[r].begin());
}
bool f(ll l, ll r) {
	if (count(l, r) > count(r, l)) return true;
	return false;
}

signed main() {
	ll n; cin >> n;
	vector<vector<ll>> help(n);
	for (ll x = 0; x < n; x++) {
		ll k; cin >> k;
		ll maxi = -1;
		for (ll i = 0; i < k; i++) {
			ll a; cin >> a;
			if (maxi < a) help[x].push_back(a);
			maxi = max(maxi, a);
		}
	}
	ll kmax = 10 + 2;
	vector<ll> dp(kmax);
	dp[kmax - 1] = 0;
	for (ll x = kmax - 2; x > -1; x--) {
		for (ll i = 0; i < n; i++) {
			if (help[i].back() <= x) continue;
			dp[x] = max(dp[x], dp[help[i].back()] + (help[i].end() - lower_bound(help[i].begin(), help[i].end(), x)));
		}
	}
	cout << dp[0];
}
 