#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

bool comp(vector<long long> a, vector<long long> b) {
    return a[a.size() - 1] < b[b.size() - 1];
}

void sol2(long long n, vector<vector<long long>> v) {
    vector<long long> dp(12, 0);
    for (int i = 1; i <= n; i++) {
        long long id = v[i][v[i].size() - 1];
        for (int j = 0; j < 11; j++) {
            long long t = upper_bound(v[i].begin(), v[i].end(), j) - v[i].begin();
            t = v[i].size() - t;
            dp[id] = max(dp[id], dp[j] + t);
        }
    }
    long long mx = 0;
    for (int i = 0; i < 11; i++) {
        mx = max(mx, dp[i]);
    }
    cout << mx << endl;
    exit(0);
}

int main()
{
    long long n;
    cin >> n;
    vector<vector<long long>> v(n + 1);
    v[0] = {0};
    for (int i = 1; i <= n; i++) {
        long long k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            long long a;
            cin >> a;
            if (v[i].size() == 0 || v[i][v[i].size() - 1] < a) {
                v[i].push_back(a);
            }
        }
    }
    sort(v.begin(), v.end(), comp);
    if (n > 1000) {
        sol2(n, v);
    }

    /*for (auto i : v) {
        for (auto j : i) {
            cout << j << " ";
        } cout << endl;
    } cout << endl;*/
    vector<long long> dp(n + 1, 0);
    vector<long long> mx(n + 1);
    dp[0] = 0;
    mx[0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            long long t = upper_bound(v[i].begin(), v[i].end(), mx[j]) - v[i].begin();
            t = v[i].size() - t;
            //cout << i << " " << t << endl;
            if (t + dp[j] > dp[i]) {
                dp[i] = t + dp[j];
                mx[i] = max(mx[j], v[i][v[i].size() - 1]);
            }
        }
    }
    /*for (auto i : dp) {
        cout << i << " ";
    } cout << endl;
    for (auto i : mx) {
        cout << i << " ";
    } cout << endl;*/
    long long ans = 0;
    for (int i = 0; i <= n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;


    return 0;
}

