#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

bool comp(vector<long long> a, vector<long long> b) {
    return a[a.size() - 1] < b[b.size() - 1];
}

struct tree{
    vector<long long> tr;
    vector<long long> res;

    void build(long long id, long long l, long long r) {
        if (r - l == 1) {
            tr[id] = 0;
            return;
        }
        long long mid = (l + r) / 2;
        build(id * 2 + 1, l, mid);
        build(id * 2 + 2, mid, r);
        tr[id] = 0;
    }

    tree(long long n) {
        tr.resize(4 * n);
        res.resize(n);
    }

    void change(long long id, long long l, long long r, long long i, long long x) {
        if (r - l == 1) {
            tr[id] = max(tr[id], x);
            res[l] = tr[id];
            return;
        }
        long long mid = (l + r) / 2;
        if (i < mid) {
            change(id * 2 + 1, l, mid, i, x);
        } else {
            change(id * 2 + 2, mid, r, i, x);
        }
        tr[id] = max(tr[id * 2 + 1], tr[id * 2 + 2]);
    }

    long long ask(long long id, long long l, long long r, long long ql, long long qr) {
        if (ql <= l && r <= qr) {
            return tr[id];
        }
        if (r <= ql || qr <= l) {
            return 0;
        }
        long long mid = (l + r) / 2;
        return max(ask(id * 2 + 1, l, mid, ql, qr), ask(id * 2 + 2, mid, r, ql, qr));
    }
};

void sol2(long long n, vector<vector<long long>> v) {
    vector<long long> dp(12, 0);
    for (int i = 1; i <= n; i++) {
        long long id = v[i][v[i].size() - 1];
        for (int j = 0; j < 11; j++) {
            long long t = upper_bound(v[i].begin(), v[i].end(), j) - v[i].begin();
            t = v[i].size() - t;
            dp[id] = max(dp[id], dp[j] + t);
        }
    }
    long long mx = 0;
    for (int i = 0; i < 11; i++) {
        mx = max(mx, dp[i]);
    }
    cout << mx << endl;
    exit(0);
}

void sol3(long long n, vector<vector<long long>> v){
    /*for (auto i : v) {
        for (auto j : i) {
            cout << j <<  " ";
        } cout << endl;
    }*/
    long long maxa = 0;
    for (int i = 0; i <= n; i++) {
        maxa = max(maxa, v[i][v[i].size() - 1]);
    }
    tree tr(maxa + 2);
    for (int i = 1; i <= n; i++) {
        if (v[i].size() == 1) {
            long long t = tr.ask(0, 0, maxa + 2, 0, v[i][0]) + 1;
            tr.change(0, 0, maxa + 2, v[i][0], t);
        } else {
            long long t = tr.ask(0, 0, maxa + 2, 0, v[i][1]) + 1;
            tr.change(0, 0, maxa + 2, v[i][1], t);
            t = tr.ask(0, 0, maxa + 2, 0, v[i][0]) + 2;
            tr.change(0, 0, maxa + 2, v[i][1], t);
        }
        /*for (auto j : tr.res) {
            cout << j << " ";
        } cout << endl;*/

    }
    cout << tr.ask(0, 0, maxa, 0, maxa);
    exit(0);
}
int main()
{
    long long n;
    cin >> n;
    vector<vector<long long>> v(n + 1);
    v[0] = {0};
    bool fl = true;
    for (int i = 1; i <= n; i++) {
        long long k;
        cin >> k;
        if (k > 3) {
            fl = false;
        }
        for (int j = 0; j < k; j++) {
            long long a;
            cin >> a;
            if (v[i].size() == 0 || v[i][v[i].size() - 1] < a) {
                v[i].push_back(a);
            }
        }
    }
    sort(v.begin(), v.end(), comp);
    if (n > 1000) {
        if (fl) {
            sol3(n, v);
        }
        sol2(n, v);
    }

    /*for (auto i : v) {
        for (auto j : i) {
            cout << j << " ";
        } cout << endl;
    } cout << endl;*/
    vector<long long> dp(n + 1, 0);
    vector<long long> mx(n + 1);
    dp[0] = 0;
    mx[0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            long long t = upper_bound(v[i].begin(), v[i].end(), mx[j]) - v[i].begin();
            t = v[i].size() - t;
            //cout << i << " " << t << endl;
            if (t + dp[j] > dp[i]) {
                dp[i] = t + dp[j];
                mx[i] = max(mx[j], v[i][v[i].size() - 1]);
            }
        }
    }
    /*for (auto i : dp) {
        cout << i << " ";
    } cout << endl;
    for (auto i : mx) {
        cout << i << " ";
    } cout << endl;*/
    long long ans = 0;
    for (int i = 0; i <= n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;


    return 0;
}


