#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

struct SegmentTree {
    vector<int> tree;
    int n;

    void upd(int v, int val) {
        v += n;
        rmax(tree[v], val);

        for (; v > 1; v >>= 1) {
            tree[v >> 1] = max(tree[v], tree[v ^ 1]);
        }
    }

    int get(int l, int r) {
        int ans = 0;

        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                rmax(ans, tree[l++]);
            }

            if (r & 1) {
                rmax(ans, tree[--r]);
            }
        }

        return ans;
    }

    void init(int n) {
        this->n = n;
        tree.assign(2 * n, 0);
    }
};

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> my(n);
    vector<int> max_el(n);

    SegmentTree dp;
    dp.init(3e5);
    vector<vector<int>> ask(3e5);
    int mx_vl = 0;

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        my[i].resize(k);
        cin >> my[i];

        int val = my[i][0];
        vector<int> ans;

        ans.emplace_back(val);

        for (int &it : my[i]) {
            if (rmax(val, it)) {
                ans.emplace_back(it);
            }
        }

        my[i] = ans;
        rmax(mx_vl, ans.back());
        ask[ans.back()].push_back(i);

        reverse(all(my[i]));
    }

    for (int i = 1; i <= 2e5; i++) {
        int val = 0;
        for (int &it : ask[i]) {
            int cnt = 1;
            for (int &x1 : my[it]) {
                rmax(val, dp.get(0, x1) + cnt++);
            }
        }

        dp.upd(i, val);
    }

    cout << dp.get(0, 3e5) << endl;
}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}

