#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u: v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u: v) {
        os << u << ' ';
    }
    return os;
}

struct segtree {
    int n;
    vector<int> tree;

    segtree() {}

    segtree(int _n) {
        n = _n;
        tree.resize(2 * n, 0);
    }

    void set(int i, int v) {
        i += n;
        tree[i] = v;
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    int get(int l, int r) {
        l += n;
        r += n;
        int ans = 0;
        while (l <= r) {
            if (l % 2 == 1) {
                ans = max(ans, tree[l]);
                l += 1;
            }
            if (r % 2 == 0) {
                ans = max(ans, tree[r]);
                r -= 1;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

//const int N = 200;
const int N = 200'001;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    segtree sgt;
    vector<vector<int>> ans(n);

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
        int mx = 0;
        for (int j = 1; j < k; ++j) {
            if (a[i][j] > a[i][mx]) {
                mx = j;
            }
        }
        a[i].resize(mx + 1);
        ans[i].resize(a[i].size());
    }

    map<int, vector<int>> m;

    sgt = segtree(N + 1);

    for (int i = 0; i < n; ++i) {
        m[a[i].back()].push_back(i);
        for (int j = ((int) a[i].size()) - 1; j >= 0; --j) {
            sgt.set(a[i][j], sgt.get(a[i][j] + 1, N) + 1);
        }
        for (int j = 0; j < a[i].size(); ++j) {
            ans[i][j] = sgt.get(a[i][j], a[i][j]);
        }
        for (int j = 0; j < a[i].size(); ++j) {
            sgt.set(a[i][j], 0);
        }
    }

    vector<int> dp(N + 1);

    for (int i = 1; i < N + 1; ++i) {
        dp[i] = dp[i - 1];

        for (auto elem : m[i]) {
            for (int j = 0; j < a[elem].size(); ++j) {
                dp[i] = max(dp[i], dp[a[elem][j] - 1] + ans[elem][j]);
            }
        }
    }

    cerr << dp << '\n';
    cout << dp.back() << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day1/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}