#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int pw = 345;
int mod = 1e9 + 9;

int add(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}

int sub(int a, int b) {
    a -= b;
    if ( a < 0) a += mod;
    return a;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

struct hashing {
    vector<int> hsh;

    void build(vector<int> a) {
        int n = a.size();
        hsh.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            hsh[i + 1] = add(mul(hsh[i], pw), a[i]);
        }
    }

    int& operator[](int i) {
        return hsh[i];
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<hashing> hsh(n);
    for (int c = 0; c < n; ++c) {
        int k;
        cin >> k;
        vector<int> x(k);
        for (int i = 0; i < k; ++i) cin >> x[i];
        for (int i = 1; i < k; ++i) x[i] = max(x[i], x[i - 1]);
        x.resize(unique(all(x)) - x.begin());
        reverse(all(x));
        hsh[c].build(x);
        a[c] = x;
    }
    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int i, int j) -> bool {
        int l = 0, r = min(a[i].size(), a[j].size()) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (hsh[i][m] == hsh[j][m]) l = m;
            else r = m;
        }
        if (l == min(a[i].size(), a[j].size())) {
            return a[i].size() > a[j].size();
        }
        return a[i][l] < a[j][l];
    });
    int ans = 0;
    int mx = 0;
    for (auto i : p) {
        reverse(all(a[i]));
        for (auto j : a[i]  ) if (j > mx) {
            mx = j;
            ++ans;
        }
    }
    cout << ans;
}
