#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;


struct FenwickTree {
    vector<int> tree;
    int size;

    FenwickTree(int n) {
        tree.resize(n);
        size = n;
    }

    void update(int pos, int value) {
        for (int i = pos; i < size; i |= i + 1) {
            tree[i] = max(tree[i], value);
        }
    }

    int query(int pos) {
        int res = 0;
        for (int i = pos; i >= 0; i = (i & (i + 1)) - 1) {
            res = max(res, tree[i]);
        }
        return res;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> a(n);
    vector<vector<int>> b(n);
    vector<int> values = {0};
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (auto& x : a[i]) {
            cin >> x;
            values.push_back(x);
        }
        int curr_max = 0;
        for (auto x : a[i]) {
            if (x > curr_max) {
                b[i].push_back(x);
                curr_max = x;
            }
        }
    }

    sort(values.begin(), values.end());
    values.resize(unique(values.begin(), values.end()) - values.begin());
    int m = values.size();
    map<int, int> mp;
    for (int i = 0; i < m; ++i) {
        mp[values[i]] = i;
    }

    sort(b.begin(), b.end(), [&](const auto& lhs, const auto& rhs) {
        return make_pair(lhs.back(), lhs[0]) < make_pair(rhs.back(), rhs[0]);
    });

    int ans = 0;
    vector<int> dp(n);
    FenwickTree tree(m);
    for (int i = 0; i < n; ++i) {
        int cost = b[i].size();
        for (auto& x : b[i]) {
            x = mp[x];
            dp[i] = max(dp[i], tree.query(x - 1) + cost);
            --cost;
        }
        tree.update(b[i].back(), dp[i]);
        ans = max(ans, dp[i]);
    }
    cout << ans << '\n';

    return 0;
}