#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <climits>
#include <random>
#include <bitset>

using namespace std;

#define int long long
#define endl '\n'

mt19937_64 engine;

const long long mod = 1e9 + 7;
const long double pi = acosl(-1.0);
const long double eps = 1e-10;

long long gcd(long long x, long long y)
{
    if (y == 0) return x;
    return gcd(y, x % y);
}

long long lcm(long long x, long long y)
{
    return x / gcd(x, y) * y;
}

long long binpow(long long x, long long y)
{
    if (y == 0) return 1;
    if (y == 1) return x;
    int f = binpow(x, y / 2);
    if (y % 2 == 0) return (f * f) % mod;
    else return (((f * f) % mod) * f) % mod;
}

vector<int> maxx;

bool cmp(int a, int b)
{
    return maxx[a] < maxx[b];
}

void task()
{
    int n;
    cin >> n;

    vector<vector<int>> v(n);
    maxx.resize(n, -1);

    for (int i = 0; i < n; i++)
    {
        int m;
        cin >> m;
        v[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            cin >> v[i][j];
            maxx[i] = max(maxx[i], v[i][j]);
        }
    }

    vector<int> vv(n);
    for (int i = 0; i < n; i++)
    {
        vv[i] = i;
    }

    sort(vv.begin(), vv.end(), cmp);

    /*int curmax = -1;
    int sum = 0;

    for (int i = 0; i < n; i++)
    {
        int cur = vv[i];
        for (int j = 0; j < v[cur].size(); j++)
        {
            if (v[cur][j] > curmax)
            {
                curmax = v[cur][j];
                sum++;
            }
        }
    }

    cout << sum << endl;*/

    for (int i = 0; i < n; i++)
    {
        vector<int>& a = v[i];
        vector<pair<int, int>> pref(a.size());
        pref[0] = { a[0], 0 };
        for (int j = 1; j < a.size(); j++)
        {
            if (a[j] > pref[j - 1].first) pref[j] = { a[j], j };
            else pref[j] = pref[j - 1];
        }

        vector<int> nv;

        int cur = a.size() - 1;
        while (cur != -1)
        {
            int pos = pref[cur].second;
            nv.push_back(a[pos]);
            cur = pos - 1;
        }
        reverse(nv.begin(), nv.end());
        a = nv;
    }

    vector<vector<int>> nv(n);

    for (int i = 0; i < n; i++)
    {
        nv[i] = v[vv[i]];
    }

    v = nv;

    vector<int> dp(n);
    dp[0] = v[0].size();

    for (int i = 1; i < n; i++)
    {
        dp[i] = v[i].size();
        for (int j = 0; j < i; j++)
        {
            if (v[j].back() == v[i].back()) break;
            int nr = v[j].back();
            int l = -1;
            int r = v[i].size() - 1;
            while (r - l > 1)
            {
                int m = (r + l) / 2;
                if (v[i][m] > nr) r = m;
                else l = m;
            }

            dp[i] = max(dp[i], dp[j] + (int)v[i].size() - r);
        }
    }

    cout << dp[n - 1] << endl;
}

signed main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << fixed << setprecision(15);
    engine.seed(58);

    int t = 1;
    bool multitest = false;
    if (multitest) cin >> t;
    while (t--) task();

    return 0;
}
