#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>
#include <chrono>
#include <cassert>
#include <climits>

using namespace std;

using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
istream& operator>>(istream &in, vector <T> &arr) {
    for (T &i: arr) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream &out, const vector <T> &arr) {
    for (const T &i: arr) out << i << ' ';
    return out;
}

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

//#define int int64_t
//#define multitest

#pragma GCC target("fma")
#pragma GCC optimize("O3")
#pragma GCC optimize("trapv")

const int N  = 2e5 + 5;

vector <int> g[N];

const int mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector <vector <int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
    }

    auto slow = [&] () {
        sort(all(a));
        long long ans = 0;
        do {
            int mx = 0;
            long long cur_ans = 0;
            for (int i = 0; i < n; ++i) {
                for (int j: a[i]) {
                    cur_ans += j > mx;
                    mx = max(mx, j);
                }
            }
            ans = max(cur_ans, ans);
        } while (next_permutation(all(a)));
        return ans;
    };

    cout << slow() << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
    auto start = clock();
#endif
    int t;
#ifdef multitest
    cin >> t;
#else
    t = 1;
#endif
    while (t --> 0) solve();
#ifdef LOCAL
    auto end = clock();
    cerr << "time: " << end - start << endl;
#endif
    return 0;
}
