#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 9;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

vector <vector <int>> al;

struct Otr
{
	int l, r, w;
	Otr(int l = 0, int r = 0, int w = 0) :l(l), r(r), w(w) {}
	bool operator< (const Otr& o) const
	{
		return l < o.l;
	}
};

int tree[(MAXN + 1) * 4];

int get(int v, int l, int r, int zl, int zr)
{
	if (zr <= l or r <= zl)
	{
		return 0;
	}
	if (zl <= l and r <= zr)
	{
		return tree[v];
	}
	int mid = (l + r) / 2;
	return max(get(v * 2 + 1, l, mid, zl, zr), get(v * 2 + 2, mid, r, zl, zr));
}

void chan(int v, int l, int r, int ind, int val)
{
	if (l + 1 == r)
	{
		rmax(tree[v], val);
		return;
	}
	int mid = (l + r) / 2;
	if (ind < mid)
	{
		chan(v * 2 + 1, l, mid, ind, val);
	}
	else
		chan(v * 2 + 2, mid, r, ind, val);
	tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int sz = 1;
	while (sz < MAXN + 1)
	{
		sz *= 2;
	}

	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		al.emplace_back();
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			if (al.back().empty() or x > al.back().back())
			{
				al.back().push_back(x);
			}
		}
	}

	vector <Otr> otr;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < al[i].size(); j++)
		{
			otr.push_back({ al[i][j],al[i].back(),int(al[i].size()) - j });
		}
	}
	sort(ALL(otr));

	for (int i = 0; i < otr.size(); i++)
	{
		int t = get(0, 0, sz, 0, otr[i].l);
		chan(0, 0, sz, otr[i].r, t + otr[i].w);
	}
	cout << get(0, 0, sz, 0, sz);
}