#include <bits/stdc++.h>

using namespace std;

#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

const int C = 200'001;

struct FenwickTree {
    int size;
    vector<int> t;

    int get(int ind) {
        int res = 0;
        for (int i = ind; i >= 0; i &= i + 1, --i) umax(res, t[i]);
        return res;
    }

    void change(int ind, int val) {
        for (int i = ind; i < size; i |= i + 1) umax(t[i], val);
    }

    FenwickTree() = default;
    explicit FenwickTree(int n) : size(n), t(size) {}
};

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> a(n);
    vector<int> mx(n);

    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int& x : a[i]) cin >> x;
        mx[i] = *max_element(a[i].begin(), a[i].end());
    }

    vector<int> p(n);
    iota(p.begin(), p.end(), 0);

    sort(p.begin(), p.end(), [&](int x, int y) {
        return mx[x] < mx[y];
    });

    FenwickTree tree(C);

    for (int i : p) {
        int mx_ = INT_MIN;

        int m = sz(a[i]);
        vector<int> ps(m + 1);
        for (int j = 0; j < m; ++j) {
            ps[j + 1] = ps[j] + umax(mx_, a[i][j]);
        }

        int best = 0;
        for (int j = 0; j < m; ++j) {
            umax(best, tree.get(a[i][j] - 1) + ps[m] - ps[j]);
        }

        tree.change(mx[i], best);
    }

    cout << tree.get(C - 1) << '\n';
}

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1
*/

/*
4
2
3 4
2
1 8
2
2 8
2
7 9
*/

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}