#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

struct segtree {
    struct node {
        ll sum = 0;

        node operator+(node b) const {
            node ans(0);
            ans.sum = max(sum, b.sum);
            return ans;
        }

        node(int x) {
            sum = x;
        }
    };

    vector<node> tree;
    int sz = 1;

    void build(int v, int l, int r, vector<ll> &a) {
        if (r - l == 1) {
            if (l < a.size()) {
                tree[v] = a[l];
            }
            return;
        }
        int mid = (r + l) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }


    segtree(vector<ll> &a) {
        while (sz < a.size()) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1, 0);
        build(0, 0, sz, a);
    }

    node get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (qr <= l || r <= ql) {
            return node(0);
        }
        int mid = (r + l) / 2;
        node m1 = get(2 * v + 1, l, mid, ql, qr);
        node m2 = get(2 * v + 2, mid, r, ql, qr);
        return m1 + m2;
    }

    node get(int ql, int qr) {
        return get(0, 0, sz, ql, qr);
    }

    void change(int v, int l, int r, int ind, ll x) {
        if (r - l == 1) {
            tree[v] = max(x, tree[v].sum);
            return;
        }
        int mid = (r + l) / 2;
        if (ind < mid) {
            change(2 * v + 1, l, mid, ind, x);
        } else {
            change(2 * v + 2, mid, r, ind, x);
        }
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    void change(int ind, ll x) {
        change(0, 0, sz, ind, x);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<int, vector<ll>>> had(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        had[i].second.resize(k);
        cin >> had[i].second;
        ll maxim = 0;
        for (auto el: had[i].second) {
            maxim = max(maxim, el);
        }
        vector<ll> stek;
        std::reverse(had[i].second.begin(), had[i].second.end());
        for (auto el: had[i].second) {
            while (!stek.empty() && stek.back() <= el) {
                stek.pop_back();
            }
            stek.push_back(el);
        }
        std::reverse(stek.begin(), stek.end());
        had[i].second = stek;
        had[i].first = maxim;
    }
    had.push_back({0, {}});
    std::sort(had.begin(), had.end());
    vector<ll> dp(200001, 0);
    segtree mach(dp);
    for (int i = 0; i <= n; i++) {
        for (int k = 0; k < had[i].second.size(); k++) {
            ll maxim = 0;
            maxim = mach.get(0, had[i].second[k]).sum;
            mach.change(had[i].first, ll(had[i].second.size() - k + maxim));
        }
    }
    ll maxim = 0;
    for (auto el: dp) {
        maxim = max(maxim, el);
    }
    cout << mach.tree[0].sum << "\n";

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}