#include <iostream>
#include <vector>
#include <numeric>

using namespace std;
using ll = long long;

const ll INF18 = 1e18;

ll solveFact(const vector<vector<ll>> &albums) {
    ll n = ll(albums.size());
    vector<ll> order(n);
    iota(order.begin(), order.end(), 0);
    ll res = 0;
    do {
        ll tmp = 0;
        ll mx = 0;
        for (const auto &id: order) {
            for (auto &item: albums[id]) {
                if (mx < item) {
                    ++tmp;
                    mx = item;
                }
            }
        }

        res = max(res, tmp);
    } while (next_permutation(order.begin(), order.end()));
    return res;
}

ll solveA2(const vector<vector<ll>> &albums) {
    ll n = ll(albums.size());
    if (n == 1) {
        bool wasOne = false;
        for (const auto &item: albums[0]) {
            if (item == 2 && wasOne) {
                return 2;
            } else if (item == 1) {
                wasOne = true;
            }
        }

        return 1;
    } else {
        bool wasOne = false;
        bool wasTwo = false;
        for (const auto &lst: albums) {
            for (const auto &item: lst) {
                if (item == 1) {
                    wasOne = true;
                } else {
                    wasTwo = true;
                }
            }
        }
        return wasOne + wasTwo;
    }
}

void resolve() {
    ll n;
    cin >> n;
    vector<vector<ll>> albums(n);
    ll maxA = 0;
    ll maxK = 0;
    for (ll i = 0; i < n; ++i) {
        ll sz;
        cin >> sz;
        maxK = max(maxK, sz);
        albums[i].resize(sz);
        for (auto &item: albums[i]) {
            cin >> item;
            maxA = max(maxA, item);
        }
    }

    ll res = 0;
    if (maxA <= 2) {
        res = solveA2(albums);
    } else {
        res = solveFact(albums);
    }
    cout << res << '\n';
}

int32_t main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve();
    return 0;
}
