#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 200100;
const ll mod = 1e9 + 7;

vector <int> v[sz];
vector <int> crt;
bool used[sz];
int c[sz];
int n;

int f(int it, int n) {
	if (it == n) {
		int ans = 0;
		int last = 0;
		for (int i : crt) {
			for (int j : v[i]) {
				if (j > last) {
					++ans;
					last = j;
				}
			}
		}
		return ans;
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		if (used[i]) continue;
		used[i] = 1;
		crt.push_back(i);
		ans = max(ans, f(it + 1, n));
		crt.pop_back();
		used[i] = 0;
	}
	return ans;
}

bool cmp(vector <int> a, vector <int> b) {
	if (a.size() == 1) a.push_back(a[0]);
	if (b.size() == 1) b.push_back(b[0]);
	if (a[0] == b[0] && a[1] == b[1]) return 0;
	if (a[1] <= b[0]) return 1;
	if (b[1] <= a[0]) return 0;
	if (a[0] <= b[0] && b[1] <= a[1]) return 0;
	if (b[0] <= a[0] && a[1] <= b[1]) return 1;
	return a[0] <= b[0] && a[1] <= b[1];
}

int dfs(int u, int last) {
	auto t = upper_bound(v[u].begin(), v[u].end(), last);
	int here = v[u].end() - t;
	int ans = 0;
	last = v[u].back();
	for (int i = 1; i <= n; ++i) {
		if (v[i].back() > last) {
			ans = max(ans, dfs(i, last));
		}
	}
	return ans + here;
}

int main() {
	cin >> n;
	int mx = 0;
	int mk = 0;
	for (int i = 1; i <= n; ++i) {
		int k;
		cin >> k;
		int last = 0;
		while (k--) {
			int a;
			cin >> a;
			if (a > last) {
				last = a;
				v[i].push_back(a);
			}
		}
		mx = max(mx, last);
		mk = max(mk, (int)v[i].size());
	}
	if (n <= 7) {
		cout << f(0, n);
		return 0;
	}
	if (mx <= 2) {
		set <int> s;
		for (int i = 1; i <= n; ++i) {
			for (int j : v[i]) s.insert(j);
		}
		cout << s.size();
		return 0;
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		ans = max(ans, dfs(i, 0));
	}
	cout << ans;
	return 0;
}