#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;


#define int long long

class SegmentTree {
private:
	vector <int> data;
	int size;

	int get(int ql, int qr, int nl, int nr, int node) {
		if (ql >= nr || nl >= qr) return 0;
		if (ql <= nl && nr <= qr) return data[node];
		return max(
			get(ql, qr, nl, (nl + nr) / 2, node * 2),
			get(ql, qr, (nl + nr) / 2, nr, node * 2 + 1)
		);
	}

public:
	SegmentTree(int n) {
		size = 1;
		while (size < n) size *= 2;
		data.assign(size * 2, 0);
	}

	void update(int pos, int val) {
		pos += size;
		data[pos] = max(data[pos], val);
		while ((pos /= 2) > 0) {
			data[pos] = max(data[pos * 2], data[pos * 2 + 1]);
		}
	}

	int get(int l, int r) {
		return get(l, r, 0, size, 1);
	}
};

void solve() {
	int n; cin >> n;
	vector <vector <int>> v(n);
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		for (int j = 0; j < k; ++j) {
			int x; cin >> x;
			if (v[i].empty() || v[i].back() < x) {
				v[i].push_back(x);
			}
		}
	}
	sort(all(v), [&](const vector <int>& a, const vector <int>& b) {return a.back() < b.back(); });

	SegmentTree dp(v.back().back() + 1);
	for (auto& vec : v) {
		dp.update(vec.back(), dp.get(0, vec[0]) + vec.size());
		for (int i = 0; i < vec.size() - 1; ++i) {
			dp.update(vec.back(), dp.get(vec[i], vec[i + 1]) + (int)vec.size() - i - 1);
		}
	}

	cout << dp.get(0, v.back().back() + 1);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}