#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int MAXN = 262144; // 262144

vector <vector <int>> task;

int tree[2 * MAXN];

void upd_v(int v) {
    v += MAXN;
    v >>= 1;
    while (v > 0) {
        tree[v] = max(tree[v << 1], tree[(v << 1) + 1]);
        v >>= 1;
    }
}

int get_max(int v, int l, int r, int ln, int rn) {
    if (l >= rn || r <= ln) {
        return 0;
    }
    if (l >= ln && r <= rn) {
        return tree[v];
    }
    int m = (l + r) >> 1;
    return max(get_max(v << 1, l, m, ln, rn), get_max((v << 1) + 1, m, r, ln, rn));
}

struct num {
    int val, l, r;
};

signed main() {
    for (int i = 0; i < 2 * MAXN; i++) {
        tree[i] = 0;
    }
    int n;
    cin >> n;
    task.resize(n);
    int cnt, t;
    for (int i = 0 ; i < n;i++) {
        cin >> cnt;
        for (int j = 0 ; j < cnt; j++) {
            cin >> t;
            if (task[i].size() == 0) {
                task[i].push_back(t);
            } else if (task[i].back() < t) {
                task[i].push_back(t);
            }
        }
    }
    vector <num> srt;
    for (int i = 0 ; i < n; i++) {
        for (int j = 0 ; j < task[i].size(); j++) {
            srt.push_back({((int) task[i].size()) - j, task[i][j], task[i].back()});
        }
    }
    sort(srt.begin(), srt.end(), [] (num a, num b) {return a.l < b.l;});
    // for (auto i: srt) {
    //     cout << i.l << " " << i.r << " " << i.val << "\n";
    // }
    for (auto i: srt) {
        int val = get_max(1, 0, MAXN, 0, i.l);
        tree[i.r + MAXN] = max(tree[i.r + MAXN], val + i.val);
        upd_v(i.r);
    }
    cout << get_max(1, 0, MAXN, 0, MAXN);
}