
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
using namespace std;
#define double long double
#define int long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) <<": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;    
    }
    return a + b;
}
struct segtree {
    vector<int> tree;
    int size = 1;
    void init(int n) {
        while (size < n) size *= 2;
        tree = vector<int>(2 * size - 1, 0);
    }
    void upd(int i, int a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            upd(i, a, 2 * x + 1, lx, m);
        }
        else {
            upd(i, a, 2 * x + 2, m, rx);
        }
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int l, int r, int x, int lx, int rx) {
        if (rx <= l || lx >= r) {
            return -INF;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int mx1 = get(l, r, 2 * x + 1, lx, m);
        int mx2 = get(l, r, 2 * x + 2, m, rx);
        return max(mx1, mx2);
    }
};
const int MAXA = 200020;
void solve() {
    int n;
    segtree st;
    cin >> n;
    st.init(MAXA);
    vector<int> all_k(n), get_mx(n);
    vector<pair<int, int> > for_sort;
    vector<vector<int> > all_bad(n), add(n), all(n);
    for (int i = 0; i < n; i++) {
        int k, mx = 0;
        cin >> k;
        all_k[i] = k;
        for (int j = 0; j < k; j++) {
            int a; cin >> a;
            all_bad[i].pb(a);
            mx = max(mx, a);
        }
        for_sort.pb({ mx,i });
        get_mx[i] = mx;
    }
    sort(for_sort.begin(), for_sort.end());
    for (int i = 0; i < n; i++) {
        for (auto c : all_bad[for_sort[i].second]) {
            all[i].pb(c);
            add[i].pb(0);
        }
        get_mx[i] = for_sort[i].first;
    }
    for (int i = 0; i < n; i++) {
        vector<int> next(add[i].size(),-1), cnt = next;
        vector<int> a = all[i];
        vector<int> st;
        for (int j = 0; j < add[i].size(); j++) {
            while (st.size() > 0 && a[st[st.size() - 1]] < a[j]) {
                next[st[st.size() - 1]] = j;
                st.pop_back();
            }
            st.pb(j);
        }
        for (int j = add[i].size() - 1; j >= 0; j--) {
            if (next[j] == -1) {
                cnt[j] = 0;
                continue;
            }
            cnt[j] = cnt[next[j]] + 1;
        }
        add[i] = cnt;
    }
    /*
    debug(3);
    for (auto c : add) {
        for (auto x : c) {
            cout << x << " ";
        }
        cout << endl;
    }
    */
    vector<int> dp(MAXA);
    for (int i = 0; i < n; i++) {
        int mx = 0, may_st = 0, cur_mx = 0;
        for (int j = 0; j < all[i].size(); j++) {
            if (all[i][j] <= cur_mx) continue;
            int maximum = st.get(0, all[i][j], 0, 0, st.size);
            int may = maximum + add[i][j] + 1;
            mx = max(mx, may);
            cur_mx = max(all[i][j], cur_mx);
        }
        if (dp[get_mx[i]] < mx) {
            st.upd(get_mx[i], mx, 0, 0, st.size);
        }
        dp[get_mx[i]] = max(dp[get_mx[i]], mx);
    }
    int ans = 0;
    for (int i = 0; i < MAXA; i++) {
        ans = max(dp[i], ans);
    }
    cout << ans;
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    srand(time(NULL));
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
