#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));

ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return uid(rng) % n;
}

int R = 1;

struct segment_tree {
    vector<ll> t, d;

    explicit segment_tree(int n = 1 << 19) {
        R = 1;
        while (R < n)
            R *= 2;
        t.resize(R * 2 + 10, 0);
        d.resize(R * 2 + 10, 0);
    }

    void calc(int node) {
        if (node < R)
            t[node] = t[node * 2] + t[node * 2 + 1];
    }

    void push(int node, int nl, int nr) {
        t[node] += d[node] * (nr - nl + 1);
        if (node < R) {
            d[node * 2] += d[node];
            d[node * 2 + 1] += d[node];
        }
        d[node] = 0;
    }

    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (ql <= nl && nr <= qr) {
            t[node] += val * (nr - nl + 1);
            d[node] += val;
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }

    ll ans(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (ql <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return ans(ql, qr, node * 2, nl, nm) +
               ans(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

vector<int> p[200010];

bool cmp(vector<int> a, vector<int> b) {
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    reverse(a.begin(), a.end());
    reverse(a.begin() + 1, a.end());
    reverse(b.begin(), b.end());
    reverse(b.begin() + 1, b.end());
    return a < b;
}

void solve() {
    int n;
    cin >> n;
    int sm = 0;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        p[i].resize(k);
        for (auto &el: p[i])
            cin >> el;
        sm += k;
    }
    if (n <= 1000) {
        sort(p + 1, p + n + 1, cmp);
        p[0] = {0};
        vector<int> dp(n + 1);
        dp[0] = 0;
        for (int i = 1; i <= n; i++) {
            int pr = *max_element(p[i - 1].begin(), p[i - 1].end());
            int cnt = 0, mx = pr;
            for (int j = i; j <= n; j++) {
                int mx1 = pr, cnt1 = 0;
                for (auto &el: p[j]) {
                    if (mx < el) {
                        mx = el;
                        cnt++;
                    }
                    if (mx1 < el) {
                        mx1 = el;
                        cnt1++;
                    }
                }
                dp[j] = max(dp[j], dp[i - 1] + max(cnt, cnt1));
            }
        }
        cout << *max_element(dp.begin(), dp.end()) << endl;
        return;
    }
    sort(p + 1, p + n + 1, cmp);
    int ans = 0;
    for (int _ = 0; _ < 10000000 / sm; _++) {
        int mx = 0, cnt = 0;
        for (int i = 0; i < n; i++)
            if (rnd(2) == 1 || _ == 0)
                for (auto &el: p[i + 1])
                    if (el > mx) {
                        mx = el;
                        cnt++;
                    }
        ans = max(ans, cnt);
    }
    cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}



