#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <vector>

#define sz(a) int((int)a.size())

using namespace std;

struct VEC {
    vector<int> a, cnt_inv;
    vector<pair<int, int>> sorted_a;
    int mx;
};

int cnt(VEC& a, VEC& b) {
    int ans = a.cnt_inv.back() + b.cnt_inv.back();
    int l = 0, r = b.sorted_a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (b.sorted_a[m].first <= a.mx) {
            l = m;
        } else {
            r = m;
        }
    }
    int last_no = b.sorted_a[l].second;
    if (b.sorted_a[l].first > a.mx) {
        return ans;
    }
    ans -= b.cnt_inv[last_no];
//    while (r - l > 1) {
//        int m = (l + r) / 2;
//        if (b.sorted_a[m].first <= a.mx) {
//            l = m;
//        } else {
//            r = m;
//        }
//    }
//    int last_no = b.sorted_a[r].second;
//    if (b.sorted_a[r].first <= a.mx) {
//        ans -= b.cnt_inv.back();
//    } else {
//
//        ans -= b.cnt_inv[last_no - 1];
//    }
    return ans;
}

bool smart_comp(VEC& a, VEC& b) {
    /*
    int cnt_a_b = cnt(a, b);
    int cnt_b_a = cnt(b, a);
    if (cnt_a_b != cnt_b_a) {
        return cnt_a_b > cnt_b_a;
    }
    return a.mx < b.mx;
     */
    return a.mx < b.mx;
}

void solve_smart(int n) {
    vector<VEC> vv(n);
    for (int i = 0; i < n; ++i) {
        int len;
        cin >> len;
        vv[i].a.resize(len);
        vv[i].cnt_inv.resize(len);
        vv[i].sorted_a.resize(len);
        int mx = 0;
        int cnt_mx = 0;
        for (int j = 0; j < len; ++j) {
            cin >> vv[i].a[j];
            if (vv[i].a[j] > mx) {
                mx = vv[i].a[j];
                cnt_mx++;
            }
            vv[i].cnt_inv[j] = cnt_mx;
        }
        for (int j = 0; j < len; ++j) {
            vv[i].sorted_a[j].first = vv[i].a[j];
            vv[i].sorted_a[j].second = j;
        }
        sort(vv[i].sorted_a.begin(), vv[i].sorted_a.end());
        vv[i].mx = mx;
    }
    // cout << vv[0].cnt_inv.back() << ' ' << vv[1].cnt_inv.back() << '\n';
//    for (auto el : vv[0].cnt_inv) {
//        cout << el << ' ';
//    }
//    cout << '\n';
//    for (auto el : vv[1].cnt_inv) {
//        cout << el << ' ';
//    }
//    cout << '\n';
//    cout << cnt(vv[0], vv[1]);
    sort(vv.begin(), vv.end(), smart_comp);
    int mx = 0, ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int el : vv[i].a) {
            cout << el << ' ';
            if (el > mx) {
                mx = el;
                ans++;
            }
        }
    }
    cout << '\n';
    cout << ans;
}

vector<vector<int>> have;
vector<bool> used;
vector<int> comb;

int ANS = 0;

int CNT_KOL() {
    int mx = 0, ans = 0;
    for (int el : comb) {
        for (int i = 0; i < have[el].size(); ++i) {
            if (have[el][i] > mx) {
                mx = have[el][i];
                ans++;
            }
        }
    }
    return ans;
}

void rec(int n) {
//    cout << "IN1" << endl;
//    cout << comb.size() << endl;
    if (comb.size() == n) {
        ANS = max(ANS, CNT_KOL());
//        cout << "ENDED" << endl;
//        for (auto el : comb) {
//            cout << el << ' ';
//        }
//        cout << endl;
        return;
    }
//    cout << "IN2" << endl;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comb.push_back(i);
            used[i] = true;
//            cout << "IN3" << endl;
            rec(n);
            used[i] = false;
            comb.pop_back();
        }
    }
}

void solve_stupid(int n) {
    used.resize(n, false);
    have.resize(n);
    for (int i = 0; i < n; ++i) {
        int len;
        cin >> len;
        have[i].resize(len);
        for (int& el : have[i]) {
            cin >> el;
        }
    }
//    cout << "OK1" << endl;
    rec(n);
//    cout << "EEEEEEEEEEND" << endl;
    cout << ANS;
}

void solve() {
    int n;
    cin >> n;
    if (n <= 7) {
        solve_stupid(n);
        return;
    }
    solve_smart(n);
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}
