#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint& pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res *= a;
			}
			a *= a;
			n /= 2;
		}
		return res;
	}

	mint& rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}
	mint& operator-=(const mint&b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}
	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}
	mint& operator/=(const mint& b) {
		assert(b.x != 0);
		*this *= b.rev();
		return *this;
	}
	mint operator+(const mint& b) {
		return mint(x + b.x);
	}
	mint operator-(const mint& b) {
		return mint(x - b.x);
	}
	mint operator*(const mint& b) {
		return mint(1ll * x * b.x);
	}
	mint operator/(const mint& b) {
		return mint(x) * b.rev();
	}
};

vector<int> get(vector<int>& b) {
	vector<int> res;
	res.push_back(b[0]);
	for (int i = 1; i < b.size(); i++) {
		if (res.back() < b[i]) {
			res.push_back(b[i]);
		}
	}
	reverse(res.begin(), res.end());
	return res;
}

//struct BIT {
//	vector<int> t;
//	BIT(int n) {
//		t.resize(n + 1);
//	}
//	int get(int r) {
//		int res = 0;
//		for (; r > 0; r -= r & (-r)) {
//			res += t[r];
//		}
//		return res;
//	}
//	void upd(int r, int x) {
//		for (; r < t.size(); r += r & (-r)) {
//			t[r] += x;
//		}
//	}
//};

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> a(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		vector<int> b(k);
		for (int j = 0; j < k; j++) {
			cin >> b[j];
		}
		a[i] = get(b);
	}
	vector<int> dp(1010);
	dp[0] = 0;
	int ans = 0;
	for (int i = 0; i < 1010; i++) {
		ans = max(ans, dp[i]);
		for (int j = 0; j < n; j++) {
			if (a[j][0] <= i) continue;
			int r = -1;
			for (int p = 19; p >= 0; p--) {
				if ((r + (1 << p)) >= a[j].size()) continue;
				if (a[j][r + (1 << p)] > i) {
					r += (1 << p);
				}
			}
			dp[a[j][0]] = max(dp[a[j][0]], dp[i] + r + 1);
		}
	}
	cout << ans << '\n';
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}
