#include <bits/stdc++.h>

#define int long long

using namespace std;
template <typename Node>
struct SegTree {
    int n;
    int h = 0;
    vector<Node> t;

    SegTree(const vector<Node>& in) {
        n = in.size();
        while ((1 << h) < n)
            ++h;
        t.resize((1 << (h + 1)), Node::zero_el());
        for (int i = 0; i < n; ++i)
            t[(1 << h) + i] = in[i];
        for (int i = (1 << h) - 1; i > 0; --i)
            t[i] = Node::merge(t[2 * i], t[2 * i + 1]);
    }

    void upd(int v, int vl, int vr, int i, Node& val) {
        if (vl + 1 == vr) {
            t[v] = val;
            return;
        }
        int vm = (vl + vr) / 2;
        if (i < vm)
            upd(2 * v, vl, vm, i, val);
        else
            upd(2 * v + 1, vm, vr, i, val);
        t[v] = Node::merge(t[2 * v], t[2 * v + 1]);
    }

    void upd(int i, Node val) {
        upd(1, 0, (1 << h), i, val);
    }

    Node get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l)
            return Node::zero_el();
        if (l <= vl && vr <= r)
            return t[v];
        int vm = (vl + vr) / 2;
        return Node::merge(get(2 * v, vl, vm, l, r), get(2 * v + 1, vm, vr, l, r));
    }

    Node get(int l, int r) {
        return get(1, 0, (1 << h), l, r);
    }

    Node get(int i) {
        return t[(1 << h) + i];
    }
};

struct Node {
    int val;

    static Node merge(Node a, Node b) {
        return {max(a.val, b.val)};
    }

    static Node zero_el() {
        return {0};
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> albums(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int tmp;
            cin >> tmp;
            if (albums[i].empty() || tmp > albums[i].back())
                albums[i].push_back(tmp);
        }
    }
    sort(albums.begin(), albums.end(), [&](const vector<int> &a, const vector<int> &b) {
        return a.back() < b.back();
    });
    vector<Node> in(albums.back().back() + 1);
    SegTree<Node> st(in);
    vector<int> dp(n);
    for (int i = 0; i < n; ++i) {
        dp[i] = albums[i].size();
        for (int j = 0;j < albums[i].size(); ++j) {
            int newln = (int)albums[i].size() - j;
            newln += st.get(0, albums[i][j]).val;
            dp[i] = max(dp[i], newln);
        }
        if (dp[i] > st.get(albums[i].back()).val)
            st.upd(albums[i].back(), {dp[i]});
    }
    cout << *max_element(dp.begin(), dp.end());
}