#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

const int maxn = 2e5;

vector<int> arr[maxn];

namespace SEG_TREE {
    struct ST {
        vector<int> tree;

        ST(int sz) {
            tree.resize(4 * sz);
        }

        int get(int i, int l, int r, int ql, int qr) {
            if (qr <= l or r <= ql)
                return 0;
            if (ql <= l and r <= qr)
                return tree[i];
            int mid = (l + r) / 2;
            int a = get(2 * i + 1, l, mid, ql, qr);
            int b = get(2 * i + 2, mid, r, ql, qr);
            return max(a, b);
        }

        void add(int i, int l, int r, int q, int x) {
            if (q < l or r <= q)
                return;

            if (l + 1 == r) {
                tree[i] = max(tree[i], x);
                return;
            }

            int mid = (l + r) / 2;
            add(2 * i + 1, l, mid, q, x);
            add(2 * i + 2, mid, r, q, x);
            tree[i] = max(tree[i], x);
        }

        void add(int q, int x) {
            add(0, 0, tree.size() / 4, q, x);
        }

        int get(int l, int r) {
            return get(0, 0, tree.size() / 4, l, r);
        }
    };
}
using SEG_TREE::ST;

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (j == 0 or arr[i].back() < x)
                arr[i].push_back(x);
        }
    }

    vector<int> ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](int a, int b) {return arr[a].back() < arr[b].back(); });

    ST st(maxn + 1);
    for (int x : ord) {
        for (int i = 0; i < arr[x].size(); ++i) {
            int res = st.get(0, arr[x][i]);
            int len = arr[x].size() - i;
            st.add(arr[x].back(), res + len);
        }
    }

    cout << st.get(0, maxn + 1) << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}
