#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

#define int long long

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcd(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

struct song{
    int st, ln, en;
};

bool cmp(song a, song b){
    return a.st < b.st;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    set<int> al;
    vector<vector<int>> a(n);
    vector<song> songs;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int mx = 0;
        for (int j = 0; j < k; ++j) {
            int c;
            cin >> c;
            if (c > mx) {
                al.insert(c);
                a[i].push_back(c);
                mx = c;
            }
        }
        for (int j = 0; j < a[i].size(); ++j){
            songs.push_back({a[i][j], (int) a[i].size() - j, a[i].back()});
        }
    }
    sort(songs.begin(), songs.end(), cmp);
    map<int, int> ind;
    int xx = 0;
    for (auto i : al){
        ind[i] = xx++;
    }
    fen.resize(xx);
    for (auto i : songs){
        int mx = get(ind[i.st] - 1);
        mx += i.ln;
        add(ind[i.en], mx);
    }
    cout << *max_element(fen.begin(), fen.end());
}
