#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> g;
int maxa = 10;
vector<int> mx;

int inf = 1;

void dfs(int v){
    mx[v] = 0;
    for (int i = 0; i < maxa; ++i){
        if (g[v][i] != -inf) {
            if (mx[i] == -inf) {
                dfs(i);
            }
            mx[v] = max(mx[v], mx[i] + g[v][i]);
        }
    }
}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        v[i].reserve(k);
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (v[i].empty() || v[i].back() < x){
                v[i].push_back(x);
            }
        }
    }
    g.assign(maxa, vector<int>(maxa, -inf));
    mx.assign(maxa, -inf);

    for (int i = 0; i < n; ++i) {
        int sz = v[i].size();
        for (int j = 0; j < sz; ++j) {
            for (int k = 0; k < v[i][j]; ++k) {
                g[k][v[i].back()] = max(g[k][v[i].back()], sz - j);
            }
        }
    }

//    for (int i = 0; i < maxa; ++i) {
//        for (int j = 0; j < maxa; ++j) {
//            cout << g[i][j] << ' ';
//        }
//        cout << endl;
//    }

    dfs(0);
    cout << mx[0] << endl;

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}