#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

struct Tree {
	int n;
	vector<int> t;
	Tree() {}
	Tree(int n) : n(n) {
		t.assign(n << 1, 0);
	}
	void update(int i, int x) {
		t[i += n] = x;
		for (i >>= 1; i >= 1; i >>= 1) {
			t[i] = max(t[i << 1], t[i << 1 | 1]);
		}
	}
	int query(int l, int r) {
		int ans = 0;
		for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if (l & 1) {
				ckmax(ans, t[l++]);
			}
			if (r & 1) {
				ckmax(ans, t[--r]);
			}
		}
		return ans;
	}
};

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> a(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}
	vector<vector<int>> c(n);
	for (int i = 0; i < n; ++i) {
		c[i].push_back(a[i][0]);
		for (int j = 1; j < (int) a[i].size(); ++j) {
			if (c[i].back() < a[i][j]) {
				c[i].push_back(a[i][j]);
			}
		}
	}
	vector<pair<int, int>> b;
	for (int i = 0; i < n; ++i) {
		b.emplace_back(c[i].back(), i);
	}
	sort(b.begin(), b.end());
	vector<int> dp(n, 0);
	Tree st(b.back().first + 1);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		dp[i] = (int) c[b[i].second].size();
		for (int j = 0; j < (int) c[b[i].second].size(); ++j) {
			ckmax(dp[i], st.query(0, c[b[i].second][j]) + (int) c[b[i].second].size() - j);
		}
		st.update(b[i].first, dp[i]);
		ckmax(ans, dp[i]);
	}
	cout << ans << endl;
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
