#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long

const int inf = 1e18, maxn = 2e5 + 100;

struct Segtree {
    int n;
    vector<int> a;
    vector<int> t;

    int op(int _a, int _b) {
        return max(_a, _b);
    }

    Segtree() {};

    Segtree(int _n) {
        n = _n;
        a.assign(n, 0);
        t.resize(4 * n);
        build(1, 0, n);
    }

    Segtree(vector<int> _a) {
        n = (int) _a.size();
        a = _a;
        t.resize(4 * n);
        build(1, 0, n);
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            t[v] = val;
            a[l] = val;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) update(v * 2, l, m, pos, val);
        else update(v * 2 + 1, m, r, pos, val);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) return -inf;
        if (lq <= l && r <= rq) return t[v];
        int m = (l + r) / 2;
        return op(get(v * 2, l, m, lq, rq), get(v * 2 + 1, m, r, lq, rq));
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    int get(int pos) {
        return a[pos];
    }

    void upd(int pos, int val) {
        update(1, 0, n, pos, val);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, {0});
    map<int, vector<int>> mp;
    int k, x;
    for (int i = 0; i < n; i++) {
        cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> x;
            if (x > a[i].back())a[i].pb(x);
        }
        mp[a[i].back()].pb(i);
    }
//    for (auto i: a) {
//        for (auto j: i) cout << j << ' ';
//        cout << endl;
//    }
    Segtree dp(maxn);
    dp.upd(0, 0);
    for (int i = 1; i < maxn; i++) {
        for (auto j : mp[i]) {
            k = a[j].size();
            for (int z=0; z < k - 1; z++) dp.upd(i, max(dp.get(i), dp.get(a[j][z], a[j][z + 1]) + k - z - 1));
        }
    }
//    for (int i=0; i < 10; i++) cout << dp.get(i) << ' '; cout << endl;
    cout << dp.get(0, maxn);
}

signed main() {
#ifdef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}
