#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;

const int MX = (1 << 18);//18

int tree[MX * 2];

int upd(int i, int l, int r, int q, int x) {
	if (q < l || q >= r)
		return tree[i];
	if (r - l == 1)
		return tree[i] = max(tree[i], x);
	int m = (l + r) / 2;
	return tree[i] = max(upd(i * 2, l, m, q, x), upd(i * 2 + 1, m, r, q, x));
}
int get(int i, int l, int r, int ql, int qr) {
	if (qr <= l || r <= ql)
		return 0;
	if (ql <= l && r <= qr)
		return tree[i];
	int m = (l + r) / 2;
	return max(get(i * 2, l, m, ql, qr), get(i * 2 + 1, m, r, ql, qr));
}

bool cmp(const vector<int>& a, const vector<int>& b) {
	return a.back() < b.back();
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<vector<int>> a(n);
	int maxim = 0;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			maxim = max(maxim, x);
			if (a[i].empty() || x > a[i].back())
				a[i].push_back(x);
		}
	}
	sort(a.begin(), a.end(), cmp);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < a[i].size(); ++j) {
			int f = get(1, 0, MX, 0, a[i][j]);
			int f2 = a[i].size() - j;
			upd(1, 0, MX, a[i].back(), f + f2);
			ans = max(ans, f + f2);
		}
	}
	cout << ans << "\n";
}