#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG D.cpp -o D
using namespace std;

using ld = long double;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

bool cmp(vector<int> f, vector<int> s) {
    sort(f.rbegin(), f.rend());
    sort(s.rbegin(), s.rend());
    for (int i = 0; i < (int)min(f.size(), s.size()); ++i) {
        if (f[i] != s[i]) return f[i] < s[i];
    }
    return f.size() < s.size();
}

void slow(int n) {
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int x;
         cin >> x;
         a[i].resize(x);
         for (auto &j : a[i]) cin >> j;
    }
    int best = 0;
    for (int i = 0; i < 5040; ++i) {
        int ans = 0, mx = 0;
        for (auto x : a) {
            for (auto y : x) {
                if (y > mx) ans++, mx = y;
            }
        }
        best = max(best, ans);
        next_permutation(a.begin(), a.end());
    }
    cout << best << '\n';
}

void random_solve() {
    int n;
    cin >> n;
    if (n < 8) slow(n), exit(0);
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int x;
         cin >> x;
         a[i].resize(x);
         for (auto &j : a[i]) cin >> j;
    }
    sort(a.begin(), a.end(), cmp);
    int ans = 0, mx = 0;
    for (auto i : a) {
        for (auto j : i) {
            if (j > mx) ans++, mx = j;
        }
    }
    while ((ld)clock() / CLOCKS_PER_SEC < 0.8) {
        random_shuffle(a.begin(), a.end());
        int cur = 0, mx = 0;
        for (auto x : a) {
            for (auto y : x) {
                if (y > mx) cur++, mx = y;
            }
        }
        ans = max(ans, cur);
    }
    cout << ans << '\n';
}

void solve() {
    int n;
    cin >> n;
    if (n < 8) slow(n), exit(0);
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int x;
         cin >> x;
         a[i].resize(x);
         for (auto &j : a[i]) cin >> j;
    }
    sort(a.begin(), a.end(), cmp);
    int ans = 0, mx = 0;
    for (auto i : a) {
        for (auto j : i) {
            if (j > mx) ans++, mx = j;
        }
    }
    cout << ans << '\n';
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    random_solve();
    return 0;
}
 