#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef int ll;
typedef long double ld;
vector<vector<pair<ll, ll>>> g;
vector<ll> dist;
void dfs(ll v) {
    for (auto to : g[v]) {
        dist[to.first] = max(dist[to.first], dist[v] + to.second);
        dfs(to.first);
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }
    vector<ll> mxel(n);
    vector<vector<ll>> p(n);
    for (int i = 0; i < n; ++i) {
        ll now = 0;
        for (ll w : a[i]) {
            if (w > now) {
                now = w;
                p[i].push_back(w);
            }
        }
        mxel[i] = now;
    }
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (mxel[i] >= mxel[j]) continue;
            ll ct = p[j].end() - upper_bound(p[j].begin(), p[j].end(), mxel[i]);
            g[i].push_back({ j, ct });
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        dist.assign(n, 0);
        dist[i] = p[i].size();
        dfs(i);
        for (ll w : dist) ans = max(ans, w);
    }
    cout << ans;
}
