#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<pair<ll, ll>>> g;
vector<ll> dist, used, order;
void dfs(ll v, ll it) {
    used[v] = it;
    for (auto to : g[v]) {
        if (used[to.first] != it) {
            dfs(to.first, it);
        }
    }
    order.push_back(v);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    if (n <= 30000) {
        vector<vector<ll>> a(n);
        for (int i = 0; i < n; ++i) {
            ll k;
            cin >> k;
            a[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> a[i][j];
            }
        }
        vector<ll> mxel(n);
        vector<vector<ll>> p(n);
        for (int i = 0; i < n; ++i) {
            ll now = 0;
            for (ll w : a[i]) {
                if (w > now) {
                    now = w;
                    p[i].push_back(w);
                }
            }
            mxel[i] = now;
        }
        g.resize(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (mxel[i] >= mxel[j]) continue;
                ll ct = p[j].end() - upper_bound(p[j].begin(), p[j].end(), mxel[i]);
                g[i].push_back({ j, ct });
            }
        }
        ll ans = 0;
        used.assign(n, -1);
        dist.assign(n, 0);
        for (int i = 0; i < n; ++i) {
            order.clear();
            dfs(i, i);
            reverse(order.begin(), order.end());
            for (int j = 0; j < (ll)order.size(); ++j) {
                dist[order[j]] = 0;
            }
            dist[order[0]] = p[order[0]].size();
            for (int j = 0; j < (ll)order.size(); ++j) {
                ans = max(ans, dist[order[j]]);
                for (auto to : g[order[j]]) {
                    dist[to.first] = max(dist[to.first], dist[order[j]] + to.second);
                }
            }
        }
        cout << ans;
    }
    else {
        vector<vector<ll>> a(n);
        vector<ll> dp(11, 0);
        vector<vector<ll>> ind(11), p(n);
        for (int i = 0; i < n; ++i) {
            ll k;
            cin >> k;
            a[i].resize(k);
            ll now = 0;
            for (int j = 0; j < k; ++j) {
                cin >> a[i][j];
                if (a[i][j] > now) {
                    now = a[i][j];
                    p[i].push_back(a[i][j]);
                }
            }
            ind[now].push_back(i);
        }
        ll ans = 0;
        for (int i = 1; i <= 10; ++i) {
            for (int j = 0; j < i; ++j) {
                for (ll& id : ind[i]) {
                    ll ct = p[id].end() - upper_bound(p[id].begin(), p[id].end(), j);
                    dp[i] = max(dp[i], dp[j] + ct);
                }
            }
            ans = max(ans, dp[i]);
        }
        cout << ans;
    }
}
