/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;


struct segtree {
    int sz;
    vector <int> tree;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz - 1, 0);
    }

    void update (int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = max(tree[x], v);
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            update(i, v, 2 * x + 1, lx, m);
        }
        else {
            update(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }

    int get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return 0;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return max(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }
};


const int N = 2e5 + 1;
int sz[N], n;
vector <int> a[N];

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        int pref = 0;
        for (int j = 0; j < sz[i]; ++j) {
            int x; cin >> x;
            if (x > pref) {
                a[i].pb(x);
                pref = x;
            }
        }
        sz[i] = a[i].size();
    }
    vector <pii> v;
    for (int i = 0; i < n; ++i) {
        v.pb({a[i].back(), i});
    }
    sort(all(v));
    segtree st; st.init(N);
    for (auto i : v) {
        int ind = i.second, m = sz[ind];
        for (int j = m - 1; j >= 0; --j) {
            st.update(a[ind].back(), m - j + st.get(0, a[ind][j], 0, 0, N), 0, 0, N);
        }
    }
    cout << st.tree[0] << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}

