#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ALL(a) (a).begin(),(a).end()
#define RALL(a) (a).rbegin(),(a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename K, typename V, typename Cmp = less<K>>
using ordered_map =
    __gnu_pbds::tree<K, V, Cmp, __gnu_pbds::rb_tree_tag,
                     __gnu_pbds::tree_order_statistics_node_update>;

template <typename T, typename Cmp = less<T>>
using ordered_set = ordered_map<T, __gnu_pbds::null_type, Cmp>;

template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
  for (T& e : v) is >> e;
  return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
  for (const T& e : v) os << e << " ";
  return os;
}
template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
  return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
  return os << p.first << " " << p.second;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}
template <typename T>
void chmin(T& a, const T& b) {
  if (a > b) a = b;
}

void solve();

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

vector<i32>::iterator stalinsort(vector<i32>& v) {
  auto it1 = v.begin(), it2 = next(v.begin()), end = v.end();
  for (; it2 != end; ++it2) {
    if (*it2 > *it1) {
      ++it1;
      *it1 = *it2;
    }
  }
  return ++it1;
}

void solve() {
  i32 n;
  cin >> n;
  vector<vector<i32>> a(n);
  for (int i = 0; i < n; ++i) {
    i32 k;
    cin >> k;
    a[i].resize(k);
    cin >> a[i];
    a[i].erase(stalinsort(a[i]), a[i].end());
  }

  map<i32, vector<i32>> m;
  for (int i = 0; i < n; ++i) {
    m[a[i].back()].push_back(i);
  }
  constexpr i32 kMaxA = 10;
  vector<i32> dp(kMaxA + 1);
  for (int i = 1; i < kMaxA + 1; ++i) {
    dp[i] = dp[i - 1];
    if (!m.contains(i)) continue;
    for (i32 j : m[i]) {
      for (int k = 0; k < ssize(a[j]); ++k) {
        chmax(dp[i], dp[a[j][k] - 1] + (i32)ssize(a[j]) - k);
      }
    }
  }
  cout << dp.back() << "\n";
}
