#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

struct Edge {
    int to;
    int weight;

    Edge() {}
    Edge(int to, int weight) : to(to), weight(weight) {}
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int max_val = 0;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > max_val) {
                a[i].push_back(x);
                max_val = x;
            }
        }
    }
    vector<int> sorted = {0};
    for (int i = 0; i < n; ++i) {
        for (int x : a[i]) {
            sorted.push_back(x);
        }
    }
    sort(all(sorted));
    int len = unique(all(sorted)) - sorted.begin();
    sorted.resize(len);
    for (int i = 0; i < n; ++i) {
        for (int& x : a[i]) {
            x = lower_bound(all(sorted), x) - sorted.begin();
        }
    }

    

    vector<vector<Edge>> graph(len);
    for (const vector<int>& v : a) {
        int k = (int)v.size();
        for (int i = 0; i < k; ++i) {
            int from = v[i] - 1;
            int to = v.back();
            int weight = k - i;
            graph[from].emplace_back(to, weight);
        }
    }
    for (int i = 0; i < len - 1; ++i) {
        graph[i].emplace_back(i + 1, 0);
    }
    vector<int> dp(len);
    for (int v = 0; v < len; ++v) {
        for (auto [u, weight] : graph[v]) {
            dp[u] = max(dp[u], dp[v] + weight);
        }
    }
    cout << dp.back() << '\n';
}