#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

int get(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el: a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el: b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return ans;
}

int get1(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el: a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el: b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return cur;
}

int get2(vector<int> a, vector<int> b) {
    return min(a[0], a[1]);
}

//struct Fenwick {
//    vector<int> t;
//
//    Fenwick() {
//        t.resize(MAXN, 0);
//    }
//
//    void upd(int i, int nv) {
//        for (; i < t.size(); i += i & -i) {
//            t[i] = max(t[i], nv);
//        }
//    }
//
//    int get(int len) {
//        int mx = 0;
//        for (; len > 0; len -= len & -len) mx = max(mx, t[len]);
//        return mx;
//    }
//};

const int R = 1 << 19;

struct Fenwick {
    vector<int> t;

    Fenwick() {
        t.resize(R * 2, 0);
    }

    void upd(int ql, int nv, int node = 1, int nl = 1, int nr = R) {
        if (ql == nl && nr == ql) {
            t[node] = max(t[node], nv);
            return;
        }
        if (ql < nl || nr < ql) {
            return;
        }
        int nm = (nr + nl) / 2;
        upd(ql, nv, node * 2,nl, nm);
        upd(ql, nv, node * 2 + 1, nm + 1, nr);
        t[node] = max(t[node * 2], t[node * 2 + 1]);
    }

    int get(int ql ,int qr, int node = 1, int nl = 1,int nr = R) {
        if (ql > qr) return -1;
        if (ql <= nl && nr <= qr) {
            return t[node];
        }
        if (qr < nl  || nr < ql) {
            return 0;
        }
        int nm  =(nr + nl) / 2;
        return max(get(ql,qr, node * 2, nl, nm), get(ql,qr, node * 2 + 1, nm + 1, nr));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a[n];
    int mxall = 0;
    int mxsz = 0;
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        mxsz = max(mxsz, k);
        a[i].resize(k);
        for (auto &j: a[i]) {
            cin >> j;
            mxall = max(mxall, j);
        }
    }
    if (mxall <= 2) {
        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < n; ++i) {
            int cn = count(all(a[i]), 1);
            for (auto &el: a[i]) {
                if (el == 1) {
                    --cn;
                } else {
                    if (cn) {
                        cout << 2;
                        return;
                    }
                }
            }
            if (count(all(a[i]), 1)) {
                ++cnt1;
            }
            if (count(all(a[i]), 2)) {
                ++cnt2;
            }
        }
        if (max(cnt1, cnt2) >= 2) {
            cout << 2;
        } else {
            cout << 1;
        }
        return;
    }
    Fenwick fenw;
    const int MX = 2e5 + 1;
    vector<int> dp(MX + 1, 0);
    vector<int> near[n], way[n], go[n];
    for (int i = 0; i < n; ++i) {
        near[i].resize(a[i].size(), -1);
        way[i].resize(a[i].size(), 0);
        go[i].resize(a[i].size(), 0);
        vector<int> d;
        for (int j = a[i].size() - 1; j >= 0; --j) {
            while (!d.empty() && a[i][d.back()] <= a[i][j]) d.pop_back();
            if (!d.empty()) {
                near[i][j] = d.back();
            }
            d.push_back(j);
        }
        for (int j = a[i].size() - 1; j >= 0; --j) {
            if (near[i][j] == -1) {
                way[i][j] = 1;
                go[i][j] = a[i][j];
            } else {
                way[i][j] = way[i][near[i][j]] + 1;
                go[i][j] = go[i][near[i][j]];
            }
        }
    }
    vector<int> mx;
    for (int i = 0; i < n; ++i) {
        mx.push_back(*max_element(all(a[i])));
    }
    if (1) {
        vector<tuple<int, int, int>> s;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < a[i].size(); ++j) {
                s.emplace_back(go[i][j], j, i);
            }
        }
        sort(all(s));
        for (auto &[x, j, i]: s) {
            fenw.upd(go[i][j], fenw.get(1, go[i][j] - 1) + way[i][j]);
        }
        int mxx = 1;
        for (auto &el: fenw.t) {
            mxx = max(mxx, el);
        }
        cout << mxx;
        return;
    }
    vector<int> uk(n, 0);
    vector<int> t;
    for (int i = 0; i < n; ++i) {
        for (auto &el: a[i]) {
            t.push_back(el);
        }
    }
    t.push_back(0);
    sort(all(t)), t.resize(unique(all(t)) - t.begin());
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(i);
    }
    set<pair<int, int>> nst;
    vector<int> usd(MAXN,-1);
    vector<int> inds(MAXN, -1);
    for (int i = 0; i < n; ++i) {
        if (inds[a[i][0]] == -1) {
            nst.emplace(a[i][0], i);
        } else if (way[i][0] > way[inds[a[i][0]]][0]) {
            int j = inds[a[i][0]];
            nst.erase({a[i][0], j});
            nst.emplace(a[i][0], i);
        }
    }
    for (auto &s: t) {
        int cnt = 0;
        for (auto nw = nst.upper_bound({s + 1, -1}); nw != nst.end(); ++nw) {
            if (++cnt >= 1500) break;
            auto[x, i] = *nw;
            if (dp[s] > dp[mx[i]] - way[i][uk[i]]) { //dp[mx[i]] - way[i][uk[i]] = const
                dp[mx[i]] = dp[s] + way[i][uk[i]]; //dp[mx[i]] - way[i][uk[i]] < dp[s] Такие что
                //a[i][uk[i]] > s
            } //суммарно хуево
        }
        while (!nst.empty() && nst.begin()->X <= s) { //суммарно nlogn
            auto[x, i] = *nst.begin();
            nst.erase(nst.begin());
            while (uk[i] < a[i].size() && a[i][uk[i]] <= s) {
                ++uk[i];
            }
            if (uk[i] == a[i].size()) continue;
            int nw = mx[i];
            int cnt = way[i][uk[i]];
            dp[nw] = max(dp[nw], dp[s] + cnt);
            nst.emplace(a[i][uk[i]], i);
        }
    }
    cout << *max_element(all(dp));
}