#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>

using namespace std;

const int INF = 2 * 1e9 + 1;

int n;
vector<int> suf_max;
vector<pair<int, int>> p;

int find_suf(int x) {
    int l = -1;
    int r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (suf_max[m] > x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int ask(int i, int best, int must) {
    if (best < 0 || best >= n) {
        return INF;
    }
    if (best == i) {
        return INF;
    }
    if (best < must) {
        return INF;
    }
    return p[best].first;
}

int answer(vector<int>& var, int x) {
    int ans = INF;
    for (auto i : var) {
        ans = min(ans, abs(x - i));
    }
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cin >> n;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        p[i] = {a, b};
    }
    sort(p.begin(), p.end());
    for (auto [a, b] : p) {
        cerr << a << ' ' << b << '\n';
    }
    cerr << '\n';

    suf_max.assign(n, 0);
    suf_max[n - 1] = p[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        suf_max[i] = max(suf_max[i + 1], p[i].second);
    }
    for (auto i : suf_max) {
        cerr << i << ' ';
    }
    cerr << '\n';

    int ans = INF;
    for (int i = 0; i < n; ++i) {
        int M = p[i].second;
        pair<int, int> t = {M, 0};
        auto it = lower_bound(p.begin(), p.end(), t);
        int best = min(n - 1, int(it - p.begin())); //fit M the best
        int must = find_suf(M) - 1; //find suf, where we can buy in the second market
        vector<int> var;
        for (int d = -1; d <= 1; ++d) {
            var.push_back(ask(i, best + d, must));
        }
        var.push_back(ask(i, must, must));
        ans = min(ans, answer(var, M));
    }
    cout << ans << '\n';
}
