#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>

#define sc second
#define fr first
#define ll long long
#define ld long double
#define db if(0)
#define int long long

using namespace std;
const int N = 500500;
pair<int, int>  a[N];
int n;

mt19937 gen(13515);

void input(){
    cin >> n;
    for (int i = 0; i < n; ++i){
        cin >> a[i].fr >> a[i].sc;
    }
}


int count(int id){
    int mx = a[id].fr;
    int delta = 2e9;
    int delta0 = 0;

    for (int i = 0; i < n; ++i){
        if (id == i) continue;
        if (a[i].fr > mx){
            delta0 = max(delta0, max(a[i].sc - mx, 0ll));
        }
        delta = min(abs(a[i].sc - mx), delta);
     //   cout << i << ' ' << mx << ' ' << delta << ' ' << delta0 << '\n';
    }
    return max(delta, delta0);
}

int solve_1(){
    int mn = 2e9;
    for (int mask = 0; mask < (1 << n); ++mask){
        int m1 = 0;
        int m2 = 0;
        for (int i = 0; i < n; ++i){
            if (mask & (1 << i)){
                m1 = max(m1, a[i].fr);
            }
            else{
                m2 = max(m2, a[i].sc);
            }
        }
        mn = min(mn, abs(m1 - m2));
    }
    return mn;
}

int solve0(){
    int mn = 2e9;
    for (int i = 0; i < n; ++i){
        mn = min(mn, count(i));
    }
    return mn;
}

void test(){
    n = 3;
    for (int i = 0; i < n; ++i){
        a[i].fr = gen() % 10;
        a[i].sc = gen() % 10;
    }
}
void testing(){
    for (int i = 0; i < 10000; ++i){
        test();
        int a1 = solve_1();
        int a2 = solve0();
        if (a1 != a2){
            cout << "WA " << a1 << ' ' << a2 << '\n';;
            for (int i = 0; i < n; ++i){
                cout << a[i].fr << ' ' << a[i].sc << '\n';
            }
            cout << '\n';
            break;
        }
        else{
            cout << "OK\n";
        }
    }
}


int solve2(){
    sort(a, a + n);
    multiset<int> s1, s2;
    for (int i = 1; i < n; ++i){
        s1.insert(a[i].sc);
    }
    multiset<int>::iterator pt;
    int MN = 2e9;
    for (int i = 0; i < n - 1; ++i){
        int mx1 = a[i].fr;
        int mx20 = -1;
        if (!s1.empty()){
            mx20 = *s1.rbegin();
        }
        if (mx20 >= mx1){
            MN = min(MN, mx20 - mx1);
            pt = s1.find(a[i + 1].sc);
            s1.erase(pt);
            s2.insert(a[i].sc);
            continue;
        }
        int delta = mx1 - mx20;

        if (!s2.empty()){
            pt = s2.lower_bound(mx1);
            if (pt == s2.end()){
                --pt;
            }
            delta = min(delta, abs(mx1 -  *pt));
            ++pt;
            if (pt != s2.end()){
                delta = min(delta, abs(mx1 -  *pt));
            }
        }
        MN = min(MN, delta);

        pt = s1.find(a[i + 1].sc);
        s1.erase(pt);
        s2.insert(a[i].sc);
    }
    int mx1 = a[n - 1].fr;
    int delta = 2e9;
    pt = s2.lower_bound(mx1);
    if (pt == s2.end()){
        --pt;
    }
    delta = min(delta, abs(mx1 -  *pt));
    ++pt;
    if (pt != s2.end()){
        delta = min(delta, abs(mx1 -  *pt));
    }

    MN = min(MN, delta);
    return MN;
}

signed main(){
    //testing();
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    input();
    cout << solve2() << '\n';;
}
