#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

void solve() {
	ll n;
	std::cin >> n;
	v<pll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i].first >> list[i].second;
	}
	std::sort(all(list));
	v<ll> suf(n + 1);
	suf.back() = 0;
	for (int i = n - 1; i >= 0; --i) {
		suf[i] = std::max(suf[i], list[i].second);
	}
	std::multiset<ll> set;
	ll ans = Max;
	for (int i = 0; i < n; ++i) {
		if (i == n - 1 || list[i].first != list[i + 1].first) {
			ll tmp = suf[i + 1];
			ll now = Min;
			auto it = set.lower_bound(list[i].first);
			if (it != set.end() && std::abs(list[i].first - now) > std::abs(list[i].first - *it)) {
				now = *it;
			}
			if (it != set.begin()) {
				--it;
				if (std::abs(now - list[i].first) > std::abs(list[i].first - *it)) {
					now = *it;
				}
			}
			ll max = std::max(now, tmp);
			ans = std::min(ans, std::abs(list[i].first - max));
			set.insert(list[i].second);
		}
	}
	std::cout << ans;
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}