#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

int n;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) {
        return a.second > b.second;
    }
    return a.first < b.first;
}

vector<pair<int, int>> v;

void input() {
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
}

int solve_slow() {
    int ans = 1e9;
    for (int mask = 1; mask < (1ll<<n) - 1; ++mask) {
        int mx1 = 0;
        int mx2 = 0;
        for (int i = 0; i < n; ++i) {
            if (mask&(1ll<<i)) {
                mx1 = max(mx1, v[i].first);
            } else {
                mx2 = max(mx2, v[i].second);
            }
        }
        ans = min(ans, abs(mx1 - mx2));
    }
    return ans;
}

int solve_fast() {
    sort(v.begin(), v.end(), cmp);
    vector<int> suf(n);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = v[i].second;
        if (i != n - 1) {
            suf[i] = max(suf[i], suf[i + 1]);
        }
    }
    int ans = 1e9;
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v[i].first - suf[i + 1]));
    }
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v[n - 1].first - v[i].second));
    }
    return ans;
}

void solve() {
    input();
    cout << solve_slow();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}