#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

class SegmentTree {
private:
    vector<int> d;
    int n;

    void upd(int i) {
        d[i] = (d[2 * i] + d[2 * i + 1]);
    }

public:
    SegmentTree(const vector<int> &v) {
        n = 1;
        while (n < sz(v)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(v); ++i) {
            d[i + n] = v[i];
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += d[l++];
            }
            if (r & 1) {
                res += d[--r];
            }
        }
        return res;
    }

    void upd(int i, int x) {
        d[i += n] = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};

using pii = pair<int, int>;

template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
}

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
};

const int MAXN = 5e5 + 1;
int d[MAXN];

void build() {
    memset(d, 0, sizeof(d));
}

int get(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        res += d[i];
    }
    return res;
}

int get(int l, int r) {
    mnr(r, MAXN - 1);
    mxr(l, 0);
    return get(r) - get(l - 1);
}

void upd(int i, int x) {
    for (; i < MAXN; i |= (i + 1)) {
        d[i] += x;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<pii> v(n);
    map<int, int> cnta, cntb;
    int mxa = 0, mxb = 0;
    for (auto &[a, b]: v) {
        cin >> a >> b;
        ++cnta[a];
        ++cntb[b];
        mxr(mxa, a);
        mxr(mxb, b);
    }
    sort(all(v));
    vector<int> smax(n + 1, -1e9);
    for (int i = n - 1; i >= 0; --i) {
        if (i + 1 < n) {
            smax[i] = smax[i + 1];
        }
        mxr(smax[i], v[i].ss);
    }
    vector<int> szh;
    for (auto[a, b]: v) {
        szh.push_back(b);
    }
    sort(all(szh));
    szh.resize(unique(all(szh)) - szh.begin());
    int l = 0, r = 1e9;
    while (l != r) {
        int mid = (l + r) / 2;
        bool check = false;
        build();
        for (int i = 0; i < n; ++i) {
            if (smax[i + 1] <= v[i].ff + mid) {
                auto l1 = lower_bound(all(szh), v[i].ff - mid) - szh.begin();
                auto l2 = (upper_bound(all(szh), v[i].ff + mid)) - szh.begin();
                if (abs(smax[i + 1] - v[i].ff) <= mid ||
                    get(l1, --l2)) {
                    check = true;
                    break;
                }
            }
            upd(lower_bound(all(szh), v[i].ss) - szh.begin(), 1);
        }
        if (check) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }
    cout << l;
}
