#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;

using namespace std;

vector<int> treemx1, treemx2;

int gtmx1(int i, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return treemx1[i];
    }
    int mid = (l + r) / 2;
    return max(gtmx1(2 * i + 1, l, mid, lq, rq), gtmx1(2 * i + 2, mid, r, lq, rq));
}

int gtmx2(int i, int l, int r, int lq, int rq) {
    if (rq <= l || r <= lq) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return treemx2[i];
    }
    int mid = (l + r) / 2;
    return max(gtmx2(2 * i + 1, l, mid, lq, rq), gtmx2(2 * i + 2, mid, r, lq, rq));
}

void st1(int i, int l, int r, int q, int val) {
    if (l + 1 == r) {
        treemx1[i] = val;
        return;
    }
    int mid = (l + r) / 2;
    if (mid <= q) {
        st1(2 * i + 2, mid, r, q, val);
    } else {
        st1(2 * i + 1, l, mid, q, val);
    }
    treemx1[i] = max(treemx1[2 * i + 1], treemx1[2 * i + 2]);
}

void st2(int i, int l, int r, int q, int val) {
    if (l + 1 == r) {
        treemx2[i] = val;
        return;
    }
    int mid = (l + r) / 2;
    if (mid <= q) {
        st2(2 * i + 2, mid, r, q, val);
    } else {
        st2(2 * i + 1, l, mid, q, val);
    }
    treemx2[i] = max(treemx2[2 * i + 1], treemx2[2 * i + 2]);
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    treemx1.resize(4 * n, 0);
    treemx2.resize(4 * n, 0);
    set<pair<int, int>> st;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        st.insert({ a[i], i });
        st.insert({ b[i], i + n });
    }
    vector<int> used1(n, 0), used2(n, 0);
    int cnt = 0;
    int ans = MOD;
    for (auto p : st) {
        int val = p.first;
        int i = p.second;
        if (i < n) {
            used1[i] = 1;
            if (used2[i] == 0) {
                ++cnt;
            }
            if (cnt == n) {
                int nw = max(gtmx2(0, 0, n, 0, i), gtmx2(0, 0, n, i + 1, n));
                if (nw != 0) {
                    ans = min(ans, val - nw);
                }
            }
            st1(0, 0, n, i, val);
        } else {
            i -= n;
            used2[i] = 1;
            if (used1[i] == 0) {
                ++cnt;
            }
            if (cnt == n) {
                int nw = max(gtmx1(0, 0, n, 0, i), gtmx1(0, 0, n, i + 1, n));
                if (nw != 0) {
                    ans = min(ans, val - nw);
                }
            }
            st2(0, 0, n, i, val);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}