#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define LL __int128
#define F first
#define S second
mt19937 rnd(100);

struct Node {
    Node *L, *R;
    ll y, v, c;
};

ll size(Node *r) {
    return r == nullptr ? 0 : r->c;
}

void update(Node *r) {
    r->c = size(r->L) + 1 + size(r->R);
}

pair<Node *, Node *> split(Node *r, ll k) {
    if (r == nullptr)
        return {nullptr, nullptr};
    else if (size(r->L) >= k) {
        auto p = split(r->L, k);
        r->L = p.S;
        update(r);
        return {p.F, r};
    } else {
        auto p = split(r->R, k - size(r->L) - 1);
        r->R = p.F;
        update(r);
        return {r, p.S};
    }
}

Node *merge(Node *r1, Node *r2) {
    if (r1 == nullptr)
        return r2;
    else if (r2 == nullptr)
        return r1;
    else if (r1->y <= r2->y) {
        r1->R = merge(r1->R, r2);
        update(r1);
        return r1;
    } else {
        r2->L = merge(r1, r2->L);
        update(r2);
        return r2;
    }
}

/*
struct mst {
    vector<vector<pair<ll, ll>>> arr;
    ll size;

    mst(vector<pair<ll, ll>> &inp) {
        ll k = 1;
        while (k < inp.size())
            k *= 2;
        size = k * 2;
        arr.resize(size);
        for (int i = 0; i < inp.size(); ++i)
            arr[i + k] = {inp[i]};
        while (--k)
            merge(k);
    }

    void merge(ll x) {
        ll s1 = arr[x * 2].size();
        ll s2 = arr[x * 2 + 1].size();
        ll p1 = 0, p2 = 0;
        arr[x].resize(s1 + s2);

        while (p1 + p2 < s1 + s2)
            if (p2 == s2 || p1 != s1 && arr[x * 2][p1] < arr[x * 2 + 1][p2])
                arr[x][p1 + p2] = arr[x * 2][p1], p1++;
            else
                arr[x][p1 + p2] = arr[x * 2 + 1][p2], p2++;
    }

    ll l1, r1, l2, r2, ans;

    ll ask(ll _l1, ll _r1, ll _l2, ll _r2) {
        l1 = _l1, r1 = _r1, l2 = _l2, r2 = _r2, ans = 0;
        ask(0, size / 2, 1);
        return ans;
    }

    void ask(ll L, ll R, ll now) {
        if (L >= l1 && R <= r1) {
            ll l = -1, r = arr[now].size(), mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (arr[now][mid] < l2)
                    l = mid;
                else
                    r = mid;
            }
            ll le = -1, ri = arr[now].size();
            while (ri - le > 1) {
                mid = (ri + le) / 2;
                if (arr[now][mid] >= r2)
                    ri = mid;
                else
                    le = mid;
            }
            ans += le - l;
        } else if (L >= r1 || R <= l1)
            return;
        else
            ask(L, (R + L) / 2, now * 2), ask((R + L) / 2, R, now * 2 + 1);
    }
};
*/
unordered_map<ll, ll> dp;

ll sum(ll l, ll r) {
    ll h1, h2;
    if (!dp.count(r)) {
        cout << "? " << r << endl;
        cin >> h1;
        if (h1 == -1)
            ::exit(0);
        dp[r] = h1;
    } else
        h1 = dp[r];
    if (!dp.count(l - 1)) {
        cout << "? " << l - 1 << endl;
        cin >> h2;
        if (h2 == -1)
            ::exit(0);
        dp[l - 1] = h2;
    } else
        h2 = dp[l - 1];
    return (r * (r + 1) / 2 - h1) - (l * (l - 1) / 2 - h2);
} // Сумма живых чисел на отрезке. 2 операции

vector<ll> ans;

ll find(ll l, ll r, ll kmi, ll kma) {
    if (kmi == r - l + 1) {
        for (int i = l; i <= r; ++i)
            ans.push_back(i);
        return r - l + 1;
    }
    if (kmi == kma && kma == 1) {
        if (l != r)
            ans.push_back(sum(l, r));
        else
            ans.push_back(l);
        return 1;
    }
    if (!kma || l >= r)
        return 0;

    ll su = sum(l, r);

    ll l1 = kmi, r1 = kma + 1, mid;
    while (r1 - l1 > 1) {
        mid = (r1 + l1) / 2;
        if ((l + mid - 1) * (l + mid) / 2 - l * (l - 1) / 2 <= su)
            l1 = mid;
        else
            r1 = mid;
    }
    kma = min(kma, l1);

    l1 = kmi - 1, r1 = kma;
    while (r1 - l1 > 1) {
        mid = (r1 + l1) / 2;
        if (r * (r + 1) / 2 - (r - mid) * (r - mid + 1) / 2 >= su)
            r1 = mid;
        else
            l1 = mid;
    }
    kmi = max(kmi, r1);

    if (!su)
        return 0;
    if (!kma || l >= r)
        return 0;
    if (kmi == r - l + 1) {
        for (int i = l; i <= r; ++i)
            ans.push_back(i);
        return r - l + 1;
    }
    if (kmi == kma && kma == 1) {
        ans.push_back(su);
        return 1;
    }

    ll h1 = find(l, (r + l) / 2, max(0ll, kmi - (r - (r + l) / 2)), min(kma, (r + l) / 2 - l + 1));
    ll h2 = find((r + l) / 2 + 1, r, max(0ll, kmi - h1), kma - h1);
    return h1 + h2;
}


int main() {
    cin.tie(0), ios_base::sync_with_stdio(0);

    /*
    ll _, a;
    cin >> _;
    while (_--) {
        dp.clear();
        dp[0] = 0;
        ans.clear();

        ll n, k;
        cin >> n >> k;
        find(1, n, k, k);

        sort(ans.begin(), ans.end());
        cout << "! ";
        for (ll i: ans)
            cout << i << ' ';
        cout << endl;
        cin >> a;
        if (a == -1)
            return 0;
    }
    */

    ll n;
    cin >> n;
    vector<pair<ll, ll>> arr(n);
    for (auto &p: arr)
        cin >> p.F >> p.S;
    sort(arr.begin(), arr.end());
    map<ll, set<pair<ll, ll>>> se1; // {y, {{x1, i1}, {x2, i2}, {x3, i3} ...}} Для второго множества
    priority_queue<tuple<ll, ll, ll>> pq; // {y, x, i} Для кандидатов в кандидаты из первого множества
    set<tuple<ll, ll, ll>> se2; // Для кандидатов из первого множества
    vector<tuple<ll, ll, ll>> help;
    ll ans = LLONG_MAX;

    for (int i = 0; i < n; ++i) {
        if (!se1.count(arr[i].S))
            se1[arr[i].S] = *new set<pair<ll, ll>>;
        se1[arr[i].S].insert({arr[i].F, i});
    }

    for (int i = 0; i < n; ++i) {
        help.push_back({arr[i].F, arr[i].S, i});

        pq.push({arr[i].S, arr[i].F, i});
        if (i != n - 1 && arr[i].F == arr[i + 1].F)
            continue;

        for (auto t: help) { // перебираем венец эволюции

            while (!se1.empty()) {
                while (!(--se1.end())->S.empty() && (--(--se1.end())->S.end())->S <= i)
                    (--se1.end())->S.erase((--(--se1.end())->S.end()));
                if (!(--se1.end())->S.empty()) {
                    ans = min(ans, abs(get<0>(t) - (--se1.end())->F));
                    break;
                } else
                    se1.erase((--se1.end()));
            }

            while (!pq.empty() && (se1.empty() || get<0>(pq.top()) >= (--se1.end())->F)) {
                se2.insert(pq.top());
                pq.pop();
            }

            tuple<ll, ll, ll> h1 = {get<1>(t), get<0>(t), get<2>(t)};
            bool b = se2.count(h1);
            if (b)
                se2.erase(h1);

            if (!se2.empty()) {
                auto h = se2.lower_bound({get<0>(t), -1, -1});
                if (h != se2.end())
                    ans = min(ans, abs(get<0>(t) - get<0>(*h)));
                if (h != se2.begin())
                    ans = min(ans, abs(get<0>(t) - get<0>(*(--h))));
            }

            if (b)
                se2.insert(h1);
        }
        help.clear();

    }

    cout << ans;

    return 0;
}
/*
3
1 2
5 6
3 1


5
1 5
2 7
3 3
4 10
2 5

2
1 2
2 1

 */
/*
Среди набора пар чисел нужно выбрать два числа разного типа и из разных групп
 чтобы из каждой пары можно было бы выбрать число меньшего значения чем соответствующее
 и чтобы разница между выбранными была минимальна

4324332
4 2
5
2

 */
/*
1 3 4 5  7  9
1 4 8 13 20 29
 */
/*
D-шка бфс
 За какое количество выступений мы сможем попасть в город i с макс прибылью j за выступление и с l по r


B
 Нужно выбрать 2 различные точки а остальные разделить на множества чтобы одна точка была правее всех в своем множестве, а другая выше чтобы abs(x1 - y2) был минимальным
Допустим мы берем какую-то точку
 Изначально пишаем все точки ниже ее в одно множество
 Среди остальных берем самую правую

 Если вторая нужная точка в том множестве то она самая правая
 иначе она в первом множестве и правее всех точек во втором
 Среди всех точек первого множества которые правее второго берем ту у которой ближе всего к нужному

 1. Отсортим пары
 Певое множество всегда будет префиксом
 Будем хранить верхнюю точку первого множества
 Нужно уметь находить максимум по второй координате в правом множестве с ближайшей к нашей
 Для этого для правого множества будем хранить сет сетов

 Нужно уметь среди точек первого множества находить ближайшую по значению к конкретному
 и при этом чтобы другой параметр был больше или равен максимуму в правом множестве. СЕТ
 */