#include <iostream>
#include <algorithm>
#include <fstream>

#include <vector>
#include <map>
#include <set>

#include <stack>
#include <queue>
#include <deque>

using namespace std;

using ll = long long;
using ld = long double;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

struct stores{
    ll a, b;
};

bool operator==(stores s1, stores s2){
    return s1.a == s2.a && s1.b == s2.b;
}

bool compA(stores s1, stores s2){
    if (s1.a != s2.a){
        return s1.a < s2.a;
    }
    return s1.b < s2.b;
}

bool compB(stores s1, stores s2){
    if (s1.b != s2.b){
        return s1.b < s2.b;
    }
    return s1.a < s2.a;
}

int main(){
    ll n;
    cin >> n;
    vector<stores> AB(n);
    for (ll i = 0; i < n; i++){
        cin >> AB[i].a >> AB[i].b;
    }
    stable_sort(AB.begin(), AB.end(), compA);

    vl suff_max_b(n);
    suff_max_b[n - 1] = AB.back().b;
    for (ll i = n - 2; i >= 0; i--){
        suff_max_b[i] = max(suff_max_b[i], suff_max_b[i + 1]);
    }

    vector<stores> AB_bsort = AB;
    stable_sort(AB_bsort.begin(), AB_bsort.end(), compB);

    ll ans = -1;
    ll old_a = AB.back().a;
    ll curr_a = 0;
    ll curr_b_min = 0;
    for (ll i = n - 1; i >= 0; i--){
        curr_a = AB[i].a;
        if (curr_a < old_a){
            curr_b_min = suff_max_b[i + 1]; 
        }

        ll left = 0, right = n, middle = 0;
        while (left + 1 < right){
            middle = (left + right) / 2;
            if (AB_bsort[middle].b < curr_b_min){
                left = middle;
            }
            else{
                right = middle;
            }
        }
        ll b_index = left;
        if (AB_bsort[left].b < curr_b_min){
            b_index++;
        }
        
        left = b_index; right = n, middle = 0;
        while (left + 1 < right){
            middle = (left + right) / 2;
            if (AB_bsort[middle].b < curr_a){
                left = middle;
            }
            else{
                right = middle;
            }
        }

        if (AB_bsort[left] == AB[i]){
            if (left - 1 >= b_index){
                ll val = abs(curr_a - AB_bsort[left - 1].b);
                if (val < ans || ans < 0){
                    ans = val;
                }
            }
            if (left + 1 < n){
                ll val = abs(curr_a - AB_bsort[left + 1].b);
                if (val < ans || ans < 0){
                    ans = val;
                }
            }
        }
        else{
            ll val = abs(curr_a - AB_bsort[left].b);
            if (val < ans || ans < 0){
                ans = val;
            }
        }

        if (AB_bsort[left].b < curr_a){
            if (left + 1 < n){
                if (AB_bsort[left + 1] == AB[i]){
                    if (left + 2 < n){
                        ll val = abs(curr_a - AB_bsort[left + 2].b);
                        if (val < ans || ans < 0){
                            ans = val;
                        }
                    }
                }
                else{
                    ll val = abs(curr_a - AB_bsort[left + 1].b);
                    if (val < ans || ans < 0){
                        ans = val;
                    }
                }
            }
        }

        old_a = curr_a;
    }

    ll ans2 = -1;
    for (ll i = 0; i < n; i++){
        for (ll j = 0; j < n; j++){
            if (i == j){
                continue;
            }

            ll val = abs(AB[i].a - AB[j].b);
            bool is_good = true;            
            for (ll k = 0; k < n; k++){
                if (AB[k].a > AB[i].a && AB[k].b > AB[j].b){
                    is_good = false;
                }
            }
            if (is_good){
                if (ans2 > val || ans2 < 0){
                    ans2 = val;
                }
            }
        }
    }

    //cout << ans << '\n';
    cout << ans2 << '\n';
    // if (ans == ans2){
    //     cout << "OK";
    // }
    // else{
    //     cout << "WA";
    // }
    return 0;
}