#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define ld long double
#define ull unsigned long long
#define x first
#define y second

const ll INF = 1e17 + 10, MOD1 = 1e9 + 7, MOD = 228228227, N = 5e5 + 2, MAXN = 1e5 + 2;
const ld EPS = 0.00000001;

random_device rd;
mt19937 rnd(rd());

struct node{
    int v, l, r, i;
};

vector<vector<node>> tree(2, vector<node>(4 * MAXN));
vector<vector<int>> a(2, vector<int>(5e5 + 2));

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[0][v] = {a[0][l], l, r, l};
        tree[1][v] = {a[1][l], l, r, l};
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[0][v] = {max(tree[0][2 * v + 1].v, tree[0][2 * v + 2].v), l, r};
    if (tree[0][2 * v + 1].v > tree[0][2 * v + 2].v) {
        tree[0][v].i = tree[0][2 * v + 1].i;
    } else {
        tree[0][v].i = tree[0][2 * v + 2].i;
    }
    tree[1][v] = {max(tree[1][2 * v + 1].v, tree[1][2 * v + 2].v), l, r};
    if (tree[1][2 * v + 1].v > tree[1][2 * v + 2].v) {
        tree[1][v].i = tree[1][2 * v + 1].i;
    } else {
        tree[1][v].i = tree[1][2 * v + 2].i;
    }
}

pair<int, int> get(int v, int t) {
    return {tree[t][v].v, tree[t][v].i};
}

void update(int v, int i, int t) {
    if (tree[t][v].r - tree[t][v].l == 1) {
        tree[t][v].v = -1;
        return;
    }
    int m = (tree[t][v].r + tree[t][v].l) / 2;
    if (i > m) {
        update(2 * v + 1, i, t);
    } else {
        update(2 * v + 2, i, t);
    }
    tree[t][v].v = max(tree[t][2 * v + 1].v, tree[t][2 * v + 2].v);
    if (tree[t][2 * v + 1].v > tree[t][2 * v + 2].v) {
        tree[t][v].i = tree[t][2 * v + 1].i;
    } else {
        tree[t][v].i = tree[t][2 * v + 2].i;
    }
}

void solve() {
    int n;
    cin >> n;
    bool fl = true;
    set<pair<int, pair<int, int>>, greater<pair<int, pair<int, int>>>> st;
    for (int i = 0; i < n; i++) {
        cin >> a[0][i] >> a[1][i];
        st.insert({a[0][i], {i, 0}});
        st.insert({a[1][i], {i, 1}});
        if (a[0][i] != a[1][i]) {
            fl = false;
        }
    }
    int ans = 1e9 + 3;
    if (fl) {
        sort(a[0].begin(), a[0].end());
        cout << a[0][n - 1] - a[0][n - 2];
        return;
    }
    build(0, 0, n);
    vector<int> used(n), mx(2);
    while (!st.empty()) {
        auto k = *st.begin();
        st.erase(st.begin());
        int i = k.y.x, v = k.x, t = k.y.y;
        update(0, i, t);
        if (used[i]) {
            continue;
        }
        vector<int> mx1 = mx;
        mx1[t] = max(mx1[t], v);
        int t1 = (t + 1) % 2;
        update(0, i, t1);
        auto k1 = get(0, t1);
        mx1[t1] = max(mx1[t1], k1.x);
        st.erase({a[t1][i], {i, t1}});
        ans = min(ans, abs(mx1[t1] - mx1[t]));
        mx[t1] = max(mx[t1], a[t1][i]);
        used[i] = 1;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}