#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>
#include<set>
#include<tuple>


using namespace std;
typedef long long ll;


vector<multiset<int>> t1;
vector<vector<int>> t;
const int INF = 2000000000;
vector<int> tree;


void build(vector<int>& m)
{
    t1.resize(m.size());
    t.resize(m.size());
    for (int i = 0; i < m.size(); i++)
    {
        for (int j = i; j < m.size(); j = j | (j + 1))
        {
            t1[j].insert(m[i]);
        }
    }
    for (int i = 0; i < m.size(); i++)
    {
        t[i].resize(t1[i].size());
        int ind = 0;
        for (auto el: t1[i])
        {
            t[i][ind] = el;
            ind++;
        }
    }
    return;
}


pair<int, int> get_zapr(int R, int x)
{
    int ans1 = INF;
    int ans2 = -INF;
    for (int r = R; r >= 0; r = (r & (r + 1)) - 1)
    {
        auto it = upper_bound(t[r].begin(), t[r].end(), x);
        if (it != t[r].end())
        {
            ans1 = min(ans1, *it);
        }
        auto it1 = lower_bound(t[r].begin(), t[r].end(), x);
        if (it1 != t[r].begin())
        {
            --it1;
            ans2 = max(ans2, *it1);
        }
    }
    return {ans1, ans2};
}


void build_tree(int k, int l, int r, vector<int>& m)
{
    if (r - l == 1)
    {
        tree[k] = m[l];
        return;
    }
    build_tree(2 * k, l, (l + r) / 2, m);
    build_tree(2 * k + 1, (l + r) / 2, r, m);
    tree[k] = max(tree[2 * k], tree[2 * k + 1]);
    return;
}


int get_mx(int k, int l, int r, int lf, int rf)
{
    if (l >= rf || r <= lf)
    {
        return -INF;
    }
    if (lf <= l && rf >= r)
    {
        return tree[k];
    }
    return max(get_mx(2 * k, l, (l + r) / 2, lf, rf), get_mx(2 * k + 1, (l + r) / 2, r, lf, rf));
}



int main()
{
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; i++)
    {
        cin >> p[i].first >> p[i].second;
    }
    sort(p.begin(), p.end());
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = p[i].second;
    }
    tree.resize(4 * n);
    build_tree(1, 0, n, a);
    build(a);
    int ans = INF;
    for (int i = 0; i < n ; i++)
    {
        int mx = get_mx(1, 0, n, i + 1, n);
        int ansnow = INF;
        auto [mn1, mx1] = get_zapr(i - 1, p[i].first);
        if (mn1 >= mx && mn1 != INF)
        {
            ansnow = min({ansnow, abs(p[i].first - mn1), abs(mx1 - p[i].first)});
        }
        else if (mx < mx1)
        {
            ansnow = min({ansnow, abs(mx - p[i].first), abs(mx1 - p[i].first)});
        }
        else
        {
            ansnow = min(ansnow, abs(mx1 - p[i].first));
        }
        ans = min(ansnow, ans);
    }
    cout << ans;
    return 0;
}
