// #define _GLIBCXX_DEBUG_PEDANTIC
// думай о правильности перед написанием
// проверяй идеи
// проверяй правильность кода
// пробуй разные подходы
// не задерживайся слишком долго на одной задаче
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;

const int INF = 1e9 + 200;

struct FenwickTreeMax {
    vector<int> tree;
    int size;

    FenwickTreeMax(int n) {
        size = n;
        tree.assign(size, 0);
    }

    void update(int pos, int value) {
        for (int i = pos; i < size; i |= i + 1) {
            tree[i] = max(tree[i], value);
        }
    }

    int query(int pos) {
        int res = 0;
        for (int i = pos; i >= 0; i = (i & (i + 1)) - 1) {
            res = max(res, tree[i]);
        }
        return res;
    }
};

struct FenwickTreeMin {
    vector<int> tree;
    int size;

    FenwickTreeMin(int n) {
        size = n;
        tree.assign(size, INF);
    }

    void update(int pos, int value) {
        for (int i = pos; i < size; i |= i + 1) {
            tree[i] = min(tree[i], value);
        }
    }

    int query(int pos) {
        int res = INF;
        for (int i = pos; i >= 0; i = (i & (i + 1)) - 1) {
            res = min(res, tree[i]);
        }
        return res;
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> values;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        values.push_back(a[i].first);
        values.push_back(a[i].second);
    }

    sort(values.begin(), values.end());
    values.resize(unique(values.begin(), values.end()) - values.begin());
    int m = values.size();

    map<int, int> mp;
    for (int i = 0; i < m; ++i) {
        mp[values[i]] = i;
    }

    int ans = 1e9 + 5;
    {
        sort(a.begin(), a.end());
        
        FenwickTreeMax tree_max(m);
        FenwickTreeMin tree_min(m);

        vector<int> pref_max(n + 1);
        for (int i = n - 1; i >= 0; --i) {
            pref_max[i] = max(pref_max[i + 1], a[i].second);
        }
        for (int i = 0; i < n; ++i) {
            if (i != n - 1) {
                ans = min(ans, abs(a[i].first - pref_max[i + 1]));
            }
            {
                int mx1 = tree_max.query(mp[a[i].first]);
                ans = min(ans, abs(a[i].first - max(mx1, pref_max[i + 1])));
                int mx2 = tree_min.query(m - mp[a[i].first] - 1);
                ans = min(ans, abs(a[i].first - max(mx2, pref_max[i + 1])));
            }
            tree_min.update(m - mp[a[i].second] - 1, a[i].second);
            tree_max.update(mp[a[i].second], a[i].second);
        }
    }

    cout << ans << '\n';

    return 0;
}