#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>

using namespace std;
using pii = pair<int, int>;

int search(vector<pii>& a, int x, int canNot) {
    int predl = -1, predr = -1;
    int l = 0;
    int r = a.size();
    while (r - l > 1 ) {
        predl = l;
        predr = r;
        int m1 = (2 * l + r) / 3;
        int m2 = (l + 2 * r) / 3;
        int res1 = abs(x - a[m1].first);
        int res2 = abs(x - a[m2].first);
        if (res1 <= res2) {
            r = m2;
        } else {
            l = m1;
        }
        if (predl == l && predr == r) break;
    }
    if (a[l].second == canNot) {
        if (l > 0) {
            l--;
        } else {
            l++;
        }
    }
    if (a[r].second == canNot) {
        if (r < a.size() - 2) {
            r++;
        } else {
            r--;
        }
    }
    if (abs(x - a[l].first) <= abs(x - a[r].first)) {
        return l;
    } else {
        return r;
    }
}

int main() {
    int n, x, y;
    cin >> n;
    vector<int> a;
    vector<int> b;
    vector<pii> c, d;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a.emplace_back(x);
        b.emplace_back(y);
        c.emplace_back(x, i);
        d.emplace_back(y, i);
    }
    sort(c.rbegin(), c.rend());
    sort(d.rbegin(), d.rend());
    int ans = 1e9;
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        x = c[i].first;
        if (i != 0) {
            cur = max(cur, b[c[i - 1].second]);
        }
        int ind = search(d, x, c[i].second);
        ans = min(ans, min(abs(x - cur), abs(x - d[ind].first)));
    }
    cout << ans << endl;

    return 0;
}
