#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 5E5, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

bool used_a[MAXN], used_b[MAXN];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <pair <int, int>> a(n), b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first >> b[i].first;
		a[i].second = i;
		b[i].second = i;
	}
	sort(ALL(a));
	sort(ALL(b));

	int ans = 1E9 + 1;
	int i = n - 1, j = 0, max_suf_a = n - 1, max_suf_b = 0;
	for (; j < n; j++)
	{
		used_a[b[j].second] = true;
		while (max_suf_a >= 0 and used_a[a[max_suf_a].second])
		{
			--max_suf_a;
		}

		while (i >= 0 and a[i].first >= b[j].first and max_suf_b <= j + 1 and max_suf_a <= i)
		{
			used_b[a[i].second] = true;
			while (max_suf_b < n and used_b[b[max_suf_b].second])
			{
				++max_suf_b;
			}

			--i;
		}

		if (i != n - 1)
		{
			if (a[i + 1].second == b[j].second)
			{
				if (i != n - 2)
				{
					if (a[i + 2].first >= b[j].first)
					{
						rmin(ans, a[i + 2].first - b[j].first);
					}
				}
			}
			else
			{
				if (a[i + 1].first >= b[j].first)
				{
					rmin(ans, a[i + 1].first - b[j].first);
				}
			}
		}
	}

	fill(used_a, used_a + n, false);
	fill(used_b, used_b + n, false);
	i = 0;
	j = n - 1;
	max_suf_a = 0;
	max_suf_b = n - 1;
	for (; i < n; i++)
	{
		used_b[a[i].second] = true;
		while (max_suf_b >= 0 and used_b[b[max_suf_b].second])
		{
			--max_suf_b;
		}

		while (j >= 0 and b[j].first>=a[i].first and max_suf_a <= i + 1 and max_suf_b <= j)
		{
			used_a[b[j].second] = true;
			while (max_suf_a < n and used_a[a[max_suf_a].second])
			{
				++max_suf_a;
			}

			--j;
		}

		if (j != n - 1)
		{
			if (a[i].second == b[j + 1].second)
			{
				if (j != n - 2)
				{
					if (b[j + 2].first >= a[i].first)
					{
						rmin(ans, b[j + 2].first - a[i].first);
					}
				}
			}
			else
			{
				if (b[j + 1].first >= a[i].first)
				{
					rmin(ans, b[j + 1].first - a[i].first);
				}
			}
		}
	}
	cout << ans;
}