#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 5E5, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

bool used_a[MAXN], used_b[MAXN];
int tm_max_suf_a[MAXN + 1], tm_max_suf_b[MAXN + 1];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <pair <int, int>> a(n), b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first >> b[i].first;
		a[i].second = i;
		b[i].second = i;
	}
	sort(ALL(a));
	sort(ALL(b));

	int max_suf = n - 1;
	for (int i = 0; i < n; i++)
	{
		used_b[a[i].second] = true;
		while (max_suf >= 0 and used_b[b[max_suf].second])
		{
			tm_max_suf_b[max_suf] = i;
			--max_suf;
		}
	}
	max_suf = n - 1;
	for (int i = 0; i < n; i++)
	{
		used_a[b[i].second] = true;
		while (max_suf >= 0 and used_a[a[max_suf].second])
		{
			tm_max_suf_a[max_suf] = i;
			--max_suf;
		}
	}

	int ans = 1E9 + 1;
	for (int i = 0; i < n; i++)
	{
		int l = tm_max_suf_a[i + 1] - 1, r = n;
		rmax(l, lower_bound(ALL(b), make_pair(a[i].first, 0)) - b.begin() - 1);
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			if (tm_max_suf_b[mid + 1] > i)
			{
				l = mid;
			}
			else
				r = mid;
		}

		int j = r;
		if (j != n)
		{
			if (a[i].second == b[j].second)
			{
				if (j != n - 1)
				{
					if (b[j + 1].first >= a[i].first)
					{
						rmin(ans, b[j + 1].first - a[i].first);
					}
				}
			}
			else
			{
				if (b[j].first >= a[i].first)
				{
					rmin(ans, b[j].first - a[i].first);
				}
			}
		}
	}

	for (int i = 0; i < n; i++)
	{
		int l = tm_max_suf_b[i + 1] - 1, r = n;
		rmax(l, lower_bound(ALL(a), make_pair(b[i].first, 0)) - a.begin() - 1);
		while (r - l > 1)
		{
			int mid = (l + r) / 2;
			if (tm_max_suf_a[mid + 1] > i)
			{
				l = mid;
			}
			else
				r = mid;
		}

		int j = r;
		if (j != n)
		{
			if (b[i].second == a[j].second)
			{
				if (j != n - 1)
				{
					if (a[j + 1].first >= b[i].first)
					{
						rmin(ans, a[j + 1].first - b[i].first);
					}
				}
			}
			else
			{
				if (a[j].first >= b[i].first)
				{
					rmin(ans, a[j].first - b[i].first);
				}
			}
		}
	}
	cout << ans;
}