#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>


using namespace std;

typedef long long ll;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return ((a - b) % m + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector<int> a(n);
	vector<int> b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	vector<pair<int, int>> arr(n);
	for (int i = 0; i < n; i++) {
		arr[i] = { a[i], b[i] };
	}
	sort(arr.begin(), arr.end());
	vector<int> mx_suff(n);
	mx_suff[n - 1] = arr[n - 1].second;
	for (int i = n - 2; i >= 0; i--) {
		mx_suff[i] = max(mx_suff[i + 1], arr[i].second);
	}
	int ans = 1e9;
	for (int i = 0; i + 1 < n; i++) {
		int mx1 = arr[i].first;
		int mx2 = mx_suff[i + 1];
		ans = min(abs(mx1 - mx2), ans);
	}
	cout << ans << '\n';
	exit(0);
}