#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(1);
unordered_map<int, int> se;

struct node {
    int x, y, k, sum;
    node *l = 0, *r = 0;

    node(int x1) {
        x = x1;
        y = rnd();
        k = 1;
        sum = x1;
    }
};

node *root = 0;

int get(node *v) {
    if (!v) return 0;
    return v->sum;
}

void upd(node *v) {
    v->sum = get(v->l) + get(v->r) + v->x;
}

node *merge(node *v, node *u) {
    if (!v) return u;
    if (!u) return v;
    if (v->y < u->y) {
        u->l = merge(v, u->l);
        upd(u);
        return u;
    } else {
        v->r = merge(v->r, u);
        upd(v);
        return v;
    }
}

pair<node *, node *> split(node *v, int x) {
    if (!v) return {0, 0};
    if (v->x > x) {
        auto f = split(v->l, x);
        v->l = f.second;
        upd(v);
        return {f.first, v};
    } else {
        auto f = split(v->r, x);
        v->r = f.first;
        upd(v);
        return {v, f.second};
    }
}

void del(int x) {
    se[x]--;
    if (se[x] != 0) {
        return;
    }
    auto [v1, v2] = split(root, x);
    auto [v3, v4] = split(v1, x - 1);
    root = merge(v3, v2);
}

void ins(int x) {
    se[x]++;
    if (se[x] != 1) return;
    auto [v1, v2] = split(root, x);
    node *x1 = new node(x);
    root = merge(v1, x1);
    root = merge(root, v2);
}

int find_r(node *v) {
    if (!v) return -1e18;
    if (!(v->r)) return v->x;
    return find_r(v->r);
}

int find_l(node *v) {
    if (!v) return -1e18;
    if (!(v->l)) return v->x;
    return find_l(v->l);
}

signed main() {
    int n;
    cin >> n;
    vector<pair<int, int>> w;
    bool br = 1;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        w.push_back({x, y});
        if (x != y) br = 0;
    }
    if (br) {
        sort(w.begin(), w.end());
        cout << w[n - 1].first - w[n - 2].first;
        return 0;
    }
    sort(w.begin(), w.end());
    for (int i = 0; i < n; i++) {
        ins(w[i].second);
    }
    int ma2 = -1e18, ans = 1e18;
    int last = n - 1;
    for (int i = n - 1; i > -1; i--) {
        while (w[last].first > w[i].first) {
            del(w[last].second);
            last--;
        }
        int ma1 = w[i].first;
        del(w[i].second);
        auto [v1, v2] = split(root, w[i].first);
        ans = min(ans, abs(max(ma2, find_r(v1) - ma1)));
        ans = min(ans, abs(max(ma2, find_l(v2) - ma1)));
        root = merge(v1, v2);
        ins(w[i].second);
        ans = min(ans, abs(ma1 - ma2));
        ma2 = max(ma2, w[i].second);
    }
    cout << ans;
}