#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#if !defined LOCAL && !defined DEBUG
#define USE_FAST_IO
#endif

#ifdef USE_FAST_IO
#define endl '\n'
#endif

using namespace std;

const int INF = 1'000'000'007;

int main() {
#ifdef USE_FAST_IO
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n; cin >> n;
    vector<pair<int, int>> by_as;
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        by_as.emplace_back(a, b);
    }
    sort(by_as.begin(), by_as.end());
    vector<int> bs_sufmax(n + 1, -INF), bs_prefmax(n + 1, -INF);
    for (int i = n - 1; i >= 0; i--) {
        bs_sufmax[i] = max(bs_sufmax[i + 1], by_as[i].second);
    }
    for (int i = 0; i < n; i++) {
        bs_prefmax[i + 1] = max(bs_prefmax[i], by_as[i].second);
    }
    int ans = INF;
    multiset<int> bs_pref;
    multiset<int> bs_suff;
    for (int i = 0; i < n; i++) {
        bs_suff.insert(by_as[i].second);
    }
    int ptr = 0;
    for (int i = 0; i < n; i = ptr) {
        while (ptr < n && by_as[i].first == by_as[ptr].first) {
            ptr++;
        }
        for (int j = i; j < ptr; j++) {
            bs_suff.erase(bs_suff.find(by_as[j].second));
            if (ptr - i > 1) {
                bs_pref.insert(by_as[j].second);
            }
        }
        int a = by_as[i].first;
        auto it_pref = bs_pref.upper_bound(a);
        auto it_suff = bs_suff.upper_bound(a);
        if (it_suff != bs_suff.end()) {
            ans = min(ans, *it_suff - a);
        } else {
            if (it_suff != bs_suff.begin()) {
                    auto new_it_suff = it_suff;
                    --new_it_suff;
                if (it_pref != bs_pref.end()) {
                   ans = min(ans, min(*it_pref - a, a - *new_it_suff));
                } else {
                    ans = min(ans, a - *new_it_suff);
                }
            } else {
                if (it_pref != bs_pref.end() && it_pref != bs_pref.begin()) {
                    auto new_it_pref = it_pref;
                    --new_it_pref;
                    ans = min(ans, min(*it_pref - a, a - *new_it_pref));
                } else if (it_pref != bs_pref.end()) {
                    ans = min(ans, *it_pref - a);
                } else if (it_pref != bs_pref.begin()) {
                    --it_pref;
                    ans = min(ans, a - *it_pref);
                }
            }
        }
        for (int j = i; j < ptr; j++) {
            bs_pref.insert(by_as[i].second);
        }
    }
    cout << ans << endl;
}
