#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#if !defined LOCAL && !defined DEBUG
#define USE_FAST_IO
#endif

#ifdef USE_FAST_IO
#define endl '\n'
#endif

using namespace std;

const int INF = 1'000'000'007;

int main() {
#ifdef USE_FAST_IO
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n; cin >> n;
    vector<pair<int, int>> by_as;
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        by_as.emplace_back(a, b);
    }
    sort(by_as.begin(), by_as.end());
    int ans = INF;
    for (int mask = 1; mask < ((1 << n) - 1); mask++) {
        int mx1 = -INF, mx2 = -INF;
        for (int bit = 0; bit < n; bit++) {
            if ((mask >> bit) & 1) {
                mx1 = max(mx1, by_as[bit].first);
            } else {
                mx2 = max(mx2, by_as[bit].second);
            }
        }
        ans = min(ans, abs(mx2 - mx1));
    }
    cout << ans << endl;
}
