#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x, y;

    Point(int x, int y) {
        this->x = x;
        this->y = y;
    }

    friend int operator%(Point a, Point b) {
        return a.x * b.y - a.y * b.x;
    }

    friend int operator*(Point a, Point b) {
        return a.x * b.x + a.y * b.y;
    }

    friend Point operator+(Point a, Point b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend Point operator-(Point a, Point b) {
        return {a.x - b.x, a.y - b.y};
    }

    long long len_sq(Point a) {
        return a.x * a.x + a.y * a.y;
    }

    double len(Point a) {
        return sqrt(len_sq(a));
    }

    long long dist_sq(Point a, Point b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
    }

    double dist(Point a, Point b) {
        return sqrt(dist_sq(a, b));
    }

    bool check_collinear(Point a, Point b) {
        if (abs(double(a.x) / double(b.x) - double(a.y) / double(b.y)) < 1e-8) {
            return true;
        }
        return false;
    }

};

bool comp_points(Point a, Point b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

void obol(vector<Point> arr) {
    int min_x = -1e9;
    Point min(1e9, 1e9);
    queue<Point> q;
    sort(arr.begin(), arr.end(), comp_points);
    q.push(arr[0]);
    q.push(arr[1]);
    int i = 2;
}

vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        int a1, b1;
        cin >> a1 >> b1;
        a[i] = {a1, i};
        b[i] = {b1, i};
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int ind1 = a.size() - 1;
    int ind2 = b.size() - 1;
    long long ans = 1e9;
    vector<short> flag_a(n, 0);
    vector<short> flag_b(n, 0);
    pair<int, int> m1;
    pair<int, int> m2;
    while (true) {
        m1 = a[ind1];
        m2 = b[ind2];
        if (flag_a[m1.second] == 1) {
            if (ind2 >= 1) {
                ans = min(ans, 1ll * abs(m1.first - b[ind2 - 1].first));
            }
            ans = min(ans, 1ll * abs(m1.first - m2.first));
            break;
        }
        if (flag_b[m2.second] == 1) {
            if (ind1 >= 1) {
                ans = min(ans, 1ll * abs(m2.first - b[ind1 - 1].first));
            }
            ans = min(ans, 1ll * abs(m2.first - m1.first));
            break;
        }
        //1, i = j
        //berem ai  i   bj
        if (m1.second != m2.second) {
            ans = min(ans, 1ll * abs(m1.first - m2.first));
        }
        //berem ai  i   bj-2
        if (ind2 >= 1) {
            if (b[ind2 - 1].second == m1.second && ind2 >= 2) {
                ans = min(ans, 1ll * abs(m1.first - b[ind2 - 2].first));
            }
                //berem ai   i   bj-1
            else {
                if (b[ind2 - 1].second != m1.second) {
                    ans = min(ans, 1ll * abs(m1.first - b[ind2 - 1].first));
                }
            }
        }
        //berem bj  i   ai-2
        if (ind1 >= 1) {
            if (a[ind1 - 1].second == m2.second && ind1 >= 2) {
                ans = min(ans, 1ll * abs(m2.first - a[ind1 - 2].first));
            }
                //berem bj   i   ai-1
            else {
                if (a[ind1 - 1].second != m2.second) {
                    ans = min(ans, 1ll * abs(m2.first - a[ind1 - 1].first));
                }
            }
        }
        flag_a[m1.second] = -1;
        flag_b[m1.second] = 1;
        flag_a[m2.second] = 1;
        flag_b[m2.second] = -1;
        ind1--;
        ind2--;
    }
    cout << ans;

}

int main() {
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
