#include <iostream>
#include <utility>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

//struct LCA{
//    int n, k;
//    vector<int> depths, parents;
//    vector<vector<int>> dp;
//
//    void dfs(int v, int par, vector<vector<int>>& g, vector<bool>& used){
//        used[v] = true;
//        parents[v] = par;
//        for(auto to : g[v]){
//            if(!used[to])
//                dfs(to, v, g, used);
//        }
//        if(par != -1)
//            depths[v] = depths[par] + 1;
//
//    }
//
//    int get_log2(int n){
//        ll num = 1;
//        k = 0;
//        while (num < n) {
//            num *= 2;
//            k++;
//        }
//        return k;
//    }
//
//    void LA(){
//        for(int i = 0; i < n; i++)
//            dp[0][i] = parents[i];
//        for(int i = 1; i <= k; i++){
//            for(int j = 0; j < n; j++){
//                dp[k][i] = dp[k - 1][dp[k - 1][i]];
//            }
//        }
//    }
//
//    void build(vector<vector<int>>& g){
//        n = g.size();
//        vector<bool> used(n);
//        depths.assign(n, 0);
//        parents.assign(n, 0);
//        dfs(0,-1,g,used);
//
//        int k = get_log2(n);
//        dp.assign(k + 1, vector<int>(n));
//        LA();
//    }
//
//    int up(int v, int level){
//        for(int i = k; i >= 0; i--){
//            if(depths[v] - (1ll << i) >= level){
//                v = dp[i][v];
//            }
//        }
//        return v;
//    }
//
//    int lca(int v, int u){
//        if(depths[v] < depths[u])
//            u = up(u, depths[v]);
//        if (depths[u] < depths[v])
//            v = up(v, depths[u]);
//
//
//    }
//
//
//};
//
const ll INF = 2e9 + 100;
struct segtree{
    vector<int> tree;
    int size;

    int init(int n){
        size = 1;
        while(size < n)
            size *= 2;
        tree.assign(2 * size - 1, -INF);
    }


};

int timer;
//void dfs1(int v, vector<vector<pair<int, int>>>& g, vector<int>& used, vector<int>& tout){
//    used[v] = true;
//
//    for(auto e : g[v]){
//        int to = e.first;
//        if(!used[to]){
//            dfs1(to, g, used, tout);
//        }
//    }
//    tout[v] = timer++;
//}

void condense(int v, vector<vector<int>>& g, vector<vector<int>>& cond,vector<int>&used){
    used[v] = true;
    cond.back().push_back(v);

    for(auto to : g[v]){
        if(!used[to])
            condense(to, g, cond, used);
    }
}

//void solve1(){
//    timer = 0;
//    int n, m;
//    cin >> n >> m;
//
//    vector<vector<pair<int, int>>> g(n);
//    for(int i = 0;  i < m; i++){
//        int v,u,w;
//        cin >> v >> u >> w;
//        v--, u--;
//        g[v].push_back({u, w});
//    }
//
//    vector<int> tout(n), used(n);
//    for(int i = 0; i < n; i++){
//        if(!used[i]){
//            dfs(i,g, used, tout);
//        }
//    }
//
//    vector<vector<int>> cond, inv_g(n);
//    used.assign(n, 0);
//    for(int i = 0; i < n; i++){
//        for(auto e : g[i]){
//            inv_g[e.first].push_back(i);
//        }
//    }
//    for(int i = 0; i < n; i++){
//        if(!used[i])
//            condense(i, inv_g, cond, used);
//    }
//
//    for(int i = 0;  i< cond.size(); i++){
//        cout<<i <<"\n";
//        for(auto j : cond[i])
//            cout<<j << ' ';
//        cout<<"\n";
//    }
//
//}

//const ll P = {29, 31, 179, 239}, MODS = {1000000007, 1000000009, 1000000003};
const ll P = 29, MOD = 1e9 + 7;

ll summ(ll a, ll b, ll m){
    if(a + b > m)
        return a + b - m;
    return a + b;
}

ll get_minus(ll a, ll b, ll m){
    if (a < b)
        return a - b + m;
    return a - b;
}

ll product(ll a, ll b, ll m){
    return a * b % m;
}

struct Hash{
    vector<ll> h, powers;

    void build(string& s){
        int n = s.length();

            powers.push_back({1});
            h.push_back({0});


            for(int j = 0; j < n; j++){
                powers.push_back(product(powers.back(), P, MOD));
        }

            for(int j = 0; j < n; j++){
                ll sym = s[j] - 'a' + 1;
                h.push_back(summ(product(h.back(), P, MOD), sym,MOD));
            }

    }

    ll get_sub(int l, int r){
        l--;
        return product(get_minus(h[r], h[l], MOD), powers[r - l], MOD);
    }
};

void solve(){

}

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<ll, ll>> ac(n), bc(n);
    for(int i = 0;  i< n; i++){
        cin >> ac[i].first >> ac[i].second;
        bc[i].first = ac[i].second, bc[i].second = ac[i].first;
    }
    sort(ac.begin(), ac.end());
    sort(bc.begin(), bc.end());

    vector<ll> a(n), ab(n), b(n), ba(n);
    for(int i = 0; i < n; i++){
        a[i] = ac[i].first;
        ab[i] = ac[i].second;
        b[i] = bc[i].first;
        ba[i] = bc[i].second;
    }

    vector<ll> a_mx(n + 1, -INF), b_mx(n + 1, -INF);
    for(int i = n - 1; i > -1; i--){
        a_mx[i] = max(a_mx[i + 1], ab[i]);
        b_mx[i] = max(b_mx[i + 1], ba[i]);
    }

    ll ans = 4 * INF;
    multiset<ll> other;
    other.insert(-INF);
    other.insert(INF);
    for(int i = 0; i < n; i++){
        ll local_mn = INF;
        ll right_mx = a_mx[i + 1];
        ll diff1 = abs(right_mx - a[i]);
        auto it = other.upper_bound(a[i]);
        if(*it > a[i])
            --it;
        ll diff2 = abs(*it - a[i]), val2 = *it;
        ++it;
        ll diff3 = abs(*it - a[i]), val3 = *it;
        if(val2 >= right_mx)
            local_mn = min(diff1, diff2);
        if(val3 >= right_mx)
            local_mn = min(local_mn, min(diff1, diff3));
        ans = min(ans, local_mn);
        other.insert(ab[i]);
    }
    cout<<ans;

    return 0;
}