#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <functional>
#include <climits>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>



const int mod = 1000000007;

using namespace std;


using ll = long long;
using dl = long double;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;



template <typename T, typename S>
istream& operator>>(istream& in, pair<T, S>& a)
{
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream& operator<<(ostream& out, pair<T, S>& a)
{
    out << a.first << ' ' << a.second;
    return out;
}
template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (T& x : a) in >> x;
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T>& a)
{
    for (T& x : a) out << x << ' ';
    return out;
}

template <typename T>
struct VEC
{
    T x, y;
    template <typename S>
    VEC(S _x, S _y): x(_x), y(_y) {};
    VEC() {};

};
template <typename T>
VEC<T> operator+(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x + b.x, a.y + b.y);
}
template <typename T>
VEC<T> operator-(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x - b.x, a.y - b.y);
}
template <typename T>
ll cross(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.x + a.y*b.y;
}
template <typename T>
ll vecp(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.y - a.y*b.x;
}
template <typename T>
T dist2(VEC<T>& a, VEC<T>& b)
{
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}
template <typename T>
istream& operator >>(istream& in, VEC<T>& a)
{
    in >> a.x >> a.y;
    return in;
}
template <typename T>
ostream& operator <<(ostream& out, VEC<T>& a)
{
    out << a.x << ' ' << a.y;
    return out;
}

template <typename T>
dl angle(VEC<T>& a, VEC<T>& b)
{
    dl ret = atan2((dl)vecp(a, b), (dl)cross(a, b));
    return ret;
}


ll gcd (ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a%b);
}
ll lcm(ll x, ll y)
{
    return (x/gcd(x, y))*y;
}
ll binpow(ll x, ll p, int m)
{
    if (p == 0) return 1;
    ll ret = binpow(x, p>>1, m);
    ret = ret*ret%m;
    if (p&1) ret = ret*x%mod;
    return ret;
}


struct segmtree
{
    vector<set<int>> tree;
    vector<int> mn;
    vector<int> source;
    int size;
    void merge(int v, int p)
    {
        for (int x : tree[p]) tree[v].insert(x);
        mn[v] = min(mn[v], mn[p]);
    }
    void update(int v)
    {
        merge(v, 2 * v);
        merge(v, 2*v + 1);
    }
    segmtree(vector<int> a): source(a), size(a.size()), tree(a.size() << 2, set<int>()), mn(a.size() << 2, INT_MAX) { };
    void build(int v, int l, int r)
    {
        if (l + 1 == r)
        {
            tree[v].insert(source[l]);
            mn[v] = source[l];
        }
        else
        {
            int m = (l + r) >> 1;
            int vl = 2*v, vr = vl + 1;
            build(vl, l, m);
            build(vr, m, r);
            update(v);
        }
    }

    ll ret = INT_MAX;
    int gl, gr, gv;
    int get(int l, int r, int val)
    {
        gl = l, gr = r + 1, gv = val;
        ret = INT_MAX;
        rec_get(1, 0, size);
        return ret;
    }
    void rec_get(int v, int l, int r)
    {
        if (l >= gl && r <= gr)
        {
            auto px = tree[v].lower_bound(gv);
            if (px != tree[v].end()) ret = min(ret, (ll)abs(gv - *px));
            if (px != tree[v].begin())
            {
                --px;
                ret = min(ret, (ll)abs(gv - *px));
            }
        }
        else
        {
            int m = (l + r) >> 1;
            int vl = 2*v, vr = vl + 1;
            if (m > gl) rec_get(vl, l, m);
            if (m < gr) rec_get(vr, m, r);
        }
    }
    int minn;
    int getm(int l, int r)
    {
        minn = INT_MAX;
        gl = l, gr = r + 1;
        rec_getm(1, 0, size);
        return minn;
    }  
    void rec_getm(int v, int l, int r)
    {
        if (l >= gl && r <= gr)
        {
            minn = min(minn, mn[v]);
        }
        else
        {
            int m = (l + r) >> 1;
            int vl = 2*v, vr = vl + 1;
            if (m > gl) rec_getm(vl, l, m);
            if (m < gr) rec_getm(vr, m, r);
        }
    } 




};



signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(18);
    


    int t = 1;
    //cin >> t;
next:
    while (t--)
    {
        int n;
        cin >> n;
        vector<pii> ab(n);
        cin >> ab;
        bool eq = true;
        for (int i = 0; i < n; i++)
        {
            eq = eq && (ab[i].first == ab[i].second);
        }
        /*
        if (n <= 20)
        {
            int ans = INT_MAX;
            int g = (1 << n) - 1;
            for (int mask = 1; mask < g; mask++)
            {
                int m1=0, m2=0;
                for (int i = 0; i < n; i++)
                {
                    if ((1&(mask>>i)) != 0)
                    {
                        m2 = max(m2, ab[i].second);
                    }
                    else m1 = max(m1, ab[i].first);
                }
                ans = min(ans, abs(m2 - m1));
            }
            cout << ans << '\n';
        }
        */
        if (eq)
        {
            sort(ab.begin(), ab.end());
            cout << abs(ab[n - 1].second - ab[n - 2].first) << '\n';
        }
        else
        {
            bool eq2 = true;
            for (int i = 0; i < n - 1; i++)
            {
                eq2 = eq2 && (ab[i].first == ab[i + 1].first);
            }
            if (eq2)
            {  
                int ans = INT_MAX;
                for (int i = 0; i < n; i++)
                {
                    ans = min(ans, abs(ab[i].second - ab[0].first));
                }
                cout << ans << '\n';
                goto next;
                
            }
            int ans = INT_MAX;
            sort(ab.begin(), ab.end());


            vector<int> prefmx(n + 1, -1);
            for (int i = n - 1; i >= 0; i--)
            {
                prefmx[i] = max(prefmx[i + 1], ab[i].second);
            }

            map<int, int> cnt;
            vector<int> food(n);
            for (int i = 0; i < n; i++)
            {
                ++cnt[ab[i].first];
                food[i] = ab[i].second;
            }

            segmtree treee(food);
            treee.build(1, 0, treee.size);
            int prev = -1;
            for (int i = n - 1; i >= 0; i--)
            {
                int m1 = ab[i].first;
                if (prev != ab[i].first)
                {
                    int m2 = prefmx[i + 1];
                    int diff = abs(ab[i].first - m2);
                    if (m1 > m2)
                    {
                        if (i != 0 && ab[i - 1].first == ab[i].first)
                        {
                            diff = min(diff, treee.get(i - cnt[m1] + 1, i, m1));
                        }
                        if (i - cnt[i] >= 0) diff = min(diff, treee.get(0, i - cnt[m1], m1));
                    }
                    ans = min(ans, diff);
                }
                prev = ab[i].first;
            }
            cout << ans << '\n';











            /*
            int prev = -1;
            for (int i = n - 1; i >= 0; i--)
            {
                if (prev != ab[i].first)
                {
                    int m2 = -1;
                    
                    
                    
                    for (int j = i+1; j < n; j++)
                    {
                        m2 = max(m2, ab[j].second);
                    }
                    int diff = abs(ab[i].first - m2);
                    if (m2 < ab[i].first)
                    {
                        if (i != 0 && ab[i - 1].first == ab[i].first)
                        {
                            for (int j = i; j >= 0 && ab[j].first == ab[i].first; j--)
                            {
                                if (abs(ab[j].second - ab[i].first) < diff)
                                {
                                    diff = abs(ab[j].second - ab[i].first);
                                }
                            }
                        }
                        for (int j = i - 1; j >= 0; j--)
                        {
                            if (ab[j].first == ab[i].first) continue;
                            if (abs(ab[j].second - ab[i].first) < diff)
                            {
                                diff = abs(ab[j].second - ab[i].first);
                            }
                        }
                    }
                    ans = min(ans, diff);                   
                }
                prev = ab[i].first;
            }
            cout << ans << '\n';
            */
        }
        
        


    }
    return 0;
}