#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

void resolve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> src(n);
    for (auto &item: src) {
        cin >> item.first >> item.second;
    }

    if (n > 5000) {
        sort(src.begin(), src.end());
        cout << src[n - 1].first - src[n - 2].first << '\n';
        return;
    }

    ll res = 1e18;
    for (ll i = 0; i < n; ++i) {
        ll ai = src[i].first;
        vector<ll> canB;
        ll maxB = -1e18;
        for (ll j = 0; j < n; ++j) {
            if (j == i) {
                continue;
            }

            if (src[j].first > src[i].first) {
                maxB = max(maxB, src[j].second);
            } else {
                canB.push_back(src[j].second);
            }
        }

        res = min(res, abs(ai - maxB));
        for (const auto &item: canB) {
            if (item >= maxB) {
                res = min(res, abs(ai - item));
            }
        }
    }

    cout << res << '\n';
}

void resolve1() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> src(n);
    for (auto &item: src) {
        cin >> item.first >> item.second;
    }

    sort(src.begin(), src.end());
    if (n > 5000) {
        cout << src[n - 1].first - src[n - 2].first << '\n';
        return;
    }

    vector<ll> sufMax(n);
    sufMax[n - 1] = src[n - 1].second;
    for (ll i = n - 2; i >= 0; --i) {
        sufMax[i] = max(sufMax[i + 1], src[i].second);
    }

    ll res = 1e18;
    for (ll i = 0; i < n; ++i) {
        ll ai = src[i].first;
        vector<ll> canB;
        for (ll j = 0; j < i; ++j) {
            if (j == i) {
                continue;
            }

            canB.push_back(src[j].second);
        }

        ll maxB = -1e18;
        if (i < n - 1) {
            maxB = sufMax[i + 1];
        }

        res = min(res, abs(ai - maxB));
        for (const auto &item: canB) {
            if (item >= maxB) {
                res = min(res, abs(ai - item));
            }
        }
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve1();
    return 0;
}
