#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

void resolve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> src(n);
    for (auto &item: src) {
        cin >> item.first >> item.second;
    }

    sort(src.begin(), src.end());
    if (n > 10000) {
        cout << src[n - 1].first - src[n - 2].first << '\n';
        return;
    }

    vector<ll> sufMax(n);
    sufMax[n - 1] = src[n - 1].second;
    for (ll i = n - 2; i >= 0; --i) {
        sufMax[i] = max(sufMax[i + 1], src[i].second);
    }

    ll res = 1e18;
    vector<ll> canB;
    for (ll i = 0; i < n; ++i) {
        ll ai = src[i].first;
        ll maxB = -1e18;
        if (i < n - 1) {
            maxB = sufMax[i + 1];
        }

        res = min(res, abs(ai - maxB));
        for (const auto &item: canB) {
            if (item >= maxB) {
                res = min(res, abs(ai - item));
            }
        }
        canB.push_back(src[i].second);
    }

    cout << res << '\n';
}

void resolve1() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> src(n);
    for (auto &item: src) {
        cin >> item.first >> item.second;
    }

    sort(src.begin(), src.end());
    vector<ll> sufMax(n);
    sufMax[n - 1] = src[n - 1].second;
    for (ll i = n - 2; i >= 0; --i) {
        sufMax[i] = max(sufMax[i + 1], src[i].second);
    }

    ll res = 1e18;
    set<ll> canB;
    for (ll i = 0; i < n; ++i) {
        ll ai = src[i].first;
        ll maxB = -1e18;
        if (i < n - 1) {
            maxB = sufMax[i + 1];
        }

        res = min(res, abs(ai - maxB));
        if (!canB.empty()) {
            auto it = canB.lower_bound(ai);
            if (it == canB.end()) {
                --it;
                if (*it >= maxB) {
                    res = min(res, abs(ai - *it));
                }
            } else {
                if (*it >= maxB) {
                    res = min(res, abs(ai - *it));
                }

                if (it != canB.begin()) {
                    --it;
                    if (*it >= maxB) {
                        res = min(res, abs(ai - *it));
                    }
                }
            }
        }

        canB.insert(src[i].second);
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve1();
    return 0;
}
