#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

#define line cout<<'\n'

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 6e5 + 100;

vector <int> tree[4 * nmax];
vector <int> arr(nmax, inf);
int n;

void f(vector <int> &res, vector <int> &a, vector<int> &b) {
    res.clear();
    int l = 0, r = 0;
    while (l < sz(a) && r < sz(b)) {
        if (a[l] < b[r]) res.emplace_back(a[l++]);
        else res.emplace_back(b[r++]);
    }
    while (l < sz(a)) res.emplace_back(a[l++]);
    while (r < sz(b)) res.emplace_back(b[r++]);
}

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        tree[v].emplace_back(arr[tl]);
        return;
    }

    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm, tr);

    f(tree[v], tree[v * 2], tree[v * 2 + 1]);
}

int get(int v, int tl, int tr, int ql, int qr, int num, int x) {
    if (tr <= ql || qr <= tl) return inf;
    if (ql <= tl && tr <= qr) {
        if (tree[v].empty() || tree[v].back() < num) return inf;
        return abs(x - *lower_bound(all(tree[v]), num));
    }
    int tm = (tl + tr) / 2;
    return min(get(v * 2, tl, tm, ql, qr, num, x), get(v * 2 + 1, tm, tr, ql, qr, num, x));
}

void solve() {
    cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];

    vector <pair<int, int>> p(n + 1);
    for (int i = 0; i < n; i++)
        p[i + 1] = {a[i], b[i]};

    vector <int> suf(n + 2);
    sort(all(p));
    vector <int> P(n + 1);
    for (int i = 1; i <= n; i++)
        P[i] = p[i].first;

    for (int i = 1; i <= n; i++)
        arr[i] = p[i].second;

    for (int i = n; i >= 1; i--) {
        suf[i] = max(suf[i + 1], p[i].second);
    }
    suf[n + 1] = -inf;

    build(1, 1, nmax);

    map<int, int> mp;
    for (auto x : a)
        mp[x]++;

    int ans = inf;
    for (int i = 1; i <= n; i++) {
        ans = min(ans, abs(P[i] - suf[i + 1]));
        int r = i;
        if (mp[P[i]] == 1) r--;
        if (r >= 1) {
            ans = min(ans, get(1, 1, nmax, 1, r + 1, suf[i + 1], P[i]));
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}