#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);
const int SZ = 1e5 + 1, inf = 2e9;
const long long INF = 2e18;

struct Pt {
    ld x, y;
    Pt(ld x = 0, ld y = 0) : x(x), y(y) {}
};

Pt operator+(Pt a, Pt b) {
    return Pt(a.x + b.x, a.y + b.y);
}
Pt operator-(Pt a, Pt b) {
    return Pt(a.x - b.x, a.y - b.y);
}
ld operator*(Pt a, Pt b) {
    return a.x * b.x + a.y * b.y;
}
ld operator%(Pt a, Pt b) {
    return a.x * b.y - a.y * b.x;
}
ld get_ungle(Pt a, Pt b) {
    return atan2(a % b, a * b);
}

struct segment_tree {
    struct Node {
        ///
        Node() {}
    };
    int sz;
    vector<Node> tree;

    segment_tree(int n) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(sz * 2 - 1, Node());
        build(0, 0, sz);
    }

    void push(int v, int l, int r) {
        return;
    }

    void upd(int v, int l, int r) {
        return;
    }

    void build(int vert, int left, int right) {
        if (right - left) {
            return;
        }
        int midle = (left + right) / 2;
        build(vert * 2 + 1, left, midle);
        build(vert * 2 + 2, midle, right);
        upd(vert, left, right);
    }

    void on_segment(int vert, int left, int right, int qleft, int qright) {
        if (qleft <= left && right <= qright) {
            //in
            return;
        }
        if (right <= qleft || qright <= left) {
            //not in
            return;
        }
        push(vert, left, right);
        int midle = (left + right) / 2;
        on_segment(vert * 2 + 1, left, midle, qleft, qright);
        on_segment(vert * 2 + 2, midle, right, qleft, qright);
        upd(vert, left, right);
    }
};

struct n_segment_tree {
    struct Node {
        ///
        int l, r;
        Node(int l = -1, int r = -1) : l(l), r(r) {}
    };
    int sz;
    vector<Node> tree;

    n_segment_tree(int n) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(1, Node());
        //build(0, 0, sz);
    }

    void push(int v, int l, int r) {
        if (tree[v].l == -1) {
            tree[v].l = tree.size();
            tree.push_back(Node());
        }
        if (tree[v].r == -1) {
            tree[v].r = tree.size();
            tree.push_back(Node());
        }
        return;
    }

    void upd(int v, int l, int r) {
        return;
    }

    void on_segment(int vert, int left, int right, int qleft, int qright) {
        if (qleft <= left && right <= qright) {
            //in
            return;
        }
        if (right <= qleft || qright <= left) {
            //not in
            return;
        }
        push(vert, left, right);
        int midle = (left + right) / 2;
        on_segment(tree[vert].l, left, midle, qleft, qright);
        on_segment(tree[vert].r, midle, right, qleft, qright);
        upd(vert, left, right);
    }
};

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; i++)
        cin >> vec[i].first >> vec[i].second;
    sort(vec.begin(), vec.end());
    int mx = vec.back().second, mi = inf, ans = inf;
    for (int i = n - 2; i >= 0; i--) {
        ans = min(ans, abs(vec[i].first - mx));
        ans = min(ans, abs(vec.back().first - vec[i].second));
        mx = max(mx, vec[i].second);
    }
    cout << ans;
}