#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
// #define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int MAXN = 1048576;
int tree[2 * MAXN];

struct shop{
    int a, b, pos;
};

void build_tree() {
    for (int i = MAXN - 1; i > 0 ; i--) {
        tree[i] = max(tree[i << 1], tree[(i << 1) + 1]);
    }
}

// int get_max(int v, int l, int r, int ln, int rn) {
//     if (l >= rn || r <= ln) {
//         return -1;
//     }
//     if (l >= ln && r <= rn) {
//         return tree[v];
//     }
//     int m = (l + r) >> 1;
//     int v1, v2;
//     return max(get_max(v << 1, l, m, ln, rn), get_max((v << 1) + 1, m, r ,ln, rn));
// }

void upd_way(int v) {
    v += MAXN; 
    v >>= 1;
    while (v > 0) {
        tree[v] = max(tree[v << 1], tree[(v << 1) + 1]);
        v >>= 1;
    }
}

vector <shop> tb;

int bin_s(int val) {
    int l = -1, r = tb.size();
    int m;
    while (l + 1 < r) {
        m = (l + r) >> 1;
        if (tb[m].b <= val) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

signed main() {
    for (int i = 0 ; i < 2 * MAXN; i++) {
        tree[i] = -1;
    }
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector <shop> task;
    task.resize(n);
    tb.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i].a >> task[i].b;
        tree[i + MAXN] = task[i].b;
        task[i].pos = i;
        tb[i] = task[i];
    }
    sort(tb.begin(), tb.end(), [] (shop a, shop b) {return a.b < b.b;});
    sort(task.begin(), task.end(), [] (shop a, shop b) {if (a.a == b.a) {
        return a.b < b.b;
    }return a.a < b.a;});
    build_tree();
    int ans = 1e9 + 50;
    int max_a = 0;
    for (int i = 0 ; i < n; i++) {
        max_a = max(max_a, task[i].a);
        tree[task[i].pos + MAXN] = -1;
        upd_way(task[i].pos);
        int pos = bin_s(max_a);
        if (pos != -1 && tb[pos].a != task[i].a) {
            ans = min(ans, abs(max(tree[1], tb[pos].b) - max_a));
        }
        if (pos != (n - 1) && tb[pos + 1].a != task[i].a) {
            ans = min(ans, abs(max(tree[1], tb[pos + 1].b) - max_a));
        }
        if (pos != 0 && tb[pos - 1].a != task[i].a) {
            ans = min(ans, abs(max(tree[1], tb[pos - 1].b) - max_a));
        }
    }
    cout << ans;
}