#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b) {
    return ((ll)a * b) % mod;
}

struct cnm {
    vector<int> par, rang;
    void init(int n) {
        for (int i = 0; i < n; i++) {
            rang.pb(0);
            par.pb(i);
        }
    }
    int get(int a) {
        while (par[a] != a) {
            return get(par[a]);
        }
        par[a] = a;
        return par[a];
    }   
    void make_union(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return;
        if (rang[a] < rang[b]) swap(a, b);
        rang[a]++;
        par[b] = a;
    }
};
const int MAXN = 2e5 + 10;
const int MAX_LOG = 20;
vector<vector<int> > gr;
int up[MAXN][MAX_LOG];
vector<int> path, gets, in, out;
int fl = 0, timer = 0;
int is_pred(int a, int b) {
    if (in[a] <= in[b] && out[a] >= out[b]) return 1;
    return 0;
}
void make_in_out(int u, int p) {
    in[u] = timer;
    timer++;
    for (auto to : gr[u]) {
        if (to == p) continue;
        up[to][0] = u;
        make_in_out(to, u);
    }
    out[u] = timer;
    timer++;
}
void make_lca(int u, int p) {
    for (int i = 1; i < MAX_LOG; i++) {
        int c = up[u][i - 1];
        int next = up[c][i - 1];
        up[u][i] = next;
    }
    for (auto to : gr[u]) {
        if (to == p) continue;
        make_lca(to, u);
    }
}
int get_lca(int a, int b) {
    if (is_pred(a, b)) return a;
    if (is_pred(b, a)) return b;
    for (int i = 19; i >= 0; i--) {
        int c = up[a][i];
        if (!is_pred(c, b)) {
            a = c;
        }
    }
    return up[a][0];
}
void solve() {
    int n;
    cin >> n;
    vector<pair<int, int> > all;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        all.pb({ a,b });
    }
    sort(all.begin(), all.end());
    //for (auto c : all) cout << c.first << " " << c.second;
    multiset<int> pref;
    for (int i = 0; i < all.size() - 1; i++) {
        pref.insert(all[i].second);
    }
    int cur_mx_b = -1, ans = INF + 1000;
    for (int i = n - 1; i >= 0; i--) {
        int cur_a = all[i].first;
        if (i != n - 1) {
            auto c = pref.lower_bound(all[i].second);
            pref.erase(c);
        }
        if (cur_mx_b == -1) {
            auto it = pref.upper_bound(cur_a);
            auto it2 = it;
            if (it != pref.end()) {
                int cur = *(it);
                ans = min(ans, abs(cur_a - cur));
            }
            if (it2 != pref.begin()) {
                it2--;
                int cur = *(it2);
                ans = min(ans, abs(cur_a - cur));
            }
        }
        else {
            ans = min(ans, abs(cur_a - cur_mx_b));
            if (cur_mx_b < cur_a && pref.size() > 0) {
                auto it = pref.upper_bound(cur_a);
                auto it2 = it;
                if (it != pref.end()) {
                    int cur = *(it);
                    ans = min(ans, abs(cur_a - cur));
                }
                if (it2 != pref.begin()) {
                    it2--;
                    int cur = *(it2);
                    if (cur >= cur_mx_b) ans = min(ans, abs(cur_a - cur));
                }
            }
        }
        cur_mx_b = max(cur_mx_b, all[i].second);
    }
    cout << ans;

}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}