#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
#define rd (int)ran()
using namespace std;

mt19937 ran;
int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}
int modpow(int a, int n){
    if(n == 0){
        return 1;
    }
    if(n % 2 == 0){
        return modpow(modmult(a,a), n/2);
    }
    return modmult(a, modpow(a, n - 1));
}
int moddel(int a, int b){
    return modmult(a, modpow(b, mod - 2));
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

vector<pll> dot, dotmin, a;

void build(ll v, ll l, ll r){
    if(l == r){
        dot[v] = {a[l].first, a[l].second};
        dotmin[v] = {a[l].first, a[l].second};
        return;
    }
    ll m = (l + r)/2;
    build(v * 2, l , m);
    build(v * 2 + 1, m + 1 , r);
    dot[v] = max(dot[v * 2], dot[v *  2 + 1]);
    dotmin[v] = min(dotmin[v * 2], dotmin[v *  2 + 1]);
}

ll maxbi (ll v, ll l, ll r, ll tek){
    if(l > r || dot[v].first <= tek){
        return 1000000000000000;
    }
    if(l == r){
        return dot[v].second;
    }
    ll m = (l + r)/2;
    ll ri = maxbi(v * 2 + 1, m + 1, r , tek);
    if (ri == 1000000000000000){
        return maxbi(v * 2, l , m, tek);
    }
    return ri;
}

ll blbi(ll v, ll l, ll r, ll tek, int i){
    if(l > r || dotmin[v].first > tek){
        return 1000000000000000;
    }
    if(l == r){
        if(l == i){
            return 1000000000000000;
        }
        return abs(dot[v].second - tek);
    }
    ll m = (l + r)/2;
    return min(blbi(v * 2, l, m, tek, i), blbi(v * 2 + 1, m + 1,r , tek, i));
}

bool cmp(pii f, pii s){
    if(f.second != s.second){
        return f.second < s.second;
    }
    return f.first < s.first;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    dot.resize(4*n + 1);
    dotmin.resize(4*n + 1);
    a.resize(n);
    fort(i, n){
        cin >> a[i].first >> a[i].second;
    }
    sort(all(a), cmp);
    build(1, 0 , n - 1);
    ll ans = INT32_MAX;
    fort(i, n){
        ll t1 = abs(maxbi(1, 0 , n - 1, a[i].first) - a[i].first);
        if(t1 > 1000000000){
            ll t2 = blbi(1, 0, n - 1, a[i].first, i);
            ans = min(ans, t2);
        } else{
        ans = min(t1, ans);
    }}
    if(ans == INT32_MAX){
        cout << 0;
    }
    else{
        cout << ans;
    }
}