#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
#define rd (int)ran()
using namespace std;

mt19937 ran;
int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}
int modpow(int a, int n){
    if(n == 0){
        return 1;
    }
    if(n % 2 == 0){
        return modpow(modmult(a,a), n/2);
    }
    return modmult(a, modpow(a, n - 1));
}
int moddel(int a, int b){
    return modmult(a, modpow(b, mod - 2));
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

vector<pll> dot, a;

void build(ll v, ll l, ll r){
    if(l == r){
        dot[v] = {a[l].s, a[l].s};
        return;
    }
    ll m = (l + r)/2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    dot[v].first = min(dot[v*2].first, dot[v*2+1].first);
    dot[v].s = max(dot[v*2].s, dot[v*2+1].s);
}

ll minn(ll v, ll l, ll r, ll ql, ll qr){
    if(l > r || l > qr || r < ql){
        return INT32_MAX;
    }
    if(l >= ql && r <= qr){
        return dot[v].first;
    }
    ll m = (l + r)/2;
    return min(minn(v * 2, l , m , ql, qr), minn(v*2+1, m + 1, r, ql, qr));
}
ll maxx(ll v, ll l, ll r, ll ql, ll qr){
    if(l > r || l > qr || r < ql){
        return 0;
    }
    if(l >= ql && r <= qr){
        return dot[v].s;
    }
    ll m = (l + r)/2;
    return  max(maxx(v * 2, l , m , ql, qr), maxx(v*2+1, m + 1, r, ql, qr));
}

bool cmp(pll f, pll s){
    if(f.f != s.f){
        return f.f < s.f;
    }
    return f.s < s.s;
}

ll prav(){
    int n = len(a);
    ll ans = INT32_MAX;
    for(int mask = 1; mask < (1 << n) - 1; mask++){
        ll tempmask = mask, tempa = 0, tempb = 0;
        for(int i = 0; i < n; i++){
            if((tempmask & 1) == 1){
                tempb = max(tempb, a[i].second);
            } else{
                tempa = max(tempa, a[i].f);
            }
            tempmask = (tempmask >> 1);
        }
        ans = min(ans, abs(tempa - tempb));
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    a.resize(n);
    dot.resize(4*n+1);
    fort(i, n){
        cin >> a[i].f >> a[i].s;
    }
    sort(all(a), cmp);
    ll i = 0;
    ll ans = INT32_MAX;
    build(1, 0, n - 1);
    while(a[i].f != a[n - 1].f){
        ll t1 = maxx(1, 0 , n - 1, i + 1, n - 1);
        ll t2 = maxx(1, 0 , n - 1, 0, i - 1);
        ll t3 = minn(1, 0 , n - 1, 0, i - 1);
        if(t1 > t2) {
            t2 = t1;
        }
        ans = min(ans, min(abs(a[i].f - t1), min(abs(a[i].f - t2), abs(a[i].f - t3))));
        i++;
    }
    ll pos = 0;
    for(ll j = 0; j < n; j++){
        if(abs(a[n - 1].f - a[pos].s) > abs(a[n - 1].f - a[j].s)){
            pos = j;
        }
    }
    while(i < n){
        if(pos == i){
            ll pos1 = 0;
            for(int j = 0; j < n; j++){
                if(i == j) continue;
                if(abs(a[n - 1].f - a[pos1].s) > abs(a[n - 1].f - a[j].s)){
                    pos1 = j;
                }
            }
            ans = min(ans, abs(a[n - 1].f - a[pos1].s));
        }
        else{
            ans = min(ans, abs(a[n - 1].f - a[pos].s));
        }
        i++;
    }
    cout << ans;



}