#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

constexpr int tsize = 524288;

int tree[2 * tsize];

void set(int v, int vl, int vr, int i, int x) {
    if (vr - vl == 1) {
        tree[v] = x;
        return;
    }
    if (i < (vl + vr) / 2) {
        set(2 * v + 1, vl, (vl + vr) / 2, i, x);
    } else {
        set(2 * v + 2, (vl + vr) / 2, vr, i, x);
    }
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int getlastgt(int v, int vl, int vr, int x) {
    if (vr - vl == 1) {
        return vl;
    }
    if (tree[2 * v + 2] < x) {
        return getlastgt(2 * v + 1, vl, (vl + vr) / 2, x);
    } else {
        return getlastgt(2 * v + 2, (vl + vr) / 2, vr, x);
    }
}

void build(int v, int vl, int vr, const vector<pair<int, int>>& a) {
    if (vr - vl == 1) {
        tree[v] = -1;
        if (vl < (int)a.size()) {
            tree[v] = a[vl].first;
        }
        return;
    }
    build(2 * v + 1, vl, (vl + vr) / 2, a);
    build(2 * v + 2, (vl + vr) / 2, vr, a);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    sort(a.begin(), a.end(), [](const pair<int, int>& p1, const pair<int, int>& p2) {
        if (p1.second == p2.second) {
            return p1.first < p2.first;
        }
        return p1.second < p2.second;
    });

    build(0, 0, tsize, a);

    int bestres = 2000000000;

    for (int max1 = 0; max1 < n; max1++) {
        set(0, 0, tsize, max1, -1);

        int cl = getlastgt(0, 0, tsize, a[max1].first) + 1;
        if (cl < n) {
            bestres = min(bestres, abs(a[cl].second - a[max1].first));
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (a[mid].second > a[max1].first) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            if (r < n && r >= cl) {
                bestres = min(bestres, abs(a[r].second - a[max1].first));
            }
            r--;
            if (r >= cl) {
                bestres = min(bestres, abs(a[r].second - a[max1].first));
            }
        }

        set(0, 0, tsize, max1, a[max1].first);
    }

    cout << bestres << "\n";

    return 0;
}
