#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll
const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}

	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};


int n;
vector<int> a, b;

void solve1() {
	int ans = 2e12;
	for (int m = 1; m < (1 << n); m++) {
		int m1 = 0, m2 = 0;
		for (int k = 0; k < n; k++) {
			if (m >> k & 1) {
				m1 = max(m1, a[k]);
			} else {
				m2 = max(m2, b[k]);
			}
		}
		ans = min(ans, abs(m1 - m2));
	}
	cout << ans << '\n';
}

void solve() {
	cin >> n;
	a.resize(n);
	b.resize(n);
	map<int, vector<int>> q;
	multiset<int> have, can;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		q[b[i]].push_back(i);
		have.insert(a[i]);
	}
	//solve1();
	int ans = (int)(2e12);
	for (auto& [val, idx] : q) {
		for (auto& u : idx) {
			can.insert(a[u]);
			have.erase(have.lower_bound(a[u]));
		}
		for (auto& u : idx) {
			can.erase(can.lower_bound(a[u]));

			int mx = -1;
			if (have.size()) {
				mx = *have.rbegin();
				ans = min(ans, abs(mx - val));
			}
			if (can.size()) {
				auto it = can.lower_bound(val);
				if (it != can.end()) {
					int cur = *it;
					if (mx == -1 || (mx < cur && abs(mx - val) > abs(val - cur))) {
						ans = min(ans, abs(cur - val));
					}
				}
				if (it != can.begin()) {
					--it;
					int cur = *it;
					if (mx == -1 || (mx < cur && abs(mx - val) > abs(val - cur))) {
						ans = min(ans, abs(cur - val));
					}
				}
			}
			can.insert(a[u]);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}