#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll
const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}

	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	vector<pair<int, int>> c(n);
	vector<int> sf(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		c[i].first = a[i];
		c[i].second = b[i];
	}
	sort(c.begin(), c.end());
	sf[n] = -((int)2e12);
	for (int i = n - 1; i >= 0; i--) {
		sf[i] = max(sf[i + 1], c[i].second);
	}
	multiset<int> can;
	int ans = 2e12;
	for (int i = 0; i < n;) {
		int j = i;
		while (j < n && c[j].first == c[i].first) {
			can.insert(c[j].second);
			j++;
		}
		int mx = sf[j];
		for (int k = i; k < j; k++) {
			int val = c[k].first;
			can.erase(can.find(c[k].second));
			auto it = can.lower_bound(val);
			int mx1 = mx, mx2 = mx;
			if (it != can.end()) {
				int cur = *it;
				if ((mx < cur && abs(mx - val) > abs(val - cur))) {
					mx1 = cur;
				}
			}
			if (it != can.begin()) {
				--it;
				int cur = *it;
				if ((mx < cur && abs(mx - val) > abs(val - cur))) {
					mx2 = cur;
				}
			}
			ans = min({ ans, abs(val - mx1), abs(val - mx2) });
			can.insert(c[k].second);
		}
		i = j;
	}

	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}