#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;

ll binpow(ll n, ll k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

struct seg_tree{
    vector <int> t;
    vector <int> p;

    void push(int v){
        if(p[v] != 0){
            t[v * 2] += p[v];
            t[v * 2 + 1] += p[v];
            p[v * 2] += p[v];
            p[v * 2 + 1] += p[v];
            p[v] = 0;
        }
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return 0;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

void solve(){
    int n;
    cin >> n;

    vector < pair <int, int> > a(n);
    int otv = 1e18;
    for(int i = 0; i < n; ++i){
        cin >> a[i].first >> a[i].second;
    }

    sort(a.begin(), a.end());

    vector <int> suf(n);
    int mx = -1, mxc = 0;
    int last = 1e18;
    set < pair <int, int> > s;
    for(int i = n - 1; i >= 0; --i){
        if(last != a[i].first){
            mx = max(mx, mxc);
            mxc = 0;
            last = a[i].first;
        }

        mxc = max(mxc, a[i].second);
        suf[i] = mx;
    }

    last = -1;
    for(int i = 0; i < n; ++i){
        if(last != a[i].first){
            int l = a[i].first;
            for(int j = i; j < n; ++j){
                if(l != a[j].first){
                    break;
                }

                s.insert({a[i].second, i});
            }
            last = a[i].first;
        }
        if(suf[i] != -1) {
            s.erase({a[i].second, i});
            auto x = s.lower_bound({a[i].first, -1});
            if(x != s.end() && suf[i] < a[i].first){
                int y = x->first;
                otv = min(otv, abs(a[i].first - y));
            }else{
                otv = min(otv, abs(a[i].first - suf[i]));
            }
            s.insert({a[i].second, i});
        }else{
            s.erase({a[i].second, i});
            auto x = s.lower_bound({a[i].first, -1});
            if(x != s.end()){
                int y = x->first;
                otv = min(otv, abs(a[i].first - y));
            }
            s.insert({a[i].second, i});
        }
    }



    for(int i = 0; i < n; ++i){
        swap(a[i].first, a[i].second);
    }

    sort(a.begin(), a.end());

    suf.assign(n, 0);
    mx = -1, mxc = 0;
    last = 1e18;
    s.clear();
    for(int i = n - 1; i >= 0; --i){
        if(last != a[i].first){
            mx = max(mx, mxc);
            mxc = 0;
            last = a[i].first;
        }

        mxc = max(mxc, a[i].second);
        suf[i] = mx;
    }

    last = -1;
    for(int i = 0; i < n; ++i){
        if(last != a[i].first){
            int l = a[i].first;
            for(int j = i; j < n; ++j){
                if(l != a[j].first){
                    break;
                }

                s.insert({a[i].second, i});
            }
            last = a[i].first;
        }
        if(suf[i] != -1) {
            s.erase({a[i].second, i});
            auto x = s.lower_bound({a[i].first, -1});
            if(x != s.end() && suf[i] < a[i].first){
                int y = x->first;
                otv = min(otv, abs(a[i].first - y));
            }else{
                otv = min(otv, abs(a[i].first - suf[i]));
            }
            s.insert({a[i].second, i});
        }else{
            s.erase({a[i].second, i});
            auto x = s.lower_bound({a[i].first, -1});
            if(x != s.end()){
                int y = x->first;
                otv = min(otv, abs(a[i].first - y));
            }
            s.insert({a[i].second, i});
        }
    }

    cout << otv;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}