#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    int ans = INF;

    vector<int> order1(n);
    vector<int> order2(n);
    iota(all(order1), 0);
    iota(all(order2), 0);

    sort(all(order1), [&](int v, int u){
        if (v == u) {
            return false;
        }
        return a[v] < a[u];
    });
    sort(all(order2), [&](int v, int u){
        if (v == u) {
            return false;
        }
        return b[v] < b[u];
    });

    ll l = -1, r = 1e9;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        int ptr = n - 1;
        int mxa = 0, mxb = 0;
        bool ok = 0;
        for (int i = n - 1; i >= 0; --i) {
            while (ptr > 0 && a[order1[i]] + m < b[order2[ptr]]) {
                mxb = max(mxb, a[order2[ptr]]);
                --ptr;
            }
            if (order1[i] != order2[ptr]) {
                if (mxb <= a[order1[i]] && abs(a[order1[i]] - b[order2[ptr]]) <= m) {
                    ok = 1;
                }
            }
//            for (int j = n - 1; j >= 0; --j) {
//                if (order1[i] != order2[j]) {
//                    if (mxb <= a[order1[i]]) {
//                        ans = min(ans, abs(a[order1[i]] - b[order2[j]]));
//                    }
//                    mxb = max(mxb, a[order2[j]]);
//                }
//            }
            mxa = max(mxa, b[order1[i]]);
        }
        if (ok) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << en;
}

void stupid() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    int ans = INF;
    for (int mask = 1; mask < (1 << n) - 1; ++mask) {
        int A = -INF, B = -INF;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                A = max(A, a[i]);
            } else {
                B = max(B, b[i]);
            }
        }
        ans = min(ans, abs(A - B));
    }
    cout << ans << en;
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 2;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
