#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <algorithm>
#include <deque>

using namespace std;

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcp(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<vector<pair<int, int>>> a(2);
    int al[n][2];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            int c;
            cin >> c;
            a[j].push_back({c, i});
            al[i][j] = c;
        }
    }
    sort(a[0].begin(), a[0].end());
    sort(a[1].begin(), a[1].end());
    int ans = 2e9;
    for (int i = 0; i < 2; ++i) {
        vector<int> cnt(n);
        multiset<int> first;
        set<int> next;
        for (int j = 0; j < n; ++j) {
            first.insert(al[j][1 - i] * n + j);
        }
        for (auto elem: a[i]) {
            first.erase(first.find(al[elem.second][1 - i] * n + elem.second));
            int mx = 0;
            if (first.size()) {
                mx = max(mx, *first.rbegin() / n);
            }
            if (mx <= elem.first) {
                auto f = next.upper_bound(elem.first);
                if (f != next.begin()) {
                    --f;
                    mx = max(mx, (*f));
                }
                if (mx != 0 && mx <= elem.first) {
                    ans = min(ans, elem.first - mx);
                }
            }
            next.insert(al[elem.second][1 - i]);
        }
    }
    cout << ans;
}