#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	sort(a.begin(), a.end());
	vector<int> xs;
	xs.push_back((int) -1e9);
	for (int i = n - 1; i > 0; --i) {
		xs.push_back(max(xs.back(), a[i].second));
	}
	int ans = (int) 1e9;
	set<int> q;
	for (int i = 0; i < n; ++i) {
		if (i) {
			q.insert(a[i - 1].second);
		}
		int x = xs.back();
		xs.pop_back();
		if (a[i].first <= x) {
			ckmin(ans, x - a[i].first);
			continue;
		}
		ckmin(ans, a[i].first - x);
		if (q.empty()) {
			continue;
		}
		{
			auto it = q.upper_bound(a[i].first);
			if (it != q.end()) {
				ckmin(ans, *it - a[i].first);
			}
			if (it != q.begin()) {
				--it;
				if (*it > x) {
					ckmin(ans, a[i].first - *it);
				}
			}
		}
	}
	cout << ans << endl;
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
