#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
//#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

ll solve2(ll n, const vii &a) {
  vector<pair<ii, ll>> b(n);
  for (int i = 0; i < n; ++i) {
    b[i] = {a[i], i};
  }
  sort(b.begin(), b.end());
  b.emplace_back(ii{1e18, 0}, n);
  for (ll i = n - 1; i >= 0; --i) {
    b[i].first.second = max(b[i].first.second, b[i + 1].first.second);
  }

  ll l;
  {
    ll L = -1, R = n;
    while (R - L > 1) {
      ll M = (L + R) / 2;
      (b[M].first.first <= b[M + 1].first.second ? L : R) = M;
    }
    l = L;
  }

  ll ans = 1e18;
  if (l != -1) {
    ans = b[l + 1].first.second - b[l].first.first;
  }

  vii c(n);
  for (int i = 0; i < n; ++i) {
    c[i] = {a[i].second, i};
  }
  sort(c.begin(), c.end());

  for (ll i = l + 1; i < n; ++i) {
    auto it = lower_bound(c.begin(), c.end(), ii{b[i].first.first, 0});
    if (it == c.end()) continue;
    if (it->second == b[i].second) {
      it = upper_bound(c.begin(), c.end(), *it);
      if (it == c.end()) continue;
    }
    ans = min(ans, it->first - b[i].first.first);
  }

  return ans;
}

void solve() {
  ll n;
  cin >> n;
  vii a(n);
  cin >> a;

  ll ans = solve2(n, a);
  for (auto &e : a) e = {e.second, e.first};
  ans = min(ans, solve2(n, a));

  cout << ans << endl;
}