#include <bits/stdc++.h>

using namespace std;

int sz;
vector<vector<int>> tree;

inline vector<int> combine(vector<int> &a, vector<int> &b) {
    vector<int> ans;
    int idx = 0;
    int jdx = 0;
    while (idx < a.size() && jdx < b.size()) {
        if (a[idx] <= b[jdx]) {
            ans.push_back(a[idx]);
            idx++;
        } else {
            ans.push_back(b[jdx]);
            jdx++;
        }
    }
    for (int i = idx; i < a.size(); ++i) {
        ans.push_back(a[i]);
    }
    for (int i = jdx; i < b.size(); ++i) {
        ans.push_back(b[i]);
    }
    return ans;
}

inline void build(int v, int l, int r, vector<pair<int, int>> &a) {
    if (r - l == 1) {
        if (l < a.size()) {
            tree[v] = {a[l].second};
        } else {
            tree[v] = {};
        }
        return;
    }
    build(2 * v + 1, l, (l + r) / 2, a);
    build(2 * v + 2, (l + r) / 2, r, a);
    tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
}

inline void init(int n, vector<pair<int, int>> &a) {
    sz = 1;
    while (sz < n) {
        sz *= 2;
    }
    tree.resize(2 * sz - 1);
    build(0, 0, sz, a);
}

inline int ans3(int v, int l, int r, int ql, int qr, int val) {
    if (r <= ql | qr <= l)return INT_MAX;
    if (ql <= l && r <= qr) {
        int x1 = INT_MAX;
        int y1 = INT_MAX;
        if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].end()) {
            x1 = *lower_bound(tree[v].begin(), tree[v].end(), val);
        }
        if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].begin()) {
            y1 = *(--lower_bound(tree[v].begin(), tree[v].end(), val));
        }
        if (x1 == INT_MAX && y1 == INT_MAX)return INT_MAX;
        else if (x1 == INT_MAX)return abs(y1 - val);
        else if (y1 == INT_MAX)return abs(x1 - val);
        else return min(abs(x1 - val), abs(y1 - val));
    }
    int s1 = ans3(2 * v + 1, l, (l + r) / 2, ql, qr, val);
    int s2 = ans3(2 * v + 2, (l + r) / 2, r, ql, qr, val);
    return min(s1, s2);
}

inline int ans1(int v, int l, int r, int ql, int qr, int val) {
    if (r <= ql | qr <= l)return INT_MAX;
    if (ql <= l && r <= qr) {
        int x1 = INT_MAX;
        if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].end()) {
            x1 = *lower_bound(tree[v].begin(), tree[v].end(), val);
        }
        return x1;
    }
    int s1 = ans1(2 * v + 1, l, (l + r) / 2, ql, qr, val);
    int s2 = ans1(2 * v + 2, (l + r) / 2, r, ql, qr, val);
    return min(s1, s2);
}

inline int ans2(int v, int l, int r, int ql, int qr, int val) {
    if (r <= ql | qr <= l)return INT_MAX;
    if (ql <= l && r <= qr) {
        int x1 = INT_MAX;
        if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].begin()) {
            x1 = *(--lower_bound(tree[v].begin(), tree[v].end(), val));
        }
        return x1;
    }
    int s1 = ans2(2 * v + 1, l, (l + r) / 2, ql, qr, val);
    int s2 = ans2(2 * v + 2, (l + r) / 2, r, ql, qr, val);
    if (s1 == INT_MAX && s2 == INT_MAX)return INT_MAX;
    else if (s1 == INT_MAX)return s2;
    else if (s2 == INT_MAX)return s1;
    else {
        return max(s1, s2);
    }
}

bool cmp(pair<int, int> &a, pair<int, int> &b) {
    if (a.first != b.first)return a < b;
    return b.first > b.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
    }
    sort(c.begin(), c.end(), cmp);
    init(n, c);
    vector<int> sufmx(n + 1, 0);
    sufmx[n - 1] = c[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        sufmx[i] = max(sufmx[i + 1], c[i].second);
    }
    int ans = INT_MAX;
    for (int i = 0; i < n; ++i) {
        int x = c[i].first;
        int mx = sufmx[i + 1];
        if (i == n - 1) {
            ans = min(ans, ans3(0, 0, sz, 0, i, x));
        } else if (i == 0) {
            ans = min(ans, abs(x - mx));
        } else {
            if (mx >= x) {
                ans = min(ans, mx - x);
                continue;
            }
            if (mx < x) {
                int y1 = ans2(0, 0, sz, 0, i, x);
                if (y1 == INT_MAX || y1 < mx) {
                    y1 = mx;
                }
                ans = min(ans, min(ans1(0, 0, sz, 0, i, x) - x, min(x - mx, x - y1)));
            }
        }
    }
    cout << ans;
}
