#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>


using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = 1e18;


bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return (a.second <= b.second);
}

ll max(ll a, ll b) {
	if (a >= b) {
		return a;
	}
	return b;
}

ll min(ll a, ll b) {
	if (a <= b) {
		return a;
	}
	return b;
}

void solve() {
	int n;
	cin >> n;

	ll ans = linf;
	vector<pair<ll, ll>> a(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}

	sort(a.begin(), a.end(), cmp);

	vector<ll> max_suf(n + 1, 0);
	for (int i = n - 1; i > -1; --i) {
		max_suf[i] = max(max_suf[i + 1], a[i].first);
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (a[j].first > max_suf[i + 1]) {
				ans = min(ans, abs(a[i].second - a[j].first));
			}
		}
		ans = min(ans, abs(a[i].second - max_suf[i + 1]));
	}

	// stupid(n, a);
	cout << ans << endl;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}

	

	return 0;
}
