#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());


bool check(vector<pair<ll, ll>> &a, vector<ll> &suf, ll val) {
    ll n = sz(a);
    set<ll> s;
    for(int i = 0; i < n; i++) {
        ll M1 = a[i].first;
        ll M2 = -1e18;
        if(i + 1 <= n - 1)
            M2 = suf[i + 1];
        if(M2 > M1)
            continue;
        if(M1 - val <= M2)
            return true;
        auto p = s.lower_bound(M1 - val);
        if(p != s.end() && ((*p) <= M2)) {
            return true;
        }
        s.insert(a[i].second);
    }
    return false;
}

ll make(vector<pair<ll, ll>> &a) {
    ll n = sz(a);
    vector<ll> suf(n);
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 <= n - 1)
            suf[i] = suf[i + 1];
        suf[i] = max(suf[i], a[i].second);
    }

    ll L = -1, R = 1e9 + 100;
    while (R - L > 1) {
        ll MID = (R + L) / 2;
        if(check(a, suf, MID))
            R = MID;
        else
            L = MID;
    }
    return R;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(all(a));
    ll best = make(a);
    for(int i = 0; i < n; i++) {
        swap(a[i].first, a[i].second);
    }
    sort(all(a));
    best = min(best, make(a));
    cout << best;
}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
