#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <random>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	if (p == 1) return a;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N], tout[N], p[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
	tout[v] = timer++;
}
bool upper(ll a, ll b)
{
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
void up(ll& a, ll& b, ll& ans)
{
	while (!upper(head[a], b))
	{
		ans = min(ans, get(1, 0, n - 1, tin[head[a]], tin[a]));
		a = p[head[a]];
	}
}
ll get(ll a, ll b)
{
	ll ans = 1e18;
	up(a, b, ans);
	up(b, a, ans);
	if (upper(b, a)) swap(a, b);
	ans = min(ans, get(1, 0, n - 1, tin[a], tin[b]));
	return ans;
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//random_device rd;
	//mt19937 gen(rd());

	ll n;
	cin >> n;
	vector <pair <ll, ll>> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
	ll ans = 1e18;
	sort(a.begin(), a.end());
	set <pair <ll, ll>> s1, s2, s3;
	for (ll i = 0; i < n; i++) s3.insert({ a[i].second, i });
	for (ll i = 0; i < n; i++)
	{
		ll ma = -1e18, m1 = -1e18, m2 = 1e18;
		s3.erase({ a[i].second, i });
		if (!s3.empty()) ma = (*s3.rbegin()).first;
		while (!s2.empty() && (*s2.begin()).first < a[i].first)
		{
			s1.insert(*s2.begin());
			s2.erase(*s2.begin());
		}
		if (!s1.empty()) m1 = (*s1.rbegin()).first;
		if (!s2.empty()) m2 = (*s2.begin()).first;
		m1 = max(m1, ma);
		m2 = max(m2, ma);
		ans = min(ans, abs(a[i].first - m1));
		ans = min(ans, abs(a[i].first - m2));
		s2.insert({ a[i].second, i });
	}
	cout << ans;

	return 0;
}
/*

*/