#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

constexpr int N = 3e5 + 3;

template<int MOD>
class MintBase {
 public:
  using Type = MintBase<MOD>;
  MintBase(): x(0) {}
  explicit MintBase(int x) : x(x) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD ? x + rhs.x - MOD : x + rhs.x
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD : x - rhs.x
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return x < rhs.x; }
  bool operator == (const Type & rhs) const { return x == rhs.x; }
  bool operator != (const Type & rhs) const { return x != rhs.x; }

 private:
  int x;
};
typedef MintBase<int(1e9) + 7> Mint;

template<int MOD1, int MOD2>
class HashBase {
 public:
  using Type = HashBase<MOD1, MOD2>;
  HashBase(): x(0), y(0) {}
  explicit HashBase(int x) : x(x), y(x) {}
  HashBase(int x, int y) : x(x), y(y) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD1 ? x + rhs.x - MOD1 : x + rhs.x,
        y + rhs.y >= MOD2 ? y + rhs.y - MOD2 : y + rhs.y
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD1 : x - rhs.x,
        y - rhs.y < 0 ? y - rhs.y + MOD2 : y - rhs.y
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD1),
        static_cast<int>(1ll * y * rhs.y % MOD2)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return optimization < rhs.optimization; }
  bool operator == (const Type & rhs) const { return optimization == rhs.optimization; }
  bool operator != (const Type & rhs) const { return optimization != rhs.optimization; }

 private:
  union {
    struct { int y, x; };
    ll optimization;
  };
};
typedef HashBase<int(1e9) + 7, int(1e9) + 9> Hash;
Hash P(911, 991), pws[N];

template<int MOD1, int MOD2>
HashBase<MOD1, MOD2> Substr(int l, int r, const vector<HashBase<MOD1, MOD2>> & hash) {
  return hash[r] - hash[l] * pws[r - l];
}

vector<int> ZFunc(const string & s) {
  vector<int> z(s.size());
  int n = static_cast<int>(s.size());
  for (int i = 1, l = 0, r = 0; i < n; ++i) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n && s[z[i]] == s[i + z[i]])
      ++z[i];
    if (i + z[i] > r)
      l = i, r = i + z[i];
  }
  return z;
}

class SegmentTree {
 public:
  SegmentTree(int n) {
    sz = 1;
    while (sz < n) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
  }
  SegmentTree(const vector<ll> & orig) {
    sz = 1;
    while (sz < static_cast<int>(orig.size())) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
    for (int i = 0; i < static_cast<int>(orig.size()); ++i)
      segm[i + sz] = orig[i];
    for (int i = sz - 1; i > 0; --i)
      segm[i] = segm[i << 1] + segm[i << 1 | 1];
  }
  ll Get(int l, int r) {
    return Get(l, r, 1, 0, sz);
  }
  void Update(int l, int r, ll val) {
    Update(l, r, val, 1, 0, sz);
  }

 private:
  void Push(int v, int vl, int vr) {
    if (add[v]) {
      segm[v] += add[v] * (vr - vl);
      if (v < sz) {
        add[v << 1] += add[v];
        add[v << 1 | 1] += add[v];
      }
      add[v] = 0;
    }
  }
  ll Get(int l, int r, int v, int vl, int vr) {
    if (l >= vr || vl >= r) return 0;
    Push(v, vl, vr);
    if (l <= vl && vr <= r) return segm[v];
    int vm = (vl + vr) >> 1;
    return Get(l, r, v << 1, vl, vm) + Get(l, r, v << 1 | 1, vm, vr);
  }
  void Update(int l, int r, ll val, int v, int vl, int vr) {
    Push(v, vl, vr);
    if (l >= vr || vl >= r) return;
    if (l <= vl && vr <= r) {
      add[v] = val;
      Push(v, vl, vr);
      return;
    }
    int vm = (vl + vr) >> 1;
    Update(l, r, val, v << 1, vl, vm);
    Update(l, r, val, v << 1 | 1, vm, vr);
    segm[v] = segm[v << 1] + segm[v << 1 | 1];
  }
 private:
  int sz;
  vector<ll> segm, add;
};

const ld EPS = 1e-12;
const ld PI = acosl(-1);
const ld PI_TWICE = PI * 2;
const ld PI_HALF = PI * 0.5;

int sign(ld x) {
  if (x > EPS) return 1;
  if (x < -EPS) return -1;
  return 0;
}

struct Point {
  ld x, y;
  Point() : x(0), y(0) {}
  Point(ld x, ld y) : x(x), y(y) {}
  Point operator + () const { return *this; }
  Point operator - () const { return { -x, -y }; }

  Point operator + (const Point & rhs) const { return { x + rhs.x, y + rhs.y }; }
  Point operator - (const Point & rhs) const { return { x - rhs.x, y - rhs.y }; }
  Point operator * (ld k) const { return { x * k, y * k }; }
  Point& operator += (const Point & rhs) { return *this = *this + rhs; }
  Point& operator -= (const Point & rhs) { return *this = *this - rhs; }
  Point& operator *= (ld k) { return *this = *this * k; }

  ld operator * (const Point & rhs) const { return x * rhs.x + y * rhs.y; }
  ld operator % (const Point & rhs) const { return x * rhs.y - y * rhs.x; }
  ld Angle(const Point & p) const {
    ld ans = atan2l(*this % p, *this * p);
    return ans < EPS ? ans + PI_TWICE : ans;
  }
  ld Dist2(const Point & p) const {
    ld dx = x - p.x, dy = y - p.y;
    return dx * dx + dy * dy;
  }
  ld Dist(const Point & p) const {
    return sqrtl(Dist2(p));
  }

  bool operator < (const Point & p) const {
    int z = sign(x - p.x);
    return z == 0 ? sign(y - p.y) == -1 : z == -1;
  }
  bool operator == (const Point & p) const {
    return sign(x - p.x) == 0 && sign(y - p.y) == 0;
  }
  bool operator != (const Point & p) const {
    return sign(x - p.x) != 0 || sign(y - p.y) != 0;
  }

  friend istream & operator >> (istream & in, Point & p) {
    ll a, b;
    in >> a >> b;
    p.x = a, p.y = b;
    return in;
  }
  friend ostream & operator << (ostream & out, const Point & p) {
    out << p.x << ' ' << p.y;
    return out;
  }
};

#define int ll

void Solve() {

  int n;
  cin >> n;
  vector<int> a(n), b(n);
  multiset<int> st;
  vector<pair<int, int>> v(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i] >> b[i];
    st.insert(b[i]);
    v[i] = { a[i], i };
  }
  set<int> ch;
  sort(v.begin(), v.end());
  int ans = INF;
  for (int i = 0; i < n; ++i) {
    int u = v[i].second;
    st.erase(st.find(b[u]));
    if (!st.empty())
      smin(ans, abs(a[u] - *st.rbegin()));
    auto it = ch.lower_bound(a[u]);
    if (it != ch.end())
      smin(ans, abs(a[u] - *it));
    if (it != ch.begin()) {
      --it;
      smin(ans, abs(a[u] - *it));
    }

    ch.insert(b[u]);
  }
  cout << ans << endl;

}


int32_t main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  pws[0] = Hash(1);
  for (int i = 1; i < N; ++i) {
    pws[i] = pws[i-1] * P;
  }

  cout << fixed << setprecision(12);
  Solve();

  return 0;
}
