#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <tuple>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif


template<typename T>
istream &operator>>(istream &in, pair<T, T> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

const int INF = 2e9;
const int BLOCK = 707;

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> ab(n);
    cin >> ab;
    sort(ab.begin(), ab.end());
    vector<int> a(n), b(n), b2(n);
    range(i, n) {
        tie(a[i], b[i]) = ab[i];
        b2[i] = b[i];
    }
    for (auto l = b2.begin(); l < b2.end(); l += BLOCK) {
        sort(l, min(b2.end(), l + BLOCK));
    }
    int rmaxb = 0;
    int best = INF;
    for (int i = n - 1; i >= 0; i--) {
        best = min(best, abs(rmaxb - a[i]));
        range(j, i / BLOCK) {
            int L = j * BLOCK, R = L + BLOCK;
            while (L + 1 != R) {
                int c = (L + R) / 2;
                if (b2[c] <= a[i]) {
                    L = c;
                } else {
                    R = c;
                }
            }
            best = min(best, abs(a[i] - max(rmaxb, b2[L])));
            if (R < (j + 1) * BLOCK) {
                best = min(best, abs(a[i] - max(rmaxb, b2[R])));
            }
        }
        for (int j = i / BLOCK * BLOCK; j < i; j++) {
            best = min(best, abs(a[i] - max(rmaxb, b[j])));
        }
        rmaxb = max(rmaxb, b[i]);
    }
    cout << best << endline;
}