#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <tuple>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif


template<typename T>
istream &operator>>(istream &in, pair<T, T> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

int INF = 2e9;

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> ab(n);
    cin >> ab;
    sort(ab.begin(), ab.end());
    vector<int> a(n), b(n);
    bool g4 = true;
    range(i, n) {
        tie(a[i], b[i]) = ab[i];
        g4 = g4 && (a[i] == b[i]);
    }
    if (g4) {
        cout << a.back() - a[a.size() - 2] << endline;
        return 0;
    }
    int smaxb = 0;
    int best = INF;
    for (int i = n - 1; i >= 0; i--) {
        best = min(best, abs(smaxb - a[i]));
        range(j, i) {
            best = min(best, abs(a[i] - max(smaxb, b[j])));
        }
        smaxb = max(smaxb, b[i]);
    }
    cout << best << endline;
}