#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 500000;
const int BUFFER_SIZE = 100000;

int pos = 0;
char buffer[BUFFER_SIZE];

void read_char()
{
    if (++ pos == BUFFER_SIZE) fread(buffer, 1, BUFFER_SIZE, stdin), pos = 0;
}

int val = 0;

int read_int()
{
    val = 0;
    for (; buffer[pos] < '0' or '9' < buffer[pos]; read_char());
    for (; '0' <= buffer[pos] and buffer[pos] <= '9'; read_char())
    {
        val = val * 10 + (buffer[pos] - '0');
    }
    return val;
}

int mx[MAXN + 5];

bool cmp(pair<int, int> x, pair<int, int> y)
{
    if (x.first != y.first) return (x.first < y.first);
    return (x.second > y.second);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    n = read_int();

    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        int a, b;
        a = read_int();
        b = read_int();
        v.push_back({a, b});
    }

    sort(v.begin(), v.end(), cmp);

    mx[n] = -1;
    for (int i = n - 1; i >= 0; -- i)
    {
        mx[i] = max(mx[i + 1], v[i].second);
    }

    set<int> s;
    int ans = 1e9 + 1;
    for (int i = 0; i < n; ++ i)
    {
        int mxb = mx[i + 1];
        if (mxb >= v[i].first) ans = min(ans, mxb - v[i].first);
        else
        {
            ans = min(ans, v[i].first - mxb);
            auto it = lower_bound(s.begin(), s.end(), v[i].first);
            if (it != s.end()) ans = min(ans, (*it) - v[i].first);
            if (it != s.begin())
            {
                it--;
                ans = min(ans, v[i].first - max((*it), mxb));
            }
        }
        s.insert(v[i].second);
    }

    cout << ans << endl;

    return 0;
}
