#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#define endl '\n'
using namespace std;

const int MAXN = 500000;
const int BUFFER_SIZE = 100000;

int pos = 0;
char buffer[BUFFER_SIZE];

void read_char()
{
    if (++ pos == BUFFER_SIZE) fread(buffer, 1, BUFFER_SIZE, stdin), pos = 0;
}

int val = 0;

int read_int()
{
    val = 0;
    for (; buffer[pos] < '0' or '9' < buffer[pos]; read_char());
    for (; '0' <= buffer[pos] and buffer[pos] <= '9'; read_char())
    {
        val = val * 10 + (buffer[pos] - '0');
    }
    return val;
}

int mx[MAXN + 5];

bool cmp(pair<int, int> x, pair<int, int> y)
{
    if (x.first != y.first) return (x.first < y.first);
    return (x.second > y.second);
}

int tree[8 * MAXN + 5];

void update(int v, int l, int r, int upos)
{
    if (l == r)
    {
        tree[v]++;
        return;
    }

    int mid = (l + r) / 2;
    if (upos <= mid) update(2 * v, l, mid, upos);
    else update(2 * v + 1, mid + 1, r, upos);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int l, int r, int ql, int qr)
{
    if (qr < l or r < ql) return 0;
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return (query(2 * v, l, mid, ql, qr) + query(2 * v + 1, mid + 1, r, ql, qr));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    n = read_int();

    vector<int> comp;
    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        int a, b;
        a = read_int();
        b = read_int();
        v.push_back({a, b});
        comp.push_back(a);
        comp.push_back(b);
    }

    sort(v.begin(), v.end(), cmp);

    sort(comp.begin(), comp.end());
    auto it = unique(comp.begin(), comp.end());
    comp.resize(distance(comp.begin(), it));

    mx[n] = -1;
    for (int i = n - 1; i >= 0; -- i)
    {
        mx[i] = max(mx[i + 1], v[i].second);
    }

    set<int> s;
    int ans = 1e9 + 1;
    for (int i = 0; i < n; ++ i)
    {
        int mxb = mx[i + 1];
        if (mxb >= v[i].first) ans = min(ans, mxb - v[i].first);
        else
        {
            ans = min(ans, v[i].first - mxb);
            int p = lower_bound(comp.begin(), comp.end(), v[i].first) - comp.begin() + 1;
            int l = p, r = comp.size() + 1;
            while (r - l > 1)
            {
                int mid = (l + r) / 2;
                if (query(1, 1, n, p + 1, mid) == 0) l = mid;
                else r = mid;
            }
            if (r <= comp.size()) ans = min(ans, comp[r - 1] - v[i].first);

            l = 0;
            r = p;
            while (r - l > 1)
            {
                int mid = (l + r) / 2;
                if (query(1, 1, n, mid, p - 1) == 0) r = mid;
                else l = mid;
            }
            if (l != 0) ans = min(ans, v[i].first - max(comp[l - 1], mxb));
            /**auto it = lower_bound(s.begin(), s.end(), v[i].first);
            if (it != s.end()) ans = min(ans, (*it) - v[i].first);
            if (it != s.begin())
            {
                it--;
                ans = min(ans, v[i].first - max((*it), mxb));
            }*/
        }
        int c = lower_bound(comp.begin(), comp.end(), v[i].second) - comp.begin() + 1;
        update(1, 1, n, c);
    }

    cout << ans << endl;

    return 0;
}
