#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>
#include <iomanip>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

void solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n, vector<int> (2));
  for (auto &x : a) {
    for (auto &y : x) {
      cin >> y;
    }
  }

  sort(all(a));
  multiset<int> st;
  for (int i = 0; i < n; i++) {
    st.insert(a[i][1]);
  }

  int res = 1e18, mx = -1;
  for (int i = n - 1; i >= 0; i--) {
    st.erase(st.find(a[i][1]));
    if (mx > a[i][0]) {
      res = min(res, mx - a[i][0]);
    } else {
      auto it = st.lower_bound(a[i][0]);
      if (it != st.end()) {
        res = min(res, *it - a[i][0]);
      }
      if (it != st.begin()) {
        res = min(res, a[i][0] - max(*prev(it), mx));
      }
    }

    mx = max(mx, a[i][1]);
  }

  cout << res << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}