#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

#define int ll

const int mod = 1e9 + 7, k1 = 29, k2 = 31;

int add(int a, int b) {
    if (a + b >= mod)
        return a + b - mod;
    return a + b;
}

int mul(int a, int b) {
    return int(1LL * a * b % mod);
}

int sub(int a, int b) {
    if (a - b < 0)
        return a - b + mod;
    return a - b;
}

pair<int, int> operator+(pair<int, int> a, pair<int, int> b) {
    return {add(a.first, b.first), add(a.second, b.second)};
}

pair<int, int> operator*(pair<int, int> a, pair<int, int> b) {
    return {mul(a.first, b.first), mul(a.second, b.second)};
}

pair<int, int> operator-(pair<int, int> a, pair<int, int> b) {
    return {sub(a.first, b.first), sub(a.second, b.second)};
}

typedef pair<int, int> pii;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n&1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

const int maxn = 5e6 + 100;
int deg1[maxn], deg2[maxn], inv_deg1[maxn], inv_deg2[maxn];

void precalc() {
    deg1[0] = deg2[0] = inv_deg1[0] = inv_deg2[0] = 1;
    int inv_k1 = binpow(k1, mod - 2);
    int inv_k2 = binpow(k2, mod - 2);
    for (int i = 1; i < maxn; ++i) {
        deg1[i] = mul(deg1[i - 1], k1);
        deg2[i] = mul(deg2[i - 1], k2);
        inv_deg1[i] = mul(inv_deg1[i - 1], inv_k1);
        inv_deg2[i] = mul(inv_deg2[i - 1], inv_k2);
    }
}

int ask(int p) {
    cout << "? " << p << endl;
    int x; cin >> x;
    return x;
}

void give_answer(vector<int>& ans) {
    cout << "! ";
    for (auto &el : ans)
        cout << el << ' ';
    cout << endl;
}

int get(int i) {
    return 1LL * i * (i + 1) / 2;
}

#define MT

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int all_sum = ask(n);
    int curr_found = 0;
    int lst_k = 0;
    for (int i = 0; i < k; ++i) {
        int l = lst_k, r = n + 1;
        while (r - l > 1) {
            int m = (r + l) >> 1;
            int sm = ask(m);
            if (get(m) - curr_found == sm) {
                l = m;
            } else {
                r = m;
            }
        }
        // l + 1 = nw_k
        curr_found += l + 1;
        ans.push_back(l + 1);
    }

    give_answer(ans);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    precalc();
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}