#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

std::map<ll, ll> mem;

void answer(v<ll>& list) {
	std::cout << "! ";
	for (auto i : list) {
		std::cout << i << ' ';
	}
	std::cout << std::endl;
	ll ans;
	std::cin >> ans;
	if (ans == -1) exit(0);
}

ll q(ll x) {
	if (mem.find(x) != mem.end()) {
		return mem[x];
	}
	std::cout << "? " << x << std::endl;
	ll ans;
	std::cin >> ans;
	mem[x] = ans;
	return ans;
}

void solve() {
	mem.clear();
	ll n, k;
	std::cin >> n >> k;
	v<ll> ans;
	ll last = 0, sum = 0;
	for (int i = 0; i < k; ++i) {
		ll lhs = last, rhs = n;
		while (rhs - lhs > 1) {
			ll mid = lhs + (rhs - lhs) / 2;
			if (q(mid) - sum == (mid * (mid + 1)) / 2 - (last * (last + 1)) / 2) {
				lhs = mid;
			}
			else {
				rhs = mid;
			}
		}
		ans.push_back(rhs);
		last = rhs;
		sum = q(last);
	}
	answer(ans);
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}