#include <bits/stdc++.h>
using namespace std;
vector<int> ans;
map<int, long long> pref;

long long getNeed(int l, int r) {
    return (l + r) * 1ll * (r - l + 1) / 2;
}

long long ask(int l, int r) {
    long long resp;
    if (pref.find(r) == pref.end()) {
        cout << "? " << r << endl;
        cin >> resp;
        pref[r] = resp;
        if (resp == -1) {
            exit(0);
        }
    }
    if (pref.find(l - 1) == pref.end()) {
        cout << "? " << l - 1 << endl;
        cin >> resp;
        pref[l] = resp;
        if (resp == -1) {
            exit(0);
        }
    }
    return pref[r] - pref[l - 1];
}

void find(int l, int r, long long sum) {
    if (sum == 0) {
        for (int i = l; i <= r; ++i) {
            ans.emplace_back(i);
        }
        return;
    }
    if (l == r) {
        assert(false);
        return;
    }
    if (l + 1 == r) {
        ans.emplace_back(2 * l + 1 - sum);
        return;
    }
    int m = l + (r - l) / 2;
    // [l, m]
    long long sumL = ask(l, m);
    if (getNeed(l, m) != sumL) {
        find(l, m, sumL);
    }
    // [m + 1, r]
    long long sumR = sum - sumL;
    if (getNeed(m + 1, r) != sumR) {
        find(m + 1, r, sumR);
    }
}

void answer() {
    cout << '!';
    for (const int& i : ans) {
        cout << ' ' << i;
    }
    cout << endl;
    int resp;
    cin >> resp;
    if (resp == -1) {
        exit(0);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    pref.clear();
    pref[0] = 0;
    if (n <= 1000) {
        // pairs
        for (int i = 2; i <= n; i += 2) {
            long long cur = ask(i - 1, i);
            // cerr << "i: " << i << ", cur: " << cur << '\n';
            if (cur == 0) {
                ans.emplace_back(i - 1);
                ans.emplace_back(i);
            } else if (cur != 2 * i - 1) {
                ans.emplace_back(2 * i - 1 - cur);
            }
        }
        if ((int)ans.size() < k) {
            assert(ans.empty() || ans.back() != n);
            ans.emplace_back(n);
        }
    } else {
        // find
        pref[n] = ask(1, n);
        find(1, n, pref[n]);
    }
    answer();
}

int main() {
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/

#ifdef LOCAL
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
