#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

#ifdef NT1E
int money[10] = {1, 0, 3, 4, 5, 0, 7, 0, 9, 0};


ll ask(int p) {
    cerr << p;
    ll s = 0;
    for (int i = 0; i < p; ++i) {
        s += money[i];
    }
    cerr << "=>" << s << ' ';
    return s;
}
#else

unordered_map<int, ll> qcache;
ll ask(int p) {
    auto it = qcache.find(p);
    if (it != qcache.end()) {
        return it->second;
    }
    ll v;
    cout << "? " << p << endl;
    cin >> v;
    if (v == -1) {
        exit(0);
    }
    return qcache[p] = v;
}
#endif

void solve() {
    qcache.clear();
    int n, k;
    cin >> n >> k;
    ll s = 0;
    vector<int> ans;
    int left = 0, right = n;
    for (int i = 0; i < k - 1; ++i) {
        right = n;
        while (right - left > 1) {
            int mid = (right + left + 1) / 2;
            ll v = ask(mid);
            if (v + s < mid * 1ll * (mid + 1) / 2) {
                right = mid;
            } else {
                left = mid;
            }
        }
        cerr << "ok" << right << endl;
        ans.push_back(right);
        s += right;
        left = right;
    }
    ans.push_back(n * 1ll * (n + 1) / 2 - ask(n) - s);
    cout << "! ";
    for (int now : ans) {
        cout << now << ' ';
    }
    cout << endl;
    cin >> n;
    if (n == -1) {
        exit(0);
    }
}

int main() {
//#ifdef NT1E
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}