#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

#ifdef NT1E
int money[10] = {1, 0, 3, 4, 5, 0, 7, 0, 9, 0};


ll ask(int p) {
    cerr << p;
    ll s = 0;
    for (int i = 0; i < p; ++i) {
        s += money[i];
    }
    cerr << "=>" << s << ' ';
    return s;
}
#else

unordered_map<int, ll> qcache;
ll ask(int p) {
    auto it = qcache.find(p);
    if (it != qcache.end()) {
        return it->second;
    }
    ll v;
    cout << "? " << p << endl;
    cin >> v;
    if (v == -1) {
        exit(0);
    }
    return qcache[p] = v;
}
#endif

vector<int> solve(int left, int right, ll s, ll rs) {
    rs = right * 1ll * (right + 1) / 2 - rs;
    s = (left + 1) * 1ll * left / 2 - s;
    vector<int> ans;
    int orig_right = right;
    while (s != rs) {
        right = orig_right;
        while (right - left > 1) {
            int mid = (right + left + 1) / 2;
            ll v = ask(mid);
            if (v + s < mid * 1ll * (mid + 1) / 2) {
                right = mid;
            } else {
                left = mid;
            }
        }
//        cerr << "ok" << right << endl;
        ans.push_back(right);
        s += right;
        left = right;
    }
//    ans.push_back(n * 1ll * (n + 1) / 2 - rs - s);
    return ans;
}

void solve(int n, int k) {
#ifndef NT1E
    qcache.clear();
#endif
    vector<int> res;
    res.reserve(k);
    ll p = 0;
    int K = 0, kf = 228337;
    for (int i = 1; i <= 3500; ++i) {
        int f = (n + i - 1) / i + k * (1 + __lg(i - 1));
        if (f < kf) {
            kf = f;
            K = i;
        }
    }
//    cerr << K << ' ' << kf << ' ';
    for (int i = 0; i < (n + K - 1) / K; ++i) {
        ll rs = ask(min(n, (i + 1) * K));
        for (int now : solve(i * K, min(n, (i + 1) * K), p, rs)) {
            res.push_back(now);
        }
        p = rs;
    }
    cout << "! ";
    for (int now : res) {
        cout << now << ' ';
    }
    cout << endl;
    int r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
}

int main() {
//#ifdef NT1E
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, k;
        cin >> n >> k;
        solve(n, k);
    }
    return 0;
}