#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

#ifdef NT1E
int money[10] = {1, 0, 3, 4, 5, 0, 7, 0, 9, 0};


ll ask(int p) {
    cerr << p;
    ll s = 0;
    for (int i = 0; i < p; ++i) {
        s += money[i];
    }
    cerr << "=>" << s << ' ';
    return s;
}
#else

unordered_map<int, ll> qcache;
ll ask(int p) {
    auto it = qcache.find(p);
    if (it != qcache.end()) {
        return it->second;
    }
    ll v;
    cout << "? " << p << endl;
    cin >> v;
    if (v == -1) {
        exit(0);
    }
    return qcache[p] = v;
}
#endif

vector<int> solve(int left, int right, ll s, ll rs) {
    ll os = s, ors = rs;
    rs = right * 1ll * (right + 1) / 2 - rs;
    s = (left - 1) * 1ll * left / 2 - s;
    ll rss = rs - s;
    if (rss == 0) {
        return {};
    }
    else if (rss <= right) {
        return {(int)(rs - s)};
    } else {
        int mid;
        if (rss < 2 * right) {
            mid = (1 + rss) / 2;
        } else {
            mid = (2 + rss) / 3;
        }
        ll am = ask(mid - 1);
        vector<int> s1 = solve(left, mid - 1, os, am);
        vector<int> s2 = solve(mid, right, am, ors);
        s1.reserve(s1.size() + s2.size());
        for (int now : s2) {
            s1.push_back(now);
        }
        return s1;
    }
}

void solve(int n, int k) {
#ifndef NT1E
    qcache.clear();
#endif
    vector<int> res;
    res.reserve(k);
    ll p = 0;
    for (int first = 1; first <= n; first = first * 2 + 1) {
        ll rs = ask(min(n, first * 2));
        for (int now : solve(first, min(n, 2 * first), p, rs)) {
            res.push_back(now);
        }
        p = rs;
    }

    cout << "! ";
    for (int now : res) {
        cout << now << ' ';
    }
    cout << endl;
    int r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
}

int main() {
//#ifdef NT1E
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, k;
        cin >> n >> k;
        solve(n, k);
    }
    return 0;
}

