#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll sum(ll l, ll r){ // (l, r]
    return r * (r+1) / 2 - l * (l+1)/2;
}

map<ll, ll> que;

ll get(ll x){ // [1, x]
    if (que.find(x) == que.end()){
        cout << "? " << x << endl;
        cin >> que[x];
        if (que[x] == -1) exit(0);
    }
    return que[x];
}

ll get(ll l, ll r) { // (l, r]
    return get(r) - get(l);
}
vector<ll> ans;
void find(ll l, ll r){
    if (l == r) return;
    if (get(l, r) == sum(l, r)) return;
    if (sum(l, r) - get(l, r) < l + 1 + l + 2) {
        ans.push_back(sum(l, r) - get(l, r));
        return;
    }
    ll mid = (l+r)/2;
    find(l, mid);
    find(mid, r);
}

int main() {
    fastio();
    ll t;
    cin >> t;
    while(t--){
        ll n, k;
        cin >> n >> k;
        que.clear();
        que[0] = 0;
        ans.clear();
        find(0, n);
        cout << "! ";
        for (ll x : ans) cout << x << " ";
        cout << endl;
        ll res;
        cin >> res;
        if (res == -1) exit(0);
    }
    return 0;
}