#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll sum(ll l, ll r){ // (l, r]
    return r * (r+1) / 2 - l * (l+1)/2;
}

map<ll, ll> que;

ll get(ll x){ // [1, x]
    if (que.find(x) == que.end()){
        cout << "? " << x << endl;
        cin >> que[x];
        if (que[x] == -1) exit(0);
    }
    return que[x];
}

ll get(ll l, ll r) { // (l, r]
    return get(r) - get(l);
}
vector<ll> ans;
void find(ll l, ll r){
    if (l == r) return;
    if (get(l, r) == sum(l, r)) return;
    if (sum(l, r) - get(l, r) < l + 1 + l + 2) {
        ans.push_back(sum(l, r) - get(l, r));
        return;
    }
    ll mid = (l+r)/2;
    find(l, mid);
    find(mid, r);
}

int main() {
    fastio();
    ll t;
    cin >> t;
    while(t--){
        ll n, k;
        cin >> n >> k;
        que.clear();
        que[0] = 0;
        ans.clear();
        if (k == 3){
            ll l = 0, r = n;
            while(l+1<r){
                ll mid = (l+r)/2;
                if (get(0, mid) == sum(0, mid)){
                    l = mid;
                }else{
                    r = mid;
                }
            }
            ans.push_back(r);
            ll sm = sum(r, n) - get(r, n);
            ans.push_back(sum(r, sm / 2) - get(r, sm / 2));
            ans.push_back(sm - ans.back());
            cout << "! ";
            for (ll x : ans) cout << x << " ";
            cout << endl;
            ll res;
            cin >> res;
            if (res == -1) exit(0);
        }
        else if (k == 4){
            ll l = 0, r = n;
            while(l+1<r){
                ll mid = (l+r)/2;
                if (get(0, mid) == sum(0, mid)){
                    l = mid;
                }else{
                    r = mid;
                }
            }
            ans.push_back(r);
            ll sm = sum(r, n) - get(r, n);
            ll f = sm / 3;
            ll sm1 = sum(r, f) - get(r, f);
            ll sm2 = sm - sm1;
            if (sm1 <= 0 || sm2 <= 0) {
                cout << "aboba" << endl;
                return 0;
            }
            if (get(r, sm1 / 2) == sum(r, sm1 / 2)) {
                ans.push_back(sm1);
                ans.push_back(sum(f, sm2 / 2) - get(f, sm2 / 2));
                ans.push_back(sm2 - ans.back());
            }
            else{
                ans.push_back(sum(r, sm1 / 2) - get(r, sm1 / 2));
                ans.push_back(sm1 - ans.back());
                ans.push_back(sm2);
            }
            cout << "! ";
            for (ll x : ans) cout << x << " ";
            cout << endl;
            ll res;
            cin >> res;
            if (res == -1) exit(0);
        }
        else{
            find(0, n);
            cout << "! ";
            for (ll x : ans) cout << x << " ";
            cout << endl;
            ll res;
            cin >> res;
            if (res == -1) exit(0);
        }
    }
    return 0;
}