#include <iostream>
#include <algorithm>
#include <fstream>

#include <vector>
#include <map>
#include <set>

#include <stack>
#include <queue>
#include <deque>

using namespace std;

using ll = long long;
using ld = long double;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

void go(ll left, ll right, ll prev_count, ll count, vl& answers, map<ll, ll>& old_answers){
    if (count == 0){
        for (ll i = left; i <= right; i++){
            answers.push_back(i);
        }
        return;
    }
    ll summ = right * (right + 1) / 2 - left * (left - 1) / 2; 
    if (count == summ){
        return;
    }
    ll delta = summ - count;
    if (delta >= left && delta <= right && delta <= 2 * left){
        answers.push_back(delta);
        return; 
    }
    count = (delta - left) * (delta - left + 1) / 2 - left * (left - 1) / 2;
    right = delta - left;

    ll middle = (left + right) / 2;
    ll left_count;
    if (old_answers[middle] == 0){
        cout << "? " << middle << '\n';
        cout.flush();
        cin >> left_count;
        if (left_count == 0){
            old_answers[middle] = -1;
        }
        else{
            old_answers[middle] = left_count;
        }
    }
    else if (old_answers[middle] == -1){
        left_count = 0;
    }
    else{
        left_count = old_answers[middle];
    }
    left_count -= prev_count;
    ll right_count = count - left_count;

    go(left, middle, prev_count, left_count, answers, old_answers);
    go(middle + 1, right, prev_count + left_count, right_count, answers, old_answers);
}

void solve(){
    ll n, k;
    cin >> n >> k;

    cout << "? " << n << '\n';
    cout.flush();
    ll count;
    cin >> count; 

    vl answers(0);
    map<ll, ll> old_answers;
    go(1, n, 0, count, answers, old_answers);
    cout << "! ";
    for (auto elem : answers){
        cout << elem << ' ';
    }
    cin >> k;
    return;
}

int main(){
    ll t;
    cin >> t;
    for (ll t_ = 0; t_ < t; t_++){
        solve();
        cout << '\n';
    }
    return 0;
}