#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

mt19937 rnd;
struct Solution {
    static ll mst(int l, int r) {
        return (ll) (l + 1) * (ll) (r - l) + (ll) (r - l) * (ll) (r - l - 1) / 2ll;
    }

    struct Interactor {
        unordered_map<int, ll> rs;
        int n{}, k{};

#ifdef ILKRAS
        set<int> ar;
        int counter = 0;
#endif

        Interactor() {
#ifdef ILKRAS
            if (!STRS) {
                cout << "INIT" << endl;
            }
#endif
            if (!STRS) {
                cin >> n >> k;
            } else {
                n = rnd() % 1000000000 + 1;
                k = rnd() % 100 + 1;
            }
#ifdef ILKRAS
            for (int i = 0; i < k; ++i) {
                int prv = 0;
                if (!STRS) {
                    int x;
                    cin >> x;
                    ar.insert(x);
                } else {
                    int x = rnd() % (n - prv) + prv + 1;
                    prv = x - 1;
                    ar.insert(x);
                }
            }
#endif
        };

        ll ask(int p) {
            assert(1 <= p && p <= n);
            if (rs.count(p))
                return rs[p];
#ifdef ILKRAS
            if (!STRS) {
                cout << "ASK " << ++counter << endl;
            }
#endif
            if (!STRS) {
                cout << "? " << p << endl;
            }
#ifndef ILKRAS
            cin >> rs[p];
            if (rs[p] == -1) {
                assert(false);
            }
#else
            ll res = mst(0, p);
            for (auto &it: ar) {
                if (it <= p) {
                    res -= it;
                }
            }
            rs[p] = res;
            if (!STRS) {
                cout << "RES: " << res << endl;
            }
#endif
            return rs[p];
        }

        void ans(vector<int> ar) {
            if (!STRS) {
                cout << "! ";
                for (auto &it: ar) {
                    cout << it << " ";
                }
                cout << endl;
            }
#ifdef ILKRAS
            if (!STRS) {
                cout << "FINISHED IN " << counter << endl;
            }
            set<int> kk;
            for (auto &it: ar) {
                kk.insert(it);
            }
            if (kk != this->ar) {
                if (!STRS) {
                    assert(false);
                } else {
                    cout << "WA\n";
                    cout << n << " " << k << "\n";
                    for (auto& it : ar) {
                        cout << it << " ";
                    }
                    cout << "\n";
                    cout << "WA:\n";
                    for (auto& it : kk) {
                        cout << it << " ";
                    }
                    cout << endl;
                    STRS = false;
                }
            }
#else
            int res;
            cin >> res;
            if (res != 1) {
                exit(0);
            }
#endif
        }
    };

    Interactor io;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    vector<int> ans;

    void slvrc(int l, // 0
               int r, // n
               ll lsum, // 0
               ll rsum, // ask(n)
               int &k
    ) {
        ll cur = rsum - lsum;
        if (cur == mst(l, r)) {
            return;
        }
        if (l + 1 == r || k == 1) {
            ans.push_back((int) (mst(l, r) - cur));
            k--;
            return;
        }
        int m = (l + r) / 2;
        ll df = io.ask(m);
        slvrc(l, m, lsum, df, k);
        if (k == 0)
            return;
        slvrc(m, r, df, rsum, k);
    }

    ll neg(int p) {
        return mst(0, p) - io.ask(p);
    }

    signed operator()(int TEST = -1) {
        int n = io.n;
        int k = io.k;
        if (k != 3) {
            slvrc(0, n, 0, io.ask(n), k);
            io.ans(ans);
            return 0;
        }
        int mx = neg(n);
        int l = 1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            ll rs = neg(m);
            if (rs == mx) {
                r = m;
                continue;
            }
            if (rs == 0) {
                l = m;
                continue;
            }
            ll nw = neg(rs - 1);
            if (nw != 0) {
                r = m;
            } else {
                l = m;
            }
        }
        int rs = neg(r - 1);
        ans = {rs, r, mx - rs - r};
        io.ans(ans);
#ifdef ILKRAS
#endif
        return 0;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
        if (st % 100 == 0) {
            cout << st << endl;
        }
    }
    int t = 1;
    cin >> t;
#ifdef ILKRAS
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//2
//100000 3
//400 5700 89000
//1000000000 3
//400000 5700000 89000000
//
//4
//3 2
//1 3
//10 4
//2 6 8 10
//100000 3
//400 5700 89000
//1000000000 3
//400000 5700000 89000000
