#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x, y;

    Point(int x, int y) {
        this->x = x;
        this->y = y;
    }

    friend int operator%(Point a, Point b) {
        return a.x * b.y - a.y * b.x;
    }

    friend int operator*(Point a, Point b) {
        return a.x * b.x + a.y * b.y;
    }

    friend Point operator+(Point a, Point b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend Point operator-(Point a, Point b) {
        return {a.x - b.x, a.y - b.y};
    }

    long long len_sq(Point a) {
        return a.x * a.x + a.y * a.y;
    }

    double len(Point a) {
        return sqrt(len_sq(a));
    }

    long long dist_sq(Point a, Point b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
    }

    double dist(Point a, Point b) {
        return sqrt(dist_sq(a, b));
    }

    bool check_collinear(Point a, Point b) {
        if (abs(double(a.x) / double(b.x) - double(a.y) / double(b.y)) < 1e-8) {
            return true;
        }
        return false;
    }

};

bool comp_points(Point a, Point b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

void obol(vector<Point> arr) {
    int min_x = -1e9;
    Point min(1e9, 1e9);
    queue<Point> q;
    sort(arr.begin(), arr.end(), comp_points);
    q.push(arr[0]);
    q.push(arr[1]);
    int i = 2;
}

vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

int counter_steps = 0;

void check_step() {
    assert(counter_steps <= 3500);
}

long long ask(int p) {
    cout << "? " << p << endl;
    counter_steps++;
    check_step();
    long long ans;
    cin >> ans;
    return ans;
}

long long resp() {
    long long ans;
    cin >> ans;
    return ans;
}

set<int> st;
map<int, long long> sm;

long long sum_first(long long n) {
    return n * (n + 1) / 2;
}

set<int> ans;

void check_sum(int n) {
    if (sm.find(n) == sm.end()) {
        sm[n] = ask(n);
    }
}

void find1(int l, int r) {
    if (r - l == 0) {
        check_sum(r);
        check_sum(r - 1);
        int real_sum = sum_first(r) - sum_first(r - 1);
        if (real_sum != sm[r] - sm[r - 1]) {
            ans.insert(r);
            return;
        }
    }
    if (r - l == 1) {
        check_sum(r);
        check_sum(l - 1);
        long long sum_fake = sm[r] - sm[l - 1];
        if (sum_fake == 0){
            ans.insert(l);
            ans.insert(r);
            return;
        }
        if (r + l == sum_fake) {
            return;
        }
        if (r == sum_fake) {
            ans.insert(l);
            return;
        } else {
            ans.insert(r);
            return;
        }
    }
    int m = (l + r) / 2;
    check_sum(r);
    check_sum(m);
    check_sum(l - 1);
    long long real_sum_left = sum_first(m) - sum_first(l - 1);
    if (real_sum_left != sm[m] - sm[l - 1]) {
        find1(l, m);
    }
    long long real_sum_right = sum_first(r) - sum_first(m);
    if (real_sum_right != sm[r] - sm[m]) {
        find1(m + 1, r);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    sm.clear();
    sm[0] = 0;
    find1(1, n);
    cout << "! ";
    for (auto u: ans) {
        cout << u << " ";
    }
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
