#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;

#define int long long

int ask(int p)
{
	cout << "? " << p << endl;
	int got;
	cin >> got;
	if (got == -1) exit(0);
	return got;
}

void ans(vector <int> fal)
{
	cout << "! ";
	for (auto i : fal) cout << i << ' ';
	cout << endl;
	int got;
	cin >> got;
	if (got == -1) exit(0);
}

inline void solve()
{
	int n, k;
	cin >> n >> k;

	vector <int> fal;

	set <pair <int, int>> done;

	while (fal.size() < k)
	{
		int l, r;
		if (fal.size()) l = fal.back();
		else l = 0;
		r = n;

		while (l + 1 < r)
		{
			int mid = (l + r) >> 1;

			auto pt = done.lower_bound(make_pair(mid, (int)0));
			if (pt != done.end())
			{
				int f = pt->second;
				for (auto i : fal) f += i;
				if (f == (pt->first + 1) * pt->first / 2)
				{
					l = mid;
					continue;
				}
			}

			auto got = ask(mid);
			done.insert({ mid, got });
			for (auto i : fal) got += i;
			if (got == mid * (mid + 1) / 2) l = mid;
			else r = mid;
		}

		fal.push_back(r);
	}

	ans(fal);
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}