#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <functional>
#include <climits>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>



const int mod = 1000000007;

using namespace std;


using ll = long long;
using dl = long double;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;



template <typename T, typename S>
istream& operator>>(istream& in, pair<T, S>& a)
{
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream& operator<<(ostream& out, pair<T, S>& a)
{
    out << a.first << ' ' << a.second;
    return out;
}
template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (T& x : a) in >> x;
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T>& a)
{
    for (T& x : a) out << x << ' ';
    return out;
}

template <typename T>
struct VEC
{
    T x, y;
    template <typename S>
    VEC(S _x, S _y): x(_x), y(_y) {};
    VEC() {};

};
template <typename T>
VEC<T> operator+(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x + b.x, a.y + b.y);
}
template <typename T>
VEC<T> operator-(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x - b.x, a.y - b.y);
}
template <typename T>
ll cross(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.x + a.y*b.y;
}
template <typename T>
ll vecp(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.y - a.y*b.x;
}
template <typename T>
T dist2(VEC<T>& a, VEC<T>& b)
{
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}
template <typename T>
istream& operator >>(istream& in, VEC<T>& a)
{
    in >> a.x >> a.y;
    return in;
}
template <typename T>
ostream& operator <<(ostream& out, VEC<T>& a)
{
    out << a.x << ' ' << a.y;
    return out;
}

template <typename T>
dl angle(VEC<T>& a, VEC<T>& b)
{
    dl ret = atan2((dl)vecp(a, b), (dl)cross(a, b));
    return ret;
}


ll gcd (ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a%b);
}
ll lcm(ll x, ll y)
{
    return (x/gcd(x, y))*y;
}
ll binpow(ll x, ll p, int m)
{
    if (p == 0) return 1;
    ll ret = binpow(x, p>>1, m);
    ret = ret*ret%m;
    if (p&1) ret = ret*x%mod;
    return ret;
}


struct segmtree
{
    vector<int> tree;
    int size;
    void merge()
    {

    }
    void clear()
    {

    }
    void update()
    {

    }
    segmtree() { }
    void build()
    {

    }

};



signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(18);
    

    int t = 1;
    cin >> t;
next:
    while (t--)
    {
        
        function<ll(int)> ask = [](int p)
        {
            cout << "? " << p << endl;
            ll a;
            cin >> a;
            if (a == -1) exit(0);
            return a;
        };
        vector<int> ans;
        function<void()> answer = [&]()
        {
            cout << "! "<< ans << endl;
            int a;
            cin >> a;
            if (a == -1) exit(0);
        };
        //

        int n, k;
        cin >> n >> k;
        map<int, ll> save;
        for (int i = 0; i < k; i++)
        {
            if (ans.empty())
            {
                int u = ask(1);
                save[1] = u;
                if (u == 0) 
                {
                    ans.push_back(1);
                    continue;
                }
            }
            int l = (ans.empty() ? 1 : ans.back()), r = n+1;
            while (l + 1 != r)
            {
                ll m = (l + r) >> 1;
                ll summ;
                if (save.find(m) != save.end()) summ = save[m];
                else
                {
                    summ = ask(m);
                    save[m] = summ;
                }
                for (int x : ans)
                {
                    if (x > m) break;
                    summ += x;
                }
                if (summ == m*(m + 1)/2) l = m;
                else r = m;
            }
            ans.push_back(r);
        }
        answer();
        

        
    }
    return 0;
}

