#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <functional>
#include <climits>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>
#include <random>
#include <chrono>



const int mod = 1000000007;

using namespace std;


using ll = long long;
using dl = long double;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;



template <typename T, typename S>
istream& operator>>(istream& in, pair<T, S>& a)
{
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream& operator<<(ostream& out, pair<T, S>& a)
{
    out << a.first << ' ' << a.second;
    return out;
}
template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (T& x : a) in >> x;
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T>& a)
{
    for (T& x : a) out << x << ' ';
    return out;
}

template <typename T>
struct VEC
{
    T x, y;
    template <typename S>
    VEC(S _x, S _y): x(_x), y(_y) {};
    VEC() {};

};
template <typename T>
VEC<T> operator+(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x + b.x, a.y + b.y);
}
template <typename T>
VEC<T> operator-(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x - b.x, a.y - b.y);
}
template <typename T>
ll cross(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.x + a.y*b.y;
}
template <typename T>
ll vecp(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.y - a.y*b.x;
}
template <typename T>
T dist2(VEC<T>& a, VEC<T>& b)
{
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}
template <typename T>
istream& operator >>(istream& in, VEC<T>& a)
{
    in >> a.x >> a.y;
    return in;
}
template <typename T>
ostream& operator <<(ostream& out, VEC<T>& a)
{
    out << a.x << ' ' << a.y;
    return out;
}

template <typename T>
dl angle(VEC<T>& a, VEC<T>& b)
{
    dl ret = atan2((dl)vecp(a, b), (dl)cross(a, b));
    return ret;
}


ll gcd (ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a%b);
}
ll lcm(ll x, ll y)
{
    return (x/gcd(x, y))*y;
}
ll binpow(ll x, ll p, int m)
{
    if (p == 0) return 1;
    ll ret = binpow(x, p>>1, m);
    ret = ret*ret%m;
    if (p&1) ret = ret*x%mod;
    return ret;
}


struct segmtree
{
    vector<int> tree;
    int size;
    void merge()
    {

    }
    void clear()
    {

    }
    void update()
    {

    }
    segmtree() { }
    void build()
    {

    }

};


//#define STRE
//#define HAND
//vector<int> fake = {2, 3, 4};
/*
1
1000000000 3

*/

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(18);
    

    int t = 1;
    cin >> t;
next:
    while (t--)
    {

        map<int, ll> save;
        int cnt_a = 0;
        /*
        #ifdef HAND
        ll n = 949140301, k = 3;
        vector<int> fake = { 328157671, 767071880, 922033176};
        #endif
        */
        #ifdef STRE
        ll k = 3;
        mt19937_64 rg(chrono::steady_clock().now().time_since_epoch().count());
        uniform_int_distribution<int> rng1(3, 1000000000);
        ll n = rng1(rg);
        uniform_int_distribution<int> rng2(1, n);
        set<int> fakes;
        while(fakes.size() != 3)
        {
            fakes.insert(rng2(rg));
        }
        vector<int> fake;
        for (int x : fakes)
        {
            fake.push_back(x);
        }
        #else
        ll n, k;
        cin >> n >> k;
        #endif
        
        function<ll(ll)> ask = [&](ll p)
        {
            #ifndef STRE
            if (save.find(p) != save.end()) return save[p];
            cout << "? " << p << endl;
            ll a;
            cin >> a;
            if (a == -1) exit(0);
            save[p] = a;
            return a;
            #else
            if (save.find(p) == save.end()) ++cnt_a;
            if (cnt_a > 33)
            {
                cout << "\nWWWWWWWWWWWWWWWWWWWWWWWWWW\n" << n << ' ' << k << '\n' << fake << "\nWWWWWWWWWWWWWWWWWWWWW\n";
                exit(0);
            }
            ll ret = p*(p + 1)/2;
            for (int x : fake) 
            {
                if (x <= p) ret -= x;
            }
            save[p] = ret;
            return ret;
            #endif
        };
        vector<int> ans;
        function<void()> answer = [&]()
        {
            #ifndef STRE
            cout << "! "<< ans << endl;
            int a;
            cin >> a;
            if (a == -1) exit(0);
            #else
            if (fake != ans)
            {
                cout << "\nWWWWWWWWWWWWWWWWWWWWWWWWWW\n" << n << ' ' << k << '\n' << fake <<  "\nWWWWWWWWWWWWWWWWWWWWW\n";
                exit(0);
            }
            #endif
        };  
        //

        save[0] = 0;
        if (k == 3)
        {
            ll S = n*(n + 1)/2 - ask(n);
            ll mid = S/3;
            ll ifm = mid*(mid + 1)/2 - ask(mid);
            int l, r;
            if (ifm > mid)
            {
                ans.push_back(S - ifm);
                S = ifm;
                l = 0, r = ifm+1;
            }
            else
            {
                ll suppose = ifm;
                ll supposed = ask(suppose - 1);
                //ll small = ask(suppose - 1);
                if (supposed == suppose*(suppose - 1)/2)
                {
                    ans.push_back(suppose);
                    S -= suppose;
                    l = suppose - 1, r = S/2 + 1;
                }
                else
                {
                    ans.push_back(S - suppose);
                    S = suppose;
                    l = 0, r = S/2 + 1;
                }
            }
            
            while (l + 1 != r)
            {
                ll m = (l + r) >> 1;
                ll summ = ask(m);
                for (int x : ans)
                {
                    if (x > m) break;
                    summ += x;
                }
                if (summ == m*(m + 1)/2) l = m;
                else r = m;
            }
            ans.push_back(r), ans.push_back(S-r);
            sort(ans.begin(), ans.end());
            answer();
            goto next;
        }
        
        for (int i = 0; i < k; i++)
        {
            if (ans.empty())
            {
                int u = ask(1);
                save[1] = u;
                if (u == 0)
                {
                    ans.push_back(1);
                    continue;
                }
            }
            int l = (ans.empty() ? 1 : ans.back()), r = n+1;
            while (l + 1 != r)
            {
                ll m = (l + r) >> 1;
                ll summ = ask(m);
                for (int x : ans)
                {
                    if (x > m) break;
                    summ += x;
                }
                if (summ == m*(m + 1)/2) l = m;
                else r = m;
            }
            ans.push_back(r);
        }
        answer();
        

        
        


    }
    return 0;
}

