#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

map<ll, ll> memorized;

ll ask(ll p) {
    if (memorized.contains(p)) {
        return memorized[p];
    }

    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }

    memorized[p] = res;
    return res;
}

void solveK3(ll n) {
    ll L = 0;
    ll R = n + 1;
    ll M = 0;
    ll mReal = 0;
    while (true) {
        ll m = (L + R) >> 1;
        ll real = ask(m);
        if (m * (m + 1) / 2 == real) {
            L = m;
        } else if (real == ask(n)) {
            R = m;
        } else {
            M = m;
            mReal = real;
            break;
        }
    }

    vector<ll> res;
    ll lSum = M * (M + 1) / 2 - mReal;
    if (lSum <= M && ask(lSum) == lSum * (lSum + 1) - lSum) {
        res.push_back(lSum);

        ll rMid = (M + 1 + R) / 2;
        ll rrSum = ask(rMid);
        res.push_back(rMid * (rMid + 1) / 2 - rrSum - res[0]);
        res.push_back(R * (R - 1) / 2 - ask(R) - res[0] - res[1]);
    } else {
        ll rAll = ask(n) - mReal;
        ll rAllReal = R * (R + 1) / 2 - M * (M + 1) / 2;
        ll rSum = rAll - rAllReal;
        res.push_back(rSum);

        ll lMid = lSum / 2;
        ll llSum = ask(lMid);
        res.push_back(lMid * (lMid + 1) / 2 - llSum);
        res.push_back(R * (R - 1) / 2 - ask(R) - res[0] - res[1]);
    }

    sort(res.begin(), res.end());
    cout << "! ";
    for (ll i = 0; i < ll(res.size()); ++i) {
        cout << res[i];
        if (i < n - 1) {
            cout << ' ';
        }
    }
    cout << endl;

    ll verdict;
    cin >> verdict;
    if (verdict == -1) {
        exit(0);
    }
}

void resolve() {
    memorized.clear();
    ll n, k;
    cin >> n >> k;
    if (n == -1 || k == -1) {
        exit(0);
    }

    if (k == 3) {
        solveK3(n);
        return;
    }

    ll allSum = ask(n);
    vector<ll> res;
    ll got = 0;
    for (ll i = 0; i < k - 1; ++i) {
        ll l = 0;
        ll r = n + 1;
        if (!res.empty()) {
            l = res.back();
        }

        while (r - l > 1) {
            ll m = (l + r) >> 1;
            ll real = ask(m);
            ll notLeft = (m * (m + 1) / 2) - got;
            ll diff = notLeft - real;
            if (diff > 0 && diff < l * 2) {
                r = diff;
                break;
            }

            if (real == notLeft) {
                l = m;
            } else {
                r = m;
            }
        }

        res.push_back(r);
        got += r;
    }

    res.push_back(n * (n + 1) / 2 - allSum - got);
    sort(res.begin(), res.end());
    cout << "! ";
    for (ll i = 0; i < ll(res.size()); ++i) {
        cout << res[i];
        if (i < n - 1) {
            cout << ' ';
        }
    }
    cout << endl;

    ll verdict;
    cin >> verdict;
    if (verdict == -1) {
        exit(0);
    }
}

int32_t main() {
    ll testN;
    cin >> testN;
    while (testN--) {
        resolve();
    }
    return 0;
}
