#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 1e9;

std::set <int> s;
int cntQuestions;
inline llong getSum(int l, int r)
{
    return 1LL * (l + r) * (r - l + 1) / 2;
}

int n;
inline llong makeQuestion(int to)
{
    assert(to <= n);
    llong res;
    std::cout << "? " << to << std::endl;
    std::cin >> res;
    return res;
}

int searchL, searchR;
std::vector <int> listFake;
llong sumOfFake;
llong currFound;
llong currSum;
int k;

void reset()
{
    listFake.clear();
    sumOfFake = currFound = currSum = 0;
    searchL = searchR = 0;
}

int search()
{
    int l = searchL - 1, r = searchR, mid;
    while (l < r - 1)
    {
        llong currTry;
        mid = (l + r) / 2;
        currTry = makeQuestion(mid);
        currTry -= getSum(1, l - 1) - sumOfFake;
        currTry += currFound;

        if (currTry == getSum(l, mid)) l = mid;
        else r = mid;
    }

    searchL = r + 1;
    return r;
}

void solve1(int l, int r, llong sum)
{
    listFake.push_back(getSum(l, r) - sum);
}

void solve2(int searchL, int searchR, llong prefixSum, llong allSum)
{
    int l = searchL - 1, r = searchR, mid;
    while (l < r - 1)
    {
        llong currTry;
        mid = (l + r) / 2;
        currTry = makeQuestion(mid);
        currTry -= prefixSum;
        if (currTry == getSum(searchL, mid)) l = mid;
        else r = mid;
    }

    listFake.push_back(r);
    solve1(r + 1, searchR, prefixSum + allSum - makeQuestion(r));
}

void solve3()
{
    llong sum = makeQuestion(n);
    int l = 0, r = n, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        llong curr = makeQuestion(mid);
        if (curr == getSum(1, mid))
        {
            l = mid;
            continue;
        }

        if (sum - curr == getSum(mid + 1, r))
        {
            r = mid;
            continue;
        }
        
        llong ifLNum = getSum(1, mid) - curr;
        llong ifRNum = getSum(mid + 1, r) - (sum - curr);
        if (ifLNum > mid || ifRNum < mid + 1 + mid + 2)
        {
            solve2(1, mid, 0, curr);
            solve1(mid + 1, r, sum - curr);
            return;
        }

        if (ifRNum > r || ifLNum < l + l + 1)
        {
            solve1(1, mid, curr);
            solve2(mid + 1, r, curr, sum - curr);
            return;
        }

        llong res = makeQuestion(ifLNum - 1);
        if (res == getSum(l, ifLNum) - 1)
        {
            solve1(1, mid, curr);
            solve2(mid + 1, r, curr, sum - curr);
        } else
        {
            solve2(l, mid, 0, curr);
            solve1(mid + 1, r, sum - curr);
            return;
        }
    }
}

int tests;
void solve()
{
    int bucketSize = n / (3 * k / 2) + (n % (3 * k / 2) > 0);
    int l = 0, r = 0;
    while (listFake.size() < k)
    {
        l = r + 1;
        r += bucketSize;
        r = std::min(r, n);
        if (l > n)
        {
            break;
        }

        currSum = makeQuestion(r);
        currSum -= getSum(1, l - 1) - sumOfFake;
        currFound = 0; searchL = l; searchR = r;
        if (currSum == 0)
        {
            for (int i = l ; i <= r ; ++i)
            {
                sumOfFake += i;
                listFake.push_back(i);
            }

            continue;
        }

        if (currSum < l + l + 1)
        {
            for (int i = l ; i <= r ; ++i)
            {
                if (i == currSum) continue;
                listFake.push_back(i);
                sumOfFake += i;
            }

            continue;
        }

        while (currSum + l + (l + 1) <= getSum(l, r))
        {
            int curr = search();
            listFake.push_back(curr);
            currFound += curr;
            currSum += curr;
        }

        if (currSum != getSum(l, r))
        {
            listFake.push_back(getSum(l, r) - currSum);
            currFound += listFake.back();
        }
    
        sumOfFake += currFound;
    }

    // // std::cout << "!";
    // for (const int &i : listFake)
    // {
    //     if (!s.count(i))
    //     {
    //         std::cout << "WA\n";
    //         return;
    //     }
    //     // std::cout << ' ' << i;
    // }

    // std::cout << "OK\n";
    // return;
}

void output()
{
    std::cout << "!";
    for (const int &i : listFake)
    {
        std::cout << ' ' << i;
    }

    std::cout << std::endl;

    int res;
    std::cin >> res;
    if (res == -1)
    {
        exit(0);
    }
}

void input()
{
    std::cin >> n >> k;
}

int main()
{
    srand(5);
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        if (k == 3) solve3();
        else solve();
        output();
    }

    return 0;
}