#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

const long long MD = 1e9 + 7, p = 137;

long long cerate_hash(string str) {
	long long res = 0, step = 1;
	for (char i : str) {
		res += ((i - 'a' + 1) * step) % MD;
		res %= MD;
		step *= p;
		step %= MD;
	}
	return res;
}

long long bpow(long long a, long long b) {
	if (b == 0) {return 1;}
	if (b == 1) {return a;}
	long long res = bpow(a, b / 2) % MD;
	if (b % 2) {
		return (((res * res) % MD) * a) % MD;
	}
	return (res * res) % MD;
}


void solve() {
	long long n, m, step = 1, x, y;
	string str, inp;
	cin >> n >> m;
	cin >> str;
	vector<long long> pref = {0}, pw;
	for (char i : str) {
		pref.push_back((pref[pref.size() - 1] + (i - 'a' + 1) * step) % MD);
		pw.push_back(bpow(step, MD - 2) % MD);
		step *= p;
		step %= MD;
	}
	vector<vector<long long>> vect;
	for (int i = 0; i < n; ++i) {
		cin >> inp;
		vect.push_back({cerate_hash(inp), (long long) inp.size()});
	}
	
	// for (long long i : pref) {
	// 	cout << i << ' ';
	// }
	// cout << endl;

	// for (auto i : vect) {
	// 	cout << i[0] << ' ';
	// }
	// cout << endl;

	long long cnt;
	for (int i = 0; i < m; ++i) {
		cin >> x >> y;
		--x; --y;
		cnt = 0;
		// cout << x << ' ' << y << endl;
		for (int j = 0; j < n; ++j) {
			for (int k = x; k <= y - (vect[j][1] - 1); ++k) {
				// cout << n << ' ' << k << endl;
				step = pref[k + vect[j][1]] + MD - pref[k];
				step %= MD;
				// cout << step << " > ";
				step = (step * pw[k]) % MD;
				// cout << step <<  ' ' << vect[j][0] << endl;
				if (step == vect[j][0]) {
					cnt++;
				}
			}
		}
		cout << cnt << ' ';  // "< ----- " << endl;
	}
	cout << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}