#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

map<int, long long> answ;

vector<long long> poss;

long long ask(int x) {
    if (answ.find(x) != answ.end()) {
        long long res = answ[x];
        for (auto el : poss) {
            if (el <= x) {
                res += el;
            }
        }
        return res;
    }
    cout << "? " << x << endl;
    long long res;
    cin >> res;
    assert(res >= 0);
    answ[x] = res;
    for (auto el : poss) {
        if (el <= x) {
            res += el;
        }
    }
    return res;
}

void flushans() {
    poss.resize(0);
    answ.clear();
}

constexpr long long getrealsum(int x) {
    return x * (x + 1ll) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    int kst = k;
    while ((int)poss.size() < kst) {
        long long sumall = getrealsum(n);
        long long realsumall = ask(n);
        long long sumempty = sumall - realsumall;

        long long maxk = (sumempty - (k * (k - 1ll) / 2) + k - 1) / k;
        long long sumtail = (2ll * n - (k - 1) + 1) * (k - 1ll) / 2;
        long long mink = max(1ll, sumempty - sumtail);
        if (!poss.empty()) {
            mink = max(mink, poss.back() + 1);
        }

        mink--;
        while (maxk - mink > 1) {
            long long mid = (mink + maxk) / 2;
            long long cres = ask(mid);
            if (cres == getrealsum(mid)) {
                mink = mid;
            } else {
                maxk = mid;
            }
        }
        poss.emplace_back(maxk);
        k--;
    }
    cout << "!";
    for (auto el : poss) {
        cout << " " << el;
    }
    cout << endl;
    int ansj;
    cin >> ansj;
    assert(ansj > 0);
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
        flushans();
    }
    return 0;
}
