#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll
const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}

	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};

int ask(int p) {
	cout << "? " << p << endl;
	int res;
	cin >> res;
	return res;
}

int sm(int x) {
	return x * (x + 1) / 2;
}

int findLeast(int n, int L = 0, int add = 0) {
	int l = L, r = n + 1;
	while (r > l + 1) {
		int m = (r + l) / 2;
		int res = ask(m);
		if (res + add != sm(m)) {
			r = m;
		} else {
			l = m;
		}
	}
	return r;
}

void solve() {
	int n, k;
	cin >> n >> k;
	if (k == 3) {
		int x = findLeast(n), y = -1, z = -1;
		int sum = sm(n) - ask(n) - x;
		int get = sm(sum / 2) - ask(sum / 2);
		if (x <= sum / 2) {
			y = get - x;
			z = sum - y;
		} else {
			y = get;
			z = sum - y;
		}
		cout << "! " << x << " " << y << " " << z << endl;
	} else {
		vector<int> ans = {findLeast(n)};
		int add = ans.back();
		for (int i = 1; i < k; i++) {
			int x = findLeast(n, ans.back(), add);
			ans.push_back(x);
			add += x;
		}
		cout << "! ";
		for (auto& u : ans) {
			cout << u << " ";
		}
		cout << endl;
	} 
	int res;
	cin >> res;
	if (res == -1) {
		exit(0);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}