#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define int __int128
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;
const int inf = 2000000000000000000;

ll binpow(ll n, ll k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

struct seg_tree{
    vector <int> t;
    vector <int> p;

    void push(int v){
        if(p[v] != 0){
            t[v * 2] += p[v];
            t[v * 2 + 1] += p[v];
            p[v * 2] += p[v];
            p[v * 2 + 1] += p[v];
            p[v] = 0;
        }
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return 0;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

int quer(int p){
    cout << "? " << p << endl;
    int x;
    cin >> x;

    if(x == -1){
        assert(0);
    }

    return x;
}

void solve(){
    int n, k;
    cin >> n >> k;

    if(n <= 1000){
        vector <int> otv;
        int sm = 0;
        for(int i = 2; i <= n; i += 2){
            if(otv.size() == k){
                break;
            }
            int x = quer(i) - ((i - 2) * (i - 1) / 2 - sm);

            if(x == 0){
                otv.push_back(i - 1);
                otv.push_back(i);

                sm += 2 * i - 1;
            }else{
                if(x != 2 * i - 1){
                    otv.push_back(2 * i - 1 - x);
                    sm += 2 * i - 1 - x;
                }
            }
        }

        if(otv.size() < k){
            otv.push_back(n);
        }

        cout << "! ";
        for(auto x : otv){
            cout << x << " ";
        }
        cout << endl;

        int x;
        cin >> x;
        if(x == -1){
            assert(0);
        }

        return;
    }

    if(k == 3){
        int sm = 0, smn = n * (n + 1) / 2 - quer(n);
        int l = 0, r = n;
        int x1 = -1;
        bool state = 0;
        while(l + 1 < r){
            int m = (l + r) / 2;

            int x = quer(m);
            x1 = x;

            sm = m * (m + 1) / 2 - x;

            if(sm != smn && sm > 0){
                x = quer(smn - sm - 1);
                if(x != smn){
                    sm = smn - sm;
                    state = 1;
                }else{
                    state = 0;
                }

                break;
            }

            if(x != m * (m + 1) / 2){
                r = m;
            }else{
                l = m;
            }
        }

        vector <int> otv;
        int b = 0;
        if(state == 0){
            while(l + 1 < r){
                int m = (l + r) / 2;

                int x;
                if(x1 != -1){
                    x = x1;
                    x1 = -1;
                }else {
                    x = quer(m);
                }

                if(x != m * (m + 1) / 2 - sm){
                    r = m;
                }else{
                    l = m;
                }
            }

            b = r;
        }else{
            while(l + 1 < r){
                int m = (l + r) / 2;

                int x;
                if(x1 != -1){
                    x = x1;
                    x1 = -1;
                }else {
                    x = quer(m);
                }

                x = m * (m + 1) / 2 - x;

                if(x == smn - sm){
                    r = m;
                }else{
                    l = m;
                }
            }

            b = r;
        }

        cout << "! " << sm << " " << b << " " << smn - b - sm << endl;
        int x;
        cin >> x;
        if(x == -1){
            assert(0);
        }

        return;
    }

    int l = 0, r = n;
    vector <int> otv;
    int sm = 0, smn = n * (n + 1) / 2 - quer(n);
    for(int i = 0; i + 1 < k; ++i){
        r = n;
        while(l + 1 < r){
            int m = (l + r) / 2;

            int x = quer(m);

            if(x != m * (m + 1) / 2 - sm){
                r = m;
            }else{
                l = m;
            }
        }

        otv.push_back(r);
        sm += r;
    }

    otv.push_back(smn - sm);

    cout << "! ";
    for(auto x : otv){
        cout << x << " ";
    }
    cout << endl;

    int x;
    cin >> x;
    if(x == -1){
        assert(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    cin >> tests;
    while(tests--) {
        solve();
    }
}