#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = (ll) 1e18 + 9;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 5e6 + 15;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

map<int, int> was;
map<int, int> asked;

int ask(int p) {
    if(was[p]) return asked[p];
    cout << "? " << p << endl;
    int ans;
    cin >> ans;
    was[p] = 1;
    asked[p] = ans;
    return ans;
}

void announce(vector<int> out) {
    cout << "! ";
    for(auto i : out) cout << i << " ";
    cout << endl;
    int res;
    cin >> res;
    assert(res == 1);
}

int get(int l, int r) {
    int ans = (l + r) * (r - l + 1) / 2;
    return ans;
}

void solve_cringe(int n, int k) {
    if(n == 1) {
        announce(vector<int>(1, 1));
        return;
    }
    vector<int> p(n + 1, -1);
    for(int i = 2; i <= n; i += 2) {
        p[i] = ask(i);
    }
    vector<int> out;
    int sum = 0;
    for(int i = 2; i <= n; i += 2) {
        sum += 2 * i - 1;
        if(sum != p[i]) {
            int diff = sum - p[i];
            assert(diff >= 0);
            int x = i - 1;
            int y = i;
            if(diff == x + y) {
                out.pb(x);
                out.pb(y);
            }
            else if(diff == x) out.pb(x);
            else if(diff == y) out.pb(y);
            else assert(0);
        }
        sum = p[i];
    }
    if(sz(out) < k) {
        assert(n & 1);
        out.pb(n);
    }
    assert(sz(out) == k);
    announce(out);
}

void solve() {
    was.clear(); asked.clear();
    int n, k;
    cin >> n >> k;
    if(n <= 1000) {
        solve_cringe(n, k);
        return;
    }
    int sum = 0;
    int lst = 0;
    vector<int> out;
    for(int i = 0; i < k; i++) {
        int l = lst + 1, r = n;
        int coin = -1;
        while(l <= r) {
            int m = (l + r) / 2;
            int s = ask(m) - sum;
            if(s != get(lst + 1, m)) {
                r = m - 1;
                coin = m;
            }
            else l = m + 1;
        }
        assert(~coin);
        out.pb(coin);
        sum += get(lst + 1, coin - 1);
        lst = coin;
    }
    announce(out);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    cin >> ttt;
    while(ttt--) solve();
}
