#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct fenwick
{
	long long n;
	unordered_map<long long, long long> t;

	fenwick(long long in)
	{
		n = in;
	}

	void upd(long long k, long long val)
	{
		k++;
		for (; k <= n; k += k & -k)
		{
			t[k] += val;
		}
	}

	long long get(long long k)
	{
		k++;
		long long sum = 0;
		for (; k > 0; k -= k & -k)
		{
			sum += t[k];
		}
		return sum;
	}
};

long long sumlr(long long l, long long r)
{
	return (l + r) * (r - l + 1) / 2;
}

map<long long, long long> memqr;

long long ask(long long k)
{
	long long res = 0;
	if (memqr.find(k) == memqr.end())
	{
		if (memqr.find(k - 1) != memqr.end() && memqr.find(k + 1) != memqr.end())
		{
			memqr[k] = memqr[k + 1] - memqr[k - 1];
			res = memqr[k];
		}
		else
		{
			cout << "? " << k << endl;
			cout.flush();
			cin >> res;
		}
		memqr[k] = res;
	}
	else
	{
		res = memqr[k];
	}
	return res;
}

void answer(vector<long long>& ans)
{
	cout << "! ";
	for (auto& i : ans)
	{
		cout << i << " ";
	}
	cout << endl;
	cout.flush();
	long long res;
	cin >> res;
}

void solve()
{
	long long n, k;
	cin >> n >> k;
	memqr[0] = 0;

	vector<long long> ans;
	fenwick ft(n + 3);
	while (k--)
	{
		long long left = 0, right = n;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			long long res = ask(mid);
			res += ft.get(mid);
			if (res == sumlr(1, mid))
			{
				left = mid;
			}
			else
			{
				right = mid;
			}
		}
		ans.push_back(right);
		ft.upd(right, right);
	}
	answer(ans);
}

void reset()
{
	memqr.clear();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
		reset();
	}

	return 0;
}

/*























*/
