#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n, k;

long long sumlr(long long l, long long r)
{
	return (l + r) * (r - l + 1) / 2;
}

long long ask(long long k)
{
	long long res = 0;
	cout << "? " << k << endl;
	cin >> res;
	return res;
}

void answer(vector<long long>& ans)
{
	cout << "! ";
	for (auto& i : ans)
	{
		cout << i << " ";
	}
	cout << endl;
	long long res;
	cin >> res;
}

void solve_bs()
{
	vector<long long> ans;
	for (long long _ = 0; _ < k; _++)
	{
		long long left = 0, right = n;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			long long res = ask(mid);
			for (auto& i : ans)
			{
				if (i <= mid)
				{
					res += i;
				}
			}

			if (res == sumlr(1, mid))
			{
				left = mid;
			}
			else
			{
				right = mid;
			}
		}
		ans.push_back(right);
	}
	answer(ans);
}

void solve1000()
{
	long long prev = 0;
	vector<long long> ans;
	for (long long i = 2; i <= n; i += 2)
	{
		long long res = ask(i);
		res -= prev;
		if (res != i - 1 + i)
		{
			if (res == i)
			{
				ans.push_back(i - 1);
			}
			else if (res == i - 1)
			{
				ans.push_back(i);
			}
			else
			{
				ans.push_back(i - 1);
				ans.push_back(i);
			}
		}
		res += prev;
		prev = res;
	}
	if (ans.size() != k)
	{
		ans.push_back(n);
	}
	answer(ans);
}

void solve()
{
	cin >> n >> k;
	if (n <= 1000)
	{
		solve1000();
		return;
	}

	solve_bs();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/