#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n, k;

long long sumlr(long long l, long long r)
{
	return (l + r) * (r - l + 1) / 2;
}

map<long long, long long> memqr;

long long ask(long long k)
{
	if (k == 0)
	{
		return 0;
	}
	if (memqr.find(k) != memqr.end())
	{
		return memqr[k];
	}

	long long res = 0;
	cout << "? " << k << endl;
	cin >> res;
	memqr[k] = res;
	return res;
}

void answer(vector<long long>& ans)
{
	cout << "! ";
	for (auto& i : ans)
	{
		cout << i << " ";
	}
	cout << endl;
	long long res;
	cin >> res;
}

void solve_bs()
{
	vector<long long> ans;
	for (long long _ = 0; _ < k; _++)
	{
		long long left = 0, right = n;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			long long res = ask(mid);
			for (auto& i : ans)
			{
				if (i <= mid)
				{
					res += i;
				}
			}

			if (res == sumlr(1, mid))
			{
				left = mid;
			}
			else
			{
				right = mid;
			}
		}
		ans.push_back(right);
	}
	answer(ans);
}

void solve1000()
{
	long long prev = 0;
	vector<long long> ans;
	for (long long i = 2; i <= n; i += 2)
	{
		long long res = ask(i);
		res -= prev;
		if (res != i - 1 + i)
		{
			if (res == i)
			{
				ans.push_back(i - 1);
			}
			else if (res == i - 1)
			{
				ans.push_back(i);
			}
			else
			{
				ans.push_back(i - 1);
				ans.push_back(i);
			}
		}
		res += prev;
		prev = res;
	}
	if (ans.size() != k)
	{
		ans.push_back(n);
	}
	answer(ans);
}

void solve33()
{
	vector<long long> ans;
	long long left = 0, right = n;
	long long sumall = ask(n);
	long long df3 = sumlr(1, n) - sumall;
	while (right - left > 1)
	{
		long long mid = (left + right) / 2;
		long long res = ask(mid);
		long long dfl = sumlr(1, mid) - res;
		if (dfl == df3)
		{
			right = mid;
		}
		else if (dfl == 0)
		{
			left = mid;
		}
		else
		{
			long long dfr = df3 - dfl;
			if (1 <= dfl <= mid)
			{
				res = ask(dfl - 1);
				if (res == sumlr(0, dfl - 1))
				{
					ans.push_back(dfl);
					left = mid;
				}
				else
				{
					ans.push_back(dfr);
					right = mid;
				}
			}
			else
			{
				ans.push_back(dfr);
				right = mid;
			}
			break;
		}
	}

	df3 -= ans[0];
	while (right - left > 1)
	{
		long long mid = (left + right) / 2;
		long long res = ask(mid);
		for (auto& i : ans)
		{
			if (i <= mid)
			{
				res += i;
			}
		}
		long long dfl = sumlr(1, mid) - res;

		if (dfl == df3)
		{
			right = mid;
		}
		else if (dfl == 0)
		{
			left = mid;
		}
		else
		{
			ans.push_back(dfl);
			ans.push_back(df3 - dfl);
			break;
		}
	}
	answer(ans);
}

void solve()
{
	cin >> n >> k;
	memqr[0] = 0;
	if (k == 3)
	{
		solve33();
		return;
	}
	if (n <= 1000)
	{
		solve1000();
		return;
	}

	solve_bs();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
		memqr = {};
	}

	return 0;
}

/*























*/