#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

int ask(int p) {
	cout << "?" << " " << p << endl << flush;
	int ans;
	cin >> ans;
	if (ans == -1) {
		exit(0);
	}
	return ans;
}

void say(const vector<int> &is) {
	cout << "!" << " ";
	for (const int &i : is) {
		cout << i << " ";
	}
	cout << endl << flush;
	int ans;
	cin >> ans;
	if (ans == -1) {
		exit(0);
	}
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<pair<int, int>> p;
	p.emplace_back(0, 0);
	for (int i = 0; i < k; ++i) {
		int l = p.back().first;
		int r = n + 1;
		int rans = -1;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			int mans = ask(mid);
			if (mans - p.back().second == mid * (mid + 1) / 2 - p.back().first * (p.back().first + 1) / 2) {
				l = mid;
			} else {
				r = mid;
				rans = mans;
			}
		}
		p.emplace_back(r, rans);
	}
	vector<int> ans;
	for (int i = 0; i < k; ++i) {
		ans.push_back(p[i + 1].first);
	}
	say(ans);
}

int32_t main() {
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
