#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <random>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll) || typeid(T) == typeid(char))
        end_char = ' ';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

ll f(ll p) {
    return (p * (p + 1)) / 2;
}

map<int, ll> asked;

ll ask(int p) {
    if (asked.find(p) != asked.end())
        return asked[p];
    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1)
        exit(0);
    asked[p] = f(p) - res;
    return f(p) - res;
}

vector<int> ans;
void solve(int left, int right, ll lp, ll allp) {
    //cout << left << ' ' << right << ' ' << allp << endl;
    if (allp == 0)
        return;
    if (f(right) - f(left - 1) == allp) {
        for (int i = left; i <= right; ++i)
            ans.push_back(i);
        return;
    }
    if (left <= allp && allp <= right && left + left >= allp) {
        ans.push_back(allp);
        return;
    }
    int mid = (left + right) / 2;
    ll p = ask(mid);
    solve(left, mid, lp, p - lp);
    solve(mid + 1, right, p, allp - p + lp);
}

void solutionk3(int n) {
    int left = 1, right = n;
    ll allp = ask(n);
    ll p = 0;
    int mid;
    while (true) {
        mid = (left + right) / 2;
        p = ask(mid);
        if (p == 0) {
            left = mid + 1;
            continue;
        }
        if (p == allp) {
            right = mid;
            continue;
        }
        break;
    }
    ll b = allp - p;
    if (mid <= b && b <= right) {
        ans.push_back(b);
        int l = left - 1, r = mid;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (ask(m) == 0)
                l = m;
            else
                r = m;
        }
        ans.push_back(r);
        ans.push_back(p - r);
    }
    else {
        ans.push_back(p);
        int l = mid - 1, r = right;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (ask(m) == p)
                l = m;
            else
                r = m;
        }
        ans.push_back(r);
        ans.push_back(allp - r);
    }
}

int main() {
//    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
//#ifdef DUDE
//    freopen("input.txt", "r", stdin);
//#endif


    int test;
    cin >> test;
    while (test--) {
        int n, k;
        cin >> n >> k;
        if (k == 3) {
            solutionk3(n);
            cout << "! " << ans << endl;
            int a;
            cin >> a;
            if (a == -1)
                return 0;
            continue;
        }
        ll p = ask(n);
        solve(1, n, 0, p);
        cout << "! " << ans << endl;
        int a;
        cin >> a;
        if (a == -1)
            return 0;
        ans.clear();
        asked.clear();
    }
    return 0;
}
