#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

map<int, ll> mem;

ll f(ll n) {
    return n * (n + 1) / 2;
}

ll get(int p) {
    if (mem.find(p) == mem.end()) {
        cout << "? " << p << endl;
        ll x;
        cin >> x;
        mem[p] = x;
    }
    return mem[p];
}

int answer(const vector<int>& ans) {
    cout << "! ";
    for (int x : ans) cout << x << " ";
    cout << endl;
    int x;
    cin >> x;
    return x;
}

int solve() {

    int n, k;
    cin >> n >> k;
    mem.clear();

    vector<int> ans;
    ll pre = 0, nextr = n;
    while (k--) {
        ll nl = (ans.empty() ? 0 : ans.back());
        ll l = nl, r = nextr;
        while (l < r - 1) {
            ll m = (l + r) / 2;
            ll d = get(m);

            if (d == -1) return -1;
            if (d - pre != f(m) - f(nl)) r = m;
            else l = m;
        }

        pre += f(r - 1) - f(nl);
        ans.push_back(r);

        bool is = false;
        for (auto [x, y] : mem) {
            if (x > r && y - pre != f(x) - f(r)) {
                nextr = x;
                is = true;
                break;
            }
        }
        if (!is) nextr = n;
    }

    return answer(ans);
}

int main() {
#ifndef LOCAL
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) {
        if (solve() == -1) return 0;
    }

}