#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

constexpr int N = 3e5 + 3;

template<int MOD>
class MintBase {
 public:
  using Type = MintBase<MOD>;
  MintBase(): x(0) {}
  explicit MintBase(int x) : x(x) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD ? x + rhs.x - MOD : x + rhs.x
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD : x - rhs.x
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return x < rhs.x; }
  bool operator == (const Type & rhs) const { return x == rhs.x; }
  bool operator != (const Type & rhs) const { return x != rhs.x; }

 private:
  int x;
};
typedef MintBase<int(1e9) + 7> Mint;

template<int MOD1, int MOD2>
class HashBase {
 public:
  using Type = HashBase<MOD1, MOD2>;
  HashBase(): x(0), y(0) {}
  explicit HashBase(int x) : x(x), y(x) {}
  HashBase(int x, int y) : x(x), y(y) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD1 ? x + rhs.x - MOD1 : x + rhs.x,
        y + rhs.y >= MOD2 ? y + rhs.y - MOD2 : y + rhs.y
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD1 : x - rhs.x,
        y - rhs.y < 0 ? y - rhs.y + MOD2 : y - rhs.y
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD1),
        static_cast<int>(1ll * y * rhs.y % MOD2)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return optimization < rhs.optimization; }
  bool operator == (const Type & rhs) const { return optimization == rhs.optimization; }
  bool operator != (const Type & rhs) const { return optimization != rhs.optimization; }

 private:
  union {
    struct { int y, x; };
    ll optimization;
  };
};
typedef HashBase<int(1e9) + 7, int(1e9) + 9> Hash;
Hash P(911, 991), pws[N];

template<int MOD1, int MOD2>
HashBase<MOD1, MOD2> Substr(int l, int r, const vector<HashBase<MOD1, MOD2>> & hash) {
  return hash[r] - hash[l] * pws[r - l];
}

vector<int> ZFunc(const string & s) {
  vector<int> z(s.size());
  int n = static_cast<int>(s.size());
  for (int i = 1, l = 0, r = 0; i < n; ++i) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n && s[z[i]] == s[i + z[i]])
      ++z[i];
    if (i + z[i] > r)
      l = i, r = i + z[i];
  }
  return z;
}

class SegmentTree {
 public:
  SegmentTree(int n) {
    sz = 1;
    while (sz < n) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
  }
  SegmentTree(const vector<ll> & orig) {
    sz = 1;
    while (sz < static_cast<int>(orig.size())) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
    for (int i = 0; i < static_cast<int>(orig.size()); ++i)
      segm[i + sz] = orig[i];
    for (int i = sz - 1; i > 0; --i)
      segm[i] = segm[i << 1] + segm[i << 1 | 1];
  }
  ll Get(int l, int r) {
    return Get(l, r, 1, 0, sz);
  }
  void Update(int l, int r, ll val) {
    Update(l, r, val, 1, 0, sz);
  }

 private:
  void Push(int v, int vl, int vr) {
    if (add[v]) {
      segm[v] += add[v] * (vr - vl);
      if (v < sz) {
        add[v << 1] += add[v];
        add[v << 1 | 1] += add[v];
      }
      add[v] = 0;
    }
  }
  ll Get(int l, int r, int v, int vl, int vr) {
    if (l >= vr || vl >= r) return 0;
    Push(v, vl, vr);
    if (l <= vl && vr <= r) return segm[v];
    int vm = (vl + vr) >> 1;
    return Get(l, r, v << 1, vl, vm) + Get(l, r, v << 1 | 1, vm, vr);
  }
  void Update(int l, int r, ll val, int v, int vl, int vr) {
    Push(v, vl, vr);
    if (l >= vr || vl >= r) return;
    if (l <= vl && vr <= r) {
      add[v] = val;
      Push(v, vl, vr);
      return;
    }
    int vm = (vl + vr) >> 1;
    Update(l, r, val, v << 1, vl, vm);
    Update(l, r, val, v << 1 | 1, vm, vr);
    segm[v] = segm[v << 1] + segm[v << 1 | 1];
  }
 private:
  int sz;
  vector<ll> segm, add;
};

map<int, int> history;
ll Q(int n) {
  if (history.count(n)) return history[n];
  cout << "? " <<  n << endl;
  ll ans;
  cin >> ans;
  if (ans == -1) exit(0);
  return history[n] = ans;
}

void Answer(const vector<int> & v) {
  cout << "!";
  for (int x : v) {
    cout << ' ' << x;
  }
  cout << endl;
  int ans;
  cin >> ans;
  if (ans == -1) exit(0);
}

ll Sum(int fr, int to) {
  return ((1ll * to * (to + 1)) >> 1) - ((1ll * fr * (fr - 1)) >> 1);
}

void Solve() {

  int n, k;
  cin >> n >> k;
  ll plus = 0;
  int last = 0;
  vector<int> ans;
  for (int i = 0; i < k; ++i) {
    int l = last, r = n;
    while (r - l > 1) {
      int m = (l + r) >> 1;
      if (Q(m) == Sum(last + 1, m) + plus) l = m;
      else r = m;
    }
    if (last + 1 != r)
      plus += Sum(last + 1, r - 1);
    last = r;
    ans.push_back(r);
  }
  Answer(ans);

}


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  pws[0] = Hash(1);
  for (int i = 1; i < N; ++i) {
    pws[i] = pws[i-1] * P;
  }

  int T;
  cin >> T;
  while (T--) {
    Solve();
    history.clear();
  }

  return 0;
}
