#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll q = 179, M = 1e9 + 7, MAXN = 5000 + 10;
const ll p = 257, K = 1e9 + 9;

ll f[MAXN];
ll h[MAXN];

ll ans[MAXN][MAXN];

void solve() {
	f[0] = 1;
	for (ll i = 1; i < MAXN; i++) {
		f[i] = f[i - 1] * q % M;
		h[i] = h[i - 1] * p % K;
	}
	ll n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> a(n);
	vector<ll> pref;
	if (n <= 100) {
		string ss;
		vector<vector<int>> ind(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
			ss = a[i] + "#" + t;
			pref.assign(ss.size() + 1, 0);
			for (int j = 1; j < ss.size(); j++) {
				int new_j = pref[j - 1];
				while (new_j > 0 && ss[new_j] != ss[j]) {
					new_j = pref[new_j - 1];
				}
				pref[j] = new_j + (ss[new_j] == ss[j]);
				if (pref[j] == a[i].size()) {
					ind[i].push_back(j - 2 * a[i].size());
				}
			}
		}
		vector<pair<int, int>> b(m);
		int l, r;
		map<pair<int, int>, int> mp;
		int cntcnt = 0;
		for (int i = 0; i < m; i++) {
			cin >> b[i].first >> b[i].second; b[i].first--; b[i].second--;
			if (mp.find(b[i]) != mp.end()) {
				cout << mp[b[i]] << " ";
			}
			else {
				cntcnt++;
				assert(cntcnt <= 10010);
				int ans = 0;
				for (int j = 0; j < n; j++) {
					l = b[i].first; r = b[i].second - a[j].size() + 1;
					int xxxxx = (upper_bound(ind[j].begin(), ind[j].end(), r) - upper_bound(ind[j].begin(), ind[j].end(), l - 1));
					ans += max(0, xxxxx);
				}
				mp[{ b[i].first, b[i].second}] = ans;
				cout << ans << " ";
			}
		}
		return;
	}
	ll Hash = 0, Hash2;
	set <pair<ll, ll>> st;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		Hash = 0; Hash2 = 0;
		for (ll j = 0; j < a[i].size(); j++) {
			Hash *= q; Hash += a[i][j]; Hash %= M;
			Hash2 *= p; Hash2 += a[i][j]; Hash2 %= K;
		}
		st.insert({ Hash, Hash2 });
	}
	for (ll l = 0; l < t.size(); l++) {
		Hash = 0; Hash2 = 0;
		for (ll r = l; r < t.size(); r++) {
			Hash *= q; Hash += t[r]; Hash %= M;
			Hash2 *= p; Hash2 += t[r]; Hash2 %= K;
			if (st.find({ Hash, Hash2 }) != st.end()) {
				ans[l][r] = 1;
			}
		}
	}
	for (ll len = 2; len <= t.size(); len++) {
		for (ll l = 0; l + len <= t.size(); l++) {
			ll r = l + len - 1;
			ans[l][r] += ans[l][r - 1] + ans[l + 1][r];
			if (r - l >= 2) {
				ans[l][r] -= ans[l + 1][r - 1];
			}
		}
	}
	vector<pair<ll, ll>> b(m);
	ll l, r;
	for (ll i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second; b[i].first--; b[i].second--;
		l = b[i].first; r = b[i].second;
		cout << ans[l][r] << " ";
	}

}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
5
10 4
5 4
3 4
1 4
7 4

*/