#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll P = 53, M = 1000000007;

inline ll hash_char(char c) {
    return c - 'a' + 1;
}

void hash_str(const string &s, vector<ll> &h) {
    ll n = ll(s.size());
    for (ll i = 0; i < n; i++) h[i + 1] = (h[i] * P % M + hash_char(s[i])) % M;
}

ll hash_str(const string &s) {
    vector<ll> h(s.size() + 1);
    hash_str(s, h);
    return h.back();
}

const ll N = 500000;

ll F[N + 1];

ll hash_substr(const vector<ll> &h, ll l, ll r) {
    return (M + h[r] - h[l] * F[r - l] % M) % M;
}

void build(const vector<vector<ll>> &a, vector<vector<ll>> &t, ll v, ll vl, ll vr) {
    if (vl + 1 == vr) t[v] = a[vl];
    else {
        ll vm = (vl + vr) / 2;
        build(a, t, LC(v), vl, vm);
        build(a, t, RC(v), vm, vr);
        t[v].reserve(t[LC(v)].size() + t[RC(v)].size());
        merge(t[LC(v)].begin(), t[LC(v)].end(), t[RC(v)].begin(), t[RC(v)].end(), back_inserter(t[v]));
    }
}

ll query(const vector<vector<ll>> &t, ll l, ll r, ll x, ll v, ll vl, ll vr) {
    if (r <= vl || vr <= l) return 0;
    if (l <= vl && vr <= r) return upper_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
    else {
        ll vm = (vl + vr) / 2;
        ll cl = query(t, l, r, x, LC(v), vl, vm);
        ll cr = query(t, l, r, x, RC(v), vm, vr);
        return cl + cr;
    }
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    F[0] = 1;
    for (ll i = 1; i <= N; i++) F[i] = F[i - 1] * P % M;
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    ll k = ll(t.size());
    vector<ll> h(t.size() + 1);
    hash_str(t, h);
    vector<string> a(n);
    for (auto &s: a) cin >> s;
    unordered_set<ll> d;
    for (auto &s: a) d.insert(hash_str(s));
    vector<vector<ll>> f(k);
    for (ll l = 0; l < k; l++) {
        for (ll r = l + 1; r <= k; r++) {
            ll x = hash_substr(h, l, r);
            if (d.find(x) != d.end()) f[l].push_back(r);
        }
    }
    vector<vector<ll>> tr(4 * k);
    build(f, tr, 0, 0, k);
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--;
        ll ans = query(tr, l, r, r, 0, 0, k);
        cout << ans << ' ';
    }
    cout << '\n';
}