#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;
using pi = pair<int, int>;
using vpi = vector<pi>;
using str = string;

const int maxN = 5e5, SZ1 = 2e6, SZ2 = 5e6;

struct State {
    int len, link, cnt, jump;
    map<char, int> next;
} sa[SZ1];

int test = 1, n, m, l, r, sz, last;
ll ans[maxN], ft[SZ2 + 1];
vpi q[SZ2];
str t, s;

void sa_extend(char c) {
    int cur = sz++;
    sa[cur].len = sa[last].len + 1;
    int p = last;
    while (p != -1 && !sa[p].next.count(c)) {
        sa[p].next[c] = cur;
        p = sa[p].link;
    }
    if (p == -1) {
        sa[cur].link = 0;
    } else {
        int q = sa[p].next[c];
        if (sa[q].len == sa[p].len + 1) {
            sa[cur].link = q;
        } else {
            int clone = sz++;
            sa[clone].len = sa[p].len + 1;
            sa[clone].link = sa[q].link;
            sa[clone].next = sa[q].next;
            while (p != -1 && sa[p].next[c] == q) {
                sa[p].next[c] = clone;
                p = sa[p].link;
            }
            sa[cur].link = sa[q].link = clone;
        }
    }
    last = sa[last].next[c];
}

void add(int id, int x) {
    id++;
    for (; id <= (int)t.size(); id += id & (-id))
        ft[id] += x;
}

ll get(int id) {
    id++;
    ll res = 0;
    for (; id > 0; id -= id & (-id))
        res += ft[id];
    return res;
}

int jump(int id) {
    if (sa[id].jump != -1)
        return sa[id].jump;
    if (id == 0)
        sa[id].jump = 0;
    else if (sa[sa[id].link].cnt)
        sa[id].jump = sa[id].link;
    else
        sa[id].jump = jump(sa[id].link);
    return sa[id].jump;
}

void solve() {
    for (int i = 0; i < sz; i++) {
        sa[i].next.clear();
        sa[i].cnt = 0;
    }
    for (int i = 0; i < (int)t.size(); i++) {
        q[i].clear();
        ft[i] = 0;
    }
    cin >> n >> m >> t;
    sz = 1;
    sa[0].len = 0;
    sa[0].link = -1;
    for (int i = 0; i < n; i++) {
        cin >> s;
        last = 0;
        for (int j = 0; j < (int)s.size(); j++)
            sa_extend(s[j]);
        sa[last].cnt++;
    }
    for (int i = 0; i < sz; i++)
        sa[i].jump = -1;
    for (int i = 0; i < m; i++) {
        cin >> l >> r;
        q[r - 1].emplace_back(l - 1, i);
    }
    last = 0;
    for (int i = 0; i < (int)t.size(); i++) {
        while (last != 0 && !sa[last].next.count(t[i]))
            last = sa[last].link;
        if (sa[last].next.count(t[i]))
            last = sa[last].next[t[i]];
        int p = last;
        while (p != 0) {
            //add(i - sa[p].len + 1, sa[p].cnt);
            ft[i - sa[p].len + 1] += sa[p].cnt;
            p = jump(p);
        }
        for (auto &[l, id] : q[i]) {
            //ans[id] = get(i) - get(l - 1);
            for (int j = l; j <= i; j++)
                ans[id] += ft[j];
        }
    }
    for (int i = 0; i < m; i++)
        cout << ans[i] << " ";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
