#include <bits/stdc++.h>

using namespace std;

int MOD1 = 1e9 + 7;
int MOD2 = 998244353;

int add1(int a, int b)
{
    return (a + b) % MOD1;
}

int mul1(int a, int b)
{
    return (a * 1ll * b) % MOD1;
}

int sub1(int a, int b)
{
    return (a - b + MOD1) % MOD1;
}

int add2(int a, int b)
{
    return (a + b) % MOD2;
}

int mul2(int a, int b)
{
    return (a * 1ll * b) % MOD2;
}

int p1 = 29;
int p2 = 31;

const int MAXN = 5e6;

int pw1[MAXN];
int pw2[MAXN];

int h1[MAXN];
int h2[MAXN];

void hashing(string& s)
{
    int hs1 = 0;
    int hs2 = 0;
    for (int i = 0; i < s.size(); i++)
    {
        char c = s[i];
        hs1 = mul1(hs1, p1);
        hs2 = mul2(hs2, p2);

        hs1 = add1(hs1, c - 'a' + 1);
        hs2 = add2(hs2, c - 'a' + 1);

        h1[i] = hs1;
        h2[i] = hs2;
    }
}

pair<int, int> get_hash(string& s)
{
    int hs1 = 0;
    int hs2 = 0;
    for (int i = 0; i < s.size(); i++)
    {
        char c = s[i];
        hs1 = mul1(hs1, p1);
        hs2 = mul2(hs2, p2);

        hs1 = add1(hs1, c - 'a' + 1);
        hs2 = add2(hs2, c - 'a' + 1);
    }
    return {hs1, hs2};
}
//
//pair<int, int> get_sub

int get_sub_hash(int l, int r)
{
    if (l == 0)
        return h1[r];
    return sub1(h1[r], mul1(h1[l - 1], pw1[r - l + 1]));
}

vector<string> strs;

vector<int> lens;

vector<vector<int> > pos;
vector<vector<int> > pos_ind;
vector<vector<int> > ind;

int cur_ind[MAXN];

int get_id(int x)
{
    return lower_bound(lens.begin(), lens.end(), x) - lens.begin();
}

int main()
{
    pw1[0] = 1;
    pw2[0] = 1;
    for (int i = 1; i < MAXN; i++)
    {
        pw1[i] = mul1(pw1[i - 1], p1);
        pw2[i] = mul2(pw2[i - 1], p2);
    }
    int n, q;
    cin >> n >> q;
    string t;
    cin >> t;
    hashing(t);
    strs.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> strs[i];
        lens.push_back(strs[i].size());
    }
    sort(lens.begin(), lens.end());
    lens.erase(unique(lens.begin(), lens.end()), lens.end());
    pos.resize(lens.size());
    pos_ind.resize(lens.size());
    ind.resize(lens.size());
    for (int i = 0; i < n; i++)
    {
        pos[get_id(strs[i].size())].push_back(i);
    }
    for (int _ = 0; _ < lens.size(); _++)
    {
        int i = lens[_];
        int C = 0;
        set<int> st;
        for (int j = 0; j < pos[_].size(); j++)
        {
            st.insert(get_hash(strs[pos[_][j]]).first);
        }
        for (int j = 0; j < (int)t.size() - i + 1; j++)
        {
            int cur = get_sub_hash(j, j + i - 1);
            if (st.count(cur))
            {
                pos_ind[_].push_back(j);
            }
        }
    }
//    for (int _ = 0; _ < lens.size(); _++)
//    {
//        int i = lens[_];
//        cout << i << ": ";
//        for (auto& x : pos_ind[_]) cout << x << ' ';
//        cout << endl;
//    }
    while (q--)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        long long ans = 0;
        for (int _ = 0; _ < lens.size(); _++)
        {
            int i = lens[_];
            int cnt = upper_bound(pos_ind[_].begin(), pos_ind[_].end(), r - i + 1) - lower_bound(pos_ind[_].begin(), pos_ind[_].end(), l);
            ans += cnt;
        }
        cout << ans << endl;
    }
    return 0;
}
