#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mod = 1e9 + 7;
const int mod1 = 998244353;
const int b = 31;
const int p = 27;

struct segtree{
    vector<vector<int> > t;
    int sz_t;
    void build(int v, int tl, int tr, vector<vector<int> > &a) {
        if (tr - tl == 1) {
            t[v] = a[tl];
            return;
        }
        build(v * 2, tl, (tl + tr) / 2, a);
        build(v * 2 + 1, (tl + tr) / 2, tr, a);
        int l = 0, r = 0;
        while (l < t[v * 2].size() || r < t[v * 2 + 1].size()) {
            if (l == t[v * 2].size()) {
                t[v].push_back(t[v * 2 + 1][r++]);
            } else if (r == t[v * 2 + 1].size()) {
                t[v].push_back(t[v * 2][l++]);
            } else if (t[v * 2][l] < t[v * 2 + 1][r]) {
                t[v].push_back(t[v * 2 + 1][l++]);
            } else {
                t[v].push_back(t[v * 2 + 1][r++]);
            }
        }
    }
    void build(vector<vector<int> > &a) {
        sz_t = a.size();
        t.resize(4 * a.size());
        build(1, 0, sz_t, a);
    }
    int get_ans(int v, int tl, int tr, int l, int r, int x) {
        if (l <= tl && tr <= r) {
            int g = upper_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
            return g;
        }
        if (max(l, tl) >= min(r, tr)) {
            return 0;
        }
        return get_ans(v * 2, tl, (tl + tr) / 2, l, r, x) + get_ans(v * 2 + 1, (tl + tr) / 2, tr, l, r, x);
    }
    int get_ans(int l, int r, int x) {
        return get_ans(1, 0, sz_t, l, r + 1, x);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<ll> hash(t.size() + 1), hash1(t.size() + 1);
    vector<ll> p_pow(t.size() + 1), p_pow2(t.size() + 1);
    p_pow[0] = 1;
    p_pow2[0] = 1;
    for (int i = 1; i <= t.size(); i++) {
        p_pow[i] = p_pow[i - 1] * b;
        p_pow2[i] = p_pow2[i - 1] * b;
        p_pow[i] %= mod;
        p_pow2[i] %= mod1;
    }
    hash[0] = 0;
    for (int i = 0; i < t.size(); i++) {
        hash[i + 1] = hash[i] + (t[i] - 'a' + 1) * p_pow[i];
        hash1[i + 1] = hash1[i] + (t[i] - 'a' + 1) * p_pow2[i];
        hash[i + 1] %= mod;
        hash1[i + 1] %= mod1;
    }
    unordered_set<ll> ss, ss1;
    set<int> lens;
    for (int i = 0; i < n; i++) {
        ll h = 0, h1 = 0;
        string s;
        cin >> s;
        if (s.size() > t.size()) {
            continue;
        }
        for (int i = 0; i < s.size(); i++) {
            h = h + (s[i] - 'a' + 1) * p_pow[i];
            h1 = h1 + (s[i] - 'a' + 1) * p_pow2[i];
            h %= mod;
            h1 %= mod1;
        }
        ss.insert(h * p_pow[t.size() - s.size()] % mod);
        ss1.insert(h1 * p_pow2[t.size() - s.size()] % mod1);
        lens.insert(s.size());
    }
    vector<vector<int> > ans(t.size());
    for (auto it : lens) {
        int len = it;
        for (int i = len - 1; i < t.size(); i++) {
            ll h = ((hash[i + 1] - hash[i + 1 - len]) % mod + mod) % mod;
            ll h1 = ((hash1[i + 1] - hash1[i + 1 - len]) % mod1 + mod1) % mod1;
            if (ss.count(h * p_pow[t.size() - i - 1] % mod) && ss1.count(h1 * p_pow2[t.size() - i - 1] % mod1)) {
                ans[i + 1 - len].push_back(len);
            }
        }
    }
    segtree st;
    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < ans[i].size(); j++) {
            ans[i][j] -= i;
        }
    }
    st.build(ans);
    for (int test = 0; test < m; test++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        cout << st.get_ans(l, r, r + 1) << endl;
    }
}

int main() {
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\input.txt", "r", stdin);
//    freopen("C:\\Users\\olymp\\CLionProjects\\day_2\\output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << setprecision(20) << fixed;
    solve();
}
