#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

const int mod = 1e9 + 7, k1 = 29, k2 = 31;

int add(int a, int b) {
    if (a + b >= mod)
        return a + b - mod;
    return a + b;
}

int mul(int a, int b) {
    return int(1LL * a * b % mod);
}

int sub(int a, int b) {
    if (a - b < 0)
        return a - b + mod;
    return a - b;
}

pair<int, int> operator+(pair<int, int> a, pair<int, int> b) {
    return {add(a.first, b.first), add(a.second, b.second)};
}

pair<int, int> operator*(pair<int, int> a, pair<int, int> b) {
    return {mul(a.first, b.first), mul(a.second, b.second)};
}

pair<int, int> operator-(pair<int, int> a, pair<int, int> b) {
    return {sub(a.first, b.first), sub(a.second, b.second)};
}

typedef pair<int, int> pii;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n&1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

const int maxn = 5e6 + 100;
int deg1[maxn], deg2[maxn], inv_deg1[maxn], inv_deg2[maxn];

void precalc() {
    deg1[0] = deg2[0] = inv_deg1[0] = inv_deg2[0] = 1;
    int inv_k1 = binpow(k1, mod - 2);
    int inv_k2 = binpow(k2, mod - 2);
    for (int i = 1; i < maxn; ++i) {
        deg1[i] = mul(deg1[i - 1], k1);
        deg2[i] = mul(deg2[i - 1], k2);
        inv_deg1[i] = mul(inv_deg1[i - 1], inv_k1);
        inv_deg2[i] = mul(inv_deg2[i - 1], inv_k2);
    }
}

struct query {
    int l, r, ind;
};

struct hasher {
    ll operator()(pair<int, int> a) {
        return (1LL<<30) * a.first + a.second;
    }
};

int n, m;
string t;
vector<string> a;
vector<query> qs;
vector<pair<int, int>> hsh;
vector<pair<int, int>> hashes;

void solve_stupid() {
    hsh.assign(len(t) + 1, {0, 0});
    for (int i = 0; i < len(t); ++i) {
        hsh[i + 1] = hsh[i] + pair<int, int>{mul(t[i] - 'a' + 1, deg1[i]), mul(t[i] - 'a' + 1, deg2[i])};
    }

    auto get_hash = [&] (int l, int r) {
        return (hsh[r + 1] - hsh[l]) * pii{inv_deg1[l], inv_deg2[l]};
    };

    sort(all(a), [&] (string& s1, string& s2) {
        return len(s1) < len(s2);
    });

    hashes.resize(n);
    for (int i = 0; i < n; ++i) {
        pii h = {0, 0};
        for (int j = 0; j < len(a[i]); ++j) {
            h = h + pii{mul(a[i][j] - 'a' + 1, deg1[j]), mul(a[i][j] - 'a' + 1, deg2[j])};
        }

        hashes[i] = h;
    }
    vector<int> answer(m, 0);

    vector<int> pref(len(t), 0);

    hasher Hasher;

    int l = 0, r = 0;auto get = [&] (unordered_set<ll>& st, int l) {
        fill(all(pref), 0);

        for (int i = l - 1; i < len(t); ++i) {
            pair<int, int> h = get_hash(i - l + 1, i);
            if (st.contains(Hasher(h))) {
                pref[i] = 1;
            }
        }

        for (int i = 1; i < len(t); ++i) pref[i] += pref[i - 1];

        for (auto &el : qs) {
            if (el.r - el.l + 1 < l)
                continue;
            int right = el.r;
            int left = el.l + l - 1;
            int sum = pref[right];
            if (left)
                sum -= pref[left - 1];
            answer[el.ind] += sum;
        }
    };

    while (r < n) {
        while (r + 1 < n && len(a[r + 1]) == len(a[r])) ++r;
        // [l..r] - одинаковой длины
        unordered_set<ll> h;
        for (int i = l; i <= r; ++i) {
            h.insert(Hasher(hashes[i]));
        }

        get(h, len(a[r]));
        r++;
        l = r;
    }

    for (auto &el : answer) cout << el << ' ';
}

void solve() {
    cin >> n >> m;
    cin >> t;
    a.resize(n);
    qs.reserve(m);
    for (auto &el : a) cin >> el;

    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r, --l, --r;
        qs.push_back({l, r, i});
    }

    solve_stupid();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    precalc();
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}