#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

struct node {
	ll x;
	ll type;
	ll num;
};

struct hash {
	ll Mod, k;

	v<ll> h, p;

	ll sum(ll a, ll b) {
		a += b;
		if (a >= Mod) return a - Mod;
		return a;
	}

	ll sub(ll a, ll b) {
		a -= b;
		if (a < 0) return a + Mod;
		return a;
	}

	ll mul(ll a, ll b) {
		return a * b % Mod;
	}

	hash(ll Mod, ll k, str& t) : Mod(Mod), k(k) {
		ll n = t.size();
		h.resize(n + 1, 0);
		p.resize(n + 1, 1);
		for (int i = 1; i <= n; ++i) {
			p[i] = mul(p[i - 1], k);
			h[i] = sum(mul(h[i - 1], k), t[i - 1] - 'a' + 1);
		}
	}

	ll count(str& t) {
		ll now = 0;
		for (int i = 1; i <= t.size(); ++i) {
			now = sum(mul(now, k), t[i - 1] - 'a' + 1);
		}
		return now;
	}

	ll substr(ll l, ll r) {
		return sub(h[r + 1], mul(h[l], p[r - l + 1]));
	}
};

void solve() {
	ll n, m;
	std::cin >> n >> m;
	str t;
	std::cin >> t;
	hash h(1234567891, 42, t);
	v<ll> s(n);
	v<ll> size(n);
	for (int i = 0; i < n; ++i) {
		str tmp;
		std::cin >> tmp;
		s[i] = h.count(tmp);
		size[i] = tmp.size();
	}
	v<ll> tmpa;
	for (int j = 0; j < m; ++j) {
		ll l, r;
		std::cin >> l >> r;
		--l, --r;
		ll ans = 0;
		for (int j = 0; j < n; ++j) {
			for (int k = l; k + size[j] - 1 <= r; ++k) {
				if (h.substr(k, k + size[j] - 1) == s[j]) {
					++ans;
				}
			}
		}
		tmpa.push_back(ans);
	}
	for (auto i : tmpa) {
		std::cout << i << ' ';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}