#include <bits/stdc++.h>
using namespace std;
const int maxlen = 1e6 + 1, maxn = 5e5;

int go[maxlen][26], trans[maxlen][26], sz = 0;
int par[maxlen], h[maxlen], sufLink[maxlen], superSufLink[maxlen];
char let[maxlen], isTerm[maxlen];

int create(int p, char l) {
    for (int i = 0; i < 26; ++i) {
        go[sz][i] = -1;
    }
    par[sz] = p;
    let[sz] = l;
    isTerm[sz] = false;
    // superSufLink[v] = -1;
    return sz++;
}
string s[maxn];

void insert(int idx) {
    // maybe i should swap it on const string& s
    int v = 0;
    for (int i = 0; i < (int)s[idx].size(); ++i) {
        char j = s[idx][i] - 'a';
        if (go[v][j] == -1) {
            go[v][j] = create(v, j);
            h[go[v][j]] = h[v] + 1;
        }
        v = go[v][j];
    }
    isTerm[v] = true;
}

void AhoCorasik() {
    queue<int> q;
    q.push(0);
    // sufLink[v] = trans[sufLink[par[v]]][let[v]]
    // superSufLink[v] = sufLink[v], if it is terminal
    // superSufLink[sufLink[v]] otherwise
    // trans[v][c] = go[v][c], if != -1
    // trans[sufLink[v]][c] otherwise
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (par[v] > 0) {
            sufLink[v] = trans[sufLink[par[v]]][let[v]];
            if (!isTerm[sufLink[v]]) {
                superSufLink[v] = superSufLink[sufLink[v]];
            } else {
                superSufLink[v] = sufLink[v];
            }
        } else {
            superSufLink[v] = -1;
        }
        // cerr << "v: " << v << ", sufLink: " << sufLink[v] << ", superSufLink: " << superSufLink[v] << '\n';
        for (int j = 0; j < 26; ++j) {
            if (go[v][j] == -1) {
                trans[v][j] = trans[sufLink[v]][j];
            } else {
                trans[v][j] = go[v][j];
                q.push(go[v][j]);
            }
        }
    }
}
int perblock = 1;
const int maxt = 5e6;
int seq[maxt], sum[3000];
int ans[maxn];

void solve() {
    create(-1, 27);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    while (perblock * 1ll * perblock < (int)t.size()) {
        ++perblock;
    }
    // cerr << "perblock: " << perblock << '\n';
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        insert(i);
    }
    AhoCorasik();
    // cerr << "!\n";
    vector<int> l(m), r(m), order(m);
    for (int i = 0; i < m; ++i) {
        order[i] = i;
        cin >> l[i] >> r[i];
        --l[i], --r[i];
    }
    sort(order.begin(), order.end(), [&](const int& A , const int& B) {\
        return r[A] < r[B];
    });
    for (int iter = 0, i = -1, v = 0, j; iter < m; ++iter) {
        int idx = order[iter];
        // cerr << "idx: " << idx << '\n';
        while (i + 1 <= r[idx]) {
            ++i;
            v = trans[v][t[i] - 'a'];
            // cerr << "i: " << i << ", v: " << v << '\n';
            if (isTerm[v]) {
                // cerr << "u: " << v << '\n';
                // add(i - h[v]);
                j = i - h[v] + 1;
                // cerr << "j: " << j << '\n';
                ++seq[j];
                ++sum[j / perblock];
            }
            for (int u = superSufLink[v]; u != -1; u = superSufLink[u]) {
                // cerr << "u: " << u << '\n';
                // add(i - h[u]);
                j = i - h[u] + 1;
                // cerr << "j: " << j << '\n';
                ++seq[j];
                ++sum[j / perblock];
            }
        }
        // l[idx], r[idx]
        int lb = l[idx] / perblock, rb = r[idx] / perblock;
        int cur = 0;
        if (lb != rb) {
            int limL = (lb + 1) * perblock;
            for (int pos = l[idx]; pos < limL; ++pos) {
                cur += seq[pos];
            }
            int limR = rb * perblock;
            for (int pos = r[idx]; pos >= limR; --pos) {
                cur += seq[pos];
            }
        } else {
            for (int pos = l[idx]; pos <= r[idx]; ++pos) {
                cur += seq[pos];
            }
        }
        for (int b = lb + 1; b < rb; ++b) {
            cur += sum[b];
        }
        ans[idx] = cur;
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
