#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << " : " << x << '\n';
#define watch_arr(arr) \
cout << #arr << " : "; \
forn(i, arr.size()) \
    cout << arr[i] << ' '; \
cout << '\n';

const int N = 5e5, T = 5e6, S = 1e6;

int pi_arr[T + S + 1];

void pi(string &s) {
    pi_arr[0] = 0;
    for (int i = 1; i < s.size(); ++i) {
        int j = pi_arr[i - 1];
        while (s[j] != s[i] && j != 0)
            j = pi_arr[j - 1];
        if (s[j] == s[i])
            j++;
        pi_arr[i] = j;
    }
}

struct SegmentTree {
    vector<int> &arr;
    vector<vector<int>> &tree;

    SegmentTree(vector<int> &arr, vector<vector<int>> &tree) : arr(arr), tree(tree) {}

    vector<int> merge(vector<int> &v1, vector<int> &v2) {
        vector<int> v;
        int i1 = 0, i2 = 0;

        while(i1 < v1.size() && i2 < v2.size()) {
            if(v1[i1] <= v2[i2]) {
                v.push_back(v1[i1]);
                ++i1;
            } else {
                v.push_back(v2[i2]);
                ++i2;
            }
        }

        while(i1 < v1.size()) {
            v.push_back(v1[i1]);
            ++i1;
        }
        
        while(i2 < v2.size()) {
            v.push_back(v2[i2]);
            ++i2;
        }

        return v;
    }

    void build(int v, int tl, int tr) {
        if(tr - tl == 0)
            return;
        if(tr - tl == 1) {
            tree[v].push_back(arr[tl]);
            return;
        }

        int mid = (tl + tr) / 2;
        build(v * 2 + 1, tl, mid);
        build(v * 2 + 2, mid, tr);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    int get(int l, int r, int b, int v, int tl, int tr) {
        if(tr - tl == 0)
            return 0;
        if(l <= tl && tr <= r)
            return upper_bound(tree[v].begin(), tree[v].end(), b) - tree[v].begin();
        if(l >= tr || r <= tl)
            return 0;

        int mid = (tl + tr) / 2;
        int v1 = get(l, r, b, v * 2 + 1, tl, mid),
            v2 = get(l, r, b, v * 2 + 2, mid, tr);
        return v1 + v2;
    }

    int get(int l, int r, int b) {
        return get(l, r, b, 0, 0, arr.size());
    }
};

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    string s;
    cin >> n >> m >> s;

    vector<pair<int, int>> p_arr;
    vector<int> begin_arr, end_arr;
    vector<int> sz(n);

    forn (i, n) {
        string p;
        cin >> p;
        sz[i] = p.size();
        string check_s = p + '#' + s;
        pi(check_s);
        for (int j = sz[i] + 1; j < check_s.size(); j++) {
            if (pi_arr[j] == sz[i])
                p_arr.push_back({j - 2 * sz[i], j - sz[i] - 1});
        }
    }

    sort(p_arr.begin(), p_arr.end());
    forn (i, p_arr.size()) {
        begin_arr.push_back(p_arr[i].first);
        end_arr.push_back(p_arr[i].second);
    }

    vector<vector<int>> tree(4 * end_arr.size());
    SegmentTree st(end_arr, tree);
    st.build(0, 0, end_arr.size());

    forn (i, m) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        int lb = lower_bound(begin_arr.begin(), begin_arr.end(), l) - begin_arr.begin(),
            rb = upper_bound(begin_arr.begin(), begin_arr.end(), r) - begin_arr.begin();
        cout << st.get(lb, rb, r) << ' ';
    }
}
