#include <bits/stdc++.h>

using namespace std;

#define int long long

int mod = 1e9 + 7;
int p = 317;

int add(int a, int b) {
    if (a + b >= mod) {
        return a + b - mod;
    }
    return a + b;
}

int sub(int a, int b) {
    if (a - b < 0) {
        return mod + a - b;
    }
    return a - b;
}

int mul(int a, int b) {
    return a * b % mod;
}

int make_hash(string s) {
    int h = 0;
    for (int i = 0; i < s.size(); i++) {
        h = mul(add(h, s[i]), p);
    }
    return h;
}

vector <int> pw;
vector <int> hs;

void calc(string &s) {
    int n = s.size();
    pw.resize(n + 1);
    hs.resize(n + 1);
    pw[0] = 1;
    for (int i = 0; i < n; i++) {
        pw[i + 1] = mul(pw[i], p);
    }
    for (int i = 0; i < n; i++) {
        hs[i + 1] = mul(add(hs[i], s[i]), p);
    }
}

int get_hash(int l, int r) {
    return sub(hs[r + 1], mul(hs[l], pw[r - l + 1]));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    map <int, int> mp;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        mp[make_hash(s)]++;
    }
    calc(t);
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int res = 0;
        for (int i = l; i <= r; i++) {
            for (int j = i; j <= r; j++) {
                res += mp[get_hash(i, j)];
            }
        }
        cout << res << " ";
    }
    return 0;
}