#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

struct node {
    array<int, 26> g;
    char val;
    int p;
    int suff_link;
    int super_suff_link;
    bool is_terminate;

    node(int v, char a) {
        suff_link = -1;
        super_suff_link = -1;
        //g = {0};
        for (int i = 0; i < 26; ++i) {
            g[i] = 0;
        }
        val = a;
        p = v;
        is_terminate = false;
    }
};

struct aho_corasic {
    vector<node> t;

    void init() {
        t = {node{0, 0}};
        t[0].suff_link = t[0].super_suff_link = 0;
        /*for (int i = 0; i < ; ++i) {

        }*/
    }

    void add(string& s) {
        int now = 0;
        for (int i = 0; i < s.size(); ++i) {
            if (t[now].g[s[i] - 'a'] == 0) {
                t[now].g[s[i] - 'a'] = t.size();
                t.emplace_back(now, s[i] - 'a');
            }
            now = t[now].g[s[i] - 'a'];
            if (i == 0) {
                t[now].suff_link = 0;
                t[now].super_suff_link = 0;
            }
        }
        t[now].is_terminate = true;
    }

    void activate() {
        //int now = 0;
        queue<int> q;
        q.push(0);
        while (!q.empty()) {
            int now = q.front();
            q.pop();
            if (t[now].suff_link != 0) {
                t[now].suff_link = t[t[t[now].p].suff_link].g[t[now].val];
                if (t[t[now].suff_link].is_terminate)
                    t[now].super_suff_link = t[now].suff_link;
                else
                    t[now].super_suff_link = t[t[now].suff_link].super_suff_link;
            }
            for (int i = 0; i < 26; ++i) {
                if (t[now].g[i] != 0) {
                    q.push(t[now].g[i]);
                } else
                    t[now].g[i] = t[t[now].suff_link].g[i];
            }
        }
    }

    int calc(string& s) {
        int now = 0;
        int ans = 0;
        for (int i = 0; i < s.size(); ++i) {
            now = t[now].g[s[i] - 'a'];
            int tmp = now;
            while (tmp != 0) {
                ans += t[tmp].is_terminate;
                tmp = t[tmp].super_suff_link;
            }
        }
        return ans;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    aho_corasic ac;
    ac.init();
    for (int i = 0; i < n; ++i) {
        string tmp;
        cin >> tmp;
        ac.add(tmp);
    }
    ac.activate();
    vector<int> segments_beginnings = {0};
    vector<int> cnt;
    {
        int now = 0;
        //int ans = 0;
        int cnt = 0;
        for (int i = 0; i < s.size(); ++i) {
            now = ac.t[now].g[s[i] - 'a'];
            if (now == 0) {
                segments_beginnings.push_back(i + 1);
                segments_beginnings.push_back(cnt);
                cnt = 0;
            }
            int tmp = now;
            int ans = 0;
            while (tmp != 0) {
                ans += ac.t[tmp].is_terminate;
                tmp = ac.t[tmp].super_suff_link;
            }
            cnt += ans;
        }
    }
    vector<int> prefsum(cnt.size() + 1);
    prefsum[0] = 0;
    for (int i = 0; i < cnt.size(); ++i) {
        prefsum[i + 1] = prefsum[i] + cnt[i];
    }
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        int ans = 0;
        int r1;
        r1 = lower_bound(segments_beginnings.begin(), segments_beginnings.end(), l) - segments_beginnings.begin();
        if (segments_beginnings[r1] != l) {
            string tmp = string(s.begin() + l, s.begin() + segments_beginnings[r1]);
            ans += ac.calc(tmp);
        }
        int r2 = upper_bound(segments_beginnings.begin(), segments_beginnings.end(), r) - segments_beginnings.begin() - 1;
        if (segments_beginnings[r2] != r) {
            string tmp = string(s.begin() + segments_beginnings[r2], s.begin() + r);
            ans += ac.calc(tmp);
        }
        ans += prefsum[r2 + 1] - prefsum[r1];
        //string tmp = string(s.begin() + l, s.begin() + r);
        cout << ans << ' ';
    }
}


signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}