#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

const int N = 5e5 + 5;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 7;
const int P1 = 31;
const int P2 = 31;

int add(int a, int b, int mod){
    a += b;
    if(a >= mod)a -= mod;
    return a;
}

int sub(int a, int b, int mod){
    a -= b;
    if(a < 0)a += mod;
    return a;
}

int mult(int a, int b, int mod){
    return 1LL * a * b % mod;
}

int bpow(int a, int b, int mod){
    int res = 1;
    while(b){
        if(b & 1)res = mult(res, a, mod);
        a = mult(a, a, mod);
        b >>= 1;
    }
    return res;
}

int _div(int a, int b, int mod){
    return mult(a, bpow(b, mod - 2, mod), mod);
}

int p1[N], p2[N];
int pref1[N], pref2[N];

pair<int, int> get_hash(int l, int r){
    int H1;
    if(l)H1 = sub(pref1[r], pref1[l - 1], MOD1);
    else H1 = pref1[r];
    H1 = _div(H1, p1[l], MOD1);

    int H2;
    if(l)H2 = sub(pref2[r], pref2[l - 1], MOD2);
    else H2 = pref2[r];
    H2 = _div(H2, p2[l], MOD2);

    return {H1, H2};
}

pair<int, int> Hash(string s){
    pair<int, int> H = {0, 0};
    for(int i = 0; i < sz(s); i++){
        H.fi = add(H.fi, mult(s[i] - 'a' + 1, p1[i], MOD1), MOD1);
        H.se = add(H.se, mult(s[i] - 'a' + 1, p2[i], MOD2), MOD2);
    }
    return H;
}

pair<int, int> h[N];
int n, m;
string s;
int len[N];
vector<int> v[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    p1[0] = p2[0] = 1;

    for(int i = 1; i < N; i++){
        p1[i] = mult(p1[i - 1], P1, MOD1);
        p2[i] = mult(p2[i - 1], P2, MOD2);
    }

    cin >> n >> m;
    cin >> s;

    for(int i = 0; i < sz(s); i++){
        if(i){
            pref1[i] = add(pref1[i - 1], mult(s[i] - 'a' + 1, p1[i], MOD1), MOD1);
            pref2[i] = add(pref2[i - 1], mult(s[i] - 'a' + 1, p2[i], MOD2), MOD2);
        } else {
            pref1[i] = s[i] - 'a' + 1;
            pref2[i] = s[i] - 'a' + 1;
        }
    }

    for(int i = 0; i < n; i++){
        string str;
        cin >> str;
        h[i] = Hash(str);
        len[i] = sz(str);
    }

    for(int i = 0; i < sz(s); i++){
        for(int j = 0; j < n; j++){
            if(j + len[j] - 1 >= sz(s))continue;
            if(h[j] == get_hash(i, i + len[j] - 1)){
                v[i].pb(i + len[j] - 1);
            }
        }
        sort(all(v[i]));
    }

    while(m--){
        int l, r;
        cin >> l >> r;
        l--, r--;
        ll ans = 0;
        for(int i = l; i <= r; i++){
            int pos = lower_bound(all(v[i]), r + 1) - v[i].begin();
            ans += pos;
        }
        cout << ans << " ";
    }

    cout << "\n";

    return 0;
}
