#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct shash{
    long long R = 27, mod = 1e9 + 7;
    vector<long long> st;
    vector<long long> h;
    shash(string s) {
        st.resize(s.size() + 1);
        h.resize(s.size() + 1);
        st[0] = 1;
        h[0] = 0;
        for (int i = 0; i < s.size(); i++) {
            st[i + 1] = st[i] * R % mod;
            h[i + 1] = (h[i] * R + s[i] - 'a' + 1) % mod;
        }
    }
    long long get(long long l, long long r) {
        return (h[r] + mod - h[l] * st[r - l] % mod) % mod;
    }
};

int main()
{
    long long n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    shash st(t);
    vector<pair<long long, long long>> v(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        shash tmp(s);
        v[i] = {tmp.get(0, s.size()), s.size()};
    }
    for (int i = 0; i < m; i++) {
        long long l, r;
        cin >> l >> r;
        l--;
        long long ans = 0;
        for (int j = l; j < r; j++) {
            for (auto [h, sz] : v) {
                if (j + sz <= r && st.get(j, j + sz) == h) {
                    ans++;
                }
            }
        }
        cout << ans << " ";
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
*/
