#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

void merg(vector<long long> &a, vector<long long> &b, vector<long long> &res) {
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[i] + b[i];
    }
}

vector<long long> merg(vector<long long> &a, vector<long long> &b) {
    vector<long long> res(a.size());
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[i] + b[i];
    }
    return res;
}

struct tree{
    vector<vector<long long>> tr;
    vector<long long> v;
    vector<long long> st;

    void build(long long id, long long l, long long r) {
        if (r - l == 1) {
            tr[id] = st;
            return;
        }
        long long mid = (l + r) / 2;
        build(id * 2 + 1, l, mid);
        build(id * 2 + 2, mid, r);
        tr[id] = st;
        merg(tr[id * 2 + 1], tr[id * 2 + 2], tr[id]);
    }

    tree(long long sz, long long n) {
        sz++;
        tr.resize(n * 4, vector<long long> (sz, 0));
        st.resize(sz, 0);
        build(0, 0, n);
    }

    void change(long long id, long long l, long long r, long long i, long long sz) {
        if (r - l == 1) {
            tr[id][sz]++;
            return;
        }
        long long mid = (l + r) / 2;
        if (i < mid) {
            change(id * 2 + 1, l, mid, i, sz);
        } else {
            change(id * 2 + 2, mid, r, i, sz);
        }
        tr[id][sz]++;
    }

    long long ask(long long id, long long l, long long r, long long ql, long long qr, long long t) {
        if (l >= r) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tr[id][t];
        }
        if (r <= ql || qr <= l) {
            return 0;
        }
        long long mid = (l + r) / 2;
        return ask(id * 2 + 1, l, mid, ql, qr, t) + ask(id * 2 + 2, mid, r, ql, qr, t);
    }
};
struct shash{
    long long R = 27, mod = 1e9 + 7;
    vector<long long> st;
    vector<long long> h;
    shash(string s) {
        st.resize(s.size() + 1);
        h.resize(s.size() + 1);
        st[0] = 1;
        h[0] = 0;
        for (int i = 0; i < s.size(); i++) {
            st[i + 1] = st[i] * R % mod;
            h[i + 1] = (h[i] * R + s[i] - 'a' + 1) % mod;
        }
    }
    long long get(long long l, long long r) {
        return (h[r] + mod - h[l] * st[r - l] % mod) % mod;
    }
};

int main()
{
    long long n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    shash st(t);
    vector<pair<long long, long long>> v(n);
    set<long long> st2;
    long long msz = 0;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        st2.insert(s.size());
        long long tm = s.size();
        msz = max(msz, tm);
        shash tmp(s);
        v[i] = {tmp.get(0, s.size()), s.size()};
    }
    tree tr(msz, t.size());
    for (auto [h, sz] : v) {
        for (int j = 0; j < t.size(); j++) {
            if (j + sz <= t.size() && st.get(j, j + sz) == h) {
                tr.change(0, 0, t.size(), j, sz);
            }
        }
    }
    /*for (auto i : tr.tr) {
        for (auto j : i) {
            cout << j << " ";
        } cout << endl;
    } cout << endl;*/
    vector<long long> sizes;
    for (auto x : st2) {
        sizes.push_back(x);
    }
    for (int i = 0; i < m; i++) {
        long long l, r;
        cin >> l >> r;
        l--;
        long long ans = 0;
        for (int j = 0; j < sizes.size(); j++) {
            ans += tr.ask(0, 0, t.size(), l, r - sizes[j] + 1, sizes[j]);
        }
        cout << ans << " ";
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
*/
