#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

void merg(vector<int> &a, vector<int> &b, vector<int> &res) {
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[i] + b[i];
    }
}

vector<int> merg(vector<int> &a, vector<int> &b) {
    vector<int> res(a.size());
    for (int i = 0; i < a.size(); i++) {
        res[i] = a[i] + b[i];
    }
    return res;
}

struct tree{
    vector<map<int, int>> tr;
    vector<int> v;

    tree(int sz, int n) {
        sz++;
        tr.resize(n * 4);
    }

    void change(int id, int l, int r, int i, int sz) {
        if (r - l == 1) {
            if (tr[id].find(sz) == tr[id].end()) {
                tr[id][sz] = 1;
            } else {
               tr[id][sz]++;
            }
            return;
        }
        int mid = (l + r) / 2;
        if (i < mid) {
            change(id * 2 + 1, l, mid, i, sz);
        } else {
            change(id * 2 + 2, mid, r, i, sz);
        }
        if (tr[id].find(sz) == tr[id].end()) {
            tr[id][sz] = 1;
        } else {
           tr[id][sz]++;
        }
    }

    int ask(int id, int l, int r, int ql, int qr, int t) {
        if (l >= r) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            if (tr[id].find(t) == tr[id].end()) {
                return 0;
            }
            return tr[id][t];
        }
        if (r <= ql || qr <= l) {
            return 0;
        }
        int mid = (l + r) / 2;
        return ask(id * 2 + 1, l, mid, ql, qr, t) + ask(id * 2 + 2, mid, r, ql, qr, t);
    }
};
struct shash{
    int R = 27, mod = 1e9 + 7;
    vector<long long> st;
    vector<long long> h;
    shash(string s) {
        st.resize(s.size() + 1);
        h.resize(s.size() + 1);
        st[0] = 1;
        h[0] = 0;
        for (int i = 0; i < s.size(); i++) {
            st[i + 1] = st[i] * R % mod;
            h[i + 1] = (h[i] * R + s[i] - 'a' + 1) % mod;
        }
    }
    int get(int l, int r) {
        return (h[r] + mod - h[l] * st[r - l] % mod) % mod;
    }
};

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    shash st(t);
    vector<pair<long long, int>> v(n);
    set<int> st2;
    int msz = 0;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        st2.insert(s.size());
        int tm = s.size();
        msz = max(msz, tm);
        shash tmp(s);
        v[i] = {tmp.get(0, s.size()), s.size()};
    }
    tree tr(msz, t.size());
    for (auto [h, sz] : v) {
        for (int j = 0; j < t.size(); j++) {
            if (j + sz <= t.size() && st.get(j, j + sz) == h) {
                tr.change(0, 0, t.size(), j, sz);
            }
        }
    }
    /*for (auto i : tr.tr) {
        for (auto j : i) {
            cout << j << " ";
        } cout << endl;
    } cout << endl;*/
    vector<int> sizes;
    for (auto x : st2) {
        sizes.push_back(x);
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int j = 0; j < sizes.size(); j++) {
            ans += tr.ask(0, 0, t.size(), l, r - sizes[j] + 1, sizes[j]);
        }
        cout << ans << " ";
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
*/
