#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

const ll K = 26;

struct Vertex {
	bool is_str;
	int to[K];
	Vertex() {
		is_str = false;
		fill(to, to + K, -1);
	}
};

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 200007;
ll n, m, k;
vector<Vertex>p(1);
string h;
vector<int>d[N];
ll t[4 * N];

void update(int v, int tl, int tr, int ind, ll vl) {
	if (tl == tr) {
		t[v] += vl;
	}
	else {
		int tm = (tl + tr) / 2;
		if (tm >= ind) {
			update(2 * v, tl, tm, ind, vl);
		}
		else {
			update(2 * v + 1, tm + 1, tr, ind, vl);
		}
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}

ll get_sum(int v, int tl, int tr, int l, int r) {
	//cout << l << " " << r << " " << tl << " " << tr << endl;
	if (l > r)return 0;
	if (tl == l && tr == r) {
		return t[v];
	}
	else {
		int tm = (tl + tr) / 2;
		return get_sum(2 * v, tl, tm, l, min(r, tm)) +
			get_sum(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
	}
}

void add(const string& s) {
	int v = 0;
	for (int i = 0; i < s.size(); i++) {
		int c = s[i] - 'a';
		if (p[v].to[c] == -1) {
			p[v].to[c] = p.size();
			p.emplace_back();
		}
		v = p[v].to[c];
	}
	p[v].is_str = true;
}

void query(int l) {
	int v = 0;
	for (int i = l; i < h.size(); i++) {
		int c = h[i] - 'a';
		if (p[v].to[c] == -1) {
			return;
		}
		v = p[v].to[c];
		if (p[v].is_str) {
			d[l].push_back(i);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	cin >> h;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add(s);
	}
	for (int i = 0; i < h.size(); i++) {
		query(i);
	}
	vector<pair<pair<int, int>, int>>q;
	vector<ll>ans(m);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		q.push_back({ {l,r},i });
	}
	//return 0;
	sort(q.begin(), q.end());
	reverse(q.begin(), q.end());
	int ind = 0;
	for (int i = h.size() - 1; i >= 0; i--) {
		for (int x : d[i]) {
			update(1, 0, h.size() - 1, x, 1);
		}
		while (ind < q.size() && q[ind].ff.ff == i) {
			ans[q[ind].ss] = get_sum(1, 0, h.size() - 1, i, q[ind].ff.ss);
			ind++;
		}
			//return 0;
	}
	for (int x : ans) {
		cout << x << " ";
	}
}