#include <bits/stdc++.h>

using namespace std;

constexpr int mod = 1e9 + 7, base = 29;

constexpr int R = 1 << 16;

vector<int> tree[R * 2];

void build() {
    for (int i = R - 1; i > 0; --i) {
        tree[i].resize(tree[i * 2].size() + tree[i * 2 + 1].size());
        merge(tree[i * 2].begin(), tree[i * 2].end(), tree[i * 2 + 1].begin(), tree[i * 2 + 1].end(), tree[i].begin());
    }
}

int get(int l, int r, int mx) {
    l += R;
    r += R;
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += upper_bound(tree[l].begin(), tree[l].end(), mx) - tree[l].begin();
            l++;
        }
        if (r & 1) {
            --r;
            ans += upper_bound(tree[r].begin(), tree[r].end(), mx) - tree[r].begin();
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    vector<int> vl(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        for (auto ch : s[i]) {
            vl[i] = (vl[i] * 1LL * base + ch - 'a' + 1) % mod;
        }
    }
    vector<int> pw((int)t.size() + 1);
    pw[0] = 1;
    for (int i = 1; i <= (int)t.size(); ++i) {
        pw[i] = pw[i - 1] * 1LL * base % mod;
    }
    vector<int> pr((int)t.size() + 1);
    for (int i = 0; i < (int)t.size(); ++i) {
        pr[i + 1] = (pr[i] * 1LL * base + t[i] - 'a' + 1) % mod;
    }
    for (int i = 0; i < (int)t.size(); ++i) {
        for (int j = 0; j < n; ++j) {
            if (i + (int)s[j].size() <= (int)t.size()) {
                int hash_nw = pr[i + (int)s[j].size()] - pr[i] * 1LL * pw[(int)s[j].size()] % mod;
                if (hash_nw < 0) {
                    hash_nw += mod;
                }
                if (hash_nw == vl[j]) {
                    tree[i + R].push_back(i + (int)s[j].size());
                }
            }
        }
        sort(tree[i + R].begin(), tree[i + R].end());
    }
    build();
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << get(l, r, r) << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
