#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double
#define bint __int128_t

const ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (bint)(a * b % mod);
}

ll sub(ll a, ll b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}

ll add(ll a, ll b) {
    return (a + b) % mod;
}

const ll p = 37;
const int sz = 5e6 + 1;
ll pw[sz];

ll gethash(int l, int r, vector<ll> hsh) {
    ll oct = mul((l == 0 ? 0 : hsh[l - 1]), pw[r - l + 1]);
    return sub(hsh[r], oct);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> t;
    {
        string ts; cin >> ts;
        t.resize((int)ts.size());
        t[0] = (ts[0] - 'a' + 1);
        for (int i = 1; i < (int)t.size(); i++) {
            t[i] = add(mul(t[i - 1], p), (ts[i] - 'a' + 1));
        }
    }
    vector<vector<ll>> st(n);
    {
        for (int i = 0; i < n; i++) {
            string ts; cin >> ts;
            st[i].resize((int)ts.size());
            st[i][0] = (ts[0] - 'a' + 1);
            for (int j = 1; j < (int)st[i].size(); j++) {
                st[i][j] = add(mul(st[i][j - 1], p), (ts[j] - 'a' + 1));
            }
        }
    }
    for (int q = 0; q < m; q++) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int cnt = 0;
        for (; l <= r; l++) {
            for (int i = 0; i < n; i++) {
                if (l + st[i].size() - 1 > r) continue;
                if (st[i].back() == gethash(l, (int)st[i].size() + l - 1, t)) cnt++;
            }
        }
        cout << cnt << " ";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // cout << fixed << setprecision(20);

    pw[0] = 1;
    for (int i = 1; i < sz; i++) {
        pw[i] = mul(pw[i - 1], p);
    }
    ll t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}