#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MOD = 1e9 + 9;
const int MAXN = 5e5 + 1;
const int k = 31;

int p[MAXN];

struct Hash {
    int n;
    string s;
    vector<int> h;

    Hash() {}
    Hash(const string &s) : n(s.size()), s(s), h(vector<int>(n + 1)) {}

    void init() {
        for (int i = 0; i < n; ++i) {
            int x = (s[i] - 'a') + 1;
            h[i + 1] = (1LL * h[i] * k + x) % MOD;
        }
    }

    int hash_substring(int l, int r) {
        return ((1LL * h[r] - 1LL * h[l - 1] * p[r - l + 1]) % MOD + MOD) % MOD;
    }
};

bool comp(const Hash &a, const Hash &b) {
    return a.n < b.n;
}

void solve() {
    int N, m;
    cin >> N >> m;
    string t;
    cin >> t;
    int n = (int)t.size();
    Hash T(t);
    T.init();

    vector<vector<Hash>> a(26);
    for (int i = 0; i < N; ++i) {
        string s;
        cin >> s;
        Hash S(s);
        S.init();
        a[s[0] - 'a'].emplace_back(S);
    }
    for (int i = 0; i < 26; ++i) {
        sort(a[i].begin(), a[i].end(), comp);
    }

    map<pair<int, int>, ll> mp;
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        if (mp.find({l, r}) != mp.end()) {
            cout << mp[{l, r}] << ' ';
            continue;
        }

        ll ans = 0;
        for (int j = l; j <= r; ++j) {
            for (auto H : a[t[j - 1] - 'a']) {
                if (j + H.n > r + 1) {
                    break;
                }

                if (T.hash_substring(j, j + H.n - 1) == H.hash_substring(1, H.n)) {
                    ++ans;
                }
            }
        }

        cout << ans << ' ';
        mp[{l, r}] = ans;
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    p[0] = 1;
    for (int i = 1; i <= 5e5; ++i) {
        p[i] = (p[i - 1] * k) % MOD;
    }

    int T = 1;
    //cin >> T;
    while (T --> 0) {
        solve();
    }

    return 0;
}
