#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e15 + 7,
k = 31, MOD = 1e9 + 7;

vector<int> pow_h;

int get_hash(int l, int r, const vector<int> &hashes) { // [l, r)
    return ((hashes[r] - hashes[l] * pow_h[r - l]) % MOD + MOD) % MOD;
}

int word_get_hash(const string &s) {
    int n = (int)s.size();
    vector<int> hashes(n + 1);
    for (int i = 1; i <= n; i++) {
        hashes[i] = ((hashes[i - 1] * k) % MOD + (s[i - 1] - 'a' + 1)) % MOD;
    }
    return hashes[n];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    string t;
    cin >> n >> m >> t;
    int v = (int)t.size();
    pow_h.resize(v + 3, 1);
    for (int i = 1; i < v + 3; i++)
        pow_h[i] = (pow_h[i - 1] * k) % MOD;
    vector<string> s(n);
    for (auto &i : s)
        cin >> i;
    vector<int> hashes(v + 1);
    for (int i = 1; i <= v; i++) {
        hashes[i] = ((hashes[i - 1] * k) % MOD + (t[i - 1] - 'a' + 1)) % MOD;
    }
    vector<vector<pair<int, int>>> a(n);
    for (int i = 0; i < n; i++) {
        int p = word_get_hash(s[i]),
        sz = (int)s[i].size();
        for (int j = 0; j + sz <= v; j++) {
            if (get_hash(j, j + sz, hashes) == p) {
                a[i].push_back({j, j + sz - 1});
            }
        }
    }
    while (m--) {
        int l, r, res = 0;
        cin >> l >> r;
        l--;
        r--;
        for (auto &i : a) {
            for (auto &[lp, rp] : i) {
                if (l <= lp && rp <= r)
                    res++;
            }
        }
        cout << res << "\n";
    }
}