#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int MAXN=1e6+10;
struct node {
    int ch[26];
    int fail, ok, w, len;
};
node trie[MAXN];
vector <pair <int,int> > sub[MAXN], sub1[MAXN];
string str, word[MAXN];
int m, cnt;
void add(int ind) {
    int cur=0;
    for (int i=0;i<word[ind].size();i++) {
        int let=word[ind][i]-'a';
        if (trie[cur].ch[let]==0) {
            cnt++;
            trie[cur].ch[let]=cnt;
            trie[cnt].len=trie[cur].len+1;
        }
        cur=trie[cur].ch[let];
    }
    trie[cur].w++;
}
void bfs() {
    queue <int> q;
    q.push(0);
    while (!q.empty()) {
        int x=q.front();
        q.pop();
        for (int i=0;i<26;i++) {
            int child=trie[x].ch[i];
            if (child==0) continue;
            int up=x;
            bool fl=false;
            while (up!=0) {
                if (trie[trie[up].fail].ch[i]!=0) {
                    trie[child].fail=trie[trie[up].fail].ch[i];
                    fl=true;
                    break;
                }
                up=trie[up].fail;
            }
            if (!fl) trie[child].fail=0;
            if (trie[trie[child].fail].w) trie[child].ok=trie[child].fail;
            else trie[child].ok=trie[trie[child].fail].ok;
            q.push(child);
        }
    }
}
void find_substr() {
    int cur=0;
    for (int i=0;i<str.size();i++) {
        int let=str[i]-'a';
        while (cur!=0 && trie[cur].ch[let]==0) cur=trie[cur].fail;
        if (cur==0 && trie[cur].ch[let]==0) cur=0;
        else cur=trie[cur].ch[let];
        int kopie=cur;
        while (cur!=0 && trie[cur].w) {
            sub[i].push_back({trie[cur].len,trie[cur].w});
            cur=trie[cur].ok;
        }
        cur=kopie;
    }
}
void find_substr1() {
    for (int i=0;i<str.size();i++) {
        for (int j=0;j<m;j++) {
            int n=word[j].size();
            if (n>i+1) continue;
            if (str.substr(i-n+1,n)==word[j]) sub1[i].push_back({n,1});
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> m >> q >> str;
    for (int i=0;i<m;i++) {
        cin >> word[i];
        if (word[i].size()<=str.size()) add(i);
    }
    bfs();
    find_substr();
    find_substr1();
    /*for (int i=0;i<str.size();i++) {
        if (sub1[i].empty()) continue;
        cout << i << ' ' << sub1[i].size() << ":\n";
        for (auto j:sub1[i]) cout << j.first << ' ' << j.second << endl;
    }*/
    int l, r, ans;
    for (int i=0;i<q;i++) {
        cin >> l >> r;
        l--; r--;
        ans=0;
        for (int i=l;i<=r;i++) {
            for (auto j:sub1[i]) {
                if (i-j.first+1>=l) ans+=j.second;
            }
        }
        cout << ans;
        if (i<q-1) cout << ' ';
    }
    cout << endl;
    return 0;
}