#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_set>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

//const ll MOD = 1000000007;
const ll P = 239;
const int max_len = 100005;
const int K = 350;
const ll MOD = 998244353;

using namespace std;

int ms[K][max_len];
int SZ[K];
int ful[max_len];

int dp[5000][5000];
int pr[100][50001];

void smaln(int n, int m, string &s, vector<string> &str) {
    vector<ll> pw(s.size() + 1, 1), hsh(s.size() + 1, 0);
    for (int i = 0; i < (int)s.size(); ++i) {
        pw[i + 1] = pw[i] * P % MOD;
        hsh[i + 1] = (hsh[i] * P + s[i]) % MOD;
    }
    for (int i = 0; i < n; ++i) {
        ll h = 0;
        for (char ch : str[i]) {
            h = (h * P + ch) % MOD;
        }
        for (int st = 0; st <= (int)(s.size()) - (int)(str[i].size()); ++st) {
            ll hnw = (hsh[st + (int)str[i].size()] - hsh[st] * pw[(int)str[i].size()] + MOD * MOD) % MOD;
            if (hnw == h) {
                ++pr[i][st + 1];
            }
            pr[i][st + 1] += pr[i][st];
        }
    }
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        --l; --r;
        int ans = 0;
        for (int j = 0; j < n; ++j) {
            int sz = str[j].size();
            if (sz <= r - l + 1) {
                int f = l;
                int s = r - sz + 2;
                ans += pr[j][s] - pr[j][f];
            }
        }
        cout << ans << '\n';
    }
}

void big_ass(int n, int m, string &s, vector<string> &str) {
    if (n <= 100) {
        smaln(n, m, s, str);
        return;
    }
    vector<ll> pw(s.size() + 1, 1), hsh(s.size() + 1, 0);
    for (int i = 0; i < (int)s.size(); ++i) {
        pw[i + 1] = pw[i] * P % MOD;
        hsh[i + 1] = (hsh[i] * P + s[i]) % MOD;
    }
    for (int i = 0; i < n; ++i) {
        ll h = 0;
        for (char ch : str[i]) {
            h = (h * P + ch) % MOD;
        }
        for (int st = 0; st <= (int)(s.size()) - (int)(str[i].size()); ++st) {
            ll hnw = (hsh[st + (int)str[i].size()] - hsh[st] * pw[(int)str[i].size()] + MOD * MOD) % MOD;
            if (hnw == h) {
                ++dp[st][st + (int)str[i].size() - 1];
            }
        }
    }
    for (int l = (int)s.size() - 2; l >= 0; --l) {
        dp[l][l + 1] += dp[l][l] + dp[l + 1][l + 1];
        for (int r = l + 2; r < (int)s.size(); ++r) {
            dp[l][r] += dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1];
        }
    }
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r; --l; --r;
        cout << dp[l][r] << '\n';
    }
}

void solve() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<string> str(n);
    int SM = 0;
    for (int i = 0; i < n; ++i) {
        cin >> str[i];
        SM += (int)str[i].size();
    }
    if (SM > 100000) {
        big_ass(n, m, s, str);
        return;
    }
    vector<ll> pw(s.size() + 1, 1), hsh(s.size() + 1, 0);
    for (int i = 0; i < (int)s.size(); ++i) {
        pw[i + 1] = pw[i] * P % MOD;
        hsh[i + 1] = (hsh[i] * P + s[i]) % MOD;
    }
    vector<int> L(m), R(m), ans(m, 0);
    for (int i = 0; i < m; ++i) {
        cin >> L[i] >> R[i]; --L[i]; --R[i];
    }
    int hm = 0;
    for (int i = 0; i < n; ++i) {
        if ((int)str[i].size() >= K) {
            ll h = 0;
            for (char ch : str[i]) {
                h = (h * P + ch) % MOD;
            }
            SZ[hm] = (int)str[i].size();
            for (int st = 0; st <= (int)(s.size()) - (int)(str[i].size()); ++st) {
                ll hnw = (hsh[st + (int)str[i].size()] - hsh[st] * pw[(int)str[i].size()] + MOD * MOD) % MOD;
                if (hnw == h) {
                    ++ms[hm][st + 1];
                }
                ms[hm][st + 1] += ms[hm][st];
            }
            ++hm;
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < hm; ++j) {
            if (SZ[j] <= R[i] - L[i] + 1) {
                ans[i] += ms[j][R[i] - SZ[j] + 2] - ms[j][L[i]];
            }
        }
    }
    for (int i = 0; i < hm; ++i) {
        fill(ms[i], ms[i] + max_len, 0);
    }
    unordered_set<int> mp[K];
    for (int i = 0; i < n; ++i) {
        if ((int)str[i].size() < K) {
            ll h = 0;
            for (char ch : str[i]) {
                h = (h * P + ch) % MOD;
            }
            mp[(int)str[i].size()].insert(h);
        }
    }
    int LST;
    for (int st = 0; st < (int)s.size(); ++st) {
        for (int len = 1; (len < K && st + len <= (int)s.size()); ++len) {
            ll hnw = (hsh[st + len] - hsh[st] * pw[len] + MOD * MOD) % MOD;
            if (mp[len].count(hnw)) {
                ++ms[len][st];
            }
            ms[len][st] += ms[len - 1][st];
            LST = len;
        }
        ++LST;
        while (LST < K) {
            ms[LST][st] = ms[LST - 1][st];
            ++LST;
        }
        ful[st + 1] = ms[K - 1][st] + ful[st];
    }
    for (int i = 0; i < m; ++i) {
        int lst = R[i] - (K - 1) + 1;
        if (lst >= L[i]) {
            ans[i] += ful[lst + 1] - ful[L[i]];
        }
        for (int j = max(L[i], lst + 1); j <= R[i]; ++j) {
            ans[i] += ms[R[i] - j + 1][j];
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}