#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { cout << #a << endl; for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { cout << #a << endl; for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

//mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 1e6+1;
const int A = 26;

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

struct Node {
	int term = 0, link = -1, par = -1, parc = -1, fast_link = -1;
	int go[A], delta[A];

	Node() {
		for (int c = 0; c < A; c++) {
			go[c] = -1, delta[c] = -1;
		}
	}
};

Node aho[N];
int answer[N];
int last = 1;
int root = 0;

void add_word(string& s) {
	int u = 0;
	int n = s.size();
	for (int i = 0; i < n; i++) {
		int c = s[i] - 'a';
		if (aho[u].go[c] == -1) {
			aho[last].par = u;
			aho[last].parc = c;
			aho[u].go[c] = last++;
		}
		u = aho[u].go[c];
	}

	aho[u].term = 1;
}


// fast links

int get_link(int u); 
int get_delta(int u, int c);

int get_link(int u) {
	if (aho[u].link == -1) {
		if (u == root || aho[u].par == root) aho[u].link = root;
		else aho[u].link = get_delta(get_link(aho[u].par), aho[u].parc);
	}
	return aho[u].link;
}

int get_delta(int u, int c) {
	if (aho[u].delta[c] == -1) {
		if (aho[u].go[c] != -1) aho[u].delta[c] = aho[u].go[c];
		else if (u == root) aho[u].delta[c] = root;
		else aho[u].delta[c] = get_delta(get_link(u), c);
	}
	return aho[u].delta[c];
}

int get_fast_link(int u) {
	if (aho[u].fast_link == -1) {
		if (aho[get_link(u)].term) aho[u].fast_link = aho[u].link;
		else aho[u].fast_link = get_fast_link(aho[u].link);
	}
	return aho[u].fast_link;
}

int get_value(int u) {
	if (answer[u] >= 0) return answer[u];
	int ans = 0;
	while (u != root) {
		ans += (aho[u].term);
		u = get_fast_link(u);
	}
	return answer[u] = ans;
}


void solve() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	for (int i = 0; i < N; i++) answer[i] = -1;
	
	aho[root].par = root;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add_word(s);
	}

	

	while (m--) {
		int l, r;
		cin >> l >> r, l--;
		int u = root;
		ll ans = 0;
		for (int i = l; i < r; i++) {
			u = get_delta(u, t[i] - 'a');
			ans += get_value(u);
		}
		cout << ans << ' ';
	}
}
