#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>


using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

const ll Hmod = 1e9 + 9;
const ll Ht = 31;

struct Hash {
    vector<ll> powt, h;

    Hash(string &s) {
        ll n = s.size();
        powt.resize(n + 1, 1);
        h.resize(n + 1, 0);
        for (ll i = 0; i < n; i++) {
            powt[i + 1] = (powt[i] * Ht) % Hmod;
            h[i + 1] = (h[i] * Ht + (s[i] - 'a' + 1)) % Hmod;
        }
    }

    ll get(ll l, ll r) {
        return (h[r + 1] - h[l] * powt[r + 1 - l] + Hmod * Hmod) % Hmod;
    }
};

ll hcount(string &s) {
    ll ans = 0;
    for (ll i = 0; i < s.size(); i++) {
        ans = (ans * Ht + (s[i] - 'a' + 1)) % Hmod;
    }
    return ans;
}

struct Z {
    ll r, i, d;
};

struct Segtree {
    struct Node {
        ll x;

        Node() : x(0) {}

        Node(ll x_) : x(x_) {}

        Node operator+(const Node &a) const {
            return Node(x + a.x);
        }
    };

    vector<Node> t;
    ll sz;

    Segtree(vector<ll> &v) : sz(1) {
        ll n = v.size();
        while (sz < n) sz *= 2;
        t.assign(sz * 2, Node());
        for (ll i = 0; i < n; i++) {
            t[sz + i] = Node(v[i]);
        }
        for (ll i = sz - 1; i >= 1; i--)
            t[i] = t[i * 2] + t[i * 2 + 1];
    }
    void change(ll i, ll d){
        t[sz+i].x+=d;
        ll v =(sz+i)/2;
        while(v>0){
            t[v]=t[v*2]+t[v*2+1];
            v/=2;
        }
    }
    Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1){
        if (r == -1) r = sz;
        if (lx<=l&&r<=rx) return t[v];
        if (lx >= r|| l>=rx) return Node();
        ll mid = (l+r)/2;
        return get(lx, rx, v*2+1, mid, r) + get(lx, rx, v*2, l, mid);
    }
};

int main() {
    fastio();
    ll n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    ll m = s.size();
    Hash h = Hash(s);
    vector<ll> hs(n, 0), ls(n, 0);
    for (ll i = 0; i < n; i++) {
        string t;
        cin >> t;
        ls[i] = t.size();
        hs[i] = hcount(t);
    }
    vector<vector<Z>> sob(m);
    vector<ll> ans(q);
    for (ll i = 0; i < q; i++) {
        ll l, r;
        cin >> l >> r;
        if (l - 2 >= 0) sob[l - 2].push_back({r - 1, i, -1});
        sob[r - 1].push_back({r - 1, i, 1});
    }
    vector<ll> pr(m, 0);
    Segtree seg = Segtree(pr);
    for (ll i = 0;i<m;i++){
        for (ll j = 0;j<n;j++){
            if (i + ls[j] <= m && h.get(i, i + ls[j] - 1) == hs[j]){
                seg.change(i+ls[j]-1, 1);
            }
        }
        for (auto& z : sob[i]){
            ans[z.i] += seg.get(0, z.r+1).x * z.d;
        }
    }
    for (ll x : ans) cout << x << " ";
    return 0;
}