#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ll T = 239;
const ll N = 5e4;

vector<ll> tp, hp;

ll hash1(ll l, ll r) {
    if (l == 0) return hp[r];
    ll h = (hp[r] - (hp[l - 1] * tp[r - l + 1]) % MOD + MOD) % MOD;
    return h;
}

ll hash2(string s) {
    ll h = 0;
    for (ll i = 0; i < s.size(); i++) h = ((h * T) % MOD + (s[i] - 'a' + 1)) % MOD;
    return h;
}

signed main() {
    ll n, m; cin >> n >> m;
    string t; cin >> t;
    tp.resize(t.size());
    hp.resize(t.size());
    tp[0] = 1;
    hp[0] = (t[0] - 'a' + 1);
    for (ll i = 1; i < t.size(); i++) {
        tp[i] = (tp[i - 1] * T) % MOD;
        hp[i] = ((hp[i - 1] * T) % MOD + (t[i] - 'a' + 1)) % MOD;
    }
    unordered_set<ll> hs;
    for (ll i = 0; i < n; i++) {
        string s; cin >> s;
        hs.insert(hash2(s));
    }
    ll len = t.size();
    vector<vector<ll> > cnt(len, vector<ll>(len)), pref(len, vector<ll>(len));
    for (ll l = 0; l < len; l++) {
        for (ll r = l; r < len; r++) {
            if (r > 0) pref[l][r] = pref[l][r - 1];
            ll h = hash1(l, r);
            if (hs.find(h) != hs.end()) {
                pref[l][r] = (pref[l][r] + 1) % MOD;
            }
        }
    }
    for (ll r = 0; r < len; r++) {
        for (ll l = r; l >= 0; l--) {
            cnt[l][r] = pref[l][r];
            if (l + 1 < len) cnt[l][r] = (cnt[l][r] + cnt[l + 1][r]) % MOD;         
        }
    }
    while (m--) {
        ll l, r; cin >> l >> r; l--, r--;
        cout << cnt[l][r] << " ";
    }
    return 0;
}