#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;
const ll MOD1 = 1e9 + 9;
const ll MOD2 = 1e9 + 7;
const ll T = 239;
const ll N = 5e4;

vector<ll> tp, hp, tp2, hp2;

ll hash1(ll l, ll r) {
    if (l == 0) return hp[r];
    ll h = (hp[r] - (hp[l - 1] * tp[r - l + 1]) % MOD1 + MOD1) % MOD1;
    return h;
}

ll hash12(ll l, ll r) {
    if (l == 0) return hp2[r];
    ll h = (hp2[r] - (hp2[l - 1] * tp2[r - l + 1]) % MOD2 + MOD2) % MOD2;
    return h;
}

ll hash2(string s) {
    ll h = 0;
    for (ll i = 0; i < s.size(); i++) h = ((h * T) % MOD1 + (s[i] - 'a' + 1)) % MOD1;
    return h;
}

ll hash22(string s) {
    ll h = 0;
    for (ll i = 0; i < s.size(); i++) h = ((h * T) % MOD2 + (s[i] - 'a' + 1)) % MOD2;
    return h;
}

signed main() {
    ll n, m; cin >> n >> m;
    string t; cin >> t;
    tp.resize(t.size());
    hp.resize(t.size());
    tp[0] = 1;
    hp[0] = (t[0] - 'a' + 1);
    for (ll i = 1; i < t.size(); i++) {
        tp[i] = (tp[i - 1] * T) % MOD1;
        hp[i] = ((hp[i - 1] * T) % MOD1 + (t[i] - 'a' + 1)) % MOD1;
    }
    tp2.resize(t.size());
    hp2.resize(t.size());
    tp2[0] = 1;
    hp2[0] = (t[0] - 'a' + 1);
    for (ll i = 1; i < t.size(); i++) {
        tp2[i] = (tp2[i - 1] * T) % MOD2;
        hp2[i] = ((hp2[i - 1] * T) % MOD2 + (t[i] - 'a' + 1)) % MOD2;
    }
    unordered_set<ll> hs, hs2;
    for (ll i = 0; i < n; i++) {
        string s; cin >> s;
        hs.insert(hash2(s));
        hs2.insert(hash22(s));
    }
    ll len = t.size();
    vector<vector<ll> > cnt(len, vector<ll>(len)), pref(len, vector<ll>(len));
    for (ll l = 0; l < len; l++) {
        for (ll r = l; r < len; r++) {
            if (r > 0) pref[l][r] = pref[l][r - 1];
            ll h = hash1(l, r), h2 = hash12(l, r);
            if (hs.find(h) != hs.end() && hs2.find(h) != hs2.end()) {
                pref[l][r] = (pref[l][r] + 1) % MOD1;
            }
        }
    }
    for (ll r = 0; r < len; r++) {
        for (ll l = r; l >= 0; l--) {
            cnt[l][r] = pref[l][r];
            if (l + 1 < len) cnt[l][r] = (cnt[l][r] + cnt[l + 1][r]) % MOD1;         
        }
    }
    while (m--) {
        ll l, r; cin >> l >> r; l--, r--;
        cout << cnt[l][r] << " ";
    }
    return 0;
}