#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const ll MOD1 = 2e9 + 11;
const ll MOD2 = 2e9 + 33;
const ll p1 = 239;
const ll p2 = 311;
const int MAXN = 5e5 + 5;

ll mult(ll a, ll b, ll mod) {
    return (a * b) % mod;
}

ll add(ll a, ll b, ll mod) {
    return (a + b < mod ? a + b : a + b - mod);
}

ll sub(ll a, ll b, ll mod) {
    return (a - b < 0 ? a - b + mod : a - b);
}

ll pow1[MAXN], pow2[MAXN];

pll wholeHash(const string &s) {
    pll Hs = {0, 0};
    int n = sz(s);
    for (int i = 0; i < n; i++) {
        Hs.X = add(mult(Hs.X, p1, MOD1), (ll) s[i], MOD1);
        Hs.Y = add(mult(Hs.Y, p2, MOD2), (ll) s[i], MOD2);
    }
    return Hs;
}

void calcHash(const string &s, vector<pll> &Hs) {
    int n = sz(s);
    Hs.rs(n + 1);
    Hs[0] = {0, 0};
    for (int i = 0; i < n; i++) {
        Hs[i + 1].X = add(mult(Hs[i].X, p1, MOD1), (ll) s[i], MOD1);
        Hs[i + 1].Y = add(mult(Hs[i].Y, p2, MOD2), (ll) s[i], MOD2);
    }
}

pll subHash(const vector<pll> Hs, int l, int r) {
    ll fir = sub(Hs[r].X, mult(Hs[l].X, pow1[r - l], MOD1), MOD1);
    ll sec = sub(Hs[r].Y, mult(Hs[l].Y, pow2[r - l], MOD2), MOD2);
    return make_pair(fir, sec);
}

int out[5005][50005];

void solve() {
    int n, m;
    string t;
    cin >> n >> m >> t;

    vector<pll> Ht;

    calcHash(t, Ht);

    set<pll> exi;

    for (int _ = 0; _ < n; _++) {
        string si;
        cin >> si;
        exi.insert(wholeHash(si));
    }
    int N = sz(t);

    for (int l = 0; l < N; l++) {
        int ans = 0;
        for (int r = l + 1; r <= N; r++) {
            ans += (exi.find(subHash(Ht, l, r)) != exi.end());
            out[l][r] = ans;
        }
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = i + 1; j <= N; j++) {
//            pll ans = subHash(Ht, i, j);
//            cout << i + 1 << ' ' << j << ' ' << ans << '\n';
//        }
//    }

    for (int _ = 0; _ < m; _++) {
        int l, r;
        cin >> l >> r;
        l--;
        ll ans = 0;
        for (int L = l; L < r; L++) {
            ans += out[L][r];
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    pow1[0] = pow2[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        pow1[i] = mult(pow1[i - 1], p1, MOD1);
        pow2[i] = mult(pow2[i - 1], p2, MOD2);
    }
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
