#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int MOD1 = 1e9 + 7;
const int p1 = 239;
const int MAXN = 5e5 + 5;

int mult(int a, int b, int mod) {
    return (a * 1LL * b) % mod;
}

int add(int a, int b, int mod) {
    return (a + b < mod ? a + b : a + b - mod);
}

int sub(int a, int b, int mod) {
    return (a - b < 0 ? a - b + mod : a - b);
}

int pow1[MAXN], pow2[MAXN];

int wholeHash(const string &s) {
    int Hs = 0;
    int n = sz(s);
    for (int i = 0; i < n; i++) {
        Hs = add(mult(Hs, p1, MOD1), (int) s[i], MOD1);
    }
    return Hs;
}

void calcHash(const string &s, vector<int> &Hs) {
    int n = sz(s);
    Hs.rs(n + 1);
    Hs[0] = 0;
    for (int i = 0; i < n; i++) {
        Hs[i + 1] = add(mult(Hs[i], p1, MOD1), (int) s[i], MOD1);
    }
}

int subHash(const vector<int> Hs, int l, int r) {
    return sub(Hs[r], mult(Hs[l], pow1[r - l], MOD1), MOD1);
}

struct bor {
    bor *go[26];
    int f;
    int cnt = 0;

    bor() {
        f = cnt = 0;
        for (auto &i: go)i = nullptr;
    }
};

int scnt(bor *rt) {
    return (rt ? rt->cnt : 0);
}

int sf(bor *rt) {
    return (rt ? rt->f : 0);
}

bor *add(bor *rt, const string &s, int ind) {
    if (!rt)rt = new bor();
    rt->cnt++;
    if (ind == sz(s)) {
        rt->f = 1;
        return rt;
    }
    rt->go[s[ind] - 'a'] = add(rt->go[s[ind] - 'a'], s, ind + 1);
    return rt;
}

ll out[5005][5005];
ll Ans[5005][5005];

void solve() {
    int n, m;
    string t;
    cin >> n >> m >> t;
    bor *rt = nullptr;
    for (int _ = 0; _ < n; _++) {
        string si;
        cin >> si;
        rt = add(rt, si, 0);
    }
    int N = sz(t);

    for (int l = 0; l < N; l++) {
        bor *cur = rt;
        for (int r = l + 1; r <= N; r++) {
            cur = cur->go[t[r - 1] - 'a'];
            if (scnt(cur) == 0)break;
            out[l][r] += cur->f;
        }
    }
    for (int l = 0; l < N; l++) {
        for (int r = l + 1; r <= N; r++) {
            out[l][r] += out[l][r - 1];
        }
    }

    for (int r = 1; r <= N; r++) {
        ll ans = 0;
        for (int l = r - 1; l > -1; l--) {
            ans += out[l][r];
            Ans[l][r] = ans;
        }
    }

    for (int _ = 0; _ < m; _++) {
        int l, r;
        cin >> l >> r;
        cout << Ans[l - 1][r] << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    pow1[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        pow1[i] = mult(pow1[i - 1], p1, MOD1);
    }
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
