#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;
const ll MOD = 1e9 + 7, BASE = 31;

ll get_hash(const string &s) {
    ll cur_hash = 0;
    for (int j = 0; j < s.size(); ++j) {
        cur_hash = (cur_hash * BASE % MOD + (s[j] - 'a' + 1)) % MOD;
    }
    return cur_hash;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    set<ll> hashes;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        hashes.insert(get_hash(s));
    }
    vector<vector<int>> cnt(t.size());
    for (int i = 0; i < t.size(); ++i) {
        ll cur_hash = 0;
        for (int j = i; j < t.size(); ++j) {
            cur_hash = (cur_hash * BASE % MOD + (t[j] - 'a' + 1)) % MOD;
            if (hashes.find(cur_hash) != hashes.end()) {
                cnt[i].push_back(j);
            }
        }
        sort(cnt[i].begin(), cnt[i].end());
    }
    int sz = t.size();
    for (int _ = 0; _ < m; ++_) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int ans = 0;
        for (int i = l; i < t.size(); ++i) {
            ans += (lower_bound(cnt[i].begin(), cnt[i].end(), r + 1) - cnt[i].begin());
        }
        cout << ans << " ";
    }

    return 0;
}