#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <deque>
#include <numeric>
using ll = long long;
#define all(x) x.begin(), x.end()
using namespace std;

struct mst {
	vector<vector<ll>> t;
	int n;

	void build(int v, int vl, int vr, vector<int>& a) {
		if (vl + 1 == vr) {
			t[v].push_back(a[vl]);
			return;
		}
		int m = (vl + vr) / 2;
		build(2 * v, vl, m, a);
		build(2 * v + 1, m, vr, a);
		merge(all(t[2 * v]), all(t[2 * v + 1]), back_inserter(t[v]));
	}

	mst(int n_, vector<int>& a) {
		n = n_;
		int sz = 1;
		while (sz < n) {
			sz *= 2;
		}
		t.resize(sz, {});
		if (n != 0)
			build(1, 0, n, a);
	}

	ll query(int v, int vl, int vr, int l, int r, int val) {
		if (vl >= r || l >= vr)
			return 0ll;
		if (l <= vl && vr <= r) {
			if (t[v].size() == 0) {
				return 0ll;
			}
			return t[v].size() - (lower_bound(all(t[v]), val) - t[v].begin());
		}
		return query(2 * v, vl, (vl + vr) / 2, l, r, val)
			+ query(2 * v + 1, (vl + vr) / 2, vr, l, r, val);

	}

};

int mod1 = 1e9 + 7;
int mod2 = 1e9 + 9;
int p = 127;
signed main() {
#ifdef LOCAL
	freopen("C:\\Users\\olymp\\source\\repos\\Project1\\input.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> v;
	set<pair<int, int>> h;
	vector<pair<int, int>> pref_hash(1);
	pref_hash[0] = { t[0] - 'a' + 1, t[0] - 'a' + 1 };
	for (int i = 1; i < t.size(); ++i) {
		pref_hash.push_back({ ((pref_hash[i - 1].first * p) % mod1
			+ t[i] - 'a' + 1) % mod1,  ((pref_hash[i - 1].second * p) % mod2
			+ t[i] - 'a' + 1) % mod2 });
	}
	vector<pair<int, int>> deg(t.size() + 1);
	deg[0] = { 1, 1 };
	for (int i = 1; i < t.size() + 1; ++i) {
		deg[i].first = deg[i - 1].first * p;
		deg[i].first %= mod1;
		deg[i].second = deg[i - 1].second * p;
		deg[i].second %= mod2;
	}
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		v.push_back(s);
		int hash = 0;
		int hash1 = 0;
		for (auto j : s) {
			hash *= p;
			hash %= mod1;
			hash += j - 'a' + 1;
			hash %= mod1;
			hash1 *= p;
			hash1 %= mod2;
			hash1 += j - 'a' + 1;
			hash1 %= mod2;
		}
		h.insert({ hash, hash1 });
	}

	vector<vector<int>> idx(t.size());
	vector<int> idx1;
	vector<int> start;
	vector<int> end;
	for (int i = 0; i < t.size(); ++i) {
		int sz = idx1.size();
		for (int j = i; j >= 0; --j) {
			int hash = pref_hash[i].first;
			if (j != 0) {
				hash = ((hash - (pref_hash[j - 1].first
					* deg[i - j + 1].first) % mod1
					) % mod1 + mod1) % mod1;
			}
			int hash1 = pref_hash[i].second;
			if (j != 0) {
				hash1 = ((hash1 - (pref_hash[j - 1].second
					* deg[i - j + 1].second) % mod2
					) % mod2 + mod2) % mod2;
			}
			if (h.find({ hash, hash1 }) != h.end()) {
				idx[i].push_back(j);
				idx1.push_back(j);
			}
		}
		start.push_back(sz);
		end.push_back(idx1.size());
		sort(all(idx[i]));
	}
	mst mt(idx1.size(), idx1);
	while (m--) {
		int l, r;
		cin >> l >> r;
		--l;
		--r;
		ll ans = mt.query(1, 0, idx1.size(), start[l], end[r], l);
		//vector<int> res;
		//for (int i = l; i <= r; ++i) {
		//	int ind = lower_bound(all(idx[i]), l) - idx[i].begin();
		//	ans += idx[i].size() - ind;
		//	/*for (int j = 0; j < idx[i].size(); ++j) {
		//		if (idx[i][j].first < l) {
		//			break;
		//		}
		//		res.push_back(idx[i][j].second);
		//	}*/
		//}
		cout << ans << ' ';
	}

	return 0;
}