#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>
#include<set>
#include<tuple>
#include<unordered_set>

using namespace std;
typedef long long ll;
int pw = 179;
int mod = 1e9 + 7;


void hash_(string s, vector<ll>& h, vector<ll>& p)
{
    h.resize(s.size() + 1);
    p.resize(s.size() + 1);
    p[0] = 1;
    h[0] = 0;
    for (int i = 0; i < s.size(); i++)
    {
        p[i + 1] = p[i] * pw % mod;
        h[i + 1] = h[i] * pw + s[i] - 'a' + 1;
        h[i + 1] %= mod;
    }
    return;
}


ll count_h(string& s)
{
    ll ans = 0;
    for (int i = 0; i < s.size(); i++)
    {
        ans = ans * pw + s[i] - 'a' + 1;
        ans %= mod;
    }
    return ans;
}


int hashij(int i, int j, vector<ll>& h, vector<ll>& p)
{
    return (h[j] - h[i] * p[j - i] % mod + mod) % mod;
}


int main()
{
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<ll> h;
    vector<ll> p;
    hash_(t, h, p);
    vector<string> s(n);
    vector<ll> hh(n);
    for (int i = 0 ; i < n; i++)
    {
        cin >> s[i];
        hh[i] = count_h(s[i]);
    }
    for (int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        unordered_multiset<int> ch;
        for (int L = l; L <= r; L++)
        {
            for (int R = L; R <= r; R++)
            {
                ch.insert(hashij(L, R + 1, h, p));
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i++)
        {
            ans += ch.count(hh[i]);
        }
        cout << ans << endl;
    }
    return 0;
}