#define _GLIBCXX_DEBUG_PEDANTIC
// думай о правильности перед написанием
// проверяй идеи
// проверяй правильность кода
// пробуй разные подходы
// не задерживайся слишком долго на одной задаче
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int long long

#define dbg(x) cerr << #x << ": " << x << endl;


const int MOD = 1e9 + 7;
const int BASE = 13373;


int add(int a, int b) {
    int res = a + b;
    if (res >= MOD) res -= MOD;
    return res;
}

int mul(ll a, int b) {
    return a * b % MOD;
}

int sub(int a, int b) {
    int res = a - b;
    if (res < 0) res += MOD;
    return res;
}

struct Hasher {
    vector<int> pref;
    vector<int> power;
    int size;

    Hasher(const string& s) {
        size = s.size() + 1;
        pref.resize(size);
        power.assign(size, 1);

        for (int i = 1; i < size; ++i) {
            int c = (int)(s[i - 1] - 'a') + 27;
            pref[i] = add(mul(pref[i - 1], BASE), c);
            power[i] = mul(power[i - 1], BASE);
        }
    }

    int substr(int l, int r) {
        ++l, ++r;
        int res = pref[r];
        res = sub(res, mul(pref[l - 1], power[r - l + 1]));
        return res;
    }

    int get_hash() const {
        return pref.back();
    }
};


const int MAX_N = 5000 + 5;
int dp[MAX_N][MAX_N];




int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;
    int sz = s.size();

    Hasher s_hash(s);
    for (int i = 0; i < n; ++i) {
        string t;
        cin >> t;
        Hasher h(t);
        int curr_sz = t.size();
        int curr_hash = h.get_hash();
        for (int j = 0; j + curr_sz - 1 < sz; ++j) {
            if (s_hash.substr(j, j + curr_sz - 1) == curr_hash) {
                ++dp[j][j + curr_sz - 1];
            }
        }
    }

    for (int len = 2; len <= sz; ++len) {
        for (int l = 0; l + len - 1 < sz; ++l) {
            int r = l + len - 1;
            dp[l][r] += dp[l + 1][r];
            dp[l][r] += dp[l][r - 1];
            dp[l][r] -= dp[l + 1][r - 1];
        }
    }

    for (int t = 0; t < m; ++t) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        cout << dp[l][r] << ' ';
    }
    cout << '\n';

    return 0;
}