#include <iostream>
#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<signed, signed>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


const ll MAX_MEMORY = 900 * 1024 * 1024;
char MEMORY[MAX_MEMORY];
int mem_pos = 0;
void* operator new(size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void* operator new[](size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void operator delete(void*) noexcept {}
void operator delete(void*, size_t) noexcept {}
void operator delete[](void*) noexcept {}
void operator delete[](void*, size_t) noexcept {}


const int MAXN = 5e5 + 57;


struct Trie {
    bool term = false;
    Trie *ch[26];
    Trie() {
        fill(ch, ch+26, nullptr);
    }
    Trie *suff = nullptr;
    Trie *par = nullptr;
    int h = 0;
    Trie* pi = nullptr;
};


void add(string const& s, Trie* root) {
    for (char sym : s) {
        if (root->ch[sym - 'a'] == nullptr) {
            root->ch[sym - 'a'] = new Trie();
            root->ch[sym - 'a']->par = root;
            root->ch[sym - 'a']->h = root->h + 1;
        }
        root = root->ch[sym - 'a'];
    }
    root->term = true;
}


void calc_suff_pi(Trie* root) {
    deque<pair<Trie*, char>> q;
    for (int i = 0; i < 26; ++i) {
        if (root->ch[i]) {
            q.push_back({root, (char) i + 'a'});
        }
    }
    root->suff = root;
    root->pi = root;
    while (!q.empty()) {
        auto [par, sym] = q.front();
        q.pop_front();
        auto v = par->ch[sym - 'a'];
        v->suff = par->suff;
        while (v->suff != root && !v->suff->ch[sym - 'a']) {
            v->suff = v->suff->suff;
        }
        if (v->suff->ch[sym - 'a'] && v->suff->ch[sym - 'a'] != v) {
            v->suff = v->suff->ch[sym - 'a'];
        }
        v->pi = (v->suff->term ? v->suff : v->suff->pi);
        for (int i = 0; i < 26; ++i) {
            if (v->ch[i]) {
                q.push_back({v, (char) i + 'a'});
            }
        }
    }
}
void go(char sym, Trie*& cur, Trie* root) {
    while (cur != root && !cur->ch[sym - 'a']) {
        cur = cur->suff;
    }
    if (cur->ch[sym - 'a']) {
        cur = cur->ch[sym - 'a'];
    }
}


struct St {
    int t[4 * MAXN]{};
    void add(int tv, int tl, int tr, int qi, int qx) {
        if (tl + 1 == tr) {
            t[tv] += qx;
            return;
        }
        int tm = (tl + tr) / 2;
        if (qi < tm) {
            add(tv * 2 + 1, tl, tm, qi, qx);
        }
        else {
            add(tv * 2 + 2, tm, tr, qi, qx);
        }
        t[tv] = t[tv * 2 + 1] + t[tv * 2 + 2];
    }
    int get(int tv, int tl, int tr, int ql, int qr) {
        if (qr <= tl || tr <= ql) {
            return 0;
        }
        if (ql <= tl && tr <= qr) {
            return t[tv];
        }
        int tm = (tl + tr) / 2;
        return get(tv * 2 + 1, tl, tm, ql, qr) +
               get(tv * 2 + 2, tm, tr, ql, qr);
    }
} st;

inline signed one() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    Trie* root = new Trie();
    for (auto &str : s) {
        cin >> str;
        add(str, root);
    }
    calc_suff_pi(root);
    Trie* cur = root;
    vector<vector<pii>> q(t.size(), vector<pii>());
    vector<int> ans(m);
    for (int i = 0; i < m; ++i) {
        int li, ri;
        cin >> li >> ri;
        --li, --ri;
        q[ri].push_back({li, i});
    }
    ordered_set<pair<int, int>> cur_occur;
    int timer = 0;
    for (int i = 0; i < t.size(); ++i) {
        char sym = t[i];
        go(sym, cur, root);
        Trie* pi = (cur->term ? cur : cur->pi);
        while (pi->term) {
            cur_occur.insert({i - pi->h + 1, timer++});
            pi = pi->pi;
        }
        for (auto [li, qi] : q[i]) {
            ans[qi] = cur_occur.size() - cur_occur.order_of_key({li, -1});
        }
    }
    for (auto ansi : ans) {
        cout << ansi << ' ';
    }
    cout << endl;
    return 0;
}


signed main() {
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode) {
            return retcode;
        }
    }
    return 0;
}