#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    string t;
    vector<string> s;
    vector<pair<int, int>> q;

    solve() : s(n), q(m) {
        cin >> t;
        for (string &x : s) {
            cin >> x;
        }
        for (auto &[a, b] : q) {
            cin >> a >> b;
            --a;
        }
        solve_segdp();
    }

    const long long MOD = 1000000009;
    const long long P = 29;

    vector<long long> t_hash;
    vector<long long> powmod;

    void calc_thash() {
        long long cur = 0;
        t_hash.push_back(cur);
        powmod.push_back(1);
        for (char c : t) {
            cur = (cur * P + (c - 'a' + 1)) % MOD;
            t_hash.push_back(cur);
            powmod.push_back(powmod.back() * P % MOD);
        }
    }

    long long extract_hash(int l, int r) {
        return (t_hash[r] + MOD - t_hash[l] * powmod[r - l] % MOD) % MOD;
    }

    void solve_segdp() {
        calc_thash();
        unordered_set<long long> hashes;

        auto calc_hash = [&](const string &x) {
            long long res = 0;
            for (char c : x) {
                res = (res * P + (c - 'a' + 1)) % MOD;
            }
            return res;
        };

        for (const string &x : s) {
            hashes.insert(calc_hash(x));
        }

        vector<vector<long long>> dp(t.size() + 1);
        for (int len = 0; len <= t.size(); ++len) {
            dp[len].resize(t.size() - len + 1);
        }
        for (int len = 1; len <= t.size(); ++len) {
            for (int start = 0; start + len <= t.size(); ++start) {
                dp[len][start] = dp[len - 1][start] + dp[len - 1][start + 1];
                if (len >= 2) {
                    dp[len][start] -= dp[len - 2][start + 1];
                }
                if (hashes.find(extract_hash(start, start + len)) != hashes.end()) {
                    ++dp[len][start];
                }
            }
        }

        for (auto [l, r] : q) {
            cout << dp[r - l][l] << " ";
        }
        cout << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
