#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>
#include <chrono>
#include <cassert>
#include <climits>

using namespace std;

using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
istream& operator>>(istream &in, vector <T> &arr) {
    for (T &i: arr) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream &out, const vector <T> &arr) {
    for (const T &i: arr) out << i << ' ';
    return out;
}

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define mp make_pair

//#define int int64_t
//#define multitest
#define ull uint64_t
#define x first
#define y second

#pragma GCC target("fma")
#pragma GCC optimize("O3")
//#pragma GCC optimize("trapv")

long long mod = 1e9 + 7;
using hash_t = pair <long long, ull>;

hash_t mul(hash_t a, hash_t b) {
    return {(a.x % mod) * (b.x % mod) % mod, a.y * b.y};
}

hash_t add(hash_t a, hash_t b) {
    return {(a.x % mod + b.x % mod) % mod, a.y + b.y};
}

hash_t subtract(hash_t a, hash_t b) {
    return {(a.x % mod - b.x % mod + mod) % mod, a.y - b.y};
}

const int p = 31;

string reversed(const string &s) {
    string ans = s;
    reverse(all(ans));
    return ans;
}

hash_t calc_hash(const string &s) {
    hash_t cur_hash = {0, 0};
    hash_t cur_p = {1, 1};
    for (auto c: reversed(s)) {
        cur_hash = add(cur_hash, mul(cur_p, {c - 'a' + 1, c - 'a' + 1}));
        cur_p = mul(cur_p, {p, p});
    }
    return cur_hash;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector <string> s(n);
    cin >> s;
    vector <pair <hash_t, int>> st;
    for (auto &i: s) st.emplace_back(calc_hash(i), i.size());
    sort(all(st));
    vector <vector <long long>> anses(t.size(), vector <long long>(t.size(), 0));
    while (m --> 0) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        if (!anses[l][r]) {
            long long ans = 0;

            for (auto [hsh, len]: st) {
                 hash_t cur_hash = calc_hash(t.substr(l, len));
                 hash_t cur_p = {1, 1};
                 for (int i = 0; i < len - 1; ++i) {
                     cur_p = mul(cur_p, {p, p});
                 }
                 for (int i = l + len; i <= r; ++i) {
                     ans += hsh == cur_hash;
                     cur_hash = subtract(cur_hash, mul(cur_p, {t[i - len] - 'a' + 1, t[i - len] - 'a' + 1}));
                     cur_hash = mul(cur_hash, {p, p});
                     cur_hash = add(cur_hash, {t[i] - 'a' + 1, t[i] - 'a' + 1});
                 }
                ans += hsh == cur_hash;
            }

            anses[l][r] = ans;
        }

        cout << anses[l][r] << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
    auto start = clock();
#endif
    int t;
#ifdef multitest
    cin >> t;
#else
    t = 1;
#endif
    while (t --> 0) solve();
#ifdef LOCAL
    auto end = clock();
    cerr << "time: " << end - start << endl;
#endif
    return 0;
}