#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define int long long 

int code(char c) {
	return (int)(c - 'a' + 1);
}

const int mod = 1e9 + 9;
const int base = 31;

int SUM(int a, int b) {
	if (b < 0) b += mod;
	return (a + b) % mod;
}

int MULT(int a, int b) {
	return (a * b) % mod;
}

int binpow(int a, int n) {
	int ans = 1;
	while (n) {
		if (n & 1) ans = MULT(ans, a);
		a = MULT(a, a);
		n >>= 1;
	}
	return ans;
}

signed main() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> vec(n);
	for (string &s: vec) cin >> s;
	map<int, vector<int>> layers;
	set<int> lens;
	for (int i = 0; i < n; ++i) {
		string &s = vec[i];
		int hs = 0, h = 0;
		int l = 0, r = s.size();
		if (r > t.size()) continue;
		if (*(lens.lower_bound(s.size())) != s.size()) {
			lens.insert(s.size());
			layers[s.size()] = vector<int>(t.size(), 0);
		}
		int mult = binpow(base, s.size());
		for (int j = 0; j < r; ++j) {
			hs = MULT(hs, base);
			hs = SUM(hs, code(s[j]));
			h = MULT(h, base);
			h = SUM(h, code(t[j]));
		} 
		while (r != t.size()) {
			if (hs == h) {
				layers[s.size()][l] += 1;
			}
			h = MULT(h, base);
			h = SUM(h, code(t[r]));
			h = SUM(h, -MULT(mult, code(t[l])));
			++l;
			++r;
		}
		if (hs == h) {
			layers[s.size()][l] += 1;
		}
		// cerr << "layer " << s.size() << endl;
		// for (int i = 0; i < t.size(); ++i) {
		// 	cerr << layers[s.size()][i] << ' ';
		// }
		// cerr << endl;
	}
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		--l;
		int ans = 0;
		for (int x: lens) {
			for (int j = l; j + x <= r; ++j) {
				ans += layers[x][j];
			}
		}
		cout << ans << endl;
	}
}