#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define int long long

const int INF = 1e17 + 7;

using namespace std;
//using namespace __gnu_pbds;
//using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Hash {
    vector<vector<int>> pref, pw;
    vector<int> mod, base;
    int n;

    Hash(string &s, vector<int> &_mod, vector<int> &_base) {
        mod = _mod;
        base = _base;
        n = (int) s.size();
        pref.resize(n + 1, vector<int>(2, 0));
        pw.resize(n + 1, vector<int>(2, 1));
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < 2; j++) {
                pref[i][j] = ((pref[i - 1][j] * base[j]) % mod[j] + s[i - 1] - 'a') % mod[j];
                pw[i][j] = (pw[i - 1][j] * base[j]) % mod[j];
            }
        }
    }

    vector<int> get(int l, int r) {
        vector<int> res(2, 0);
        for (int i = 0; i < 2; i++) {
            res[i] = (pref[r][i] + mod[i] - (pref[l][i] * pw[r - l][i]) % mod[i]) % mod[i];
        }
        return res;
    }
};

bool comp(Hash &a, Hash &b) {
    return a.n < b.n;
}

void sf() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    sf();
    vector<int> mods = {1000000007, 998244353};
    vector<int> base = {37, 41};
    int m, q;
    cin >> m >> q;
    string s;
    cin >> s;
    int n = (int) s.size();
    vector<string> vec(m);
    for (auto &i : vec) cin >> i;
    vector<Hash> hashes;
    for (int i = 0; i < m; i++) {
        hashes.emplace_back(Hash(vec[i], mods, base));
    }
    sort(hashes.begin(), hashes.end(), comp);
    Hash ABOBA(s, mods, base);
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        int cnt = 0;
        for (int i = l; i < r; i++) {
            for (int j = 0; j < m; j++) {
                if (i + hashes[j].n > r) break;
                vector<int> v1 = hashes[j].pref.back();
                vector<int> v2 = ABOBA.get(i, i + hashes[j].n);
                cnt += v1 == v2;
            }
        }
        cout << cnt << ' ';
    }
}
