#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef unsigned int uint;
typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

uint p = 1337, mod = 1e9 + 7;

const int MAXN = 1e5;
uint power[MAXN];

bool cmp(string& a, string& b) {
    return sz(a) < sz(b);
}

void solve() {
    uint a = 2;
    cout << a << '\n';
    int n, m, l, r;
    cin >> n >> m;
    string t;
    cin >> t;
    int ts = sz(t);
    vector<string> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    sort(All(s), cmp);
    vector<vector<int>> pref;
    vector<int> lens;
    for (int l = 0; l < n; l++) {
        int len = sz(s[l]);
        lens.push_back(len);
        int r = l;
        while (r + 1 < n && sz(s[r + 1]) == len)
            r++;

        unordered_set<uint> cur_h;
        for (int j = l; j <= r; j++) {
            uint h = 0;
            for (char c : s[j]) {
                h *= p;
                h += c;
            }
            cur_h.insert(h);
        }
        vector<int> cur(ts + 1);
        cur[0] = 0;

        uint h = 0;
        for (int i = 0; i < ts; i++) {
            h *= p;
            h += t[i];
            if (i - len >= 0)
                h -= power[len] * t[i - len];
            cur[i + 1] = cur[i];
            if (cur_h.count(h))
                cur[i + 1]++;
        }
        pref.emplace_back();
        swap(pref.back(), cur);
        l = r;
    }
    int sq = sz(pref);
    while (m--) {
        cin >> l >> r;
        l--, r--;
        ll ans = 0;
        for (int i = 0; i < sq; i++) {
            int len = lens[i];
            if (len > r - l + 1) break;
            int tr = r, tl = l + len - 1;
            ans += pref[i][tr + 1] - pref[i][tl];
        }
        cout << ans << '\n';
    }
}

void precalc() {
    power[0] = 1;
    for (int i = 1; i < MAXN; i++)
        power[i] = power[i - 1] * p;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    precalc();
    solve();
}