//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cmath>
#include <math.h>
#include <algorithm>

using namespace std;

mt19937 rnd(12);

const int N = 1e6 + 1, inf = 1e9 + 111, mod = 1e9 + 181, p = 43;

struct Fenwick_tree
{
    vector<int> tree;

    Fenwick_tree() {}
    Fenwick_tree(int n) {
        tree.resize(n, 0);
    }

    void upd(int i, int x) {
        while (i < tree.size()) {
            tree[i] += x;
            i |= (i + 1);
        }
    }

    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += tree[i];
            i &= (i + 1);
            i--;
        }
        return sum;
    }
};

inline int add(int a, int b) {
    if (a + b >= mod) {
        return a + b - mod;
    }
    return a + b;
}

inline int sub(int a, int b) {
    if (a - b < 0) {
        return a - b + mod;
    }
    return a - b;
}

inline int mul(long long a, long long b) {
    long long res = (a * b) % mod;
    return res;
}

int prefixHash[50011], degree[50011];

int getSegment(int l, int r) {
    if (l == 0)
        return prefixHash[r];
    return sub(prefixHash[r], mul(prefixHash[l - 1], degree[(r - l + 1)]));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    degree[0] = 1;
    for (int i = 1; i < 50011; i++) {
        degree[i] = mul(degree[i - 1], p);
    }
    int sz = t.size();
    prefixHash[0] = t[0];
    for (int i = 1; i < sz; i++) {
        prefixHash[i] = add(mul(prefixHash[i - 1], p), t[i]);
    }
    vector<vector<int>> have(sz);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int now = s[0];
        for (int y = 1; y < s.size(); y++) {
            now = add(mul(now, p), s[y]);
        }
        for (int y = 0; y + s.size() - 1 < sz; y++) {
            if (getSegment(y, y + s.size() - 1) == now) {
                have[y].push_back(y + s.size() - 1);
            }
        }
    }
    for (int i = 0; i < sz; i++) {
        sort(have[i].begin(), have[i].end());
    }
    vector<vector<int>> requests(m, vector<int> (3));
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int res = 0;
        for (int i = l; i <= r; i++) {
            for (int elem : have[i]) {
                if (elem > r) break;
                res++;
            }
        }
        cout << res << " ";
    }

}

