#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES"<<endl
#define int long long
#define str string

const int p = 31;
const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;

struct polyhash {
    int n;
    vector<pair<int, int>> h, ppow;

    polyhash() = default;
    polyhash(int n_, str &s) {
        n = n_;
        h.assign(n + 1, {0, 0});
        ppow.assign(n + 1, {1, 1});
        build(s);
    }

    void build(str &s) {
        for (int i = 1; i <= n; i++) {
            ppow[i].ff = (ppow[i - 1].ff * p) % mod;
            ppow[i].sc = (ppow[i - 1].sc * p) % mod2;
            h[i] = {(h[i - 1].ff * p + s[i-1] - 'a' + 1) % mod,
                    (h[i - 1].sc * p + s[i-1] - 'a' + 1) % mod2};
        }
    }

    pair<int, int> substr(int l, int r) {
        return {(h[r + 1].ff - (h[l].ff * ppow[r - l + 1].ff) % mod + mod) % mod,
                (h[r + 1].sc - (h[l].sc * ppow[r - l + 1].sc) % mod2 + mod2) % mod2};
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    str t; cin >> t;

    vector<str> s(n);
    f (i, 0, n) {
        cin >> s[i];
    }
    sort(all(s), [](str s1, str s2) {
        return s1.size() < s2.size();
    });
    vector<polyhash> P(n);
    f (i, 0, n) {
        P[i] = polyhash(sz(s[i]), s[i]);
    }

    polyhash pl(sz(t), t);
    vector<vector<int>> have(sz(t));
    for (int endd = 0; endd < sz(t); endd++) {
        for (int j = 0; j < n; j++) {
            if (endd + 1 >= sz(s[j]) && pl.substr(endd - sz(s[j]) + 1, endd) == P[j].h.back()) {
                have[endd].pb(sz(s[j]));
            }
        }
    }

    vector<vector<int>> answ(sz(t), vector<int>(sz(t), 0));
    f (i, 0, sz(t)) {
        answ[i][i] = (!have[i].empty() && have[i][0] == 1 ? 1 : 0);
        for (int j = i + 1; j < sz(t); j++) {
            int L = -1, R = sz(have[j]);
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (have[j][M] <= j - i + 1) L = M;
                else R = M;
            }
            answ[i][j] = answ[i][j - 1] + R;
        }
    }

    while (m--) {
        int l, r; cin >> l >> r;
        cout << answ[l - 1][r - 1] << ' ';
    }
    cout << '\n';

    return 0;
}