#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES"<<endl
#define int long long
#define str string

const int p = 31;
const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;

struct polyhash {
    int n;
    vector<pair<int, int>> h, ppow;

    polyhash() = default;
    polyhash(int n_, str &s) {
        n = n_;
        h.assign(n + 1, {0, 0});
        ppow.assign(n + 1, {1, 1});
        build(s);
    }

    void build(str &s) {
        for (int i = 1; i <= n; i++) {
            ppow[i].ff = (ppow[i - 1].ff * p) % mod;
            ppow[i].sc = (ppow[i - 1].sc * p) % mod2;
            h[i] = {(h[i - 1].ff * p + s[i-1] - 'a' + 1) % mod,
                    (h[i - 1].sc * p + s[i-1] - 'a' + 1) % mod2};
        }
    }

    pair<int, int> substr(int l, int r) {
        return {(h[r + 1].ff - (h[l].ff * ppow[r - l + 1].ff) % mod + mod) % mod,
                (h[r + 1].sc - (h[l].sc * ppow[r - l + 1].sc) % mod2 + mod2) % mod2};
    }
};

struct MergeSortTree {
    int n;
    vector<int> a;
    vector<vector<int>> t;

    MergeSortTree() = default;
    MergeSortTree(int n_, vector<int> a_) {
        n = n_;
        a = a_;
        t.resize(4 * n);
        build(1, 0, n);
    }

    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t[v] = {a[tl]};
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm, tr);
        t[v].assign(tr - tl, 0);
        merge(all(t[v*2]), all(t[v*2+1]), t[v].begin());
    }

    int req(int v, int tl, int tr, int l, int r, int x) {
        if (tr <= l || tl >= r) return 0;
        if (l <= tl && tr <= r) {
            int L = -1, R = sz(t[v]);
            while (R - L > 1) {
                int M = (L+R) / 2;
                if (t[v][M] >= x) R = M;
                else L = M;
            }
            return sz(t[v]) - R;
        }
        int tm = (tl + tr) / 2;
        return req(v * 2, tl, tm, l, r, x) + req(v * 2 + 1, tm, tr, l, r, x);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    str t; cin >> t;

    vector<str> s(n);
    f (i, 0, n) {
        cin >> s[i];
    }
    sort(all(s), [](str s1, str s2) {
        return s1.size() < s2.size();
    });
    vector<polyhash> P(n);
    f (i, 0, n) {
        P[i] = polyhash(sz(s[i]), s[i]);
    }

    polyhash pl(sz(t), t);
    vector<int> tomst;
    vector<pair<int, int>> grans(sz(t));
    for (int endd = 0; endd < sz(t); endd++) {
        tomst.pb(-1);
        grans[endd].ff = tomst.size() - 1;
        for (int j = 0; j < n; j++) {
            if (endd + 1 >= sz(s[j]) && pl.substr(endd - sz(s[j]) + 1, endd) == P[j].h.back()) {
                tomst.pb(endd - sz(s[j]) + 1);
            }
        }
        grans[endd].sc = sz(tomst) - 1;
    }

    MergeSortTree mst(sz(tomst), tomst);

    while (m--) {
        int l, r; cin >> l >> r;
        cout << mst.req(1, 0, sz(tomst), grans[l - 1].ff, grans[r - 1].sc + 1, l - 1) << ' ';
    }
    cout << '\n';

    return 0;
}