#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 5E6, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator+ (const Mod_int& m) const
	{
		return ans + m.ans;
	}
	Mod_int operator+= (const Mod_int& m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int& m) const
	{
		return ans - m.ans + MOD;
	}
	Mod_int operator-= (const Mod_int& m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
	bool operator== (const Mod_int& m) const
	{
		return ans == m.ans;
	}
};

Mod_int hash_pr[MAXN + 1], step[MAXN + 1];

Mod_int get_hash(int l, int sz)
{
	return hash_pr[l + sz] - hash_pr[l] * step[sz];
}

unordered_map <int, unordered_set <int64_t>> mp;
unordered_map <int, vector <int>> pref_mp;
unordered_set <int> sz;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	step[0] = 1;
	for (int i = 0; i < MAXN; i++)
	{
		step[i + 1] = step[i] * 269;
	}

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	for (int i = 0; i < s.size(); i++)
	{
		hash_pr[i + 1] = hash_pr[i] * 269 + s[i];
	}

	for (int i = 0; i < n; i++)
	{
		Mod_int h = 0;
		string p;
		cin >> p;
		for (int i = 0; i < p.size(); i++)
		{
			h *= 269;
			h += p[i];
		}
		mp[p.size()].insert(h.ans);
		sz.insert(p.size());
	}

	for (auto x : sz)
	{
		pref_mp[x].resize(s.size() + 1);
		for (int i = 0; i < int(s.size()) - x + 1; i++)
		{
			pref_mp[x][i + 1] = pref_mp[x][i];
			if (mp[x].count(get_hash(i, x).ans))
			{
				pref_mp[x][i + 1]++;
			}
		}
	}

	for (int i = 0; i < m; i++)
	{
		int l, r;
		cin >> l >> r;
		int64_t ans = 0;
		for (auto x : sz)
		{
			if (r - x + 1 >= l - 1)
			{
				ans += pref_mp[x][r - x + 1] - pref_mp[x][l - 1];
			}
		}
		cout << ans << ' ';
	}
}