#pragma optimize("O3, unroll-loops")
#pragma target("avx,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

const int mod1 = 1000000009, mod2 = 1000000321, prime = 239;
int prime_obr1, prime_obr2;

int bin_pow1(int a, int x) {
    int res = 1;
    while (x) {
        if (x % 2) {
            res *= a;
            res %= mod1;
        }
        a *= a;
        a %= mod1;
        x /= 2;
    }
    return res;
}

int bin_pow2(int a, int x) {
    int res = 1;
    while (x) {
        if (x % 2) {
            res *= a;
            res %= mod2;
        }
        a *= a;
        a %= mod2;
        x /= 2;
    }
    return res;
}


void solve() {
    prime_obr1 = bin_pow1(prime, mod1 - 2);
    prime_obr2 = bin_pow2(prime, mod2 - 2);
    int n, q;
    string t;
    cin >> n >> q >> t;
    vector<string> str(n);
    int hashes1[500000], hashes2[500000], p_power1[1000100], p_power2[1000100], hashT1[5000001], hashT2[5000001], p_obr1[1000100], p_obr2[1000100];
    unsigned int i2[64];
    i2[0] = 1;
    for (int i = 1; i < 64; i++) {
        i2[i] = i2[i - 1] * 2;
    }
    p_power1[0] = 1;
    p_obr1[0] = 1;
    p_power2[0] = 1;
    p_obr2[0] = 1;
    for (int i = 1; i < 1000100; i++) {
        p_power1[i] = (p_power1[i - 1] * prime) % mod1;
        p_obr1[i] = (p_obr1[i - 1] * prime_obr1) % mod1;
        p_power2[i] = (p_power2[i - 1] * prime) % mod2;
        p_obr2[i] = (p_obr2[i - 1] * prime_obr2) % mod2;
    }
    hashT1[0] = 0;
    hashT2[0] = 0;
    for (int i = 1; i <= t.size(); i++) {
        hashT1[i] = (hashT1[i - 1] + (t[i - 1] - 'a' + 1) * p_power1[i - 1]) % mod1;
        hashT2[i] = (hashT2[i - 1] + (t[i - 1] - 'a' + 1) * p_power2[i - 1]) % mod2;
    }
    set<int> sizes;
    for (int i = 0; i < n; i++) {
        cin >> str[i];
        sizes.insert(str[i].size());
        hashes1[i] = 0;
        hashes2[i] = 0;
        for (int j = 0; j < str[i].size(); j++) {
            hashes1[i] += (str[i][j] - 'a' + 1) * p_power1[j];
            hashes1[i] %= mod1;
            hashes2[i] += (str[i][j] - 'a' + 1) * p_power2[j];
            hashes2[i] %= mod2;
        }
    }
    int f[3000], cnt = 0;
    for (int i : sizes) {
        f[cnt++] = i;
    }
    unsigned int bitset1[15625006], bitset2[15625006];
    for (int i = 0; i < n; i++) {
        bitset1[hashes1[i] / 64] |= i2[hashes1[i] % 64];
        bitset2[hashes2[i] / 64] |= i2[hashes2[i] % 64];
    }
    if (t.size() <= 50000) {
        int32_t pr[50001][1500];
        int hsh1 = 0, hsh2 = 0, cnt1 = cnt;
        for (int i = 0; i < t.size(); i++) {
            for (int j = 0; j < cnt1; j++) {
                if (i + f[j] > t.size()) {
                    cnt1 = j;
                    break;
                }
                hsh1 = (((hashT1[i + f[j]] - hashT1[i]) * p_obr1[i]) % mod1 + mod1) % mod1;
                hsh2 = (((hashT2[i + f[j]] - hashT2[i]) * p_obr2[i]) % mod2 + mod2) % mod2;
                pr[i + 1][j] = pr[i][j];
                if ((bitset1[hsh1 / 64] & i2[hsh1 % 64]) && (bitset2[hsh2 / 64] & i2[hsh2 % 64])) {
                    pr[i + 1][j]++;
                }
            }
        }
        while (q--) {
            int x, y, ans = 0;
            cin >> x >> y; x--;
            for (int i = 0; i < cnt; i++) {
                if (x + f[i] > y) {
                    break;
                }
                ans += pr[y - f[i] + 1][i] - pr[x][i];
            }
            cout << ans << ' ';
        }
        return;
    }
    int32_t pr[250001][448];
    int hsh1 = 0, hsh2 = 0, cnt1 = cnt;
    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < cnt1; j++) {
            if (i + f[j] > t.size()) {
                cnt1 = j;
                break;
            }
            hsh1 = (((hashT1[i + f[j]] - hashT1[i]) * p_obr1[i]) % mod1 + mod1) % mod1;
            hsh2 = (((hashT2[i + f[j]] - hashT2[i]) * p_obr2[i]) % mod2 + mod2) % mod2;
            pr[i + 1][j] = pr[i][j];
            if ((bitset1[hsh1 / 64] & i2[hsh1 % 64]) && (bitset2[hsh2 / 64] & i2[hsh2 % 64])) {
                pr[i + 1][j]++;
            }
        }
    }
    while (q--) {
        int x, y, ans = 0;
        cin >> x >> y; x--;
        for (int i = 0; i < cnt; i++) {
            if (x + f[i] > y) {
                break;
            }
            ans += pr[y - f[i] + 1][i] - pr[x][i];
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(100);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}