#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;

int n, m;
string t;
int k;

const int N = 500010;
const int K = 50010;
string s[N];

vector <int> f[4 * K];

void add(int i, int l, int r, int q, int v)
{
	f[i].push_back(v);

	if (l + 1 == r) return;
	int m = (l + r) >> 1;
	if (q < m) add(2 * i + 1, l, m, q, v);
	else add(2 * i + 2, m, r, q, v);
}

void build(int i, int l, int r)
{
	sort(f[i].begin(), f[i].end());

	if (l + 1 == r) return;
	int m = (l + r) >> 1;
	build(2 * i + 1, l, m);
	build(2 * i + 2, m, r);
}

int gt(int i, int l, int r, int ql, int qr, int ls)
{
	if (qr <= l || r <= ql) return 0;
	if (ql <= l && r <= qr) return upper_bound(f[i].begin(), f[i].end(), ls) - f[i].begin();

	int m = (l + r) >> 1;
	return gt(2 * i + 1, l, m, ql, qr, ls) +
		gt(2 * i + 2, m, r, ql, qr, ls);
}

const int MOD1 = 1000000007;
const int MOD2 = 1000000009;
const int P1 = 913373;
const int P2 = 311;

int po1[K];
int po2[K];

pair <int, int> hs[K];

pair <int, int> gt(int l, int r)
{
	int len = r - l + 1;
	return make_pair(
		(hs[r].first + MOD1 - (ll)hs[l - 1].first * po1[len] % MOD1) % MOD1,
		(hs[r].second + MOD2 - (ll)hs[l - 1].second * po2[len] % MOD2) % MOD2
	);
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	po1[0] = po2[0] = 1;

	for (int i = 1; i < K; ++i)
	{
		po1[i] = (ll)po1[i - 1] * P1 % MOD1;
		po2[i] = (ll)po2[i - 1] * P2 % MOD2;
	}

	cin >> n >> m;
	cin >> t;
	k = t.size();
	t = ' ' + t + ' ';

	for (int i = 1; i <= k; ++i)
	{
		hs[i].first = ((ll)hs[i - 1].first * P1 % MOD1 + t[i]) % MOD1;
		hs[i].second = ((ll)hs[i - 1].second * P2 % MOD2 + t[i]) % MOD2;
	}

	for (int i = 1; i <= n; ++i)
	{
		cin >> s[i];

		pair <int, int> ha = { 0, 0 };
		for (auto c : s[i])
		{
			ha.first = ((ll)ha.first * P1 % MOD1 + c) % MOD1;
			ha.second = ((ll)ha.second * P2 % MOD2 + c) % MOD2;
		}

		for (int j = 1; j + s[i].size() - 1 <= k; ++j)
		{
			if (gt(j, j + s[i].size() - 1) == ha)
			{
				//cout << j << ' ' << j + s[i].size() - 1 << endl;
				add(0, 1, k + 1, j, j + s[i].size() - 1);
			}
		}
	}

	build(0, 1, k + 1);

	while (m--)
	{
		int l, r;
		cin >> l >> r;

		auto got = gt(0, 1, k + 1, l, k + 1, r);
		cout << got << ' ';
	}

	return 0;
}