#include <iostream>
#include <utility>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;


const ll P = 29, MOD = 1e9 + 7;

ll summ(ll a, ll b, ll m){
    if(a + b > m)
        return a + b - m;
    return a + b;
}

ll get_minus(ll a, ll b, ll m){
    if (a < b)
        return a - b + m;
    return a - b;
}

ll product(ll a, ll b, ll m){
    return a * b % m;
}

struct Hash{
    vector<ll> h, powers;

    void build(string& s){
        int n = s.length();

        powers.push_back(1);
        h.push_back(0);


        for(int j = 0; j < n; j++){
            powers.push_back(product(powers.back(), P, MOD));
        }

        for(int j = 0; j < n; j++){
            ll sym = s[j] - 'a' + 1;
            h.push_back(summ(product(h.back(), P, MOD), sym,MOD));
        }
    }

    ll get_sub(int l, int r){
        l--;
//        for(auto i : h)
//            cout<< i << ' ';
//        cout<<"\n";
        return get_minus(h[r], product(h[l], powers[r - l], MOD), MOD);
    }
};

void solve(){

}

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    Hash hs;
    hs.build(s);
    int s_len = s.length();
    vector<vector<int>> dp(s.length(), vector<int>(s.length()));
    for(int i = 0;  i< n; i++){
        string ti;
        cin >> ti;
        ll hash_t = 0;
        int len = ti.length();
        for(int j = 0; j < len; j++){
            ll sym = ti[j] - 'a' + 1;
            hash_t = summ(product(hash_t, P, MOD), sym, MOD);
        }

        for(int j = 1; j + len - 1 <= s_len; j++){
           // cout<<hash_t << ' ' << hs.get_sub(j, j + len - 1) << "\n";
           //cout<<s.substr(j - 1, len) << "\n"
                                         "";
            if(hash_t == hs.get_sub(j, j + len - 1)){
                dp[j - 1][j + len - 2]++;
            }
        }
       // cout<<"\n";
    }
    for(int j = 0; j < s.length(); j++){
        for(int i = j - 1; i > -1; i--){
            dp[i][j] += dp[i + 1][j];
            dp[i][j] += dp[i][j - 1];
            dp[i][j] -= dp[i + 1][j - 1];
        }
    }

    while(m--){
        int l, r;
        cin >> l >> r;
        l--, r--;
        cout<<dp[l][r]<<" ";
    }
    return 0;
}