#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

// #define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

struct BIT {
    int size;
    vector<int> t;

    int get(int ind) {
        int res = 0;
        for (int i = ind; i >= 0; i &= i + 1, --i) {
            res += t[i];
        }
        return res;
    }

    void add(int ind, int val) {
        for (int i = ind; i < size; i |= i + 1) {
            t[i] += val;
        }
    }

    BIT(int n) : size(n), t(size) {}
};

const int MOD = 1'000'000'007;
const int P = 289;

int add(int x, int y) {
    return (x + y) % MOD;
}

int sub(int x, int y) {
    return (x - y + MOD) % MOD;
}

int mul(int x, int y) {
    return int64_t(x) * y % MOD;
}

struct Hasher {
    int size;
    vector<int> p;
    vector<int> h;

    int get(int l, int r) {
        return sub(h[r], mul(h[l], p[r - l]));
    }

    Hasher() = default;
    explicit Hasher(const string& s) : size(s.size() + 1), p(size), h(size) {
        p[0] = 1;
        for (int i = 0; i < size - 1; ++i) {
            p[i + 1] = mul(p[i], P);
            h[i + 1] = add(s[i], mul(h[i], P));
        }
    }
};

void solve() {
    int n, q;
    cin >> n >> q;

    string t;
    cin >> t;

    int m = sz(t);

    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    Hasher ht(t);

    vector<vector<int>> occ(m);
    for (int i = 0; i < n; ++i) {
        int hs = 0;
        for (char c : s[i]) {
            hs = add(c, mul(hs, P));
        }
        for (int j = 0; j + sz(s[i]) <= m; ++j) {
            if (ht.get(j, j + sz(s[i])) == hs) {
                occ[j].push_back(j + sz(s[i]) - 1);
            }
        }
    }

    vector<int> ans(q);

    vector<vector<pair<int, int>>> iq(m), rq(m);
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        iq[l].emplace_back(r, i);
        rq[r].emplace_back(r, i);
    }

    BIT tree(m);
    for (int i = 0; i < m; ++i) {
        for (auto [r, ind] : iq[i]) {
            ans[ind] -= tree.get(r);
        }
        for (int r : occ[i]) {
            tree.add(r, 1);
        }
        for (auto [r, ind] : rq[i]) {
            ans[ind] += tree.get(r);
        }
    }

    for (int x : ans) {
        cout << x << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}