#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

struct Query{
    int l, r, i;
};

string t;
vector<Query> q;
vector<string> s;
vector<vector<pair<int, int> > > qu;
vector<int> f[2], ans;

void inc(int pos, int who){
    for(; pos < sz(t); pos |= pos + 1)
        f[who][pos] ++;
}

int sum(int pos, int who){
    int ans = 0;
    for(; pos >= 0; pos = (pos & (pos + 1)) - 1)
        ans += f[who][pos];
    return ans;
}


main(){
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);

    int n, m;
    cin >> n >> m;
    s.resize(n);
    q.resize(m);
    ans.resize(m);
    cin >> t;
    f[0].resize(sz(t));
    f[1].resize(sz(t));
    qu.resize(sz(t));
    for(int i = 0; i < n; i ++)
        cin >> s[i];
    for(int i = 0; i < m; i ++){
        cin >> q[i].l >> q[i].r;
        q[i].l --; q[i].r --;
        q[i].i = i;
        qu[q[i].r].push_back({q[i].l, q[i].i});
    }

    vector<string> now(n);
    vector<vector<int> > p(n);
    for(int j = 0; j < n; j ++){
        now[j] = s[j] + "." + t;
        p[j].resize(sz(now[j]));
        for(int i = 1; i < sz(s[j]) + 1; i ++){
            int prev = p[j][i - 1];
            while(prev > 0 && now[j][prev] != now[j][i])
                prev = p[j][prev - 1];
            if (now[j][i] == now[j][prev])
                p[j][i] = prev + 1;
        }
    }

    for(int border = 0; border < sz(t); border ++){
        for(int j = 0; j < n; j ++){
            int i = sz(s[j]) + 1 + border;
            int prev = p[j][i - 1];
            while(prev > 0 && now[j][prev] != now[j][i])
                prev = p[j][prev - 1];
            if (now[j][i] == now[j][prev])
                p[j][i] = prev + 1;
            if (p[j][i] == sz(s[j])){
                int pos = i - sz(s[j]) - 1;
                inc(pos - sz(s[j]) + 1, 0);
                inc(pos, 1);
            }
        }

        for(auto query : qu[border]){
            int l = query.first, r = border;
            int ans_now = sum(r, 1) - (l > 0 ? sum(l - 1, 0) : 0);
            ans[query.second] = ans_now;
        }
    }


//    for(int i = 0; i < m; i ++){
//        int l = q[i].l, r = q[i].r;
//        int ans = sum(r, 1) - (l > 0 ? sum(l - 1, 0) : 0);
//        cout << ans << ' ';
//    }


    for(int i = 0; i < m; i ++)
        cout << ans[i] << ' ';
}

/*
5 5
aaaaa
a
aa
aaa
aaaa
aaaaa
1 5
2 4
3 3
2 5
4 5
*/
