#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500100;
const ll mod = 1e9 + 7;
const int k = 26;

int len[sz];
vector <int> pos[sz];

struct node {
	node() : term(false), long_suf(nullptr) {
		fill(suf, suf + k, nullptr);
	}
	bool term;
	node* suf[k];
	node* long_suf;
	node* pr;
	int it;
};

int main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	node* root = new node;
	root->term = true;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		len[i] = s.size();
		node* crt = root;
		for (int j = 0; j < len[i]; ++j) {
			int c = s[j] - 'a';
			if (crt->suf[c] == nullptr) {
				crt->suf[c] = new node();
				crt->suf[c]->pr = crt;
			}
			crt = crt->suf[c];
		}
		crt->term = true;
		crt->it = i;
	}
	queue <node*> q;
	root->pr = nullptr;
	root->long_suf = nullptr;
	for (int i = 0; i < k; ++i) {
		if (root->suf[i] == nullptr) {
			root->suf[i] = root;
		}
		else {
			q.push(root->suf[i]);
		}
	}
	while (!q.empty()) {
		node* p = q.front();
		q.pop();
		for (int i = 0; i < k; ++i) {
			if (p->suf[i] != nullptr) {
				q.push(p->suf[i]);
				p->suf[i]->pr = p->pr->suf[i];
			}
			else {
				p->suf[i] = p->pr->suf[i];
			}
		}
		if (p->pr->term) {
			p->long_suf = p->pr;
		}
		else {
			p->long_suf = p->pr->long_suf;
		}
	}
	node* crt = root;
	for (int i = 0; i < t.size(); ++i) {
		int c = t[i] - 'a';
		crt = crt->suf[c];
		if (crt->term) {
			pos[crt->it].push_back(i);
		}
		node* tmp = crt->long_suf;
		while (tmp->long_suf != nullptr) {
			pos[tmp->it].push_back(i);
			tmp = tmp->long_suf;
		}
	}
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		--l;
		--r;
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			for (int u : pos[i]) {
				if (u > r) break;
				if (u - len[i] + 1 >= l) ++ans;
			}
		}
		cout << ans << ' ';
	}
} 