#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

//#define int long long

void solve() {
	int n, m; cin >> n >> m;
	string s; cin >> s;

	uint64 p0 = 257;
	vector <uint64> pw(s.size() + 1, 1);
	for (int i = 1; i < pw.size(); ++i) {
		pw[i] = pw[i - 1] * p0;
	}

	vector <uint64> hs(s.size() + 1, 0);
	for (int i = 1; i < hs.size(); ++i) {
		hs[i] = hs[i - 1] * p0 + s[i - 1];
	}

	auto getHs = [&](int l, int r) {
		return hs[r] - hs[l] * pw[r - l];
	};


	unordered_set <uint64> st;
	vector <int> ln;
	for (int i = 0; i < n; ++i) {
		string t; cin >> t;
		ln.push_back(t.size());
		uint64 chs = 0;
		for (int i = 0; i < t.size(); ++i) {
			chs = chs * p0 + t[i];
		}
		st.insert(chs);
	}
	sort(all(ln));
	ln.resize(unique(all(ln)) - ln.begin());

	while (m--) {
		int l, r; cin >> l >> r;
		--l;
		int ans = 0;
		for (auto len : ln) {
			for (int i = l; i + len <= r; ++i) {
				ans += st.count(getHs(i, i + len));
			}
		}

		cout << ans << '\n';
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}