#include <iostream>
#include <vector>
#include <random>
#include <set>

#define int long long
typedef long  long ll;
using namespace std;

int p = 257, k = 1e9 + 7; // или плюс 3

void set_pows(vector<int> & pows) {
    pows[0] = 1;
    for (int i = 1; i < pows.size(); i++) {
        pows[i] = (pows[i - 1] * p) % k;
    }
}

void set_hash(vector<int> & hash, string & s) {
    for (int i = 1; i < s.size() + 1; i++) {
        hash[i] = (hash[i - 1] * p + (s[i - 1] - 'a' + 1)) % k;
    }
}

int sub_hash(int l, int r, vector<int> & hash, vector<int> &pows) {
    return (hash[r + 1] + k - (hash[l] * pows[r - l + 1]) % k) % k;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<int> pows(t.size() + 1), t_hash(t.size() + 1);
    set_pows(pows);
    set_hash(t_hash, t);

    vector<vector<int>> v(n);
    vector<int> lens(n);

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        lens[i] = s.size();

        if (s.size() > t.size()) {
            continue;
        }
        vector<int> s_hash(s.size() + 1);
        set_hash(s_hash, s);
//        cout << " : " << s_hash[s.size() - 1] << endl;
        for (int j = 0; j < t.size() - s.size() + 1; j++) {
//            cout << i << " " << j << " " << sub_hash(j, j + s.size() - 1, t_hash, pows) << endl;
            if (sub_hash(j, j + s.size() - 1, t_hash, pows) == sub_hash(0, s.size() - 1, s_hash, pows)) {
                v[i].push_back(j);
            }
        }
    }

//    for (int i = 0; i < n; i++) {
//        for (int j : v[i]) {
//            cout << j << " ";
//        }
//        cout << endl;
//    }
//    cout << endl;

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            if (!v[j].size()) continue;
            int ind1 = lower_bound(v[j].begin(), v[j].end(), l) - v[j].begin();
            int ind2 = upper_bound(v[j].begin(), v[j].end(), r - lens[j] + 1) - v[j].begin();
            int k = v[j][ind1];
            if (l <= k && k + lens[j] - 1 <= r) {
                ans += ind2 - ind1;
            }
        }
        cout << ans << endl;
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
//
//vect a.x * b.y - b.x * a.y
//scal a.x * b.x + a.y * b.y
