#include <bits/stdc++.h>

//#define _GLIBCXX_DEBUG

#define GCC optimize("O3")
#define GCC optimize("Ofast")
//#define GCC optimize("unroll-loops")
#define GCC target("avx2")

//#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using namespace std;

const int k = 2;
int M[k] = {(int)1e9 + 7, (int)1e9 + 9};

struct Hash {
    int h[k];

    Hash(int x = 0) {
        for (int i = 0; i < k; ++i) {
            h[i] = x % M[i];
        }
    }

    Hash operator+(Hash other) {
        Hash res;
        for (int i = 0; i < k; ++i) {
            res.h[i] = h[i] + other.h[i];
            if (res.h[i] >= M[i]) res.h[i] -= M[i];
        }
        return res;
    }

    Hash operator-(Hash other) {
        Hash res;
        for (int i = 0; i < k; ++i) {
            res.h[i] = h[i] - other.h[i];
            if (res.h[i] < 0) res.h[i] += M[i];
        }
        return res;
    }

    Hash operator*(Hash other) {
        Hash res;
        for (int i = 0; i < k; ++i) {
            res.h[i] = (ll)h[i] * other.h[i] % M[i];
        }
        return res;
    }

    bool operator<(Hash other) {
        for (int i = 0; i < k; ++i) {
            if (h[i] < other.h[i]) return true;
            if (h[i] > other.h[i]) return false;
        }
        return false;
    }
};

ll HashFunc(const Hash &other) {
    return ((ll)other.h[0] << 30ll) + other.h[1];
}

Hash p(31);

vector<Hash> pr, s;

Hash get(int l, int r) {
    return s[r] - s[l - 1] * pr[r - l + 1];
}

const int N = 100010;
ll f[N];

ll sum(int r) {
    ll res = 0;
    for (; r > 0; r -= (r & -r)) {
        res += f[r];
    }
    return res;
}

ll sum(int l, int r) {
    return sum(r) - sum(l - 1);
}

void update(int i, int val) {
    for (; i < N; i += (i & -i)) {
        f[i] += val;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    string t;
    cin >> n >> m >> t;
    pr.resize(N, Hash(1));
    for (int i = 1; i < N; ++i) {
        pr[i] = pr[i - 1] * p;
    }
    unordered_set<ll> now;
    now.reserve(n);
    for (int i = 0; i < n; ++i) {
        string cur;
        cin >> cur;
        int len = sz(cur);
        Hash temp(0);
        for (int j = 0; j < len; ++j) {
            temp = temp * p + (cur[j] - 'a' + 1);
        }
        now.insert(HashFunc(temp));
    }
    int len = sz(t);
    s.resize(len + 1, Hash(0));
    for (int i = 1; i <= len; ++i) {
        s[i] = s[i - 1] * p + (t[i - 1] - 'a' + 1);
    }
    vector<tuple<int, int, int, int>> events;
    events.reserve(N);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        events.emplace_back(r, 1, i, l);
    }
    for (int i = 1; i <= len; ++i) {
        for (int j = i; j <= len; ++j) {
            if (now.find(HashFunc(get(i, j))) != now.end()) {
                events.emplace_back(j, 0, -1, i);
            }
        }
    }
    sort(all(events));
    vector<ll> ans(m);
    for (auto &[pos, type, index, left]: events) {
        if (type) {
            ans[index] = sum(left, pos);
        } else {
            update(left, 1);
        }
    }
    for (ll &i: ans) cout << i << ' ';
    return 0;
}