#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 5000 + 10;
const llong INF = 1e18;

int n, q, l;
int f[MAXN];
int lenn[MAXN];
int cnt[MAXN][MAXN];
void match(char t[], char s[], int len)
{
    std::fill(f + 1, f + 1 + len, 0);
    for (int i = 2 ; i <= len ; ++i)
    {
        int last = i - 1;
        while (last >= 1 && s[f[last] + 1] != s[i])
        {
            last = f[last];
        }
        
        if (last == 0) f[i] = 0;
        else f[i] = f[last] + 1;
    }

    int where = 0;
    for (int i = 1 ; i <= l ; ++i)
    {
        int last = where;
        while (last >= 1 && s[last + 1] != t[i])
        {
            last = f[last];
        }
        
        where = last + (s[last + 1] == t[i]);
        if (where == len)
        {
            cnt[i - len + 1][i]++;
            where = 0;
        }
    }
}

int prefix[MAXN][MAXN];
char s[MAXN][MAXN];
char t[MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        match(t, s[i], lenn[i]);
    }

    for (int i = 1 ; i <= l ; ++i)
    {
        for (int j = 1 ; j <= l ; ++j)
        {
            prefix[i][j] = cnt[i][j] + prefix[i - 1][j] + prefix[i][j - 1] - prefix[i - 1][j - 1];
        }
    }

    int l, r;
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> l >> r; l--;
        std::cout << prefix[r][r] - prefix[l][r] - prefix[r][l] + prefix[l][l] << ' ';
    }

    std::cout << '\n';
}

char s2[MAXN];
void input()
{
    std::cin >> n >> q;
    std::cin >> s2; l = strlen(s2);
    for (int j = 1 ; j <= l + 1 ; ++j) t[j] = s2[j - 1];
    for (int i = 1 ; i <= n ; ++i)
    {
        int l2;
        std::cin >> s2; l2 = strlen(s2);
        for (int j = 1 ; j <= l2 + 1 ; ++j) s[i][j] = s2[j - 1];
        lenn[i] = l2;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}