#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, mod2 = 228228227, maxn = 1e6 + 1;

int only_hash(string &s, ll M) {
	ll h = s[0] - 'a' + 1, x = 31;
	for (int i = 1; i < sz(s); ++i) {
		h = ((h * x) % M + (s[i] - 'a' + 1)) % M;
	}
	return h;
}

struct HASH {
	vector<ll> h, p;
	ll M;

	void build(string &s, ll MOD) {
		ll n = sz(s), x = 31;
		M = MOD;
		h.resize(n), p.resize(n);
		p[0] = 1, h[0] = s[0] - 'a' + 1;
		for (int i = 1; i < n; ++i) {
			h[i] = (h[i - 1] * x % M + (s[i] - 'a' + 1)) % M;
			p[i] = (p[i - 1] * x) % M;
		}
	}

	int get(int l, int r) {
		if (l < 0 || r >= sz(h) || l > r)return 0;
		if (l == 0)return h[r];
		return (h[r] - (h[l - 1] * p[r - l + 1]) % M + M) % M;
	}
};

vector<vector<int>> L;
vector<set<pii>> LEN;
set<pii > ex[maxn];
int n, N, M;
vector<vector<int>> tr;

void merge(int v) {
	int v1 = v * 2, v2 = v1 + 1;
	int i1 = 0, i2 = 0;
	int n1 = sz(tr[v1]), n2 = sz(tr[v2]);
	while (i1 < n1 && i2 < n2) {
		if (tr[v1][i1] < tr[v2][i2]) tr[v].push_back(tr[v1][i1++]);
		else tr[v].push_back(tr[v2][i2++]);
	}
	while (i1 < n1)tr[v].push_back(tr[v1][i1++]);
	while (i2 < n2)tr[v].push_back(tr[v2][i2++]);
}

void build() {
	N = 1;
	while (N <= M) N *= 2;
	tr.resize(2 * N);
	for (int i = 0; i < M; ++i) {
		tr[i + N] = L[i];
	}
	for (int i = N - 1; i > 0; --i) {
		merge(i);
	}
}

int get(int lq, int rq, int x, int v = 1, int l = 0, int r = N) {
	if (rq <= l || r <= lq)return 0;
	if (lq <= l && r <= rq)return upper_bound(all(tr[v]), x) - tr[v].begin();
	int m = (l + r) / 2;
	return get(lq, rq, x, v * 2, l, m) + get(lq, rq, x, v * 2 + 1, m, r);
}

void solve() {
	int q, m;
	string t;
	cin >> n >> q >> t, m = sz(t);
	M = m;
	vector<string> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		ex[sz(a[i])].insert({only_hash(a[i], mod), only_hash(a[i], mod2)});
	}
	HASH T, T2;
	T.build(t, mod);
	T2.build(t, mod2);
	vector<int> all;
	for (int nn = 1; nn < maxn; ++nn) {
		if (ex[nn].empty())continue;
		all.push_back(nn);
		LEN.push_back(ex[nn]);
	}

	L.resize(m);
	int ind = 0;
	for (int len: all) {
		for (int i = 0; i + len - 1 < m; ++i) {
			int f = T.get(i, i + len - 1);
			int f2 = T2.get(i, i + len - 1);
			if (LEN[ind].find({f, f2}) != LEN[ind].end()) L[i].push_back(i + len - 1);
		}
		ind++;
	}
	build();
	while (q--) {
		int l, r;
		cin >> l >> r, l--, r--;
		cout << get(l, r + 1, r) << ' ';
	}
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
