#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>
#define int ll

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

struct edge {
    int term;
    vec<int> to;

    edge() {
        to = vec<int>(26, -1);
        term = 0;
    }
};

vec<edge> trie;
string t;
vec<vec<int>> qwe;

void add(string s) {
    int v = 0;
    for (char c : s) {
        if (trie[v].to[c - 'a'] == -1) {
            trie[v].to[c - 'a'] = (int)trie.size();
            trie.emplace_back();
        }
        v = trie[v].to[c - 'a'];
    }
    trie[v].term++;
}

void dosth(int i) {
    int v = 0;
    for (int j = i; j < t.size(); j++) {
        if (trie[v].to[t[j] - 'a'] == -1) {
            break;
        }
        v = trie[v].to[t[j] - 'a'];
        if (trie[v].term) {
            qwe.push_back({ i, j, trie[v].term });
        }
    }
}

void solve() {
    trie.emplace_back();
    int n, m; cin >> n >> m;
    cin >> t;
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        add(s);
    }
    for (int i = 0; i < t.size(); i++) {
        dosth(i);
    }
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        a--;
        b--;
        int ans = 0;
        for (int j = 0; j < qwe.size(); j++) {
            if (a <= qwe[j][0] && qwe[j][1] <= b) {
                ans += qwe[j][2];
            }
        }
        cout << ans << '\n';
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
    #endif // _DEBUG

    int tests = 1;
    //cin >> tests;

    while (tests--) {
        solve();
    }
}