#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

//#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

#pragma GCC optimize("O3") // O3 maybe
#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

const int infll = 1e18;

const int N = 5e3 + 10;

const int mod = 1e9 + 9;

int add (int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int sub (int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

int base = 179;

const int K = 1e4 + 10;

struct Hasher {
    int n;
    int init (string &s) {
        int h = 0;
        for (int i = 0; i < sz(s); i++) {
            h = add(mul(base, h), s[i]);
        }
        return h;
    }
};

gp_hash_table<int, int> table[K];
bool good[N][N];

signed dp[N][N];
bool used[N][N];

void count_dp (int l, int r) {
    if (used[l][r]) return;
    used[l][r] = true;
    if (l > r) return;
    if (l == r) {
        if (good[l][r]) dp[l][r]++;
        return;
    }
    count_dp(l + 1, r);
    count_dp(l, r - 1);
    count_dp(l + 1, r - 1);
    dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1];
    dp[l][r] += good[l][r];
}

void solve_stupid (int n, int m, string &t) {
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        if (sz(s[i]) > sz(t)) continue;
        Hasher x;
        table[sz(s[i])][x.init(s[i])]++;
    }
    for (int i = 0; i < sz(t); i++) {
        int cur = 0;
        for (int j = i; j < sz(t); j++) {
            cur = add(mul(cur, base), t[j]);
            good[i][j] = (table[j - i + 1][cur] > 0);
        }
    }
    count_dp(0, sz(t) - 1);
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;r--;
        cout << dp[l][r] << "\n";
    }
}

struct Hasher2 {
    vector<int> h;
    vector<int> p;
    int n;
    void init (string &s) {
        n = sz(s);
        h.assign(n + 1, 0);
        p.assign(n + 1, 1);
        for (int i = 0; i < n; i++) {
            h[i + 1] = add(mul(base, h[i]), s[i]);
            p[i + 1] = mul(p[i], base);
        }
    }
    int get (int l, int r) {
        return sub(h[r + 1], mul(p[r - l + 1], h[l]));
    }
};

struct Fenwick {
    vector<int> t;
    int n;
    void init (int k) {
        n = k + 10;
        t.assign(n + 10, 0);
    }
    void add (int k, int x) {
        for (; k <= n; k += k & -k) {
            t[k] += x;
        }
    }
    int sum (int x) {
        int ans = 0;
        for (; x > 0; x -= x & -x) {
            ans += t[x];
        }
        return ans;
    }
    int sum (int l, int r) {
        return sum(r) - sum(l - 1);
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
#ifndef home
    if (n <= 5000 && sz(t) <= 5000) {
        solve_stupid(n, m);
        return;
    }
#endif
    Hasher2 h;
    string t;
    cin >> t;
    h.init(t);
    vector<string> s(n);
    vector<vector<int>> good(sz(t));
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        if (sz(s[i]) > sz(t)) continue;
        Hasher x;
        int H = x.init(s[i]);
        for (int j = 0; j < sz(t) - sz(s[i]) + 1; j++) {
            if (h.get(j, j + sz(s[i]) - 1) == H) {
                good[j + sz(s[i]) - 1].push_back(j);
            }
        }
    }
    vector<vector<vector<int>>> Query (sz(t));
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;r--;
        Query[r].push_back({l, i});
    }
    Fenwick f;
    f.init(sz(t) + 10);
    vector<int> ans(m, 0);
    for (int i = 0; i < sz(t); i++) {
        for (int j = 0; j < sz(good[i]); j++) {
            f.add(good[i][j] + 1, 1);
        }
        for (auto v : Query[i]) {
            ans[v[1]] = f.sum(v[0] + 1, i + 1);
        }
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << " ";
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//   cin >> t;
    while (t--)
        solve();
}
/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */