#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b,int m) {
    return ((ll)a * b) % m;
}

int add(int a, int b,int m) {
    if (a + b >= m) return a + b - m;
    return a + b;
}
const int base = 31;
int get_hash(vector<int> a, int m) {
    int ans = 0;
    for (int i = 0; i < a.size(); i++) {
        ans = mul(ans, base, m);
        ans = add(ans, a[i], m);
    }
    return ans;
}
struct hashes {
    vector<int> pref;
    vector<int> power;
    void init(vector<int> a,int m) {
        int n = a.size();
        pref = vector<int>(n + 1);
        power = vector<int>(n + 1);
        power[0] = 1;
        for (int i = 0; i < a.size(); i++) {
            pref[i + 1] = (pref[i] * base) % m;
            pref[i + 1] = add(pref[i + 1], a[i], m);
            power[i + 1] = mul(power[i], base, m);
        }
    }
    int get_hash(int l, int r,int m) {
        int right = pref[r], left = pref[l];
        left = mul(left, power[r - l], m);
        return (right - left + m) % m;
    }
};
void solve() {
    int n, m;
    cin >> n >> m;
    string t; cin >> t;
    hashes hash_st, hash_st_9;
    vector<int> st;
    for (int i = 0; i < t.size(); i++) st.pb(t[i] - 96);
    hash_st.init(st,mod);
    hash_st_9.init(st, mod9);
    set<pair<int,int> > all_hashes;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        vector<int> a;
        for (int j = 0; j < s.size(); j++) {
            a.pb(s[j] - 96);
        }
        all_hashes.insert({ get_hash(a, mod),get_hash(a,mod9) });
    }
    int t_sz = t.size();
    vector<vector<int> > pos(t_sz);
    for (int i = 0; i < t_sz; i++) {
        for (int j = i; j < t_sz; j++) {
            int cur = hash_st.get_hash(i, j + 1,mod);
            int cur_9 = hash_st_9.get_hash(i, j + 1, mod9);
            if (all_hashes.count({ cur,cur_9 })) {
                pos[i].pb(j);
            }
        }
    }
    /*
    for (auto c : pos) {
        for (auto x : c) {
            cout << x << " ";
        }
        cout << endl;
    }
    */
    vector<int> all_ans;
    for (int it = 0; it < m; it++) {
        int l, r, ans = 0;
        cin >> l >> r;
        l--; r--;
        for (int j = l; j <= r; j++) {
            auto c = upper_bound(pos[j].begin(), pos[j].end(), r) - pos[j].begin();
            ans += c;
        } 
        all_ans.pb(ans);
    }
    for (auto c : all_ans) cout << c << " ";

}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}