#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 1e6 + 10;
const int MAXT = 5005;
const int MAXT2 = 50005;
const int BASE = 31;
const db eps = 1e-9;

struct Node {
    signed go[26];
    signed cntEnd;
};

int borSz = 1;
Node bor[MAXL];

void insertToBor(string s) {
    int v = 0;
    for (auto c : s) {
        if (bor[v].go[c - 'a'] != 0) {
            v = bor[v].go[c - 'a'];
        } else {
            bor[v].go[c - 'a'] = borSz;
            v = bor[v].go[c - 'a'];
            borSz++;
        }
    }
    bor[v].cntEnd++;
}

signed f[MAXT][MAXT]; // all in 1 numer

int getPref(int x, int y) {
    int ans = 0;
    for (int i = x; i > 0; i -= i & -i) {
        for (int j = y; j > 0; j -= j & -j) {
            ans += f[i][j];
        }
    }
    return ans;
}

void add(int x, int y, int c) {
    for (int i = x; i < MAXT; i += i & -i) {
        for (int j = y; j < MAXT; j += j & -j) {
            f[i][j] += c;
        }
    }
}

int getSum(int x1, int y1, int x2, int y2) {
    return getPref(x2, y2) - getPref(x1 - 1, y2) - getPref(x2, y1 - 1) + getPref(x1 - 1, y1 - 1);
}

int st[MAXT2 + 5];
int ht[MAXT2];
signed pref[105][MAXT2 + 5];

int getSub(int l, int r) { // 0-numer [l..r]
    return (((ht[r + 1] - ht[l] + MOD) % MOD) * st[MAXT2 - r]) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m; cin >> n >> m;
    string t; cin >> t;
    if (t.size() <= MAXT) {
        for (int i = 0; i < n; ++i) {
            string s;
            cin >> s;
            insertToBor(s);
        }
        for (int i = 0; i < (int) t.size(); ++i) {
            int v = 0;
            for (int j = i; j < (int) t.size(); ++j) {
                if (bor[v].go[t[j] - 'a'] == 0) break;
                v = bor[v].go[t[j] - 'a'];
                if (bor[v].cntEnd) {
                    add(i + 1, j + 1, 1);
                }
            }
        }
        for (int _ = 0; _ < m; ++_) {
            int l, r;
            cin >> l >> r;
            int ans = getSum(l, l, r, r);
            cout << ans << ' ';
        }
        return 0;
    }
    vector<string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    st[0] = 1;
    for (int i = 1; i < MAXT2 + 5; ++i) {
        st[i] = (st[i - 1] * BASE) % MOD;
    }
    ht[0] = 0;
    for (int i = 0; i < t.size(); ++i) {
        ht[i + 1] = (ht[i] + ((t[i] - 'a' + 1) * st[i]) % MOD) % MOD;
    }
    vector<int> hs(n);
    for (int i = 0; i < n; ++i) {
        int h = 0;
        for (int j = 0; j < a[i].size(); ++j) {
            h += ((a[i][j] - 'a' + 1) * st[j]) % MOD;
            h %= MOD;
        }
        h *= st[MAXT2 - (a[i].size() - 1)];
        h %= MOD;
        hs[i] = h;
    }
    vector<vector<signed>> ins(n);
    for (int i = 0; i < n; ++i) {
        for (int l = 0; l <= (int)t.size() - (int)a[i].size(); ++l) {
            if (hs[i] == getSub(l, l + a[i].size() - 1)) {
                ins[i].push_back(l + 1);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        int u = 0, now = 0;
        for (int j = 0; j < MAXT2; ++j) {
            if (u < ins[i].size() && ins[i][u] == j) {
                now++;
                u++;
            }
            pref[i][j] = now;
        }
    }
    for (int _ = 0; _ < m; ++_) {
        int l, r; cin >> l >> r;
        int ans = 0, len = r - l + 1;
        for (int i = 0; i < n; ++i) {
            if (len < a[i].size()) continue;
            if (l + (len - a[i].size()) < 0 || l + (len - a[i].size()) >= MAXT2) continue;
            ans += pref[i][l + (len - a[i].size())] - pref[i][l - 1];
//            auto it1 = lower_bound(all(ins[i]), l);
//            auto it2 = upper_bound(all(ins[i]), l + (len - a[i].size()));
//            ans += it2 - it1;
        }
        cout << ans << ' ';
    }
    return 0;
}