#include <bits/stdc++.h>
typedef long long ll;

using namespace std;

const ll MOD = 1791791791, P = 239, SIZE_T = 1e5 + 7, SIZE_S = 1e5 + 7, K = 6;

ll hash_t[SIZE_T], pows[SIZE_T];

ll get_lr(int l, int r) {
    return (hash_t[r] - hash_t[l] * pows[r - l] % MOD + MOD) % MOD;
}

struct req {
    int type, x, ind, y;

    bool operator<(req a) {
        if (x == a.x) return type < a.type;
        return x < a.x;
    }
};

int t_f[SIZE_T];

int getr(int r) {
    int res = 0;
    for (; r > 0; r -= r & -r) res += t_f[r];
    return res;
}

void add(int ind, int val) {
    for (; ind < SIZE_T; ind += ind & -ind) t_f[ind] += val;
}

unordered_map<ll, vector<int>> flex;

signed main() {
    pows[0] = 1;
    for (int i = 1; i < SIZE_T; ++i) {
        pows[i] = pows[i - 1] * P % MOD;
    }
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    if (t.size() > 50000) {
        vector<string> all(n);
        vector<ll> all_h(n);
        vector<vector<int>> inds(SIZE_S);
        for (int i = 0; i < n; ++i) cin >> all[i], inds[all[i].size()].push_back(i);
        for (int i = 0; i < n; ++i) {
            for (char j: all[i]) {
                all_h[i] = (all_h[i] * P % MOD + j - 'a' + 7) % MOD;
            }
        }

        for (int i = 0; i < t.size(); ++i) {
            hash_t[i + 1] = (hash_t[i] * P % MOD + t[i] - 'a' + 7) % MOD;
        }
        vector<req> ufo;
        vector<req> w;
        vector<int> ans(m);
        for (int i = 0; i < m; ++i) {
            int l, r;
            cin >> l >> r, l--;
            w.push_back({-1, l, i, r});
            w.push_back({1, r - 1, i, r});
        }
        for (int k = 0; k < K; ++k) {
            if (inds[k].empty()) continue;
            for (int i = 0; i + k <= t.size(); ++i) {
                flex[get_lr(i, i + k)].push_back(i);
            }
            ufo = w;
            for (auto i: inds[k]) {
                for (int x: flex[all_h[i]]) ufo.push_back({0, x, -1, x + k});
            }
            sort(ufo.begin(), ufo.end());
            for (auto x: ufo) {
                if (x.type == 0) {
                    add(x.y, 1);
                }
                if (x.type == -1) {
                    ans[x.ind] -= getr(x.y);
                }
                if (x.type == 1) {
                    ans[x.ind] += getr(x.y);
                }
            }

            flex.clear();
        }
        for (int k = K; k < SIZE_S; ++k) {
            if (inds[k].empty()) continue;
            ufo = w;
            for (auto i: inds[k]) {
                for (int j = 0; j + k <= t.size(); ++j) {
                    if (get_lr(j, j + k) == all_h[i]) ufo.push_back({0, j, -1, j + k});
                }
            }
            sort(ufo.begin(), ufo.end());
            for (auto x: ufo) {
                if (x.type == 0) {
                    add(x.y, 1);
                }
                if (x.type == -1) {
                    ans[x.ind] -= getr(x.y);
                }
                if (x.type == 1) {
                    ans[x.ind] += getr(x.y);
                }
            }
        }

        for (int i: ans) cout << i << " ";
        cout << endl;
    }
    else {
        vector<string> all(n);
        vector<long long> all_h(n);
        for (int i = 0; i < n; ++i) cin >> all[i];
        for (int i = 0; i < n; ++i) {
            for (char j : all[i]) {
                all_h[i] = (all_h[i] * P % MOD + j - 'a' + 7) % MOD;
            }
        }
        for (int i = 0; i < t.size(); ++i) {
            hash_t[i + 1] = (hash_t[i] * P % MOD + t[i] - 'a' + 7) % MOD;
        }
        vector<req> ufo;
        for (int i = 0; i < t.size(); ++i) {
            for (int j = 0; j < n; ++j) {
                if (i + all[j].size() > t.size()) continue;
                if (get_lr(i, i + all[j].size()) == all_h[j]) {
                    ufo.push_back({0, i, -1, i + (int)all[j].size()});
                }
            }
        }
        vector<int> ans(m);
        for (int i = 0; i < m; ++i) {
            int l, r;
            cin >> l >> r, l--;
            ufo.push_back({-1, l, i, r});
            ufo.push_back({1, r - 1, i, r});
        }
        sort(ufo.begin(), ufo.end());
        for (auto x : ufo) {
            if (x.type == 0) {
                add(x.y, 1);
            }
            if (x.type == -1) {
                ans[x.ind] = -getr(x.y);
            }
            if (x.type == 1) {
                ans[x.ind] += getr(x.y);
            }
        }
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}