#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;
using coor = int;

const int N = 1e6 + 5;
const ll MOD = 1e9 + 7;
const ll BASE = 13;

ll get_hash(string& s, vll& pw) {
	ll res = 0;
	for (int i = 0; i < s.size(); i++) {
		res = (res + (s[i] - 'a' + 1) * pw[i]) % MOD;
	}
	return res;
}

ll binpow(ll val, int q) {
	if (q == 0) {
		return 1;
	}
	if (q % 2) {
		return (val * binpow(val, q - 1)) % MOD;
	}
	return binpow((val * val) % MOD, q / 2);
}

void solve() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vll pw(N);
	pw[0] = 1;
	for (int i = 1; i < N; i++) {
		pw[i] = (pw[i - 1] * BASE) % MOD;
	}
	vll rpw(N);
	rpw[N - 1] = binpow(pw[N - 1], MOD - 2);
	for (int i = N - 2; i >= 0; i--) {
		rpw[i] = (rpw[i + 1] * BASE) % MOD;
	}
	vector<string> t(n);
	for (auto& elem : t) {
		cin >> elem;
	}
	vll hsh(n);
	for (int i = 0; i < n; i++) {
		hsh[i] = get_hash(t[i], pw);
	}
	vll h(s.size());
	h[0] = s[0] - 'a' + 1;
	for (int i = 1; i < s.size(); i++) {
		h[i] = (h[i - 1] + (s[i] - 'a' + 1) * pw[i]) % MOD;
	}
	vvll a(s.size(), vll(s.size()));
	for (int k = 0; k < n; k++) {
		for (int i = 0; i + t[k].size() - 1 < s.size(); i++) {
			int j = i + t[k].size() - 1;
			ll tmp = 0;
			if (i != 0) {
				tmp = h[i - 1];
			}
			ll chash = (h[j] - tmp) % MOD;
			chash = (chash + MOD) % MOD;
			chash = (chash * rpw[i]) % MOD;
			if (chash == hsh[k]) {
				a[i][j]++;
			}
		}
	}
	for (int len = 1; len < s.size(); len++) {
		for (int i = 0; i + len < s.size(); i++) {
			int j = i + len;
			if (i + 1 == j) {
				a[i][j] = (a[i][i] + a[j][j] + a[i][j]) % MOD;
				continue;
			}
			a[i][j] = (a[i][j - 1] + a[i][j]) % MOD;
			a[i][j] = (a[i + 1][j] + a[i][j]) % MOD;
			a[i][j] = (a[i][j] - a[i + 1][j - 1] + MOD) % MOD;
		}
	}
	while (m--) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		cout << a[l][r] << ' ';
	}
} 

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}