#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

typedef unsigned long long ull;
typedef long long ll;

//template <typename T>
//using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ull p = 29;
const ull MOD = 12345679;
const int max_t_size = 5e6 + 1;

ull mod(ull x) {
   x %= MOD;
   while (x < 0) x += MOD;
   return x;
}

struct my_hash {
   vector<ull> h;
   vector<ull> pw;
   int n;
   my_hash (string s) {
      n = sz(s);
      h.resize(n + 1);
      pw.resize(n + 1);
      pw[0] = 1;
      for (int i = 1; i <= n; i++) {
         h[i] = (h[i - 1] * p % MOD + (s[i - 1] - 'a' + 1)) % MOD;
         pw[i] = pw[i - 1] * p % MOD;
      }
   }
   ull get_hash(string cur_s) {
      ull hs = 0;
      for (int i = 1; i <= sz(cur_s); i++) {
         hs = (hs * p % MOD + (cur_s[i - 1] - 'a' + 1)) % MOD;
      }
      return hs;
   }
   bool equal(int l, int r, ull hash) {
      return mod(h[r] - h[l - 1] * pw[r - l + 1] % MOD) == hash;
   }
};

int n, m;
vector<int> pr[max_t_size];
vector<int> tree[4 * max_t_size];

string t;

void build(int v, int tl, int tr) {
   if (tl == tr) {
      tree[v] = pr[tl];
      return;
   }
   
   int tm = (tl + tr) >> 1;
   build(v << 1, tl, tm);
   build(v << 1 | 1, tm + 1, tr);
   tree[v].resize(sz(tree[v << 1]) + sz(tree[v << 1 | 1]));
   merge(all(tree[v << 1]), all(tree[v << 1 | 1]), tree[v].begin());
}

int get(int l, int r, int v, int tl, int tr) {
   if (l <= tl && tr <= r) {
      return upper_bound(all(tree[v]), r) - tree[v].begin();
   }
   if (tr < l || r < tl) {
      return 0;
   }
   int tm = (tl + tr) >> 1;
   return get(l, r, v << 1, tl, tm) + get(l, r, v << 1 | 1, tm + 1, tr);
}

int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   
   cin >> n >> m >> t;
   my_hash h(t);
   for (int i = 0; i < n; i++) {
      string cur_s;
      cin >> cur_s;
      ull s_hash = h.get_hash(cur_s);
      for (int r = sz(cur_s); r <= sz(t); r++) {
         int l = r - sz(cur_s) + 1;
         if (h.equal(l, r, s_hash)) {
            pr[l].push_back(r);
         }
      }
   }
   for (int i = 1; i <= sz(t); i++) {
      sort(all(pr[i]));
   }
   build(1, 1, sz(t));
   while (m--) {
      int l, r;
      cin >> l >> r;
      cout << get(l, r, 1, 1, sz(t)) << ' ';
   }
}
