#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define int __int128
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;
const int inf = 2000000000000000000;

ll binpow(ll n, ll k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

struct seg_tree{
    vector <int> t;
    vector <int> p;

    void push(int v){
        if(p[v] != 0){
            t[v * 2] += p[v];
            t[v * 2 + 1] += p[v];
            p[v * 2] += p[v];
            p[v * 2 + 1] += p[v];
            p[v] = 0;
        }
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tl >= r || tr <= l){
            return;
        }
        if(tl >= l && tr <= r){
            t[v] += val;
            p[v] += val;
            return;
        }

        push(v);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tl >= r || tr <= l){
            return 0;
        }
        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v);
        int tm = (tl + tr) / 2;
        return max(quer(v * 2, l, r, tl, tm), quer(v * 2 + 1, l, r, tm, tr));
    }
};

void solve(){
    int n, m;
    cin >> n >> m;
    string d;
    cin >> d;

    vector < map <char, int> > t(1e6 + 20);
    vector <bool> term(1e6 + 20);
    int nxt = 2;
    for(int _ = 0; _ < n; ++_){
        string s;
        cin >> s;

        int v = 1;
        for(auto c : s){
            if(t[v][c] != 0){
                v = t[v][c];
            }else{
                t[v][c] = nxt;
                v = nxt;
                nxt++;
            }
        }

        term[v] = 1;
    }

    n = d.length();

    vector < vector <int> > dp(n, vector <int> (n));
    for(int i = n - 1; i >= 0; --i){
        int v = 1, kol = 0;
        bool ok = 1;
        for(int j = i; j < n; ++j){
            char c = d[j];

            if(ok) {
                if (t[v].find(c) == t[v].end()) {
                    ok = 0;
                } else {
                    v = t[v][c];
                    kol += term[v];
                }
            }

            if(i + 1 < n) {
                dp[i][j] = dp[i + 1][j] + kol;
            }else{
                dp[i][j] = kol;
            }
        }
    }


    while(m--){
        int l, r;
        cin >> l >> r;
        --l; --r;

        cout << dp[l][r] << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}