#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll P = 97;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int R = 1;
vector <pair <int, int>> p;
vector <vector <int>> t;

struct Hash{
    int MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;
    vector <pair <int, int>> h;

    Hash(string s){
        h.resize(s.size() + 1);
        h[1] = {s[0] - 'a' + 1, s[0] - 'a' + 1};
        for (int i = 1; i < s.size(); i++){
            h[i + 1].first = (s[i] - 'a' + 1) + h[i].first * P;
            h[i + 1].second = (s[i] - 'a' + 1) + h[i].second * P;
            h[i + 1].first %= MOD1;
            h[i + 1].second %= MOD2;
        }
    }

    Hash(){}

    pair <int, int> get(int l, int r){
        pair <int, int> res;
        res.first = h[r].first + MOD1 - (h[l - 1].first * p[r - l + 1].first) % MOD1;
        res.second = h[r].second + MOD2 - (h[l - 1].second * p[r - l + 1].second) % MOD2;
        res.first %= MOD1;
        res.second %= MOD2;
        return res;
    }
};

vector <int> upd(vector <int> &a, vector <int> &b){
    vector <int> c;
    int l = 0, r = 0;
    while (l < a.size() && r < b.size()){
        if (a[l] < b[r]){
            c.push_back(a[l]);
            l++;
        }else{
            c.push_back(b[r]);
            r++;
        }
    }
    for (int i = l; i < a.size(); i++) c.push_back(a[i]);
    for (int i = r; i < b.size(); i++) c.push_back(b[i]);
    return c;
}

void build(){
    for (int i = R - 1; i > 0; i--){
        t[i] = upd(t[i * 2], t[i * 2 + 1]);
    }
}

int get_ans(int ql, int qr, int nl, int nr, int node, int x){
    if (nl >= qr || ql >= nr) return 0;
    if (nl >= ql && nr <= qr){
        return t[node].size() - (lower_bound(t[node].begin(), t[node].end(), x) - t[node].begin());
    }
    int nm = (nl + nr) / 2;
    return get_ans(ql, qr, nl, nm, node * 2, x) + get_ans(ql, qr, nm, nr, node * 2 + 1, x);
}

void height(int n){
    while (R < n) R *= 2;
}

signed main(){
    Fast();
    p.resize(100001);
    p[0] = {1, 1};
    for (int i = 1; i < p.size(); i++){
        p[i].first = p[i - 1].first * P;
        p[i].second = p[i - 1].second * P;
        p[i].first %= (int)(1e9 + 7);
        p[i].second %= (int)(1e9 + 9);
    }
    int n, m;
    cin >> n >> m;
    string str;
    cin >> str;
    Hash h(str);
    set <pair <int, int>> s;
    vector <pair <int, int>> seg;
    vector <int> k;
    for (int i = 0; i < n; i++){
        string st;
        cin >> st;
        Hash e(st);
        for (int j = 1; j <= str.size(); j++){
            if (j + st.size() - 1 > str.size()) break;
            if (h.get(j, j + st.size() - 1) == e.h.back()) seg.push_back({j - 1, j + st.size() - 2}), k.push_back(j + st.size() - 2);
        }
    }
    sort(k.begin(), k.end());
    k.push_back((int)str.size());
    sort(k.begin(), k.end());
    height((int)str.size());
    t.resize(2 * R);
    for (int i = 0; i < seg.size(); i++){
        t[seg[i].second + R].push_back(seg[i].first);
    }
    for (int i = R; i < 2 * R; i++){
        sort(t[i].begin(), t[i].end());
    }
    build();
    for (int _ = 0; _ < m; _++){
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ind = upper_bound(k.begin(), k.end(), r) - k.begin();
        cout << get_ans(0, k[ind], 0, R, 1, l) << " ";
    }
    return 0;
}