#include <bits/stdc++.h>

using namespace std;

array<vector<int>, 26> go;
vector<int> suff, supersuff;
vector<vector<int>> term;

void add_trie(int v, string &s, int id, int pos) {
    if (pos == s.size()) {
        term[v].push_back(id);
        return;
    }
    int c = s[pos] - 'a';
    if (go[c][v] == -1) {
        go[c][v] = go[0].size();
        for (int i = 0; i < 26; ++i)
            go[i].push_back(-1);
        suff.push_back(0);
        supersuff.push_back(0);
        term.push_back({});
    }
    add_trie(go[c][v], s, id, pos + 1);
}

queue<int> q;

void build_vert(int v) {
    if (v == 0) {
        suff[v] = v;
        for (int c = 0; c < 26; ++c) {
            if (go[c][v] == -1)
                go[c][v] = v;
            else
                q.push(go[c][v]);
            supersuff[go[c][v]] = suff[go[c][v]] = v;
        }
        return;
    }
    for (int c = 0; c < 26; ++c) {
        if (go[c][v] == -1)
            go[c][v] = go[c][suff[v]];
        else {
            q.push(go[c][v]);
            suff[go[c][v]] = go[c][suff[v]];
            if (term[suff[go[c][v]]].size())
                supersuff[go[c][v]] = suff[go[c][v]];
            else
                supersuff[go[c][v]] = supersuff[suff[go[c][v]]];
        }
    }
}

vector<pair<int, int>> pts;

int build_corasick(int n) {
    string text;
    cin >> text;
    for (int i = 0; i < 26; ++i)
        go[i].reserve(2e5);
    suff.reserve(2e5);
    supersuff.reserve(2e5);
    term.reserve(2e5);
    for (int i = 0; i < 26; ++i)
        go[i].push_back(-1);
    suff.push_back(0);
    supersuff.push_back(0);
    term.push_back({});
    vector<int> sizes(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        sizes[i] = s.size();
        add_trie(0, s, i, 0);
    }
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        build_vert(v);
    }
    vector<pair<int, int>> occ;
    int curv = 0;
    for (int i = 0; i < text.size(); ++i) {
        curv = go[text[i] - 'a'][curv];
        vector<int> ans;
        int v = curv;
        while (suff[v] != v) {
            for (auto id: term[v])
                ans.push_back(id);
            v = supersuff[v];
        }
        for (auto el: ans)
            pts.push_back({i - sizes[el] + 1, i});
    }
    return text.size();
}

vector<int> fenw;

void upd(int i, int val) {
    for (; i <   fenw.size(); i += (i & (-i)))
        fenw[i] += val;
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= (i & (-i)))
        res += fenw[i];
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    n = build_corasick(n);
    vector<vector<tuple<int, int, int>>> opev(n), clev(n);
    vector<vector<int>> ptev(n);
    for (auto [x, y]: pts)
        ptev[x].push_back(y);
    for (int tn = 0; tn < m; ++tn) {
        int li, ri;
        cin >> li >> ri;
        --li, --ri;
        opev[li].push_back({li, ri, tn});
        clev[ri].push_back({li, ri, tn});
    }
    vector<int> ans(m);
    fenw.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        for (auto [li, ri, id]: opev[i]) {
            int tmp = get(ri + 1);
            if (li)
                tmp -= get(li);
            ans[id] -= tmp;
        }
        for (auto y: ptev[i]) {
            upd(y + 1, 1);
        }
        for (auto [li, ri, id]: clev[i]) {
            int tmp = get(ri + 1);
            if (li)
                tmp -= get(li);
            ans[id] += tmp;
        }
    }
    for (auto el: ans)
        cout << el << ' ';
}