#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> go;
vector<int> suff, supersuff;
vector<vector<int>> term;

void add_trie(int v, string &s, int id, int pos) {
    while (pos != s.size()) {
        int c = s[pos] - 'a';
        if (go[v][c] == -1) {
            go[v][c] = go.size();
            go.push_back(vector<int>(26, -1));
            suff.push_back(0);
            supersuff.push_back(0);
            term.push_back({});
        }
        v = go[v][c];
        ++pos;
    }
    term[v].push_back(id);
    return;
}

queue<int> q;

void build_vert(int v) {
    if (v == 0) {
        suff[v] = v;
        for (auto &el: go[v]) {
            if (el == -1)
                el = v;
            else
                q.push(el);
            supersuff[el] = suff[el] = v;
        }
        return;
    }
    for (int c = 0; c < 26; ++c) {
        if (go[v][c] == -1)
            go[v][c] = go[suff[v]][c];
        else {
            q.push(go[v][c]);
            suff[go[v][c]] = go[suff[v]][c];
            if (term[suff[go[v][c]]].size())
                supersuff[go[v][c]] = suff[go[v][c]];
            else
                supersuff[go[v][c]] = supersuff[suff[go[v][c]]];
        }
    }
}

vector<pair<int, int>> pts;

int build_corasick(int n) {
    string text;
    cin >> text;
    go.push_back(vector<int>(26, -1));
    suff.push_back(0);
    supersuff.push_back(0);
    term.push_back({});
    vector<int> sizes(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        sizes[i] = s.size();
        add_trie(0, s, i, 0);
    }
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        build_vert(v);
    }
    vector<pair<int, int>> occ;
    int curv = 0;
    for (int i = 0; i < text.size(); ++i) {
        curv = go[curv][text[i] - 'a'];
        vector<int> ans;
        int v = curv;
        while (suff[v] != v) {
            for (auto id: term[v])
                ans.push_back(id);
            v = supersuff[v];
        }
        for (auto el: ans)
            pts.push_back({i - sizes[el] + 1, i});
    }
    return text.size();
}

vector<int> fenw;

void upd(int i, int val) {
    for (; i < fenw.size(); i += (i & (-i)))
        fenw[i] += val;
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= (i & (-i)))
        res += fenw[i];
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    n = build_corasick(n);
    vector<int> to_comp_x, to_comp_y;
    for (auto [x, y]: pts) {
        to_comp_x.push_back(x);
        to_comp_y.push_back(y);
    }
    vector<pair<int, int>> qries(m);
    for (int tn = 0; tn < m; ++tn) {
        int li, ri;
        cin >> li >> ri;
        --li, --ri;
        qries[tn] = {li, ri};
        to_comp_x.push_back(li);
        to_comp_x.push_back(ri);
        to_comp_y.push_back(li);
        to_comp_y.push_back(ri);
    }
    sort(to_comp_x.begin(), to_comp_x.end());
    to_comp_x.resize(unique(to_comp_x.begin(), to_comp_x.end()) - to_comp_x.begin());
    map<int, int> comp_x;
    for (int i = 0; i < to_comp_x.size(); ++i)
        comp_x[to_comp_x[i]] = i;
    sort(to_comp_y.begin(), to_comp_y.end());
    to_comp_y.resize(unique(to_comp_y.begin(), to_comp_y.end()) - to_comp_y.begin());
    map<int, int> comp_y;
    for (int i = 0; i < to_comp_y.size(); ++i)
        comp_y[to_comp_y[i]] = i;
    vector<vector<tuple<int, int, int>>> opev(to_comp_x.size()), clev(to_comp_x.size());
    vector<vector<int>> ptev(to_comp_x.size());
    for (auto [x, y] : pts)
        ptev[comp_x[x]].push_back(comp_y[y]);
    for (int i =0; i < m; ++i) {
        auto [li, ri] = qries[i];
        opev[comp_x[li]].push_back({comp_y[li], comp_y[ri], i});
        clev[comp_x[ri]].push_back({comp_y[li], comp_y[ri], i});
    }
    vector<int> ans(m);
    fenw.resize(to_comp_y.size() + 1);
    for (int i = 0; i < to_comp_x.size(); ++i) {
        for (auto [li, ri, id]: opev[i]) {
            int tmp = get(ri + 1);
            if (li)
                tmp -= get(li);
            ans[id] -= tmp;
        }
        for (auto y: ptev[i]) {
            upd(y + 1, 1);
        }
        for (auto [li, ri, id]: clev[i]) {
            int tmp = get(ri + 1);
            if (li)
                tmp -= get(li);
            ans[id] += tmp;
        }
    }
    for (auto el: ans)
        cout << el << ' ';
}