#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;

const int C = 26, N = 1e6;
vector<int> g[N];
vector<int> pos[N];
int h[N], lent;
struct node {
    int nx[C], suff = -1, cnt = 0;
    node() {
        fill(nx, nx + C, -1);
    }
};
vector<node> t(1);
void add_word(const string & s) {
    int v = 0;
    for (char ch : s) {
        int x = ch - 'a';
        if (t[v].nx[x] == -1) {
            h[sz(t)] = h[v] + 1;
            t[v].nx[x] = sz(t);
            t.emplace_back();
        }
        v = t[v].nx[x];
    }
    t[v].cnt++;
}
void build_aho() {
    vector<pair<int, int>> q;
    for (int x = 0; x < C; ++x) {
        if (t[0].nx[x] == -1) {
            t[0].nx[x] = 0;
        } else {
            q.emplace_back(0, x);
        }
    }
    for (int st = 0; st < sz(q); ++st) {
        auto [par, x] = q[st];
        int v = t[par].nx[x];
        if (t[par].suff == -1) {
            t[v].suff = 0;
        } else {
            t[v].suff = t[t[par].suff].nx[x];
        }
        g[t[v].suff].emplace_back(v);
        for (int y = 0; y < C; ++y) {
            if (t[v].nx[y] == -1) {
                t[v].nx[y] = t[t[v].suff].nx[y];
            } else {
                q.emplace_back(v, y);
            }
        }
    }
}
struct FT {
    vector<ll> t;
    FT(int n) : t(n) {}
    void update(int p, int add) {
        for (; p < sz(t); p |= p + 1) t[p] += add;
    }
    ll get(int p) {
        ll res = 0;
        for (; p > 0; p &= p - 1) res += t[p - 1];
        return res;
    }
};
struct event {
    int x, y, id, w;
    event(int x = 0, int y = 0, int id = 0, int w = 1) : x(x), y(y), id(id), w(w) {}
};
vector<event> ev;
void merge(vector<int> & a, vector<int> & b) {
    if (sz(a) < sz(b)) swap(a, b);
    for (int el : b) a.emplace_back(el);
    auto tmp = vector<int>();
    swap(tmp, b);
}
void dfs(int v) {
    for (int to : g[v]) {
        dfs(to);
        merge(pos[v], pos[to]);
    }
    if (t[v].cnt) {
        int len = h[v];
        for (int x : pos[v]) {
            int b = lent - (x - len + 1);
            ev.emplace_back(b, x, -1, t[v].cnt);
        }
    }
}
void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    lent = sz(s);
    vector<int> len(n);
    for (int i = 0; i < n; ++i) {
        string tmp;
        cin >> tmp;
        len[i] = sz(tmp);
        add_word(tmp);
    }
    build_aho();
    ev.reserve(7e6);
    int v = 0;
    for (int i = 0; i < sz(s); ++i) {
        int x = s[i] - 'a';
        v = t[v].nx[x];
        pos[v].emplace_back(i);
    }
    dfs(0);
    vector<ll> ans(q);
    for (int i = 0; i < q; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        ev.emplace_back(lent - a, b, i);
    }
    sort(ev.begin(), ev.end(), [](auto fst, auto snd) {
        if (fst.x != snd.x)
            return fst.x < snd.x;
        return fst.id < snd.id;
    });
    FT ft(lent + 10);
    for (auto [x, y, id, w] : ev) {
//        cerr << x << ' ' << y << ' ' << id << ' ' << w << '\n';
        if (id == -1) {
            ft.update(y, w);
        } else {
            ans[id] = ft.get(y);
        }
    }
    for (int el : ans) cout << el << ' ';
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    solve();
    return 0;
}