#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define double ld


#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")
#pragma GCC target("avx,avx2")

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}


const int maxn = 5e5;
const int maxlen = 750000;

ll fenwick_tree[maxlen + 1];
struct Fenw {
    ll get(int x) {
        ll res = 0;
        for (; x > 0; x -= x & -x)
            res += fenwick_tree[x];
        return res;
    }

    void add(int x, int val) {
        for (; x <= maxlen; x += x & -x) {
            fenwick_tree[x] += val;
        }
    }
    ll get(int l, int r) {
        return get(r - 1) - get(l - 1);
    }
};


const int P = 228;
const ll Q1 = 1e9 + 7;
const ll Q2 = 1e9 + 9;

struct Hash {
    ll a = 0, b = 0;

    Hash operator-(Hash other) const {
        return {((a - other.a) % Q1 + Q1) % Q1, ((b - other.b) % Q2 + Q2) % Q2};
    }

    Hash operator+(Hash other) const {
        return {(a + other.a) % Q1, (b + other.b) % Q2};
    }

    Hash operator+(ll x) const {
        return {(a + x) % Q1, (b + x) % Q2};
    }

    Hash operator*(int p) const {
        return {a * p % Q1, b * p % Q2};
    }

    Hash operator*(Hash p) const {
        return {a * p.a % Q1, b * p.b % Q2};
    }

    bool operator==(Hash other) const {
        return a == other.a and b == other.b;
    }

    bool operator<(Hash other) const {
        if (a != other.a)
            return a < other.a;
        return b < other.b;
    }
};

struct Node {
    Node* next[26];
    Node* sufflink;
    map<int, int> lens;

    Node() {
        for (int i = 0; i < 26; ++i)
            next[i] = nullptr;
        sufflink = nullptr;
    }
};

Node* add(Node* cur, string & s, int i) {
    if (cur == nullptr)
        cur = new Node();

    if (i == s.size()) {
        cur->lens[s.size()] += 1;
        return cur;
    }
    cur->next[s[i] - 'a'] = add(cur->next[s[i] - 'a'], s, i + 1);
    return cur;
}

void mv(Node* a, Node* b) {
    for (auto[len, cnt] : a->lens)
        b->lens[len] += cnt;
}

void build(Node* root) {
    deque<Node*> nodes;
    for (int i = 0; i < 26; ++i) {
        if (root->next[i] != nullptr) {
            root->next[i]->sufflink = root;
            nodes.push_back(root->next[i]);
        }
    }

    root->sufflink = root;
    for (int i = 0; i < 26; ++i) {
        if (root->next[i] == nullptr) {
            root->next[i] = root;
        }
    }

    while (nodes.size() > 0) {
        Node* u = nodes[0];
        nodes.pop_front();

        for (int to = 0; to < 26; ++to) {
            if (u->next[to] == nullptr) {
                u->next[to] = u->sufflink->next[to];
            } else {
                u->next[to]->sufflink = u->sufflink->next[to];
                nodes.push_back(u->next[to]);
                mv(u->sufflink->next[to], u->next[to]);
            }
        }
    }
}

ll ans[maxn];
vector<pair<int, int>> req[maxlen + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int len = s.size();

    Node* root = nullptr;

    for (int i = 0; i < n; ++i) {
        string d;
        cin >> d;
        root = add(root, d, 0);
    }

    build(root);

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        req[y].push_back({x, i});
    }

    Fenw fenw;

    Node* cur = root;

    for (int i = 1; i <= len; ++i) {
        cur = cur->next[s[i - 1] - 'a'];

        for (auto [lens, cnt] : cur->lens) {
            fenw.add(i - lens + 1, cnt);
        }

        for (auto [l, pos] : req[i]) {
            ans[pos] = fenw.get(l, i + 1);
        }
    }

    for (int i = 0; i < m; ++i)
        cout << ans[i] << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}