#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define double ld


using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}


const int maxn = 5e5;
const int maxlen = 5e6;

ll fenwick_tree[maxlen + 1];

struct Fenw {
    int len;

    Fenw(int sz) {
        len = sz;
    }

    ll get(int x) {
        ll res = 0;
        for (; x > 0; x -= x & -x)
            res += fenwick_tree[x];
        return res;
    }

    void add(int x, int val) {
        for (; x < len; x += x & -x) {
            fenwick_tree[x] += val;
        }
    }
    ll get(int l, int r) {
        return get(r - 1) - get(l - 1);
    }
};

const int maxv = 1e6 + 10;

int last_node = 1;

int nxt[26][maxv];
int sufflink[maxv];
vector<int> lens[maxv];

int add(int cur, string & s, int i) {
    if (cur == 0)
        cur = last_node++;

    if (i == s.size()) {
        lens[cur].push_back(s.size());
        return cur;
    }
    nxt[s[i] - 'a'][cur] = add(nxt[s[i] - 'a'][cur], s, i + 1);
    return cur;
}

void mv(int a, int b) {
    for (int i : lens[a])
        lens[b].push_back(i);
}

void build(int root) {
    deque<int> nodes;
    for (int i = 0; i < 26; ++i) {
        if (nxt[i][root] != 0) {
            sufflink[nxt[i][root]] = root;
            nodes.push_back(nxt[i][root]);
        }
    }

    sufflink[root] = root;
    for (int i = 0; i < 26; ++i) {
        if (nxt[i][root] == 0) {
            nxt[i][root] = root;
        }
    }

    while (nodes.size() > 0) {
        int u = nodes[0];
        nodes.pop_front();

        for (int to = 0; to < 26; ++to) {
            if (nxt[to][u] == 0) {
                nxt[to][u] = nxt[to][sufflink[u]];
            } else {
                sufflink[nxt[to][u]] = nxt[to][sufflink[u]];
                nodes.push_back(nxt[to][u]);
                mv(nxt[to][sufflink[u]], nxt[to][u]);
            }
        }
    }
}

ll ans[maxn];

vector<pair<int, int>> req[maxlen + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int len = s.size();

    int root = 0;
    for (int i = 0; i < n; ++i) {
        string d;
        cin >> d;
        root = add(root, d, 0);
    }

    build(root);

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        req[y].push_back({x, i});
    }

    Fenw fenw(len + 1);

    int cur = root;

    for (int i = 1; i <= len; ++i) {
        cur = nxt[s[i - 1] - 'a'][cur];

        for (int lens : lens[cur]) {
            fenw.add(i - lens + 1, 1);
        }

        for (auto [l, pos] : req[i]) {
            ans[pos] = fenw.get(l, i + 1);
        }
    }

    for (int i = 0; i < m; ++i)
        cout << ans[i] << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}