#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
ll p = 277, mod = 2286661337;
vector <ll> powers;
ll geth(string& s) {
	ll h = 0;
	for (int i = 0; i < s.size(); i++) {
		h = (h * p + (s[i] - 'a' + 1)) % mod;
	}
	return h;
}
struct Hash {
	vector <ll> h;
	Hash(string& s) {
		h.resize(s.size() + 1);
		for (int i = 0; i < s.size(); i++) {
			h[i + 1] = (h[i] * p + (s[i] - 'a' + 1)) % mod;
		}
	}
	ll get(ll l, ll r) {
		return (h[r] - (h[l] * powers[r - l]) % mod + mod) % mod;
	}
};
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	powers.resize(5e6 + 1);
	powers[0] = 1;
	for (int i = 1; i <= 5e6; i++) powers[i] = powers[i - 1] * p % mod;
	set <ll> hs;
	int n, m; cin >> n >> m;
	string t; cin >> t;
	Hash x(t);
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		hs.insert(geth(s));
	}
	vector <vector <int>> kol(t.size(), vector <int>(t.size(), 0));
	for (int l = 0; l < t.size(); l++) {
		for (int r = l; r < t.size(); r++) {
			ll h = x.get(l, r + 1);
			if (hs.find(h) != hs.end()) kol[l][r]++;
		}
	}
	for (int len = 1; len <= t.size(); len++) {
		for (int l = 0; l <= t.size() - len; l++) {
			int r = l + len - 1;
			if (l + 1 <= r) kol[l][r] += kol[l + 1][r];
			if (r - 1 >= l) kol[l][r] += kol[l][r - 1];
			if (l + 1 <= r - 1) kol[l][r] -= kol[l + 1][r - 1];
		}
	}
	while (m--) {
		int l, r; cin >> l >> r; l--, r--;
		cout << kol[l][r] << "\n";
	}
	return 0;
}