#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

#pragma GCC optimize("Ofast")

const int N = 1e5 + 7, MOD2 = 1e9 + 7, MOD = 1000003, C = 10, p1 = 29, p2 = 31;

vector<int> hash2[MOD];

int n, k;

long long pows1[N* 10], pows2[N * 10];

long long obr_p1, obr_p2;

int t, q;

string s;

int binpow(long long a, int step, int md) {
	if (step == 0) {
		return 1;
	}
	long long h = binpow(a, step / 2, md);
	h = (h * h) % md;
	if (step % 2) {
		h = (h * a) % md;
		return h;
	}
	return h;
}

struct window {
	long long h1, h2;
	int len;
	void build() {
		len = 0;
		h1 = 0;
		h2 = 0;
	}
	void add(char a) {
		int c = a - 'a' + 1;
		h1 += (pows1[len] * c) % MOD;
		h2 += (pows2[len] * c) % MOD2;
		len++;
		h1 %= MOD;
		h2 %= MOD2;
	}
	void del(char a) {
		int c = a - 'a' + 1;
		h1 -= c;
		h2 -= c;
		h1 += MOD;
		h2 += MOD2;
		if (h1 > MOD) {
			h1 -= MOD;
		}
		if (h2 > MOD2) {
			h2 -= MOD2;
		}
		h1 *= obr_p1;
		h2 *= obr_p2;
		h1 %= MOD;
		h2 %= MOD2;
		len--;
	}
};

window a;

vector<int> lengths;

vector<int> add[N];

struct Node {
	int sum;
	Node* l, * r;
	Node(int c) {
		sum = c;
		l = nullptr;
		r = nullptr;
	}
	Node(Node* lft, Node* rgt) {
		l = lft;
		r = rgt;
		sum = 0;
		sum += l->sum;
		sum += r->sum;
	}
	Node() {
		sum = 0;
		l = nullptr;
		r = nullptr;
	}
};

Node nodes[N * 400];
int CNT = 0;
Node* nw(int v) {
	nodes[CNT].sum = v;
	nodes[CNT].l = nullptr;
	nodes[CNT].r = nullptr;
	CNT++;
	return &nodes[CNT - 1];
}

Node* nw(Node* lft, Node* rgt) {
	nodes[CNT].l = lft;
	nodes[CNT].r = rgt;
	nodes[CNT].sum = 0;
	nodes[CNT].sum += lft->sum;
	nodes[CNT].sum += rgt->sum;
	CNT++;
	return &nodes[CNT - 1];
}

int SZ = 0;

Node* build(int n) {
	vector<Node*> tree;
	int h = 1;
	while (h < n) {
		h *= 2;
	}
	SZ = h;
	tree.resize(h * 2);
	for (int i = h * 2 - 1; i >= 1; i--) {
		if (i >= h) {
			tree[i] = nw(0);
		}
		else {
			tree[i] = nw(tree[i * 2], tree[i * 2 + 1]);
		}
	}
	return tree[1];
}

Node* heads[N];

Node* add1(Node* v, int x, int L, int R, int val) {
	if (L == x && R == x) {
		return nw(v->sum + val);
	}
	if (L > x || R < x) {
		return v;
	}
	return nw(add1(v->l, x, L, (L + R) / 2, val), add1(v->r, x, (L + R) / 2 + 1, R, val));
}

Node* Add(Node* head, int i) {
	return add1(head, i + 1, 1, SZ, 1);
}

int get (Node* v, int l, int r, int L, int R) {
	if (L >= l && R <= r) {
		return v->sum;
	}
	if (L > r || R < l) {
		return 0;
	}
	return get(v->l, l, r, L, (L + R) / 2) + get(v->r, l, r, (L + R) / 2 + 1, R);
}

int Get(Node* v, int l, int r) {
	return get(v, l + 1, r + 1, 1, SZ);
}

void solve() {
	cin >> t >> q;
	cin >> s;
	n = s.size();
	for (int i = 0; i < t; i++) {
		string s1;
		cin >> s1;
		lengths.push_back(s1.size());
		a.build();
		for (auto u : s1) {
			a.add(u);
		}
		hash2[a.h1].push_back(a.h2);
	}
	sort(lengths.begin(), lengths.end());
	lengths.resize(unique(lengths.begin(), lengths.end()) - lengths.begin());
	int I = 0;
	for (auto l : lengths) {
		if (l > n) {
			break;
		}
		a.build();
		for (int i = 0; i < l; i++) {
			a.add(s[i]);
		}
		for (int i = 0; i < n + 1 - l; i++) {
			if (find(hash2[a.h1].begin(), hash2[a.h1].end(), a.h2) != hash2[a.h1].end()) {
				add[i + l - 1].push_back(i);
				//cout << i << "!\n";
			}
			a.del(s[i]);
			if (i + l < n)
				a.add(s[i + l]);
		}
		I++;
	}

	heads[0] = build(n);
	for (auto u : add[0]) {
		heads[0] = Add(heads[0], u);
	}
	for (int i = 1; i < n; i++) {
		heads[i] = heads[i - 1];
		for (auto u : add[i]) {
			heads[i] = Add(heads[i], u);
		}
	}

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		long long answ = 0;
		answ = Get(heads[r], l, r);
		cout << answ << " ";
	}
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	/*int i = 1e7;
	while (true) {
		bool f = 1;
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				f = 0;
				break;
			}
		}if (f) {
			cout << i << "\n\n";
			break;
		}
		i++;
	}*/

	obr_p1 = binpow(p1, MOD - 2, MOD);
	obr_p2 = binpow(p2, MOD2 - 2, MOD2);
	pows1[0] = 1;
	pows2[0] = 1;
	for (int i = 1; i < N * 10; i++) {
		pows1[i] = (pows1[i - 1] * p1) % MOD;
		pows2[i] = (pows2[i - 1] * p2) % MOD2;
	}
	int t;
	t = 1;
	while (t--) {
		solve();
	}
}