#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = (ll) 1e18 + 9;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 5e6 + 15;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int m;
int f[MAX];

void update(int p, int x) {
    p += 5;
    for(; p < m + 10; p += p & -p) f[p] += x;
}

int get(int p) {
    p += 5;
    int ans = 0;
    for(; p; p -= p & -p) ans += f[p];
    return ans;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

ll mult(ll a, ll b) {
    ll ans = ((__int128) a * b) % mod;
    return ans;
}

ll add(ll a, ll b) {
    a += b;
    if(a >= mod) a -= mod;
    return a;
}

ll sub(ll a, ll b) {
    a -= b;
    if(a < 0) a += mod;
    return a;
}

void adds(ll &a, ll b) {
    a += b;
    if(a >= mod) a -= mod;
}

void subs(ll &a, ll b) {
    a -= b;
    if(a < 0) a += mod;
}

ll binpow(ll x, ll n) {
    ll ans = 1;
    while(n) {
        if(n & 1) ans = mult(ans, x);
        n >>= 1;
        x = mult(x, x);
    }
    return ans;
}

vector<ll> pw(MAX, 1), inv(MAX, 1);

ll get_hash(string &s) {
    ll ans = 0;
    for(int i = 0; i < sz(s); i++) {
        adds(ans, mult(pw[i], s[i]));
    }
    return ans;
}

ll pref_h[MAX];

ll get_hsh(int l, int r) {
    ll ans = sub(pref_h[r], l? pref_h[l - 1] : 0);
    ans = mult(ans, inv[l]);
    return ans;
}

const int buben = 150;

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    m = sz(s);
    vector<string> a(n);
    vector<ll> hsh(n);
    vector<int> light, heavy;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        hsh[i] = get_hash(a[i]);
        if(sz(a[i]) <= buben) light.pb(i);
        else heavy.pb(i);
    }
    for(int i = 0; i < m; i++) {
        if(i) pref_h[i] = pref_h[i - 1];
        adds(pref_h[i], mult(s[i], pw[i]));
    }
    auto comp = hsh;
    sort(all(comp)); comp.erase(unique(all(comp)), comp.end());
    for(auto &i : hsh) i = lower_bound(all(comp), i) - comp.begin();
    vector<vector<int>> seg(m);
    vector<ll> pref(m + 1);
    for(int i = 0; i < m; i++) {
        ll h = 0;
        for(int j = 1; i + j - 1 < m && j <= buben; j++) {
            adds(h, mult(pw[j - 1], s[i + j - 1]));
            ll check = *lower_bound(all(comp), h);
            if(check == h) {
//                cout << i << " " << i + j - 1 << endl;
                ///?????
                seg[i + j - 1].pb(i);
            }
        }
    }
    for(auto idx : heavy) {
        int len = sz(a[idx]);
        ll sup = comp[hsh[idx]];
        for(int i = 0; i + len - 1 < m; i++) {
            if(get_hsh(i, i + len - 1) == sup) {
//                cout << i << ' ' << i + len - 1 << endl;
                ///?????
                seg[i + len - 1].pb(i);
            }
        }
    }
    vector<vector<pair<int, int>>> qr(m);
    for(int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r; l--, r--;
        qr[r].pb({l, i});
    }
    vector<int> ans(q);
    for(int i = 0; i < m; i++) {
        for(auto l : seg[i]) update(l, 1);
        for(auto [l, idx] : qr[i]) {
            ans[idx] = get(l, i);
        }
    }
    for(auto i : ans) cout << i << " ";
}

signed main() {
    for(int i = 1; i < MAX; i++) {
        pw[i] = mult(pw[i - 1], base);
    }
    inv[MAX - 1] = binpow(pw[MAX - 1], mod - 2);
    for(int i = MAX - 1; i; i--) {
        inv[i - 1] = mult(inv[i], base);
    }
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
