#include <bits/stdc++.h>

using namespace std;

const int p = 1327;
const int mod = 1e9 + 7;
const int N = 5555;
int ppow[N];

void init() {
  ppow[0] = 1;
  for (int i = 1; i < N; i++)
    ppow[i] = ppow[i - 1] * p % mod;
}

const int maxn = 1 << 16;
struct node {
  vector<int> mrg;
} tree[2 * maxn - 1];

void edit(int x, int l, int r, int ind, int val) {
  if (r < ind || ind < l)
    return;
  if (l == r) {
    tree[x].mrg.push_back(val);
    return;
  }
  int mid = (l + r) >> 1;
  edit(2 * x + 1, l, mid, ind, val);
  edit(2 * x + 2, mid + 1, r, ind, val);
}

void build(int x, int l, int r) {
  if (l == r) {
    sort(tree[x].mrg.begin(), tree[x].mrg.end());
    return;
  }
  int mid = (l + r) >> 1;
  build(2 * x + 1, l, mid);
  build(2 * x + 2, mid + 1, r);
  merge(tree[2 * x + 1].mrg.begin(), tree[2 * x + 1].mrg.end(), tree[2 * x + 2].mrg.begin(), tree[2 * x + 2].mrg.end(), back_inserter(tree[x].mrg));
}

long long Get(int x, int l, int r, int ll, int rr, int L) {
  if (r < ll || rr < l)
    return 0;
  if (ll <= l && r <= rr) {
    int low = -1, high = (int)tree[x].mrg.size();
    while (low + 1 < high) {
      int mid = (low + high) >> 1;
      if (tree[x].mrg[mid] <= L) low = mid;
      else high = mid;
    }
    return low + 1;
  }
  int mid = (l + r) >> 1;
  return Get(2 * x + 1, l, mid, ll, rr, L) + Get(2 * x + 2, mid + 1, r, ll, rr, L);
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  init();
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, q;
  cin >> n >> q;
  string t;
  cin >> t;
  int hash[t.size()];
  hash[0] = t[0];
  for (int i = 1; i < (int)t.size(); i++) {
    hash[i] = (hash[i - 1] + ppow[i] * t[i]) % mod;
  }
  auto get = [&](int l, int r) {
    return (hash[r] - (l > 0 ? hash[l - 1] : 0) + mod) % mod;
  };
  for (int i = 0; i < n; i++) {
    string s;
    cin >> s;
    int h = 0;
    for (int j = 0; j < (int)s.size(); j++)
      h = (h + ppow[j] * s[j]) % mod;
    for (int j = 0; j + (int)s.size() - 1 < (int)t.size(); j++) {
      int h2 = get(j, j + (int)s.size() - 1);
      if (h * ppow[j] % mod == h2) {
        edit(0, 0, maxn - 1, j, j + (int)s.size() - 1);
      }
    }
  }
  build(0, 0, maxn - 1);
  while (q--) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    cout << Get(0, 0, maxn - 1, l, r, r) << ' ';
  }
}