#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

const long long N = 5e5 + 10, P = 301, M = 1849797119;
long long pdeg[N];

void precalc()
{
	pdeg[0] = 1;
	for (long long i = 1; i < N; i++)
	{
		pdeg[i] = (pdeg[i - 1] * P) % M;
	}
}

vector<long long> build_hash(string& s)
{
	vector<long long> h(s.size() + 1);
	for (long long i = 0; i < s.size(); i++)
	{
		h[i + 1] = ((h[i] * P) % M + s[i]) % M;
	}
	return h;
}

long long str_hash(string& s)
{
	long long h = 0;
	for (long long i = 0; i < s.size(); i++)
	{
		h = (h * P) % M;
		h = (h + s[i]) % M;
	}
	return h;
}

long long mod(long long a)
{
	a %= M;
	if (a < 0)
	{
		a += M;
	}
	return a;
}

long long geth(vector<long long>& h, long long l, long long r)
{
	r++;
	return mod(h[r] - (h[l] * pdeg[r - l]) % M);
}

void solve()
{
	precalc();

	long long n, m;
	string t;
	vector<string> s;
	cin >> n >> m >> t;
	s.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> s[i];
	}
	set<long long> st;
	for (long long i = 0; i < n; i++)
	{
		st.insert(str_hash(s[i]));
	}
	vector<long long> ht = build_hash(t);

	vector<long long> ans(m);
	for (long long _ = 0; _ < m; _++)
	{
		long long l, r;
		cin >> l >> r;
		l--; r--;

		long long cnt = 0;
		for (long long i = l; i < r + 1; i++)
		{
			for (long long j = i; j < r + 1; j++)
			{
				if (st.find(geth(ht, i, j)) != st.end())
				{
					cnt++;
				}
			}
		}
		ans[_] = cnt;
	}
	for (long long i = 0; i < m; i++)
	{
		cout << ans[i] << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/
