#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

int base = 1303;
int base1 = 239;
const int P = 1e9 + 7;
const int P1 = 1e8 + 1303;

#define int long long

int add(int a, int b){
    return (a + b) % P;
}
int add1(int a, int b){
    return (a + b) % P1;
}

int mul(int a, int b){
    return (a * b) % P;
}
int mul1(int a, int b){
    return (a * b) % P1;
}

pair<int, int> addh(pair<int, int> hash, char c){
    c -= ('a' - 1);
    return make_pair(add(mul(hash.first, base), c),
                     add1(mul1(hash.second, base1), c));
}

pair<int, int> hsh(string &s){
    pair<int, int> hash = {0, 0};
    for (int i = 0; i < s.size(); ++i) {
        hash = addh(hash, s[i]);
    }
    return hash;
}

signed main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    set<pair<int, int>> hashs;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        hashs.insert(hsh(v[i]));
    }
    vector<vector<int>> dp(t.size(), vector<int>(t.size(), 0));
    for (int i = 0; i < t.size(); ++i) {
        int cnt = 0;
        pair<int, int> hash = addh({0, 0}, t[i]);
        int left = i;
        while (left < t.size()) {
            if (hashs.find(hash) != hashs.end()) {
                cnt++;
//                    cout << le << ' ' << left << endl;
            }
            dp[i][left] = cnt;
            left++;
            if (left != t.size()) {
                hash = addh(hash, t[left]);
            }
        }
    }
//    assert(hashs.size() == n);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int cnt = 0;
        for (int le = l; le <= r; ++le) {
            cnt += dp[le][r];
        }
        cout << cnt << endl;
    }

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}