#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

int base = 10;
int base1 = 239;
const int P = 1e9;
const int P1 = 1e8 + 1303;

#define int long long

int add(int a, int b){
    return (a + b) % P;
}
int add1(int a, int b){
    return (a + b) % P1;
}

int mul(int a, int b){
    return (a * b) % P;
}

int mul1(int a, int b){
    return (a * b) % P1;
}

pair<int, int> addh(pair<int, int> hash, char c){
    c -= ('a' - 1);
    return make_pair(add(mul(hash.first, base), c),
                     add1(mul1(hash.second, base1), c));
}

pair<int, int> delh(pair<int, int> hash, char c, int powbase, int powbase1){
    c -= ('a' - 1);
    return make_pair(add(hash.first, P - mul(c, powbase)),
                     add1(hash.second,  P1 - mul1(c, powbase1)));

}

pair<int, int> hsh(string &s){
    pair<int, int> hash = {0, 0};
    for (int i = 0; i < s.size(); ++i) {
        hash = addh(hash, s[i]);
    }
    return hash;
}


int pow2(int a, int n, int p){
    if (n == 0){
        return 1;
    }
    if (n % 2 == 0){
        int x = pow2(a, n / 2, p);
        return (x * x) % p;
    }
    if (n % 2 == 1){
        return (a * pow2(a, n - 1, p)) % p;
    }
}

signed main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    set<pair<int, int>> hashs;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        hashs.insert(hsh(v[i]));
    }
    if (t.size() <= 5000) {
        vector<vector<int>> dp(t.size(), vector<int>(t.size(), 0));
        for (int i = 0; i < t.size(); ++i) {
            int cnt = 0;
            pair<int, int> hash = addh({0, 0}, t[i]);
            int left = i;
            while (left < t.size()) {
                if (hashs.find(hash) != hashs.end()) {
                    dp[i][left]++;
//                    cout << le << ' ' << left << endl;
                }
                left++;
                if (left != t.size()) {
                    hash = addh(hash, t[left]);
                }
            }
        }
//    for (int i = 0; i < t.size(); ++i) {
//        for (int j = 0; j < t.size(); ++j) {
//            cout << dp[i][j] << ' ';
//        }
//        cout << endl;
//    }
//    cout << endl;
        for (int i = 0; i < t.size(); ++i) {
            for (int l = 0; l + i < t.size(); ++l) {
                int r = l + i;
                if (r - 1 >= 0) {
                    dp[l][r] += dp[l][r - 1];
                }
                if (l + 1 < t.size()) {
                    dp[l][r] += dp[l + 1][r];
                }
                if (r - 1 >= 0 && l + 1 < t.size()) {
                    dp[l][r] -= dp[l + 1][r - 1];
                }
            }
        }

        for (int i = 0; i < m; ++i) {
            int l, r;
            cin >> l >> r;
            --l;
            --r;
            cout << dp[l][r] << '\n';
        }
        return 0;
    }
    vector<vector<int>> indices(n);
    for (int i = 0; i < n; ++i) {
        int sz = v[i].size();
        int powbase1 = pow2(base1, sz, P1);
        int powbase = pow2(base, sz, P);
        pair<int, int> hash = {0, 0};
        for (int j = 0; j < sz - 1; ++j){
            hash = addh(hash, t[j]);
        }
        pair<int, int> hash0 = hsh(v[i]);
        for (int j = sz - 1; j < t.size(); ++j){
            hash = addh(hash, t[j]);
            if (j >= sz){
                hash = delh(hash, t[j - sz], powbase, powbase1);
            }
            if (hash == hash0){
                indices[i].push_back(j - sz + 1);
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << i << ":::    ";
//        for (auto el : indices[i]){
//            cout << el << ' ';
//        }
//        cout << endl;
//    }
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int cnt = 0;
        for (int j = 0; j < n; ++j) {
            cnt += upper_bound(indices[j].begin(), indices[j].end(), r - v[j].size() + 1) -
                    lower_bound(indices[j].begin(), indices[j].end(), l);
        }
        cout << cnt << endl;
    }

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}