#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	int tn = (int) t.size();
	vector<vector<int>> dp(tn, vector<int>(tn, 0));
	for (int i = 0; i < tn; ++i) {
		for (int j = i; j < tn; ++j) {
			for (int k = 0; k < n; ++k) {
				if (s[k] == t.substr(i, j - i + 1)) {
					++dp[i][j];
				}
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		--l;
		--r;
		int ans = 0;
		for (int L = l; L <= r; ++L) {
			for (int R = L; R <= r; ++R) {
				ans += dp[L][R];
			}
		}
		cout << ans << " ";
	}
	cout << endl;
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
