#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 321;
const ll P = 239;

const int MAXS = 1e6 + 10;
const int MAXN = 5e4 + 10;
const int MAXP = min(MAXN, MAXS);
vector<int> hashs[MAXS];
vector<int> inds[MAXS];
int pw[MAXP];
int h[MAXN] = {};

void buildHashs(string& s) {
    int n = s.size();
    for (int i = 0; i < n; i++)  h[i + 1] = (h[i] * P + (s[i] - 'a' + 1)) % mod;
}

int getHash(string& s) {
    int n = s.size();
    ll h = 0;
    for (int i = 0; i < n; i++) h = (h * P + (s[i] - 'a' + 1)) % mod;
    return h;
}

int getHash(int l, int r) {
    ll res = (h[r] - 1LL * h[l] * pw[r - l]) % mod;
    if (res < 0) res += mod;
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pw[0] = 1;
    for (int i = 1; i < MAXP; i++) pw[i] = (pw[i - 1] * P) % mod;

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int t_len = t.length();
    buildHashs(t);

    vector<int> l;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int len = s.length();
        l.push_back(len);
        hashs[len].push_back(getHash(s));
    }

    sort(all(l));
    l.resize(unique(all(l)) - l.begin());
    for (auto len : l) {
        sort(all(hashs[len]));
        for (int i = 0; i < t_len; i++) {
            if (i + len - 1 < t_len) {
                ll cur = getHash(i, i + len);
                auto it = lower_bound(all(hashs[len]), cur);
                if (it != hashs[len].end() && *it == cur) {
                    inds[len].push_back(i + 1);
                }
            }
        }
    }

    for (int i = 0; i < m; i++) {
        int lq, rq;
        cin >> lq >> rq;
        ll ans = 0;
        for (auto len : l) {
            if (lq + len - 1 > rq) {
                break;
            }
            ans += upper_bound(all(inds[len]), rq - len + 1) - lower_bound(all(inds[len]), lq);
        }
        cout << ans << ' ';
    }

    return 0;
}