#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll T = 1e5 + 5;
const ll P = 179;
const ll M = 1e9 + 9;

ll p[T];

void fillp() {
	p[0] = 1;
	for (int i = 1; i < T; ++i) {
		p[i] = p[i - 1] * P % M;
	}
}

struct Str {
	string s;
	vector<ll> h;
	void init() {
		cin >> s;
		h.resize(s.size() + 1);
		for (int i = 0; i < s.size(); ++i) {
			h[i + 1] = (h[i] * P + s[i] - 'a') % M;
		}
	}
	// [ l , r )
	ll geth(int l = -1, int r = -1) {
		if (l == -1)
			return h.back();
		return (h[r] - (h[l] * p[r - l] % M) + M) % M;
	}
	Str() {}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	fillp();
	int n, m;
	cin >> n >> m;
	Str t;
	t.init();
	vector<Str> s(n);
	vector<vector<int>> f(n);
	for (int i = 0; i < n; ++i) {
		s[i].init();
		int sz = s[i].s.size();
		//cout << s[i].s << "      ";
		for (int j = 0; j + sz <= t.s.size(); ++j) {
			if (t.geth(j, j + sz) == s[i].geth()) {
				f[i].push_back(j);
				//cout << j << " ";
			}
		}
		//cout << "\n";
	}
	for (int i = 0; i < m; ++i) {
		int ql, qr;
		cin >> ql >> qr;
		--ql;
		int res = 0;
		for (int j = 0; j < n; ++j) {
			int sz = s[j].s.size();
			if (f[j].empty() || f[j][0] + sz > qr || f[j].back() < ql)
				continue;
			int l = -1, r = f[j].size() - 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (f[j][m] < ql)
					l = m;
				else
					r = m;
			}
			int fl = r;
			//int fl = lower_bound(f[j].begin(), f[j].end(), ql) - f[j].begin();
			l = 0;
			r = f[j].size();
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (f[j][m] + sz <= qr)
					l = m;
				else
					r = m;
			}
			int fr = r;
			//int fr = upper_bound(f[j].begin(), f[j].end(), qr - sz) - f[j].begin();
			//if (f[j][fr] + sz > qr)
				//--fr;
			//cout << "   " << j << ": " << fl << " " << fr << "\n";
			res += fr - fl;
		}
		cout << res << " ";
	}
}