#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <unordered_set>

//#define   unsigned ull -> long long;
using namespace std;

typedef unsigned long long  ull;

ull mod = 1e9 + 7;
ull p = 157;

vector < ull > ch;
vector < ull > deg;

ull get_hash(const string& a) {
    ull h = 0;
    for (auto i : a) {
        h = ((h * p) % mod + (i - 'a' + 1)) % mod;
        h %= mod;
    }
    return h;
}

void zapolni(const string& s) {
    ull h = 0;
    for (ull i = 0; i < s.size(); i++) {
        h = ((h * p) % mod + (s[i] - 'a' + 1)) % mod;
        h %= mod;
        ch[i] = h;
    }
}

void stepen() {
    ull t = 0;
    for (ull i = 0; i < deg.size(); i++) {
        t = (t * p) % mod;
        if (i == 0)t = 1;
        deg[i] = t;
    }
}

ull get(ull l, ull r) {
    if (l == 0) {
        return ch[r];
    }
    l--;
    return (ch[r] - ch[l] * deg[r - l] % mod);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ull n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    unordered_set < ull > q;
    for (ull i = 0; i < n; i++) {
        string a;
        cin >> a;

        q.insert(get_hash(a));
    }
    
    ch.resize(s.size());
    zapolni(s);

    deg.resize(s.size());
    stepen();
    
    vector < ull > answer(m);
    for (ull i = 0; i < m; i++) {
        ull l, r;
        cin >> l >> r;
        l--; r--;

        ull kol = 0;
        for (ull j = l; j <= r; j++) {
            for (ull len = 0; j + len <= r; len++) {
                if (q.find(get(j, j + len)) != q.end()) {
                    //cout << j << " " << j + len << '\n';
                    kol++;
                }
            }
        }

        answer[i] = kol;
    }

    for (auto i : answer) {
        cout << i << " ";
    }
}
