#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

constexpr ll mod1 = 1e9 + 7, mod2 = 2286661337, p1 = 237, p2 = 371;
vector<ll>pp1, pp2;

inline void M1(ll& a) {
	if (a >= mod1)
		a -= mod1;
}

inline void M2(ll& a) {
	if (a >= mod2)
		a -= mod2;
}

pair<ll, ll> get_hashes(string& s) {
	ll h1 = 0, h2 = 0;
	for (int i = 0; i < s.size(); i++) {
		h1 = (h1 * p1 % mod1 + s[i] - 'a' + 1);
		h2 = (h2 * p2 % mod2 + s[i] - 'a' + 1);
		M1(h1);
		M2(h2);
	}
	return { h1, h2 };
}

vector<ll>h1, h2;
ll get_hash1(int l, int r) {
	ll ans = (h1[r + 1] - h1[l] * pp1[r - l + 1] % mod1 + mod1);
	M1(ans);
	return ans;
}
ll get_hash2(int l, int r) {
	ll ans = (h2[r + 1] - h2[l] * pp2[r - l + 1] % mod2 + mod2);
	M2(ans);
	return ans;
}

struct MyHash
{
	ll operator()(pair<ll, ll> const& el) const noexcept
	{
		return (el.first << 5) ^ (el.second >> 7) + el.first >> 2 - el.second << 9;
	}
};

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	pp1.resize(1e6 + 1, 1);
	pp2.resize(1e6 + 1, 1);
	for (int i = 1; i < pp1.size(); i++) {
		pp1[i] = pp1[i - 1] * p1 % mod1;
		pp2[i] = pp2[i - 1] * p2 % mod2;
	}
	int n, m;
	cin >> n >> m;
	string t; cin >> t;
	h1.resize(t.size() + 1);
	h2.resize(t.size() + 1);
	for (int i = 1; i <= t.size(); i++) {
		h1[i] = (h1[i - 1] * p1 % mod1 + t[i - 1] - 'a' + 1);
		h2[i] = (h2[i - 1] * p2 % mod2 + t[i - 1] - 'a' + 1);
		M1(h1[i]);
		M2(h2[i]);
	}
	map<int, vector<pair<ll, ll>>>group;
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		group[s.size()].push_back(get_hashes(s));
	}
	vector<int>lens(group.size());
	vector<unordered_set<pair<ll, ll>, MyHash>>hashes(group.size());
	int ind = 0;
	for (auto& i : group) {
		lens[ind] = i.first;
		hashes[ind].max_load_factor(0.25);
		for (auto& x : i.second) {
			hashes[ind].insert(x);
		}
		++ind;
	}
	vector<vector<int>>reqs(t.size());
	vector<int>scan_open(t.size()), scan_close(t.size());
	for (int len_i = 0; len_i < lens.size(); len_i++) {
		for (int i = lens[len_i] - 1; i < t.size(); i++) {
			int l = i - lens[len_i] + 1;
			pair<ll, ll>me = { get_hash1(l, i), get_hash2(l, i) };
			if (hashes[len_i].find(me) != hashes[len_i].end()) {
				scan_open[l]++;
				//scanline[l].push_back({ 0, 0 });
				scan_close[i]++;
				//scanline[i].push_back({ 1, 0 });
			}
		}
	}
	vector<int>ans(m);
	vector<int>l(m), r(m);
	for (int i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
		l[i]--, r[i]--;
		reqs[r[i]].push_back(i);
	}
	
	vector<int>close(t.size()), open(t.size());
	int s_close = 0, s_open = 0;
	for (int i = 0; i < t.size(); i++) {
		s_close += scan_close[i];
		s_open -= scan_close[i];
		s_open += scan_open[i];
		close[i] = s_close;
		open[i] = s_open;
		for (auto ind : reqs[i]) {
			ans[ind] = s_close - (l[ind] == 0 ? 0 : close[l[ind] - 1] + open[l[ind] - 1]);
		}
	}
	for (auto i : ans) {
		cout << i << ' ';
	}
	return 0;
}