#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
//#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

vi zfunc(string t) {
  ll n = t.size();
  vi z(n);
  z[0] = 0;
  ll L = 0, R = 0;
  for (int i = 1; i < n; ++i) {
    if (i < R) z[i] = min(z[i - L], R - i);
    while (i < n && t[z[i]] == t[i + z[i]]) ++z[i];
    if (i + z[i] > R) L = i, R = i + z[i];
  }
  return z;
}

void solve() {
  ll n, m;
  cin >> n >> m;
  string t;
  vector<string> s(n);
  cin >> t >> s;

  vector<pair<ii, ll>> q;

  for (int qq = 0; qq < m; ++qq) {
    ll l, r;
    cin >> l >> r;
    --l;
    q.emplace_back(ii{l, r}, qq);
  }
  sort(q.begin(), q.end());
  vi ans(m);

  for (auto w : s) {
    vi z = zfunc(w + "#" + t);
    for (int i = 0; i < t.size(); ++i) {
      if (z[w.size() + 1 + i] == w.size()) {
        ll qq_end = upper_bound(q.begin(), q.end(), pair<ii, ll>{{i, (ll) 1e18}, (ll) 1e18}) - q.begin();
        for (int qq = 0; qq < qq_end; ++qq) {
          auto [lr, qqq] = q[qq];
          auto [l, r] = lr;
          if (l <= i && i + w.size() <= r) {
            ans[qqq] += 1;
          }
        }
      }
    }
  }

  cout << ans << endl;
}