#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
//#include <iomanip>
//#include <map>
//#include <random>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/rope>

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
//mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll))
        end_char = ' ';
    if (typeid(T) == typeid(ld))
        end_char = '\t';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

const int N = 1e6 + 100;
int go[N][26];
int pref[N], suf[N];
int par[N], parc[N];
bool term[N];
int new_v = 2;


void add_str(const vector<int>& s) {
    int v = 1;
    for (int c : s) {
        if (go[v][c] == 0) {
            go[v][c] = new_v;
            par[new_v] = v;
            parc[new_v] = c;
            ++new_v;
        }
        v = go[v][c];
    }
    term[v] = true;
}

void build() {
    for (int i = 0; i < 26; ++i)
        go[0][i] = 1;
    par[1] = 0;
    parc[1] = 0;
    suf[0] = 0;

    queue<int> q;
    q.push(1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        suf[v] = go[suf[par[v]]][parc[v]];
        if (v == 1)
            suf[v] = 0;
        for (int c = 0; c < 26; ++c) {
            if (go[v][c] != 0) {
                q.push(go[v][c]);
                continue;
            }
            go[v][c] = go[suf[v]][c];
        }
        pref[v] = pref[suf[v]] + term[v];
    }
}

ll precacl[5050][5050];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    string ts;
    cin >> ts;
    vector<int> t(ts.size());
    for (int i = 0; i < ts.size(); ++i)
        t[i] = ts[i] - 'a';
    string ss;
    vector<int> s;
    for (int i = 0; i < n; ++i) {
        cin >> ss;
        s.resize(ss.size());
        for (int j = 0; j < ss.size(); ++j)
            s[j] = ss[j] - 'a';
        add_str(s);
    }
    build();
//    cout << new_v << endl;
//    for (int i = 0; i < new_v; ++i) {
//        cout << i << ' ' << pref[i] << ' ' << suf[i] << ":\t";
//        for (int c = 0; c < 5; ++c) {
//            cout << go[i][c] << ' ';
//        }
//        cout << endl;
//    }
    for (int i = 0; i < t.size(); ++i) {
        ll res = 0;
        int v = 1;
        for (int j = i; j < t.size(); ++j) {
            v = go[v][t[j]];
            res += pref[v];
            precacl[i][j] = res;
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        cout << precacl[l][r] << ' ';
    }
}
