#include<bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int K = 26;

struct node {
    array<int, K> go;
    int suf = -1, term = -1, pterm = -1;

    node() {
        for (int i = 0; i < K; ++i)
            go[i] = -1;
    }
};

const int N = 1e6 + 10;
int curr = 1;
array<node, N> t;

void add_string(string &s, int i) {
    int v = 0;
    for (char c: s) {
        int x = c - 'a';
        if (t[v].go[x] == -1) {
            t[v].go[x] = curr;
            ++curr;
        }
        v = t[v].go[x];
    }
    t[v].term = i;
}

void build() {
    vector<pii> p(curr, {-1, -1});
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < K; ++i) {
            if (t[v].go[i] > 0) {
                p[t[v].go[i]] = {v, i};
                q.push(t[v].go[i]);
            }
        }
        if (p[v].first > 0)
            t[v].suf = t[t[p[v].first].suf].go[p[v].second];
        else
            t[v].suf = 0;
        if (t[t[v].suf].term != -1)
            t[v].pterm = t[v].suf;
        else
            t[v].pterm = t[t[v].suf].pterm;
        if (v != 0) {
            for (int i = 0; i < K; ++i) {
                if (t[v].go[i] == -1)
                    t[v].go[i] = t[t[v].suf].go[i];
            }
        }
    }
}

int cnt = 0;
vi len;
vector<vi> l;

void read(string &s) {
    int v = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        v = t[v].go[s[i] - 'a'];
        if (t[v].term != -1) {
            l[i].push_back(i - len[t[v].term] + 1);
            ++cnt;
        }
        for (int u = t[v].pterm; u != -1; u = t[u].pterm) {
            l[i].push_back(i - len[t[u].term] + 1);
            ++cnt;
        }
    }
}

const int R = (1 << 23);
array<int, R * 2> tr;

void update(int ul, int ur, int x, int v = 1, int lb = 0, int rb = R) {
    if (ul >= rb || lb >= ur)
        return;
    if (ul <= lb && rb <= ur) {
        tr[v] += x;
        return;
    }
    int m = (lb + rb) / 2;
    update(ul, ur, x, v * 2, lb, m);
    update(ul, ur, x, v * 2 + 1, m, rb);
}

int get(int i, int v = 1, int lb = 0, int rb = R) {
    if (rb - lb == 1)
        return tr[v];
    int m = (lb + rb) / 2;
    if (i < m)
        return get(i, v * 2, lb, m) + tr[v];
    else
        return get(i, v * 2 + 1, m, rb) + tr[v];
}

int main() {
    fast;
    int n, m;
    string s;
    cin >> n >> m >> s;
    len.resize(n);
    l.resize(s.size());
    for (int i = 0; i < n; ++i) {
        string ss;
        cin >> ss;
        len[i] = (int)ss.size();
        add_string(ss, i);
    }
    for (int i = 0; i < K; ++i) {
        if (t[0].go[i] == -1)
            t[0].go[i] = 0;
    }
    build();
    read(s);
    if (cnt > 1e7)
        return -1;
    vector<vector<pii>> r(s.size());
    for (int i = 0; i < m; ++i) {
        int lq, rq;
        cin >> lq >> rq;
        r[rq - 1].emplace_back(lq - 1, i);
    }
    vi ans(m);
    for (int i = 0; i < (int)s.size(); ++i) {
        for (int j: l[i])
            update(0, j + 1, 1);
        for (auto p: r[i]) {
            ans[p.second] = get(p.first);
        }
    }
    for (int i = 0; i < m; ++i)
        cout << ans[i] << ' ';
}
