#include <bits/stdc++.h>

using namespace std;

const int N = 1'000'000;

int t[26][N], idx[N], sufLink[N], p[N], pc[N], timer = 1, ssLink[N];

void add(const string &s, int i) {
    int v = 0;
    for (auto it : s) {
        if (t[it - 'a'][v] == 0) {
            pc[timer] = it - 'a';
            p[timer] = v;
            t[it - 'a'][v] = timer++;
        }
        v = t[it - 'a'][v];
    }
    idx[v] = i;
}

void build() {
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        if (p[v] != 0) {
            sufLink[v] = t[pc[v]][sufLink[p[v]]];
        }
        if (sufLink[v] != 0) {
            if (idx[sufLink[v]] != -1) {
                ssLink[v] = sufLink[v];
            } else {
                ssLink[v] = ssLink[sufLink[v]];
            }
        }
        for (auto & c : t) {
            if (c[v] == 0) {
                c[v] = c[sufLink[v]];
            } else {
                q.push(c[v]);
            }
        }
    }
}

int f = 431143;

int rng() {
    return f = f * 211312321 + 13312311241;
}

struct node {
    int x, y, cnt;
    size_t size;
    node *l, *r;

    explicit node(int v) : x(v), y(rng()), cnt(1), size(1), l(nullptr), r(nullptr) {};
};

size_t getSize(node *tr) {
    if (tr == nullptr) {
        return 0;
    }
    return tr->size;
}

void update(node *tr) {
    if (tr == nullptr) {
        return;
    }
    tr->size = getSize(tr->l) + getSize(tr->r) + tr->cnt;
}

node *merge(node *t1, node *t2) {
    if (t1 == nullptr) {
        return t2;
    }
    if (t2 == nullptr) {
        return t1;
    }
    if (t1->y > t2->y) {
        t1->r = merge(t1->r, t2);
        update(t1);
        return t1;
    } else {
        t2->l = merge(t1, t2->l);
        update(t2);
        return t2;
    }
}

pair<node*, node*> split(node *tr, int v) {
    if (tr == nullptr) {
        return {nullptr, nullptr};
    }
    if (v > tr->x) {
        auto[t1, t2] = split(tr->r, v);
        tr->r = t1;
        update(tr);
        return {tr, t2};
    } else {
        auto[t1, t2] = split(tr->l, v);
        tr->l = t2;
        update(tr);
        return {t1, tr};
    }
}

node *insert(node *tr, int x) {
    auto[t1, t23] = split(tr, x);
    auto[t2, t3] = split(t23, x + 1);
    if (t2 == nullptr) {
        return merge(merge(t1, new node(x)), t3);
    } else {
        t2->cnt++;
        update(t2);
        return merge(merge(t1, t2), t3);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    for (auto &it : idx) {
        it = -1;
    }

    int n, m;
    cin >> n >> m;

    string text;
    cin >> text;

    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        add(a[i], i);
    }

    build();

    vector<vector<int>> ans(n);
    int v = 0;
    for (int i = 0; i < (int) text.size(); i++) {
        v = t[text[i] - 'a'][v];
        int x = v;
        if (idx[v] != -1) {
            ans[idx[v]].push_back(i);
        }
        while (x > 0) {
            x = ssLink[x];
            if (idx[x] != -1) {
                ans[idx[x]].push_back(i);
            }
        }
    }

    vector<vector<int>> ans1(text.size());

    for (int i = 0; i < n; i++) {
        for (auto &it : ans[i]) {
            ans1[it - a[i].size() + 1].push_back(it);
        }
    }

    for (int i = 0; i < (int) text.size(); i++) {
        sort(ans1[i].begin(), ans1[i].end());
    }

    struct query {
        int l, r, idx;
    };

    vector<query> queries(m);
    for (int i = 0; i < m; i++) {
        cin >> queries[i].l >> queries[i].r;
        queries[i].l--;
        queries[i].r--;
        queries[i].idx = i;
    }

    sort(queries.begin(), queries.end(), [](query a, query b) {
        return a.l > b.l;
    });


    int j = (int) text.size() - 1;
    node *tr = nullptr;
    vector<int> ans_i(m);
    for (auto &it : queries) {
        while (j > -1 && j >= it.l) {
            for (auto it1 : ans1[j]) {
                tr = insert(tr, it1);
            }
            j--;
        }
        auto[t1, t2] = split(tr, it.r + 1);
        ans_i[it.idx] = (int) getSize(t1);
        tr = merge(t1, t2);
    }
    for (auto it : ans_i) {
        cout << it << " ";
    }
}////