#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define len(a) ll(a.size())

// author: @cot-in

const ll mod = 1e9 + 7;
const ll p = 40;

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

ll add(ll a, ll b) {
    return (a + b) % mod;
}

ll sub(ll a, ll b) {
    return (a - b + 2 * mod) % mod;
}

ll mul(ll a, ll b) {
    return (1ll * a * 1ll * b) % mod;
}

struct Hash {
    ll n;
    string s;
    vector<ll> hashes, pw;

    Hash() {}

    Hash(string ss) {
        s = ss;
        n = len(s);
        hashes.resize(n + 1, 0);
        pw.resize(n + 1, 1);
        build();
    }

    void build() {
        for (ll i = 1; i <= n; i++)
            hashes[i] = add(mul(hashes[i - 1], p), s[i - 1] - 'a' + 1);
        for (ll i = 1; i <= n; i++)
            pw[i] = mul(pw[i - 1], p);
    }

    ll get(ll l, ll r) {
        return sub(hashes[r], mul(hashes[l], pw[r - l]));
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash main(t);
    vector<Hash> s(n);
    for (ll i = 0; i < n; i++) {
        string x;
        cin >> x;
        s[i] = Hash(x);
//        cout << s[i].get(0, s[i].n) << endl;
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        ll cnt = 0;
        for (auto el: s) {
            for (ll i = l; i <= r - el.n + 1; i++) {
                if (el.get(0, el.n) == main.get(i, i + el.n)) {
//                    cout << el.get(0, el.n) << ' ' << i << ' ' << i + el.n - 1 << endl;
                    cnt++;
                }
            }
        }
        cout << cnt << ' ';
    }
    return 0;
}