#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define len(a) ll(a.size())

// author: @cot-in

const ll mod = 1e9 + 7;
const ll p = 40;
const ll mxn = 6000;

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

ll add(ll a, ll b) {
    return (a + b) % mod;
}

ll sub(ll a, ll b) {
    return (a - b + 2 * mod) % mod;
}

ll mul(ll a, ll b) {
    return (1ll * a * 1ll * b) % mod;
}

struct Hash {
    ll n;
    string s;
    vector<ll> hashes, pw;

    Hash() {}

    Hash(string ss) {
        s = ss;
        n = len(s);
        hashes.resize(n + 1, 0);
        pw.resize(n + 1, 1);
        build();
    }

    void build() {
        for (ll i = 1; i <= n; i++)
            hashes[i] = add(mul(hashes[i - 1], p), s[i - 1] - 'a' + 1);
        for (ll i = 1; i <= n; i++)
            pw[i] = mul(pw[i - 1], p);
    }

    ll get(ll l, ll r) {
        return sub(hashes[r], mul(hashes[l], pw[r - l]));
    }
};

ll hshs[mxn];
ll lengths[mxn];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash main(t);
    if (true) {
        for (ll i = 0; i < n; i++) {
            string x;
            cin >> x;
            hshs[i] = Hash(x).get(0, len(x));
            lengths[i] = len(x);
//        cout << s[i].get(0, s[i].n) << endl;
        }
        vector<vector<ll>> pref(n, vector<ll>(len(t)));
//    for (ll i = 0; i < n; i++) {
//        Hash el = s[i];
//        ll good = el.get(0, n);
//        for (ll j = 0; j <= len(t) - el.n + 1; j++) {
//            if (main.get(j, j + el.n) == good) {
//
//            }
//        }
//    }
        while (m--) {
            ll l, r;
            cin >> l >> r;
            l--;
            r--;
            ll cnt = 0;
            for (ll j = 0; j < n; j++) {
                for (ll i = l; i <= r - lengths[j] + 1; i++) {
                    if (hshs[j] == main.get(i, i + lengths[j])) {
//                    cout << el.get(0, el.n) << ' ' << i << ' ' << i + el.n - 1 << endl;
                        cnt++;
                    }
                }
            }
            cout << cnt << ' ';
        }
    } else {
        for (ll i = 0; i < n; i++) {
            string x;
            cin >> x;
            hshs[i] = Hash(x).get(0, len(x));
            lengths[i] = len(x);
        }
        vector<int> vc(len(t));
        for (ll i = 0; i < n; i++) {
            auto cur = hshs[i];
            auto l = lengths[i];
            for (ll j = 0; j <= len(t) - lengths[i] + 1; j++) {
                if (cur == main.get(j, j + l))
                    vc[j + l - 1]++;
            }
        }
        vector<ll> pref(len(t) + 1, 0);
        for (ll i = 0; i < len(t); i++)
            pref[i + 1] = pref[i] + vc[i];
        for (auto el: vc)
            cout << el << ' ';
        cout << endl;
        for (auto el: pref)
            cout << el << ' ';
        cout << endl;
        while (m--) {
            ll l, r;
            cin >> l >> r;
            r--;
            cout << pref[r] - pref[l] << endl;
        }
    }
    return 0;
}