#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

const int H = 31;
const int MOD = 1e9 + 7;

struct Hash {
    int n;
    vector<int> h, p;

    Hash(const string& s) {
        n = (int)s.size();
        p.resize(n + 1);
        p[0] = 1;
        h.resize(n + 1);
        h[0] = 0;
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] * H) % MOD;
            h[i] = ((h[i - 1] * H) % MOD + s[i - 1]) % MOD;
        }
    }

    int get(int l, int r) {
        return (h[r] + MOD * MOD - p[r - l + 1] * h[l - 1]) % MOD;
    }
};

int num_hash(const string &s) {
    int h = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        h = ((h * H) % MOD + s[i]) % MOD;
    }
    return h;
}

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;

    Hash h(s);
    unordered_set<int> st;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        st.insert(num_hash(t));
    }
    for (; q; --q) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int x = l; x <= r; x++) {
            for (int y = l; y <= r; y++) {
                if (st.find(h.get(x, y)) != st.end())
                    ans++;
            }
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}