#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

const int H1 = 31;
const int H2 = 37;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;

struct Hash {
    int n;
    vector<int> h1, p1;
    vector<int> h2, p2;

    Hash(const string& s) {
        n = (int)s.size();
        p1.resize(n + 10);
        p1[0] = 1;
        h1.resize(n + 10);
        h1[0] = 0;

        p2.resize(n + 10);
        p2[0] = 1;
        h2.resize(n + 10);
        h2[0] = 0;

        for (int i = 1; i <= n; i++) {
            p1[i] = (p1[i - 1] * H1) % MOD1;
            h1[i] = ((h1[i - 1] * H1) % MOD1 + s[i - 1]) % MOD1;

            p2[i] = (p2[i - 1] * H2) % MOD2;
            h2[i] = ((h2[i - 1] * H2) % MOD2 + s[i - 1]) % MOD2;
        }
    }

    pair<int, int> get(int l, int r) {
        //cout << '&' << l << ' ' << r << ' ' << r - l + 1 << '\n';
        //assert(l - 1 > 0);
        int a = (h1[r] + MOD1 * MOD1 - p1[r - l + 1] * h1[l - 1]) % MOD1;
        int b = (h2[r] + MOD2 * MOD2 - p2[r - l + 1] * h2[l - 1]) % MOD2;
        return {a, b};
    }

};

int num_hash1(const string &s) {
    int h = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        h = ((h * H1) % MOD1 + s[i]) % MOD1;
    }
    return h;
}

int num_hash2(const string &s) {
    int h = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        h = ((h * H2) % MOD2 + s[i]) % MOD2;
    }
    return h;
}

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;

    Hash h(s);
    set< pair<int, int> > st;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        st.insert({num_hash1(t), num_hash2(t)});
    }
    for (; q; --q) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int x = l; x <= r; x++) {
            for (int y = x; y <= r; y++) {
                if (st.find(h.get(x, y)) != st.end())
                    ans++;
            }
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}
