#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

const int H1 = 31;
const int H2 = 37;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;

struct Hash {
    int n;
    vector<int> h1, p1;
    vector<int> h2, p2;

    Hash(const string& s) {
        n = (int)s.size();
        p1.resize(n + 10);
        p1[0] = 1;
        h1.resize(n + 10);
        h1[0] = 0;

        p2.resize(n + 10);
        p2[0] = 1;
        h2.resize(n + 10);
        h2[0] = 0;

        for (int i = 1; i <= n; i++) {
            p1[i] = (p1[i - 1] * H1) % MOD1;
            h1[i] = ((h1[i - 1] * H1) % MOD1 + s[i - 1]) % MOD1;

            p2[i] = (p2[i - 1] * H2) % MOD2;
            h2[i] = ((h2[i - 1] * H2) % MOD2 + s[i - 1]) % MOD2;
        }
    }

    pair<int, int> get(int l, int r) {
        //cout << '&' << l << ' ' << r << ' ' << r - l + 1 << '\n';
        //assert(l - 1 > 0);
        int a = (h1[r] + MOD1 * MOD1 - p1[r - l + 1] * h1[l - 1]) % MOD1;
        int b = (h2[r] + MOD2 * MOD2 - p2[r - l + 1] * h2[l - 1]) % MOD2;
        return {a, b};
    }

};

int num_hash1(const string &s) {
    int h = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        h = ((h * H1) % MOD1 + s[i]) % MOD1;
    }
    return h;
}

int num_hash2(const string &s) {
    int h = 0;
    for (int i = 0; i < (int)s.size(); i++) {
        h = ((h * H2) % MOD2 + s[i]) % MOD2;
    }
    return h;
}

void solve() {
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    int m = (int)s.size();

    Hash h(s);
    vector< pair<int, pair<int, int>> > v;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        v.push_back({(int)t.size(), {num_hash1(t), num_hash2(t)}});
    }
    vector< pair<int, int> > p;
    vector<int> ans(q, 0);
    for (; q; --q) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        p.emplace_back(l, r);
    }
    for (auto &[sz, pr] : v) {
        for (int i = 0; i + sz - 1 < m; i++) {
            if (pr == h.get(i + 1, i + sz - 1 + 1)) {
                int it = 0;
                for (auto &j : p) {
                    if (j.ff <= i && i + sz - 1 <= j.ss)
                        ans[it]++;
                    it++;
                }
            }
        }
    }
    for (auto &i : ans)
        cout << i << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}