#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

struct fenwick {

    fenwick(int n) : n(n) {
        v.resize(n);
    }

    void add(int r, int x) {
        for (; r < n; r = r | (r + 1)) {
            v[r] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            s += v[r];
        }
        return s;
    }

    int n;
    vector<ll> v;

};

struct qr {

    qr() {}
    qr(int l, int r, int i) : l(l), r(r), i(i) {}

    int l, r, i;

};

int n, m;
string t;
vector<string> s;
vector<qr> qrs;

vector<vector<int>> go;
vector<int> suff, supersuff, term, d;

void solve() {

    cin >> n >> m;
    cin >> t;
    s.resize(n);
    for (auto& x : s) cin >> x;
    qrs.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> qrs[i].l >> qrs[i].r;
        qrs[i].l--, qrs[i].r--;
        qrs[i].i = i;
    }

//    sort(all(s));
//    vector<int> cnt;
//    for (int i = 0; i < n; i++) {
//        if (i == 0 || s[i - 1] != s[i]) cnt.push_back(1);
//        else cnt.back()++;
//    }
//    s.resize(unique(all(s)) - s.begin());

    go.emplace_back(26, -1);
    suff.push_back(0);
    supersuff.push_back(0);
    term.push_back(0);
    d.push_back(0);

    for (int i = 0; i < n; i++) {
        int v = 0;
        for (char j : s[i]) {
            if (go[v][j - 'a'] == -1) {
                go[v][j - 'a'] = go.size();
                go.emplace_back(26, -1);
                suff.push_back(0);
                supersuff.push_back(0);
                term.push_back(0);
                d.push_back(d[v] + 1);
            }
            v = go[v][j - 'a'];
        }
        term[v] = 1;
    }

    queue<int> q;
    vector<int> used(go.size());
    used[0] = 1;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int i = 0; i < 26; i++) {
            if (go[v][i] == -1) {
                if (v == 0) go[v][i] = 0;
                else go[v][i] = go[suff[v]][i];
            } else {
                if (v == 0) suff[go[v][i]] = supersuff[go[v][i]] = 0;
                else {
                    suff[go[v][i]] = go[suff[v]][i];
                    if (term[suff[go[v][i]]] > 0) supersuff[go[v][i]] = suff[go[v][i]];
                    else supersuff[go[v][i]] = supersuff[suff[go[v][i]]];
                }
                if (!used[go[v][i]]) {
                    q.push(go[v][i]);
                    used[go[v][i]] = 1;
                }
            }
        }
    }

    vector<vector<int>> pos(go.size());
    int v = 0;
    for (int i = 0; i < t.size(); i++) {
        v = go[v][t[i] - 'a'];
        pos[v].push_back(i);
    }

    vector<vector<int>> l(t.size());
    for (int i = go.size() - 1; i > 0; i--) {
        for (int x : pos[i]) {
            if (term[i] > 0) {
                l[x].push_back(x - d[i] + 1);
            }
            pos[supersuff[i]].push_back(x);
        }
    }

//    for (int i = 0; i < t.size(); i++) {
//        cout << i << ": ";
//        for (auto [j, x] : l[i]) {
//            cout << j << " " << x << ", ";
//        }
//        cout << "\n";
//    }

    sort(all(qrs), [](qr a, qr b) {
        return a.r < b.r;
    });

    fenwick f(t.size());
    vector<ll> ans(m);

    int ptr = 0;
    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < l[i].size(); j++) {
            f.add(l[i][j], 1);
        }
        while (ptr < m && qrs[ptr].r == i) {
            ans[qrs[ptr].i] = f.get(t.size() - 1) - f.get(qrs[ptr].l - 1);
            ptr++;
        }
    }

    cout << ans;

}
//
//5 5
//abcde
//        acbdcfsdbf
//dfgfdg
//        sdfhsd
//a
//        bc
//1 2
//2 3
//1 5
//2 5
//3 4

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cout << setprecision(10) << fixed;
    solve();

}