#pragma GCC target("avx2,bmi,bmi2,lzcnt,sse4.2")
#pragma GCC optimize("O3,unroll-loops,Ofast,fast-math")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;
const int K = 2e9 + 100;
const int N = 5e6 + 10;
const int B = 31;
const int B2 = 37;
ll p[N], p2[N], h[N], h2[N];

pll HASH(string &s)
{
    int n = sz(s);
    ll H = 0;
    for (int i = 0; i < n; i++) (H += (ll)(s[i] - 'a' + 1) * p[i]) %= mod;
    (H *= p[N - n]) %= mod;
    ll H2 = 0;
    for (int i = 0; i < n; i++) (H2 += (ll)(s[i] - 'a' + 1) * p2[i]) %= mod2;
    (H2 *= p2[N - n]) %= mod2;
    return {H, H2};
}

ll hsh(pll H)
{
    return H.f * K + H.s;
}

vec<int> vals[4 * N];
vec<int> init[N];

vec<int> merge(const vec<int> &a, const vec<int> &b)
{
    int n = sz(a), m = sz(b);
    int i = 0, j = 0;
    vec<int> res;
    while (i < n || j < m)
    {
        if (i == n) res.pb(b[j++]);
        else if (j == m) res.pb(a[i++]);
        else
        {
            if (a[i] < b[j]) res.pb(a[i++]);
            else res.pb(b[j++]);
        }
    }
    return res;
}

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        vals[v] = init[tl];
        return;
    }
    int m = tl + tr >> 1;
    build(2 * v + 1, tl, m);
    build(2 * v + 2, m + 1, tr);
    vals[v] = merge(vals[2 * v + 1], vals[2 * v + 2]);
}

int get(int l, int r, int v, int tl, int tr)
{
    if (tl > r || tr < l) return 0;
    if (tl >= l && tr <= r) return upper_bound(all(vals[v]), r) - vals[v].begin();
    int m = tl + tr >> 1;
    return get(l, r, 2 * v + 1, tl, m) + get(l, r, 2 * v + 2, m + 1, tr);
}

pll get_hash(int l, int r)
{
    ll H = (h[r] - (l - 1 >= 0 ? h[l - 1] : 0) + mod) * p[N - r - 1] % mod;
    ll H2 = (h2[r] - (l - 1 >= 0 ? h2[l - 1] : 0) + mod2) * p2[N - r - 1] % mod2;
    return {H, H2};
}

void solve()
{
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int len = sz(t);
    vec<string> s(n);
    set<int> lens;
    gp_hash_table<int, int> exists;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
        pll H = HASH(s[i]);
        lens.insert(sz(s[i]));
        exists[hsh(H)] = 1;
    }
    for (int i = 0; i < len; i++)
    {
        if (i > 0)
        {
            h[i] += h[i - 1];
            h2[i] += h2[i - 1];
        }
        (h[i] += (ll)(t[i] - 'a' + 1) * p[i]) %= mod;
        (h2[i] += (ll)(t[i] - 'a' + 1) * p2[i]) %= mod2;
    }
    for (int start = 0; start < len; start++)
    {
        for (auto &L : lens)
        {
            int end = start + L - 1;
            if (end >= len) break;
            pii H = get_hash(start, end);
            if (exists[hsh(H)]) init[start].pb(end);
        }
    }
    build(0, 0, len - 1);
    while (m--)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        cout << get(l, r, 0, 0, len - 1) << " ";
    }
}

void precalc()
{
    p[0] = 1;
    for (int i = 1; i < N; i++) p[i] = p[i - 1] * B % mod;
    p2[0] = 1;
    for (int i = 1; i < N; i++) p2[i] = p2[i - 1] * B2 % mod2;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    precalc();
    solve();
    return 0;
}
