#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
#include <unordered_map>

using namespace std;

struct query {
	int l, r, id;
	query(int l0, int r0, int i) {
		l = l0;
		r = r0;
		id = i;
	}
};

const int MAXC = 1e6 + 7;
vector <string> s[MAXC];

const int base = 179;
const int mod = 1791791791;
int b[MAXC];

void calc_b() {
	b[0] = 1;
	for (int i = 1; i < MAXC; i++)
		b[i] = (1ll * b[i - 1] * base) % mod;
}

int myhash(string& s) {
	int res = 0;
	for (auto e : s)
		res = (res * 1ll * base + (e - 'a' + 1)) % mod;
	return res;
}

vector <int> pref;
void calc_pref(string& s) {
	int n = (int)s.size();
	pref.resize(n);
	pref[0] = (s[0] - 'a' + 1);
	for (int i = 1; i < n; i++)
		pref[i] = (1ll * pref[i - 1] * base + (s[i] - 'a' + 1)) % mod;
}

int get_hash(int l, int r) {
	if (l == 0)
		return pref[r];
	int h = (pref[r] - pref[l - 1] * 1ll * b[r - l + 1]) % mod;
	if (h < 0)
		h += mod;
	return h;
}

void solve() {
	calc_b();

	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	int sz = (int)t.size();
	calc_pref(t);
	string temp;
	for (int i = 0; i < n; i++) {
		cin >> temp;
		s[(int)temp.size()].push_back(temp);
	}
	vector <query> q;
	vector <long long> ans(m, 0);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		q.push_back(query(l, r, i));
	}


	for (int len = 1; len < MAXC; len++) {
		if (s[len].empty())
			continue;
		unordered_map <int, bool> good_hash;
		for (auto e : s[len])
			good_hash[myhash(e)] = true;
		vector <int> a(sz, 0);
		for (int l = 0; l + len - 1 < sz; l++) {
			int r = l + len - 1;
			if (good_hash[get_hash(l, r)])
				a[l]++;
		}
		vector <long long> sum(sz + 1, 0);
		for (int i = 1; i <= sz; i++)
			sum[i] = sum[i - 1] + a[i - 1];
		for (auto e : q) {
			if (e.r - e.l + 1 < len)
				continue;
			int l = e.l;
			int r = e.r - len + 1;
			ans[e.id] += (sum[r + 1] - sum[l]);
		}
	}
	for (auto e : ans)
		cout << e << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}