#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <cassert>
#define int long long
#define all(a) a.begin(), a.end()
using namespace std;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
using namespace std;
const int C = 800;
struct Tp {
	int a, b;
	Tp() {
		a = b = 0;
	}
	Tp(int a1, int a2) : a(a1), b(a2) { }
	bool operator==(const Tp& other) {
		return a == other.a && b == other.b;
	}
};
const int mod1 = 1e9 + 7, mod2 = 1e9 + 9;
const int b1 = 1000003, b2 = 1410361;
//14248343
struct Hash {
	int n;
	vector<Tp> h;
	vector<Tp> pw;
	Tp all_h;
	bool operator<(const Hash& other) {
		return n < other.n;
	}
	Hash(int _n, string& s, int tp) : n(_n) {
		if (tp == 1) {
			h.resize(_n + 1);
			pw.resize(_n + 1);
			h[0] = { 0, 0 };
			pw[0] = { 1, 1 };
			for (int i = 1; i <= _n; i++) {
				h[i].a = ((h[i - 1].a + (s[i - 1] - 'a' + 1ll)) * b1) % mod1;
				h[i].b = ((h[i - 1].b + (s[i - 1] - 'a' + 1ll)) * b2) % mod2;
				pw[i].a = (pw[i - 1].a * b1) % mod1;
				pw[i].b = (pw[i - 1].b * b2) % mod2;
			}
			all_h = h.back();
		}
		if (tp == 2) {
			all_h = { 0, 0 };
			for (int i = 1; i <= _n; i++) {
				all_h.a = (((all_h.a + (s[i - 1] - 'a' + 1ll)) * b1) % mod1);
				all_h.b = ((all_h.b + (s[i - 1] - 'a' + 1ll)) * b2) % mod2;
			}
		}
	}
	Tp get_all() {
		return all_h;
	}
	int Big_hash_all() {
		return all_h.a + all_h.b * 14248343ll;
	}
	Tp get_hash(int l, int r) {
		Tp res;
		res.a = (h[r + 1].a - (h[l].a * pw[(r - l + 1ll)].a) % mod1 + mod1) % mod1;
		res.b = (h[r + 1].b - (h[l].b * pw[(r - l + 1ll)].b) % mod2 + mod2) % mod2;
		return res;
	}
	int Big_hash(int l, int r) {
		Tp rs = get_hash(l, r);
		return rs.a + rs.b * 14248343ll;
	}
};
vector<int> pref_C;
vector<vector<int>> C_buf;
vector<vector<int>> C_del;
void solve1(Hash& Text, vector<Hash>& small) {
	pref_C.resize(Text.n + 1, 0); C_buf.resize(C + 1, vector<int>(Text.n + 1, 0));
	C_del.resize(C + 1, vector<int>(Text.n + 1, 0));
	unordered_set<int> hashs;
	for (Hash& i : small) {
		hashs.insert(i.Big_hash_all());
	}
	for (int i = 0; i < Text.n; i++) {
		pref_C[i + 1] += pref_C[i];
		for (int j = i; j <= min(j + C - 1, Text.n - 1); j++) {
			if (hashs.find(Text.Big_hash(i, j)) != hashs.end()) {
				C_buf[j - i + 1][i + 1] += 1;
				pref_C[i + 1] += 1;
			}
		}
		for (int j = C - 1; j >= 0; j--) {
			C_buf[j][i + 1] += C_buf[j + 1][i + 1];
		}
		int it = 2;
		for (int j = i; j + C - 1 > i && j >= 0; j--) {
			C_del[it][i + 1] += C_buf[it][j + 1];
			C_del[it][i + 1] += C_del[it - 1][i + 1];
			it++;
		}
	}

}
vector<vector<int>> scan;
void solve2(Hash& Text, vector<Hash>& big) {
	scan.resize(Text.n);
	for (int i = 0; i < Text.n; i++) {
		for (int j = 0; j < (int)big.size(); j++) {
			if (i + big[j].n - 1ll >= Text.n) { continue; }
			if (Text.get_hash(i, i + big[j].n - 1ll) == big[j].get_all()) {
				scan[i + big[j].n - 1ll].push_back(i);
			}
		}
	}
}
int get_ans_small(int l, int r) {
	int ans = 0;
	{
		int ans1 = pref_C[r + 1] - pref_C[l];
		int it = 2;
		if (r - l + 1 >= C) {
			ans1 -= C_del[C][r + 1];
		}
		else {
			ans1 -= C_del[r - l + 2][r + 1];
		}
		ans += ans1;
	}
	return ans;
}
struct Fenwick {
	int n; 
	vector<int> t;
	Fenwick(int _n) : n(_n) {
		t.resize(_n + 1ll);
	}
	void update(int i, int x) {
		for (; i <= n; i += i & -i) {
			t[i] += x;
		}
	}
	int get(int i) {
		int res = 0;
		for (; i; i -= i & -i) {
			res += t[i];
		}
		return res;
	}
	int sum(int l, int r) {
		return get(r) - get(l - 1);
	}
};

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m; cin >> n >> m;
	string t; cin >> t;
	Hash Text((int)t.size(), t, 1ll);
	vector<Hash> big, small;
	vector<int> sizes_big;
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		if ((int)s.size() <= C) {
			small.push_back(Hash((int)s.size(), s, 2ll));
		}
		else {
			sizes_big.push_back((int)s.size());
			big.push_back(Hash((int)s.size(), s, 2ll));
		}
	}
	solve1(Text, small);
	solve2(Text, big);
	vector<int> ans(m);
	vector<vector<pair<int, int>>> query((int)t.size());
	for (int i = 0; i < m; i++) {
		int l, r; cin >> l >> r;
		query[r - 1].push_back({ i, l - 1 });
		ans[i] += get_ans_small(l - 1ll, r - 1ll);
	}
	Fenwick T((int)t.size());
	for (int i = 0; i < (int)t.size(); i++) {
		for (int& x : scan[i]) {
			T.update(x + 1, 1ll);
		}
		for (auto&& [ind, pos] : query[i]) {
			ans[ind] += T.sum(pos + 1, i);
		}
	}
	for (int& i : ans) {
		cout << i << ' ';
	}
}