#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = unsigned long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const ll LL_INF = 2e18 + 10;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

struct Hash {
    string s;
    int n;
    ll base;
    vector<ll> p;
    vector<ll> hash;
    Hash() : n(0), base(0) {}
    Hash(string& _s, ll _base) : s(_s), base(_base) {
        n = s.size();
        p.resize(n);
        hash.resize(n);
        p[0] = 1;
        hash[0] = s[0] - 'a' + 1;
        for (int i = 1; i < n; i++) {
            p[i] = p[i - 1] * base;
            hash[i] = hash[i - 1] * base + s[i] - 'a' + 1;
        }
    }
    ll get(int l, int r) {
        if (l == 0) {
            return hash[r];
        }
        return hash[r] - hash[l - 1] * p[r - l + 1];
    }
};

struct Node {
    int to[26];
    bool ends_here;
    Node() {
        ends_here = false;
        for (int i = 0; i < 26; i++) {
            to[i] = -1;
        }
    }
};

vector<Node> trie;

void add(int u, const string& s, int i) {
    if (i == (int)s.size()) {
        trie[u].ends_here = true;
        return;
    }
    int c = s[i] - 'a';
    if (trie[u].to[c] == -1) {
        trie[u].to[c] = trie.size();
        trie.emplace_back();
    }
    add(trie[u].to[c], s, i + 1);
}

int contains(int u, const string& s, int i) {
    int to_add = 0;
    if (trie[u].ends_here) {
        to_add++;
    }
    if (i == s.size()) {
        return to_add;
    }
    char c = s[i] - 'a';
    if (trie[u].to[c] == -1) {
        return to_add;
    }
    return to_add + contains(trie[u].to[c], s, i + 1);
}

int main() {
    trie.emplace_back();
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        add(0, s[i], 0);
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        ll ans = 0;
        for (int i = l; i <= r; i++) {
            string sub;
            for (int j = i; j <= r; j++) {
                sub.push_back(t[j]);
            }
            ans += contains(0, sub, 0);
        
        }
        cout << ans << ' ';
    }
}
