#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

#ifndef LOCAL
constexpr int maxmem = 1e9;
char mem[maxmem];
int mpos = 0;

void *operator new(size_t n) {
    assert((mpos += n) <= maxmem);
    return mem + mpos - n;
}

void operator delete(void *) noexcept {}
#endif

struct Hash {
    static constexpr ll base = 239, mod = (1ull << 63) - 457;
    vector<ll> pref, pow_base;

    Hash(string s) {
        int n = s.size();
        pref.resize(n + 1);
        pow_base.resize(n + 1);
        pow_base[0] = 1;
        for (int i = 0; i < n; ++i) {
            pref[i + 1] = ((pref[i] * (__int128) base) + s[i] - 'a' + 1) % mod;
            pow_base[i + 1] = (pow_base[i] * (__int128) base) % mod;
        }
    }

    ll get(int l, int r) {
        return ((pref[r] - (pref[l] * (__int128) pow_base[r - l]) % mod) % mod + mod) % mod;
    }
};

struct Fenwick {
    vector<int> t;
    int n;

    Fenwick(int n) : n(n) {
        t.resize(n + 1);
    }

    void add(int i, int x) {
        for (++i; i <= n; i += i & (-i)) {
            t[i] += x;
        }
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & (-i)) {
            ans += t[i];
        }
        return ans;
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash ht(t);
    vector<int> lens;
    vector<ll> hh;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        ll cur = 0;
        for (char j : s) {
            cur = (cur * (__int128) Hash::base + j - 'a' + 1) % Hash::mod;
        }
        hh.push_back(cur);
        lens.push_back(s.size());
    }
    sort(lens.begin(), lens.end());
    lens.resize(unique(lens.begin(), lens.end()) - lens.begin());
    sort(hh.begin(), hh.end());
    vector<pair<int, int>> pos;
    for (int r = 0; r < (int) t.size(); ++r) {
        for (int len : lens) {
            int l = r - len + 1;
            if (l < 0) {
                continue;
            }
            ll cur = ht.get(l, l + len);
            if (binary_search(hh.begin(), hh.end(), cur)) {
                pos.push_back({l, r});
            }
        }
    }
    vector<array<int, 3>> q;
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        q.push_back({l, r, i});
//        int ans = 0;
//        for (auto [li, ri] : pos) {
//            if (l <= li && ri < r) {
//                ++ans;
//            }
//        }
//        cout << ans << " ";
    }
//    sort(pos.begin(), pos.end(), [&](const pair<int, int> &a, const pair<int, int> &b) {
//        return a.second < b.second || (a.second == b.second && a.first < b.first);
//    });
    sort(q.begin(), q.end(), [&](const array<int, 3> &a, const array<int, 3> &b) {
        return a[1] < b[1] || (a[1] == b[1] && a[0] < b[0]);
    });
    // l <= pos[i].first && pos[i].second < r
    Fenwick st(t.size());
    int ind = 0;
    vector<int> ans(m);
    for (auto [l, r, i] : q) {
        while (ind < (int) pos.size() && pos[ind].second < r) {
            st.add(pos[ind].first, 1);
            ++ind;
        }
        ans[i] = st.get(l, r);
    }
    for (int i : ans) {
        cout << i << " ";
    }
}
