#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

const int MOD1 = 1e9 + 7;
const int MOD2 = 1'575'179;

const int BASE = 29;

string read_string() {
    string s;
    cin >> s;
    for (char& ch : s) {
        ch = ch - 'a' + 1;
    }
    return s;
}

struct Hash {
    int val1;
    int val2;

    Hash() {}
    Hash(int val) : val1(val), val2(val) {}
    Hash(int val1, int val2) : val1(val1), val2(val2) {}
};

bool operator < (const Hash& a, const Hash& b) {
    if (a.val1 != b.val1) {
        return a.val1 < b.val1;
    }
    return a.val2 < b.val2;
}

bool operator == (const Hash& a, const Hash& b) {
    return a.val1 == b.val1 && a.val2 == b.val2;
}

Hash operator + (const Hash& a, const Hash& b) {
    return Hash(a.val1 + b.val1 >= MOD1 ? a.val1 + b.val1 - MOD1 : a.val1 + b.val1,
                a.val2 + b.val2 >= MOD2 ? a.val2 + b.val2 - MOD2 : a.val2 + b.val2);
}

Hash operator - (const Hash& a, const Hash& b) {
    return Hash(a.val1 >= b.val1 ? a.val1 - b.val1 : a.val1 - b.val1 + MOD1,
                a.val2 >= b.val2 ? a.val2 - b.val2 : a.val2 - b.val2 + MOD2);
}

Hash operator * (const Hash& a, const Hash& b) {
    return Hash(1ll * a.val1 * b.val1 % MOD1, 1ll * a.val2 * b.val2 % MOD2);
}
Hash get_hash_str(const string& s) {
    Hash ans = 0;
    for (char ch : s) {
        ans = ans * BASE + ch;
    }
    return ans;
}

struct Hasher {
    int operator() (const Hash& ha) const {
        return ha.val1 ^ ha.val2;
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n, m;
    cin >> n >> m;
    string t = read_string();
    int len = (int)t.size();
    t = " " + t;
    vector<string> v(n);
    for (string& s : v) {
        s = read_string();
    }
    vector<int> lens(n);
    for (int i = 0; i < n; ++i) {
        lens[i] = (int)v[i].size();
    }
    sort(all(lens));
    int len_lens = unique(all(lens)) - lens.begin();
    lens.resize(len_lens);

    vector<vector<string>> strings(len_lens);
    for (int i = 0; i < n; ++i) {
        int pos = lower_bound(all(lens), (int)v[i].size()) - lens.begin();
        strings[pos].push_back(move(v[i]));
    }

    vector<Hash> p(len + 1);
    p[0] = 1;
    for (int i = 1; i <= len; ++i) {
        p[i] = p[i - 1] * BASE;
    }
    vector<Hash> h(len + 1);
    h[0] = 0;
    for (int i = 1; i <= len; ++i) {
        h[i] = h[i - 1] * BASE + t[i];
    }

    vector<vector<int>> pref(len_lens, vector<int>(len + 1));

    for (int i = 0; i < len_lens; ++i) {
        unordered_set<Hash, Hasher> st;
        for (const string& s : strings[i]) {
            st.insert(get_hash_str(s));
        }
        for (int j = lens[i]; j <= len; ++j) {
            Hash ha = h[j] - h[j - lens[i]] * p[lens[i]];
            if (st.find(ha) != st.end()) {
                ++pref[i][j];
            }
        }
    }
    for (int i = 0; i < len_lens; ++i) {
        for (int j = 1; j <= len; ++j) {
            pref[i][j] += pref[i][j - 1];
        }
    }
    for (int _ = 0; _ < m; ++_) {
        int l, r;
        cin >> l >> r;
        long long ans = 0;
        int le = r - l + 1;
        for (int i = 0; i < len_lens && le >= lens[i]; ++i) {
            ans += pref[i][r] - pref[i][l + lens[i] - 2];
        }
        cout << ans << ' ';
    }
}