#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>
#include <random>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) ((n >> i) & 1)
#define ull unsigned long long

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
//#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

struct node {
	map<char, node*> mp;
	ll add = 0;

	void add_f(string& s, int i) {
		if (i == s.size()) {
			this->add++;
			re;
		}

		if (mp[s[i]] == nullptr)
			mp[s[i]] = new node();

		mp[s[i]]->add_f(s, i + 1);
	}

	void cnt(string& s, int i, vector<ll>& v) {
		if (i != 0)v[i - 1] = add;

		if (i == s.size()) re;

		if (mp[s[i]] == nullptr) re;

		mp[s[i]]->cnt(s, i + 1, v);
	}
};

node* bor = new node();

ull key = 29;

void solve2(int n, int m, string& t) {
	vector<ull> pw(t.size() + 1);
	pw[0] = 1;
	for (int i = 1; i <= t.size(); i++)
		pw[i] = pw[i - 1] * key;

	vector<string> v(n);
	cin >> v;
	vector<ull> hash(t.size() + 1);

	for (int i = t.size() - 1; i >= 0; i--) {
		hash[i] = hash[i + 1] * key + t[i];
	}

	vector<vector<ll>> dp(t.size() + 1, vector<ll>(t.size() + 1));

	fori(v.size()) {
		ull h = 0;
		for (int j = v[i].size() - 1; j >= 0; j--)
			h = h * key + v[i][j];

		forj(t.size()) {
			if (j + v[i].size() > t.size())continue;

			if (j + v[i].size() <= t.size() && hash[j] - hash[j + v[i].size()] * pw[v[i].size()] == h) {
				dp[j + 1][j + v[i].size()]++;
			}
		}
	}

	fori(t.size())
		forj(t.size())
		dp[i + 1][j + 1] += dp[i][j + 1] + dp[i + 1][j] - dp[i][j];

	while (m--) {
		ll l, r; cin >> l >> r;
		l--;

		cout << dp[r][r] - dp[r][l] - dp[l][r] + dp[l][l] << "\n";
	}
}

int main() {
	preproc; fast_io;

	int n, m; cin >> n >> m;
	string t; cin >> t;

	if (n <= 100) {
		solve2(n, m, t);
		re 0;
	}

	fori(n) {
		string a; cin >> a;
		bor->add_f(a, 0);
	}

	vector<vector<ll>> dp(t.size(), vector<ll>(t.size()));

	fori(t.size()) {
		bor->cnt(t, i, dp[i]);
	}

	vector<vector<ll>> dp2(t.size() + 1, vector<ll>(t.size() + 1));

	fori(t.size()) {
		forj(t.size()) {
			dp2[i + 1][j + 1] = dp2[i][j + 1] + dp2[i + 1][j] - dp2[i][j] + dp[i][j];
			cout << dp2[i + 1][j + 1] << " \n"[j == t.size() - 1];
		}
	}

	while (m--) {
		ll l, r; cin >> l >> r;
		l--;
		cout << dp2[r][r] - dp2[r][l] - dp2[l][r] + dp2[l][l] << " ";
	}
}