#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Hash {
    int p = 179, m = 1e9 + 7;
    vector<int> h, pr;

    int mul(int a, int b) {
        return a * 1ll * b % m;
    }

    int sum(int a, int b) {
        a += b;
        if (a >= m) a -= m;
        return a;
    }

    int sub(int a, int b) {
        a -= b;
        if (a < 0) a += m;
        return a;
    }

    Hash(string s) {
        int n = s.size();
        h.resize(n);
        pr.resize(n + 1);
        pr[0] = 1;
        h[0] = s[0];
        for (int i = 1; i <= n; i++) pr[i] = mul(pr[i - 1], p);
        for (int i = 1; i < n; i++) h[i] = sum(s[i], mul(h[i - 1], p));
    }

    int get(int l, int r) {
        return sub(h[r], (l == 0 ? 0 : mul(h[l - 1], pr[r - l + 1])));
    }
};

bool comp(Hash &a, Hash &b) { return a.h.size() < b.h.size(); }

vector<vector<int>> tree;
vector<vector<int>> a;

void build(int v, int lv, int rv) {
    if (lv == rv - 1) {
        tree[v] = a[lv];
        return;
    }
    int mid = (lv + rv) / 2;
    build(2 * v + 1, lv, mid);
    build(2 * v + 2, mid, rv);
    for (auto i: tree[2 * v + 1]) tree[v].push_back(i);
    for (auto i: tree[2 * v + 2]) tree[v].push_back(i);
    sort(tree[v].begin(), tree[v].end());
}

int get(int v, int lv, int rv, int l, int r, int s) {
    if (l >= rv || lv >= r) return 0;
    if (l <= lv && rv <= r) return upper_bound(tree[v].begin(), tree[v].end(), s) - tree[v].begin();
    int mid = (lv + rv) / 2;
    return get(2 * v + 1, lv, mid, l, r, s) + get(2 * v + 2, mid, rv, l, r, s);
}

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    string t;
    cin >> n >> m >> t;
    int sz = 1;
    while (sz <= t.size()) sz *= 2;
    tree.resize(sz * 4);
    a.resize(sz * 4);
    Hash p(t);
    vector<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        Hash e(s);
        st.push_back({e.h.size(), e.h.back()});
    }
    sort(st.begin(), st.end());
    for (auto e: st) {
        for (int j = 0; j + e.first - 1 < t.size(); j++) {
            if (p.get(j, j + e.first - 1) == e.second) a[j].push_back(j + e.first - 1);
        }
    }
    build(0, 0, sz);
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = get(0, 0, sz, l, r + 1, r);
        cout << ans << ' ';
    }
    return 0;
}