#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 5e6 + 1, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

struct mint {
    int x;

    mint(int x_ = 0) {
        x = x_;
    }

    mint operator+(const mint &oth) const {
        return x + oth.x >= MOD ? x + oth.x - MOD : x + oth.x;
    }

    mint operator-(const mint &oth) const {
        return x - oth.x < 0 ? x - oth.x + MOD : x - oth.x;
    }

    mint operator*(const mint &oth) const {
        return (1LL * x * oth.x) % MOD;
    }

    bool operator==(const mint &oth) const {
        return x == oth.x;
    }
};

mint pw[MAXN];

const mint P = 31;

void init() {
    pw[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        pw[i] = pw[i - 1] * P;
    }
}

mint get_hash(const string &s) {
    mint hsh = 0;
    for (auto &el: s) {
        hsh = (hsh + (el - 'a' + 1)) * P;
    }
    return hsh;
}

struct Hash {
    vector<mint> hs;

    Hash(const string &s) {
        hs.resize(s.size() + 1, 0);
        for (int i = 0; i < s.size(); ++i) {
            hs[i + 1] = (hs[i] + (s[i] - 'a' + 1)) * P;
        }
    }

    mint get(int l, int r) {
        return hs[r] - hs[l - 1] * pw[r - l + 1];
    }
};

const int K = 707;

struct Node {
    int l, r, ind;

    bool operator<(const Node &oth) const {
        if (l / K == oth.l / K) return r < oth.r;
        return l / K < oth.l / K;
    }
};

void solve() {
    init();
    vector<int> lens;
    vector<pair<string, mint>> a;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        a.emplace_back(s, get_hash(s));
        lens.push_back(s.size());
    }
    unordered_map<int, int> cnt;
    for (auto &[x, y]: a) {
        ++cnt[y.x];
    }
    sort(all(lens)), lens.resize(unique(all(lens)) - lens.begin());
    Hash hs(t);
    vector<pair<int, int>> hv[t.size() + 1], hvback[t.size() + 1];
    for (int i = 1; i <= t.size(); ++i) {
        int sm = 0;
        for (int j = 0; j < lens.size() && i + lens[j] - 1 <= t.size(); ++j) {
            sm += cnt[hs.get(i, i + lens[j] - 1).x];
            hv[i].emplace_back(i + lens[j] - 1, sm);
        }
    }
    for (int i = 1; i <= t.size(); ++i) {
        int sm = 0;
        for (int j = 0; j < lens.size() && i - lens[j] + 1 >= 1; ++j) {
            sm += cnt[hs.get(i - lens[j] + 1, i).x];
            hvback[i].emplace_back(i - lens[j] + 1, sm);
        }
        reverse(all(hvback[i]));
    }
    auto get = [&](int ind, int r) -> int {
        if (hv[ind].empty() || hv[ind][0].X > r) return 0;
        int nw = upper_bound(all(hv[ind]), make_pair(r + 1, -1)) - hv[ind].begin() - 1;
        return hv[ind][nw].Y;
    };
    auto get_back = [&](int ind, int l) -> int {
        if (hvback[ind].empty() || lower_bound(all(hvback[ind]), make_pair(l, -1)) == hvback[ind].end()) return 0;
        return lower_bound(all(hvback[ind]), make_pair(l, -1))->Y;
    };
    vector<Node> qu(m);
    for (int i = 0; i < m; ++i) {
        cin >> qu[i].l >> qu[i].r;
        qu[i].ind = i;
    }
    sort(all(qu));
    int prl = -1, prr = -1;
    vector<int> ans(m, -1);
    int cans = 0;
    for (auto &[l, r, ind] : qu) {
        if (prl == -1) {
            for (int i = l; i <= r; ++i) {
                cans += get(i, r);
            }
        } else {
            for (int i = prl; i < l; ++i) {
                cans -= get(i, prr);
            }
            if (prl < l) prl = l;
            for (int i = prr; i > r; --i) {
                cans -= get_back(i, prl);
            }
            if (prr > r) prr = r;
            for (int i = prl - 1; i >= l; --i) {
                cans += get(i, prr);
            }
            if (prl > l) prl = l;
            for (int i = prr + 1; i <= r; ++i) {
                cans += get_back(i, prl);
            }
            if (prr < r) prr = r;
        }
        ans[ind] = cans;
        prl = l, prr = r;
    }
    for (auto &el : ans) {
        cout << el << ' ';
    }
}
