#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 5e6 + 1, MOD = 1e9 + 9, MOD1 = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

struct mint {
    int x, y;

    mint(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    mint operator+(const mint &oth) const {
        return {x + oth.x >= MOD ? x + oth.x - MOD : x + oth.x,
                y + oth.y >= MOD1 ? y + oth.y - MOD1 : y + oth.y};
    }

    mint operator-(const mint &oth) const {
        return {x - oth.x < 0 ? x - oth.x + MOD : x - oth.x,
                y - oth.y < 0 ? y - oth.y + MOD1 : y - oth.y};
    }

    mint operator*(const mint &oth) const {
        return {(1LL * x * oth.x) % MOD, (1LL * y * oth.y) % MOD1};
    }
};

mint pw[MAXN];

const mint P = {31, 37};

void init() {
    pw[0] = {1, 1};
    for (int i = 1; i < MAXN; ++i) {
        pw[i] = pw[i - 1] * P;
    }
}

mint get_hash(const string &s) {
    mint hsh;
    for (auto &el: s) {
        mint nw = {el - 'a' + 1, el - 'a' + 1};
        hsh = (hsh + nw) * P;
    }
    return hsh;
}

struct Hash {
    vector<mint> hs;

    Hash(const string &s) {
        hs.resize(s.size() + 1);
        for (int i = 0; i < s.size(); ++i) {
            mint nw = {s[i] - 'a' + 1, s[i] - 'a' + 1};
            hs[i + 1] = (hs[i] + nw) * P;
        }
    }

    mint get(int l, int r) {
        return hs[r] - hs[l - 1] * pw[r - l + 1];
    }
};

int nw = 1;

const int R = 1 << 19, MXX = 5e5 + 1;

const int MX = 8e7 + 1;

ll sm[MX];
int l[MX], r[MX], root[MXX];

struct Tree {

    void create(int node, int nl = 1, int nr = R) {
        if (nl == nr) return;
        int nm = (nr + nl) / 2;
        l[node] = nw++, r[node] = nw++;
        create(l[node], nl, nm);
        create(r[node], nm + 1, nr);
    }

    void init() {
        for (int i = 0; i < MXX; ++i) {
            root[i] = nw++;
        }
        create(root[0]);
    }

    ll get(int ql, int qr, int node, int nl = 1, int nr = R) {
        if (ql <= nl && nr <= qr) {
            return sm[node];
        }
        if (qr < nl || nr < ql) {
            return 0;
        }
        int nm = (nr + nl) / 2;
        return get(ql, qr, l[node], nl, nm) + get(ql, qr, r[node], nm + 1, nr);
    }

    ll gett(int x, int less, int rig) {
        return get(less, rig, root[x]);
    }

    ll ans(int lef, int rig) {
        return gett(rig, lef, rig) - gett(lef - 1, lef, rig);
    }

    void update(int ind, int add, int vcur, int vprev, int nl = 1, int nr = R) {
        if (nl == nr) {
            sm[vcur] += add + sm[vprev];
            return;
        }
        int nm = (nr + nl) / 2;
        if (nl <= ind && ind <= nm) {
            update(ind, add, l[vcur], l[vprev], nl, nm);
        } else {
            update(ind, add, r[vcur], r[vprev], nm + 1, nr);
        }
        sm[vcur] = sm[l[vcur]] + sm[r[vcur]];
    }

    void update(int i, int ind, int add) {
        update(ind, add, root[i], root[i - 1]);
    }

    void build(int vcur, int ind, int nl = 1, int nr = R) {
        if (nl == nr) {
            return;
        }
        int nm = (nr + nl) / 2;
        if (nl <= ind && ind <= nm) {
            if (!l[vcur]) {
                l[vcur] = nw++;
            }
            build(l[vcur], ind, nl, nm);
        } else {
            if (!r[vcur]) {
                r[vcur] = nw++;
            }
            build(r[vcur], ind, nm + 1, nr);
        }
    }

    void build1(int vcur, int vprev, int ind, int nl = 1, int nr = R) {
        if (nl == nr) {
            return;
        }
        if (!r[vcur]) {
            r[vcur] = r[vprev];
        }
        if (!l[vcur]) {
            l[vcur] = l[vprev];
        }
        int nm = (nr + nl) / 2;
        if (nl <= ind && ind <= nm) {
            build1(l[vcur], l[vprev], ind, nl, nm);
        } else {
            build1(r[vcur], r[vprev], ind, nm + 1, nr);
        }
    }


    void create_new_ver(int i, const vector<int> &curs) {
        if (curs.empty()) {
            root[i] = root[i - 1];
            return;
        }
        for (auto &el: curs) {
            build(root[i], el);
        }
        for (auto &el: curs) {
            build1(root[i], root[i - 1], el);
        }
    }
};

void solve() {
    init();
    vector<int> lens;
    vector<pair<string, mint>> a;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        a.emplace_back(s, get_hash(s));
        lens.push_back(s.size());
    }
    gp_hash_table<ll, int> cnt;
    for (auto &[x, y]: a) {
        ++cnt[1LL * y.x ^ (1LL * y.y << 31L)];
    }
    sort(all(lens)), lens.resize(unique(all(lens)) - lens.begin());
    Hash hs(t);
    Tree tree;
    tree.init();
    for (int i = 1; i <= t.size(); ++i) {
        for (int j = 0; j < lens.size(); ++j) {
            if (i - lens[j] + 1 >= 1) {
                tree.build(root[i], i - lens[j] + 1);
            }
        }
        for (int j = 0; j < lens.size(); ++j) {
            if (i - lens[j] + 1 >= 1) {
                tree.build1(root[i], root[i - 1], i - lens[j] + 1);
            }
        }
        for (int j = 0; j < lens.size(); ++j) {
            if (i - lens[j] + 1 >= 1) {
                int cur = cnt[1LL * hs.get(i - lens[j] + 1, i).x ^ (1LL * hs.get(i - lens[j] + 1, i).y << 31LL)];
                tree.update(i, i - lens[j] + 1, cur);
            }
        }
    }
    while (m--) {
        int lef, rig;
        cin >> lef >> rig;
        cout << tree.ans(lef, rig) << ' ';
    }
}