#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

ll MOD = 1e9 + 7;

struct Hash {
    ll x;

    Hash() {
        x = 0;
    }

    Hash(ll _x) {
        x = _x % MOD;
    }


    Hash operator+(const Hash &other) const {
        Hash res = *this;
        res.x += other.x;
        if (res.x >= MOD){
            res.x -= MOD;
        }
        return res;
    }

    Hash operator-(const Hash &other) const {
        Hash res = *this;
        res.x -= other.x;
        res.x += MOD;
        if (res.x >= MOD){
            res.x -= MOD;
        }
        return res;
    }

    Hash operator*(const Hash &other) const {
        Hash res = *this;
        res.x *= other.x;
        res.x %= MOD;
        return res;
    }
};

Hash k = Hash(29);
vector<Hash> p;

void calc(ll n){
    p.resize(n + 1);
    p[0] = 1;
    FOR(i, 1, n + 1){
        p[i] = p[i - 1] * k;
    }
}

Hash string_to_hash(string s){
    Hash cur = Hash(s[0] - 'a' + 1);
    FOR(i, 1, sz(s)){
        cur = cur * k;
        cur = cur + Hash(s[i] - 'a' + 1);
    }
    cur = cur;
    return cur;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<Hash> t(sz(s) + 1);
    set<ll> st;
    t[0] = Hash(0);
    FOR(i, 1, sz(s) + 1){
        t[i] = t[i - 1] * k + Hash(s[i - 1] - 'a' + 1);
    }
    unordered_map<ll, ll> a;
    F0R(i, n){
        cin >> s;
        a[string_to_hash(s).x]++;
        st.insert(sz(s) - 1);
    }
    F0R(i, m){
        ll l, r;
        cin >> l >> r;
        ll ans = 0;
        r++;
        each(j, st){
            FOR(d, l, r - j){
                Hash check = (t[d + j] - t[d - 1] * p[j + 1]);
                ans += a[check.x];
            }
        }
        cout << ans << ' ';
    }
}

int main() {
    fastio;
    calc(5 * 1e6);
    int t = 1; //cin >> t;
    cout << fixed;
    cout << setprecision(20);
    F0R(i, t) {
        solve();
    }
}