#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

const int MAXN = 2e5;

struct edge {
    int to;
    int w;
    bool in_dag;
};

int n, m;
vector<edge> g_start[MAXN];
vector<edge> g[MAXN];

int dp0[MAXN], dp1[MAXN];

int a, b;

int used[MAXN];

void clear() {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        g_start[i].clear();
    }
}

vector<edge> g_bt[MAXN];
vector<edge> g_bt_final[MAXN];

int can_tob[MAXN];

void dfs1(int v) {
    used[v] = 1;
    if (v == b) {
        can_tob[v] = 1;
    }
    for (auto e : g_start[v]) {
        if (used[e.to] == 0) {
            dfs1(e.to);
        }
        can_tob[v] = (can_tob[v]|can_tob[e.to]);
    }
    used[v] = 2;
}

vector<int> topsort;

void dfs2(int v) {
    used[v] = 1;
    for (auto &e : g_bt[v]) {
        int u = e.to;
        if (used[u] != 1) {
            e.in_dag = true;
        }
        if (used[u] == 0) {
            dfs2(u);
        }
    }
    used[v] = 2;
    topsort.push_back(v);
}

void solve() {
    cin >> n >> m;
    clear();
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        g_start[u].push_back({v, w, false});
    }
    cin >> a >> b;
    --a;
    --b;
    fill(used, used + n, 0);
    dfs1(a);
    for (int i = 0; i < n; ++i) {
        if (!can_tob[i]) continue;
        for (auto e : g_start[i]) {
            if (can_tob[e.to]) {
                g[i].push_back(e);
                edge re = e;
            }
        }
    }
    if (!can_tob[a]) {
        cout << 0;
        return;
    }
    vector<int> ans_bt(30);
    for (int bitt = 0; bitt < 30; ++bitt) {
        for (int i = 0; i < n; ++i) {
            g_bt[i].clear();
            g_bt_final[i].clear();
        }
        for (int i = 0; i < n; ++i) {
            for (auto e : g[i]) {
                e.w = ((e.w>>bitt)&1);
                g_bt[i].push_back(e);
            }
        }
        fill(used, used + n, 0);
        topsort.clear();
        dfs2(a);
        reverse(topsort.begin(), topsort.end());

        vector<int> can_to1_0(n), can_to1_1(n);
        reverse(topsort.begin(), topsort.end());

        vector<int> ans_xor(n);
        reverse(topsort.begin(), topsort.end());
        assert(topsort[0] == a);
        for (auto v : topsort) {
            for (auto e : g_bt[v]) {
                int u = e.to;
                int w = e.w;
                ans_xor[u] ^= (ans_xor[v]^w);
            }
        }
        ans_bt[bitt] = ans_xor[b];
    }
    int ans_num = 0;
    for (int i = 0; i < 30; ++i) {
        ans_num += (ans_bt[i]<<i);
    }
    cout << ans_num;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t;
    while (cin >> t) {
        while (t--) {
            solve();
            cout << "\n";
        }
        cout << "\n";
    }
}
