#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
bool used[MAXN];
vector<int> order;

void dfs(int v) {
    used[v] = 1;

    for (pii &it : adj[v]) {
        if (!used[it.X]) {
            dfs(it.X);
        }
    }

    order.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;

        adj[u].push_back({v, w});
        adj[v].push_back({u, w});
    }

    fill(used, used + n, 0);
    order.clear();

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }

    reverse(all(order));

    int a, b;
    cin >> a >> b;

    --a; --b;

    vector<int> cnt(n, -1);
    vector<int> xr_path(n, 0);
    cnt[a] = 1;

    for (int i = 0; i < n; i++) {
        int v = order[i];
        if (cnt[v] == -1) {
            continue;
        }
        for (pii &it : adj[v]) {
            int u = it.X;
            if (cnt[u] == -1) {
                cnt[u] = 0;
            }

            int w = (cnt[v] ? it.Y : 0);
            cnt[u] += cnt[v];
            cnt[u] &= 1;
            xr_path[u] ^= (xr_path[v] ^ w);
        }
    }

    if (cnt[b] != -1) {
        cout << xr_path[b] << endl;
    } else {
        cout << -1 << endl;
    }

    for (int i = 0; i < n; i++) {
        adj[i].clear();
    }

}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
//#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}

