#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
vector<pii> rev_adj[MAXN];
int xor_to_vertex[MAXN];
bool can_be_used[MAXN];
int cycled[MAXN];
bool used[MAXN];
vector<int> order;
int d[MAXN];
int sum_on_pref[MAXN];

void dfs(int v) {
    used[v] = 1;

    for (pii &it : adj[v]) {
        if (!used[it.X]) {
            dfs(it.X);
        }
    }

    order.push_back(v);
}

void my_dfs(int v, int xr = 0) {
    can_be_used[v] = 1;
    xor_to_vertex[v] = xr;

    for (pii &it : rev_adj[v]) {
        if (!can_be_used[it.X]) {
            my_dfs(it.X, xr ^ it.Y);
        }
    }
}

bool good = 1;
bool has_cycle = 0;

void dfs_check(int v, int sm, int de, int pw) {
    if (!can_be_used[v]) {
        return;
    }

    used[v] = 1;
    d[v] = de;

    sum_on_pref[v] = sm;

    for (auto &it : adj[v]) {
//        cout << v << ' ' << it.X << endl;
        if (!used[it.X]) {
            bool ans = (it.Y & pw) > 0;
            dfs_check(it.X, sm ^ ans, de + 1, pw);
        } else {
            int ans = (it.Y & pw) > 0;
            int xr_on_cycle = sm ^ sum_on_pref[it.X] ^ ans;
            int ans2 = (xor_to_vertex[v] & pw) > 0;
            if (xr_on_cycle != 0 || sum_on_pref[it.X] != 0 || ans2 != 0) {
                good = 0;
//                cout << v << ' ' << it.X << endl;
//                cout << sm << ' ' << sum_on_pref[it.X] << endl;
//                cout << ans << ' ' << xr_on_cycle << ' ' << ans2 << endl;
                return;
            }
        }
    }
}

int check(int a, int b, int n) {
    for (int pow = 1; pow < 30; pow++) {
        int pw = (1ll << pow);

        good = 1;
        fill(used, used + n, 0);
        dfs_check(a, 0, 0, pw);
        if (!good) {
//            cout << pow << endl;
            return -1;
        }
    }
    return 0;
}

void find_cycle(int v) {
    if (!can_be_used[v]) {
        return;
    }

    cycled[v] = 1;

    for (auto &it : adj[v]) {
        if (cycled[it.X] == 0) {
            find_cycle(it.X);
        } else if (cycled[it.X] == 1) {
            has_cycle = 1;
        }
    }
    cycled[v] = 2;
}

void solve() {
    int n, m;
    cin >> n >> m;

    fill(can_be_used, can_be_used + n, 0);
    fill(xor_to_vertex, xor_to_vertex + n, 0);

    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;

        adj[u].push_back({v, w});
        rev_adj[v].push_back({u, w});
        used[u] = 0;
        used[v] = 0;
    }
    int a, b;
    cin >> a >> b;

    --a; --b;

    my_dfs(b);

    has_cycle = 0;
    fill(cycled, cycled + n, 0);

    find_cycle(a);

    if (!has_cycle) {
        order.clear();

        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }

        reverse(all(order));

        vector<int> cnt(n, -1);
        vector<int> xr_path(n, 0);
        cnt[a] = 1;

        for (int i = 0; i < n; i++) {
            int v = order[i];
            if (cnt[v] == -1) {
                continue;
            }
            for (pii &it: adj[v]) {
                int u = it.X;
                if (cnt[u] == -1) {
                    cnt[u] = 0;
                }

                int w = (cnt[v] ? it.Y : 0);
                cnt[u] += cnt[v];
                cnt[u] &= 1;
                xr_path[u] ^= (xr_path[v] ^ w);
            }
        }

        if (cnt[b] != -1) {
            cout << xr_path[b] << endl;
        } else {
            cout << 0 << endl;
        }
    } else {
        cout << check(a, b, n) << endl;
    }

    for (int i = 0; i < n; i++) {
        adj[i].clear();
        rev_adj[i].clear();
    }

}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
//#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}