#include <bits/stdc++.h>

using namespace std;

int get_ans(int n, int a, int b, vector<vector<pair<int, int>>> g) {
    vector<vector<pair<int, int>>> _g(n);
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            _g[j].emplace_back(i, w);
        }
    }
    vector<int> used1(n), used2(n);
    queue<int> q;
    used1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (!used1[u]) {
                used1[u] = 1;
                q.push(u);
            }
        }
    }
    used2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            if (!used2[u]) {
                used2[u] = 1;
                q.push(u);
            }
        }
    }
    vector<int> dp1(n), dp2(n);
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        if (used1[i]) {
            for (auto [j, w] : g[i]) {
                sz[j]++;
            }
        }
    }
    dp1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            sz[u]--;
            dp1[u] ^= dp1[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        sz[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (used2[i]) {
            for (auto [j, w] : _g[i]) {
                sz[j]++;
            }
        }
    }
    dp2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            sz[u]--;
            dp2[u] ^= dp2[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            if (dp1[i] && dp2[j]) {
                ans ^= w;
            }
        }
    }
    return ans;
}

vector<array<int, 2>> get_vals(int n, int start, vector<vector<pair<int, int>>> g) {
    vector<array<int, 2>> ans(n, {-1, -1});
    ans[start][0] = 0;
    queue<pair<int, int>> q;
    q.push({start, 0});
    while (!q.empty()) {
        auto [v, p] = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (ans[u][0] == -1) {
                ans[u][0] = ans[v][p] ^ w;
                q.push({u, 0});
            } else if (ans[u][1] == -1 && ans[u][0] != ans[v][p] ^ w) {
                ans[u][1] = ans[v][p] ^ w;
                q.push({u, 1});
            }
        }
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), _g(n);
    int xr_all = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        xr_all ^= w;
        g[u].emplace_back(v, w);
        _g[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    if (xr_all != 0) {
        cout << -1 << '\n';
        return;
    }
    auto vals1 = get_vals(n, a, g), vals2 = get_vals(n, b, _g);
    for (int i = 0; i < n; ++i) {
        for (int j1 = 0; j1 < 2; ++j1) {
            for (int j2 = 0; j2 < 2; ++j2) {
                if (vals1[i][j1] != -1 && vals2[i][j2] != -1 && vals1[i][j1] != vals2[i][j2]) {
                    cout << -1 << '\n';
                    return;
                }
            }
        }
    }
    cout << 0 << '\n';
    // if (n > 1000 || m > 1000) {
    //     cout << get_ans(n, a, b, g) << '\n';
    // } else {

    // }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
