#include <bits/stdc++.h>

using namespace std;

int get_ans(int n, int a, int b, vector<vector<pair<int, int>>> &g) {
    vector<vector<pair<int, int>>> _g(n);
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            _g[j].emplace_back(i, w);
        }
    }
    vector<int> used1(n), used2(n);
    queue<int> q;
    used1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (!used1[u]) {
                used1[u] = 1;
                q.push(u);
            }
        }
    }
    used2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            if (!used2[u]) {
                used2[u] = 1;
                q.push(u);
            }
        }
    }
    vector<int> dp1(n), dp2(n);
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        if (used1[i]) {
            for (auto [j, w] : g[i]) {
                sz[j]++;
            }
        }
    }
    dp1[a] = 1;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            sz[u]--;
            dp1[u] ^= dp1[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        sz[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (used2[i]) {
            for (auto [j, w] : _g[i]) {
                sz[j]++;
            }
        }
    }
    dp2[b] = 1;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [u, w] : _g[v]) {
            sz[u]--;
            dp2[u] ^= dp2[v];
            if (!sz[u]) {
                q.push(u);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            if (dp1[i] && dp2[j]) {
                ans ^= w;
            }
        }
    }
    return ans;
}

void get_vals(int n, int start, vector<vector<pair<int, int>>> &g, vector<int> &mask, vector<array<int, 2>> &ans) {
    ans[start][0] = 0;
    queue<pair<int, int>> q;
    q.push({start, 0});
    while (!q.empty()) {
        auto [v, p] = q.front();
        q.pop();
        for (auto [u, w] : g[v]) {
            if (mask[u] && ans[u][0] == -1) {
                ans[u][0] = ans[v][p] ^ w;
                q.push({u, 0});
            } else if (mask[u] && ans[u][1] == -1 && ans[u][0] != (ans[v][p] ^ w)) {
                ans[u][1] = ans[v][p] ^ w;
                q.push({u, 1});
            }
        }
    }
}

void dfs(int v, vector<int> &used, vector<int> &ord, vector<vector<pair<int, int>>> &g) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (!used[u]) {
            dfs(u, used, ord, g);
        }
    }
    ord.push_back(v);
}

void color(int v, int c, vector<int> &col, vector<vector<pair<int, int>>> &_g) {
    col[v] = c;
    for (auto [u, w] : _g[v]) {
        if (col[u] == -1) {
            color(u, c, col, _g);
        }
    }
}

vector<int> get_colors(int n, vector<vector<pair<int, int>>> g) {
    vector<vector<pair<int, int>>> _g(n);
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            _g[j].emplace_back(i, w);
        }
    }
    vector<int> used(n), ord;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, used, ord, g);
        }
    }
    reverse(ord.begin(), ord.end());
    vector<int> col(n, -1);
    int c = 0;
    for (auto v : ord) {
        if (col[v] == -1) {
            color(v, c, col, _g);
            c++;
        }
    }
    return col;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), _g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        _g[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    vector<array<int, 2>> vals1(n, {-1, -1}), vals2(n, {-1, -1});
    vector<int> mask(n, 1);
    get_vals(n, a, g, mask, vals1);
    get_vals(n, b, _g, mask, vals2);
    auto col = get_colors(n, g);
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        sz[col[i]]++;
    }
    for (int i = 0; i < n; ++i) {
        bool cycle = false;
        for (auto [j, w] : g[i]) {
            if (j == i) {
                cycle = true;
            }
        }
        for (int p1 = 0; p1 < 2; ++p1) {
            for (int p2 = 0; p2 < 2; ++p2) {
                if (vals1[i][p1] != -1 && vals2[i][p2] != -1 && vals1[i][p1] != vals2[i][p2] && (sz[col[i]] > 1 || cycle)) {
                    cout << -1 << '\n';
                    return;
                }
            }
        }
    }
    vector<int> used(n);
    mask.assign(n, 0);
    vector<vector<int>> cmp(n);
    for (int i = 0; i < n; ++i) {
        cmp[col[i]].emplace_back(i);
    }
    vector<array<int, 2>> vals_nw(n, {-1, -1});
    for (int i = 0; i < n; ++i) {
        if (!used[col[i]] && vals1[i][0] != -1 && vals2[i][0] != -1) {
            used[col[i]] = 1;
            for (auto vl : cmp[col[i]]) {
                mask[vl] = 1;
            }
            get_vals(n, i, g, mask, vals_nw);
            if (vals_nw[i][1] != -1) {
                cout << -1 << '\n';
                return;
            }
            for (auto vl : cmp[col[i]]) {
                mask[vl] = 0;
            }
        }
    }
    vector<vector<pair<int, int>>> g_nw(n);
    for (int i = 0; i < n; ++i) {
        for (auto [j, w] : g[i]) {
            if (sz[col[i]] == 1 && sz[col[j]] == 1) {
                g_nw[i].emplace_back(j, w);
            }
        }
    }
    cout << get_ans(n, a, b, g_nw) << '\n';
    // if (n > 1000 || m > 1000) {
    //     cout << get_ans(n, a, b, g) << '\n';
    // } else {

    // }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
