#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1e9 + 7;
const ll MAXN = 2e5 + 5;
const ll logn = 17;
const ll INF = 2e9;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        g[a].emplace_back(b, w);
    }
    ll a, b;
    cin >> a >> b;
    --a, --b;

    ll now = a, next = g[a].begin()->first, xr = 0;
    while (now != b) {
        xr ^= g[now].begin()->second;
        now = next;
        next = g[now].begin()->first;
    }

    if (xr) {
        cout << -1 << '\n';
        return;
    }

    now = b, next = g[b].begin()->first, xr = 0;
    while (now != a) {
        xr ^= g[now].begin()->second;
        now = next;
        next = g[now].begin()->first;
    }

    if (xr) {
        cout << -1 << '\n';
        return;
    } else {
        cout << 0 << '\n';
    }
}

int main() {
    ll t;
    cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}
