#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
using namespace std;

vector<pair<int, int>> out[200500];
vector<pair<int, int>> in[200500];
vector<pair<int, int>> g[200500];
int val[200500];
int color[200500];
int dp[200500];
bool used[200500];

vector<int> ts;

void dfs1(int u) {
    used[u] = true;
    for (auto [v, w] : out[u]) {
        if (!used[v]) {
            dfs1(v);
        }
    }
    ts.push_back(u);
}

void dfs2(int u, int c) {
    color[u] = c;
    for (auto [v, w] : in[u]) {
        if (!color[v]) {
            dfs2(v, c);
        }
    }
}

void dfs3(int u) {
    for (auto& [v, w] : g[u]) {
        if (!used[v]) {
            dfs3(v);
        }
    }
    ts.push_back(u);
}

void solve() {
    int n, m;
    cin >> n >> m;
    ts.resize(0);
    for (int u = 1; u <= n; u++) {
        out[u].resize(0);
        in[u].resize(0);
        g[u].resize(0);
        color[u] = 0;
        used[u] = false;
        val[u] = 0;
        dp[u] = 0;
    }
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        if (u != v) {
            out[u].emplace_back(v, w);
            in[v].emplace_back(u, w);
        }
        edges.emplace_back(u, v, w);
    }
    int a, b;
    cin >> a >> b;
    dfs1(a);
    if (!used[b]) {
        cout << -1 << "\n";
        return;
    }

    for (int u = 1; u <= n; u++) {
        if (!used[u]) {
            dfs1(u);
        }
    }
    reverse(ts.begin(), ts.end());
    int c = 0;
    for (int u : ts) {
        if (!color[u]) {
            c++;
            dfs2(u, c);
        }
    }

    for (auto &[u, v, w] : edges) {
        u = color[u];
        v = color[v];
        if (u == v) {
            val[u] |= w;
        } else {
            g[u].emplace_back(v, w);
        }
    }

    fill(used, used + c + 1, false);
    ts.resize(0);

    for (int u = 1; u <= c; u++) {
        if (!used[u]) {
            dfs3(u);
        }
    }

    fill(used, used + c + 1, false);

    used[b] = true;
    dp[b] = val[color[b]];

    for (int u : ts) {
        for (auto [v, w] : g[u]) {
            if (used[v]) {
                used[u] = true;
                dp[u] |= val[u] | w | dp[v];
            }
        }
    }
    if (color[a] == color[b] && val[color[a]] != 0) {
        cout << -1 << "\n";
        return;
    }
    cout << dp[color[a]] << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
