#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

vector<vector<pair<int, int>>> g;
vector<int> d, used, par;

void dfs(int u, int p = -1) {
    par[u] = p;
    used[u] = 1;
    for (auto [v, c]: g[u]) {
        if (used[v]) continue;
        dfs(v, u);
    }
}

int n, m;

void clear_and_resize() {
    used.clear();
    par.clear();
    par.resize(n);
    used.resize(n);
}

int A, B;

void solve() {
    cin >> n >> m;
    g.clear();
    g.resize(n);
    int flag_cycle = (n == m);
    int flag_tree = 1;
    set<pair<int, int>> s;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        flag_tree &= (u < v);
        s.insert({u, v});
        flag_cycle &= (u == (v - 1 + n) % n);
        g[u].push_back({v, c});
    }
    flag_cycle &= (s.size() == n);
    cin >> A >> B;
    A--, B--;
    if (flag_cycle) {
        d.assign(n, -1);
        queue<int> q;
        q.push(0);
        d[0] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, c]: g[u]) {
                if (d[v] == -1) {
                    d[v] = d[u] ^ c;
                    q.push(v);
                } else {
                    if (d[u] ^ c) {
                        cout << "-1\n";
                        return;
                    }
                }
            }
        }
        if (d[A] ^ d[B]) {
            cout << "-1\n";
        } else {
            cout << "0\n";
        }
        return;
    }
    if (A == B) {
        cout << "0\n";
        return;
    }
    if (flag_tree) {
        dbg("tree");
        clear_and_resize();
        dfs(A, A);
        int flag = (used[A] == used[B]);
        int root = A;
        if (!flag) {
            root = B;
            clear_and_resize();
            dfs(B, B);
            if (used[A] != used[B]) {
                cout << "0\n";
                return;
            }
        }
        int els = A ^ B ^ root;
        vector<int> path;
        while (els != root) {
            path.push_back(els);
            els = par[els];
        }
        path.push_back(root);
        reverse(all(path));
        int ans = 0;
        for (int i = 0; i < 31; i++) {
            vector<vector<int>> dp(path.size(), vector<int>(2));
            for (auto [v, c]: g[path[0]]) {
                if (v == path[1]) {
                    dp[1][c >> i & 1]++;
                }
            }
            for (int j = 1; j + 1 < path.size(); j++) {
                int k = path[j + 1];
                vector<int> cnt(2);
                for (auto [v, c]: g[path[j]]) {
                    if (v == k) {
                        cnt[c >> i & 1]++;
                    }
                }
                if (cnt[0]) dp[j + 1][0] = dp[j][0] * cnt[0];
                if (cnt[1]) dp[j + 1][0] += dp[j][1] * cnt[1]; // 1 edge

                if (cnt[1]) dp[j + 1][1] = dp[j][0] * cnt[1];
                if (cnt[0]) dp[j + 1][1] += dp[j][1] * cnt[0]; // 0 edge
                dp[j + 1][0] %= 2;
                dp[j + 1][1] %= 2;
            }
            ans |= (1 << i) * (dp.back()[1] % 2);
        }
        cout << ans << "\n";
        return;
    }
    dbg("else");
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
