#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

vector<vector<pair<int, int>>> edge;
vector<int> topsort, used, ans, hm;

void dfs1(int u) {
    used[u] = 1;
    for (auto p : edge[u]) {
        int v = p.first;
        if (used[v] == 0) {
            dfs1(v);
        }
    }
    topsort.push_back(u);
}

void obr(int u) {
    for (auto p : edge[u]) {
        int v = p.first;
        ans[v] = (ans[v] ^ ans[u]);
        if (hm[u]) {
            hm[v] = (hm[v] ^ 1);
            ans[v] = (ans[v] ^ p.second);
        }
    }
}

void solve() {
    edge.clear();
    topsort.clear();
    used.clear();
    ans.clear();
    hm.clear();
    int n, m; cin >> n >> m;
    edge.resize(n);
    used.resize(n, 0);
    ans.resize(n, 0);
    hm.resize(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        int w; cin >> w;
        edge[u].push_back({ v, w });
    }
    int a, b; cin >> a >> b; --a; --b;
    hm[a] = 1; dfs1(a);
    reverse(all(topsort));
    for (int u : topsort) {
        obr(u);
    }
    cout << ans[b] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}