#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

vector<vector<pair<int, int> > > g, rg;
vector<int> dp, cnt, used;

void dfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to.F]) dfs(to.F);
    }
} 

signed main() {
    int tt; cin >> tt;
    while (tt--) {
        int n, m; cin >> n >> m;
        g.assign(n, vector<pair<int, int> > (0));
        rg.assign(n, vector<pair<int, int> > (0));
        int cycle = (m == n), w0 = 1;
        for (int i = 0; i < m; i++) {
            int u, v, w; cin >> u >> v >> w; u--, v--;
            if (cycle) {
                if (i < m - 1) {
                    if (u != i || v != i + 1) cycle = 0;
                } else {
                    if (u != i || v != 0) cycle = 0;
                }
            }
            if (w != 0) w0 = 0;
            g[u].pb(mp(v, w));
            rg[v].pb(mp(u, w));
        }
        int a, b; cin >> a >> b; a--, b--;
        if (w0) {
            cout << "0\n";
            continue;
        } 
        if (cycle) {
            int x = 0, y = 0;
            if (a <= b) {
                for (int i = a; i < b; i++) x ^= (g[i][0].S);
                for (int i = b; i < n; i++) y ^= (g[i][0].S);
                for (int i = 0; i < a; i++) y ^= (g[i][0].S);
            } else {
                for (int i = a; i < n; i++) x ^= (g[i][0].S);
                for (int i = 0; i < b; i++) x ^= (g[i][0].S);
                for (int i = b; i < a; i++) y ^= (g[i][0].S);
            }
            if (x == 0 && y == 0) {
                cout << "0\n";
            } else {
                cout << "-1\n";
            }
            continue;
        }
        if (a > b) {
            cout << "-1\n";
            continue;
        }
        if (a == b) {
            cout << "0\n";
            continue;
        }
        used.assign(n, 0);
        dfs(a);
        if (!used[b]) {
            cout << "0\n";
            continue;
        }
        dp.assign(n, 0), cnt.assign(n, 0);
        cnt[a] = 1;
        for (int v = a + 1; v <= b; v++) {
            for (auto to : rg[v]) {
                int p = to.F, w = to.S;
                dp[v] ^= dp[p];
                if (cnt[p] % 2 == 1) dp[v] ^= w;
                cnt[v] += cnt[p];
            }
            cout << v << " " << dp[v] << " " << cnt[v] << endl;
        }
        cout << dp[b] << "\n";
    }
    return 0;
}
/*
1
6 10  
1 2 1
1 4 1
1 5 1
2 3 1
2 4 1
2 5 1 
2 6 1 
3 5 1 
4 5 1 
5 6 1
2 5 
*/