#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;
const int LG = 21;

vector<int> gr[MAXN];
pii a[MAXN];

int up[LG][MAXN], d[MAXN];

void dfs(int v) {
    for (int u: gr[v]) {
        if (u != up[0][v]) {
            up[0][u] = v;
            d[u] = d[v] + 1;
            dfs(u);
        }
    }
}

int lca(int u, int v) {
    if (u == v)return v;
    if (d[u] < d[v])swap(u, v);
    for (int i = LG - 1; i >= 0; i--) {
        if (d[v] < d[u] - (1 << i)) {
            u = up[i][u];
        }
    }
    u = up[0][u];
    if (u == v)return v;
    for (int i = LG - 1; i >= 0; i--) {
        if (up[i][u] != up[i][v]) {
            u = up[i][u];
            v = up[i][v];
        }
    }
    return up[0][v];
}

pii cross(pii A, pii B) {
    if (max(A.X, B.X) <= min(A.Y, B.Y))return make_pair(max(A.X, B.X), min(A.Y, B.Y));
    return make_pair(-1, -2);
}

int mult(int A, int B) {
    return (A * 1LL * B) % MOD;
}

int used[MAXN];

void solve() {
    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        gr[i].pb(p);
        gr[p].pb(i);
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    dfs(0);

    for (int l = 1; l < LG; l++) {
        for (int i = 0; i < n; i++) {
            up[l][i] = up[l - 1][up[l - 1][i]];
        }
    }

    int m;
    cin >> m;

    for (int _ = 0; _ < m; _++) {
        int A, B, C, D;

        cin >> A >> B >> C >> D;
        A--;
        B--;
        C--;
        D--;
        int lca1 = lca(A, B);
        int lca2 = lca(C, D);
        vector<int> way1 = {};
        vector<int> way2;
        vector<int> way3;
        vector<int> way4;
        while (true) {
            way1.pb(A);
            if (A == lca1)break;
            A = up[0][A];
        }
        while (true) {
            way2.pb(B);
            if (B == lca1)break;
            B = up[0][B];
        }
        while (true) {
            way3.pb(C);
            if (C == lca2)break;
            C = up[0][C];
        }
        while (true) {
            way4.pb(D);
            if (D == lca2)break;
            D = up[0][D];
        }
        for (int h: way2)way1.pb(h);
        for (int h: way4)way3.pb(h);
        for (int i = 0; i < sz(way1); i++) {
            pii ans = cross(a[way1[i]], a[way3[i]]);
            a[way1[i]] = a[way3[i]] = ans;
            used[way3[i]] = 1;
        }
        int out = 1;
        for (int i = 0; i < n; i++) {
            if(used[i] == 0)out = mult(out, a[i].Y - a[i].X + 1);
        }
        cout << out << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
