#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

vector<int> tin, tout;
int curt = 0;
vector<int> par;
vector<vector<pair<int, ll>>> g;
vector<set<int>> g2;
vector<int> topsort;
vector<bool> visit;

void dfs(int u, int p) {
    visit[u] = true;
    for (int v : g2[u]) {
        if (!visit[v]) {
            dfs(v, u);
        }
    }
    topsort.push_back(u);
}
bool is_pred(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        g.clear();
        curt = 0;
        int n, m;
        cin >> n >> m;
        g.resize(n);
        for (int _ = 0; _ < m; ++_) {
            int u, v; ll w;
            cin >> u >> v >> w;
            u--; v--;
            g[u].push_back({ v, w });
        }
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (a > b) swap(a, b);
        vector<map<ll, int>> cnt(n);
        cnt[a][0] = 1;
        for (int i = a + 1; i <= b; ++i) {
            for (auto el : g[i]) {
                int v = el.first; ll w = el.second;
                for (auto el2 : cnt[v]) {
                    ll w2 = el2.first; int c = el2.second;
                    cnt[i][w2 ^ w] += c;
                }
            }
        }
        ll ans = 0;
        for (auto el2 : cnt[b]) {
            ll w2 = el2.first; int c = el2.second;
            if (c % 2 == 1)
                ans ^= w2;
        }
        cout << ans << "\n";

    }

    return 0;
}