#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

vector<int> tin, tout;
int curt = 0;
vector<int> par;
vector<vector<pair<int, ll>>> g;
vector<set<int>> g2;
vector<int> topsort;

void dfs(int u, int p) {
    par[u] = p;
    tin[u] = curt;
    curt++;
    for (int v : g2[u]) {
        if (v != p) {
            dfs(v, u);
        }
    }
    tout[u] = curt;
    curt++;
    topsort.push_back(u);
}
bool is_pred(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        g.clear(); g2.clear();
        tin.clear(); tout.clear();
        par.clear();
        topsort.clear();
        curt = 0;
        int n, m;
        cin >> n >> m;
        g.resize(n);
        g2.resize(n);
        vector<ll> weight(n);
        ll all_xor = 0;
        bool flag = true;
        for (int _ = 0; _ < m; ++_) {
            int u, v; ll w;
            cin >> u >> v >> w;
            u--; v--;
            if (u >= v) flag = false;
            g[u].push_back({ v, w });
            g2[u].insert(v);
            weight[u] = w;
            all_xor = (all_xor ^ w);
        }
        int a, b;
        cin >> a >> b;
        a--; b--;
        if (flag) {
            if (a > b) swap(a, b);
            vector<map<ll, ll>> cnt(n);
            cnt[b][0] = 1;
            for (int i = b - 1; i >= a; --i) {
                for (auto el : g[i]) {
                    int v = el.first; ll w = el.second;
                    for (auto el2 : cnt[v]) {
                        ll w2 = el2.first; ll c = el2.second;
                        cnt[i][w2 ^ w] += c;
                    }
                }
            }
            ll ans = 0;
            for (auto el2 : cnt[a]) {
                ll w2 = el2.first; ll c = el2.second;
                if (c % 2 == 1)
                    ans ^= w2;
            }
            cout << ans << "\n";
        }
        else {
            ll xor1 = 0;
            int u = a;
            while (u != b) {
                xor1 = (xor1 ^ weight[u]);
                u = (u + 1) % n;
            }
            if (xor1 == 0 && all_xor == 0)
                cout << 0 << "\n";
            else
                cout << -1 << "\n";
        }
    }

    return 0;
}