#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

vector<vector<pii>> gr, rgr;
vector<vector<int>> comps;

vector<int> used, can_go, ver, ts, col, dist;
int s, t, bit;

void dfs_ts(int v) {
    used[v] = 1;
    for (pii to : gr[v]) {
        if (!used[to.F])
            dfs_ts(to.F);
    }
    ts.push_back(v);
}

void dfs_go(int v) {
    used[v] = 1;
    can_go[v] = (v == t);
    for (pii to : gr[v]) {
        if (!used[to.F])
            dfs_go(to.F);
        can_go[v] |= can_go[to.F];
    }
}

void dfs_col(int v, int c, int d) {
    col[v] = c;
    dist[v] = d;
    comps[c].push_back(v);
    for (pii to : rgr[v]) {
        if (col[to.F] == -1 && can_go[to.F])
            dfs_col(to.F, c, d ^ to.S);
    }
}

bool dfs(int v) {
    used[v] = 1;
    for (pii to : gr[v]) {
        if (!can_go[to.F]) continue;
        int w = (to.S >> bit) & 1;
        if (!used[to.F]) {
            ver[to.F] = ver[v] ^ w;
            if (dfs(to.F))
                return true;
        }
        if (used[to.F] == 1 && (ver[to.F] ^ ver[v] ^ w))
            return true;
    }
    used[v] = 2;
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.assign(n, {});
    rgr.assign(n, {});
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        gr[a].push_back({ b, c });
        rgr[b].push_back({ a, c });
    }

    cin >> s >> t;
    s--; t--;

    used.assign(n, 0);
    can_go.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs_go(i);
    }
    used.assign(n, 0);

    ts = {};
    dfs_ts(s);
    reverse(all(ts));


    col.assign(n, -1);
    dist.assign(n, 0);
    int cnt = 0;
    comps = {};
    vector<int> comp_ts;
    for (int v : ts) {
        if (!can_go[v] || col[v] != -1) continue;
        comps.push_back({});
        dfs_col(v, cnt, 0);
        comp_ts.push_back(cnt);
        cnt++;
    }

    vector<int> good(cnt, 1);
    for (int v = 0; v < n; v++) {
        for (pii to : gr[v]) {
            if (col[v] == col[to.F])
                good[col[v]] = 0;
        }
    }

    reverse(all(comp_ts));
    int ans = 0;
    for (bit = 0; bit < 30; bit++) {
        used.assign(n, 0);
        ver.assign(n, 0);
        // есть ли цикл с xor = 1
        if (dfs(s)) {
            cout << "-1\n";
            return;
        }
        vector<pii> dp(n, { 0, 0 }), dp2(n, { 0, 0 }), dp_can(n, { 0, 0 });
        dp[t] = { 1, 0 };
        dp_can[t] = { 1, 0 };
        for (int c : comp_ts) {
            if (!can_go[comps[c][0]]) continue;
            for (int v : comps[c]) {
                for (pii to : gr[v]) {
                    if (!can_go[to.F] || col[to.F] == col[v]) continue;
                    int w = (to.S >> bit) & 1;
                    if (w) {
                        dp_can[v].F |= dp[to.F].S;
                        dp_can[v].S |= dp[to.F].F;
                        if (good[col[to.F]]) {
                            dp[v].F ^= dp[to.F].S;
                            dp[v].S ^= dp[to.F].F;
                        } else {
                            dp2[v].F |= dp_can[v].F;
                            dp2[v].S |= dp_can[v].S;
                        }
                        dp2[v].F |= dp2[to.F].S;
                        dp2[v].S |= dp2[to.F].F;
                    }
                    else {
                        dp_can[v].F |= dp[to.F].F;
                        dp_can[v].S |= dp[to.F].S;
                        if (good[col[to.F]]) {
                            dp[v].F ^= dp[to.F].F;
                            dp[v].S ^= dp[to.F].S;
                        } else {
                            dp2[v].F |= dp_can[v].F;
                            dp2[v].S |= dp_can[v].S;
                        }
                        dp2[v].F |= dp2[to.F].F;
                        dp2[v].S |= dp2[to.F].S;
                    }
                }
            }
            if (good[c]) continue;
            
            pii p = { 0, 0 };
            for (int v : comps[c]) {
                if (dist[v] == 0) {
                    p.F |= dp2[v].F;
                    p.S |= dp2[v].S;
                }
                else {
                    p.S |= dp2[v].F;
                    p.F |= dp2[v].S;
                }
            }
            for (int v : comps[c]) {
                if (dist[v] == 0)
                    dp2[v].F |= p.F;
                else
                    dp2[v].S |= p.S;
            }
        }
        if (dp2[s].S) {
            cout << "-1\n";
            return;
        }
        ans += (dp[s].S << bit);
    }
    cout << ans << '\n';


}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();
}