#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <deque>
using ll = long long;
#define all(x) x.begin(), x.end()
using namespace std;

struct edge {
	int to, weight;
	edge() {};
	edge(int to, int weight) :
		to(to), weight(weight) {};
};

int used[200];

int color = 1;
vector<vector<edge>> g;
vector<vector<edge>> g_r;
vector<vector<edge>> g_new;
void dfs(int v, vector<vector<edge>>& gg, int fin) {
	if (v == fin) {
		if (color == 2)
			used[fin] = 3;
		else {
			used[fin] = color;
		}
		return;
	}
	if (used[v] == color || used[v] == 3)
		return;
	if (used[v] == 0 || color == 1)
		used[v] = color;
	else {
		used[v] = 3;
	}
	for (auto i : gg[v])
		dfs(i.to, gg, fin);
}

bool cycle = 0;

vector<int> parent;
int f = -1;
int s = -1;
vector<set<int>> compress;
map<int, int> dict;
void dfs1(int v, int p, int ind) {
	if (cycle || used[v] == 2) {
		
		return;
	}
	if (used[v] == 1) {
		cycle = 1;
		f = v;
		s = p;
		int ok = 0;
		set<int> st;
		while (s != f) {
			if (g_new[parent[s]][ind].weight != 0) {
				ok = 1;
			}
			st.insert(s);
			dict[s] = f;
			s = parent[s];
		}
		dict[f] = f;
		st.insert(f);
		if (ok)
			return;
		else {
			cycle = 0;
			compress[f] = st;
			s = -1;
			f = -1;
			return;
		}
	}
	int idx = 0;
	used[v] = 1;
	for (auto i : g_new[v]) {
		parent[i.to] = v;
		dfs1(i.to, v, idx);
		idx += 1;
	}
	used[v] = 2;
}

vector<vector<edge>> g2;

pair<int, int> dfs_dp(int v) {
	int ans = 0;
	int cnt = g[v].size();
	for (auto i : g2[v]) {
		pair<int, int> p = dfs_dp(i.to);
		ans = ans ^ p.first;
		if (p.second % 2 != 0 || p.second == 0)
			ans = ans ^ i.weight;
		
	}
	return { ans, cnt };
}
bool ch = 0;
void check(int v, int fin, int ok1, int ok2) {
	if (ch)
		return;
	if (v == fin) {
		if (ok1 && ok2) {
			ch = 1;
		}
		return;
	}
	for (auto i : g2[v]) {
		int b1 = 0;
		int b2 = 0;
		if (dict.find(v) != dict.end()) {
			b1 = 1;
		}
		if (i.weight > 0) {
			b2 = 1;
		}
		check(i.to, fin, ok1 | b1, ok2 | b2);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	g = {};
	g_new = {};
	g2 = {};
	g_r = {};
	parent = {};
	fill(used, used + n, 0);
	g.resize(n);
	g_r.resize(n);
	g2.resize(n);
	parent.resize(n);
	compress = {};
	compress.resize(n);
	g_new.resize(n);

	dict = {};
	f = -1;
	s = -1;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		g[u].push_back({ v, w });
		g_r[v].push_back({ u, v });
	}
	int a, b;
	cin >> a >> b;
	--a;
	--b;
	color = 1;
	dfs(a, g, b);
	color = 2;
	dfs(b, g_r, a);
	//g_new.resize(n);
	for (int i = 0; i < n; ++i) {
		for (auto j : g[i]) {
			if (used[i] == 3 && used[j.to] == 3) {
				g_new[i].push_back(j);
			}
		}
	}
	fill(used, used + n, 0);
	cycle = 0;
	//parent.resize(n);
	//compress.resize(n);
	dfs1(a, -1, 0);
	if (cycle) {
		cout << -1 << endl;
		return;
	}
	//g2.resize(n);
	for (int i = 0; i < n; ++i) {
		for (auto j : g_new[i]) {
			int vert = i;
			if (dict.find(i) != dict.end()) {
				vert = dict[i];
			}
			int vert1 = j.to;
			if (dict.find(j.to) != dict.end()) {
				vert1 = dict[j.to];
			}
			if (vert != vert1) {
				g2[vert].push_back({ vert1, j.weight });
			}
			/*if (dict.find(i) != dict.end() && dict.find(j.to) != dict.end()) {
				continue;
			}
			if (dict.find(i) != dict.end()) {
				g2[dict[i]].push_back(j);
			}
			else if (dict.find(j.to) != dict.end()) {
				g2[i].push_back({ dict[j.to], j.weight });
			}
			else {
				g2[i].push_back(j);
			}*/
		}
	}

	ch = 0;
	check(a, b, 0, 0);
	if (ch){
		cout << -1 << endl;
		return;
	}

	cout << dfs_dp(a).first << endl;
}

signed main() {
#ifdef LOCAL
	freopen("C:\\Users\\olymp\\source\\repos\\Project1\\input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}