#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;

const int MAX_N = 2e5 + 5;
vector<pair<int, int>> g[MAX_N];
bool used[MAX_N];
vector<int> order;
int dp[MAX_N];

int dfs(int v, int b) {
    if (v == b) return 0;
    used[v] = true;
    for (const auto& [u, w] : g[v]) {
        if (!used[u]) {
            return dfs(u, b) ^ w;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int xor_sum = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        xor_sum ^= w;
    }

    int a, b;
    cin >> a >> b;
    --a, --b;

    if (xor_sum != 0) {
        cout << "-1\n";
    } else {
        cout << dfs(a, b) << '\n';
    }

    order.clear();
    for (int v = 0; v < n; ++v) {
        g[v].clear();
        used[v] = false;
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}