#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    vector<vector<pair<int, int>>> graph;
    vector<vector<pair<int, int>>> reverse_graph;
    vector<bool> mark;
    vector<int> dp;

    void DFS1(int v) {
        mark[v] = true;
        for (auto [u, _] : graph[v]) {
            if (!mark[u]) {
                DFS1(u);
            }
        }
    }

    void DFS(int v) {
        dp[v] = -2;
        int cur_dp = -3;
        for (auto [u, w] : reverse_graph[v]) {
            if (!mark[u]) {
                continue;
            }
            if (dp[u] == -2) {
                assert(false);
            } else {
                if (dp[u] == -1) {
                    DFS(u);
                }
                if (cur_dp < 0) {
                    cur_dp = 0;
                }
                cur_dp ^= dp[u] ^ w;
            }
        }
        dp[v] = cur_dp;
        assert(dp[v] != -3 || !mark[v]);
    }

    solve() : graph(n), reverse_graph(n), mark(n), dp(n, -1) {
        for (int i = 0; i < m; ++i) {
            in<int> v, u, w;
            graph[v - 1].emplace_back(u - 1, w);
            reverse_graph[u - 1].emplace_back(v - 1, w);
        }

        in<int> a, b;
        DFS1(a - 1);
        dp[a - 1] = 0;
        DFS(b - 1);
        for (int i = 0; i < n; ++i) {
            cerr << dp[i] << " ";
        }
        cerr << "\n";
        if (dp[b - 1] < 0) {
            cout << "0\n";
        } else {
            cout << dp[b - 1] << "\n";
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
