#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    vector<vector<pair<int, int>>> reverse_graph;
    int a, b;
    vector<int> dp1, dp2; // f, count

    solve() : reverse_graph(n), dp1(n), dp2(n) {
        for (int i = 0; i < m; ++i) {
            in<int> v, u, w;
            reverse_graph[u - 1].emplace_back(v - 1, w);
        }

        cin >> a >> b;
        --a; --b;
        dp1[a] = 0;
        dp2[a] = 1;
        for (int i = a + 1; i <= b; ++i) {
            for (auto [prev, w] : reverse_graph[i]) {
                dp1[i] ^= dp1[prev] ^ (dp2[prev] * w);
                dp2[i] ^= dp2[prev];
            }
        }
        cout << dp1[b] << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
