#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;
vector<pair<int, int>> g[N], gr[N], g2[N], gr2[N];
int comp[N], cur = 0;
bool ok[N][2], used[N];
bool good[N];
vector<int> ord, all[N];
int mem = 0, T[N];

void zhfs(int v) {
    used[v] = 1;
    T[v] = mem++;
    for (auto to : g[v]) {
        if (good[to.first] && !used[to.first]) {
            zhfs(to.first);
        }
    }
    ord.pb(v);
}

void dfs(int v) {
    comp[v] = cur;
    all[cur].pb(v);
    for (auto to : gr[v]) {
        if (comp[to.first] == -1 && good[to.first]) {
            dfs(to.first);
        }
    }
}

void gfs(int v) {
    used[v] = 1;
    for (auto to : g2[v]) {
        if (!used[to.first]) {
            gfs(to.first);
        }
    }
    ord.pb(v);
}

vector<array<int, 3>> u;

void add_edge(int a, int b, int c) {
    u.pb({a, b, c});
    g[a].pb({b, c});
    gr[b].pb({a, c});
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            g[i].clear();
            gr[i].clear();
            g2[i].clear();
            gr2[i].clear();
            ok[i][0] = ok[i][1] = 0;
            used[i] = 0;
            good[i] = 0;
            comp[i] = -1;
            all[i].clear();
        }
        cur = 0;
        ord.clear();
        u.clear();
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            add_edge(u, v, w);
        }
        int s, t;
        cin >> s >> t;
        s--, t--;
        {
            deque<int> q{s};
            ok[s][0] = 1;
            while (q.size() > 0) {
                int v = q.front();
                q.pop_front();
                for (auto to : g[v]) {
                    if (!ok[to.first][0]) {
                        ok[to.first][0] = 1;
                        q.pb(to.first);
                    }
                }
            }
        }
        {
            deque<int> q{t};
            ok[t][1] = 1;
            while (q.size() > 0) {
                int v = q.front();
                q.pop_front();
                for (auto to : gr[v]) {
                    if (!ok[to.first][1]) {
                        ok[to.first][1] = 1;
                        q.pb(to.first);
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (ok[i][0] && ok[i][1]) {
                good[i] = 1;
            }
        }
        zhfs(s);
        reverse(all(ord));
        for (auto v : ord) {
            if (comp[v] == -1) {
                dfs(v);
                cur++;
            }
        }
        vector<int> val(n, -1);
        bool good1 = 1;
        vector<int> bad(cur);
        for (int i = 0; i < cur; i++) {
            sort(all(all[i]), [&](int x, int y){return T[x] < T[y];});
            int v = all[i][0];
            val[v] = 0;
            deque<int> q{v};
            while (q.size() > 0) {
                int u = q.front();
                q.pop_front();
                for (auto to : g[u]) {
                    if (comp[to.first] != comp[u]) continue;
                    if (val[to.first] == -1) {
                        val[to.first] = (val[u] ^ to.second);
                        q.pb(to.first);
                        g2[u].pb(to);
                        gr2[to.first].pb({u, to.second});
                    }
                    good1 &= val[to.first] == (val[u] ^ to.second);
                }
            }
            if (all[i].size() > 1) {
                bad[i] = 1;
            }
        }
        for (auto to : u) {
            if (comp[to[0]] == -1 || comp[to[1]] == -1) continue;
            //assert(comp[to[0]] != comp[to[1]]);
            if (comp[to[0]] != comp[to[1]]) {
                g2[to[0]].pb({to[1], to[2]});
                gr2[to[1]].pb({to[0], to[2]});
            } else {
                if (to[0] == to[1]) {
                    bad[comp[to[0]]] = 1;
                }
            }
        }
        if (!good1) {
            cout << -1 << endl;
            continue;
        }
        {
            vector<vector<set<int>>> mem(n, vector<set<int>>(2));
            mem[s][0].insert(0);
            set<pair<int, int>> st{{s, 0}};
            map<pair<int, int>, int> mx;
            while (st.size() > 0) {
                auto p = *st.begin();
                st.erase(p);
                while (mem[p.first][p.second].size() > 2) {
                    mem[p.first][p.second].erase(mem[p.first][p.second].begin());
                }
                if (p.second == 0 && bad[p.first]) {
                    for (auto to : mem[p.first][0]) {
                        mem[p.first][1].insert(to);
                    }
                    if (mx[{p.first, 1}] < mem[p.first][1].size() && mx[{p.first, 1}] < 2) {
                        mx[{p.first, 1}] = mem[p.first][1].size();
                        st.insert({p.first, 1});
                    }
                }
                for (auto to : g[p.first]) {
                    if (!good[to.first]) continue;
                    for (auto el : mem[p.first][p.second]) {
                        mem[to.first][p.second].insert(el ^ to.second);
                    }
                    if (mx[{to.first, p.second}] < mem[to.first][p.second].size() && mx[{to.first, p.second}] < 2) {
                        mx[{to.first, p.second}] = mem[to.first][p.second].size();
                        st.insert({to.first, p.second});
                    }
                }
             }
             if (mem[t][1].size() > 1 && *mem[t][1].rbegin() != 0) {
                cout << -1 << endl;
                continue;
            }
        }
        {
            for (int i = 0; i < n; i++) used[i] = 0;
            ord.clear();
            gfs(s);
            reverse(all(ord));
            vector<int> cnt(n), res(n);
            cnt[s] = 1;
            for (int v : ord) {
                for (auto to : g2[v]) {
                    cnt[to.first] ^= cnt[v];
                    res[to.first] ^= res[v];
                    if (cnt[v]) {
                        res[to.first] ^= to.second;
                    }
                }
            }
            if (res[t] == 0) {
                cout << 0 << endl;
            } else {
                if (*max_element(bad.begin(), bad.end()) == 0) {
                    cout << res[t] << endl;
                } else {
                    cout << -1 << endl;
                }
            }
        }
    }
    return 0;
}
