#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

#define int long long
#define double long double

using namespace std;

const int MAXN = 201'000;
const int inf = 1e18;

vector <int> g[MAXN];
vector <int> gt[MAXN];
vector <int> e, w;
vector <int> et, wt;
vector <int> ch, used, op;
vector <int> top;

void dfs(int v, int p){
    used[v] = 1;
    op[v] = p;
    for (int id : g[v]){
        int u = e[id];
        if (used[u] == 0) dfs(u, p ^ w[id]);
        else if ((op[v] ^ op[u] ^ w[id]) != 0) ch[u] = 1;
    }
    top.push_back(v);
}

void dfs2(int v){
    used[v] = 1;
    for (int id : gt[v]){
        int u = e[id];
        if (used[u] == 0) dfs2(u);
    }
}

void solve(){
    e.clear(); w.clear();
    et.clear(); wt.clear();
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; i ++) g[i].clear();
    for (int i = 0; i < n; i ++) gt[i].clear();
    int fl = 1;
    int fl2 = (n == m);
    for (int i = 0; i < m; i ++){
        int u, v, wc; cin >> u >> v >> wc; u--; v--;
        if (u >= v) fl = 0;
        if ((u + 1) == v) fl2 = 0;
        g[u].push_back(e.size());
        e.push_back(v); w.push_back(wc);
        gt[v].push_back(et.size());
        et.push_back(u); wt.push_back(wc);
    }
    int a, b; cin >> a >> b; a--; b--;
    if (fl == 1){
        vector <int> dp1(n, 0), dp2(n, 0);
        dp1[a] = 1, dp2[b] = 1;
        for (int i = 0; i < n; i ++){
            for (int id : g[i]){
                dp1[e[id]] += dp1[i] % 2;
            }
        }
        for (int i = n - 1; i >= 0; i--){
            for (int id : gt[i]){
                dp2[et[id]] += dp2[i] % 2;
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i ++){
            for (int id : g[i]){
                if (dp1[i] % 2 == 1 && dp2[e[id]] % 2 == 1)
                    ans ^= w[id];
            }
        }
        cout << ans << endl;
    }
    else if (fl2){
        if (n == 1){
            if (w[0] == 0) cout << 0 << endl;
            else cout << -1 << endl;
            return;
        }
        int x = 0;
        for (int i : w) x ^= i;
        int l = 0;
        while (a != b){
            l ^= w[g[a][0]];
            a = e[g[a][0]];
        }
        if (l != 0 || l ^ x != 0){
            cout << -1 << endl;
        }
        else{
            cout << 0 << endl;
        }
    }
    else{
        ch.clear(); ch.resize(n, 0);
        used.clear(); used.resize(n, 0);
        op.clear(); op.resize(n, 0);
        dfs(0, 0);
        used.clear(); used.resize(n, 0);
        dfs2(b);
        int fl = 0;
        for (int i = 0; i < n; i ++) if (used[i] && ch[i]) fl = 1;
        if (fl) cout << -1;
        else{
            reverse(top.begin(), top.end());
            vector <vector<int>> dpa(n, vector <int> ((1ll << 10), 0));
            for (int v : top){
                for (int id : g[v]){
                    for (int ow = 0; ow < (1ll << 10); ow++){
                        dpa[e[id]][ow ^ w[id]] += dpa[v][ow] % 2 + 2;
                    }
                }
            }
            int ans = 0;
            for (int ow = 0; ow < (1ll << 10); ow++){
                if (dpa[b][ow] % 2 == 1) ans ^= ow;
            }
            cout << ans << endl;
        }
    }
}

signed main() {
    cout << setprecision(11) << fixed;
    int t; cin >> t;
    while (t--){
        solve();
    }
    return 0;
}