#include <bits/stdc++.h>
#define int long long

using namespace std;

struct edge{
    int v, w;
};

const int maxn = 2e5 + 5;

vector < vector <edge> > g(maxn, vector <edge> ());
vector < vector <int> > h(maxn, vector <int> ());
vector < vector <int> > css(maxn, vector <int> ());
int used[maxn], col[maxn], tout[maxn];
int tme = 0;
void set_time(int v) {
    used[v] = 1;
    for (auto u : h[v]) {
        if (!used[u]) {
            set_time(u);
        }
    }
    tout[tme++] = v;
}

void set_col(int v, int c) {
    col[v] = c;
    for (auto [u, w] : g[v]) {
        if (!col[u]) {
            set_col(u, c);
        }
    }
}

vector < vector <int> > cssg(maxn, vector <int> ());
int good[maxn];
bool find_path(int v, int target) {
    used[v] = 1;
    if (v == target) {
        good[v] = 1;
    }
    for (auto u : cssg[v]) {
        if (good[u]) {
            good[v] = 1;
        }
        if (!used[u] && find_path(u, target)) {
            good[v] = 1;
        }
    }
    return good[v];
}

int tp[maxn];

void set_tp(int v, int x, int pw) {
    tp[v] = x;
    for (auto [u, w] : g[v]) {
        if (col[u] == col[v] && tp[u] == -1) {
            if (w & (1 << pw)) {
                set_tp(u, x ^ 1, pw);
            } else {
                set_tp(u, x, pw);
            }
        }
    }
}

int dp[maxn][2];
int a, b;

void calc2(int v, int target, int pw) {
    used[v] = 1;
    if (v == target) {
        if (css[v].size() == 1) {
            dp[css[v][0]][0] = 1;
            dp[css[v][0]][1] = 0;
            for (auto [u, wt] : g[css[v][0]]) {
                if (u == css[v][0]) {
                    dp[css[v][0]][0] = -1;
                }
            }
        } else {
            for (auto u : css[v]) {
                dp[u][tp[a] ^ tp[u]] = -1;
                dp[u][tp[a] ^ tp[u] ^ 1] = 0;
            }
        }
    }
    for (auto u : cssg[v]) {
        if (!used[u] && good[u]) {
            calc2(u, target, pw);
        }
    }
    int is[2][2];
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < 2; ++j) {
            is[i][j] = 0;
        }
    }
    int cnt = 0;
    for (auto d : css[v]) {
        for (auto [u, wt] : g[d]) {
            if (col[u] == v) cnt++;
            
        }
    }
    if (cnt > 0) {
        for (auto u : css[v]) {
            dp[u][0] = -1;
            dp[u][1] = -1;
        }
    }
    for (auto u : css[v]) {
        if (dp[u][0] == -1) {
            is[tp[u]][0] = 1;
        }
        if (dp[u][1] == -1) {
            is[tp[u]][1] = 1;
        }
    }
    for (auto u : css[v]) {
        if (is[tp[u]][0] || is[tp[u] ^ 1][1]) {
            dp[u][0] = -1;
        }
        if (is[tp[u]][1] || is[tp[u] ^ 1][0]) {
            dp[u][1] = -1;
        }
    }
    for (auto d : css[v]) {
        for (auto [u, wt] : g[d]) {
            if (col[u] == v) continue;
            if (wt & (1 << pw)) {
                if (dp[u][0] != -1) {
                    if (dp[d][1] == -1) {
                        dp[u][0] = -1;
                    } else {
                        dp[u][0] = dp[u][0] ^ dp[d][1];
                    }
                }
                if (dp[u][1] != -1) {
                    if (dp[d][0] == -1) {
                        dp[u][1] = -1;
                    } else {
                        dp[u][1] = dp[u][1] ^ dp[d][0];
                    }
                }
            } else {
                if (dp[u][0] != -1) {
                    if (dp[d][0] == -1) {
                        dp[u][0] = -1;
                    } else {
                        dp[u][0] = dp[u][0] ^ dp[d][0];
                    }
                }
                if (dp[u][1] != -1) {
                    if (dp[d][1] == -1) {
                        dp[u][1] = -1;
                    } else {
                        dp[u][1] = dp[u][1] ^ dp[d][1];
                    }
                }
            }
        }
    }
}

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        h[i].clear();
        used[i] = 0; col[i] = 0;
    }
    tme = 0;
    for (int i = 0; i < m; ++i) {
        int v, u, w; cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        h[u].push_back(v);
    }
    cin >> a >> b;
    a--; b--;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) set_time(i);
    }
    int colors = 1;
    for (int i = n - 1; i >= 0; --i) {
        if (!col[tout[i]]) {
            set_col(tout[i], colors++);
        }
    }
    for (int i = 1; i < colors; ++i) {
        css[i].clear();
        cssg[i].clear();
    }
    for (int i = 0; i < n; ++i) {
        css[col[i]].push_back(i);
    }
    for (int i = 1; i < colors; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i < colors; ++i) {
        good[i] = 0;
        for (auto v : css[i]) {
            for (auto [u, w] : g[v]) {
                if (col[u] != i && !used[col[u]]) {
                    used[col[u]] = 1;
                    cssg[col[u]].push_back(i);
                }
            }
        }
        for (auto v : css[i]) {
            for (auto [u, w] : g[v]) {
                used[col[u]] = 0;
            }
        }
    }
    if (!find_path(col[b], col[a])) {
        cout << "0\n";
        return;
    }
    int maxw = 30;
    int res = 0;
    for (int w = 0; w < maxw; ++w) {
        for (int i = 0; i < n; ++i) {
            tp[i] = -1;
            dp[i][0] = 0; dp[i][1] = 0;
        }
        for (int i = 1; i < colors; ++i) {
            used[i] = 0;
        }
        for (int i = 1; i < colors; ++i) {
            if (good[i]) {
                set_tp(css[i][0], 0, w);
                //cout << css[i][0] << ' ' << tp[0] << ' ' << tp[1] << ' ' << tp[2] << "\n";
                for (auto v : css[i]) {
                    for (auto [u, wt] : g[v]) {
                        if (col[u] == col[v]) {
                            int need = (wt & (1 << w)) > 0;
                            if (need != (tp[u] ^ tp[v])) {
                                cout << "-1\n";
                                return;
                            }
                        }
                    }
                }
            }
        }
        for (int i = 1; i < colors; ++i) {
            used[i] = 0;
        }
        calc2(col[b], col[a], w);
        if (dp[b][1] == -1) {
            cout << "-1\n";
            return;
        }
        if (dp[b][1]) {
            res += (1 << w);
        }
    }
    cout << res << "\n";
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
