#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct rebern {
	int a, b, w;
	rebern(){};
	rebern(int a, int b, int w): a(a), b(b), w(w) {};
};

bool check(int n, int m, vector<rebern> &rebs) {
	int ok = 1;
	ok &= (n == m);
	for (int i = 0; i < m - 1 && ok; ++i) {
		ok &= (rebs[i].a == i && rebs[i].b == i + 1);
	}
	ok &= (rebs[m - 1].a == n - 1 && rebs[m - 1].b == 0);
	return ok;
}

void solve1(int n, int m, vector<rebern> rebs, int a, int b) {
	int w = 0;
	for (int i = 0; i < m; ++i) w ^= rebs[i].w;
	if (w != 0) {cout << -1 << endl; return;}
	int w1 = 0;
	while (a != b) {
		w1 ^= rebs[a].w;
		a = rebs[a].b;
	}
	if (w1 != 0) cout << -1 << endl;
	else cout << 0 << endl;
	return;
}

vector<bool> used;
vector<int> top;
vector<vector<pair<int, int>>> g;
int t = 0;
// vector<int> ans;
vector<int> ok;

void tfs(int v) {
	if (used[v]) return;
	used[v] = 1;
	for (auto [u, _]: g[v]) tfs(u);
	top[t++] = v;
}

// void calc(int v) {
// 	for (auto [u, w]: g[v]) {
// 		if (ok[u]) {
// 			ok[v] ^= ok[u];
// 			ans[v] ^= (ok[u] * w) ^ ans[u];
// 		}
// 	}
// }

void solve() {
	int n, m;
	cin >> n >> m;
	g.assign(n, vector<pair<int, int>>(0));
	used.assign(n, 0);
	top.assign(n, 0);
	// ans.assign(n, 0);
	ok.assign(n, 0);
	t = 0;
	vector<rebern> rebs(m);
	for (rebern &r: rebs) {cin >> r.a >> r.b >> r.w; --r.a; --r.b;}
	int a, b;
	cin >> a >> b;
	--a;
	--b;
	if (check(n, m, rebs)) {
		solve1(n, m, rebs, a, b);
		return;
	}
	for (int i = 0; i < m; ++i) {
		g[rebs[i].a].push_back({rebs[i].b, rebs[i].w});
	}
	for (int v = 0; v < n; ++v) {
		if (!used[v]) tfs(v);
	}
	ok[b] = 1;
	//reverse(top.begin(), top.end());
	for (int v: top) {
		//calc(v);
		for (auto [u, _]: g[v]) {
			ok[v] ^= ok[u];
		}
	}
	int ans = 0;
	for (rebern r: rebs) if (ok[r.b]) ans ^= r.w;
	cerr << ok[a] << endl;
	cout << ans << endl;
}

int main() {
	int t = 1;
	#ifndef LOCAL
	cin >> t;
	#endif
	while (t--) {
		solve();
	}
}