#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;

vector<long> topsort;
vector<char> used;
vector<long> comp;
vector<long> comp_sz;
vector<long> petl1;
vector<long> petl2;

void dfs1(vector<vector<pair<long, long long>>> &data1, long v) {
    used[v] = 1;
    for (auto p: data1[v]) {
        if (!used[p.first]) {
            dfs1(data1, p.first);
        }
    }
    topsort.push_back(v);
}

void dfs2(vector<vector<pair<long, long long>>> &data1, long v, long c) {
    used[v] = 1;
    comp[v] = c;
    ++comp_sz[c];
    if (petl1[v]) {
        petl2[c] = 1;
    }
    for (auto p: data1[v]) {
        if (!used[p.first]) {
            dfs1(data1, p.first);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long t;
    cin >> t;

    for (long h = 0; h < t; ++h) {
        bool res = true;
        long n, m;
        long long xor1 = 0;
        cin >> n >> m;
        vector<long long> w_all;
        for (long i = 0; i < m; ++i) {
            long long v1, v2, w;
            cin >> v1 >> v2 >> w;
            xor1 ^= w;
            w_all.push_back(w);
            if (i == n - 1) {
                if (v1 != n || v2 != 1)
                    res = false;
            } else {
                if (v2 != i + 2 || v1 != i + 1)
                    res = false;
            }
        }
        long a, b;
        cin >> a >> b;
        --a, --b;
        if (res) {
            if (xor1) {
                cout << -1 << endl;
            } else {
                long long xor2 = 0;
                for (long i = min(a, b); i < max(a, b); ++i) {
                    xor2 ^= w_all[i];
                }
                cout << xor2 << endl;
            }
        } else {

        }
    }
    return 0;
}
