#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define int long long

const int INF = 1e9 + 7;

using namespace std;
//using namespace __gnu_pbds;
//using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

vector<bool> used;
vector<int> ts, color;
vector<bool> bad; // плохая ли КСС
map<pair<int, int>, int> Cnt; // кол-во ребер u->v для конд. графа
vector<int> res; // xor на пути в обычном графе
vector<int> dp; // xor всей путей от a до u
vector<int> C; // четность кол-ва путей до вершины сконд. графа

void tops(int start, vector<vector<pair<int, int>>> &gr) {
    used[start] = true;
    for (auto [to, w]: gr[start]) {
        if (!used[to]) tops(to, gr);
    }
    ts.push_back(start);
}

void condencate(int start, int c, vector<vector<pair<int, int>>> &gr) {
    color[start] = c;
    for (auto [to, w]: gr[start]) {
        if (color[to] == -1) {
            condencate(to, c, gr);
        }
    }
}

void dfs_odd_or_even(int start, vector<int> &count_path, vector<vector<pair<int, int>>> &gr) {
    // применяется для отсортированного в обратном порядке графа

    // для сконденсированного и инвертированного графа со сжатыми ребрами
    // подсчет четности путей для определения, существует ли плохая КСС, от которой нечетно
    // Cnt - число ребер из start в to
    used[start] = true;
    for (auto [to, w]: gr[start]) {
        count_path[to] ^= (count_path[start] * Cnt[make_pair(start, to)]) & 1;
        used[to] = true;
    }
}

void check(int start, int cur_xor, vector<vector<pair<int, int>>> &gr, bool &flag) {
    // для обычного графа с несжатыми ребрами. проверка одной КСС на то, что она плохая
    used[start] = true;
    res[start] = cur_xor;
    for (auto [to, w]: gr[start]) {
        int new_xor = cur_xor ^ w;
        if (!used[to] && color[to] == color[start]) {
            check(to, new_xor, gr, flag);
        }
        if (res[to] != new_xor || !flag) {
            flag = false;
            return;
        }
    }
}

void fnc(int start, vector<vector<pair<int, int>>> &gr) {
    // для сконденсированного графа со сжатыми ребрами
    used[start] = true;
    for (auto [to, w]: gr[start]) {
        used[to] = true;
        if (C[start] == 0) {
            if (Cnt[make_pair(start, to)] == 1) {
                dp[to] ^= dp[start];
            }
            continue;
        }
        if (Cnt[make_pair(start, to)]) {
            C[to] ^= 1;
            dp[to] ^= dp[start] ^ w;
        } else {
            dp[to] ^= w;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), gInv(n);
    vector<vector<int>> edges;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(make_pair(v, w));
        gInv[v].emplace_back(make_pair(u, w));
        vector<int> edge = {u, v, w};
        edges.emplace_back(edge);
    }
    used.assign(n, false);
    ts.clear();
    for (int i = 0; i < n; i++) {
        if (!used[i]) tops(i, g);
    }
    reverse(ts.begin(), ts.end());
    int c = 0;
    color.assign(n, -1);
    for (int i = 0; i < n; i++) {
        if (color[ts[i]] == -1) {
            condencate(ts[i], c, gInv);
            c++;
        }
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
//    cout << "condencate good" << endl;
    if (color[a] == color[b]) {
        res.assign(n, 0);
        used.assign(n, false);
        bool flag = true;
        check(a, 0, g, flag);
        if (flag) {
            cout << res[b];
        } else {
            cout << -1;
        }
        return;
    }
    map<pair<int, int>, int> for_graph;
    vector<vector<pair<int, int>>> gCond(c), gCondInv(c);
    map<pair<int, int>, int> cnt;
    for (int i = 0; i < m; i++) {
        int u = edges[i][0];
        int v = edges[i][1];
        int w = edges[i][2];
        cnt[make_pair(u, v)] ^= 1;
        for_graph[make_pair(u, v)] ^= w;
    }
    bad.assign(c, false);
    for (auto [V, w]: for_graph) {
        auto [u, v] = V;
        if (color[u] != color[v]) {
            Cnt[make_pair(color[u], color[v])] ^= cnt[make_pair(u, v)];
            gCond[color[u]].emplace_back(make_pair(color[v], w));
            gCondInv[color[v]].emplace_back(make_pair(color[u], w));
        } else if (u == v) {
            bad[color[u]] = true;
        }
    }
    vector<int> sz(c, 0);
    for (int i = 0; i < n; i++) {
        sz[color[i]]++;
    }
    for (int i = 0; i < c; i++) {
        bad[i] = bad[i] | (sz[i] > 1);
    }
//    cout << "new graph good" << endl;
    ts.clear();
    used.assign(c, false);
    for (int i = 0; i < c; i++) {
        if (!used[i]) {
            tops(i, gCond);
        }
    }
    used.assign(c, false);
    used[color[b]] = true;
    vector<int> count_path_back(c, 0);
    count_path_back[color[b]] = 1;
    for (int i = 0; i < c; i++) {
        if (used[ts[i]]) {
            dfs_odd_or_even(ts[i], count_path_back, gCondInv);
        }
    }
//    cout << "first check ok" << endl;
    vector<int> count_path(c, 0);
    count_path[color[a]] = 1;
    reverse(ts.begin(), ts.end());
    used.assign(c, false);
    used[color[a]] = true;
    for (int i = 0; i < c; i++) {
        if (used[ts[i]]) {
            dfs_odd_or_even(ts[i], count_path, gCond);
        }
    }
//    cout << "second check ok" << endl;
    for (int i = 0; i < c; i++) {
        if (bad[i] && (((count_path[i] & count_path_back[i]) & 1) == 0)) {
            cout << -1;
            return;
        }
    }
//    cout << "good graph" << endl;
    used.assign(c, false);
    used[color[a]] = true;
    dp.assign(c, 0);
    C.assign(c, 0);
    C[color[a]] = 1;
    for (int i = 0; i < c; i++) {
        if (used[ts[i]]) {
            fnc(ts[i], gCond);
        }
    }
    cout << dp[color[b]];
}

void sf() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    sf();
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
}