#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

vector<vector<pii>> gr, rgr;
vector<int> dp, ord, used, p;

void dfs(int v) {
    used[v] = 1;
    for (pii e : gr[v]) {
        int u, w;
        tie(u, w) = e;
        if(!used[u])
            dfs(u);
    }
    ord.push_back(v);
}

void solve() {
    int n, m, v, u, w, a, b;
    cin >> n >> m;
    gr.resize(n);
    rgr.resize(n);
    used.resize(n, 0);
    p.resize(n, 0);
    dp.assign(n, 0);
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> w;
        v--, u--;
        gr[v].emplace_back(u, w);
        rgr[u].emplace_back(v, w);
    }
    cin >> a >> b;
    a--, b--;
    dfs(a);
    p[a] = 1;
    reverse(All(ord));
    for (int v : ord) {
        dp[v] = 0;
        for (pii e : rgr[v]) {
            int u, w;
            tie(u, w) = e;
            dp[v] ^= dp[u];
            if (p[u]) {
                p[v] ^= 1;
                dp[v] ^= w;
            }
        }
    }
    cout << max(dp[b], 0) << '\n';
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        gr.clear();
        rgr.clear();
        dp.clear();
        used.clear();
        ord.clear();
        solve();
    }
}