#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 2E5, sq = 447;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

pair <int, uint32_t> to[MAXN];
uint32_t dist_a[MAXN];
int a, b;

void dfs(int x)
{
	if (to[x].first != a)
	{
		dist_a[to[x].first] = dist_a[x] ^ to[x].second;
		dfs(to[x].first);
	}
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;
		uint32_t tot = 0;
		for (int i = 0; i < m; i++)
		{
			int u, v;
			uint32_t w;
			cin >> u >> v >> w;
			to[u - 1] = { v - 1,w };
			tot ^= w;
		}
		cin >> a >> b;
		--a;
		--b;
		dist_a[a] = 0;
		dfs(a);
		if (tot == 0 and dist_a[b] == 0)
		{
			cout << 0 << endl;
		}
		else
			cout << -1 << endl;
	}
}