#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 2E5, sq = 447;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

struct Edge
{
	int from, to;
	uint32_t w;
	Edge(int from = 0, int to = 0, uint32_t w = 0) :from(from), to(to), w(w) {}
};

vector <int> mas1[MAXN], mas2[MAXN];
bool cnt_nc_from[MAXN], cnt_nc_to[MAXN];
bool used[MAXN];
pair <int, int32_t> to[MAXN];
int a, b;
int32_t dist_a[MAXN];

void dfs_from(int x)
{
	used[x] = true;
	for (int i = 0; i < mas2[x].size(); i++)
	{
		int pred = mas2[x][i];
		if (!used[pred])
		{
			dfs_from(pred);
		}
		cnt_nc_from[x] ^= cnt_nc_from[pred];
	}
	return;
}
void dfs_to(int x)
{
	used[x] = true;
	for (int i = 0; i < mas1[x].size(); i++)
	{
		int nxt = mas1[x][i];
		if (!used[nxt])
		{
			dfs_to(nxt);
		}
		cnt_nc_to[x] ^= cnt_nc_to[nxt];
	}
	return;
}
void dfs(int x)
{
	if (to[x].first != a)
	{
		dist_a[to[x].first] = dist_a[x] ^ to[x].second;
		dfs(to[x].first);
	}
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int t;
	cin >> t;
	while (t--)
	{
		bool h = true;
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; i++)
		{
			used[i] = false;
			cnt_nc_from[i] = false;
			cnt_nc_to[i] = false;
			mas1[i].clear();
			mas2[i].clear();
		}
		vector <Edge> edges;
		uint32_t tot = 0;
		for (int i = 0; i < m; i++)
		{
			int u, v;
			uint32_t w;
			cin >> u >> v >> w;
			if (v <= u)
			{
				h = false;
			}
			to[u - 1] = { v - 1,w };
			mas1[u - 1].push_back(v - 1);
			mas2[v - 1].push_back(u - 1);
			edges.push_back({ u - 1,v - 1,uint32_t(w) });
			tot ^= w;
		}
		cin >> a >> b;
		--a;
		--b;

		if (!h)
		{
			dist_a[a] = 0;
			dfs(a);
			if (tot == 0 and dist_a[b] == 0)
			{
				cout << 0 << endl;
			}
			else
				cout << -1 << endl;
		}
		else
		{
			cnt_nc_from[a] = true;
			dfs_from(b);
			fill(used, used + n, false);
			cnt_nc_to[b] = true;
			dfs_to(a);
			uint32_t ans = 0;
			for (int i = 0; i < m; i++)
			{
				if (cnt_nc_from[edges[i].from] and cnt_nc_to[edges[i].to])
				{
					ans ^= edges[i].w;
				}
			}
			cout << ans << endl;
		}
	}
}