
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>> graph;
vector<vector<int>> gr;
vector < vector<pair<int, int>>> mmm;
vector<bool> used;
vector<int> top;

void dfs(int v) {
	used[v] = true;
	for (auto to : graph[v]) {
		if (!used[to.first]) {
			dfs(to.first);
		}
	}
	top.push_back(v);
}

vector<int> comp;

void dfs1(int v, int tmp) {
	used[v] = true;
	comp[v] = tmp;
	for (auto to : gr[v]) {
		if (!used[to]) {
			dfs1(to, tmp);
		}
	}
}

void dfs3(int v) {
	used[v] = true;
	for (auto to : mmm[v]) {
		if (!used[to.first]) {
			dfs(to.first);
		}
	}
	top.push_back(v);
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		graph.clear();
		graph.resize(n);
		gr.clear();
		gr.resize(n);
		comp.assign(n, 0);
		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			a--, b--;
			graph[a].push_back({ b, c });
			gr[b].push_back(a);
		}
		int A, B;
		cin >> A >> B;
		A--, B--;
		used.assign(n, false);
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				dfs(i);
			}
		}
		reverse(top.begin(), top.end());
		int tmp = 0;
		used.assign(n, false);
		for (int i = 0; i < n; i++) {
			if (!used[top[i]]) {
				{
					dfs1(top[i], tmp);
					tmp++;
				} 
			}
		}
		if (comp[A] != comp[B]) {
			vector<vector<pair<int, int>>> graph2(tmp);
			vector<vector<int>> gr2(tmp);
			for (int i = 0; i < n; i++) {
				for (auto to : graph[i]) {
					if (comp[to.first] != comp[i]) {
						graph2[comp[i]].push_back({ comp[to.first], to.second });
						gr2[comp[to.first]].push_back(comp[i]);
					}
				}
			}
			vector<int> cnt1(tmp);
			top.clear();
			used.assign(tmp, false);
			mmm = graph2;
			for (int i = 0; i < tmp; i++) {
				if (!used[i]) {
					dfs3(i);
				}
			}

			int ans = 0;
			reverse(top.begin(), top.end());
			for (auto el : top) {
				if (el == comp[A]) {
					cnt1[el]++;
					cnt1[el] %= 2;
				}
				for (auto to : graph2[el]) {
					cnt1[to.first] += cnt1[el];
					cnt1[to.first] %= 2;
				}
			}

			vector<int> cnt2(tmp);
			reverse(top.begin(), top.end());
			for (auto el : top) {
				if (el == comp[B]) {
					cnt2[el]++;
					cnt2[el] %= 2;
				}
				for (auto to : gr2[el]) {
					cnt2[to] += cnt1[el];
					cnt2[to] %= 2;
				}
			}
			for (int i = 0; i < tmp; i++) {
				for (auto to : graph2[i]) {
					if (cnt1[i] * cnt2[to.first] % 2 == 1) {
						ans ^= to.second;
					}
				}
			}

			if (ans != 0) {
				for (int i = 0; i < n; i++) {
					if (i != A && comp[A] == comp[i]) {
						ans = -1;
					}
					if (i != B && comp[B] == comp[i]) {
						ans = -1;
					}
				}
				for (int i = 0; i < n; i++) {
					for (auto to : graph[i]) {
						if (to.first == A && i == A) {
							ans = -1;
						}
						if (to.first == B && i == B) {
							ans = -1;
						}
					}
				}
			}
			else {
				for (int b = 29; b >= 0; b--) {
					vector<vector<pair<int, int>>> graph3(n);
					for (int i = 0; i < tmp; i++) {
						for (auto to : graph[i]) {
							if (to.second & (1 << b)) {
								graph3[i].push_back({ to.first, 1 });
							}
							else {
								graph3[i].push_back({ to.first, 0 });
							}
						}
					}
					vector<pair<bool, bool>> cann(n);
					cann[A].first = true;
					deque<int> dq;
					dq.push_back(A);
					while (!dq.empty()) {
						int v = dq.front();
						dq.pop_front();
						for (auto to : graph3[v]) {
							if (cann[v].first) {
								if (to.second) {
									if (!cann[to.first].second) {
										cann[to.first].second = true;
										dq.push_back(to.first);
									}
								}
								else {
									if (!cann[to.first].first) {
										cann[to.first].first = true;
										dq.push_back(to.first);
									}
								}
							}
							if (cann[v].second) {
								if (to.second) {
									if (!cann[to.first].first) {
										cann[to.first].first = true;
										dq.push_back(to.first);
									}
								}
								else {
									if (!cann[to.first].second) {
										cann[to.first].second = true;
										dq.push_back(to.first);
									}
								}
							}
						}
					}
					if (cann[A].second) {
						ans = -1;
						break;
					}
				}
				for (int b = 29; b >= 0; b--) {
					vector<vector<pair<int, int>>> graph3(n);
					for (int i = 0; i < tmp; i++) {
						for (auto to : graph[i]) {
							if (to.second & (1 << b)) {
								graph3[i].push_back({ to.first, 1 });
							}
							else {
								graph3[i].push_back({ to.first, 0 });
							}
						}
					}
					vector<pair<bool, bool>> cann(n);
					cann[B].first = true;
					deque<int> dq;
					dq.push_back(B);
					while (!dq.empty()) {
						int v = dq.front();
						dq.pop_front();
						for (auto to : graph3[v]) {
							if (cann[v].first) {
								if (to.second) {
									if (!cann[to.first].second) {
										cann[to.first].second = true;
										dq.push_back(to.first);
									}
								}
								else {
									if (!cann[to.first].first) {
										cann[to.first].first = true;
										dq.push_back(to.first);
									}
								}
							}
							if (cann[v].second) {
								if (to.second) {
									if (!cann[to.first].first) {
										cann[to.first].first = true;
										dq.push_back(to.first);
									}
								}
								else {
									if (!cann[to.first].second) {
										cann[to.first].second = true;
										dq.push_back(to.first);
									}
								}
							}
						}
					}
					if (cann[B].second) {
						ans = -1;
						break;
					}
				}
			}
			
			cout << ans << '\n';
		}
		else {
			int ans = 0;
			for (int b = 29; b >= 0; b--) {
				vector<vector<pair<int, int>>> graph3(n);
				for (int i = 0; i < tmp; i++) {
					for (auto to : graph[i]) {
						if (to.second & (1 << b)) {
							graph3[i].push_back({ to.first, 1 });
						}
						else {
							graph3[i].push_back({ to.first, 0 });
						}
					}
				}
				vector<pair<bool, bool>> cann(n);
				cann[A].first = true;
				deque<int> dq;
				dq.push_back(A);
				while (!dq.empty()) {
					int v = dq.front();
					dq.pop_front();
					for (auto to : graph3[v]) {
						if (cann[v].first) {
							if (to.second) {
								if (!cann[to.first].second) {
									cann[to.first].second = true;
									dq.push_back(to.first);
								}
							}
							else {
								if (!cann[to.first].first) {
									cann[to.first].first = true;
									dq.push_back(to.first);
								}
							}
						}
						if (cann[v].second) {
							if (to.second) {
								if (!cann[to.first].first) {
									cann[to.first].first = true;
									dq.push_back(to.first);
								}
							}
							else {
								if (!cann[to.first].second) {
									cann[to.first].second = true;
									dq.push_back(to.first);
								}
							}
						}
					}
				}
				if (cann[B].second) {
					ans = -1;
					break;
				}
			}
			cout << ans << '\n';
		}
	}
}