#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pp;

struct Edge {
    int to, w;
};
vector<int> dst, tout;
vector<int> used;
vector<vector<Edge>> graph;
vector<int> get_here_from_start, get_here_from_finish;

const int inf = 1e9;
int timer = 1;
int tout_timer = 1;

void mini_dfs(int v, int slice) {
    used[v] = timer;
    for (auto el:graph[v]) {
        if (used[el.to] < timer && dst[el.to] == slice) {
            mini_dfs(el.to, slice);
        }
    }
    tout[v] = tout_timer;
    tout_timer++;
}

bool cmp(int a, int b) {
    return tout[a] < tout[b];
}

int n, m;

void count(int bg, vector<int> &ans2) {
    timer = 1;
    tout_timer = 1;
    dst.assign(n, inf);
    tout.assign(n, 0);
    dst[bg] = 0;
    queue<int> qq;
    qq.push(bg);
    while (!qq.empty()) {
        int fr = qq.front();
        qq.pop();
        for (auto el:graph[fr]) {
            if (dst[el.to] == inf) {
                dst[el.to] = dst[fr] + 1;
                qq.push(el.to);
            }
        }
    }
    vector<vector<int>> groups(n);
    for (int i = 0; i < n; i++) {
        if (dst[i] != inf)
            groups[dst[i]].push_back(i);
    }
    used.assign(n, 0);
    ans2[bg] = 1;
    for (auto &slicce:groups) {
        tout_timer = 1;
        for (int vrt:slicce) {
            if (used[vrt] < timer) {
                mini_dfs(vrt, dst[slicce.back()]);
                timer++;
            }
        }
        sort(slicce.begin(), slicce.end(), cmp);
        for (int el:slicce) {
            for (auto edg:graph[el]) {
                if (dst[edg.to] >= dst[el]) {
                    ans2[edg.to] += ans2[el];
                }
            }
        }

    }
}


void solve() {
    cin >> n >> m;
    graph.assign(n, {});
    vector<pp> full_edges(m);
    vector<int> wghts(m);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
        full_edges[i] = {u, v};
        wghts[i] = w;
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;

    /*for (int el:dst) {
        cout << el << ' ';
    }
    cout << '\n';*/
    get_here_from_finish.assign(n, 0);
    get_here_from_start.assign(n, 0);
    count(a, get_here_from_start);

    graph.assign(n, {});
    for (int i = 0; i < m; i++){
        graph[full_edges[i].second].push_back({full_edges[i].first, wghts[i]});
    }
    count(b, get_here_from_finish);
   /* for (int el:get_here_from_start) {
        cout << el << ' ';
    }
    cout << '\n';
    for (int el:get_here_from_finish) {
        cout << el << ' ';
    }
    cout << '\n';*/
    ll xr = 0;
    for (int i = 0; i < m; i++) {
        int used_timer = get_here_from_start[full_edges[i].first] * get_here_from_finish[full_edges[i].second];
        if (used_timer % 2 == 1) {
            xr ^= (ll)wghts[i];
        }
    }
    cout << xr << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}