#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <functional>
#include <climits>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>



const int mod = 1000000007;

using namespace std;


using ll = long long;
using dl = long double;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;



template <typename T, typename S>
istream& operator>>(istream& in, pair<T, S>& a)
{
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream& operator<<(ostream& out, pair<T, S>& a)
{
    out << a.first << ' ' << a.second;
    return out;
}
template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (T& x : a) in >> x;
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T>& a)
{
    for (T& x : a) out << x << ' ';
    return out;
}

template <typename T>
struct VEC
{
    T x, y;
    template <typename S>
    VEC(S _x, S _y): x(_x), y(_y) {};
    VEC() {};

};
template <typename T>
VEC<T> operator+(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x + b.x, a.y + b.y);
}
template <typename T>
VEC<T> operator-(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x - b.x, a.y - b.y);
}
template <typename T>
ll cross(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.x + a.y*b.y;
}
template <typename T>
ll vecp(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.y - a.y*b.x;
}
template <typename T>
T dist2(VEC<T>& a, VEC<T>& b)
{
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}
template <typename T>
istream& operator >>(istream& in, VEC<T>& a)
{
    in >> a.x >> a.y;
    return in;
}
template <typename T>
ostream& operator <<(ostream& out, VEC<T>& a)
{
    out << a.x << ' ' << a.y;
    return out;
}

template <typename T>
dl angle(VEC<T>& a, VEC<T>& b)
{
    dl ret = atan2((dl)vecp(a, b), (dl)cross(a, b));
    return ret;
}



ll binpow(ll x, ll p, int m)
{
    if (p == 0) return 1;
    ll ret = binpow(x, p>>1, m);
    ret = ret*ret%m;
    if (p&1) ret = ret*x%mod;
    return ret;
}


struct segmtree
{
    vector<int> tree;
    int size;
    void merge()
    {

    }
    void clear()
    {

    }
    void update()
    {

    }
    segmtree() { }
    void build()
    {

    }

};



signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(18);
    


    int t = 1;
    cin >> t;
next:
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector<vector<pii>> adj(n, vector<pii>()), radj(n, vector<pii>());

        for (int i = 0; i < m; i++)
        {
            int a, b, c;
            cin >> a >> b >> c;
            --a, --b;
            adj[a].push_back(pii(b, c));
            radj[b].push_back(pii(a, c));
        }
        int st, fn;
        cin >> st >> fn;
        --st, --fn;
        bool huh = st == fn;

        vector<int> tops;
        vector<bool> used(n, false);
        function<void(int)> dfs1 = [&](int start)
        {
            used[start] = true;
            for (auto& next : adj[start])
            {
                if (used[next.first]) continue;
                dfs1(next.first);
            }
            tops.push_back(start);
        };
        for (int i = 0; i < n; i++)
        {
            if (!used[i]) dfs1(i);
        }

        reverse(tops.begin(), tops.end());
        used.assign(n, false);

        int px = 0;
        vector<int> csz;
        vector<int> ise;
        vector<int> wc(n, -1);


        function<void(int)> dfs2 = [&](int start)
        {
            wc[start] = px;
            used[start] = true;
            ++csz[px];
            for (auto& next : radj[start])
            {
                if (used[next.first]) continue;
                dfs2(next.first);
            }
        };

        for (int x : tops)
        {
            if (!used[x])
            {
                csz.push_back(0);
                ise.push_back(0);
                dfs2(x);
                ++px;
            }
        }

        for (int i = 0; i < n; i++)
        {
            for (auto next : adj[i])
            {
                if (wc[i]==wc[next.first] && next.second != 0) ise[wc[i]] = true;
            }
        }
        



        vector<int> ce(px, 0);
        vector<vector<pii>> cadj(px, vector<pii>()), rcadj(px, vector<pii>());
        for (int i = 0; i < n; i++)
        {
            if (ise[i]) continue;
            for (pii next : adj[i])
            {
                if (ise[next.first]) continue;
                if (wc[i] != wc[next.first]) 
                {
                    cadj[wc[i]].push_back(pii(wc[next.first], next.second));
                    rcadj[wc[next.first]].push_back(pii(wc[i], next.second));
                }
                else ++ce[wc[i]];
            }
        }
        
        st = wc[st], fn = wc[fn];
        if (st == fn)
        {
            if (huh && !ise[st]) cout << "0\n";
            else cout << "-1\n";
            goto next;
        }
        vector<bool> inpath(px, false);
        inpath[fn] = true;
        used.assign(px, false);
        int cntp = 0;
        vector<int> ctops;
        function<void(int)> dfs3 = [&](int start)
        {
            used[start] = true;
            for (pii next : cadj[start])
            {
                if (inpath[next.second]) inpath[start] = true, ++cntp;
                if (used[next.first]) continue;
                dfs3(next.first);
            }
            ctops.push_back(start);
        };
        for (int i = 0; i < px; i++)
        {
            if (!used[i]) dfs3(i);
        }
        if (!inpath[st])
        {
            cout << "-1\n";
            goto next;
        }

        vector<int> cnt_in(px, 0), cnt_out(px, 0);
        cnt_in[st] = 1;
        cnt_out[fn] = 1;

        for (int x : ctops)
        {
            if (!inpath[x]) continue;
            for (auto& next : cadj[x])
            {
                cnt_in[next.first] = (cnt_in[next.first] + cnt_in[x])%2;
            }
        }
        reverse(ctops.begin(), ctops.end());
        for (int x : ctops)
        {
            if (!inpath[x]) continue;
            for (auto& next : rcadj[x])
            {
                cnt_out[next.first] = (cnt_out[next.first] + cnt_out[x])%2;
            }
        }

        int ans = 0;
        for (int i = 0; i < px; i++)
        {
            if (!inpath[i]) continue;
            for (pii next : cadj[i])
            {
                if (!inpath[next.first]) continue;
                if (cnt_in[i] && cnt_out[next.first])
                {
                    ans ^= next.second;
                }
            }
        }
        cout << ans << '\n';

        


        
        




        

        
        
        
        




    }
    return 0;
}

