#include <bits/stdc++.h>

using namespace std;

// #include "debug.h"
// #define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

struct Edge {
    int u;
    int v;
    int w;

    int operator()(int a) {
        return (u ^ v ^ a);
    }

    Edge() = default;
    explicit Edge(int u_, int v_, int w_) : u(u_), v(v_), w(w_) {}
};

struct Solve {
    int n, m;
    vector<Edge> e;
    vector<bool> con_b;
    vector<vector<int>> g;


    Solve() {
        cin >> n >> m;

        g.resize(n);
        e.resize(m);

        int xor_tot = 0;

        for (int i = 0; i < m; ++i) {
            int u, v, w;
            cin >> u >> v >> w;
            --u, --v;
            e[i] = Edge(u, v, w);
            g[u].push_back(i);
            g[v].push_back(i);
            xor_tot ^= w;
        }

        int a, b;
        cin >> a >> b;
        --a, --b;

        int xor_path = 0;
        for (int i = a; i != b; i = (i + 1) % n) {
            xor_path ^= e[g[i][0]].w;
        }

        // dbg(xor_tot);
        // dbg(xor_path);

        if (xor_tot == 0) {
            if (xor_path == 0) {
                cout << 0 << '\n';
            } else {
                cout << -1 << '\n';
            }
        } else {
            cout << xor_tot << '\n';
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    while (T--) {
        Solve();
    }
}