#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);
const int SZ = 2e5 + 1;
vector<pair<int, int>> g[SZ], rg[SZ];
vector<int> topsort;
vector<bool> used(SZ, 0);
vector<int> positions(SZ, -1);

int make_topsort(int v) {
    used[v] = 1;
    vector<pair<int, int>> vec;
    for (auto u : g[v]) {
        if (!used[u.first])
            vec.push_back({ make_topsort(u.first), u.second });
        else
            vec.push_back({ positions[u.first], u.second });
    }
    int pos = topsort.size();
    for (auto u : vec) {
        rg[u.first].push_back({ pos, u.second });
    }
    topsort.push_back(v);
    positions[v] = pos;
    return pos;
}

void clear_place(int n) {
    topsort.clear();
    for (int i = 0; i <= n; i++) {
        g[i].clear();
        rg[i].clear();
        used[i] = 0;
        positions[i] = -1;
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    vector<int> answers(t, -2);
    for (int q = 0; q < t; q++) {
        int n, m, all = 0, a, b;
        bool acicl = 1;
        cin >> n >> m;
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            g[u].push_back({ v, w });
            if (i != m - 1 && u >= v)
                acicl = 0;
            if (i == m - 1 && (u != n || v != 1))
                acicl = 0;
            all ^= w;
        }
        cin >> a >> b;
        if (n == m && acicl) {
            int ans = 0;
            while (a != b) {
                ans ^= g[a].back().second;
                a = g[a].back().first;
            }
            if (ans != 0 || all != 0)
                answers[q] = -1;
            else
                answers[q] = 0;
            clear_place(n);
            continue;
        }

        make_topsort(a);
        vector<ll> dp(topsort.size(), 0);
        for (int i = topsort.size() - 1; i >= 0; i--) {
            for (auto x : rg[i])
                dp[i] ^= dp[x.first] ^ x.second;
        }
        if (positions[b] == -1) {
            answers[q] = -1;
            clear_place(n);
            continue;
        }
        answers[q] = dp[positions[b]];


        clear_place(n);
    }

    for (auto x : answers)
        cout << x << '\n';
}