#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 200000 + 10;

int n, m;
int a, b;
int dp[MAXN];
bool bl[MAXN];
int ways[MAXN];
std::vector <std::pair <int,int>> g[MAXN];

void dfs(int node)
{
    if (node == b)
    {
        dp[b] = 0;
        ways[b] = 1;
        return;
    }

    if (bl[node])
    {
        return;
    }

    bl[node] = true;
    for (const auto &[i, w] : g[node])
    {
        dfs(i);
        dp[node] ^= dp[i];
        dp[node] ^= ways[i] * w;
        ways[node] ^= ways[i];
    }
}

void solve()
{
    dfs(a);
    std::cout << dp[a] << '\n';
}

std::vector <int> edges;
void solve2()
{
    int xor1 = 0;
    int xor2 = 0;
    if (a > b) std::swap(a, b);
    for (const int &i : edges) xor1 ^= i;
    for (int i = a - 1 ; i < b - 1 ; ++i)
    {
        xor2 ^= edges[i];
    }

    if (xor1 == 0 && xor2 == 0) std::cout << 0 << '\n';
    else std::cout << -1 << '\n';
}

bool isDAG;
void input()
{
    isDAG = true;
    edges.clear();
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v, w;
        std::cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        edges.push_back(w);
        isDAG &= (u < v);
    }

    std::cin >> a >> b;
}

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        dp[i] = 0;
        ways[i] = 0;
        bl[i] = false;
        g[i].clear();
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIO();
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        if (isDAG) solve();
        else solve2();
    }

    return 0;
}