#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 200000 + 10;

int n, m;
int a, b;
int isBad;
int dp[MAXN];
bool bl[MAXN];
int ways[MAXN];
int xorTo[MAXN];
int state[MAXN];
bool starts[MAXN];
std::vector <std::pair <int,int>> g[MAXN];
std::set <int> vals[MAXN];

// SCC to be written
void firstDFS(int node)
{
    state[node] = 1;
    for (const auto [i, w] : g[node])
    {
        vals[i].insert(xorTo[node] ^ w);
        if (state[i] == 2) 
        {
            continue;
        }

        if (state[i] == 1)
        {
            starts[i] = true;
            if (xorTo[node] ^ w != xorTo[i])
            {
                isBad = 2;
            } else if (isBad == 0)
            {
                isBad = 1;
            }
        
            continue;
        }
        
        xorTo[i] = xorTo[node] ^ w;
        firstDFS(i);
    }

    state[node] = 2;
}

void dfs(int node)
{
    if (node == b)
    {
        dp[b] = 0;
        ways[b] = 1;
        return;
    }

    if (bl[node])
    {
        return;
    }

    state[node] = 1;
    bl[node] = true;
    for (const auto &[i, w] : g[node])
    {
        if (state[i] == 1)
        {
            continue;
        }

        dfs(i);
        dp[node] ^= dp[i];
        dp[node] ^= ways[i] * w;
        ways[node] ^= ways[i];
    }

    state[node] = 2;
}

void solve()
{
    isBad = 0;
    firstDFS(a);
    if (isBad == 2)
    {
        std::cout << -1 << '\n';
        return;
    }

    if (isBad == 1)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            if (starts[i] && (vals[i].size() > 1 || (*vals[i].begin()) != 0))
            {
                std::cout << -1 << '\n';
                return;
            }
        }
    }
    
    std::fill(state + 1, state + 1 + n, 0);
    dfs(a);
    std::cout << dp[a] << '\n';
}

std::vector <int> edges;
void solve2()
{
    int xor1 = 0;
    int xor2 = 0;
    if (a > b) std::swap(a, b);
    for (const int &i : edges) xor1 ^= i;
    for (int i = a - 1 ; i < b - 1 ; ++i)
    {
        xor2 ^= edges[i];
    }

    if (xor1 == 0 && xor2 == 0) std::cout << 0 << '\n';
    else std::cout << -1 << '\n';
}

bool isFirst;
void input()
{
    edges.clear();
    std::cin >> n >> m;
    isFirst = (n == m);
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v, w;
        std::cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        edges.push_back(w);
        if (i == n)
        {
            isFirst &= (u == n && v == 1);
        } else
        {
            isFirst &= (u == i && v == i + 1);
        }
    }

    std::cin >> a >> b;
}

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        dp[i] = 0;
        ways[i] = 0;
        state[i] = 0;
        starts[i] = 0;
        xorTo[i] = 0;
        bl[i] = false;
        vals[i].clear();
        g[i].clear();
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIO();
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        if (isFirst) solve2();
        else solve();
    }

    return 0;
}