#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

bool ok;
bool cyc_0;
bool done;
vector <int> cnt;
vector <int> hei;
int n;
int a, b;

struct edge {
    int ver, val;
};

vector <vector <edge>> g;
vector <int> used;
vector <int> bad;
vector <int> in;

void dfs_cnt(int v, int val) {
    vector <pair<int, int>> go = {{v, val}};
    pii tmp;
    while (go.size() > 0) {
        tmp = go.back();
        used[tmp.first] = true;
        if (tmp.first == b) {
            done = true;
        }
        go.pop_back();
        for (auto n: g[tmp.first]) {
            in[n.ver]--;
            cnt[n.ver] ^= val ^ n.val;
            if (in[n.ver] <= bad[n.ver] && !used[n.ver]) {
                go.push_back({n.ver, cnt[n.ver]});
            }
        }
    }
}

int dfs_h(int v, int h) {
    hei[v] = h;
    int res;
    int tmp;
    for (auto n: g[v]) {
        if (hei[n.ver] == -1) {
            tmp = dfs_h(n.ver, h + 1);
            if (tmp <= h) {
                bad[v]++;
                cyc_0 = true;
            }
            res = min(res, tmp);
        } else {
            tmp = hei[n.ver];
            if (tmp <= h) {
                bad[v]++;
                cyc_0 = true;
            }
            res = min(res, tmp);
        }
    }
    res = min(res, h);
    return res;
}

void solve() {
    ok = true;
    cyc_0 = false;
    done = false;
    int m;
    cin >> n >> m;
    g.assign(n, {});
    in.assign(n, 0);
    int t1, t2, t3;
    for (int i = 0 ; i < m; i++) {
        cin >> t1 >> t2 >> t3;
        t1--;
        t2--;
        g[t1].push_back({t2, t3});
        in[t2]++;
    }
    cin >> a >> b;
    a--;
    b--;
    hei.assign(n, -1);
    hei[a] = 0;
    bad.assign(n, 0);
    dfs_h(a, 0);
    used.assign(n, 0);
    cnt.resize(n, 0);
    dfs_cnt(a, 0);
    if (ok && done) {
        if (cnt[b] != 0 && cyc_0) {
            cout << -1 << "\n";
        } else {
            cout << cnt[b] << "\n";
        }
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}