#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct edge {
    int u, w;
};

vector<vector<edge>> g1, g2;
vector<bool> used;
vector<pair<int, int>> dp;
vector<int> order;
vector<int> clr;

void top_sort(int v) {
    used[v] = true;
    for (auto [u, w]: g1[v]) {
        if (!used[u]) {
            top_sort(u);
        }
    }
    order.push_back(v);
}

void dfs(int v, int b) {
    used[v] = true;
    if (v == b) return;

    for (auto [u, w]: g1[v]) {
        if (!used[u]) {
            dfs(u, b);
        }
        dp[v].first ^= dp[u].first ^ (dp[u].second * w);
        dp[v].second = (dp[v].second + dp[u].second) % 2;
    }
}

void dfs2(int v, int c) {
    clr[v] = c;
    for (auto [u, w]: g2[v]) {
        if (clr[u] == -1) {
            dfs2(u, c);
        }
    }
}

void solve() {
    int n, m, a, b, c = 0;
    cin >> n >> m;

    g1.clear();
    g1.resize(n);
    g2.clear();
    g2.resize(n);
    used.clear();
    used.resize(n);
    dp.clear();
    dp.resize(n);
    order.clear();
    clr.clear();
    clr.resize(n);
    fill(clr.begin(), clr.end(), -1);

    bool group1 = (n == m);
    vector<int> wg(2 * n);

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        if (v == u && w == 0) continue;

        g1[v].push_back({u, w});
        g2[u].push_back({v, w});

        if (i < n) {
            wg[i] = wg[n + i] = w;
        }

        if (i < n - 1) {
            group1 &= (v == i && u == i + 1);
        } else {
            group1 &= (v == n - 1 && u == 0);
        }
    }

    cin >> a >> b;
    a--, b--;

    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            top_sort(v);
        }
    }
    fill(used.begin(), used.end(), false);

    reverse(order.begin(), order.end());
    for (int v: order) {
        if (clr[v] == -1) {
            dfs2(v, c++);
        }
    }

    if (clr[a] == clr[b]) {
        if (b <= a) {
            b += n;
        }

        int ans = 0, all = 0;
        for (int i = 0; i < n; ++i) {
            all ^= wg[i];
        }
        for (int i = a; i < b; ++i) {
            ans ^= wg[i];
        }

        if (ans == 0 && (all ^ ans) == 0) {
            cout << "0\n";
        } else {
            cout << "-1\n";
        }
    } else {
        dp[b] = {0, 1};
        dfs(a, b);
        cout << dp[a].first << "\n";
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}