#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

int f[maxn];

int get(int i) {
    int ans = 0;
    while (i >= 0) {
        ans = max(ans, f[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int x) {
    while (i < maxn) {
        f[i] = max(f[i], x);
        i = i | (i + 1);
    }
}

vector<int> ord;

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<int> &dp) {
    dp[v] = 0;
    for (auto [u, w] : g[v]) {
        if (dp[u] == -1) {
            dfs(u, g, dp);
        }
    }
    ord.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({ v, w });
    }
    int s, t;
    cin >> s >> t;
    --s; --t;
    int ans = 0;
    bool ok = true;
    for (int bit = 0; bit < 30; ++bit) {
        vector<vector<pair<int, int>>> gp(n);
        vector<vector<pair<int, int>>> rgp(n);
        for (int j = 0; j < n; ++j) {
            for (auto [u, w] : g[j]) {
                if ((1 << bit) & w) {
                    gp[j].push_back({ u, 1 });
                    rgp[u].push_back({ j, 1 });
                } else {
                    gp[j].push_back({ u, 0 });
                    rgp[u].push_back({ j, 0 });
                }
            }
        }
        ord.clear();
        vector<int> dp(n, -1);
        dfs(s, g, dp);
        reverse(ord.begin(), ord.end());
        for (int i : ord) {
            if (dp[i] == -1) continue;
            for (auto [u, w] : rgp[i]) {
                dp[i] ^= dp[u] ^ w;
            }
        }
        dp[t] = max(dp[t], 0);
        ans ^= (1 << bit) * dp[t];
    }
    if (ok) {
        cout << ans << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
