#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

int f[maxn];

int get(int i) {
    int ans = 0;
    while (i >= 0) {
        ans = max(ans, f[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int x) {
    while (i < maxn) {
        f[i] = max(f[i], x);
        i = i | (i + 1);
    }
}

vector<int> ord;

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<int> &dp) {
    dp[v] = 0;
    for (auto [u, w] : g[v]) {
        if (dp[u] == -1) {
            dfs(u, g, dp);
        }
    }
    ord.push_back(v);
}

void dfs(int v, vector<bool> &used, vector<vector<int>> &g) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, used, g);
        }
    }
    ord.push_back(v);
}

void dfs2(int v, vector<int> &used, vector<vector<int>> &g, int color) {
    used[v] = color;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs2(u, used, g, color);
        }
    }
}

vector<int> bfs(int v, vector<vector<int>> &g) {
    vector<int> d(g.size(), inf);
    deque<int> q{v};
    d[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int u : g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push_back(u);
            }
        }
    }
    return d;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({ v, w });
    }
    int s, t;
    cin >> s >> t;
    --s; --t;
    int ans = 0;
    for (int bit = 0; bit < 30; ++bit) {
        vector<vector<int>> gpp(n * 3);
        vector<vector<int>> rgpp(n * 3);
        vector<bool> even(n, false);
        vector<bool> odd(n, false);
        for (int j = 0; j < n; ++j) {
            for (auto [u, w] : g[j]) {
                if (w & (1 << bit)) {
                    if (u == j) odd[j] = true;
                    gpp[j].push_back(u + n);
                    gpp[j + n].push_back(u);
                    rgpp[u + n].push_back(j);
                    rgpp[u].push_back(j + n);
                    gpp[j + n * 2].push_back(u + n);
                    gpp[j + n].push_back(u + n * 2);
                    rgpp[u + n].push_back(j + n * 2);
                    rgpp[u + n * 2].push_back(j + n);
                } else {
                    if (u == j) even[j] = true;
                    gpp[j].push_back(u);
                    gpp[j + n].push_back(u + n);
                    rgpp[u].push_back(j);
                    rgpp[u + n].push_back(j + n);
                    gpp[j + n * 2].push_back(u + n * 2);
                    gpp[j + n].push_back(u + n);
                    rgpp[u + n * 2].push_back(j + n * 2);
                    rgpp[u + n].push_back(j + n);
                }
            }
        }
        vector<bool> used(n * 3, false);
        ord.clear();
        for (int i = 0; i < n * 3; ++i) {
            if (!used[i]) {
                dfs(i, used, gpp);
            }
        }
        reverse(ord.begin(), ord.end());
        int color = 1;
        vector<int> comp(n * 3, 0);
        for (int i : ord) {
            if (!comp[i]) {
                dfs2(i, comp, rgpp, color++);
            }
        }
        for (int i = 0; i < n; ++i) {
            if (comp[i] == comp[i + n]) {
                odd[i] = true;
            }
            if (comp[i] == comp[i + n * 2]) {
                even[i] = true;
            }
        }
        vector<int> dS = bfs(s, gpp);
        vector<int> dT = bfs(t, rgpp);
        vector<vector<pair<int, int>>> gp(n);
        vector<vector<pair<int, int>>> rgp(n);
        for (int j = 0; j < n; ++j) {
            for (auto [u, w] : g[j]) {
                if ((1 << bit) & w) {
                    gp[j].push_back({ u, 1 });
                    rgp[u].push_back({ j, 1 });
                } else {
                    gp[j].push_back({ u, 0 });
                    rgp[u].push_back({ j, 0 });
                }
            }
        }
        ord.clear();
        vector<int> dp(n, -1);
        vector<int> cnt(n, 0);
        cnt[s] = 1;
        dfs(s, gp, dp);
        reverse(ord.begin(), ord.end());
        for (int i : ord) {
            if (dp[i] == -1) continue;
            if (odd[i] && dS[i] != inf) {
                cout << -1 << '\n';
                return;
            }
            if (even[i]) {
                if (dS[i + n] != inf & dT[i] != inf) {
                    cout << -1 << '\n';
                    return;
                }
                if (dS[i] != inf & dT[i + n] != inf) {
                    cout << -1 << '\n';
                    return;
                }
                dp[i] = -1;
                continue;
            }
            for (auto [u, w] : rgp[i]) {
                if (dp[u] != -1) {
                    cnt[i] ^= cnt[u];
                    dp[i] ^= (dp[u] ^ (w * cnt[u]));
                }
            }
        }
        dp[t] = max(dp[t], 0);
        ans ^= ((1 << bit) * dp[t]);
    }
    cout << ans << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
