#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

int n, m;
vector<vector<pair<int, int>>> gr_in, gr_out;
int a, b;

vector<int> p;
vector<int> color;
vector<int> path_xor;

vector<bool> on_cycle, on_nonzero_cycle;

void dfs(int v) {
    color[v] = 1;
    for (auto [to, w] : gr_out[v]) {
        if (color[to] == 0) {
            p[to] = v;
            path_xor[to] = path_xor[v] ^ w;
            dfs(to);
        } else if (color[to] == 1) {
            vector<int> cycle = {v};
            int cur = v;
            while (cur != to) {
                cur = p[cur];
                cycle.push_back(cur);
            }
            if (path_xor[v] ^ path_xor[to] ^ w) {
                for (auto i : cycle) {
                    on_cycle[i] = on_nonzero_cycle[i] = true;
                }
            } else {
                for (auto i : cycle) {
                    on_cycle[i] = true;
                }
            }
        }
    }
    color[v] = 2;
}

vector<bool> used_a, used_b;
vector<int> order_a, order_b;

void topsort_a(int v) {
    used_a[v] = true;
    for (auto [to, w] : gr_out[v]) {
        if (!used_a[to]) {
            topsort_a(to);
        }
    }
    order_a.push_back(v);
}

void topsort_b(int v) {
    used_b[v] = true;
    for (auto [to, w] : gr_in[v]) {
        if (!used_b[to]) {
            topsort_b(to);
        }
    }
    order_b.push_back(v);
}

bool check() {
    order_a.clear();
    order_b.clear();
    used_a.assign(n, false);
    used_b.assign(n, false);
    topsort_a(a);
    topsort_b(b);
    reverse(order_a.begin(), order_a.end());
    reverse(order_b.begin(), order_b.end());
    for (int i = 0; i < n; ++i) {
        if (used_a[i] && used_b[i] && on_nonzero_cycle[i]) {
            return false;
        }
    }
    for (int k = 0; k < 30; ++k) {
        vector<bool> dp0_a(n, false), dp1_a(n, false);
        vector<bool> dp0_b(n, false), dp1_b(n, false);
        dp0_a[a] = dp0_b[b] = true;
        for (auto i : order_a) {
            for (auto [from, w] : gr_in[i]) {
                if (dp0_a[from]) {
                    if (w >> k & 1) {
                        dp1_a[i] = true;
                    } else {
                        dp0_a[i] = true;
                    }
                }
                if (dp1_a[from]) {
                    if (w >> k & 1) {
                        dp0_a[i] = true;
                    } else {
                        dp1_a[i] = true;
                    }
                }
            }
        }
        for (auto i : order_b) {
            for (auto [to, w] : gr_out[i]) {
                if (dp0_b[to]) {
                    if (w >> k & 1) {
                        dp1_b[i] = true;
                    } else {
                        dp0_b[i] = true;
                    }
                }
                if (dp1_b[to]) {
                    if (w >> k & 1) {
                        dp0_b[i] = true;
                    } else {
                        dp1_b[i] = true;
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (used_a[i] && used_b[i] && on_cycle[i]) {
                if (dp0_a[i] && dp1_b[i] || dp1_a[i] && dp0_b[i]) {
                    return false;
                }
            }
        }
    }
    return true;
}

vector<int> order;
vector<bool> used;

void topsort(int v) {
    used[v] = true;
    for (auto [to, w] : gr_out[v]) {
        if (!used[to] && !on_cycle[to]) {
            topsort(to);
        }
    }
    order.push_back(v);
}

void cycle_check(int v, int cur, int start) {
    used[v] = true;
    for (auto [to, w] : gr_out[v]) {
        if (!used[to]) {
            cycle_check(to, cur ^ w, start);
        } else if (to == start) {
            if (cur ^ w) {
                on_cycle[start] = on_nonzero_cycle[start] = true;
            } else {
                on_cycle[start] = true;
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    gr_in.assign(n, {});
    gr_out.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr_out[u].emplace_back(v, w);
        gr_in[v].emplace_back(u, w);
    }
    cin >> a >> b;
    a--, b--;

    p.assign(n, -1);
    color.assign(n, 0);
    path_xor.assign(n, 0);

    on_cycle.assign(n, false);
    on_nonzero_cycle.assign(n, false);

    dfs(0);

    if (n <= 1000 && m <= 1000) {
        on_cycle.assign(n, false);
        on_nonzero_cycle.assign(n, false);
    }

    for (int i = 0; i < n; ++i) {
        used.assign(n, false);
        cycle_check(i, 0, i);
    }

    if (!check()) {
        cout << -1 << '\n';
        return;
    }

    order.clear();
    used.assign(n, false);
    topsort(a);
    reverse(order.begin(), order.end());

    vector<int> cnt(n, 0);
    vector<int> xor_sum(n, 0);
    xor_sum[a] = 0;
    cnt[a] = 1;
    for (auto i : order) {
        for (auto [from, w] : gr_in[i]) {
            if (xor_sum[from] != -1) {
                xor_sum[i] ^= xor_sum[from] ^ (cnt[from] ? w : 0);
                cnt[i] ^= cnt[from];
            }
        }
    }

    cout << xor_sum[b] << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}