#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

vector<vector<pair<int, int>>> gr;
vector<int> xr;
vector<int> cnt;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for (auto [to, w] : gr[v]) {
        if (!used[to]) {
            dfs(to);
        }
        cnt[v] += cnt[to];
        xr[v] ^= xr[to];
        if (cnt[to] % 2 != 0) {
            xr[v] ^= w;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.assign(n, vector<pair<int, int>>(0));
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;
    xr.assign(n, 0);
    cnt.assign(n, 0);
    used.assign(n, false);
    cnt[b] = 1;
    used[b] = true;

    dfs(a);

    cout << xr[a] << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
