#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

const int maxn = (2e5) + 100;

vector<pair<int, int>> g[maxn];

int n, m, a, b;

void clear(int n) {
	for (int i = 0; i < n; i++) {
		g[i].clear();
	}
}

void solve2() {
	int AB = 0, cycle = g[a][0].second;
	int x = a;
	while (x != b) {
		AB ^= g[x][0].second;
		x = g[x][0].first;
	}
	x = g[a][0].first;
	while (x != a) {
		cycle ^= g[x][0].second;
		x = g[x][0].first;
	}
	if (cycle == 0 && AB == 0) {
		cout << 0 << '\n';
	} else if (AB != 0) {
		cout << -1 << '\n';
	} else if (cycle != 0 && AB == 0) {
		cout << -1 << '\n';
	}
}

void solve() {
	cin >> n >> m;
	bool ok = (n == m);
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		v--, u--;
		g[v].push_back({ u, w });
		if (i == m - 1) {
			ok &= (v == n - 1 && u == 0);
		} else {
			ok == (v == i && u == (i + 1));
		}
	}
	cin >> a >> b;
	a--, b--;
	if (ok) {
		solve2();
		clear(n);
		return;
	}
	clear(n);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}
