#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

const int maxn = (2e5) + 100;

vector<pair<int, int>> g[maxn];
vector<pair<int, int>> t[maxn];

int n, m, a, b;
int fromA[maxn], toB[maxn], used1[maxn], used2[maxn];

void clear(int n) {
	for (int i = 0; i < n; i++) {
		g[i].clear();
		t[i].clear();
		used1[i] = 0, used2[i] = 0;
		fromA[i] = -1;
		toB[i] = -1;
	}
	
}

void solve2() {
	int AB = 0, cycle = g[a][0].second;
	int x = a;
	while (x != b) {
		AB ^= g[x][0].second;
		x = g[x][0].first;
	}
	x = g[a][0].first;
	while (x != a) {
		cycle ^= g[x][0].second;
		x = g[x][0].first;
	}
	if (cycle == 0 && AB == 0) {
		cout << 0 << '\n';
	} else if (AB != 0) {
		cout << -1 << '\n';
	} else if (cycle != 0 && AB == 0) {
		cout << -1 << '\n';
	}
}

void dfs1(int v) {
	if (used1[v]) return;
	used1[v] = 1;
	if (v == b) {
		toB[v] = 1;
		return;
	}
	for (auto& [u, w] : g[v]) {
		dfs1(u);
		if (toB[u] != -1) {
			if (toB[v] == -1) toB[v] = 0;
			toB[v] ^= toB[u];
		}
	}
}

void dfs2(int v) {
	if (used2[v]) return;
	used2[v] = 1;
	if (v == a) {
		fromA[v] = 1;
		return;
	}
	for (auto& [u, w] : t[v]) {
		dfs2(u);
		if (fromA[u] != -1) {
			if (fromA[v] == -1) fromA[v] = 0;
			fromA[v] ^= fromA[u];
		}
	}
}

void solve3() {
	for (int i = 0; i < n; i++) {
		if (!used1[i]) {
			dfs1(i);
		}
		if (!used2[i]) {
			dfs2(i);
		}
	}
	int ans = 0;
	for (int v = 0; v < n; v++) {
		for (auto& [u, w] : g[v]) {
			if (fromA[v] == -1 || toB[u] == -1) continue;
			if (fromA[v] && toB[u]) {
				ans ^= w;
			}
		}
	}
	cout << ans << '\n';
}

void solve() {
	cin >> n >> m;
	bool ok = (n == m);
	bool ok1 = 1;
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		v--, u--;
		g[v].push_back({ u, w });
		t[u].push_back({ v, w });
		if (i == m - 1) {
			ok &= (v == n - 1 && u == 0);
		} else {
			ok == (v == i && u == (i + 1));
		}
		ok1 &= (v < u);
	}
	cin >> a >> b;
	a--, b--;
	if (ok) {
		solve2();
		clear(n);
		return;
	}
	if (ok1) {
		solve3();
		clear(n);
		return;
	}
	clear(n);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}
