#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long

vector<pair<int, int>> g[2000 * 101];
vector<pair<int, int>> gt[2000 * 101];
int used[2000 * 101];
vector<int> tps;

void dfs(int v) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    tps.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    fill(used, used + n + 1, 0);
    fill(g, g + n + 1, vector<pair<int, int>>());
    fill(gt, gt + n + 1, vector<pair<int, int>>());
    int xr = 0;
    vector<int> nxt(n + 1);
    bool ok = true;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a >= b) {
            ok = false;
        }
        g[a].emplace_back(b, c);
        gt[b].emplace_back(a, c);
        nxt[a] = c;
        xr ^= c;
    }
    if (!ok) {
        int wxr = xr;
        int a, b;
        cin >> a >> b;
        if (a == b) {
            if (xr != 0) {
                cout << -1 << '\n';
            } else {
                cout << 0 << '\n';
            }
            return;
        }
        xr = 0;
        while (a != b) {
            xr ^= nxt[a];
            if (a == n) {
                a = 1;
            } else {
                a++;
            }
        }
        if (xr != 0 || wxr != 0) {
            cout << -1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    } else {
        int a, b;
        cin >> a >> b;
        if (b < a) {
            cout << 0 << '\n';
            return;
        }
        tps.clear();
        vector<int> dp(n + 1, 0);
        vector<int> dp2(n + 1, 0);

        dp[a] = 0;
        dp2[a] = 1;
        for (int x = a; x <= b; x++) {
            for (auto [u, w] : gt[x]) {
                if (dp2[u] % 2 == 1) {
                    dp[x] ^= dp[u] ^ w;
                } else {
                    dp[x] ^= dp[u];
                }
                dp2[x] += dp2[u];
            }
        }
        cout << dp[b] << '\n';
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}

/*
/home/olymp/PreDay/cmake-build-debug/PreDay
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4.
4
1 1 2 2
1 2 2 1
 3 4 4 3
 3 4 3 5
 */