#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
using namespace std;
#define int long long

vector<pair<int, int>> g[2000 * 101];
vector<pair<int, int>> gt[2000 * 101];
vector<pair<int, int>> gc[2000 * 101];
vector<pair<int, int>> gct[2000 * 101];
int used[2000 * 101];
vector<int> tps;

void dfs(int v) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    tps.push_back(v);
}

vector<int> comps[2000 * 101];
int comp[2000 * 101];
int clr = 0;
void rdfs(int v) {
    comp[v] = clr;
    comps[clr].push_back(v);
    used[v] = 1;
    for (auto [u, w] : gt[v]) {
        if (!used[u]) {
            rdfs(u);
        }
    }
}

void cdfs(int v) {
    used[v] = 1;
    for (auto [u, w] : gc[v]) {
        if (!used[u]) {
            cdfs(u);
        }
    }
    tps.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    clr = 0;
    fill(used, used + n + 1, 0);
    fill(g, g + n + 1, vector<pair<int, int>>());
    fill(comp, comp + n + 1, -1);
    fill(comps, comps + n + 1, vector<int>());
    fill(gt, gt + n + 1, vector<pair<int, int>>());
    fill(gc, gc + n + 1, vector<pair<int, int>>());
    fill(gct, gct + n + 1, vector<pair<int, int>>());
    int xr = 0;
    vector<int> nxt(n + 1);
    bool ok = true;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].emplace_back(b, c);
        gt[b].emplace_back(a, c);
        nxt[a] = c;
        xr ^= c;
    }
    int a, b;
    cin >> a >> b;

    tps.clear();
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(tps.begin(), tps.end());
    fill(used, used + n + 1, 0);
    for (auto x : tps) {
        if (!used[x]) {
            rdfs(x);
            clr++;
        }
    }
    vector<int> good(clr);
    for (int i = 0; i < clr; i++) {
        for (auto x : comps[i]) {
            for (auto y : g[x]) {
                if (comp[y.first] == i) {
                    good[i] = true;
                }
                gc[i].push_back({comp[y.first], y.second});
                gct[comp[y.first]].push_back({i, y.second});
            }
        }
    }
    fill(used, used + n + 1, 0);
    tps.clear();
    cdfs(comp[a]);
    vector<int> p_cp(clr);
    reverse(tps.begin(), tps.end());
    p_cp[a] = good[comp[a]];
    for (auto x : tps) {
        p_cp[x] |= good[x];
        for (auto [y, w] : gct[x]) {
            p_cp[x] |= p_cp[y];
        }
    }
    if (!p_cp[comp[b]]) {
        fill(used, used + n + 1, 0);
        tps.clear();
        dfs(a);
        reverse(tps.begin(), tps.end());
        vector<int> dp(n + 1, 0);
        vector<int> dp2(n + 1, 0);

        dp[a] = 0;
        dp2[a] = 1;
        for (auto x : tps) {
            for (auto [u, w] : gt[x]) {
                if (dp2[u] % 2 == 1) {
                    dp[x] ^= dp[u] ^ w;
                } else {
                    dp[x] ^= dp[u];
                }
                dp2[x] += dp2[u];
                dp2[x] %= 2;
            }
        }
        cout << dp[b] << '\n';
    } else {
        fill(used, used + n + 1, 0);
        tps.clear();
        dfs(a);
        reverse(tps.begin(), tps.end());
        vector<vector<int>> dp(n + 1, vector<int> (1024));
        dp[a][0] = 1;
        for (auto x : tps) {
            for (auto [y, w] : gt[x]) {
                for (int k = 0; k < 1024; k++) {
                    if (dp[y][k]) {
                        dp[x][k^w] = 1;
                    }
                }
            }
        }
        for (auto x : tps) {
            for (auto [y, w] : gt[x]) {
                for (int k = 0; k < 1024; k++) {
                    if (dp[y][k]) {
                        dp[x][k^w] = 1;
                    }
                }
            }
        }
        for (int i = 1; i < 1024; i++) {
            if (dp[b][i] != 0) {
                cout << -1 << '\n';
                return;
            }
        }
        cout << 0 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}

/*
5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
 1 2 1
 2 1 2
 1 2
 3 3
 1 2 7
 2 3 0
 3 1 7
 2 3
 4 5
 1 1 0
 1 2 3
 2 2 0
 2 3 1
 3 4 1
 1 4
 */