#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 2e5 + 7;

struct Edge {
	int v, w;
};

int n, m, k, A, B;

vector<Edge> edges[N], rev_edges[N];

set<int> xr[N], rev_xr[N], xr2[N];

vector<int> topsort;

bool vis[N], cyc[N], dost[N];
int p[N];

void tp(int v) {
	vis[v] = 1;
	dost[v] = 1;
	for (auto u : edges[v]) {
		if (!vis[u.v]) {
			tp(u.v);
		}
		else {
			cyc[v] = 1;
		}
	}
	topsort.push_back(v);
}

void ClearVis() {
	for (int i = 1; i <= n; i++) {
		vis[i] = 0;
	}
}

int cnt[N], cnt2[N];
void solve() {
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		edges[i].clear();
		rev_edges[i].clear();
		xr[i].clear();
		rev_xr[i].clear();
		xr2[i].clear();
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		edges[u].push_back({ v,w });
		rev_edges[v].push_back({ u,w });
	}
	cin >> A >> B;
	topsort.clear();
	ClearVis();
	tp(B);
	xr[A].insert(0);
	for (auto cur : topsort) {
		for (auto e : edges[cur]) {
			for (auto X : xr[cur]) {
				xr[e.v].insert(X ^ e.w);
				if (xr[e.v].size() > 2) {
					xr[e.v].erase(xr[e.v].begin());
				}
			}
		}
	}
	rev_xr[B].insert(0);
	reverse(topsort.begin(), topsort.end());
	for (auto cur : topsort) {
		for (auto e : rev_edges[cur]) {
			for (auto X : rev_xr[cur]) {
				rev_xr[e.v].insert(X ^ e.w);
				if (rev_xr[e.v].size() > 2) {
					rev_xr[e.v].erase(rev_xr[e.v].begin());
				}
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		if (cyc[i]) {
			xr2[i] = xr[i];
		}
		else {
			xr2[i].clear();
		}
	}
	reverse(topsort.begin(), topsort.end());
	for (auto cur : topsort) {
		for (auto e : edges[cur]) {
			for (auto X : xr2[cur]) {
				xr2[e.v].insert(X ^ e.w);
				if (xr2[e.v].size() > 2) {
					xr2[e.v].erase(xr2[e.v].begin());
				}
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		for (auto u : xr2[i]) {
			for (auto v : rev_xr[i]) {
				if (u != v) {
					cout << "-1\n";
					return;
				}
			}
		}
	}
	ClearVis();
	cnt[A] = 1;
	for (auto cur : topsort) {
		for (auto e : edges[cur]) {
			cnt[e.v] += cnt[cur];
			cnt[e.v] %= 2;
		}
	}
	cnt2[B] = 1;
	reverse(topsort.begin(), topsort.end());
	for (auto cur : topsort) {
		for (auto e : rev_edges[cur]) {
			cnt2[e.v] += cnt2[cur];
			cnt2[e.v] %= 2;
		}
	}
	int ANSW = 0;
	for (int i = 1; i <= n; i++) {
		for (auto e : edges[i]) {
			if ((cnt[i] % 2 || cnt2[e.v] % 2) && dost[e.v]) {
				ANSW ^= e.w;
			}
		}
	}
	cout << ANSW << "\n";
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	
}
