#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e9;
const int MAX = 2e5 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int n, m;
int a, b;
vector<pair<int, int>> g[MAX];
vector<pair<int, int>> r[MAX];

/*
1
4 6
1 2 1
1 2 1
2 3 1
2 3 1
3 4 1
3 4 1
1 4
*/

void solve_easy() {
    vector<int> used(n + 1);
    vector<int> dps(n + 1);
    vector<int> dpt(n + 1);
    dps[a] = 1; dpt[b] = 1;
    for(int v = 1; v <= n; v++) {
        for(auto [to, w] : g[v]) {
            dps[to] ^= dps[v];
        }
    }
    for(int v = n; v; v--) {
        for(auto [to, w] : r[v]) {
            dpt[to] ^= dpt[v];
        }
    }
    int ans = 0;
    for(int v = 1; v <= n; v++) {
        for(auto [u, w] : g[v]) {
            int cnt = dps[v] & dpt[u];
            if(cnt) ans ^= w;
        }
    }
    cout << ans << '\n';
}

void solve() {
    cin >> n >> m;
    for(int i = 1; i <= n; i++) {
        g[i].clear();
        r[i].clear();
    }
    int is_easy = 1;
    int mx = 0;
    int x = 0;
    for(int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        r[v].pb({u, w});
        is_easy &= u < v;
        umax(mx, w);
        x ^= w;
    }
    cin >> a >> b;
    if(is_easy) {
        solve_easy();
        return;
    }
    int val = 0;
    function<void(int)> dfs = [&](int v) {
        if(v == b) return;
        for(auto [to, w] : g[v]) {
            val ^= w;
            dfs(to);
        }
    };
    dfs(a);
    if(x || val) {
        cout << "-1\n";
        return;
    }
    cout << 0 << '\n';
}

/*
1
3 3
1 2 1
2 3 2
3 1 3
1 3
*/

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    cin >> ttt;
    while(ttt--) solve();
}
