#include <iostream>
#include <vector>
#include <utility>
#include <tuple>
#define int long long

using namespace std;


int n, m;
vector<vector<pair<int, int>>> g, rg;
vector<tuple<int, int, int>> edge;
vector<bool> used;
vector<int> topsort1, topsort2;

void dfs1(int v) {
    used[v] = true;
    for (auto& ee : g[v]) {
        auto to = get<0>(ee);
        auto w = get<1>(ee);
        if (!used[to]) {
            dfs1(to);
        }
    }
    topsort1.push_back(v);
}

void dfs2(int v) {
    used[v] = true;
    for (auto& ee : rg[v]) {
        auto to = get<0>(ee);
        auto w = get<1>(ee);
        if (!used[to]) {
            dfs2(to);
        }
    }
    topsort2.push_back(v);
}

void solve() {
    cin >> n >> m;
    g.resize(n);
    rg.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        edge.emplace_back(u, v, w);
        g[u].emplace_back(v, w);
        rg[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    if (n == m) {
        bool flag = true;
        for (int i = 0; i < m - 1; i++) {
            flag &= get<0>(edge[i]) == i;
            flag &= get<1>(edge[i]) == i + 1;
        }
        flag &= get<0>(edge[m - 1]) == n - 1;
        flag &= get<1>(edge[m - 1]) == 0;
        if (flag) {
            int X = 0;
            for (int i = 0; i < m; i++)
                X ^= get<2>(edge[i]);
            if (X == 0) {
                cout << 0 << '\n';
                return;
            }
            else {
                cout << -1 << '\n';
                return;
            }
        }
    }
    dfs1(a);
    used.assign(n, 0);
    dfs2(b);
    reverse(topsort1.begin(), topsort1.end());
    reverse(topsort2.begin(), topsort2.end());
    vector<int> v1(n), v2(n);
    v1[a] = 1;
    for (int v : topsort1) {
        for (auto& ee : rg[v]) {
            int to = get<0>(ee);
            int w = get<1>(ee);
            v1[v] += v1[to];
        }
    }
    v2[b] = 1;
    for (int v : topsort2) {
        for (auto& ee : g[v]) {
            int to = get<0>(ee);
            int w = get<1>(ee);
            v2[v] += v2[to];
        }
    }
    int ans = 0;
    for (auto& ee : edge) {
        int u = get<0>(ee);
        int v = get<1>(ee);
        int w = get<2>(ee);
        if (w == 0)
            continue;
        if ((v1[u] * v2[v]) % 2) {
            ans ^= w;
        }
    }
    cout << ans << '\n';
    g.clear();
    rg.clear();
    edge.clear();
    used.clear();
    topsort1.clear();
    topsort2.clear();
}

signed main() {
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}