#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

long long n;
vector<edge> g[200000], rg[200000];
vector<long long> cntto, cntfrom;
long long A, B;

void calc_to(long long v)
{
	if (cntto[v] != -1)
	{
		return;
	}

	cntto[v] = 0;
	for (auto& i : rg[v])
	{
		calc_to(i.to);
		cntto[v] += cntto[i.to];
		cntto[v] %= 2;
	}
}

void calc_from(long long v)
{
	if (cntfrom[v] != -1)
	{
		return;
	}

	cntfrom[v] = 0;
	for (auto& i : g[v])
	{
		calc_from(i.to);
		cntfrom[v] += cntfrom[i.to];
		cntfrom[v] %= 2;
	}
}

void solvedag()
{
	cntto.resize(n, -1);
	cntfrom.resize(n, -1);
	cntto[A] = 1;
	cntfrom[B] = 1;
	for (long long i = 0; i < n; i++)
	{
		calc_to(i);
		calc_from(i);
	}
	
	long long ans = 0;
	for (long long i = 0; i < n; i++)
	{
		for (auto& j : g[i])
		{
			long long mul = cntto[i] * cntfrom[j.to];
			ans += mul * j.w;
		}
	}
	cout << ans << "\n";
}

void solve()
{
	long long m;
	cin >> n >> m;
	long long cntdag = 0;
	for (long long i = 0; i < m; i++)
	{
		long long a, b, w;
		cin >> a >> b >> w;
		a--; b--;
		g[a].push_back({ b, w });
		rg[b].push_back({ a, w });
		if (a < b)
		{
			cntdag++;
		}
	}
	cin >> A >> B;
	A--; B--;
	if (cntdag == m)
	{
		solvedag();
		return;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/
