#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

vector<bool> used;
vector<int> el;
vector<int> color;

void dfs(int v, vector<vector<pair<int, int>>> &gr) {
    used[v] = true;
    for (auto u: gr[v]) {
        if (!used[u.first]) {
            dfs(u.first, gr);
        }
    }
    el.push_back(v);
}

void dfs_col(int v, vector<vector<pair<int, int>>> &gr, int c) {
    color[v] = c;
    for (auto u: gr[v]) {
        if (!color[u.first]) {
            dfs_col(u.first, gr, c);
        }
    }
}

int nn;

void dfs(int v,  vector<vector<pair<int, int>>> &gr, int fin, bool fl) {
    if (fin == v && !fl){
        return;
    }
    nn ^= gr[v][0].second;
    dfs(gr[v][0].first, gr, fin, false);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> gr(n);
    vector<vector<pair<int, int>>> rev_gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        --v;
        --u;
        gr[v].push_back({u, w});
        rev_gr[u].push_back({v, w});
    }
    bool fl = n == m;
    for (int i = 0; i < n; ++i) {
        if (gr[i].size() != 1) {
            fl = false;
            break;
        }
        if (i != n - 1) {
            if (gr[i][0].first != i + 1) {
                fl = false;
                break;
            }
        } else {
            if (gr[i][0].first != 0) {
                fl = false;
                break;
            }
        }
    }
    if (fl) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        nn = 0;
        dfs(a, gr, b, false);
        int r1 = nn;
        nn = 0;
        dfs(b, gr, a, true);
        int r2 = nn;
        if (r1 > 0 || r2 > 0){
            cout << -1 << "\n";
            return;
        }
        cout << 0 << "\n";
        return;
    }
    el.clear();
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, gr);
        }
    }
    reverse(el.begin(), el.end());
    color.assign(n, 0);
    int c = 1;
    for (auto i: el) {
        if (color[i] == 0) {
            dfs_col(i, rev_gr, c++);
        }
    }
    vector<bool> bad(c);
    vector<vector<pair<int, int>>> new_gr(c);
    vector<vector<pair<int, int>>> new_gr_rev(c);
    for (int i = 0; i < n; ++i) {
        for (auto u: gr[i]) {
            if (color[u.first] == color[i] && u.second > 0) {
                bad[color[u.first]] = true;
            }
            if (color[u.first] != color[i]) {
                new_gr[color[i]].push_back({color[u.first], u.second});
                new_gr_rev[color[u.first]].push_back({color[i], u.second});
            }
        }
    }
    int a, b;
    cin >> a >> b;
    --a;
    --b;
    int st = color[a];
    int fin = color[b];
    el.clear();
    used.assign(c, false);
    for (int i = 0; i < c; ++i) {
        if (!used[i]) {
            dfs(i, new_gr);
        }
    }
    reverse(el.begin(), el.end());
    vector<bool> cnt1(c);
    vector<bool> used1(c);
    cnt1[st] = 1;
    used1[st] = true;
    for (auto v: el) {
        if (used1[v]) {
            for (auto u: new_gr[v]) {
                used1[u.first] = true;
                cnt1[u.first] = cnt1[v] ^ cnt1[u.first];
            }
        }
    }
    reverse(el.begin(), el.end());
    vector<bool> used2(c);
    vector<int> cnt2(c);
    cnt2[fin] = 1;
    used2[fin] = true;
    for (auto v: el) {
        if (used2[v]) {
            for (auto u: new_gr_rev[v]) {
                used2[u.first] = true;
                cnt2[u.first] = cnt2[v] ^ cnt2[u.first];
            }
        }
    }
    if (!used1[fin]) {
        cout << 0 << "\n";
        return;
    }
    int res = 0;
    for (int i = 0; i < c; ++i) {
        if (used1[i] && used2[i] && bad[i]) {
            cout << -1 << "\n";
            return;
        }
        for (auto v: new_gr[i]) {
            if (used1[i] && used2[v.first]) {
                bool h = cnt1[i] & cnt2[v.first];
                if (h) {
                    res ^= v.second;
                }
            }
        }
    }
    cout << res << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}