#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<pair<int, int>>> g1;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> t1;
vector<vector<pair<int, int>>> t;

void solve();

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--){
        solve();
    }
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}

void clear(){
    t1.resize(0);
    t.resize(0);
    g.resize(0);
    g1.resize(0);
}



void dfs_mark(vector<bool> &u, vector<vector<pair<int, int>>> &gg, int v) {
    u[v] = true;
    for (auto [to, w] : gg[v]){
        if (!u[to]){
            dfs_mark(u, gg, to);
        }
    }
}

void dfs_cnt(vector<int> &u, vector<vector<pair<int, int>>> &gg, int v){
    u[v] = 0;
    for (auto [to, w] : gg[v]){
        if (u[to] == -1){
            dfs_cnt(u, gg, to);
        }
        u[v] += u[to];
    }
}

void solve(){
    clear();
    int n, m;
    cin >> n >> m;
    t1.resize(n);
    t.resize(n);
    g1.resize(n);
    g.resize(n);
    bool f = true;
    bool f1 = true;
    int xrr = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        int c;
        cin >> c;
        xrr ^= c;
        f1 = f1 && (a < b);
        f = f && !(a != i || b != (i + 1) % n);
        g1[a].push_back({b, c});
//        g[a].push_back({b, c});
        t1[b].push_back({a, c});
    }
    int S, T;
    cin >> S >> T;
    --S; --T;
    if (f){
        if (xrr != 0){
            cout << -1 << endl;
        } else{
            xrr = 0;
            for (int i = S; i != T; i = (i + 1) % n){
                xrr ^= g1[i][0].second;
                assert(g1[i][0].first == (i + 1) % n);
            }
            if (xrr != 0){
                cout << -1 << endl;
            } else{
                cout << 0 << endl;
            }
        }
        return;
    }
    if (f1){
        vector<bool> us(n, false);
        vector<bool> ut(n, false);
        dfs_mark(us, g1, S);
        dfs_mark(ut, t1, T);
        if (!us[T]){
            cout << 0 << endl;
        } else{
//            vector<bool> alive(n);
//            for (int i = 0; i < n; ++i) {
//                alive[i] = us[i] && ut[i];
//            }
//            for (int i = 0; i < n; ++i) {
//                if (alive[i]){
//                    for (auto [to, we] : g1[i]) {
//                        if (alive[to]) {
//                            g[i].push_back({to, we});
//                            t[to].push_back({i, we});
//                        }
//                    }
//                }
//            }
            vector<int> cnt_from_s(n, -1);
            vector<int> cnt_from_t(n, -1);
            cnt_from_s[S] = 1;
            cnt_from_t[T] = 1;
            dfs_cnt(cnt_from_s, t1, T);
            dfs_cnt(cnt_from_t, g1, S);
            xrr = 0;
//            for (int i = 0; i < n; ++i) {
//                cout << cnt_from_s[i] << ' ';
//            }
//            cout << endl;
//            for (int i = 0; i < n; ++i) {
//                cout << cnt_from_t[i] << ' ';
//            }
//            cout << endl;
            for (int i = 0; i < n; ++i) {
                for (auto [to, w] : g1[i]){
//                    cout << i << ' ' << to << ' ' << w << endl;
//                    cout << cnt_from_s[i] << ' ' << cnt_from_t[to] << endl << endl;
                    if (cnt_from_s[i] * cnt_from_t[to] % 2 == 1){
                        xrr ^= w;
                    }
                }
            }
            cout << xrr << endl;
        }
        return;
    }
    assert(0 == 1);
}
