#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;

vector<vector<pair<int, int>>> g;
vector<vector<int>> rev_g;
vector<pair<pair<int, int>, int>> edges;
vector<bool> used;
vector<int> topsort;

void dfs_topsort(int v) {
    used[v] = true;
    for (const pair<int, int> &e : g[v]) {
        if (!used[e.X]) {
            dfs_topsort(e.X);
        }
    }
    topsort.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>>());
    edges.clear();
    rev_g.assign(n, vector<int>());
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, c);
        rev_g[b].push_back(a);
        edges.push_back({{a, b}, c});
    }
    int a, b;
    cin >> a >> b;
    a--, b--;

    used.assign(n, false);
    topsort.clear();
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_topsort(i);
        }
    }
    reverse(all(topsort));
    vector<int> pref(n), suf(n);
    pref[a] = 1;
    for (int x : topsort) {
        for (int y : rev_g[x]) {
            pref[x] += pref[y];
        }
        pref[x] %= 2;
    }
    reverse(all(topsort));
    suf[b] = 1;
    for (int x : topsort) {
        for (const pair<int, int> &e : g[x]) {
            suf[x] += suf[e.X];
        }
        suf[x] %= 2;
    }
    int ans = 0;
    for (const auto &p : edges) {
        if (pref[p.X.X] % 2 == 1 && suf[p.X.Y] % 2 == 1) {
            ans ^= p.Y;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}