#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(24234);
const ll inf = 1e18;


struct edge{
    int to;
    ll w;


    edge() {}
    edge(int to, ll w) : to(to), w(w) {}
};


int n, m;
int a, b;
vector<vector<edge>> g;
vector<vector<edge>> rg;
vector<int> top_sort;
vector<int> usd;
vector<int> is_in_cycle;
vector<int> ina, inb, inbd1, inbd2;
vector<ll> clr;
vector<vector<edge>> superg;
vector<ll> dp, dpcnt;


void dfs0(int v){
    usd[v] = true;
    for(auto [to, v]: g[v]){
        if(!usd[to]){
            dfs0(to);
        }
    }
    top_sort.push_back(v);
}


void get_top_sort(){
    usd.assign(n, false);
    top_sort.clear();
    top_sort.reserve(n);
    for(int i = 0; i < n; i += 1){
        if(!usd[i]){
            dfs0(i);
        }
    }
    reverse(all(top_sort));
}


void dfs1(int v, vector<int> &c){
    usd[v] = true;
    c.push_back(v);
    for(auto [to, w]: rg[v]){
        if(!usd[to]){
            dfs1(to, c);
        }
    }
}


bool dfs2(int v){
    usd[v] = true;
    if(is_in_cycle[v]){
        return true;
    }
    for(auto [to, w]: g[v]){
        if(!usd[to]){
            if(dfs2(to)){
                return true;
            }
        }
    }
    return false;
}


bool dfs3(int v){
    usd[v] = true;
    if(is_in_cycle[v]){
        return true;
    }
    for(auto [to, w]: rg[v]){
        if(!usd[to]){
            if(dfs3(to)){
                return true;
            }
        }
    }
    return false;
}


void dfsb(int v){
    inb[v] = true;
    for(auto [to, w]: rg[v]){
        if(!inb[to]){
            dfsb(to);
        }
    }
}


void dfsa(int v){
    ina[v] = true;
    for(auto [to, w]: g[v]){
        if(!ina[to]){
            dfsa(to);
        }
    }
}


void dfsbd1(int v){
    usd[v] = true;
    inbd1[v] = true;
    for(auto [to, w]: g[v]){
        if(!usd[to]){
            dfsbd1(to);
        }
    }
}


void dfsbd2(int v){
    usd[v] = true;
    inbd2[v] = true;
    for(auto [to, w]: rg[v]){
        if(!usd[to]){
            dfsbd2(to);
        }
    }
}


bool okdfs(int v, ll mclr){
    clr[v] = mclr;
    for(auto [to, w]: superg[v]){
        if(clr[to] == -1){
            if(!okdfs(to, mclr ^ w)){
                return false;
            }
        } else{
            if(clr[to] != (mclr ^ w)){
                return false;
            }
        }
    }
    return true;
}


void dfsdp(int v){
    usd[v] = true;
    if(v == b){
        dp[v] = 0;
        dpcnt[v] = 1;
        return;
    }
    for(auto [to, w]: g[v]){
        if(!usd[to]){
            dfsdp(to);
        }
        dpcnt[v] = (dpcnt[v] + dpcnt[to]) % 2;
        dp[v] ^= dp[to];
        if(dpcnt[to] % 2 == 1){
            dp[v] ^= w;
        }
    }
}


ll solve(){
    get_top_sort();
    usd.assign(n, false);
    is_in_cycle.assign(n, false);
    for(auto v: top_sort){
        for(auto [to, w]: g[v]){
            if(to == v){
                is_in_cycle[v] = true;
            }
        }
        if(!usd[v]){
            vector<int> c;
            dfs1(v, c);
            if(c.size() > 1){
                for(auto u: c){
                    is_in_cycle[u] = true;
                }
            }
        }
    }
    /*
    usd.assign(n, false);
    for(int v = 0; v < n; v += 1){
        for(auto [to, w]: g[v]){
            if(w == 0){
                continue;
            }
            if(dfs2(to)){
                return -1;
            }
        }
    }
    usd.assign(n, false);
    for(int v = 0; v < n; v += 1){
        for(auto [to, w]: g[v]){
            if(w == 0){
                continue;
            }
            if(dfs3(v)){
                return -1;
            }
        }
    }
    */
    ina.assign(n, false);
    dfsa(a);
    inb.assign(n, false);
    dfsb(b);
    usd.assign(n, false);
    inbd1.assign(n, false);
    for(int v = 0; v < n; v += 1){
        if(!usd[v] && is_in_cycle[v]){
            dfsbd1(v);
        }
    }
    usd.assign(n, false);
    inbd2.assign(n, false);
    for(int v = 0; v < n; v += 1){
        if(!usd[v] && is_in_cycle[v]){
            dfsbd2(v);
        }
    }
    superg.assign(n, vector<edge>());
    for(int v = 0; v < n; v += 1){
        for(auto [to, w]: g[v]){
            if(ina[v] && inb[to] && (inbd1[v] || inbd2[to])){
                superg[v].push_back(edge(to, w));
                superg[to].push_back(edge(v, w));
            }
        }
    }
    superg[a].push_back(edge(b, 0));
    superg[b].push_back(edge(a, 0));
    usd.assign(n, false);
    clr.assign(n, -1);
    for(int v = 0; v < n; v += 1){
        if(clr[v] == -1){
            if(!okdfs(v, 0)){
                return -1;
            }
        }
    }
    usd.assign(n, false);
    dp.assign(n, 0);
    dpcnt.assign(n, 0);
    dfsdp(a);
    return dp[a];
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n >> m;
        g.assign(n, vector<edge>());
        rg.assign(n, vector<edge>());
        for(int i = 0; i < m; i += 1){
            int u, v;
            ll w;
            cin >> u >> v >> w;
            u -= 1;
            v -= 1;
            g[u].push_back(edge(v, w));
            rg[v].push_back(edge(u, w));
        }
        cin >> a >> b;
        a -= 1;
        b -= 1;
        cout << solve() << "\n";
    }
    return 0;
}

/*
5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4




1
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4

*/