#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<pair<int, int>>> graph;

int ans = 0, b;

bool fillcycle(int start, int v, vi& used, graph& g, vi& cycle, vi& cnt, vi& paths, int curxor) {
	cycle[v] = max(cycle[v], cycle[start]);
	for (auto [u, len] : g[v]) {
		if (cnt[u] > 0) {
			if (cycle[v] == 2 || (cycle[v] == 1 && (paths[u] == -1 || (curxor ^ len ^ paths[u]) != 0)))
				return false;
		}
		if (used[u] == 1) {
			if (u == start)
				return true;
			fillcycle(start, u, used, g, cycle, cnt, paths, curxor ^ len);
		}
	}
	return true;
}

bool dfs(int v, vi& used, graph& g, vi& x0, vi& x1, vi& cnt, vi& cycle, vi& paths, int curxor = 0) {
	used[v] = 1;
	x0[v] = curxor;
	if (v == b) {
		if ((cycle[v] == 1 && curxor != 0) || cycle[v] == 2) {
			return false;
		}
		ans ^= curxor;
		cnt[v] = 1;
	}
	for (auto [u, len] : g[v]) {
		if (used[u] == 2) {
			if (cnt[v] == 0)
				continue;
			if (cycle[v] == 2 || (cycle[v] == 1 && (paths[u] == -1 || (curxor ^ len ^ paths[u]) != 0))) {
				return false;
			}
			ans ^= x1[u];
			x1[v] ^= x1[u];
			cnt[v] += cnt[u];
			if (cnt[u] % 2) {
				ans ^= curxor ^ len;
				x1[v] ^= len;
			}
		} else if (used[u] == 1) {
			int cyclexor = curxor ^ len ^ x0[u];
			if (cyclexor == 0) {
				cycle[u] = 1;
			} else {
				cycle[u] = 2;
			}
			if (fillcycle(u, u, used, g, cycle, cnt, paths, curxor ^ len) == false)
				return false;
		} else {
			cycle[u] = max(cycle[u], cycle[v]);
			if (dfs(u, used, g, x0, x1, cnt, cycle, paths, curxor ^ len) == false)
				return false;
			if (cnt[u] == 0)
				continue;
			if (paths[u] == -1)
				paths[v] = -1;
			if (paths[v] == 0)
				paths[v] = paths[u] ^ len;
			else if (paths[v] != (paths[u] ^ len))
				paths[v] = -1;
			x1[v] ^= x1[u];
			if (cnt[u] % 2)
				x1[v] ^= len;
			cnt[v] += cnt[u];
		}
	}
	used[v] = 2;
	return true;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}
	int a;
	cin >> a >> b;
	--a; --b;
	vector<int> x0(n), x1(n), cnt(n), cycle(n), paths(n), used(n);
	ans = 0;
	if (dfs(a, used, g, x0, x1, cnt, cycle, paths) == false)
		cout << -1 << "\n";
	else
		cout << ans << "\n";
	/*
	cout << "\nx0: ";
	for (auto f : x0)
		cout << f << " ";
	cout << "\nx1: ";
	for (auto f : x1)
		cout << f << " ";
	cout << "\n\n";
	*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}