#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int n, m;
vector<vector<pair<int,int>>>g;

void solve16(int a, int b) {
	int x = 0, x_path = 0;
	for (int i = 0; i < n; i++)
		x ^= g[i][0].second;
	for (int i = a; i != b; i = (i + 1) % n) {
		x_path ^= g[i][0].second;
	}
	if (x != 0) {
		cout << "-1\n";
	}
	else {
		if (x_path != 0)
			cout << "-1\n";
		else {
			cout << "0\n";
		}
	}
}

vector<int>ts;
vector<bool>used;
void dfs(int v) {
	used[v] = true;
	for (auto u : g[v])
		if (!used[u.first])
			dfs(u.first);
	ts.push_back(v);
}

vector<pair<int, bool>>memory;
pair<int, bool> calc(int v, int stop) {
	if (v == stop) {
		return memory[v] = { 0, true };
	}
	int x = 0;
	int f = false;
	for (auto u : g[v]) {
		if (!used[u.first])
			continue;
		pair<int, bool>kid = (memory[u.first].first == -1 ? calc(u.first, stop) : memory[u.first]);
		if (kid.second)
			kid.first ^= u.second;
		x ^= kid.first;
		f ^= kid.second;
	}
	return memory[v] = { x, f };
}

void solve32(int a, int b) {
	used.clear();
	ts.clear();
	memory.clear();

	memory.resize(n, { -1,0 });
	used.resize(n);

	dfs(a);
	reverse(ts.begin(), ts.end());
	while (!ts.empty() && ts.back() != b) {
		ts.pop_back();
	}
	used.assign(n, false);
	for (auto x : ts)
		used[x] = true;
	if (!used[a] || !used[b]) {
		cout << "0\n";
		return;
	}
	cout << calc(a, b).first << '\n';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		g.resize(n);
		bool flag16 = (n == m);
		for (int i = 0; i < m; i++) {
			int v, u, w;
			cin >> v >> u >> w;
			v--, u--;
			g[v].push_back({ u, w });
			flag16 &= (v == i && u == (i + 1) % n);
		}
		int a, b;
		cin >> a >> b;
		a--, b--;
		if(flag16)
			solve16(a, b);
		else {
			solve32(a, b);
		}

		g.clear();
	}
	return 0;
}