#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

#define int long long

struct edge{
    int u;
    int w;
};

struct node{
    int cnt;
    int x;
};

struct graph{
    vector<vector<edge>> g;
    vector<vector<int>> r_g;
    vector<int> used;
    vector<node> ans;
    vector<int> cnt;

    graph(int n){
        g.resize(n, vector<edge> ());
        r_g.resize(n, vector<int> ());
        cnt.resize(n, 0);
        used.resize(n, 0);
        ans.resize(n, {0, 0});
    }

    void clear(){
        used.clear();
        used.resize(ans.size(), 0);
    }
};

void dfs(graph &g, int v){
    g.used[v] = 1;

    for(auto el: g.g[v]){
        if(!g.used[el.u]){
            g.ans[el.u].x = (g.ans[v].x ^ el.w);
            dfs(g, el.u);
        }
    }
}

void dfs(int v, graph &g, vector<int> &top_sort){
    g.used[v] = 1;

    for(auto el: g.g[v]){
        if(!g.used[el.u]){
            dfs(el.u, g, top_sort);
        }
    }

    top_sort.push_back(v);
}

void dfs(int v, graph &g, int cnt){
    g.cnt[v] = cnt;

    for(auto el: g.r_g[v]){
        if(!g.cnt[el]){
            dfs(el, g, cnt);
        }
    }
}

bool check(graph &g, int a, int b){
    vector<int> top_sort;

    for(int i=0; i < g.ans.size();i++){
        if(!g.used[i])
            dfs(i, g, top_sort);
    }

    reverse(top_sort.begin(), top_sort.end());

    g.clear();

    int cnt=0;

    for(auto i: top_sort){
        if(!g.cnt[i]){
            cnt++;
            dfs(i, g, cnt);
        }
    }

    return true;
}

/*
1
7 8
1 2 1
2 3 1
3 1 1
3 4 1
4 6 1
4 5 1
5 6 1
4 7 1
1 1
*/

void solve(){
    int n, m; cin >> n >> m;

    graph g = graph(n);

    int circle = 0;

    for(int i=0; i < m; i++){
        int u, v, w; cin >> u >> v >> w;

        u--; v--;

        g.g[u].push_back({v, w});
        g.r_g[v].push_back(u);

        circle = (circle ^ w);
    }

    int a, b; cin >> a >> b; a--;b--;

    if(check(g, a, b)){
        cout << -1;
        return;
    }

    dfs(g, a);

    if((circle ^ g.ans[b].x) != 0 || circle != 0){
        cout << -1;
    }else{
        cout << g.ans[b].x;
    }
}

int32_t main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    */

    int t=1; cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
