#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.2")

#include<bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int n, a, b;
vector<vector<pii>> g, bg;
vector<vector<bool>> u1, u2;
vector<bool> go;
vi used, w1, w2;

void dfs1(int u, int i, int bt) {
    u1[u][i] = true;
    for (auto to: g[u]) {
        if (!u1[to.first][i ^ ((to.second >> bt) & 1)])
            dfs1(to.first, i ^ ((to.second >> bt) & 1), bt);
    }
}

void dfs2(int u, int i, int bt) {
    u2[u][i] = true;
    for (auto to: bg[u]) {
        if (!u2[to.first][i ^ ((to.second >> bt) & 1)])
            dfs2(to.first, i ^ ((to.second >> bt) & 1), bt);
    }
}

bool res;

void check_cycle(int u) {
    used[u] = 1;
    for (auto to: g[u]) {
        if (!go[to.first])
            continue;
        if (used[to.first] == 1) {
            res = true;
            return;
        }
        else if (used[to.first] == 0)
            check_cycle(to.first);
    }
    used[u] = 2;
}

void count1(int u) {
    used[u] = 1;
    for (auto to: g[u]) {
        if (go[to.first]) {
            if (used[to.first] == 0)
                count1(to.first);
            w1[u] ^= w1[to.first];
        }
    }
}

void count2(int u) {
    used[u] = 1;
    for (auto to: bg[u]) {
        if (go[to.first]) {
            if (used[to.first] == 0)
                count2(to.first);
            w2[u] ^= w2[to.first];
        }
    }
}

int solve_bit(int bt) {
    u1.assign(n, vector<bool>(2, false));
    u2.assign(n, vector<bool>(2, false));
    go.assign(n, false);
    used.assign(n, 0);
    w1.assign(n, 0);
    w2.assign(n, 0);
    dfs1(a, 0, bt);
    dfs2(b, 0, bt);
    for (int i = 0; i < n; ++i) {
        if (u1[i][0] && u2[i][1] || u1[i][1] && u2[i][0])
            go[i] = true;
    }
    res = false;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0 && go[i])
            check_cycle(i);
    }
    if (res)
        return -1;
    used.assign(n, 0);
    w1[b] = 1;
    count1(a);
    used.assign(n, 0);
    w2[a] = 1;
    count2(b);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (w2[i] == 0)
            continue;
        for (auto to: g[i]) {
            if (w1[to.first] == 1)
                ans ^= ((to.second >> bt) & 1);
        }
    }
    return ans;
}

const int K = 30;

void solve() {
    int m;
    cin >> n >> m;
    g.assign(n, vector<pii>(0));
    bg.assign(n, vector<pii>(0));
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        g[u].emplace_back(v, w);
        bg[v].emplace_back(u, w);
    }
    cin >> a >> b;
    --a;
    --b;
    int ans = 0;
    for (int i = 0; i < K; ++i) {
        int x = solve_bit(i);
        if (x == -1) {
            cout << "-1\n";
            return;
        }
        ans |= (x << i);
    }
    cout << ans << '\n';
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        solve();
}
