#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int n, a, b;
vector<vector<pii>> g, bg;
vector<pair<bool, bool>> u1, u2;
vector<bool> go;
vi used, w1, w2;

void dfs1(int u, int i, int bt) {
    if (i == 0)
        u1[u].first = true;
    else
        u1[u].second = true;
    for (auto to: g[u]) {
        int j = i ^ ((to.second >> bt) & 1);
        if (j == 0 && !u1[to.first].first)
            dfs1(to.first, j, bt);
        else if (j == 1 && !u1[to.first].second)
            dfs1(to.first, j, bt);
    }
}

void dfs2(int u, int i, int bt) {
    if (i == 0)
        u2[u].first = true;
    else
        u2[u].second = true;
    for (auto to: bg[u]) {
        int j = i ^ ((to.second >> bt) & 1);
        if (j == 0 && !u2[to.first].first)
            dfs2(to.first, j, bt);
        else if (j == 1 && !u2[to.first].second)
            dfs2(to.first, j, bt);
    }
}

bool res;

void check_cycle(int u) {
    used[u] = 1;
    for (auto to: g[u]) {
        if (!go[to.first])
            continue;
        if (used[to.first] == 1)
            res = true;
        else if (used[to.first] == 0)
            check_cycle(to.first);
        if (res)
            return;
    }
    used[u] = 2;
}

void count1(int u) {
    used[u] = 1;
    for (auto to: g[u]) {
        if (go[to.first]) {
            if (used[to.first] == 0)
                count1(to.first);
            w1[u] ^= w1[to.first];
        }
    }
}

void count2(int u) {
    used[u] = 1;
    for (auto to: bg[u]) {
        if (go[to.first]) {
            if (used[to.first] == 0)
                count2(to.first);
            w2[u] ^= w2[to.first];
        }
    }
}

void solve_bit(int bt) {
    for (int i = 0; i < n; ++i)
        u1[i] = u2[i] = {false, false};
    dfs1(a, 0, bt);
    dfs2(b, 0, bt);
    for (int i = 0; i < n; ++i) {
        if (u1[i].first && u2[i].second || u1[i].second && u2[i].first)
            go[i] = true;
    }
}

const int K = 30;

void solve() {
    int m;
    cin >> n >> m;
    g.assign(n, vector<pii>(0));
    bg.assign(n, vector<pii>(0));
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        g[u].emplace_back(v, w);
        bg[v].emplace_back(u, w);
    }
    cin >> a >> b;
    --a;
    --b;
    u1.assign(n, {false, false});
    u2.assign(n, {false, false});
    go.assign(n, false);
    used.assign(n, 0);
    w1.assign(n, 0);
    w2.assign(n, 0);
    for (int i = 0; i < K; ++i)
        solve_bit(i);
    res = false;
    for (int i = 0; i < n; ++i) {
        if (!res && used[i] == 0 && go[i])
            check_cycle(i);
    }
    if (res) {
        cout << "-1\n";
        return;
    }
    used.assign(n, 0);
    w1[b] = 1;
    count1(a);
    used.assign(n, 0);
    w2[a] = 1;
    count2(b);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (w2[i] == 0)
            continue;
        for (auto to: g[i]) {
            if (w1[to.first] == 1)
                ans ^= to.second;
        }
    }
    cout << ans << '\n';
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        solve();
}
