#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<pair<ll, ll>>> g, ng, p;
vector<ll> used;

void dfs(ll v) {
    used[v] = 1;
    for (auto to : g[v]) {
        p[to.first].push_back({ v, to.second });
        if (!used[to.first]) {
            dfs(to.first);
        }
    }
}

void gback(ll v) {
    used[v] = 1;
    for (auto to : p[v]) {
        ng[to.first].push_back({ v, to.second });
        if (!used[to.first]) {
            gback(to.first);
        }
    }
}

vector<ll> order;
void ts(ll v) {
    used[v] = 1;
    for (auto to : ng[v]) {
        if (!used[to.first]) ts(to.first);
    }
    order.push_back(v);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.clear();
    ng.clear();
    p.clear();
    order.clear();
    p.resize(n);
    g.resize(n);
    ng.resize(n);
    used.assign(n, 0);
    vector<pair<pair<ll, ll>, ll>> e(m);
    for (int i = 0; i < m; ++i) {
        ll u, v, w;
        e[i] = { {u, v}, w };
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({ v, w });
    }
    ll a, b;
    cin >> a >> b;
    --a; --b;
    dfs(a);
    used.assign(n, 0);
    gback(b);
    used.assign(n, 0);
    ts(a);
    used.assign(n, 0);
    reverse(order.begin(), order.end());
    ll ln = order.size();
    vector<ll> dp(n, 0), cnt(n, 0);
    cnt[order[0]] = 1;
    for (int i = 0; i < ln; ++i) {
        used[order[i]] = 1;
        for (auto to : ng[order[i]]) {
            ll val = (cnt[order[i]] % 2 ? to.second : 0);
            if (used[to.first] && (dp[order[i]] ^ dp[to.first] ^ val ^ dp[to.first])) {
                cout << "-1\n";
                return;
            }
            cnt[to.first] += cnt[order[i]];
            dp[to.first] ^= dp[order[i]] ^ val;
        }
    }
    cout << dp[b] << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll tc;
    cin >> tc;
    while (tc--) {
        solve();
    }

}