#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

int n, m, a, b;
vector<vector<pair<int, int>>> g, grev;
vector<int> used, good, xrpa, xrpb;

void color(vector<vector<pair<int, int>>>& gg, vector<int>& xrp, int v) {
    used[v] = 1;
    good[v] += 1;
    for (auto [to, c] : gg[v]) {
        if (!used[to]) {
            xrp[to] = xrp[v] ^ c;
            color(gg, xrp, to);
        } else {
            if (used[to] == 2 && xrp[to] != (xrp[v] ^ c)) xrp[to] = -1;
        }
    }
    used[v] = 2;
}

bool globgood;

void check(int v) {
    used[v] = 1;
    for (auto [to, c] : g[v]) {
        if (good[to] != 2) continue;
        if (used[to] == 0) {
            check(to);
        } else if (used[to] == 1) {
            if ((xrpa[v] ^ xrpa[to] ^ c) != 0) globgood = false;
            if (xrpa[v] == -1 || xrpb[v] == -1 || xrpa[v] != xrpb[v]) globgood = false;
        }
    }
    used[v] = 2;
}

vector<int> cnt, xr;

void solve() {

    cin >> n >> m;
    g.assign(n, vector<pair<int, int>>());
    grev.assign(n, vector<pair<int, int>>());
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].emplace_back(v - 1, w);
        grev[v - 1].emplace_back(u - 1, w);
    }

    cin >> a >> b;
    a--, b--;

    good.assign(n, 0);

    used.assign(n, 0);
    xrpa.assign(n, 0);
    color(g, xrpa, a);

    used.assign(n, 0);
    xrpb.assign(n, 0);
    color(grev, xrpb, b);

    used.assign(n, 0);
    globgood = true;
    check(a);

//    if (!globgood) {
//        cout << "-1\n";
//        return;
//    }

    cnt.assign(n, 0);
    xr.assign(n, 0);
    cnt[b] = 1;

    used.assign(n, 0);
    queue<int> q;
    q.push(b);
    while (!q.empty()) {
        int v = q.front();
        q.pop();

        used[v] = 1;
        for (auto [to, c] : grev[v]) {
            if (good[to] != 2) continue;
            cnt[to] ^= cnt[v];
            xr[to] ^= xr[v];
            if (cnt[v]) xr[to] ^= c;
            if (!used[to]) q.push(to);
        }
    }

    cout << xr[a] << "\n";

};

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

}