#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

vector<vector<ll>> graph;
vector<ll> p;
vector<pair<ll, ll>> available;

ll get(ll a) {
    if (p[a] == a) {
        return a;
    }

    return p[a] = get(p[a]);
}

pair<ll, ll> merge_(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first == -1 || b.first == -1) {
        return {-1, -1};
    }

    pair<ll, ll> neww = {max(a.first, b.first), min(a.second, b.second)};
    if (neww.first > neww.second) {
        return {-1, -1};
    }
    return neww;
}

void set_(ll a, ll b) {
    a = get(a);
    b = get(b);

    if (a != b) {
        available[a] = merge_(available[a], available[b]);
        p[b] = a;
    }
}

vector<ll> now;
vector<ll> ans;
void dfs(ll v, ll p, ll find_) {
    now.push_back(v);
    if (v == find_) {
        ans = now;
    }

    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v, find_);
        }
    }
    now.pop_back();
}

void solve() {
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        bool notnull = false;
        ll w1 = 0;
        while (m--) {
            ll a, b, w;
            cin >> a >> b >> w;
            if (w > 0) {
                notnull = true;
            }
            w1 = w;
        }

        ll from, to;
        cin >> from >> to;
        
        if (n == 1) {
            cout << w1 << "\n";
        }
        else if (notnull) {
            cout << -1 << "\n";
        } else {
            cout << 0 << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
