#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector<vector<tuple<int, int, int>>> g(n), ginv(n);
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            g[u].emplace_back(v, w, i);
            ginv[v].emplace_back(u, w, i);
        }
        int a, b;
        cin >> a >> b;
        a--, b--;
        queue<int> q;
        vector<int> dist_a(n, INT_MAX), dist_b(n, INT_MAX), mark(m);
        q.push(a);
        dist_a[a] = 0;
        dist_b[b] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w, i] : g[u]) {
                mark[i]++;
                if (dist_a[v] == INT_MAX) {
                    dist_a[v] = dist_a[u] + 1;
                    q.push(v);
                }
            }
        }
        q.push(b);
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w, i] : ginv[u]) {
                mark[i]++;
                if (dist_b[v] == INT_MAX) {
                    dist_b[v] = dist_b[u] + 1;
                    q.push(v);
                }
            }
        }
        vector<vector<pair<int, int>>> ng(n), nginv(n);
        for (int u = 0; u < n; u++) {
            for (auto [v, w, i] : g[u])  {
                if (mark[i] == 2) {
                    ng[u].emplace_back(v, w);
                    nginv[v].emplace_back(u, w);
                }
            }
        }
        vector<bool> visited(n, false);
        vector<int> t;
        auto DFS = [&](int u, auto&& DFS) -> void {
            visited[u] = true;
            for (auto [v, w] : ng[u]) {
                if (!visited[v]) {
                    DFS(v, DFS);
                }
            }
            t.push_back(u);
        };
        DFS(a, DFS);
        reverse(t.begin(), t.end());
        vector<int> pos(n);
        for (int i = 0; i < (int)t.size(); i++) {
            pos[t[i]] = i;
        }
        bool good = true;
        for (int u = 0; u < n; u++) {
            for (auto [v, w] : ng[u]) {
                if (pos[v] < pos[u]) {
                    good = false;
                }
            }
        }
        if (!good || dist_a[b] == INT_MAX) {
            cout << -1 << "\n";
            continue;
        }
        vector<int> path_a(n), path_b(n);
        visited.assign(n, false);
        visited[a] = true;
        q.push(a);
        path_a[a] = 1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w] : ng[u]) {
                path_a[v] ^= path_a[u];
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        visited.assign(n, false);
        visited[b] = true;
        q.push(b);
        path_b[b] = 1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w] : nginv[u]) {
                path_b[v] ^= path_b[u];
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        int ans = 0;
        for (int u = 0; u < n; u++) {
            for (auto [v, w] : ng[u]) {
                if (path_a[u] * path_b[v]) {
                    ans ^= w;
                }
            }
        }
        cout << ans << "\n";
    }
}