#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <cstring>

using namespace std;

typedef pair<int, int> pii;

const int N = 2e5;

vector<pii> arr[N], rev_arr[N];
queue<int> q;
int used[N], gen_used[N];
int patha[N], pathb[N], h1[N], h2[N];

pii val[N];

void bfsa() {
	while (q.size()) {
		int v = q.front();
		q.pop();
		used[v] = 2;
		gen_used[v]++;
		for (auto [u, w] : arr[v]) {
			if (used[u] == 0) {
				patha[u] += patha[v];
				h1[u] = h1[v] + 1;
				used[u] = 1;
				q.push(u);
			}
			else if (used[u] == 1) {
				patha[u] += patha[v];
			}
		}
	}
}

void bfsb() {
	while (q.size()) {
		int v = q.front();
		q.pop();
		used[v] = 2;
		gen_used[v]++;
		for (auto [u, w] : rev_arr[v]) {
			if (used[u] == 0) {
				pathb[u] += pathb[v];
				used[u] = 1;
				q.push(u);
			}
			else if (used[u] == 1) {
				pathb[u] += pathb[v];
			}
		}
	}
}

void refresh(int n, int m) {
	for (int i = 0; i < m; i++)
		arr[i].clear();
	for (int i = 0; i < n; i++)
		used[i] = 0;
}

void check() {
	/*while (q.size()) {
		int v = q.front();
		q.pop();
		for (auto [u, w] : arr[v]) {
			if (gen_used[u] != 2)
				continue;
			if (h1[u] > h1[v]) {
				if (val[u].first == 0)
					val[u] = val[v].first ^ w;
				else if (val[u].second == 0)
				if (!used[u]) {
					used[u] = 1;
					q.push(u);
				}
			}
			else {

			}
		}
	}*/
}

void solve() {
	int n, m, f, s, w;
	cin >> n >> m;
	refresh(n, m);
	bool flag = true;
	if (n != m)
		flag = false;
	for (int i = 0; i < m; i++) {
		cin >> f >> s >> w;
		f--;
		s--;
		arr[f].push_back({ s, w });
		rev_arr[s].push_back({ f, w });
		if (f != i)
			flag = false;
		if (i == m - 1) {
			if (s != 0)
				flag = false;
		}
		else if (s != i + 1)
			flag = false;
	}
	int a, b;
	cin >> a >> b;
	a--;
	b--;
	if (flag) {
		int c = a, ans = 0;
		while (c != b) {
			ans ^= arr[c][0].second;
			c++;
			if (c == n)
				c -= n;
		}
		if (ans != 0)
			cout << "-1\n";
		else {
			while (c != a) {
				ans ^= arr[c][0].second;
				c++;
				if (c == n)
					c -= n;
			}
			if (ans != 0)
				cout << "-1\n";
			else
				cout << 0 << "\n";
		}
		return;
	}
	q.push(a);
	patha[a] = 1;
	h1[a] = 0;
	bfsa();
	memset(used, 0, sizeof used);	
	pathb[b] = 1;
	q.push(b);
	bfsb();
	
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output1.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--)
		solve();
}