#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

const int MAX_N = 2e5;

struct Edge {
    int to;
    int weight;

    Edge() {}
    Edge(int to, int weight) : to(to), weight(weight) {}
};

int n, m;
int a, b;

vector<Edge> graph[MAX_N];
vector<Edge> reverse_graph[MAX_N];

void solve1() {
    int xor_sum = 0;
    for (int i = 0; i < n; ++i) {
        xor_sum ^= graph[i][0].weight;
    }
    if (xor_sum == 0) {
        int v = a;
        while (v != b) {
            xor_sum ^= graph[v][0].weight;
            v = graph[v][0].to;
        }
        if (xor_sum == 0) {
            cout << 0 << '\n';
        } else {
            cout << -1 << '\n';
        }
    } else {
        cout << -1 << '\n';
    }
}

void dfs(int v, bool* used, const vector<Edge>* graph) {
    used[v] = true;
    for (auto [u, weight] : graph[v]) {
        if (!used[u]) {
            dfs(u, used, graph);
        }
    }
}

bool used[MAX_N];
bool used2[MAX_N];

int dp[MAX_N];
int dp2[MAX_N];

bool valid[MAX_N];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        graph[i].clear();
        reverse_graph[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int v, u, weight;
        cin >> v >> u >> weight;
        --v;
        --u;
        graph[v].emplace_back(u, weight);
        reverse_graph[u].emplace_back(v, weight);
    }
    cin >> a >> b;
    --a;
    --b;

    bool group1 = true;
    for (int i = 0; i < n; ++i) {
        group1 &= (int)graph[i].size() == 1 && graph[i][0].to == (i + 1) % n;
    }

    if (group1) {
        solve1();
        return;
    }

    fill_n(used, n, false);
    dfs(a, used, graph);

    fill_n(used2, n, false);
    dfs(b, used2, reverse_graph);

    for (int v = 0; v < n; ++v) {
        valid[v] = used[v] && used2[v];
    }

    if (!valid[a]) {
        cout << 0 << '\n';
        return;
    }

    fill_n(dp, n, 0);
    dp[a] = 1;
    for (int v = 0; v < n; ++v) {
        for (auto [to, weight] : graph[v]) {
            dp[to] ^= dp[v];
        }
    }

    fill_n(dp2, n, 0);
    dp2[b] = 1;
    for (int v = n - 1; v >= 0; --v) {
        for (auto [to, weight] : graph[v]) {
            dp2[to] ^= dp2[v];
        }
    }

    int ans = 0;
    for (int v = 0; v < n; ++v) {
        for (auto [u, weight] : graph[v]) {
            if (dp[v] && dp2[u]) {
                ans ^= weight;
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
