#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	if (p == 1) return a;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/

ll cycle = 0;
void dfs(ll v, ll cur, vector <ll>& p, vector <ll>& color, vector <vector <pair <ll, ll>>>& g)
{
	color[v] = 1;
	p[v] = cur;
	for (auto [i, w] : g[v])
	{
		if (color[i] == 0)
		{
			dfs(i, cur ^ w, p, color, g);
		}
		else if (color[i] == 1)
		{
			if (p[i] == (cur ^ w) && cycle == 0)
			{
				cycle = 1;
			}
			else if (p[i] != (cur ^ w))
			{
				cycle = 2;
			}
		}
	}
	color[v] = 2;
}
void dfs_top(ll v, vector <ll>& k, vector <bool>& used, vector <vector <pair <ll, ll>>>& g)
{
	used[v] = true;
	for (auto [i, w] : g[v])
	{
		if (!used[i])
		{
			dfs_top(i, k, used, g);
		}
	}
	k.push_back(v);
}
void dfsl(ll v, ll cur, vector <vector <ll>>& tl, vector <ll>& color, vector <vector <pair <ll, ll>>>& g)
{
	color[v] = 1;
	if (tl[v].empty()) tl[v].push_back(cur);
	else if (!tl[v].empty() && tl[v].size() == 1 && tl[v][0] != cur) tl[v].push_back(cur);
	for (auto [i, w] : g[v])
	{
		if (color[i] == 0)
		{
			for (auto u : tl[v])
			{
				dfsl(i, u ^ w, tl, color, g);
			}
		}
	}
	color[v] = 2;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	while (t--)
	{
		cycle = 0;
		ll n, m, cur = 0;
		cin >> n >> m;
		vector <vector <pair <ll, ll>>> g(n), gr(n);
		for (ll i = 0; i < m; i++)
		{
			ll u, v, w;
			cin >> u >> v >> w;
			u--;
			v--;
			g[u].push_back({ v, w });
			gr[v].push_back({ u, w });
			cur ^= w;
		}
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		vector <ll> p(n), color(n);
		dfs(a, 0, p, color, g);
		if (color[b] == 0) cout << "-1\n";
		else if (cycle == 2)
		{
			cout << "-1\n";
		}
		else if (cycle == 1)
		{
			vector <vector <ll>> tt(n); 
			for (ll i = 0; i < n; i++) color[i] = 0;
			dfsl(a, 0, tt, color, g);
			//if (tt[b].size() == 1 && tt[b][0] == 0) cout << "0\n";
			cout << "-1\n";
		}
		else
		{
			vector <ll> k;
			vector <bool> used(n);
			dfs_top(a, k, used, g);
			reverse(k.begin(), k.end());
			vector <ll> l(n), r(n);
			l[a] = 1;
			r[b] = 1;
			for (ll i = 0; i < k.size(); i++)
			{
				for (auto [j, w] : g[k[i]])
				{
					l[j] += l[k[i]];
					l[j] %= 2;
				}
			}
			for (ll i = k.size() - 1; i >= 0; i--)
			{
				for (auto [j, w] : gr[k[i]])
				{
					r[j] += r[k[i]];
					r[j] %= 2;
				}
			}
			ll ans = 0;
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : g[i])
				{
					if (l[i] && r[j])
					{
						ans ^= w;
					}
				}
			}
			cout << ans << "\n";
		}
	}

	/*
	ll t;
	cin >> t;
	while (t--)
	{
		ll n, m;
		cin >> n >> m;
		vector <vector <pair <ll, ll>>> g(n), gr(n);
		for (ll i = 0; i < m; i++)
		{
			ll u, v, w;
			cin >> u >> v >> w;
			u--;
			v--;
			g[u].push_back({ v, w });
			gr[v].push_back({ u, w });
		}
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		vector <ll> used(n), p(n);
		bool f = false;
		vector <vector <ll>> da(n), dar(n);
		dfs(a, 0, f, dar, used, gr);
		for (ll i = 0; i < n; i++) used[i] = 0;
		dfs(a, 0, f, da, used, g);
		for (ll i = 0; i < n; i++)
		{
			set <ll> jj;
			cout << i << " - i\n";
			for (auto j1 : da[i]) cout << j1 << " ";
			cout << "\n";
			for (auto j1 : dar[i]) cout << j1 << " ";
			cout << "\n";
			for (auto j1 : da[i])
			{
				for (auto j2 : dar[i])
				{
					if ((j1 ^ j2) != 0) jj.insert(j1 ^ j2);
				}
			}
			if (jj.size() > 0) f = true;
		}
		if (f) cout << "-1\n";
		else
		{
			dfsr(b, used, gr);
			vector <vector <pair <ll, ll>>> ng(n);
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : g[i])
				{
					if (used[i] == -1 && used[j] == -1)
					{
						ng[i].push_back({j, w});
					}
				}
			}
			swap(g, ng);
			vector <vector <pair <ll, ll>>> ngr(n);
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : gr[i])
				{
					if (used[i] == -1 && used[j] == -1)
					{
						ngr[i].push_back({ j, w });
					}
				}
			}
			swap(gr, ngr);
			vector <ll> k;
			dfs_top(a, k, used, g);
			vector <ll> dp_l(n), dp_r(n);
			dp_l[a] = 1;
			dp_r[b] = 1;
			for (ll i = 0; i < k.size(); i++)
			{
				for (auto [j, w] : g[k[i]])
				{
					dp_l[k[i]] += dp_l[j];
				}
			}
			for (ll i = (ll)k.size() - 1; i >= 0; i--)
			{
				for (auto [j, w] : gr[k[i]])
				{
					dp_r[k[i]] += dp_r[j];
				}
			}
			ll ans = 0;
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : g[i])
				{
					cout << i << " " << j << " " << ans << "\n";
					cout << dp_l[i] << " " << dp_r[j] << "\n";
					if (dp_l[i] % 2 == 1 && dp_r[j] % 2 == 1)
					{
						ans ^= w;
					}
				}
			}
			cout << ans << "\n";
		}
	}
	*/

	return 0;
}
/*
*/