#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

ll dfs(int i, int e, vector<vector<pair<int, ll>>>& v) {
	if (i == e)re 0;

	for (auto j : v[i]) {
		re j.second^ dfs(j.first, e, v);
	}
}

ll dfs2(int i, int e, int c, vector<vector<pair<int, ll>>>& v) {
	if (i == e)c++;
	if (c == 2)re 0;

	for (auto j : v[i]) {
		re j.second^ dfs2(j.first, e, c, v);
	}
}

bool dfs3(int i, int e, vector<vector<pair<int, ll>>>& v, vector<bool>& good, vector<bool>& was) {
	if (was[i])re good[i];
	if (i == e) {
		good[i] = 1;
		re 1;
	}
	was[i] = true;

	bool ok = false;
	for (auto j : v[i]) {
		ok |= dfs3(j.first, e, v, good, was);
	}

	good[i] = ok;
	re ok;
}

ll f(int n, vector<ll>& dp, vector<bool>& was, int b, vector<vector<int>>& v, vector<bool>& good) {
	if (n == b)re 1;
	if (was[n])re dp[n];
	was[n] = true;

	ll& ans = dp[n];
	ans = 0;

	for (auto i : v[n]) {
		if (!good[i])continue;

		ans += f(i, dp, was, b, v, good);
	}

	re ans;
}

void solve1(int n, int m, vector<vector<pair<int, ll>>>& v, int a, int b) {
	vector<bool> was(n, false), good(n, false);
	vector<vector<int>> bv(n);

	dfs3(a, b, v, good, was);

	fill(all(was), false);
	fori(n) {
		for (auto j : v[i]) {
			bv[j.first].push_back(i);
		}
	}
	vector<ll> cnt(n, 0);

	f(b, cnt, was, a, bv, good);
	ll ans = 0;

	fori(n) {
		for (auto j : v[i]) {
			if (cnt[j.first] % 2 == 1)
				ans ^= j.second;
		}
	}

	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		vector<vector<pair<int, ll>>> v(n);

		bool ok = true;
		fori(m) {
			ll a, b, w; cin >> a >> b >> w;
			if (i != m - 1) {
				if (a != i + 1 || b != i + 2)ok = false;
			}
			else if (a != n || b != 1)ok = false;

			v[a - 1].push_back({ b - 1, w });
		}
		ll a, b; cin >> a >> b;

		if (ok) {
			if (n == 1) {
				if (v[0][0].second == 0)cout << "0\n";
				else cout << "-1\n";
				continue;
			}
			--a; --b;

			if (a == b) {
				if (dfs2(a, b, 0, v) == 0)cout << "0\n";
				else cout << "-1\n";
				continue;
			}
			ll c1 = dfs(a, b, v);
			ll c2 = dfs(b, a, v);

			if (c2 == 0 && c1 == 0)cout << "0\n";
			else cout << "-1\n";
		}
		else solve1(n, m, v, a - 1, b - 1);
	}
}

/*
5
5 10
1 2 1
1 2 2
1 3 3
1 3 4
2 3 5
3 4 10
3 5 9
4 5 8
2 4 6
2 5 7
1 5
*/