#include <iostream>
#include <vector>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

int n, m, a, b;
vector<vector<pair<int, int>>> g;
vector<pair<int, int>> cache;
vector<bool> used;

void solve1(vector<int> &w) {
    int xor_all = 0;
    range(i, m) {
        xor_all ^= w[i];
    }
    if (a == b) {
        if (xor_all) {
            cout << -1 << endl;
        } else {
            cout << 0 << endl;
        }
    } else {
        int xor1 = 0;
        if (a < b) {
            for (int i = a - 1; i < b - 1; i++) {
                xor1 ^= w[i];
            }
        } else {
            for (int i = a - 1; i < n; i++) {
                xor1 ^= w[i];
            }
            for (int i = 0; i < b - 1; i++) {
                xor1 ^= w[i];
            }
        }
        if (xor1 || (xor1 ^ xor_all)) {
            cout << -1 << endl;
        } else {
            cout << 0 << endl;
        }
    }
}

pair<int, int> dfs(int v) {
    if (v == b) {
        return {1, 0};
    }
    if (used[v]) {
        return cache[v];
    }
    used[v] = true;
    int count = 0,
            xor_ = 0;
    for (auto [u, w]: g[v]) {
        auto [cnt, xor1] = dfs(u);
        xor_ ^= (w * cnt) ^ xor1;
        count += cnt;
    }
    cache[v] = {count % 2, xor_};
    return cache[v];
}

void solve2() {
    cache.resize(n);
    used.clear();
    used.resize(n, false);
    cout << dfs(a).second << endline;
}

void run_solve() {
    g.clear();
    cin >> n >> m;
    g.resize(n);
    bool run1 = n == m;
    vector<int> ws(m);
    range(i, m) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w);
        ws[i] = w;
        run1 = run1 && (u == i) && (v == i + 1 || v == 0);
    }
    cin >> a >> b;
    a--;
    b--;
//    if (run1) {
        solve1(ws);
//    } else {
//        solve2();
//    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    loop(t) {
        run_solve();
    }
}
