/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;

struct edge
{
    int v, u, w;
}ed[maxn];

int n, m, a, b;
int to_end[maxn], from_start[maxn];
vector < int > link[maxn], rev_link[maxn];
vector < pair < int, int > > graph[maxn], in_graph[maxn];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
    {
        graph[i].clear();
        in_graph[i].clear();
        link[i].clear();
        rev_link[i].clear();
    }
    for (int i = 1; i <= m; i ++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        link[v].push_back(u);
        rev_link[u].push_back(v);
        ed[i].v = v;
        ed[i].u = u;
        ed[i].w = w;
    }
    cin >> a >> b;
}

void get_to_end()
{
    for (int i = 1; i <= n; i ++)
        to_end[i] = 0;

    to_end[b] = 1;
    queue < int > q;
    q.push(b);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int u : rev_link[v])
        {
            if (!to_end[u])
            {
                to_end[u] = 1;
                q.push(u);
            }
        }
    }
}


void get_from_start()
{
    for (int i = 1; i <= n; i ++)
        from_start[i] = 0;

    from_start[a] = 1;
    queue < int > q;
    q.push(a);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int u : link[v])
        {
            if (!from_start[u])
            {
                from_start[u] = 1;
                q.push(u);
            }
        }
    }
}

int useless[maxn];
void clear_useless()
{
    for (int i = 1; i <= n; i ++)
    {
        useless[i] = 0;
        if (!from_start[i] || !to_end[i])
            useless[i] = 1;
    }

    for (int i = 1; i <= m; i ++)
    {
        edge cur = ed[i];
        if (useless[cur.v] || useless[cur.u])
            continue;
        graph[cur.v].push_back({cur.u, cur.w});
        in_graph[cur.u].push_back({cur.v, cur.w});
    }
}

int used[maxn];
bool cycle;
void check_cycle(int v)
{
    used[v] = 1;
    for (pair < int, int > dest : graph[v])
    {
        int u = dest.first;
        if (!used[u])
        {
            check_cycle(u);
        }
        else
        {
            if (used[u] == 1)
            {
                cycle = true;
            }
        }
    }
    used[v] = 2;
}
void solve()
{
    input();
    int xor_all = 0;
    for (int i = 1; i <= m; i ++)
    {
        xor_all = (xor_all ^ ed[i].w);
    }
    if (xor_all != 0)
    {
        cout << -1 << endl;
        return;
    }

int ans = 0;
    if (a <= b)
    {

        for (int i = a; i < b; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
    }
    else
    {
        for (int i = a; i <= m; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
        for (int i = 1; i < b; i ++)
        {
            ans = (ans ^ ed[i].w);
        }
    }

    cout << ans << endl;
    /**get_to_end();
    get_from_start();
    clear_useless();
    cycle = false;
    for (int i = 1; i <= n; i ++)
        used[i] = 0;
    check_cycle(a);

    if (cycle)
    {
        cout << -1 << endl;
        return;
    }
    cout << 0 << endl;*/

}

int main()
{
    int t;
    cin >> t;
    while(t --)
    solve();
    return 0;
}

/**
2
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
3 2

*/
