#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

bool flag;
int n, m, a, b, t;
int used[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

void DFS(int u, int x)
{
    used[u] = 1;
    bool fl = true;
    for (auto [v, w] : G[u])
    {
        if (used[v] == 2) continue;
        if (used[v] == 1)
        {
            if (used[b] == 1 and (x ^ w) != 0) flag = false;
            continue;
        }
        DFS(v, (x ^ w));
    }
    used[u] = 2;
}

void solve()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
        used[i] = 0;
    }

    int x = 0;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        G[u].push_back({v, w});
        x ^= w;
    }

    cin >> a >> b;
    
    int x1 = 0;
    while (a != b)
    {
        x1 ^= G[a][0].second;
        a = G[a][0].first;
    }

    if (x == 0 and x1 == 0) cout << 0 << endl;
    else cout << -1 << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
