#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, m, a, b, ans2;
vector< pair<int, int> > G[MAXN + 5];

void DFS2(int u, int odd, int even)
{
    if (u == b)
    {
        ans2 = odd;
        return;
    }
    if (G[u].size() == 0) return;

    int prv = G[u][0].first;
    int cnt0 = 0, cnt1 = 0;
    sort(G[u].begin(), G[u].end());
    for (auto [v, w] : G[u])
    {
        if (v == prv)
        {
            if (w == 0) cnt0++;
            else cnt1++;
        }
        else
        {
            if (u == a) DFS2(prv, cnt1 % 2, cnt0 % 2);
            else
            {
                int odd1 = (odd * cnt0 + even * cnt1) % 2;
                int even1 = (odd * cnt1 + even * cnt0) % 2;
                DFS2(prv, odd1, even1);
            }
            prv = v;
            cnt0 = cnt1 = 0;
            if (w == 0) cnt0++;
            else cnt1++;
        }
    }
    if (u == a) DFS2(prv, cnt1 % 2, cnt0 % 2);
    else
    {
        int odd1 = (odd * cnt0 + even * cnt1) % 2;
        int even1 = (odd * cnt1 + even * cnt0) % 2;
        DFS2(prv, odd1, even1);
    }
}

void solve()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
    }

    bool flag1 = true, flag2 = true;
    if (n != m) flag1 = false;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        int t = (i + 1) % n;
        if (t == 0) t = n;
        if (u != i or v != t) flag1 = false;
        G[u].push_back({v, w});
        if (!(u < v and w <= 1)) flag2 = false;
    }

    cin >> a >> b;

    if (flag1)
    {
        int x = 0;
        while (a != b)
        {
            x ^= G[a][0].second;
            a = G[a][0].first;
        }

        int y = 0;
        do
        {
            y ^= G[a][0].second;
            a = G[a][0].first;
        } while (a != b);

        if (x == 0 and y == 0) cout << 0 << endl;
        else cout << -1 << endl;
        return;
    }

    if (flag2)
    {
        ans2 = 0;
        DFS2(a, 0, 0);
        cout << ans2 << endl;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
