#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; i++) {
    int u, v, c;
    cin >> u >> v >> c;
    --u, --v;
    g[u].emplace_back(v, c);
  }

  int from, to;
  cin >> from >> to;
  --from, --to;

  function<int(int, int, int)> dfs = [&] (int cur, int want, int cur_xor) {
    if (want == cur) {
      return cur_xor;
    }
    for (auto &[u, c] : g[cur]) {
      return dfs(u, want, cur_xor ^ c);
    }
  };

  int ab = dfs(from, to, 0);
  int ba = dfs(to, from, 0);

  if (ba == 0) {
    cout << ab << '\n';
  } else {
    cout << -1 << '\n';
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}