#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>

#define int long long

using namespace std;
vector <int> tin;
vector <int> tout;
vector <vector <int> > g;
vector <pair <int, int> > otr;
int tm = 0;
int n;
vector <int> p;
vector <int> prs;
vector <int> hs;
vector <int> h;
vector <vector <int> > up;
int tree[1600000];
int treerev[1600000];
vector <int> cnt;
vector <vector <int> > cmp;
int md = 1e9 + 7;

void init() {
	hs.resize(n);
	tin.resize(n);
	tout.resize(n);
	g.resize(n);
	p.resize(n);
	h.resize(n);
	cnt.resize(n);
	up.resize(n, vector <int>(20));
}
mt19937 rnd(222311);
void dfs(int v, int hh, int pr) {
	tin[v] = tm++;
	h[v] = hh;
	up[v][0] = pr;
	for (int i = 1; i < 20; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto u : g[v]) {
		dfs(u, hh + 1, v);
	}
	tout[v] = tm++;
}
int sm(int v, int l, int r, int ql) {

	if (r - l == 1) {
		return tree[v];
	}
	int mid = (r + l) / 2;
	if (ql < mid) {
		return (tree[v] + sm(v * 2 + 1, l, mid, ql)) % md;
	}
	return (tree[v] + sm(v * 2 + 2, mid, r, ql)) % md;
}
int sm2(int v, int l, int r, int ql) {
	if (r - l == 1) {
		return treerev[v];
	}
	int mid = (r + l) / 2;
	if (ql < mid) {
		return (treerev[v] + sm2(v * 2 + 1, l, mid, ql) + md) % md;
	}
	return (treerev[v] + sm2(v * 2 + 2, mid, r, ql) + md) % md;
}

void upd(int v, int l, int r, int ql, int qr, int x) {
	if (ql <= l && r <= qr) {
		tree[v] += x;
		if (tree[v] > md) {
			tree[v] %= md;
		}
		return;
	}
	if (r <= ql || l >= qr) {
		return;
	}
	int mid = (r + l) / 2;
	upd(v * 2 + 1, l, mid, ql, qr, x);
	upd(v * 2 + 2, mid, r, ql, qr, x);
}
void upd2(int v, int l, int r, int ql, int qr, int x) {

	if (ql <= l && r <= qr) {
		treerev[v] += x;
		if (treerev[v] > md) {
			treerev[v] %= md;
		}
		return;
	}
	if (r <= ql || l >= qr) {
		return;
	}
	int mid = (r + l) / 2;
	upd2(v * 2 + 1, l, mid, ql, qr, x);
	upd2(v * 2 + 2, mid, r, ql, qr, x);
}
int getp(int pp) {
	if (p[pp] == pp) {
		return pp;
	}
	return p[pp] = getp(p[pp]);
}

int gths(int v) {
	return hs[getp(v)];
}

int ans = 1;
int binpow(int n, int k) {
	if (k == 0) {
		return 1;
	}
	int x = binpow(n, k / 2);
	x *= x;
	x %= md;
	if (k % 2) {
		x *= n;
		x %= md;
	}
	return x;
}

void un(int a, int b) {
	a = getp(a);
	b = getp(b);
	int l1 = otr[a].first, r1 = otr[a].second, l2 = otr[b].first, r2 = otr[b].second;
	int st = gths(a);
	ans *= binpow(otr[a].second - otr[a].first + 1, md - 2);
	ans %= md;
	ans *= binpow(otr[b].second - otr[b].first + 1, md - 2);
	ans %= md;

	p[a] = b;
	otr[b] = { max(l1, l2), min(r1, r2) };
	ans *= max((int)0, otr[b].second - otr[b].first + 1);
	ans %= md;
	while (cmp[a].size()) {
		int v = cmp[a].back();
		cmp[a].pop_back();
		cmp[b].push_back(v);
		int delt = (gths(v) * prs[h[v]] % md) - (st * prs[h[v]] % md) + md;
		int delt2 = (gths(v) * prs[1e5 - h[v]] % md) - (st * prs[1e5 - h[v]] % md) + md;
		delt2 %= md;
		delt %= md;
		upd(0, 0, 2 * n, tin[v], tout[v], delt);
		upd2(0, 0, 2 * n, tin[v], tout[v], delt2);
	}
}

bool pr(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
	if (pr(a, b)) {
		return a;
	}
	if (pr(b, a)) {
		return b;
	}
	for (int i = 19; i >= 0; --i) {
		if (!pr(up[a][i], b)) {
			a = up[a][i];
		}
	}
	return up[a][0];
}

int cpr(int a, int ind) {
	int st = 1 << 19;
	for (int i = 19; i >= 0; i--) {
		if (st <= ind) {
			ind -= st;
			a = up[a][i];
		}
		st /= 2;
	}
	return a;
}

int gtsm(int v) {
	return sm(0, 0, 2 * n, tin[v]);
}
int getrev(int v) {
	return sm2(0, 0, 2 * n, tin[v]);
}
int ipt(int a, int b, int cnt) {
	int lc = lca(a, b);
	if (cnt <= h[a] - h[lc] + 1) {
		int e = cpr(a, cnt - 1);
		return e;
	}
	else {
		cnt -= h[a] - h[lc] + 1;
		int e = cpr(b, h[b] - h[lc] - cnt);
		return e;
	}
}


int sr(int a, int b, int c, int d) {
	int lc1 = lca(a, b);
	int dl1 = h[a] - h[lc1];
	int h1 = (getrev(a) - getrev(lc1) + md) % md;
	h1 %= md;
	h1 *= prs[2e5 - (1e5 - h[a])];
	h1 %= md;
	int h11 = (gtsm(b) - gtsm(lc1) + md) % md + (gths(lc1) * prs[h[lc1]]) % md;
	h11 %= md;
	h11 *= prs[2e5 + dl1 - h[lc1]];
	h11 %= md;
	h1 += h11;
	h1 %= md;
	int lc2 = lca(c, d);
	int dl2 = h[c] - h[lc2];
	int h2 = (getrev(c) - getrev(lc2) + md) % md;
	h2 %= md;
	h2 *= prs[2e5 - (1e5 - h[c])];
	h2 %= md;
	int h22 = (gtsm(d) - gtsm(lc2) + md) % md + (gths(lc2) * prs[h[lc2]]) % md;
	h22 %= md;
	h22 *= prs[2e5 + dl2 - h[lc2]];
	h22 %= md;
	h2 += h22;
	h2 %= md;
	return h1 == h2;
}



signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	prs.resize(4e5 + 1);
	prs[0] = 1;
	for (int i = 1; i <= 4e5; ++i) {
		prs[i] = (prs[i - 1] * 37) % md;
	}
	set <int> cmps;
	init();
	for (int i = 0; i < n; ++i) {
		p[i] = i;
		cnt[i] = 1;
		cmps.insert(i);
		cmp.push_back({ i });
	}
	for (int i = 0; i < n - 1; ++i) {
		int pi;
		cin >> pi;
		pi--;
		g[pi].push_back(i + 1);
	}
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		ans *= (r - l + 1);
		ans %= md;
		hs[i] = rnd() % md;
		otr.push_back({ l,r });

	}
	dfs(0, 0, 0);
	for (int i = 0; i < n; ++i) {
		upd(0, 0, 2 * n, tin[i], tout[i] + 1, (hs[i] * prs[h[i]]) % md);
		upd2(0, 0, 2 * n, tin[i], tout[i] + 1, (hs[i] * prs[1e5 - h[i]]) % md);
	}

	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		int lc1 = lca(a, b);
		int dl = h[a] - h[lc1] + h[b] - h[lc1] + 1;
		int pr = 0;
		while (true) {
			int l = pr, r = dl + 1;
			while (r - l > 1) {
				int mid = (r + l) / 2;
				if (!sr(a, ipt(a, b, mid), c, ipt(c, d, mid))) {
					r = mid;
				}
				else {
					l = mid;
				}
			}
			if (l == dl) {
				break;
			}
			int p1 = ipt(a, b, l + 1);
			int p2 = ipt(c, d, l + 1);
			if (cmp[getp(p1)].size() > cmp[getp(p2)].size()) {
				swap(p1, p2);
			}
			pr = l;
			cmps.erase(getp(p1));
			un(p1, p2);
		}
		cout << ans << "\n";

	}


}