#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5 + 2, P = 1543103, MOD = 1000696969, M = 1e9 + 7;

int power(int a, int b = M - 2) {
    int res = 1;
    for (; b > 0; b >>= 1, a = 1LL * a * a % M) {
        if (b & 1) {
            res = 1LL * res * a % M;
        }
    }
    return res;
}

void add(int &x, int y) {
    if ((x += y) >= MOD) x -= MOD;
}

int sub(int a, int b) {
    return a >= b ? a - b : a - b + MOD;
}

int powers[N];
int n;

namespace fn {
    int t[N], r[N];

    void mt(int x, int i) {
        i = 1LL * i * powers[x] % MOD;

        for (++x; x < N; x += x & -x) {
            add(t[x], i);
        }
    }

    void mr(int x, int i) {
//        i = 1LL * i * powers[n - x - 1] % MOD;
        i = 1LL * i * powers[x] % MOD;
        for (++x; x < N; x += x & -x) {
            add(r[x], i);
        }
    }

    void modify(int x, int i) {
        if (i < 0) i += MOD;

        mt(x, i);
        mr(n - x - 1, i);
    }


    int sumt(int x) {
        int ans = 0;

        for (++x; x > 0; x -= x & -x) {
            add(ans, t[x]);
        }

        return ans;
    }

    int sumr(int x) {
        int ans = 0;

        for (++x; x > 0; x -= x & -x) {
            add(ans, r[x]);
        }

        return ans;
    }


    int sumt(int l, int rr) {
        return sub(sumt(rr - 1), sumt(l - 1));
    }

    int sumr(int l, int rr) {
        return sub(sumr(rr - 1), sumr(l - 1));
    }
}

vector<int> adj[N];
int tin[N], siz[N], head[N], parent[N], eu[N], T = 0;

void dfs1(int v) {
    siz[v] = 1;

    for (int &to : adj[v]) {
        dfs1(to);

        siz[v] += siz[to];

        if (siz[to] > siz[adj[v][0]]) {
            swap(adj[v][0], to);
        }
    }
}

void dfs2(int v) {
    eu[T] = v;
    tin[v] = T++;

    for (int to: adj[v]) {
        if (T == tin[v] + 1) {
            head[to] = head[v];
        } else {
            head[to] = to;
        }

        dfs2(to);
    }
}

int lca(int a, int b) {
    for (;; b = parent[b]) {
        if (tin[a] > tin[b]) {
            swap(a, b);
        }

        if (tin[head[b]] <= tin[a]) {
            return a;
        }

        b = head[b];
    }
}

int fa[N], mxL[N], mnR[N], answer = 1;
vector<int> subtree[N];

void init_dsu(int n) {
    iota(fa, fa + n, 0);
    for (int i = 0; i < n; ++i) {
        subtree[i] = {i};
        mnR[i] = M - 1;
    }
}

int leader(int x) {
    return x == fa[x] ? x : fa[x] = leader(fa[x]);
}

bool unite(int x, int y) {
    x = leader(x), y = leader(y);

    if (x == y) {
        return false;
    }

    if (subtree[x].size() < subtree[y].size()) {
        swap(x, y);
    }

    for (int c: subtree[y]) {
        fn::modify(c, x - y);
    }

    if (answer != 0) {
        answer = 1LL * answer * power(mnR[x] - mxL[x] + 1) % M * power(mnR[y] - mxL[y] + 1) % M;
    }

    subtree[x].insert(subtree[x].end(), subtree[y].begin(), subtree[y].end());
    subtree[y].clear();

    fa[y] = x;
    mnR[x] = min(mnR[x], mnR[y]);
    mxL[x] = max(mxL[x], mxL[y]);

    if (mnR[x] < mxL[x]) {
        answer = 0;
    } else {
        answer = 1LL * answer * (mnR[x] - mxL[x] + 1) % M;
    }

    return true;
}

//TODO: make this a bit faster
void unite_segments(int i, int j, int len, bool revi) {
    int sumi = 0, sumj = fn::sumt(j, j + len);
    int pi = 0;

    if (revi) {
        sumi = fn::sumr(n - i - 1, n - (i - len) - 1);
        pi = (n - i - 1);
    } else {
        sumi = fn::sumt(i, i + len);
        pi = i;
    }

    if (pi < j) {
        sumi = 1LL * sumi * powers[j - pi] % MOD;
    } else if (j < pi) {
        sumj = 1LL * sumj * powers[pi - j] % MOD;
    }

    if (sumi == sumj) {
        return;
    }

    static int yay = 0;

    if (len == 1) {
        yay += !unite(i, j);
        assert(yay <= 3e4);
//        assert(unite(i, j));
    } else {
        int h = len / 2;
        unite_segments(i, j, h, revi);
        unite_segments(revi ? i - h : i + h, j + h, len - h, revi);
    }
}


void flex(int &a, int &c, int x, int y, int &la, int &lb) {
    while (a != -1 && c != -1 && (tin[a] >= tin[x] && tin[c] >= tin[y])) {
        int ma = tin[head[a]] <= tin[x] ? x : head[a];
        int mc = tin[head[c]] <= tin[y] ? y : head[c];

        int nxt = min(tin[a] - tin[ma] + 1, tin[c] - tin[mc] + 1);

        unite_segments(tin[a] - nxt + 1, tin[c] - nxt + 1, nxt, 0);
        a = eu[tin[a] - nxt + 1];
        c = eu[tin[c] - nxt + 1];
        la = a, lb = c;
        a = parent[a], c = parent[c];
    }
}

vector<pair<int, int>> path(int a, int b) {
    vector<pair<int, int>> res;

    for (;; b = parent[b]) {
        if (tin[a] > tin[b]) {
            swap(a, b);
        }

        if (tin[head[b]] <= tin[a]) {
            res.emplace_back(tin[a], tin[b] + 1);
            break;
        }

        res.emplace_back(tin[head[b]], tin[b] + 1);
        b = head[b];
    }

    return res;
}

void ez_unite(int a, int b, int c, int d) {
    auto x = path(a, b);
    auto y = path(c, d);
    reverse(x.begin(), x.end());
    reverse(y.begin(), y.end());

    bool rev = true;

    int j = 0, ty = y[0].first;
    int i = rev ? int(size(x)) - 1 : 0;
    int tx = rev ? x.back().second : x.front().first;

    while (j < y.size()) {
        int nxt = min(tx - x[i].first, y[j].second - ty);

        unite_segments(tx - 1, ty, nxt, rev);

        ty += nxt;

        tx -= nxt;
        if (tx == x[i].first) {
            i -= 1;

            if (i >= 0) {
                tx = x[i].second;
            }
        }

        if (ty == y[j].second) {
            ++j;

            if (j < y.size()) {
                ty = y[j].first;
            }
        }
    }
}

void unite_path(int a, int b, int c, int d) {
    int x = lca(a, b);
    int y = lca(c, d);
    int la, lb, lc, ld;

    flex(a, c, x, y, la, lc);
    flex(b, d, x, y, lb, ld);

    int u = -1, v = -1;
    bool ba = a != -1 && tin[x] <= tin[a];
    bool bb = b != -1 && tin[x] <= tin[b];
    bool bc = c != -1 && tin[y] <= tin[c];
    bool bd = d != -1 && tin[y] <= tin[d];

    if (ba || bb) u = ba ? la : lb;
    if (bc || bd) v = bc ? lc : ld;

    if (u != -1) {
        ez_unite(x, u, y, v);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    parent[0] = -1;


    cin >> n;

    for (int i = 1; i < n; ++i) {
        cin >> parent[i];
        parent[i] -= 1;

        adj[parent[i]].push_back(i);
    }

    dfs1(0);
    dfs2(0);

    init_dsu(n);

    for (int i = 0; i < n; ++i) {
        int t = tin[i];
        cin >> mxL[t] >> mnR[t];

        answer = 1LL * answer * (mnR[t] - mxL[t] + 1) % M;
    }

    powers[0] = 1;

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            powers[i] = 1LL * powers[i - 1] * P % MOD;
        }

        fn::modify(i, i);
    }

    int m;
    cin >> m;

    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a -= 1, b -= 1, c -= 1, d -= 1;

        unite_path(a, b, c, d);

        cout << answer << '\n';
    }

    return 0;
}