#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

struct seg {
	ll l, r;
};

vector<vector<ll>> G;
vector<ll> p;
vector<seg> segs;

vector<ll> xxx;
void dfs(ll v, ll to, ll p, vector<ll>& cur) {
	xxx.push_back(v);
	if (v == to) {
		cur = xxx;
	}
	for (ll u : G[v]) {
		if (u == p) continue;
		dfs(u, to, v, cur);
	}
	xxx.pop_back();
}

const ll M = 1e9 + 7, MAXN = 2e5 + 10;

ll sz[MAXN], P[MAXN];

ll col(ll v) {
	return (P[v] == v ? v : P[v] = col(P[v]));
}

void unique(ll a, ll b) {
	a = col(a);
	b = col(b);
	if (a == b) return;
	if (sz[a] < sz[b]) {
		swap(a, b);
	}
	sz[a] += sz[b];
	P[b] = a;
}

void solve() {
	ll n;
	cin >> n;
	for (ll i = 0; i < n; i++) {
		P[i] = i;
		sz[i] = 1;
	}
	p.assign(n, 0);
	G.assign(n, {});
	for (ll i = 1; i < n; i++) {
		cin >> p[i]; p[i]--;
		G[p[i]].push_back(i);
		G[i].push_back(p[i]);
	}
	segs.assign(n, {});
	for (ll i = 0; i < n; i++) {
		cin >> segs[i].l >> segs[i].r;
	}
	ll q, a, b, c, d, mx_l, mn_r;
	cin >> q;
	while (q--) {
		cin >> a >> b >> c >> d; a--; b--; c--; d--;
		vector<ll> cur1, cur2;
		dfs(a, b, -1, cur1);
		dfs(c, d, -1, cur2);
		for (ll i = 0; i < cur1.size(); i++) {
			ll to1 = col(cur1[i]), to2 = col(cur2[i]);
			mx_l = max(segs[to1].l, segs[to2].l);
			mn_r = min(segs[to1].r, segs[to2].r);
			segs[to1] = { mx_l, mn_r };
			segs[to2] = { mx_l, mn_r };
			unique(to1, to2);
		}
		ll ans = 1;
		for (ll i = 0; i < n; i++) {
			if (P[i] == i) {
				ans *= max(0ll, segs[i].r - segs[i].l + 1);
				ans %= M;
			}
		}
		cout << ans << "\n";
	}
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2 
1 2 2 1
3 4 4 3
3 4 3 5

*/