#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll N = 3000, M = 1000000007;

vector<ll> g[N];
pair<ll, ll> a[N];

bool dfs(vector<ll> &p, ll v, ll v1, ll w = -1) {
    p.push_back(v);
    if (v == v1) return 1;
    for (ll u: g[v]) if (u != w) if (dfs(p, u, v1, v)) return 1;
    p.pop_back();
    return 0;
}

ll p[N];

ll root(ll v) {
    if (p[v] == v) return v;
    return p[v] = root(p[v]);
}

mt19937_64 rng(40739);

ll m_pow(ll x, ll n) {
    ll res = 1;
    while (n) {
        if (n % 2) res = res * x % M;
        x = x * x % M;
        n /= 2;
    }
    return res;
}

ll inv(ll x) {
    return m_pow(x, M - 2);
}

ll m_div(ll x, ll y) {
    return x * inv(y) % M;
}

ll ans;

void join(ll v, ll u) {
    v = root(v), u = root(u);
    if (v == u) return;
    if (rng() % 2) swap(v, u);
    ans = m_div(ans, (a[v].second - a[v].first + 1));
    ans = m_div(ans, (a[u].second - a[u].first + 1));
    a[v] = {max(a[v].first, a[u].first), min(a[v].second, a[u].second)};
    ans = ans * (a[v].second - a[v].first + 1) % M;
    p[u] = v;
}

int main() {
    ll n;
    cin >> n;
    for (ll v = 0; v < n; v++) p[v] = v;
    for (ll u = 1; u < n; u++) {
        ll v;
        cin >> v, v--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (ll v = 0; v < n; v++) cin >> a[v].first >> a[v].second;
    ans = 1;
    for (ll v = 0; v < n; v++) ans = ans * (a[v].second - a[v].first + 1) % M;
    ll m;
    cin >> m;
    while (m--) {
        ll av0, av1, bv0, bv1;
        cin >> av0 >> av1 >> bv0 >> bv1;
        av0--, av1--, bv0--, bv1--;
        vector<ll> pa, pb;
        dfs(pa, av0, av1);
        dfs(pb, bv0, bv1);
        for (ll pos = 0; pos < ll(pa.size()); pos++) {
            ll v = pa[pos], u = pb[pos];
            join(v, u);
        }
        cout << ans << '\n';
    }
}