#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using vi = vector<int>;

const int maxN = 2e5, mod = 1e9 + 7;

struct Item {
    int p, sz;
    Item(int p = 0) : p(p), sz(1) {}
} DSU[maxN];

bool ok;
int test = 1, n, p, l[maxN], r[maxN], m, a, b, c, d, ans;
vi gr[maxN], p1, p2;

int mul(int a, int b) {
    return 1LL * a * b % mod;
}

int inverse(int a) {
    int b = mod - 2, res = 1;
    while (b) {
        if (b & 1)
            res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

bool dfs(int u, int p, int b) {
    if (u == b) {
        p1.push_back(u);
        return true;
    }
    for (int v : gr[u])
        if (v != p) {
            if (dfs(v, u, b)) {
                p1.push_back(u);
                return true;
            }
        }
    return false;
}

int get(int u) {
    return u == DSU[u].p ? u : DSU[u].p = get(DSU[u].p);
}

void unite(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (DSU[u].sz < DSU[v].sz)
        swap(u, v);
    DSU[v].p = u;
    DSU[u].sz += DSU[v].sz;
}

void solve() {
    cin >> n;
#ifdef LOCAL
    for (int i = 0; i < n; i++)
        gr[i].clear();
#endif
    for (int i = 1; i < n; i++) {
        cin >> p;
        p--;
        gr[i].push_back(p);
        gr[p].push_back(i);
    }
    ans = 1;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    for (int i = 0; i < n; i++)
        DSU[i] = Item(i);
    ok = true;
    cin >> m;
    while (m--) {
        cin >> a >> b >> c >> d;
        if (ok) {
            a--, b--, c--, d--;
            p1.clear();
            dfs(a, -1, b);
            swap(p1, p2);
            p1.clear();
            dfs(c, -1, d);
            for (int i = 0; i < p1.size(); i++) {
                a = get(p1[i]);
                b = get(p2[i]);
                if (a == b)
                    continue;
                unite(a, b);
                c = get(a);
                ans = mul(ans, inverse(r[a] - l[a] + 1));
                ans = mul(ans, inverse(r[b] - l[b] + 1));
                l[c] = max(l[a], l[b]);
                r[c] = min(r[a], r[b]);
                if (l[c] > r[c]) {
                    ok = false;
                    break;
                }
                ans = mul(ans, r[c] - l[c] + 1);
            }
        }
        if (!ok)
            cout << "0\n";
        else
            cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
