#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using vi = vector<int>;

const int maxN = 2e5, mod = 1e9 + 7, SZ = 2 * maxN, LG = 19;

struct Item {
    int p, sz;
    Item(int p = 0) : p(p), sz(1) {}
} DSU[maxN];

bool ok;
int test = 1, n, p[maxN], l[maxN], r[maxN], m, a, b, c, d, ans, st[SZ][LG], lg2[SZ], it, first_visit[maxN], height[maxN];
vi gr[maxN], p1, p2, pb;

int mul(int a, int b) {
    return 1LL * a * b % mod;
}

int inverse(int a) {
    int b = mod - 2, res = 1;
    while (b) {
        if (b & 1)
            res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

void dfs1(int u, int p) {
    height[u] = height[p] + 1;
    st[it][0] = u;
    first_visit[u] = it++;
    for (int v : gr[u])
        if (v != p) {
            dfs1(v, u);
            st[it++][0] = u;
        }
}

bool dfs(int u, int p, int b) {
    if (u == b) {
        p1.push_back(u);
        return true;
    }
    for (int v : gr[u])
        if (v != p) {
            if (dfs(v, u, b)) {
                p1.push_back(u);
                return true;
            }
        }
    return false;
}

int get(int u) {
    return u == DSU[u].p ? u : DSU[u].p = get(DSU[u].p);
}

void unite(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (DSU[u].sz < DSU[v].sz)
        swap(u, v);
    DSU[v].p = u;
    DSU[u].sz += DSU[v].sz;
}

int min_by_h(int u, int v) {
    return height[u] < height[v] ? u : v;
}

int lca(int u, int v) {
    u = first_visit[u];
    v = first_visit[v];
    if (u > v)
        swap(u, v);
    int k = lg2[v - u + 1];
    return min_by_h(st[u][k], st[v - (1 << k) + 1][k]);
}

void solve() {
    cin >> n;
#ifdef LOCAL
    for (int i = 0; i < n; i++)
        gr[i].clear();
#endif
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        gr[i].push_back(p[i]);
        gr[p[i]].push_back(i);
    }
    it = 0;
    dfs1(0, 0);
    lg2[0] = -1;
    for (int i = 1; i <= it; i++)
        lg2[i] = lg2[i / 2] + 1;
    for (int i = 1; i < LG; i++)
        for (int j = 0; j + (1 << i) <= it; j++)
            st[j][i] = min_by_h(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
    ans = 1;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    for (int i = 0; i < n; i++)
        DSU[i] = Item(i);
    ok = true;
    cin >> m;
    while (m--) {
        cin >> a >> b >> c >> d;
        if (ok) {
            a--, b--, c--, d--;
            p1.clear();
            int la = lca(a, b);
            while (a != la) {
                p1.push_back(a);
                a = p[a];
            }
            while (b != la) {
                pb.push_back(b);
                b = p[b];
            }
            p1.push_back(la);
            while (!pb.empty()) {
                p1.push_back(pb.back());
                pb.pop_back();
            }
            p2.clear();
            la = lca(c, d);
            while (c != la) {
                p2.push_back(c);
                c = p[c];
            }
            while (d != la) {
                pb.push_back(d);
                d = p[d];
            }
            p2.push_back(la);
            while (!pb.empty()) {
                p2.push_back(pb.back());
                pb.pop_back();
            }
            for (int i = 0; i < (int)p1.size(); i++) {
                a = get(p1[i]);
                b = get(p2[i]);
                if (a == b)
                    continue;
                unite(a, b);
                c = get(a);
                ans = mul(ans, inverse(r[a] - l[a] + 1));
                ans = mul(ans, inverse(r[b] - l[b] + 1));
                l[c] = max(l[a], l[b]);
                r[c] = min(r[a], r[b]);
                if (l[c] > r[c]) {
                    ok = false;
                    break;
                }
                ans = mul(ans, r[c] - l[c] + 1);
            }
        }
        if (!ok)
            cout << "0\n";
        else
            cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
