#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

const int maxN = 2e5, mod = 1e9 + 7, SZ = 2 * maxN, LG = 19;

struct Item {
    int p, sz;
    Item(int p = 0) : p(p), sz(1) {}
} DSU[maxN];

bool ok, g4;
int test = 1, n, p[maxN], l[maxN], r[maxN], m, a, b, c, d, ans, st[SZ][LG], lg2[SZ], it, first_visit[maxN], height[maxN], tr[maxN];
vi gr[maxN], p1, p2, p3;
vpi pa, pb, pc;

int mul(int a, int b) {
    return 1LL * a * b % mod;
}

int inverse(int a) {
    int b = mod - 2, res = 1;
    while (b) {
        if (b & 1)
            res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

void dfs(int u) {
    st[it][0] = u;
    first_visit[u] = it++;
    for (int v : gr[u]) {
        height[v] = height[u] + 1;
        dfs(v);
        st[it++][0] = u;
    }
}

int get(int u) {
    return u == DSU[u].p ? u : DSU[u].p = get(DSU[u].p);
}

int get_tr(int u) {
    return u == tr[u] ? u : tr[u] = get_tr(tr[u]);
}

void unite(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (DSU[u].sz < DSU[v].sz)
        swap(u, v);
    DSU[v].p = u;
    DSU[u].sz += DSU[v].sz;
}

int min_by_h(int u, int v) {
    return height[u] < height[v] ? u : v;
}

int lca(int u, int v) {
    u = first_visit[u];
    v = first_visit[v];
    if (u > v)
        swap(u, v);
    int k = lg2[v - u + 1];
    return min_by_h(st[u][k], st[v - (1 << k) + 1][k]);
}

void solve() {
    cin >> n;
#ifdef LOCAL
    for (int i = 0; i < n; i++)
        gr[i].clear();
#endif
    ok = true;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        gr[p[i]].push_back(i);
        ok &= p[i] == i - 1;
    }
    g4 = n > 1e5 && !ok;
    if (g4) {
        it = 0;
        dfs(0);
        lg2[0] = -1;
        for (int i = 1; i <= it; i++)
            lg2[i] = lg2[i / 2] + 1;
        for (int i = 1; i < LG; i++)
            for (int j = 0; j + (1 << i) <= it; j++)
                st[j][i] = min_by_h(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        ans = 1;
        for (int i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
            ans = mul(ans, r[i] - l[i] + 1);
        }
        for (int i = 0; i < n; i++)
            DSU[i] = Item(i);
        ok = true;
        cin >> m;
        while (m--) {
            cin >> a >> b >> c >> d;
            if (ok) {
                a--, b--, c--, d--;
                p1.clear();
                int la = lca(a, b);
                while (a != la) {
                    p1.push_back(a);
                    a = p[a];
                }
                while (b != la) {
                    p3.push_back(b);
                    b = p[b];
                }
                p1.push_back(la);
                while (!p3.empty()) {
                    p1.push_back(p3.back());
                    p3.pop_back();
                }
                p2.clear();
                la = lca(c, d);
                while (c != la) {
                    p2.push_back(c);
                    c = p[c];
                }
                while (d != la) {
                    p3.push_back(d);
                    d = p[d];
                }
                p2.push_back(la);
                while (!p3.empty()) {
                    p2.push_back(p3.back());
                    p3.pop_back();
                }
                for (int i = 0; i < (int)p1.size(); i++) {
                    a = get(p1[i]);
                    b = get(p2[i]);
                    if (a == b)
                        continue;
                    unite(a, b);
                    c = get(a);
                    ans = mul(ans, inverse(r[a] - l[a] + 1));
                    ans = mul(ans, inverse(r[b] - l[b] + 1));
                    l[c] = max(l[a], l[b]);
                    r[c] = min(r[a], r[b]);
                    if (l[c] > r[c]) {
                        ok = false;
                        break;
                    }
                    ans = mul(ans, r[c] - l[c] + 1);
                }
            }
            if (!ok)
                cout << "0\n";
            else
                cout << ans << "\n";
        }
    } else {
        it = 0;
        dfs(0);
        lg2[0] = -1;
        for (int i = 1; i <= it; i++)
            lg2[i] = lg2[i / 2] + 1;
        for (int i = 1; i < LG; i++)
            for (int j = 0; j + (1 << i) <= it; j++)
                st[j][i] = min_by_h(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        ans = 1;
        for (int i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
            ans = mul(ans, r[i] - l[i] + 1);
        }
        for (int i = 0; i < n; i++)
            DSU[i] = Item(i);
        iota(tr, tr + n, 0);
        ok = true;
        cin >> m;
        while (m--) {
            cin >> a >> b >> c >> d;
            if (ok) {
                a--, b--, c--, d--;
                int la = lca(a, b);
                pa.clear();
                while (true) {
                    int u = get_tr(a);
                    while (u != 0 && get(a) == get(p[u])) {
                        tr[u] = p[u];
                        u = get_tr(a);
                    }
                    pa.emplace_back(get(a), height[a] - max(height[get_tr(a)], height[la]) + 1);
                    if (height[get_tr(a)] <= height[la])
                        break;
                    a = p[get_tr(a)];
                }
                while (la != b) {
                    int u = get_tr(b);
                    while (u != 0 && get(b) == get(p[u])) {
                        tr[u] = p[u];
                        u = get_tr(b);
                    }
                    pc.emplace_back(get(b), height[b] - max(height[get_tr(b)], height[la] + 1) + 1);
                    if (height[get_tr(b)] <= height[la] + 1)
                        break;
                    b = p[get_tr(b)];
                }
                while (!pc.empty()) {
                    pa.push_back(pc.back());
                    pc.pop_back();
                }
                la = lca(c, d);
                pb.clear();
                while (true) {
                    int u = get_tr(c);
                    while (u != 0 && get(c) == get(p[u])) {
                        tr[u] = p[u];
                        u = get_tr(c);
                    }
                    pb.emplace_back(get(c), height[c] - max(height[get_tr(c)], height[la]) + 1);
                    if (height[get_tr(c)] <= height[la])
                        break;
                    c = p[get_tr(c)];
                }
                while (la != d) {
                    int u = get_tr(d);
                    while (u != 0 && get(d) == get(p[u])) {
                        tr[u] = p[u];
                        u = get_tr(d);
                    }
                    pc.emplace_back(get(d), height[d] - max(height[get_tr(d)], height[la] + 1) + 1);
                    if (height[get_tr(d)] <= height[la] + 1)
                        break;
                    d = p[get_tr(d)];
                }
                while (!pc.empty()) {
                    pb.push_back(pc.back());
                    pc.pop_back();
                }
                for (int i = 0; i + 1 < (int)pa.size(); i++)
                    pa[i + 1].second += pa[i].second;
                for (int i = 0; i + 1 < (int)pb.size(); i++)
                    pb[i + 1].second += pb[i].second;
                for (int i = 0, j = 0, pos = 0; true;) {
                    while (i < (int)pa.size() && pa[i].second <= pos)
                        i++;
                    while (j < (int)pb.size() && pb[j].second <= pos)
                        j++;
                    if (i == (int)pa.size() || j == (int)pb.size())
                        break;
                    a = get(pa[i].first);
                    b = get(pb[j].first);
                    if (a != b) {
                        unite(a, b);
                        c = get(a);
                        ans = mul(ans, inverse(r[a] - l[a] + 1));
                        ans = mul(ans, inverse(r[b] - l[b] + 1));
                        l[c] = max(l[a], l[b]);
                        r[c] = min(r[a], r[b]);
                        if (l[c] > r[c]) {
                            ok = false;
                            break;
                        }
                        ans = mul(ans, r[c] - l[c] + 1);
                    }
                    pos = min(pa[i].second, pb[j].second);                
                }
            }
            if (!ok)
                cout << "0\n";
            else
                cout << ans << "\n";
        }
    }
    
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
