#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e5, MOD = 1e9 + 7;

vector <int> g[MAXN];

int par[MAXN], pr[MAXN], p[MAXN], sz[MAXN], l[MAXN], r[MAXN], h[MAXN], ans = 1;

map <int, int> obr;

int binpow(int a, int n) {
    if (n == 0)
        return 1;
    if (n % 2)
        return a * binpow(a, n - 1) % MOD;
    int ans = binpow(a, n / 2);
    return ans * ans % MOD;
}

int get(int v) {
    if (v == p[v])
        return v;
    return p[v] = get(p[v]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b)
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    p[b] = a;
    sz[a] += sz[b];
    if (max(l[a], l[b]) > min(r[a], r[b])) {
        ans = 0;
        pr[a] = 0;
    } else {
        if (obr.find(pr[a]) != obr.end()) {
            ans = ans * obr[pr[a]] % MOD;
        } else {
            obr[pr[a]] = binpow(pr[a], MOD - 2);
            ans = ans * obr[pr[a]] % MOD;
        }
        if (obr.find(pr[b]) != obr.end()) {
            ans = ans * obr[pr[b]] % MOD;
        } else {
            obr[pr[b]] = binpow(pr[b], MOD - 2);
            ans = ans * obr[pr[b]] % MOD;
        }
        l[a] = max(l[a], l[b]);
        r[a] = min(r[a], r[b]);
        ans = ans * (r[a] - l[a] + 1) % MOD;
        pr[a] = r[a] - l[a] + 1;
    }
}

void dfs(int v) {
    for (int to : g[v]) {
        par[to] = v;
        h[to] = h[v] + 1;
        dfs(to);
    }
}

int lca(int a, int b) {
    while (a != b) {
        if (h[a] > h[b]) {
            a = par[a];
        } else if (h[b] > h[a]) {
            b = par[b];
        } else {
            a = par[a];
            b = par[b];
        }
    }
    return a;
}

vector <int> makepath(int a, int b, int v) {
    vector <int> v1, v2;
    while (h[a] != h[v]) {
        v1.push_back(a);
        a = par[a];
    }
    v1.push_back(a);
    while (h[b] != h[v]) {
        v2.push_back(b);
        b = par[b];
    }
    reverse(v2.begin(), v2.end());
    for (auto x : v2)
        v1.push_back(x);
    return v1;
}

void f(int a, int b, int c, int d) {
    int v1 = lca(a, b), v2 = lca(c, d);
    vector <int> path1 = makepath(a, b, v1), path2 = makepath(c, d, v2);
    for (int i = 0; i < path1.size(); ++i)
        unite(path1[i], path2[i]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int par;
        cin >> par;
        --par;
        g[par].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        p[i] = i;
        sz[i] = 1;
        pr[i] = r[i] - l[i] + 1;
        ans = ans * (r[i] - l[i] + 1) % MOD;
    }
    dfs(0);
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        f(a, b, c, d);
        cout << ans << '\n';
    }
    return 0;
}
