#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = (int)1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;
vector<vector<int>> g, binpow(19);
vector<int> rankk, pr, l, r, tin, tout;
int T = 1;

int find_set(int u) {
    return (u == pr[u] ? u : pr[u] = find_set(pr[u]));
}

void union_set(int u, int v) {
    u = find_set(u);
    v = find_set(v);
    if (u != v) {
        if (rankk[u] > rankk[v]) swap(u, v);
        rankk[v] += rankk[u];
        pr[u] = v;
    }
}

void dfs(int u) {
    tin[u] = T++;
    for (auto v : g[u]) dfs(v);
    tout[u] = T++;
}

int get_lca(int u, int v) {
    if (tin[u] <= tin[v] && tout[v] <= tout[u]) return u;
    if (tin[v] <= tin[u] && tout[u] <= tout[v]) return v;
    for (int i = 18; i>=0; --i) {
        if (!(tin[binpow[i][u]] <= tin[v] && tout[v] <= tout[binpow[i][u]])) u = binpow[i][u];
    }
    return binpow[0][u];
}

int fast_pow(int a, int b) {
    if (!b) return 1;
    if (b&1) return (a*fast_pow(a, b-1))%mod1;
    int res = fast_pow(a, b>>1);
    return (res*res)%mod1;
}

int division(int a, int b) {
    return (a*fast_pow(b, mod1-2))%mod1;
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i<19; ++i) binpow[i].resize(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    tin.resize(n);
    tout.resize(n);
    rankk.resize(n, 1);
    pr.resize(n); iota(all(pr), 0);
    bool ch = true;
    for (int i = 1; i<n; ++i) {
        int p; cin >> p; p--;
        if (p+1 != i) ch = false;
        binpow[0][i] = p;
        g[p].emplace_back(i);
    }
//    if (ch) {
//
//        return;
//    }
    dfs(0);
    for (int i = 1; i<19; ++i) {
        for (int j = 0; j<n; ++j) binpow[i][j] = binpow[i-1][binpow[i-1][j]];
    }
    int res = 1;
    for (int i = 0; i<n; ++i) {
        cin >> l[i] >> r[i];
        res *= (r[i]-l[i]+1);
        res %= mod1;
    }
    bool fl = false;
    int m; cin >> m;
    int cnt = 0;
    for (int i = 0; i<m; ++i) {
        int a, b, c, d; cin >> a >> b >> c >> d; a--; b--; c--; d--;
        if (fl) {
            cout << "0\n";
            continue;
        }
        int lca1 = get_lca(a, b), lca2 = get_lca(c, d);
//        cout << lca1 << " : " << lca2 << endl;
        vector<int> v11, v12, v21, v22;
        while (a != lca1) {
            v11.emplace_back(a); a = binpow[0][a];
        }
        v11.emplace_back(lca1);
        while (b != lca1) {
            v12.emplace_back(b); b = binpow[0][b];
        }
        reverse(all(v12));
        while (c != lca2) {
            v21.emplace_back(c); c = binpow[0][c];
        }
        v21.emplace_back(lca2);
        while (d != lca2) {
            v22.emplace_back(d); d = binpow[0][d];
        }
        reverse(all(v22));
        for (auto elem : v12) v11.emplace_back(elem);
        for (auto elem : v22) v21.emplace_back(elem);
//        print(v11);
//        print(v21);
        for (int j = 0; j<(int)v11.size(); ++j) {
            if (cnt >= (int)7e7) {
                for (int k = i; k<m; ++k) {
                    cout << res << '\n';
                }
                return;
            }
            int x = find_set(v11[j]), y = find_set(v21[j]);
            //cout << x << " " << y << endl;
            cnt++;
            if (x == y) continue;
            int nl = max(l[x], l[y]), nr = min(r[x], r[y]);
            if (nr < nl) {
                fl = true;
                break;
            }
            union_set(x, y);
            int root = find_set(x);
            res = division(res, ((r[x]-l[x]+1) * (r[y]-l[y]+1))%mod1);
            res = (res*(nr-nl+1))%mod1;
            r[root] = nr; l[root] = nl;
        }
        cout << (fl ? 0 : res) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
