#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MOD = 1e9 + 7;

int mul(int a, int b)
{
    return (a * 1ll * b) % MOD;
}

int bp(int a, int n)
{
    if (n == 0) return 1;
    int p = bp(a, n/  2);
    p = mul(p, p);
    if (n & 1) p = mul(p, a);
    return p;
}

int inv(int a)
{
    return bp(a, MOD - 2);
}

vector<pair<int, int> > seg;

vector<int> p, sz;
vector<pair<int, int> > cur_seg;

void init(int nn)
{
    p.resize(nn);
    iota(p.begin(), p.end(), 0);
    sz.resize(nn, 1);
    cur_seg.resize(nn);
    for (int i = 0; i < cur_seg.size(); i++) cur_seg[i] = seg[i];
}

pair<int, int> inter(pair<int, int> a, pair<int, int> b)
{
    return make_pair(max(a.first, b.first), min(a.second, b.second));
}

int get_par(int a)
{
    if (p[a] == a)
        return a;
    return p[a] = get_par(p[a]);
}

ll ans = 1;

int len(pair<int, int> a)
{
    if (a.first > a.second) return 0;
    return a.second - a.first + 1;
}


void mrg(int a, int b)
{
    a = get_par(a);
    b = get_par(b);
    if (a != b)
    {
        if (sz[a] < sz[b]) swap(a, b);
        sz[a] += sz[b];
        //ans /= len(cur_seg[a]);
        //ans /= len(cur_seg[b]);
        ans = mul(ans, inv(len(cur_seg[a])));
        ans = mul(ans, inv(len(cur_seg[b])));
        cur_seg[a] = inter(cur_seg[a], cur_seg[b]);
        //ans *= len(cur_seg[a]);
        ans = mul(ans, len(cur_seg[a]));
        p[b] = a;
    }
}

vector<vector<int> > g;

vector<int> tin, tout;
vector<vector<int> > up;

int timer = 0, l = 0;

void dfs(int v, int p)
{
    tin[v] = timer++;
    up[v][0] = p;
    for (int i = 1; i < l; i++)
    {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto& u : g[v])
    {
        if (u != p)
        {
            dfs(u, v);
        }
    }
    tout[v] = timer++;
}

bool anc(int a, int b)
{
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b)
{
    if (anc(a, b)) return a;
    if (anc(b, a)) return b;
    for (int i = l - 1; i >= 0; i--)
    {
        if (!anc(up[a][i], b))
        {
            a = up[a][i];
        }
    }
    return up[a][0];
}

vector<int> get_path(int a, int b)
{
    int l = lca(a, b);
    vector<int> f, s;
    while (a != l)
    {
        f.push_back(a);
        a = up[a][0];
    }
    while (b != l)
    {
        s.push_back(b);
        b = up[b][0];
    }
    f.push_back(l);
    for (int i = s.size() - 1; i >= 0; i--) f.push_back(s[i]);
    return f;
}


int main()
{
    int n;
    cin >> n;
    seg.resize(n);
    g.resize(n);
    while ((1 << l) <= n)
        l++;
    up.resize(n, vector<int>(l));
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    dfs(0, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> seg[i].first >> seg[i].second;
    }
    int q;
    cin >> q;
    init(n);
    for (int i = 0; i < n; i++)
    {
        ans = mul(ans, len(seg[i]));
    }
    for (int i = 0; i < q; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--;
        c--; d--;
        vector<int> fp = get_path(a, b);
        vector<int> sp = get_path(c, d);
        for (int i = 0; i < fp.size(); i++)
        {
            mrg(fp[i], sp[i]);
        }

//        for (int i = 0; i < n; i++)
//        {
//            if (p[i] == i)
//            {
//                ans = mul(ans, max(0, len(cur_seg[i])));
//            }
//        }
        cout << ans << endl;
    }
    return 0;
}
