#include <bits/stdc++.h>
using namespace std;

struct DSU {
    int n;
    vector<int> par, sz, l, r;
    DSU() {}
    DSU(int _n) {
        n = _n;
        par.resize(n);
        sz.resize(n);
        l.resize(n);
        r.resize(n);
        for (int i = 0; i < n; ++i) {
            par[i] = i, sz[i] = 1;
        }
    }
    int getParent(int v) {
        if (par[v] != v) {
            par[v] = getParent(par[v]);
        }
        return par[v];
    }
    void uniteSets(int v, int u) {
        v = getParent(v), u = getParent(u);
        if (v == u) {return;}
        if (sz[v] < sz[u]) {swap(v, u);}
        par[u] = v;
        sz[v] += sz[u];
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);
    }
    ~DSU() {}
};

const int mod = 1e9 + 7;

int add(int a, int b) {
    int res = a + b;
    if (res >= mod) {
        res -= mod;
    }
    return res;
}

int times(int a, int b) {
    long long res = a * 1ll * b;
    if (res >= mod) {
        res %= mod;
    }
    return res;
}
const int maxn = 2e5;
vector<int> g[maxn];
int par[maxn], tin[maxn], tout[maxn], h[maxn];
int path1[maxn], path2[maxn], tt;
char used[maxn];
vector<int> ulist;

void dfs(int v) {
    tin[v] = tt++;
    for (const int& u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
    }
    tout[v] = tt++;
}

bool isAncestor(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    par[0] = -1;
    h[0] = 0;
    tt = 0;
    for (int i = 1; i < n; ++i) {
        cin >> par[i];
        --par[i];
        g[par[i]].emplace_back(i);
    }
    DSU dsu(n);
    for (int i = 0; i < n; ++i) {
        cin >> dsu.l[i] >> dsu.r[i];
    }
    dfs(0);
    int m;
    cin >> m;
    bool able = true;
    int ans;
    for (int iter = 0; iter < m; ++iter) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        if (able) {
            int p1 = a, p2 = c;
            int last1 = 1, last2 = 1;
            path1[0] = a, path2[0] = c;
            while (!isAncestor(p1, b)) {
                p1 = par[p1];
                path1[last1++] = p1;
            }
            while (!isAncestor(p2, d)) {
                p2 = par[p2];
                path2[last2++] = p2;
            }
            int len = h[a] + h[b] - 2 * h[p1] + 1;
            int lca1 = p1, lca2 = p2;
            last1 = len - 1, last2 = len - 1;
            p1 = b, p2 = d;
            while (p1 != lca1) {
                path1[last1--] = p1;
                p1 = par[p1];
            }
            while (p2 != lca2) {
                path2[last2--] = p2;
                p2 = par[p2];
            }
            for (int i = 0; i < len; ++i) {
                dsu.uniteSets(path1[i], path2[i]);
            }
            ans = 1;
            ulist.clear();
            for (int i = 0; i < n; ++i) {
                int p = dsu.getParent(i);
                if (!used[p]) {
                    ans = times(ans, dsu.r[p] - dsu.l[p] + 1);
                    if (ans == 0) {
                        able = false;
                    }
                    used[p] = true;
                    ulist.emplace_back(p);
                }
            }
            while (!ulist.empty()) {
                used[ulist.back()] = false;
                ulist.pop_back();
            }
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
