#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <fstream>

#define f first
#define s second
#define int long long

using namespace std;

const int N = 2*1e5, mod = 1e9+7;
int t = 1;

void start();
void update();

signed main() {
    start();
    while(t--){
        update();
    }
    return 0;
}
int n, k, m;
void start(){
    //cin >> t;
}

vector<int> cnm(N);
vector<int> rank1(N);
vector<int> dl(N), dr(N);


int get(int v){
    if(cnm[v] == v){
        return v;
    }
    cnm[v] = get(cnm[v]);
    return cnm[v];
}

void merge(int v, int u){
    v = get(v);
    u = get(u);
    if(rank1[v] > rank1[u]){
        cnm[u] = v;
        dl[v] = max(dl[v], dl[u]);
        dr[v] = min(dr[v], dr[u]);
        rank1[v]++;
    }
    else{
        cnm[v] = u;
        dl[u] = max(dl[u], dl[v]);
        dr[u] = min(dr[u], dr[v]);
        rank1[u]++;
    }
}

void BFS(int v, int u, vector<int> &marsh, vector<vector<int>> &g){
    vector<int> used(n);
    vector<int> ans(n);
    queue<int> q;
    q.push(v);
    used[v] = 1;
    ans[v] = v;
    while(q.size() > 0){
        int now = q.front();
        q.pop();
        for(auto& it : g[now]){
            if(used[it] == 0){
                used[it] = 1;
                q.push(it);
                ans[it] = now;
                if(it == u){
                    int now1 = it;
                    while(ans[now1] != now1){
                        marsh.push_back(now1);
                        now1 = ans[now1];
                    }
                    return;
                }
            }
        }
    }
}

void update(){
    cin >> n;
    vector<int> g(n-1);
    vector<vector<int>> g1(n);
    for(int i = 0; i<n-1; i++){
        cin >> g[i];
        g[i]--;
    }
    for(int i = 0; i<n-1; i++){
        g1[i+1].push_back(g[i]);
        g1[g[i]].push_back(i+1);
    }
    vector<int> l(n), r(n);
    for(int i = 0; i<n; i++){
        cin >> l[i] >> r[i];
    }
    cin >> m;
    vector<int> a(m), b(m), c(m), d(m);
    for(int i = 0; i<m; i++){
        cin >> a[i] >> b[i] >> c[i] >> d[i];
    }
    for(int i = 0; i<n; i++) {
        cnm[i] = i;
        rank1[i] = 0;
        dl[i] = l[i];
        dr[i] = r[i];
    }
    for(int i = 0; i<m; i++){
        int op1 = a[i]-1, op2 = c[i]-1;
        vector<int> marsh1, marsh2;
        BFS(op1, b[i]-1, marsh1, g1);
        BFS(op2, d[i]-1, marsh2, g1);
        while(op1 != b[i]-1){
            merge(op1, op2);
            op1 = marsh1.back();
            op2 = marsh2.back();
            marsh1.pop_back();
            marsh2.pop_back();
        }
        merge(op1, op2);
        int ansi = 1;
        set<int> need;
        for(int j = 0; j<n; j++){
            int kor = get(j);
            need.insert(kor);
        }
        for(auto& it : need){
            ansi = (ansi*max((int)0, dr[it]-dl[it]+1)) % mod;
        }
        cout << ansi << endl;
    }
}
