#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << " : " << x << '\n';
#define watch_arr(arr) \
cout << #arr << " : "; \
forn(i, arr.size()) \
    cout << arr[i] << ' '; \
cout << '\n';

const int N = 2e1, MOD = 1e9 + 7;

vector<int> g[N];
bool used[N];
int par[N];
int up[N][__lg(N) + 1]{};
int comp[N];
int comp_sz[N];
pair<int, int> comp_d[N];
int tin[N], tout[N];
int t = 0;
set<int> comp_roots;

void dfs(int v) {
    tin[v] = t;
    ++t;
    used[v] = true;

    for(auto to : g[v]) {
        if(!used[to])
            dfs(to);
    }
    tout[v] = t;
    ++t;
}

void set_up(int v) {
    up[v][0] = par[v];
    forn(j, __lg(N))
        up[v][j + 1] = up[up[v][j]][j];
}

void dfs_up(int v) {
    set_up(v);
    used[v] = true;

    for(auto to : g[v]) {
        if(!used[to])
            dfs_up(to);
    }
}

void set_comp(int n) {
    forn(i, n) {
        comp[i] = i;
        comp_sz[i] = 1;
        comp_roots.insert(i);
    }
}

int get_comp(int v) {
    int comp_root = v;
    while(comp_root != comp[comp_root])
        comp_root = comp[comp_root];

    while(v != comp_root) {
        int to = comp[v];
        comp[v] = comp_root;
        v = to;
    }

    return v;
}

void merge_comp(int v1, int v2) {
    v1 = get_comp(v1);
    v2 = get_comp(v2);
    if(v1 == v2)
        return;
    if(comp_sz[v1] < comp_sz[v2])
        swap(v1, v2);
    
    comp[v2] = v1;
    comp_d[v1].first = max(comp_d[v1].first, comp_d[v2].first);
    comp_d[v1].second = min(comp_d[v1].second, comp_d[v2].second);
    comp_sz[v1] += comp_sz[v2];
    comp_roots.erase(v2);
}

int lca(int v1, int v2, int n) {
    if(tin[v1] <= tin[v2] && tout[v1] >= tout[v2])
        return v1;

    int p = __lg(n) + 1;
    while(p >= 0) {
        int v_up = up[v1][p];
        if(tin[v_up] > tin[v2] || tout[v_up] < tout[v2])
            v1 = v_up;
        p--;
    }

    return par[v1];
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);


    int n;
    cin >> n;
    forn(i, n - 1) {
        int p, v = i + 1;
        cin >> p;
        --p;
        par[v] = p;
        g[v].push_back(p);
        g[p].push_back(v);
    }
    par[0] = 0;
    dfs(0);

    forn(i, n)
        used[i] = false;
    dfs_up(0);

    forn(i, n) {
        int l, r;
        cin >> l >> r;
        comp_d[i] = {l, r + 1};
    }
    set_comp(n);

    int m;
    cin >> m;
    
    forn(i, m) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        int lca1 = lca(a, b, n), lca2 = lca(c, d, n);
        while(a != lca1 && c != lca2) {
            merge_comp(a, c);
            a = par[a];
            c = par[c];
        }

        if(a == lca1) {
            merge_comp(a, c);
            while(d != lca2) {
                merge_comp(b, d);
                b = par[b];
                d = par[d];
            }
            deque<int> way;
            while(c != lca2) {
                c = par[c];
                way.push_front(c);
            }
            while(b != lca1) {
                merge_comp(b, way.front());
                b = par[b];
                way.pop_front();
            }
        }

        
        else if(c == lca2) {
            merge_comp(a, c);
            while(b != lca1) {
                merge_comp(b, d);
                b = par[b];
                d = par[d];
            }
            deque<int> way;
            while(a != lca1) {
                a = par[a];
                way.push_front(a);
            }
            while(d != lca2) {
                merge_comp(d, way.front());
                d = par[d];
                way.pop_front();
            }
        }

        ll res = 1;
        for(auto v : comp_roots)
            res = (res * max(0, comp_d[v].second - comp_d[v].first)) % MOD;

        cout << res << '\n';
    }
}
