#define pii pair < int, int >
#include <bits/stdc++.h>
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;

const int N = (int)2e5 + 5;
const int MOD = (int)1e9 + 7;

int mul(int a, int b) {
    return ((a % MOD) * (b % MOD)) % MOD;
}

int binPow(int x, int r) {
    if (r == 0) {
        return 1;
    }
    if (r & 1) {
        return mul(binPow(x, r - 1), x);
    }
    else {
        int res = binPow(x, r / 2);
        return mul(res, res);
    }
}

int divd(int a, int b) {
    return mul(a, binPow(b, MOD - 2));
}

int sum(int a, int b) {
    return (a % MOD + b % MOD) % MOD;
}

pii r[N];

vector < int > g[N];

int tin[N], tout[N], pr[N], up[N][20], timer, parent[N], sz[N];

pii p[N];

bool upper(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

void dfs(int v, int anc) {
    tin[v] = timer++;
    up[v][0] = anc;
    for (int i = 1; i < 20; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to : g[v]) {
        if (to == anc) continue;
        dfs(to, v);
    }
    tout[v] = timer++;
}

int lca(int a, int b) {
    if (upper(a, b)) {
        return a;
    }
    if (upper(b, a)) {
        return b;
    }

    for (int i = 19; i >= 0; i--) {
        if (up[a][i] && !upper(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

vector < int > getPath(int a, int b) {
    vector < int > res;
    int l = lca(a, b);
    int cur = a;
    while (cur && upper(l, cur)) {
        res.push_back(cur);
        cur = pr[cur];
    }
    vector < int > temp;
    cur = b;
    while (cur != l) {
        temp.push_back(cur);
        cur = pr[cur];
    }
    reverse(temp.begin(), temp.end());
    for (auto x: temp) {
        res.push_back(x);
    }
    return res;
}

int findSet(int v) {
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = findSet(parent[v]);
}

int ans;

void uniteSets(int u, int v) {
    if (!ans) {
        return;
    }
    u = findSet(u); v = findSet(v);
    if (u != v) {
        ans = divd(ans, p[v].second - p[v].first + 1);
        ans = divd(ans, p[u].second - p[u].first + 1);
        if (sz[v] > sz[u]) swap(v, u);
        parent[v] = u;
        sz[u] += sz[v];
        p[u].first = max(p[u].first, p[v].first);
        p[u].second = min(p[v].second, p[u].second);
        if (p[u].second < p[u].first) {
            ans = 0; return;
        }
        ans = mul(ans, p[u].second - p[u].first + 1);
    }
}

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> pr[i];
        g[pr[i]].push_back(i);
        g[i].push_back(pr[i]);
    }
    int in = 1;
    for (int i = 1; i <= n; i++) {
        cin >> r[i].first >> r[i].second;
        in = mul(in, r[i].second - r[i].first + 1);
    }

    dfs(1, 0);

    for (int i = 1; i <= n; i++) {
        parent[i] = i; p[i] = r[i];
    }

    int m;
    cin >> m;
    ans = in;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        if (ans != 0) {
            vector < int > f = getPath(a, b);
            vector < int > s = getPath(c, d);
            for (int i = 0; i < (int)f.size(); i++) {
                uniteSets(f[i], s[i]);
                if (!ans) break;
            }
        }

        cout << ans << '\n';
    }
    return 0;
}
