#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
//#define int long long
#define all(x) (x).begin(), (x).end()

const long long mod = 1e9 + 7;

int bin_pow(int x, int p) {
    if (p == 0) {
        return 1ll;
    }
    if (p % 2 == 0) {
        long long res = bin_pow(x, p / 2);
        return res * res % mod;
    } else {
        return bin_pow(x, p - 1) * 1ll * x % mod;
    }
}

long long ans = 1;
unordered_map<int, int> kek;

int inv(int x) {
    if (kek.count(x)) {
        return kek[x];
    }
    return kek[x] = bin_pow(x, mod - 2);
}

struct DSU {
    vector<int> p;
    vector<int> sz;
    vector<pair<int, int>> segs;

    void init(int n, vector<pair<int, int>> &sg) {
        p.assign(n, 0);
        iota(all(p), 0);
        segs = sg;
        sz.assign(n, 1);
    }

    int get_parent(int v) {
        if (p[v] == v) {
            return v;
        } else {
            return p[v] = get_parent(p[v]);
        }
    }

    void merge(int a, int b) {
        a = get_parent(a);
        b = get_parent(b);
        if (a == b) {
            return;
        }
        ans *= inv(segs[a].second - segs[a].first + 1);
        ans %= mod;
        ans *= inv(segs[b].second - segs[b].first + 1);
        ans %= mod;
        int left = max(segs[a].first, segs[b].first);
        int right = min(segs[a].second, segs[b].second);
        ans *= max(0, right - left + 1);
        ans %= mod;
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        segs[a] = {left, right};
        segs[b] = {left, right};
    }
};

int n;
vector<vector<int>> g;

vector<int> get_path(int fr, int too) {
    vector<int> pr(n, -1);
    queue<int> q;
    vector<bool> used(n);
    q.push(fr);
    used[fr] = true;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to: g[v]) {
            if (!used[to]) {
                used[to] = true;
                q.push(to);
                pr[to] = v;
            }
        }
    }
    vector<int> path = {too};
    int v = too;
    while (pr[v] != -1) {
        path.push_back(pr[v]);
        v = pr[v];
    }
    reverse(all(path));
    return path;
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
        g[i].push_back(p);
    }
    vector<pair<int, int>> segs(n);
    for (auto &[l, r]: segs) {
        cin >> l >> r;
        ans *= (r - l + 1);
        ans %= mod;
    }
    int m;
    cin >> m;
    DSU dsu;
    dsu.init(n, segs);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        if (ans == 0) {
            cout << 0 << '\n';
            continue;
        }
        auto ab = get_path(a, b);
        auto cd = get_path(c, d);
        int len = (int) ab.size();
        for (int j = 0; j < len; j++) {
            dsu.merge(ab[j], cd[j]);
        }
        cout << ans << '\n';
    }
    return 0;
}

