#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> tr;
vector<vector<int>> g;
vector<int> dist;

vector<bool> used;
vector<pair<int, int>> ct;
int ll, rr;

void dfs(int v) {
	for (auto i = 0; i < tr[v].size(); ++i) {
		dist[tr[v][i]] = dist[v] + 1;
		dfs(tr[v][i]);
	}
}

void dfs2(int v) {
	ll = max(ll, ct[v].first);
	rr = min(rr, ct[v].second);
	used[v] = 1;
	for (auto i = 0; i < g[v].size(); ++i) {
		if (!used[g[v][i]]) {
			dfs2(g[v][i]);
		}
	}
}

int main(){
	int n; cin >> n;
	g.resize(n);
	tr.resize(n);
	vector<int> a(n);
	a[0] = -1;
	for (auto i = 1; i < n; ++i) {
		int y; cin >> y; y--;
		a[i] = y;
		tr[y].push_back(i);
	}
	ct.resize(n);
	for (auto i = 0; i < n; ++i) {
		int xx, yyy; cin >> xx >> yyy;
		ct[i] = { xx, yyy };
	}
	dist.resize(n);
	used.resize(n);
	dist[0] = 0;
	dfs(0);
	int t; cin >> t;
	for (auto h = 0; h < t; ++h) {
		int aa, b, c, d; cin >> aa >> b >> c >> d;
		aa--; b--; c--; d--;
		vector<int> p1 = { aa };
		vector<int> p2 = { b };
		while (p1[p1.size() - 1] != p2[p2.size() - 1]) {
			if (dist[p1[p1.size() - 1]] > dist[p2[p2.size() - 1]]) {
				p1.push_back(a[p1[p1.size() - 1]]);
			} else if (dist[p1[p1.size() - 1]] < dist[p2[p2.size() - 1]]) {
				p2.push_back(a[p2[p2.size() - 1]]);
			}
			else {
				p1.push_back(a[p1[p1.size() - 1]]);
				p2.push_back(a[p2[p2.size() - 1]]);
			}
		}
		vector<int> pp1;
		for (auto i = 0; i < p1.size(); ++i) {
			pp1.push_back(p1[i]);
		}
		for (auto i = 1; i < p2.size(); ++i) {
			pp1.push_back(p2[p2.size() - i - 1]);
		}

		p1 = { c };
		p2 = { d };
		while (p1[p1.size() - 1] != p2[p2.size() - 1]) {
			if (dist[p1[p1.size() - 1]] > dist[p2[p2.size() - 1]]) {
				p1.push_back(a[p1[p1.size() - 1]]);
			}
			else if (dist[p1[p1.size() - 1]] < dist[p2[p2.size() - 1]]) {
				p2.push_back(a[p2[p2.size() - 1]]);
			}
			else {
				p1.push_back(a[p1[p1.size() - 1]]);
				p2.push_back(a[p2[p2.size() - 1]]);
			}
		}
		for (auto i = 1; i < p2.size(); ++i) {
			p1.push_back(p2[p2.size() - i - 1]);
		}
		for (auto k = 0; k < pp1.size(); ++k) {
			g[pp1[k]].push_back(p1[k]);
			g[p1[k]].push_back(pp1[k]);
		}
		int64_t ans = 1;
		for (auto k = 0; k < n; ++k) {
			used[k]=0;
		}
		for (auto k = 0; k < n; ++k) {
			if (!used[k]) {
				ll = ct[k].first;
				rr = ct[k].second;
				dfs2(k);
				ans *= max(0, rr - ll + 1);
				ans %= 1000000007;
			}
		}
		cout << ans << '\n';
	}
	return 0;
}