#include <bits/stdc++.h>

using namespace std;
#define ll long long
const ll mod = 1e9 + 7;

inline ll power(ll x, int pw) {
    ll ans = 1;
    while (pw) {
        if (pw & 1) {
            ans = ans * x % mod;
        }
        pw >>= 1;
        x = x * x % mod;
    }
    return ans;
}

struct dsu {
    ll ans;
    vector <pair <int, int>> seg;
    vector <int> p, sz;

    dsu(int n, const vector <pair <int, int>>& seg) : seg(seg) {
        ans = 1;
        p.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            sz[i] = 1;
            ans = ans * (seg[i].second - seg[i].first + 1) % mod;
        }
    }

    int parent(int a) {
        if (a == p[a]) return a;
        p[a] = parent(p[a]);
        return p[a];
    }

    inline void unite(int a, int b) {
        a = parent(a);
        b = parent(b);
        if (a == b) return;
        if (sz[a] > sz[b]) swap(a, b);
        ans = ans * power(seg[a].second - seg[a].first + 1, mod - 2) % mod;
        ans = ans * power(seg[b].second - seg[b].first + 1, mod - 2) % mod;
        p[a] = b;
        sz[b] += sz[a];
        seg[b].second = min(seg[a].second, seg[b].second);
        seg[b].first = max(seg[a].first, seg[b].first);
        if (seg[b].first > seg[b].second) {
            ans = 0;
            return;
        }
        ans = ans * (seg[b].second - seg[b].first + 1) % mod;
    }
};

vector <vector <int>> g;
vector <int> p, bp, gl;

void dfs(int v) {
    if (v != 0 && p[v] != 0 && p[p[v]] != 0 && gl[p[v]] - gl[bp[p[v]]] == gl[bp[p[v]]] - gl[bp[bp[p[v]]]]) bp[v] = bp[bp[p[v]]];
    else bp[v] = p[v];
    for (int i : g[v]) {
        gl[i] = gl[v] + 1;
        dfs(i);
    }
}

inline int parent(int v, int k) {
    while (k) {
        int l = gl[v] - gl[bp[v]];
        if (k >= l) {
            k -= l;
            v = bp[v];
        } else {
            k--;
            v = p[v];
        }
    }
    return v;
}

inline int lca(int a, int b) {
    if (gl[a] < gl[b]) swap(a, b);
    a = parent(a, gl[a] - gl[b]);
    if (a == b) return a;
    while (p[a] != p[b]) {
        if (bp[a] != bp[b]) {
            a = bp[a];
            b = bp[b];
        } else {
            a = p[a];
            b = p[b];
        }
    }
    return p[a];
}

inline int get_path(int a, int b, vector <int>& path) {
    int lc = lca(a, b);
    int ln = gl[a] + gl[b] - 2 * gl[lc] + 1;
    for (int i = 0;; ++i) {
        path[i] = a;
        if (a == lc) break;
        a = p[a];
    }
    for (int i = ln - 1;; --i) {
        if (b == lc) break;
        path[i] = b;
        b = p[b];
    }
    return ln;
}

inline void solve() {
    int n;
    cin >> n;
    g.resize(n);
    p.resize(n, -1);
    bp.resize(n, -1);
    gl.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        g[p[i]].push_back(i);
    }
    dfs(0);
    vector <pair <int, int>> seg(n);
    for (int i = 0; i < n; ++i) cin >> seg[i].first >> seg[i].second;
    dsu now(n, seg);
    int q;
    cin >> q;
    vector <int> path1(n), path2(n);
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (now.ans != 0) {
            int ln = get_path(a - 1, b - 1, path1);
            get_path(c - 1, d - 1, path2);
            for (int i = 0; i < ln && now.ans != 0; ++i) {
                now.unite(path1[i], path2[i]);
            }
        }
        cout << now.ans << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
    return 0;
}

/*
5
 1 1 2 2
 2 4
 1 3
 1 3
 2 4
 4 4
 4
 1 1 2 2
 1 2 2 1
 3 4 4 3
 3 4 3 5

 8
 1 2 3 4 5 8 6
 3 7
 2 6
 3 8
 5 10
 5 8
 2 9
 3 8
 6 8
 4
 1 3 7 6
 4 1 5 7
 1 7 7 1
 1 8 2 7
 */