//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

const ll N = 1e5+1, LOG = 20;
ll pred[N], sz[N], par[N], l[N], r[N], ans = 1, jump[LOG + 1][N], h[N];
vector < ll > g[N];

ll get(ll v) {
    if (pred[v] == v) return v;
    return pred[v] = get(pred[v]);
}

void unious(ll v, ll u){
    v = get(v);
    u = get(u);
    if (v == u) return;
    if (sz[u] < sz[v]) swap(u, v);
    ans = ans * bin_pow(r[v] - l[v] + 1, mod - 2) % mod;
    ans = ans * bin_pow(r[u] - l[u] + 1, mod - 2) % mod;
    l[v] = max(l[v], l[u]);
    r[v] = min(r[v], r[u]);
    ans = ans * max((r[v] - l[v] + 1), 0ll) % mod;
    pred[u] = v;
    sz[v] += sz[u];
}

ll up(ll v, ll k) {
    for (ll i = LOG; i >= 0; i--) {
        if (h[v] - (1 << i) >= k) {
            v = jump[i][v];
        }
    }
    return v;
}

ll LCA(ll v, ll u) {
    if (h[v] > h[u]) v = up(v, h[u]);
    if (h[u] > h[v]) u = up(u, h[v]);
    if (v == u) return v;
    for (ll i = LOG; i >= 0; i--) {
        if (jump[i][v] != jump[i][u]) {
            v = jump[i][v];
            u = jump[i][u];
        }
    }
    return jump[0][v];
}

void dfs(ll v) {
    forall(i, g[v]) {
        h[i] = h[v] + 1;
        dfs(i);
    }
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n - 1; i++) {
        cin >> jump[0][i + 1], jump[0][i + 1]--;
        g[jump[0][i + 1]].push_back(i + 1);
    }
    for (ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        ans = ans * (y - x + 1) % mod;
        l[i] = x;
        r[i] = y;
        pred[i] = i;
        sz[i] = 1;
    }

    dfs(0);

    for (ll L = 1; L <= LOG; L++) {
        for (ll i = 0; i < n; i++) {
            jump[L][i] = jump[L - 1][jump[L - 1][i]];
        }
    }

    ll q;
    cin >> q;
    while (q--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;

        vector < ll > frst, sec;
        vector < ll > last;
        ll lca = LCA(a, b);
        while (a != lca) {
            frst.push_back(a);
            a = jump[0][a];
        }
        frst.push_back(lca);
        while (b != lca) {
            last.push_back(b);
            b = jump[0][b];
        }
        reverse(all(last));
        forall(i, last) frst.push_back(i);
        last.clear();

        lca = LCA(c, d);
        while (c != lca) {
            sec.push_back(c);
            c = jump[0][c];
        }
        sec.push_back(lca);
        while (d != lca) {
            last.push_back(d);
            d = jump[0][d];
        }
        reverse(all(last));
        forall(i, last) sec.push_back(i);

        for (ll i = 0; i < sec.size(); i++) {
            unious(frst[i], sec[i]);
        }
        cout << ans << '\n';
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
