#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

vector<ll> p(MAXN);
vector<vector<ll>> vec(MAXN);

ll getroot(ll v) {
    if (p[v] == v) return v;
    else return p[v] = getroot(p[v]);
}

void unionset(ll u, ll v) {
    u = getroot(u);
    v = getroot(v);
    if (u != v) {
        if (vec[u].size() > vec[v].size()) swap(u, v);
        p[u] = v;
        for (auto e : vec[u]) vec[v].push_back(e);
        vec[u].clear();
    }
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) p[i] = i, vec[i] = {i};
    vector<ll> pr(n);
    vector<ll> g[n];
    for (ll i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        g[i].push_back(pr[i]);
        g[pr[i]].push_back(i);
    }
    vector<ll> l(n), r(n);
    for (ll i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    ll m;
    cin >> m;
    for (ll i = 0; i < m; ++i) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<ll> dist1(n, INF), p1(n);
        vector<ll> q1;
        dist1[a] = 0;
        ll u1 = 0;
        p1[a] = -1;
        q1.push_back(a);
        while (u1 < q1.size()) {
            ll v = q1[u1];
            for (auto u : g[v]) {
                if (dist1[u] > dist1[v] + 1) {
                    dist1[u] = dist1[v] + 1;
                    q1.push_back(u);
                    p1[u] = v;
                }
            }
            u1++;
        }
        vector<ll> path1;
        ll emae = b;
        while (emae != -1) {
            path1.push_back(emae);
            emae = p1[emae];
        }
        vector<ll> dist2(n, INF), p2(n);
        vector<ll> q2;
        dist2[c] = 0;
        ll u2 = 0;
        p2[c] = -1;
        q2.push_back(c);
        while (u2 < q2.size()) {
            ll v = q2[u2];
            for (auto u : g[v]) {
                if (dist2[u] > dist2[v] + 1) {
                    dist2[u] = dist2[v] + 1;
                    q2.push_back(u);
                    p2[u] = v;
                }
            }
            u2++;
        }
        vector<ll> path2;
        emae = d;
        while (emae != -1) {
            path2.push_back(emae);
            emae = p2[emae];
        }
        for (ll j = 0; j < path1.size(); ++j) {
            unionset(path1[j], path2[j]);
        }
        ll ans = 1;
        for (ll j = 0; j < n; ++j) {
            if (vec[j].size() > 0) {
                ll mx = -1, mn = MOD;
                for (auto e : vec[j]) {
                    mx = max(mx, l[e]);
                    mn = min(mn, r[e]);
                }
                ans = (ans * max(0LL, (mn - mx + 1))) % MOD;
            }
        }
        cout << ans << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}