#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

vector<ll> p(MAXN);
vector<ll> sz(MAXN);
vector<ll> l(MAXN);
vector<ll> r(MAXN);
vector<ll> d(MAXN);
vector<ll> g[MAXN];

void dfs(ll v) {
    for (auto u : g[v]) {
        d[u] = d[v] + 1;
        dfs(u);
    }
}

vector<vector<ll>> jump(21, vector<ll> (MAXN));

ll getroot(ll v) {
    if (p[v] == v) return v;
    else return p[v] = getroot(p[v]);
}

void unionset(ll u, ll v) {
    u = getroot(u);
    v = getroot(v);
    if (u != v) {
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);
    }
}

ll up(ll v, ll k) {
    for (ll i = 20; i > -1; --i) {
        if (k & (1 << i)) v = jump[i][v];
    }
    return v;
}

ll LCA(ll u, ll v) {
    if (d[u] > d[v]) u = up(u, d[u] - d[v]);
    if (d[v] > d[u]) v = up(v, d[v] - d[u]);
    if (u != v) {
        for (ll i = 20; i > -1; --i) {
            if (jump[i][u] != jump[i][v]) {
                u = jump[i][u];
                v = jump[i][v];
            }
        }
        return jump[0][u];
    } else {
        return u;
    }
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) p[i] = i, sz[i] = 1;
    vector<ll> pr(n);
    for (ll i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        jump[0][i] = pr[i];
        g[pr[i]].push_back(i);
    }
    dfs(0);
    for (ll i = 1; i < 21; ++i) {
        for (ll j = 0; j < MAXN; ++j) {
            jump[i][j] = jump[i - 1][jump[i - 1][j]];
        }
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    for (ll i = 0; i < n; ++i) p[i] = i, sz[i] = 1;
    ll m;
    cin >> m;
    for (ll i = 0; i < m; ++i) {
        ll A, B, C, D;
        cin >> A >> B >> C >> D;
        A--, B--, C--, D--;
        vector<ll> path1, obr;
        ll ver1 = LCA(A, B);
        while (A != ver1) {
            path1.push_back(A);
            A = jump[0][A];
        }
        while (B != ver1) {
            obr.push_back(B);
            B = jump[0][B];
        }
        obr.push_back(ver1);
        for (ll j = obr.size() - 1; j > -1; --j) path1.push_back(obr[j]);
        obr.clear();

        vector<ll> path2;
        ll ver2 = LCA(C, D);
        while (C != ver2) {
            path2.push_back(C);
            C = jump[0][C];
        }
        while (D != ver2) {
            obr.push_back(D);
            D = jump[0][D];
        }
        obr.push_back(ver2);
        for (ll j = obr.size() - 1; j > -1; --j) path2.push_back(obr[j]);
        for (ll j = 0; j < path1.size(); ++j) {
            unionset(path1[j], path2[j]);
        }
        ll ans = 1;
        for (ll j = 0; j < n; ++j) {
            if (p[j] == j) {
                ans = (ans * max(0LL, (r[j] - l[j] + 1))) % MOD;
            }
        }
        cout << ans << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}