#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

vector<int> p(MAXN);
vector<int> sz(MAXN);
vector<int> l(MAXN);
vector<int> r(MAXN);
vector<int> d(MAXN);
vector<int> g[MAXN];

void dfs(int v) {
    for (auto u : g[v]) {
        d[u] = d[v] + 1;
        dfs(u);
    }
}

vector<vector<int>> jump(21, vector<int> (MAXN));

int getroot(int v) {
    if (p[v] == v) return v;
    else return p[v] = getroot(p[v]);
}

void unionset(int u, int v) {
    u = getroot(u);
    v = getroot(v);
    if (u != v) {
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);
    }
}

int up(int v, int k) {
    for (int i = 20; i > -1; --i) {
        if (k & (1 << i)) v = jump[i][v];
    }
    return v;
}

int LCA(int u, int v) {
    if (d[u] > d[v]) u = up(u, d[u] - d[v]);
    if (d[v] > d[u]) v = up(v, d[v] - d[u]);
    if (u != v) {
        for (int i = 20; i > -1; --i) {
            if (jump[i][u] != jump[i][v]) {
                u = jump[i][u];
                v = jump[i][v];
            }
        }
        return jump[0][u];
    } else {
        return u;
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) p[i] = i, sz[i] = 1;
    vector<int> pr(n);
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        jump[0][i] = pr[i];
        g[pr[i]].push_back(i);
    }
    dfs(0);
    for (int i = 1; i < 21; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            jump[i][j] = jump[i - 1][jump[i - 1][j]];
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    for (int i = 0; i < n; ++i) p[i] = i, sz[i] = 1;
    vector<int> path1, obr, path2;
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        path1.clear();
        path2.clear();
        obr.clear();
        int A, B, C, D;
        cin >> A >> B >> C >> D;
        A--, B--, C--, D--;
        int ver1 = LCA(A, B);
        while (A != ver1) {
            path1.emplace_back(A);
            A = jump[0][A];
        }
        while (B != ver1) {
            obr.emplace_back(B);
            B = jump[0][B];
        }
        obr.emplace_back(ver1);
        for (int j = obr.size() - 1; j > -1; --j) path1.push_back(obr[j]);
        obr.clear();

        int ver2 = LCA(C, D);
        while (C != ver2) {
            path2.emplace_back(C);
            C = jump[0][C];
        }
        while (D != ver2) {
            obr.emplace_back(D);
            D = jump[0][D];
        }
        obr.emplace_back(ver2);
        for (int j = obr.size() - 1; j > -1; --j) path2.push_back(obr[j]);
        for (int j = 0; j < path1.size(); ++j) {
            unionset(path1[j], path2[j]);
        }
        ll ans = 1;
        for (int j = 0; j < n; ++j) {
            if (p[j] == j) {
                ans = (ans * max(0LL, (ll)(r[j] - l[j] + 1))) % MOD;
            }
        }
        cout << ans << '\n';
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}