#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <chrono>
#include <ctime>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <limits>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <functional>
#include <random>
#include <cassert>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 200007;
const ll K = 40007;
const ll LG = 21;
ll n, m, k;
vector<int>g[N];
int p[N];
int sz[N];
int up[N][LG];
int tin[N], tout[N];
int timer = 0;
int l[N], r[N];
ll t[4 * N];
vector<pair<int, int>>val;

void build(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = 1;
	}
	else {
		int tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = (t[2 * v] * t[2 * v + 1]) % MOD;
	}
}

void update(int v, int tl, int tr, int ind, ll vl) {
	if (tl == tr) {
		t[v] = vl;
	}
	else {
		int tm = (tl + tr) / 2;
		if (tm >= ind) {
			update(2 * v, tl, tm, ind, vl);
		}
		else {
			update(2 * v + 1, tm + 1, tr, ind, vl);
		}
		t[v] = (t[2 * v] * t[2 * v + 1]) % MOD;
	}
}

void make_set(int v) {
	p[v] = v;
	sz[v] = 1;
	val[v].ff = l[v];
	val[v].ss = r[v];
	update(1, 1, n, v, r[v] - l[v] + 1);
}

int find_set(int v) {
	if (p[v] == v)return v;
	return p[v] = find_set(p[v]);
}

void union_sets(int v, int u) {
	//cout << "KPAN: " << u << ", " << v << endl;
	v = find_set(v);
	u = find_set(u);
	if (u != v) {
		if (sz[u] > sz[v]) {
			swap(u, v);
		}
		sz[v] += sz[u];
		p[u] = v;
		sz[u] = 0;
		update(1, 1, n, u, 1);
		if (val[u].ff > val[v].ff || val[u].ss < val[v].ss) {
			val[v].ff = max(val[v].ff, val[u].ff);
			val[v].ss = min(val[v].ss, val[u].ss);
			update(1, 1, n, v, val[v].ss - val[v].ff + 1);
		}
	}
}

void dfs(int v, int par) {
	up[v][0] = par;
	tin[v] = timer++;
	for (int to : g[v]) {
		if (to != par) {
			dfs(to, v);
		}
	}
	tout[v] = timer++;
}

bool is_papa(int v, int u) {
	return (tin[v] <= tin[u] && tout[v] >= tout[u]);
}

void precalc() {
	dfs(1, 1);
	for (int i = 1; i < LG; i++) {
		for (int v = 1; v <= n; v++) {
			up[v][i] = up[up[v][i - 1]][i - 1];
		}
	}
}

int lca(int v, int u) {
	if (is_papa(v, u))return v;
	if (is_papa(u, v))return u;
	for (int i = LG - 1; i >= 0; i--) {
		if (!is_papa(up[v][i], u)) {
			v = up[v][i];
		}
	}
	return up[v][0];
}

void query(int v1, int u1, int v2, int u2) {
	int p1 = lca(v1, u1);
	int p2 = lca(v2, u2);
	while (v1 != p1 && v2 != p2) {
		union_sets(v1, v2);
		v1 = up[v1][0];
		v2 = up[v2][0];
	}
	union_sets(v1, v2);
	while (u1 != p1 && u2 != p2) {
		union_sets(u1, u2);
		u1 = up[u1][0];
		u2 = up[u2][0];
	}
	union_sets(u1, u2);
	//cout << "DOPOLN\n";
	stack<int>st;
	if (v1 != p1) {
		while (v1 != p1) {
			v1 = up[v1][0];
			st.push(v1);
		}
		while (u2 != p2) {
			union_sets(u2, st.top());
			st.pop();
			u2 = up[u2][0];
		}
	}
	else if (v2 != p2) {
		while (v2 != p2) {
			v2 = up[v2][0];
			st.push(v2);
		}
		while (u1 != p1) {
			union_sets(u1, st.top());
			st.pop();
			u1 = up[u1][0];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	val.resize(n + 1, { -1,-1 });
	for (int i = 2; i <= n; i++) {
		int x;
		cin >> x;
		g[i].push_back(x);
		g[x].push_back(i);
	}
	build(1, 1, n);
	precalc();
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		make_set(i);
	}
	cin >> m;
	for (int i = 0; i < m; i++) {
		int v1, u1, v2, u2;
		cin >> v1 >> u1 >> v2 >> u2;
		query(v1, u1, v2, u2);
		cout << t[1] << endl;
	}
}
