#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define nit long long
#define int long long
vector<vector<int>> up;
vector<int> tin, tout;
vector<vector<int>> graph;
int tim = 0;
vector<int> p, sz;

int get(int v) {
    if (p[v] == v)return v;
    return p[v] = get(p[v]);
}

void union_(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b)return;
    if (sz[a] > sz[b]) {
        sz[a] += sz[b];
        p[b] = a;
    } else {
        sz[b] += sz[a];
        p[a] = b;
    }
}

void dfs(nit v, int p) {
    tin[v] = tim++;
    up[v][0] = p;
    for (int i = 1; i < 31; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (int u: graph[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = tim++;

}

bool is_upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (is_upper(a, b)) return a;
    if (is_upper(b, a)) return b;
    for (int i = 30; i >= 0; --i) {
        if (!is_upper(up[a][i], b)) {
            a = up[a][i];
        }
    }
    return up[a][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    graph.resize(n);
    tin.resize(n);
    tout.resize(n);
    up.resize(n, vector<int>(31));
    for (int i = 0; i < n - 1; ++i) {
        int j;
        cin >> j;
        graph[j - 1].push_back(i + 1);
    }
    dfs(0, 0);
    vector<pair<int, int>> zap(n);
    for (int i = 0; i < n; ++i) {
        cin >> zap[i].first >> zap[i].second;
    }
    sz.resize(n, 1);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    int m;
    cin >> m;
    set<int>k;
    for (int i = 0; i < n; ++i) {
        k.insert(i);
    }
    bool t = true;
    for (int i = 0; i < m; ++i) {
        if (!t){
            cout << 0 << "\n";
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int h = lca(a, b);
        vector<nit> patha1, patha2;
        while (a != h) {
            patha1.push_back(a);
            a = up[a][0];
        }
        patha1.push_back(h);
        while (h != b) {
            patha2.push_back(b);
            b = up[b][0];
        }
        reverse(patha2.begin(), patha2.end());
        vector<int> patha(patha1.size() + patha2.size());
        for (int j = 0; j < patha1.size(); ++j) {
            patha[j] = patha1[j];
        }
        for (int j = 0; j < patha2.size(); ++j) {
            patha[j + patha1.size()] = patha2[j];
        }
        int f = lca(c, d);
        vector<nit> pathc1, pathc2;
        while (c != f) {
            pathc1.push_back(c);
            c = up[c][0];
        }
        pathc1.push_back(f);
        while (f != d) {
            pathc2.push_back(d);
            d = up[d][0];
        }
        reverse(pathc2.begin(), pathc2.end());
        vector<int> pathc(pathc1.size() + pathc2.size());
        for (int j = 0; j < pathc1.size(); ++j) {
            pathc[j] = pathc1[j];
        }
        for (int j = 0; j < pathc2.size(); ++j) {
            pathc[j + pathc1.size()] = pathc2[j];
        }
        for (int j = 0; j < patha.size(); ++j) {
            int v, u;
            v = patha[j], u = pathc[j];
            v = get(v), u = get(u);
            k.erase(v);
            k.erase(u);
            int l = max(zap[v].first, zap[u].first), r = min(zap[v].second, zap[u].second);
            union_(v, u);
            k.insert(get(v));
            zap[get(v)] = {l, r};
        }
        int ans = 1;
        for (int j:k) {
            if (zap[j].second-zap[j].first+1) {
                ans = ((zap[j].second - zap[j].first+1)*ans)%(1000000007);
            }else {
                t = false;
                cout << 0 << "\n";
                break;
            }
        }
        if (t){
            cout << ans << '\n';
        }
    }

}
