#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int lvl[200005];
int d[20][200005];
vector<int> a[200005];
int prv[200005];
void dfs(int v, int p) {
	prv[v] = p;
	if (p == -1) {
		d[0][v] = v;
		lvl[v] = 0;
	}
	else {
		d[0][v] = p;
		lvl[v] = lvl[p] + 1;
	}
	for (int i = 1; i < 20; i++) {
		d[i][v] = d[i - 1][d[i - 1][v]];
	}
	for (auto h : a[v]) {
		if (h != p) {
			dfs(h, v);
		}
	}
}
int up(int v, int num) {
	int cur = 0;
	while (num > 0) {
		if (num % 2 == 1) {
			v = d[cur][v];
		}
		cur++;
		num /= 2;
	}
	return v;
}

int lca(int a, int b) {
	if (lvl[a] < lvl[b]) {
		swap(a, b);
	}
	a = up(a, lvl[a] - lvl[b]);
	if (a == b)
		return a;
	for (int j = 19; j >= 0; j--) {
		if (d[j][a] != d[j][b]) {
			a = d[j][a];
			b = d[j][b];
		}
	}
	return d[0][a];
}


vector<int> p(200005), h(200005), mnm(200005), mxm(200005);;
const long long mod = 1e9 + 7;
long long ans = 1;
long long ansdivide = 1;
int getp(int v) {
	if (p[v] == v) {
		return v;
	}
	return p[v] = getp(p[v]);
}
void unite(int aa, int bb) {
	aa = getp(aa);
	bb = getp(bb);
	if (aa == bb)
		return;
	if (h[aa] < h[bb]) {
		swap(aa, bb);
	}

	if (h[aa] == h[bb]) {
		h[aa]++;
	}
	p[bb] = aa;
	if (ans != 0) {
		int old = mxm[aa] - mnm[aa] + 1;
		int old2 = mxm[bb] - mnm[bb] + 1;
		mxm[aa] = min(mxm[aa], mxm[bb]);
		mnm[aa] = max(mnm[aa], mnm[bb]);

		ansdivide *= old;
		ansdivide %= mod;
		ansdivide *= old2;
		ansdivide %= mod;

		if (mxm[aa] < mnm[aa]) {
			ans = 0;
		}
		else {
			int nw = mxm[aa] - mnm[aa] + 1;
			ans *= nw;
			ans %= mod;
		}
	}
}

long long binpow(long long v, int deg) {
	if (deg == 0)
		return 1;
	if (deg == 1)
		return v;
	if (deg % 2 == 1)
		return (v * binpow(v, deg - 1)) % mod;
	long long temp = binpow(v, deg / 2);
	return (temp * temp) % mod;
}

const int prm = 227;
vector<int> degs(600000);
int n; vector<int> hd(1000000), rhd(1000000);

vector<vector<int> > list(500000);


pair<int,int>  ask(vector<int> &d,int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return { 0,0 };
	}
	if (l >= askl && r <= askr) {
		return { r - l + 1,d[v] };
	}
	auto aa = ask(d,2 * v + 1, l, (l + r) / 2, askl, askr);
	auto bb = ask(d,2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	return { aa.first + bb.first,(aa.second + (bb.second * degs[aa.first])) % mod };

}
void set(vector<int>& d, int v, int l,int r, int pos, int val) {
	if (l > pos || r < pos)
		return;
	if (l == r && l == pos) {
		d[v] = val;
		return;
	}
	set(d,2 * v + 1, l, (l + r) / 2, pos, val);
	set(d,2 * v + 2, (l + r) / 2 + 1, r, pos, val);
	int m = (l + r) / 2;
	d[v] =( d[2 * v + 1] + d[2 * v + 2] * degs[(m - l + 1)])%mod;
	return;
}


void unite2(int aa, int bb) {
	aa = getp(aa);
	bb = getp(bb);
	if (aa == bb)
		return;
	if (h[aa] < h[bb]) {
		swap(aa, bb);
	}
	h[aa] += h[bb];
	p[bb] = aa;
	for (auto hh : list[bb]) {
		list[aa].push_back(hh);
		set(hd, 0, 0, n - 1, hh, aa+1);
		set(rhd, 0, 0, n - 1, n - hh - 1, aa+1);
	}
	if (ans != 0) {
		int old = mxm[aa] - mnm[aa] + 1;
		int old2 = mxm[bb] - mnm[bb] + 1;
		mxm[aa] = min(mxm[aa], mxm[bb]);
		mnm[aa] = max(mnm[aa], mnm[bb]);

		ansdivide *= old;
		ansdivide %= mod;
		ansdivide *= old2;
		ansdivide %= mod;

		if (mxm[aa] < mnm[aa]) {
			ans = 0;
		}
		else {
			int nw = mxm[aa] - mnm[aa] + 1;
			ans *= nw;
			ans %= mod;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);


	cin >> n;
	bool locok = 1;
	for (int i = 1; i < n; i++) {
		int t1;
		cin >> t1;
		if (t1 != i)
			locok = 0;
		t1--;
		a[t1].push_back(i);
	}


	if (locok) {
		degs[0] = 1;
		for (int i = 1; i < 600000; i++) {
			degs[i] = degs[i - 1] * prm;
			degs[i] %= mod;
		}
		for (int i = 0; i < n; i++) {
			int ll, rr;
			cin >> ll >> rr;
			mxm[i] = rr;
			mnm[i] = ll;
			ans *= (rr - ll + 1);
			ans %= mod;
			p[i] = i;
			h[i] = 1;
			list[i].push_back(i);
			set(hd, 0, 0, n - 1, i, i+1);
			set(rhd, 0, 0, n - 1, n-1-i, i+1);
		}
		
		int m;
		cin >> m;
		for (int i = 0; i < m; i++) {
			int aaa, bbb, ccc, ddd;
			cin >> aaa >> bbb >> ccc >> ddd;
			aaa--;
			bbb--;
			ccc--;
			ddd--;
			if (aaa > bbb) {
				swap(aaa, bbb);
				swap(ccc, ddd);
			}

			if (ccc >= ddd) {
				int curL = aaa;
				int curR = ccc;
				while (curL <= bbb) {
					int abf = ask(hd, 0, 0, n - 1, 0, curL - 1).second;
					int bbf = ask(rhd, 0, 0, n - 1, 0, n - curR - 2).second;
					int L = -1;
					int R = n;
					while (R - L > 1) {
						int med = (R + L) / 2;
						if (curL + med >= n || curR - med < 0) {
							R = med;
							continue;
						}

						long long aa = ask(hd, 0, 0, n - 1, 0, curL + med).second;
						long long bb = ask(rhd, 0, 0, n - 1, 0, n - curR - 1 + med).second;

						aa -= abf;
						aa += mod;
						aa %= mod;

						bb -= bbf;
						bb += mod;
						bb %= mod;

						if (aa == bb) {
							L = med;
						}
						else {
							R = med;
						}

					}

					int nC = curL + R;
					int nC2 = curR - R;
					if (nC <= bbb) {
						unite2(nC, nC2);
					}
					curL = nC + 1;
					curR = nC2 - 1;
				}
			}
			else {
				int curL = aaa;
				int curR = ccc;
				while (curL <= bbb) {
					int abf = ask(hd, 0, 0, n - 1, 0, curL - 1).second;
					int bbf = ask(hd, 0, 0, n - 1, 0, curR-1).second;
					int L = -1;
					int R = n;
					while (R - L > 1) {
						int med = (R + L) / 2;
						if (curL + med >= n || curR +med >=n) {
							R = med;
							continue;
						}

						long long aa = ask(hd, 0, 0, n - 1, 0, curL + med).second;
						long long bb = ask(hd, 0, 0, n - 1, 0, curR+med).second;

						aa -= abf;
						aa += mod;
						aa %= mod;

						bb -= bbf;
						bb += mod;
						bb %= mod;

						if (aa == bb) {
							L = med;
						}
						else {
							R = med;
						}

					}

					int nC = curL + R;
					int nC2 = curR + R;
					if (nC <= bbb) {
						unite2(nC, nC2);
					}
					curL = nC + 1;
					curR = nC2 + 1;
				}
			}

			
			if (ans == 0) {
				cout << 0 << '\n';
			}
			else {
				cout << (ans * binpow(ansdivide, mod - 2)) % mod << '\n';
			}
		}

		return 0;
	}
	dfs(0, -1);
	for (int i = 0; i < n; i++) {
		int ll, rr;
		cin >> ll >> rr;
		mxm[i] = rr;
		mnm[i] = ll;
		ans *= (rr - ll + 1);
		ans %= mod;
		p[i] = i;
		h[i] = 1;
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		int lca1 = lca(a, b);
		int lca2 = lca(c, d);
		int len = lvl[b] + lvl[a] - 2 * lvl[lca1] + 1;
		vector<int> fins1, fins1s, fins2, fins2s;
		int cur = a;
		while (true) {
			fins1.push_back(cur);

			if (cur == lca1) {
				break;
			}
			cur = prv[cur];
		}
		cur = b;
		while (cur != lca1) {
			fins1s.push_back(cur);
			cur = prv[cur];
		}
		reverse(fins1s.begin(), fins1s.end());
		for (auto h : fins1s) {
			fins1.push_back(h);
		}

		cur = c;
		while (true) {
			fins2.push_back(cur);

			if (cur == lca2) {
				break;
			}
			cur = prv[cur];
		}
		cur = d;
		while (cur != lca2) {
			fins2s.push_back(cur);
			cur = prv[cur];
		}
		reverse(fins2s.begin(), fins2s.end());
		for (auto h : fins2s) {
			fins2.push_back(h);
		}


		for (int pos = 0; pos < len; pos++) {


			unite(fins1[pos], fins2[pos]);

		}
		if (ans == 0) {
			cout << 0 << '\n';
		}
		else {
			cout << (ans * binpow(ansdivide, mod - 2)) % mod << '\n';
		}


	}
}