#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1e9 + 7;
const ll MAXN = 2e5 + 5;
const ll logn = 17;
const ll INF = 2e9;
ll ans = 1;
ll N;

ll t[4 * MAXN];
ll arr[MAXN];

void build(ll v, ll l, ll r) {
    if (l + 1 == r) {
        t[v] = arr[l];
        return;
    }

    ll m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);

    t[v] = (t[2 * v] * t[2 * v + 1]) % MOD;
}

void upd(ll v, ll l, ll r, ll pos, ll x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }

    ll m = (l + r) / 2;
    if (pos < m) {
        upd(2 * v, l, m, pos, x);
    } else {
        upd(2 * v + 1, m, r, pos, x);
    }

    t[v] = (t[2 * v] * t[2 * v + 1]) % MOD;
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (qr <= l || r <= ql) {
        return 1;
    }

    if (ql <= l && r <= qr) {
        return t[v];
    }

    ll m = (l + r) / 2;
    return (get(2 * v, l, m, ql, qr) * get(2 * v + 1, m, r, ql, qr)) % MOD;
}

vector<ll> g[MAXN];
ll used[MAXN], up[MAXN][logn];
ll tin[MAXN], tout[MAXN];

ll timer = 0;
void dfs(ll v) {
    used[v] = 1;
    tin[v] = timer++;

    for (ll i = 1; i < logn; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }

    for (auto to : g[v]) {
        if (!used[to]) {
            up[to][0] = v;
            dfs(to);
        }
    }

    tout[v] = timer++;
}

bool is_ancestor(ll u, ll v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

ll lca(ll u, ll v) {
    if (is_ancestor(u, v)) {
        return u;
    }
    if (is_ancestor(v, u)) {
        return v;
    }

    for (ll i = logn - 1; i >= 0; --i) {
        if (!is_ancestor(up[u][i], v)) {
            u = up[u][i];
        }
    }

    return up[u][0];
}

ll pr[MAXN];
ll p[MAXN], sz[MAXN];
pair<ll, ll> r[MAXN];
set<ll> kek;
void build(ll n) {
    for (ll i = 0; i < n; ++i) {
        p[i] = i;
        kek.insert(i);
        sz[i] = 1;
    }
}

ll getRoot(ll v) {
    if (p[v] == v) {
        return v;
    }

    return p[v] = getRoot(p[v]);
}

void merge(ll v, ll u) {
    v = getRoot(v), u = getRoot(u);
    if (v == u) {
        return;
    }

    if (sz[v] > sz[u]) {
        swap(v, u);
    }

    r[u] = {max(r[v].first, r[u].first), min(r[v].second, r[u].second)};
    r[v] = {0, 0};
    upd(1, 0, N, u, max(0ll, r[u].second - r[u].first + 1));
    upd(1, 0, N, v, 1);
    ans = get(1, 0, N, 0, N);

    sz[u] += sz[v];
    p[v] = u;
}

int main() {
    ll n;
    cin >> n;
    N = n;
    build(n);
    for (ll i = 1; i < n; ++i) {
        ll par;
        cin >> par;
        --par;
        g[par].push_back(i);
        g[i].push_back(par);
        pr[i] = par;
    }
    dfs(0);

    for (ll i = 0; i < n; ++i) {
        cin >> r[i].first >> r[i].second;
        arr[i] = (r[i].second - r[i].first + 1);
    }
    build(1, 0, n);
    ans = get(1, 0, n, 0, n);

    ll m;
    cin >> m;
    for (ll i = 0; i < m; ++i) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        if (ans <= 0) {
            cout << ans << '\n';
            continue;
        }

        ll lca1 = lca(a, b), lca2 = lca(c, d);
        vector<ll> tmp1;
        while (a != lca1) {
            tmp1.push_back(a);
            a = pr[a];
        }
        tmp1.push_back(lca1);
        vector<ll> tmp3;
        while (b != lca1) {
            tmp3.push_back(b);
            b = pr[b];
        }
        reverse(tmp3.begin(), tmp3.end());
        for (auto x : tmp3) {
            tmp1.push_back(x);
        }

        vector<ll> tmp2;
        while (c != lca2) {
            tmp2.push_back(c);
            c = pr[c];
        }
        tmp2.push_back(lca2);
        vector<ll> tmp4;
        while (d != lca2) {
            tmp4.push_back(d);
            d = pr[d];
        }
        reverse(tmp4.begin(), tmp4.end());
        for (auto x : tmp4) {
            tmp2.push_back(x);
        }

        for (ll j = 0; j < (ll)tmp1.size(); ++j) {
            merge(tmp1[j], tmp2[j]);
        }

        cout << ans << '\n';
    }

    return 0;
}
