#include <bits/stdc++.h>

#define int long long
#define l first
#define r second

using namespace std;

const int MOD = 1e9 + 7;

vector<int> dsu_p, dsu_h;
vector<pair<int, int>> dsu_res;

void make_dsu(int n) {
    dsu_p.resize(n);
    dsu_h.resize(n);
    dsu_res.resize(n);
    for (int i = 0; i < n; i++)
        dsu_p[i] = i;
}

int dsu_get_parent(int a) {
    if (dsu_p[a] == a)
        return a;
    return dsu_p[a] = dsu_get_parent(dsu_p[a]);
}

void dsu_union(int a, int b) {
    a = dsu_get_parent(a);
    b = dsu_get_parent(b);
    if (a == b)
        return;
    int res_l = max(dsu_res[a].l, dsu_res[b].l),
    res_r = min(dsu_res[a].r, dsu_res[b].r);
    if (dsu_h[a] < dsu_h[b])
        swap(a, b);
    dsu_p[b] = a;
    dsu_res[a].l = res_l;
    dsu_res[a].r = res_r;
    if (dsu_h[a] == dsu_h[b])
        dsu_h[a]++;
}

int dsu_get_mult(int n) {
    vector<bool> used(n);
    int res = 1;
    for (int i = 0; i < n; i++) {
        int a = dsu_get_parent(i);
        if (used[a])
            continue;
        used[a] = true;
        res = (res * max((int)0, dsu_res[a].r - dsu_res[a].l + 1)) % MOD;
    }
    return res;
}

int k, t = 0;
vector<vector<int>> g, up;
vector<bool> used;
vector<int> tin, tout;

void dfs(int v) {
    for (int i = 1; i < k; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    used[v] = true;
    tin[v] = t++;
    for (int u : g[v]) {
        if (used[u])
            continue;
        up[u][0] = v;
        dfs(u);
    }
    tout[v] = t++;
}

bool is_ancestor(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
    if (is_ancestor(a, b))
        return a;
    if (is_ancestor(b, a))
        return b;
    if (a == b)
        return a;
    int i = k - 1;
    while (i > 0) {
        while (i > 0 && is_ancestor(up[a][i], b)) {
            if (is_ancestor(up[a][0], b))
                return up[a][0];
            i--;
        }
        if (is_ancestor(up[a][0], b))
            return up[a][0];
        a = up[a][i];
    }
    return up[a][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    k = __lg(n) + 2;
    up.resize(n, vector<int>(k));
    vector<int> parent(n);
    used.resize(n);
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    make_dsu(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        parent[i] = p - 1;
        g[p - 1].push_back(i);
        g[i].push_back(p - 1);
    }
    dfs(0);
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].l >> p[i].r;
        p[i].l--;
        p[i].r--;
        dsu_res[i].l = p[i].l;
        dsu_res[i].r = p[i].r;
    }
    int m;
    cin >> m;
    vector<int> dir_a, dir_b, dir_c, dir_d, dir1, dir2;
    while (m--) {
        int a, b, c, d, r1, r2;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        r1 = lca(a, b);
        r2 = lca(c, d);
        dir1.clear();
        dir2.clear();
        dir_a.clear();
        dir_b.clear();
        dir_c.clear();
        dir_d.clear();
        while (a != r1) {
            dir_a.push_back(a);
            a = parent[a];
        }
        dir_a.push_back(r1);
        while (b != r1) {
            dir_b.push_back(b);
            b = parent[b];
        }
        reverse(dir_b.begin(), dir_b.end());
        for (int i : dir_a)
            dir1.push_back(i);
        for (int i : dir_b)
            dir1.push_back(i);


        while (c != r2) {
            dir_c.push_back(c);
            c = parent[c];
        }
        dir_c.push_back(r2);
        while (d != r2) {
            dir_d.push_back(d);
            d = parent[d];
        }
        reverse(dir_d.begin(), dir_d.end());
        for (int i : dir_c)
            dir2.push_back(i);
        for (int i : dir_d)
            dir2.push_back(i);
        for (int i = 0; i < dir1.size(); i++) {
            dsu_union(dir1[i], dir2[i]);
        }
        cout << dsu_get_mult(n) << "\n";
    }
}