#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O2")

//#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back

//const int inf=1e18;
const int mod=1e9+7;
int n=2e5;
const int N=2e5;

int pw(int a, int b) {
	int r=1;
	while (b) {
		if (b&1) r=(1ll*r*a)%mod;
		a=(1ll*a*a)%mod;
		b>>=1;
	}
	return r;
}

int ans=1;
int inv(int x) {
	if (x==0) return 0;
	return pw(x,mod-2);
}

vector<pi> seg(n);

inline pi inter(pi a, pi b) {
	if (a.f==-1 || b.f==-1) return {-1,-2};
	if (a.f>b.f) swap(a,b);
	if (a.f==b.f) return {a.f,min(b.s,a.s)};
	if (a.s<b.f) return {-1,-2};
	return {b.f,min(a.s,b.s)};
}

vector<vector<int>> adj(n);
int par[N];
int sz[N];
int d[N];
int to[N];
int top[N];

void dfs(int u) {
	sz[u]=1;
	int mx=-1;
	for(auto&v:adj[u]) {
		d[v]=d[u]+1;
		dfs(v);
		sz[u]+=sz[v];
		if (mx==-1) mx=v;
		if (sz[v]>sz[mx]) mx=v;
	}
	to[u]=mx;
}
void dfs2(int u, int t) {
	top[u]=t;
	if (to[u]!=-1) dfs2(to[u],t);
	for(auto&v:adj[u]) {
		if (v==to[u]) continue;
		dfs2(v,v);
	}
}

int lca(int u, int v) {
	while (top[u]!=top[v]) {
		if (d[top[u]]<d[top[v]]) swap(u,v);
		u=par[top[u]];
	}
	if (d[u]<d[v]) swap(u,v);
	return v;
}

void print(pi f, pi s, pi t) {
	cout<<'['<<f.f<<','<<f.s<<"] u ["<<s.f<<','<<s.s<<"] = ["<<t.f<<','<<t.s<<"]\n";
}

struct DSU {
	vector<int> p,sz,r;
	DSU(int n) {
		p.assign(n,0);
		sz.assign(n,1);
		r.assign(n,0);
		forn(i,n) p[i]=i;
	}
	int get(int u) {
		return (p[u]==u)?u:get(p[u]);
	}
	void uni(int u, int v) {
		//u=get(u), v=get(v);
		//if (u==v) return;
		if (r[u]==r[v]) ++r[u];
		if (r[u]<r[v]) swap(u,v);
		p[v]=u;
		sz[u]+=sz[v];
	}
};
DSU dsu(n);

void merge(int a, int b) {
	int u=dsu.get(a);
	int v=dsu.get(b);
	if (u==v) return;
	pi sg=inter(seg[u],seg[v]);
	//print(seg[u],seg[v],sg);
	ans=(1ll*ans*inv(seg[u].s-seg[u].f+1))%mod;
	ans=(1ll*ans*inv(seg[v].s-seg[v].f+1))%mod;
	ans=(1ll*ans*(sg.s-sg.f+1))%mod;
	dsu.uni(u,v);
	seg[u]=seg[v]=sg;
}

void solve() {

	d[0]=0;

	int n; cin>>n;
	forn(i,n-1) {
		int p; cin>>p;
		par[i+1]=--p;
		adj[p].pb(i+1);
	}
	dfs(0);
	dfs2(0,0);

	forn(i,n) cin>>seg[i].f>>seg[i].s;
	forn(i,n) ans=(1ll*ans*(seg[i].s-seg[i].f+1))%mod;

	int m; cin>>m;
	while (m--) {
		int a,b,x,y; cin>>a>>b>>x>>y; --a,--b,--x,--y;
		int l1=lca(a,b), l2=lca(x,y);

		pi sg;
		int dist=d[a]+d[b]-2*d[l1]+1;
		vector<pi> walk(dist);
		int i=0;
		while (a!=l1) {
			walk[i++].f=a;
			a=par[a];
		}
		i=dist-1;
		while (b!=l1) {
			walk[i--].f=b;
			b=par[b];
		}
		walk[i].f=l1;
		i=0;
		while (x!=l2) {
			walk[i++].s=x;
			x=par[x];
		}
		i=dist-1;
		while (y!=l2) {
			walk[i--].s=y;
			y=par[y];
		}
		walk[i].s=l2;

		forn(i,dist) {
			merge(walk[i].f,walk[i].s);
		}
		cout<<ans<<'\n';
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t
	while (t--) solve();
	return 0;
}