#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

vector<vector<int>> edge;
vector<int> st, p, sz, L, R, maxl, minr;
int n, m;

void dfs(int u, int p, int last) {
    st.push_back(u);
    if (st.back() == last) {
        return;
    }
    for (int v : edge[u]) {
        if (v != p) {
            dfs(v, u, last);
            if (st.back() == last) {
                return;
            }
        }
    }
    st.pop_back();
}

vector<int> get_path(int a, int b) {
    st.clear();
    dfs(a, a, b);
    return st;
}

int get_p(int u) {
    if (p[u] == u) {
        return u;
    }
    return p[u] = get_p(p[u]);
}

void unite(int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }
    sz[u] += sz[v];
    p[v] = u;
    minr[u] = min(minr[u], minr[v]);
    maxl[u] = max(maxl[u], maxl[v]);
}

ll solve(int a, int b, int c, int d) {
    vector<int> path1 = get_path(a, b);
    vector<int> path2 = get_path(c, d);
    for (int i = 0; i < (int)path1.size(); ++i) {
        unite(path1[i], path2[i]);
    }
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        int P = get_p(i);
        if (i != P) {
            continue;
        }
        if (maxl[i] > minr[i]) {
            ans = 0;
        } else {
            ans = ans * (ll)(minr[i] - maxl[i] + 1) % MOD;
        }
    }
    return ans;
}

void solve() {
    cin >> n;
    p.resize(n);
    iota(all(p), 0);
    sz.resize(n, 1);
    L.resize(n);
    R.resize(n);
    edge.resize(n);
    for (int i = 1; i < n; ++i) {
        int p; cin >> p; --p;
        edge[p].push_back(i);
        edge[i].push_back(p);
    }
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    maxl = L;
    minr = R;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        cout << solve(a, b, c, d) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}