#include "bits/stdc++.h"
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

//using namespace __gnu_pbds;
//using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int MAXN = 200005;
int p[MAXN];
vector<int> graph[MAXN];
int h[MAXN];
int l[MAXN], r[MAXN];

constexpr int MOD = 1000000007;

void dfs(int v) {
    for (int ch : graph[v]) {
        h[ch] = h[v] + 1;
        dfs(ch);
    }
}


namespace nhash {
    constexpr int BASE = 239017, HASH_MOD = 998244353;
    constexpr array<int, MAXN> get_pw() {
        array<int, MAXN> res{};
        res[0] = 1;
        for (int i = 1; i < MAXN; ++i) {
            res[i] = (res[i - 1] * 1ll * BASE) % HASH_MOD;
        }
        return res;
    }
    constexpr array<int, MAXN> PW = get_pw();

    struct Node {
        int sz;
        int val, rval;
        Node operator+(const Node &other) const {
            return Node{sz + other.sz,
                        (int)((val * 1ll * PW[other.sz] + other.val) % HASH_MOD),
                        (int)((other.rval * 1ll * PW[sz] + rval) % HASH_MOD)
            };
        }
    };

    constexpr int R = 1 << 18;
    Node tree[R << 1];

    void upd(int pos, int val) {
        pos += R;
        tree[pos] = Node{1, val};
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = tree[2 * pos] + tree[2 * pos + 1];
        }
    }

    Node get(int l, int r) {
        Node lnode{0, 0}, rnode{0, 0};
        for (l += R, r += R; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                lnode = lnode + tree[l++];
            }
            if (r & 1) {
                rnode = tree[--r] + rnode;
            }
        }
        return lnode + rnode;
    }
};

int pathbuf[4][MAXN];

constexpr inline int invert(int a) {
    ll res = 1;
    for (int shift = 29; shift >= 0; --shift) {
        res = res * res % MOD;
        if ((MOD - 2) >> shift & 1) {
            res = res * a % MOD;
        }
    }
    return res;
};

int ans = 1;
struct StasDSU {
    vector<int> dsu;
    vector<vector<int>> sus;
    StasDSU(int n) {
        dsu.resize(n, -1);
        sus.resize(n);
        for (int i = 0; i < n; ++i) {
            sus[i].push_back(i);
        }
    }
    int get_root(int v) {
        if (dsu[v] < 0) {
            return v;
        }
        return dsu[v] = get_root(dsu[v]);
    }
    void unite(int u, int v) {
        u = get_root(u);
        v = get_root(v);
        if (u == v) {
            return;
        }
        if (dsu[u] < dsu[v]) {
            swap(u, v);
        }
        if (dsu[u] == dsu[v]) {
            --dsu[v];
        }
        ans = (ans * 1ll * invert(r[u] - l[u] + 1)) % MOD;
        ans = (ans * 1ll * invert(r[v] - l[v] + 1)) % MOD;
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);
        if (l[v] > r[v]) {
            ans = 0;
        } else {
            ans = (ans * 1ll * (r[v] - l[v] + 1)) % MOD;
        }
        dsu[u] = v;
        sus[v].resize(sus[v].size() + sus[u].size());
        for (int w : sus[u]) {
            sus[v].push_back(w);
            nhash::upd(w, v);
        }
//        sus[u].clear();
    }
};

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        cin >> p[i];
        graph[p[i]].push_back(i);
    }
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
        ans = ans * 1ll * (r[i] - l[i] + 1) % MOD;
    }
    StasDSU dsu(n + 1);
    int m;
    cin >> m;

    bool is_p_ok = true;
    for (int i = 2; i <= n; ++i) {
        if (p[i] != i - 1) {
            is_p_ok = false;
            break;
        }
    }

    if (false && is_p_ok) {
        for (int qi = 0; qi < m; ++qi) {
            if (ans == 0) {
                cout << "0\n";
                continue;
            }
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            if (a > b) {
                swap(a, b);
                swap(c, d);
            }
            if (c <= d) {
                for (int p = 0; p <= b - a; ++p) {
                    if (dsu.get_root(a + p) == dsu.get_root(c + p)) {
                        int lg = p, rg = b - a + 1;
                        while (rg - lg > 1) {
                            int mg = (lg + rg) / 2;
                            if (nhash::get(a + p, a + mg + 1).val == nhash::get(c + p, c + mg + 1).val) {
                                lg = mg;
                            } else {
                                rg = mg;
                            }
                        }
                        p = lg;
                    } else {
                        dsu.unite(a + p, c + p);
                    }
                }
            } else {
                for (int p = 0; p <= b - a; ++p) {
                    if (dsu.get_root(a + p) == dsu.get_root(c - p)) {
                        int lg = p, rg = b - a + 1;
                        while (rg - lg > 1) {
                            int mg = (lg + rg) / 2;
                            if (nhash::get(a + p, a + mg + 1).val == nhash::get(c - mg, c - p + 1).rval) {
                                lg = mg;
                            } else {
                                rg = mg;
                            }
                        }
                        p = lg;
                    } else {
                        dsu.unite(a + p, c - p);
                    }
                }
            }
            cout << ans << '\n';
        }
        return 0;
    }

    for (int qi = 0; qi < m; ++qi) {
        if (ans == 0) {
            cout << "0\n";
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int pptr[4] = {0, 0, 0, 0};
        while (h[a] > h[b]) {
            pathbuf[0][pptr[0]++] = a;
            //assert(a != 0);
            a = p[a];
        }
        while (h[b] > h[a]) {
            pathbuf[1][pptr[1]++] = b;
            //assert(b != 0);
            b = p[b];
        }
        while (h[c] > h[d]) {
            pathbuf[2][pptr[2]++] = c;
            c = p[c];
        }
        while (h[d] > h[c]) {
            pathbuf[3][pptr[3]++] = d;
            d = p[d];
        }
        while (a != b) {
            pathbuf[0][pptr[0]++] = a;
            pathbuf[1][pptr[1]++] = b;
            //assert(a * b != 0);
            a = p[a];
            b = p[b];
        }
        pathbuf[0][pptr[0]++] = a;
        //assert(a != 0);
        while (c != d) {
            pathbuf[2][pptr[2]++] = c;
            pathbuf[3][pptr[3]++] = d;
            c = p[c];
            d = p[d];
        }
        pathbuf[2][pptr[2]++] = c;

        reverse(pathbuf[1], pathbuf[1] + pptr[1]);
        reverse(pathbuf[3], pathbuf[3] + pptr[3]);

        memcpy(pathbuf[0] + pptr[0], pathbuf[1], sizeof(pathbuf[0][0]) * pptr[1]);
        memcpy(pathbuf[2] + pptr[2], pathbuf[3], sizeof(pathbuf[0][0]) * pptr[3]);

        int size = pptr[0] + pptr[1];

        for (int v = 0; v < size; ++v) {
            //cerr << "merging " << pathbuf[0][v] << ' ' << pathbuf[2][v];
            dsu.unite(pathbuf[0][v], pathbuf[2][v]);
            //cerr << "\nans=" << ans << '\n';
        }

        cout << ans << '\n';
        //cerr << ">>> ans = " << ans << "\n\n";
    }
    return 0;
}
