//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

const long long MAXN=2e5;
const long long MOD=1e9+7;
vector<vector<long long>> g;
vector<long long> p;
vector<long long> pr;
vector<long long> sz;
vector<long long> l, r;

long long tin[MAXN];
long long tout[MAXN];
long long timer=0;
long long ans = 1;

long long pow(long long a, long long b) {
    if (b==0) {
        return 1;
    }
    if (b%2==0) {
        long long x = pow(a, b/2);
        return x*x%MOD;
    }
    return pow(a,b-1)*a%MOD;
}

void dfs(long long v, long long prev) {
    tin[v]=timer++;

    for (auto u:g[v]) {
        if (u != prev) {
            dfs(u, v);
        }
    }
    tout[v]=timer++;
}

bool is_ancestor(long long v, long long u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

vector<long long> get(long long u, long long v) {
    vector<long long> ans;
    while(true) {
        ans.push_back(u);
        if (is_ancestor(u, v)) {
            break;
        }
        u = p[u];
    }
    return ans;
}

long long get(long long v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = get(pr[v]);
}

void unite(long long a, long long b) {
    a=get(a);
    b=get(b);
    if (a==b) {
        return;
    }
    if (sz[a] < sz[b]) {
        swap(a,b);
    }
    pr[b]= a;
    sz[a] += sz[b];
    ans *= pow(r[a] - l[a]+1, MOD-2);
    ans %= MOD;
    ans *= pow(r[b] - l[b]+1, MOD-2);
    ans %= MOD;
    l[a] = max(l[a], l[b]);
    r[a] = min(r[a], r[b]);
    if (l[a] > r[a]) {
        ans=0;
    }
    ans *= r[a] - l[a]+1;
    ans %= MOD;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    sz.assign(n, -1);
    pr.resize(n);
    for (long long i = 1;i<n;i++) {
        long long x;
        cin >> x;
        x--;
        p[i] = x;
        g[i].push_back(x);
        g[x].push_back(i);

    }
    for (long long i = 0;i<n;i++) {
        cin >> l[i] >> r[i];
        pr[i] = i;
        ans *= r[i]-l[i]+1;
        ans %= MOD;
    }
    dfs(0, 0);
    long long m;
    cin >> m;
    while(m--) {
        long long a,b,c,d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector<long long> path1 = get(a, b);
        vector<long long> path2=get(c, d);
        vector<long long> path3 = get(b, a);
        vector<long long> path4=get(d, c);
        reverse(path3.begin(), path3.end());
        reverse(path4.begin(), path4.end());
        path3.erase(path3.begin());
        path4.erase(path4.begin());
        for (auto e:path3) {
            path1.push_back(e);

        }
        for(auto e:path4) {
            path2.push_back(e);
        }
        for (long long i = 0;i<path1.size();i++) {
            long long u = path1[i];
            long long v = path2[i];
            unite(u, v);
        }
        cout << ans << "\n";
    }
}