//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

const int MAXN=2e5;
const int MOD=1e9+7;
vector<vector<int>> g;
vector<int> p;
vector<int> pr;
vector<int> sz;
vector<int> l, r;

int tin[MAXN];
int tout[MAXN];
int timer=0;
int ans = 1;

int pow(int a, int b) {
    if (b==0) {
        return 1;
    }
    if (b%2==0) {
        int x = pow(a, b/2);
        return (long long)x*(long long)x%(long long)MOD;
    }
    return (long long)pow(a,b-1)*(long long)a%(long long)MOD;
}

void dfs(int v, int prev) {
    tin[v]=timer++;

    for (auto u:g[v]) {
        if (u != prev) {
            dfs(u, v);
        }
    }
    tout[v]=timer++;
}

bool is_ancestor(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

vector<int> get(int u, int v) {
    vector<int> ans;
    while(true) {
        ans.push_back(u);
        if (is_ancestor(u, v)) {
            break;
        }
        u = p[u];
    }
    return ans;
}

int get(int v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = get(pr[v]);
}

void unite(int a, int b) {
    a=get(a);
    b=get(b);
    if (a==b) {
        return;
    }
    if (sz[a] < sz[b]) {
        swap(a,b);
    }
    pr[b]= a;
    sz[a] += sz[b];
    ans = (long long)ans* (long long)pow(r[a] - l[a]+1, MOD-2)%(long long)MOD;
    ans = (long long)ans* (long long)pow(r[b] - l[b]+1, MOD-2)%(long long)MOD;
    l[a] = max(l[a], l[b]);
    r[a] = min(r[a], r[b]);
    if (l[a] > r[a]) {
        ans=0;
    }
    ans = (long long)ans*(long long)(r[a] - l[a]+1)%(long long)MOD;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    sz.assign(n, -1);
    pr.resize(n);
    for (int i = 1;i<n;i++) {
        int x;
        cin >> x;
        x--;
        p[i] = x;
        g[i].push_back(x);
        g[x].push_back(i);

    }
    for (int i = 0;i<n;i++) {
        cin >> l[i] >> r[i];
        pr[i] = i;
        ans = (long long)(ans)*(long long)(r[i]-l[i]+1)%(long long)MOD;
    }
    dfs(0, 0);
    int m;
    cin >> m;
    while(m--) {
        int a,b,c,d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector<int> path1 = get(a, b);
        vector<int> path2=get(c, d);
        vector<int> path3 = get(b, a);
        vector<int> path4=get(d, c);
        path3.pop_back();
        path4.pop_back();
        reverse(path3.begin(), path3.end());
        reverse(path4.begin(), path4.end());
        for (auto e:path3) {
            path1.push_back(e);

        }
        for(auto e:path4) {
            path2.push_back(e);
        }
        for (int i = 0;i<path1.size();i++) {
            int u = path1[i];
            int v = path2[i];
            unite(u, v);
        }
        cout << ans << "\n";
    }
}