#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define LL __int128
#define F first
#define S second
mt19937 rnd(100);

ll mod = 1000000007;

ll mult(ll a, ll b) {
    if (b == 1)
        return a;
    ll k = mult(a, b / 2);
    if (b % 2)
        return (((k * k) % mod) * a) % mod;
    else
        return (k * k) % mod;
}

ll obr(ll a) {
    return mult(a, mod - 2);
}

ll timer = 0, a, b, c, d, ans = 1;
vector<vector<ll>> g;
vector<ll> tin, tout, par, lead, sz, l, r, way1, way2;

void build(ll u) {
    tin[u] = timer++;
    for (ll v: g[u])
        build(v);
    tout[u] = timer++;
}

bool upper(ll u, ll v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

ll leader(ll u) {
    if (lead[u] == u)
        return u;
    lead[u] = leader(lead[u]);
    return lead[u];
}

void merge(ll u, ll v) {
    u = leader(u), v = leader(v);
    if (u == v)
        return;
    ans = (((ans * obr(r[u] - l[u] + 1)) % mod) * obr(r[v] - l[v] + 1)) % mod;
    if (sz[u] < sz[v])
        swap(u, v);
    sz[u] += sz[v];
    lead[v] = u;
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    if (r[u] - l[u] + 1 <= 0)
        ans = 0;
    else
        ans = (ans * (r[u] - l[u] + 1)) % mod;
}

void f1(ll u, ll v, vector<ll> &way) {
    way.push_back(u);
    if (!upper(u, v))
        f1(par[u], v, way);
}

void f2(ll u, ll v, vector<ll> &way) {
    if (!upper(u, v)) {
        f2(par[u], v, way);
        way.push_back(u);
    }
}

int main() {
    cin.tie(0), ios_base::sync_with_stdio(0);

    ll n, m;
    cin >> n;

    tin.resize(n);
    tout.resize(n);
    par.resize(n);
    lead.resize(n);
    std::iota(lead.begin(), lead.end(), 0);
    l.resize(n);
    r.resize(n);
    g.resize(n);
    sz.assign(n, 1);


    par[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> par[i], par[i]--;
        g[par[i]].push_back(i);
    }
    build(0);
    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i], ans = (ans * (r[i] - l[i] + 1)) % mod;

    cin >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c >> d, a--, b--, c--, d--;
        way1.clear();
        way2.clear();
        f1(a, b, way1);
        f2(b, a, way1);
        f1(c, d, way2);
        f2(d, c, way2);
        for (int j = 0; j < way1.size(); ++j)
            merge(way1[j], way2[j]);

        cout << ans << '\n';
    }

    return 0;
}
/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

 */
/*


Учимся вставлять массив в последовательность других
При вставке удаляется какой-то префикс нашего массива и префикс следующего
При движении направа удаляемый префикс нашего массива увеличивается, а следующего кменьшается
 */
/*
A:

B:

C:

D:
 Есть набор массивов. Нужно расположить эти массивы так чтобы жадно взятая возростающая последовательность была максимальна.
 */