#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;


//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mod = 1e9 + 7;

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

struct DSU {
	int n;
	vi par, r;

	DSU() {
		
	}

	DSU(int _n) {
		n = _n;
		par = vi(n);
		r = vi(n);
		iota(all(par), 0);
	}

	int get(int x) {
		if (par[x] == x) return x;
		return par[x] = get(par[x]);
	}

	void join(int u, int v) {
		u = get(u);
		v = get(v);
		if (u == v) return;
		if (r[u] > r[v]) swap(u, v);
		if (r[u] == r[v]) r[v]++;
		par[u] = v;
	}
};

int mult(ll a, ll b) {
	return (a * b) % (ll)mod;
}

int add(int a, int b) {
	if (a + b > mod) return a + b - mod;
	if (a + b < 0) return a + b + mod;
	return a + b;
}

int sq(ll a) {
	return mult(a, a);
}

int bin_pow(int a, int b) {
	if (b == 0) return 1;
	if (b % 2 == 1) return mult(bin_pow(a, b - 1), a);
	int res = bin_pow(a, b / 2);
	return sq(res);
}

vvii st;
vvi gr;
int q;
vi ps, path, d, tin, tout, par;
DSU dsu;

void build_st() {
	ps.resize(q + 1);
	int p = 0;
	for (int i = 0; i <= q; i++) {
		if ((1 << (p + 1)) <= i) p++;
		ps[i] = p;
	}
	print(ps);

	st = vvii(ps[q]+1, vii(q));

	for (int i = 0; i < q; i++) {
		st[0][i] = { d[path[i]], i };
	}

	for (int p = 1; p <= ps[q]; p++) {
		for (int i = 0; i < q; i++) {
			st[p][i] = min(st[p - 1][i], st[p - 1][min(i + (1 << (p - 1)), q - 1)]);
		}
	}
}

ii get(int l, int r) {
	int len = r - l;
	int p = ps[len];
	return min(st[p][l], st[p][r - (1 << p)]);
}

void dfs(int u, int p) {
	tin[u] = path.size();
	path.push_back(u);
	for (auto v : gr[u]) {
		if (v == p) continue;
		d[v] = d[u] + 1;
		dfs(v, u);
		path.push_back(u);
	}
	tout[u] = path.size() - 1;
}

int get_lca(int u, int v) {
	if (d[u] > d[v]) swap(u, v);
	if (tin[u] <= tin[v] && tout[v] <= tout[u]) return u;
	if (tin[v] < tout[u]) swap(u, v);
	return path[get(tout[u], tin[v] + 1).second];
}

vii gas;

vi get_path(int u, int v) {
	int lca = get_lca(u, v);
	vi vs;
	while (u != lca) {
		vs.push_back(u);
		u = par[u];
	}
	vs.push_back(lca);
	vi part2;
	while (v != lca) {
		part2.push_back(v);
		v = par[v];
	}
	reverse(all(part2));
	vs.insert(vs.end(), part2.begin(), part2.end());

	return vs;
}

int get_amount(int u) {
	return gas[u].second - gas[u].first + 1;
}

int ans = 1;




void query(int u, int v, int x, int y) {
	vi path1 = get_path(u, v);
	vi path2 = get_path(x, y);

	int devide = 1, multiply = 1;

	int s = path1.size();
	for (int i = 0; i < s; i++) {
		int a = dsu.get(path1[i]), b = dsu.get(path2[i]);
		if (a == b) continue;

		int new_l = max(gas[a].first, gas[b].first);
		int new_r = min(gas[a].second, gas[b].second);
		if (new_l > new_r) {
			multiply = 0;
			break;
		}
		devide = mult(devide, mult(get_amount(a), get_amount(b)));
		multiply = mult(multiply, new_r - new_l + 1);

		dsu.join(a, b);
		int r = dsu.get(a);

		gas[r].first = new_l;
		gas[r].second = new_r;
	}

	ans = mult(ans, mult(bin_pow(devide, mod - 2), multiply));

}

void solve() {
	int n;
	cin >> n;
	gr.resize(n);
	tin.resize(n);
	tout.resize(n);
	d.resize(n);
	par.resize(n, -1);
	gas.resize(n);
	dsu = DSU(n);

	for (int i = 1; i < n; i++) {
		cin >> par[i];
		par[i]--;
		gr[par[i]].push_back(i);
	}

	dfs(0, -1);
	q = path.size();
	print(path);
	print(d);
	build_st();
	

	for (int i = 0; i < n; i++) {
		cin >> gas[i].first >> gas[i].second;
	}

	ans = 1;
	for (int u = 0; u < n; u++) ans = mult(ans, get_amount(u));
	debnl(ans);

	int m;
	cin >> m;
	for (int i = 0; i < m; i++){
		int u1, v1, u2, v2;
		cin >> u1 >> v1 >> u2 >> v2;
		u1--, v1--, u2--, v2--;
		query(u1, v1, u2, v2);

		cout << ans << nl;
	}

}
