#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>
#include <unordered_set>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

const ll MOD = 1e9 + 7;

vector<vector<int> > g;
vector<int> p, l, r, tin, tout;
int t = 0;
vector<unordered_set<int> > e;

void dfs(int v) {
    tin[v] = t++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = t++;
}

vector<int> path1(int a, int b) {
    //cout << a << " " << b << endl;
    vector<int> p1, p2;
    while (!(tin[a] <= tin[b] && tout[b] <= tout[a])) {
        p1.pb(a);
        a = p[a];
    }
    p1.pb(a);
    while (b != a) {
        p2.pb(b);
        b = p[b];
    }
    while (!p2.empty()) {
        p1.pb(p2.back());
        p2.pop_back();
    }
    return p1;
}

vector<int> used;
pair<int, int> dfs2(int v) {
    used[v] = 1;
    pair<int, int> p = mp(l[v], r[v]), q;
    for (auto u : e[v]) {
        if (!used[u]) {
            q = dfs2(u);
            p.F = max(p.F, q.F);
            p.S = min(p.S, q.S);
        }
    }
    return p;
}

signed main() {
    int n; cin >> n;
    p.resize(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    int m; cin >> m;
    e.resize(n);
    while (m--) {
        int a, b, c, d; 
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> p1 = path1(a, b), p2 = path1(c, d); 
        for (int i = 0; i < p1.size(); i++) {
            e[p1[i]].insert(p2[i]);
            e[p2[i]].insert(p1[i]);
        }
        used.assign(n, 0);
        int cnt = 1;
        pair<int, int> p;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                p = dfs2(i);
                cnt = (cnt * (p.S - p.F + 1)) % MOD;
            }
        }
        cout << cnt << "\n";
    }
    return 0;
}