#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>
#include <unordered_set>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

const ll MOD = 1e9 + 7;

vector<vector<ll> > g;
vector<ll> p, l, r, tin, tout;
ll t = 0;
void dfs(ll v) {
    tin[v] = t++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = t++;
}

vector<ll> path1(ll a, ll b) {
    //cout << a << " " << b << endl;
    vector<ll> p1, p2;
    while (!(tin[a] <= tin[b] && tout[b] <= tout[a])) {
        p1.pb(a);
        a = p[a];
    }
    p1.pb(a);
    while (b != a) {
        p2.pb(b);
        b = p[b];
    }
    while (!p2.empty()) {
        p1.pb(p2.back());
        p2.pop_back();
    }
    return p1;
}

vector<int> pr, rn;
vector<pair<int, int> > sg;

int get(int x) {
    //cout << x << " " << pr[x] << endl;
    if (pr[x] == x) return x;
    pr[x] = get(pr[x]);
    return pr[x];
}

void unite(int x, int y) {
    x = get(x);
    y = get(y);
    if (x == y) return;
    if (rn[x] > rn[y]) swap(x, y);
    pr[x] = y;
    rn[y] = max(rn[y], rn[x] + 1);
    sg[y].F = max(sg[y].F, sg[x].F);
    sg[y].S = min(sg[y].S, sg[x].S);
}

signed main() {
    ll n; cin >> n;
    p.resize(n);
    g.resize(n);
    l.resize(n);
    r.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
    }
    dfs(0);
    for (ll i = 0; i < n; i++) cin >> l[i] >> r[i];
    ll m; cin >> m;
    pr.resize(n);
    for (int i = 0; i < n; i++) pr[i] = i;
    rn.resize(n);
    sg.resize(n);
    for (int i = 0; i < n; i++) {
        sg[i].F = l[i];
        sg[i].S = r[i];
    }
    vector<int> used;
    int f = 0;
    while (m--) {
        ll a, b, c, d; 
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<ll> p1 = path1(a, b), p2 = path1(c, d); 
        for (ll i = 0; i < p1.size(); i++) {
            unite(p1[i], p2[i]);
        }
        used.assign(n, 0);
        ll cnt = 1;
        for (int i = 0; i < n; i++) {
            if (f == 1) break;
            int pp = get(i);
            //cout << i << " " << pp << " " << used[pp] << " " << sg[pp].F << " " << sg[pp].S << endl;
            if (!used[pp]) {
                if (sg[pp].S - sg[pp].F + 1 <= 0) f = 1;
                cnt = (cnt * (sg[pp].S - sg[pp].F + 1)) % MOD;
                used[pp] = 1;
            }
        }
        if (f) cnt = 0;
        cout << cnt << "\n";
    }
    return 0;
}