#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
const ll MOD = 1e9 + 7;

vector<vector<int>> g;
vector<int> tin, tout;
vector<int> ind;
vector<int> sz;
vector<ll> l, r;
int curt = 0;
void dfs(int u, int p) {
    tin[u] = curt;
    curt++;
    for (int v : g[u]) {
        if (v != p)
            dfs(v, u);
    }
    tout[u] = curt;
    curt++;
}
bool is_pred(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}
int getcomp(int u) {
    if (ind[u] == u) return u;
    ind[u] = getcomp(ind[u]);
    return ind[u];
}
void my_merge(int u, int v) {
    if (sz[u] > sz[v]) swap(u, v);
    ind[v] = u;
    sz[v] += sz[u];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> par(n);
    tin.resize(n); tout.resize(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
         cin >> par[i];
         par[i]--;
         g[par[i]].push_back(i);
         g[i].push_back(par[i]);
     }
    dfs(0, -1);
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    int m; cin >> m;
    vector<ll> ans(m);
    ind.resize(n);
    sz.resize(n, 1);
    for (int i = 0; i < n; ++i)
        ind[i] = i;
    for (int j = 0; j < m; ++j) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector<int> way1;
        int u = a;
        while (!is_pred(u, b)) {
            way1.push_back(u);
            u = par[u];
        }
        way1.push_back(u);
        vector<int> way2;
        u = b;
        while (!is_pred(u, a)) {
            way2.push_back(u);
            u = par[u];
        }
        reverse(way2.begin(), way2.end());
        for (int el : way2) way1.push_back(el);
        vector<int> way3;
        u = c;
        while (!is_pred(u, d)) {
            way3.push_back(u);
            u = par[u];
        }
        way3.push_back(u);
        vector<int> way4;
        u = d;
        while (!is_pred(u, c)) {
            way4.push_back(u);
            u = par[u];
        }
        reverse(way4.begin(), way4.end());
        for (int el : way4) way3.push_back(el);
        for (int i = 0; i < way1.size(); ++i) {
            int u = getcomp(way1[i]);
            int v = getcomp(way3[i]);
            ll left = max(l[u], l[v]);
            ll right = min(r[u], r[v]);
            l[u] = left; r[u] = right;
            l[v] = left; r[v] = right;
            my_merge(v, u);
        }
        ll cnt = 1;
        for (int i = 0; i < n; ++i) {
            if (ind[i] == i && l[i] > r[i]) {
                cnt = 0;
                break;
            }
            else if (ind[i] == i) {
                cnt = cnt * (r[i] - l[i] + 1) % MOD;
            }
        }
        ans[j] = cnt;
    }
    for (ll el : ans) cout << el << "\n";

    return 0;
}