
#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));

int MOD = 1e9 + 7;
int ans = 1;

int pow(int x, int a) {
    if (a == 0) return 1;
    if (a % 2 == 0) return pow((x * x) % MOD, a / 2);
    return (pow(x, a - 1) * x) % MOD;
}

vector<vector<int>> g;
vector<int> p, sz, cnt;
vector<pair<int, int>> w;

void upd(int a, int b) {
    pii c = { max(w[a].first, w[b].first), min(w[a].second, w[b].second) };
    w[a] = c;
    w[b] = c;
    int cc = max(c.second - c.first + 1, 0ll);
    cnt[a] = cc;
    cnt[b] = cc;
}

int get_p(int v) {
    if (p[v] == v) return v;
    p[v] = get_p(p[v]);
    upd(v, p[v]);
    return p[v];
}

void merge(int v, int u) {
    v = get_p(v);
    u = get_p(u);

    if (v == u) return;

    if (sz[v] < sz[u]) swap(v, u);
    p[u] = v;
    sz[u] = sz[u] + sz[v];
    sz[v] = sz[u];

    ans = (ans * pow(cnt[v], MOD - 2)) % MOD;
    ans = (ans * pow(cnt[u], MOD - 2)) % MOD;
    upd(v, u);
    ans = (ans * cnt[v]) % MOD;
    return;
}

stack<int> r1, r2;
vector<int> used;
int a, b, c, d;

bool dfs(int v, int f) {
    //cout << v << " ";
    used[v] = 1;
    if (f == 1) r1.push(v);
    else r2.push(v);
    if (f == 1 && v == b) return 1;
    if (f == 2 && v == d) return 1;
    for (auto& u : g[v]) {
        if (!used[u]) {
            if (dfs(u, f)) return 1;
        }
    }
    if (f == 1) r1.pop();
    else r2.pop();
    return 0;
}

signed main()
{
    fast;

    int n; cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p0; cin >> p0;
        g[p0 - 1].push_back(i);
        g[i].push_back(p0 - 1);
    }

    vector<int> l(n), r(n);
    cnt.resize(n);
    for (int i = 0; i < n; ++i) {
        int l0, r0;
        cin >> l0 >> r0;
        l[i] = l0;
        r[i] = r0;
        cnt[i] = r0 - l0 + 1;
        ans = (ans * cnt[i]) % MOD;
    }

    int m; cin >> m;
    sz.resize(n);
    w.resize(n);
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        sz[i] = 1;
        w[i] = { l[i], r[i] };
    }

    //cout << ans << endl;
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        //int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        while (r1.size()) r1.pop();
        while (r2.size()) r2.pop();

        used.assign(n, 0);
        dfs(a, 1);
        used.assign(n, 0);
        dfs(c, 2);

        while (r1.size()) {
            merge(r1.top(), r2.top());
            r1.pop();
            r2.pop();
        }

        cout << ans << endl;
    }
}