#include <bits/stdc++.h>
using namespace std;

typedef long double ld;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>
#define size(arr) int(arr.size())

ostream &operator<<(ostream& out, vi a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vi& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream& out, vl a) {
    for (auto u : a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream& in, vl& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}
istream &operator>>(istream& in, pii& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream& in, pll& a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream& out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 5;
const int LOG_N = 21;



vi g[MAX_N];
int parent[MAX_N][LOG_N];
int h[MAX_N];
int p[MAX_N];

void build(int v, int p) {
    parent[v][0] = p;
    for (int i = 1; i < LOG_N; ++i) {
        parent[v][i] = parent[parent[v][i - 1]][i - 1];
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        h[u] = h[v] + 1;
        build(u, v);
    }
}
int lca(int u, int v) {
    if (h[v] < h[u]) swap(v, u);
    for (int i = LOG_N - 1; i >= 0; --i) {
        if (h[parent[v][i]] >= h[u]) {
            v = parent[v][i];
        }
    }
    if (u == v) return u;
    for (int i = LOG_N - 1; i >= 0; --i) {
        if (parent[v][i] != parent[u][i]) {
            v = parent[v][i];
            u = parent[u][i];
        }
    }
    return parent[v][0];
}


int dsu[MAX_N];
int m[MAX_N];
pii interval[MAX_N];
int ans = 1;

pii merge_intervals(pii a, pii b) {
    return {max(a.first, b.first), min(a.second, b.second)};
}

int get_par(int v) {
    if (dsu[v] == v) return v;
    dsu[v] = get_par(dsu[v]);
    return dsu[v];
}

void merge(int u, int v) {
    u = get_par(u);
    v = get_par(v);
    if (u == v) return;
    if (m[u] > m[v]) swap(u, v);
    interval[v] = merge_intervals(interval[v], interval[u]);
    dsu[u] = v;
    m[v] += m[u];
}

vi get_way(int a, int b) {
    int l = lca(a, b);
//    cout << a << " " << b << " " << l << "\n";

    vector<int> first_half;
    while (a != l) {
        first_half.push_back(a);
        a = p[a];
    }
    vector<int> second_half;
    while (b != l) {
        second_half.push_back(b);
        b = p[b];
    }
    vi ans;
    for (auto u : first_half) ans.push_back(u);
    ans.push_back(l);
    reverse(all(second_half));
    for (auto u : second_half) ans.push_back(u);
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
    #define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        dsu[i] = i;
        m[i] = 1;
    }
    p[0] = 0;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> interval[i].first >> interval[i].second;
    }

    for (int i = 0; i < MAX_N; ++i) {
        for (int j = 0; j < LOG_N; ++j) {
            parent[i][j] = 0;
        }
    }

    build(0, 0);
    int T;
    cin >> T;
    int mod = 1e9 + 7;
    while (T--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vi x = get_way(a, b);
        vi y = get_way(c, d);
        for (int i = 0; i < size(x); ++i) {
            merge(x[i], y[i]);
        }
        ll ans = 1;
        for (int i = 0; i < n; ++i) {
            if (i == get_par(i)) {
//                cout << i << " " << interval[i]  << " " << (interval[i].first - interval[i].second + 1)<< "\n";
                ans = ans * (max((interval[i].second - interval[i].first + 1), 0) % mod) % mod;
            }
        }
        cout << ans % mod << "\n";
    }
}
