#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;

ll ans = 1;

vector<int> snm_pr;
vector<pair<ll, ll>> snm_ans;

int snm_get_pr(int v){
    if(snm_pr[v] == v)
        return v;
    return snm_pr[v] = snm_get_pr(snm_pr[v]);
}

bool snm_merge(int a, int b){
    a = snm_get_pr(a);
    b = snm_get_pr(b);
    ans /= snm_ans[a].second - snm_ans[a].first + 1;
    ans /= snm_ans[b].second - snm_ans[b].first + 1;
    ll g1 = max(snm_ans[a].first, snm_ans[b].first);
    ll g2 = min(snm_ans[a].second, snm_ans[b].second);
    if(g2 < g1)
        return false;
    ans *= g2 - g1 + 1;
    snm_pr[a] = b;
    snm_ans[b] = {g1, g2};
    return true;
}

vector<vector<int>> tree;
vector<int> tree_pr;
vector<int> time_over_num;
vector<int> num_over_time;
vector<int> visited;
vector<int> ind_vi;

const int nDeg = 1<<20;
vector<int> t(nDeg * 2, INT_MAX);

void build(int v, int lv, int rv){
    if(lv == rv)
        return;
    int vmid = (lv + rv) / 2;
    build(v * 2, lv, vmid);
    build(v * 2 + 1, vmid + 1, rv);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int get_min(int v, int lv, int rv, int lq, int rq){
    if(lv > rq or rv < lq)
        return INT_MAX;
    if(lv >= lq and rv <= rq){
        return t[v];
    }
    int vmid = (lv + rv)  / 2;
    return min(get_min(v * 2, lv, vmid, lq, rq),
               get_min(v * 2 + 1, vmid + 1, rv, lq, rq));
}

int get_mpr(int a, int b){
    int g1 = min(ind_vi[time_over_num[a]], ind_vi[time_over_num[b]]);
    int g2 = max(ind_vi[time_over_num[a]], ind_vi[time_over_num[b]]);
    return num_over_time[get_min(1, 0, nDeg - 1, g1, g2)];
}

int timer = 0;
void dfs_map(int v, int p){
    time_over_num[v] = timer;
    num_over_time[timer] = v;
    int g = timer++;
    visited.emplace_back(g);
    for(auto u : tree[v]){
        if(u != p) {
            visited.emplace_back(g);
            dfs_map(u, v);
        }
    }
}

auto get_path(int a, int b){
    vector<int> out;
    vector<int> out_rev;
    int mid = get_mpr(a, b);
    while (a != mid){
        out.emplace_back(a);
        a = tree_pr[a];
    }
    while (b != mid){
        out_rev.emplace_back(b);
        b = tree_pr[b];
    }
    out.emplace_back(mid);
    for (int i = 0; i < out_rev.size(); ++i) {
        out.emplace_back(out_rev[out_rev.size() - i - 1]);
    }
    return out;
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n;
    cin >> n;
    tree.assign(n, vector<int>());
    tree_pr.assign(n, 0);
    time_over_num.assign(n, -1);
    num_over_time.assign(n, -1);
    ind_vi.assign(n, -1);
    for (int i = 0; i < n - 1; ++i) {
        int h;
        cin >> h;
        --h;
        tree_pr[i + 1] = h;
        tree[h].emplace_back(i + 1);
    }

    dfs_map(0, -1);
    for (int i = 0; i < visited.size(); ++i) {
        t[nDeg + i] = visited[i];
    }
    build(1, 0, nDeg - 1);

    for (int i = 0; i < visited.size(); ++i) {
        ind_vi[visited[i]] = i;
    }

    snm_pr.assign(n, 0);
    snm_ans.assign(n, {0, 0});
    iota(all(snm_pr), 0);
    for (int i = 0; i < n; ++i) {
        cin >> snm_ans[i].first >> snm_ans[i].second;
        ans *= snm_ans[i].second - snm_ans[i].first + 1;
    }

    int q;
    cin >> q;
    bool ok = true;
    for (int i = 0; i < q; ++i) {
        if(!ok){
            cout << 0 << endl;
            continue;
        }

        int a_st, a_end, b_st, b_end;
        cin >> a_st >> a_end >> b_st >> b_end;
        --a_st, --a_end, --b_st, --b_end;
        auto ap = get_path(a_st, a_end);
        auto bp = get_path(b_st, b_end);
        for (int j = 0; j < ap.size(); ++j) {
            int a = ap[j], b = bp[j];
            if(snm_get_pr(a) == snm_get_pr(b))
                continue;
            bool u = snm_merge(a, b);
            if(!u)
                ok = false;
        }
        ll ans_l = 1;
        vector<bool> was(n, false);
        for (int j = 0; j < n; ++j) {
            int k = snm_get_pr(j);
            if(!was[k])
                ans_l = (ans_l * (snm_ans[k].second - snm_ans[k].first + 1)) % mod;
            was[k] = true;
        }

        if(ok)
            cout << ans_l << endl;
        else
            cout << 0 << endl;
    }
}
