#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
vector<vector<int>> g;
vector<int> par;
vector<pll> prices;
vector<vector<int>> up;
vector<int> tin;
vector<int> tout;
int timer;

struct Node {
    int lead;
    int size;
    pll price;
    Node(int i) {
        lead = i;
        size = 1;
        price = prices[i];
    }
};

vector<Node> un;

int leader(int v) {
    return (un[v].lead == v ? v : un[v].lead = leader(un[v].lead));
}

pll intersect(ll a1, ll b1, ll a2, ll b2) {
    if (a1 == -1 && b1 == -1 || a2 == -1 && b2 == -1) {
        return make_pair(-1, -1);
    }
    if (a1 > a2) {
        swap(a1, a2);
        swap(b1, b2);
    }
    if (a2 >= a1 && b2 <= b1) {
        return make_pair(a2, b2);
    } else if(a2 >= a1 && a2 <= b1) {
        return make_pair(a2, b1);
    } else {
        return make_pair(-1, -1);
    }
}

void unite(int a, int b) {
    a = leader(a);
    b = leader(b);
    if (un[a].size > un[b].size) {
        swap(a, b);
    }
    un[a].lead = b;
    un[b].size += un[a].size;
    un[b].price = intersect(un[b].price.first, un[b].price.second,
                            un[a].price.first, un[a].price.second);

}

void dfs(int v, int p=-1) {
    tin[v] = ++timer;
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = ++timer;
}

bool ancestor(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int lca(int v, int u, int lg) {
    if (ancestor(v, u)) {
        return v;
    }
    if (ancestor(u, v)) {
        return u;
    }
    for (int i = lg; i >= 0; --i) {
        if (!ancestor(up[i][v], u)) {
            v = up[i][v];
        }
    }
    v = up[0][v];
    return v;
}

void init_Lca(int n) {
    dfs(0);
    int lg = __lg(n);
    up.resize(lg + 1, vector<int>(n, -1));
    for (int i = 0; i < lg + 1; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == 0) {
                up[i][j] = par[j];
            } else {
                up[i][j] = up[i - 1][up[i - 1][j]];
            }
        }
    }
}

int main() {
    int n, p;
    timer = 0;
    cin >> n;
    g.resize(n, vector<int>());
    par.resize(n, 0);
    for (int i = 1; i < n; ++i) {
        cin >> p;
        --p;
        par[i] = p;
        g[i].push_back(p);
        g[p].push_back(i);
    }
    tin.resize(n, 0);
    tout.resize(n, 0);
    init_Lca(n);
    ll l, r;
    int lg = __lg(n);
    for (int i = 0; i < n; ++i) {
        cin >> l >> r;
        prices.emplace_back(l, r);
    }
    for (int i = 0; i < n; ++i) {
        un.emplace_back(i);
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        vector<int> way1, way2;
        vector<int> temp1, temp2;
        int x = lca(a, b, lg);
        int y = lca(c, d, lg);
        while (a != x) {
            way1.push_back(a);
            a = par[a];
        }
        way1.push_back(x);
        while (b != x) {
            temp1.push_back(b);
            b = par[b];
        }
        reverse(temp1.begin(), temp1.end());
        for (int i : temp1) {
            way1.push_back(i);
        }
        while (c != y) {
            way2.push_back(c);
            c = par[c];
        }
        way2.push_back(y);
        while (d != y) {
            temp2.push_back(d);
            d = par[d];
        }
        reverse(temp2.begin(), temp2.end());
        for (int i : temp2) {
            way2.push_back(i);
        }
        for (int i = 0; i < way1.size(); ++i) {
            ll k = leader(un[way1[i]].lead);
            ll s = leader(un[way2[i]].lead);
            unite(s, k);
        }
        ll ans = 1;
        int mod = 1e9 + 7;
        unordered_set<int> ch;
        for (int i = 0; i < n; ++i) {
            if (ch.find(leader(un[i].lead)) == ch.end()) {
                Node z = un[leader(un[i].lead)];
                if (z.price.first == -1) {
                    ans = 0;
                } else {x`
                    ans = (ans * (z.price.second - z.price.first + 1)) % mod;
                    ch.insert(leader(un[i].lead));
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}