#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

int n;
int timer = 0;
const int mod = 1e9 + 7;
vector<vector<int>> g;
vector<int> p, sz, num, tin, tout;
vector<pii> c;

void dfs(int v, int pr) {
    tin[v] = timer++;
    for (auto to : g[v])
        if (to != pr)
            dfs(to, v);
    tout[v] = timer++;
}

bool isAncestor(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int bin_pow(int a, int b) {
    if (b == 0) return 1;
    if (b & 1)
        return 1ll * a * bin_pow(a, b - 1) % mod;
    int ans = bin_pow(a, b / 2);
    return 1ll * ans * ans % mod;
}

int get(int v) {
    return p[v] == v ? v : p[v] = get(p[v]);
}

void unite(int a, int b) {
    a = get(a), b = get(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);
    p[b] = a;
    sz[a] += sz[b];
    c[a].ff = max(c[a].ff, c[b].ff);
    c[a].sc = min(c[a].sc, c[b].sc);
    num[a] = max(c[a].sc - c[a].ff + 1, 0);
    num[b] = max(c[a].sc - c[a].ff + 1, 0);
}

int main() {
    fast
//    file_in

    cin >> n;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    vector<int> gp(n);
    for (int i = 1; i < n; ++i) {
        int pr;
        cin >> pr;
        gp[i] = pr - 1;
        g[pr - 1].pb(i);
    }

    dfs(0, 0);
    c.resize(n);
    cin >> c;
    sz.resize(n, 1);
    p.resize(n);
    for (int i = 0; i < n; ++i)
        p[i] = i;
    ll ans = 1;
    num.resize(n);
    for (int i = 0; i < n; ++i) {
        num[i] = c[i].sc - c[i].ff + 1;
        ans = (ans * num[i]) % mod;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int v1, u1, v2, u2;
        cin >> v1 >> u1 >> v2 >> u2;
        --u2; --u1; --v2; --v1;
        vector<int> path1, path2;
        vector<int> b;
        while (!isAncestor(v1, u1)) {
            path1.pb(v1);
            v1 = gp[v1];
        }
        while (u1 != v1) {
            b.pb(u1);
            u1 = gp[u1];
        }
        b.pb(u1);
        for (int j = sz(b) - 1; j >= 0; --j)
            path1.pb(b[j]);
        b.clear();
        while (!isAncestor(v2, u2)) {
            path2.pb(v2);
            v2 = gp[v2];
        }
        while (u2 != v2) {
            b.pb(u2);
            u2 = gp[u2];
        }
        b.pb(u2);
        for (int j = sz(b) - 1; j >= 0; --j)
            path2.pb(b[j]);

        for (int j = 0; j < sz(path1); ++j) {
            int v = get(path1[j]), u = get(path2[j]);
            if (v != u) {
                ans = ans * bin_pow(num[v], mod - 2) % mod * bin_pow(num[u], mod - 2) % mod;
                unite(v, u);
                ans = ans * num[v] % mod;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
