#include <iostream>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

void chmin(int &a, int b) {
	if (a > b) a = b;
}

void chmax(int &a, int b) {
	if (a < b) a = b;
}

int SUM(int a, int b) {
	return (a + b) % mod;
}

int MULT(int a, int b) {
	return (a * b) % mod;
}

struct DSU {
	int n;
	vector<pair<int, int>> vec;
	vector<int> r;
	vector<int> p;

	DSU(int n, vector<pair<int, int>> vec): n(n), vec(vec) {
		r.resize(n, 1);
		p.resize(n, -1);
	}

	int par(int v) {
		if (p[v] == -1) return v;
		return p[v] = par(p[v]);
	}

	bool unite(int a, int b) {
		a = par(a);
		b = par(b);
		if (a == b) return 0;
		if (r[a] < r[b]) swap(a, b);
		chmax(vec[a].first, vec[b].first);
		chmin(vec[a].second, vec[b].second);
		p[b] = a;
		r[a] += r[b];
		return 1;
	}

	int calc() {
		int ans = 1;
		for (int v = 0; v < n; ++v) {
			if (p[v] == -1) {
				ans = MULT(ans, (vec[v].first <= vec[v].second ? vec[v].second - vec[v].first + 1 : 0));
			}
		}
		return ans;
	}
};

vector<vector<int>> g;

bool seek(int v, int p, int t, vector<int> &path) {
	if (v == t) return 1;
	for (int u: g[v]) if (u != p) {
		path.push_back(u);
		if (seek(u, v, t, path)) return 1;
		path.pop_back();
	}
	return 0;
}

signed main() {
	int n, m;
	cin >> n;
	g.assign(n, vector<int>(0));
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
		g[i].push_back(p);
	}
	vector<pair<int, int>> vec(n);
	for (auto &[a, b]: vec) cin >> a >> b;
	DSU dsu(n, vec);
	int lol = 0;
	cin >> m;
	for (int t = 0; t < m; ++t) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a; --b; --c; --d;
		vector<int> pathab, pathcd;
		pathab.push_back(a);
		pathcd.push_back(c);
		seek(a, -1, b, pathab);
		seek(c, -1, d, pathcd);
		for (int i = 0; i < pathab.size(); ++i) {
			dsu.unite(pathab[i], pathcd[i]);
		}
		cout << dsu.calc() << endl;
	}
}