#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <iostream>
#include <fstream>
#include <climits>
using namespace std;
#define int long long
vector <int> t;
vector <int> used;
vector <vector <int>> g;
vector <int> pred;
vector <int> de;
vector <int> a;
const int del = 1e9 + 7;
void dfs(int v,int kol) {
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++) {
        if (used[g[v][i]]!=1 && de[g[v][i]]>kol+1) {
            de[g[v][i]] = kol+1;
            pred[g[v][i]] = v;
            dfs(g[v][i],kol+1);
        }
    }
}
void build(int v, int l, int r) {
    if (l > r)
        return;
    if (l == r) {
        t[v] = a[l];
        return;
    }
    int q = (l + r) / 2;
    build(v * 2 + 1, l, q);
    build(v * 2 + 2, q + 1, r);
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}
int get(int v, int l, int r, int tl, int tr) {
    if (l == tl && r == tr) {
        return t[v];
    }
    int q = (l + r) / 2;
    if (q < tl) {
        return get(v * 2 + 2, q + 1, r, q+1, tr);
    }
    if (tr <= q) {
       return  get(v * 2 + 1, l, q, tl, q);
    } 
    return get(v * 2 + 1, l, q, tl, q) + get(v * 2 + 2, q + 1, r, q + 1, tr);
}
void update(int v, int l, int r, int tl, int tr,int new1) {
    if (tl == l && tr == r) {
        t[v] = new1;
        return;
    }
    int q = (l + r) / 2;
    if (l < tl) {
           update(v * 2 + 2, q + 1, r, tl, tr,new1);
    }
    if (tr <= q) {
        update(v * 2 + 1, l, q, tl, tr,new1);
    }
    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}
/*
* ifstream cin("");
    int n;
    cin >> n;
    a.resize(n);
    t.resize(n * 4);
    for (int i = 0; i < n; i++)cin >> a[i];
    build(0, 0, n - 1);
    update(0, 0, n - 1, 4, 4, 10);
   cout << get(0, 0, n - 1, 2, 4);
*/

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    pred.resize(n);
    de.resize(n,LLONG_MAX-1);
    vector <int> p(n);
    used.resize(n);
    g.resize(n);
    for (int i = 1; i <= n - 1; i++) {
        cin >> p[i];
        g[p[i] - 1].push_back(i);
        g[i].push_back(p[i] - 1);  

    }
    vector <pair <int, int>> lr(n);
    for (int i = 0; i < n; i++) {
        cin >> lr[i].first >> lr[i].second;
    }
    int m;
    cin >> m;
    int kol = 0;
    vector <int> t1;
    vector <int> t2;
    vector <int> megaused(n);
    for (int i = 0; i < m; i++) {
        t1.clear();
        t2.clear();
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        if (!(a == b && c == d)) {
            pred.assign(n, -1);
            de.assign(n, LLONG_MAX - 1);
            used.assign(n, 0);
            dfs(a, 0);
            int v = b;
            t1.push_back(v);
            while (pred[v] != a) {
                v = pred[v];
                t1.push_back(v);
            }
            t1.push_back(pred[v]);
            pred.assign(n, -1);
            de.assign(n, LLONG_MAX - 1);
            used.assign(n, 0);
            dfs(c, 0);
            v = d;
            t2.push_back(v);
            while (pred[v] != c) {
                v = pred[v];
                t2.push_back(v);
            }
            t2.push_back(pred[v]);
            reverse(t1.begin(), t1.end());
            reverse(t2.begin(), t2.end());
            megaused.assign(n, 0);
            for (int i = 0; i < t1.size(); i++) {
                megaused[t1[i]] = 1;
                megaused[t2[i]] = 1;
            }
            int sum = 1;
            int flag = 0;
            set <pair <int, int>> q;
            for (int i = 0; i < t1.size(); i++) {
                pair <int, int> r = { min(t1[i],t2[i]),max(t1[i],t2[i]) };
                if (q.find(r) == q.end()) {
                    q.insert(r);
                }
                else
                    continue;
                if (lr[t1[i]].second < lr[t2[i]].first || lr[t2[i]].first > lr[t1[i]].second) {
                    flag = 1;
                    break;
                }
                sum *= min(lr[t1[i]].second, lr[t2[i]].second) - max(lr[t1[i]].first, lr[t2[i]].first)+1;
                lr[t1[i]].second = min(lr[t1[i]].second, lr[t2[i]].second);
                lr[t2[i]].second = min(lr[t1[i]].second, lr[t2[i]].second);
                lr[t1[i]].first= max(lr[t1[i]].first, lr[t2[i]].first);
                lr[t2[i]].first = max(lr[t1[i]].first, lr[t2[i]].first);
            }
            if (flag == 1) {
                cout << 0<<endl;
                continue;
            }
            for (int i = 0; i < n; i++) {
                if(megaused[i]==0){
                    sum *= lr[i].second - lr[i].first + 1;
                }
            }
        cout << sum<<endl;
        }
        else {
            if (lr[a].second < lr[c].first || lr[a].first > lr[c].second) {
                cout << 0 << endl;
                continue;
            }
            int sum = min(lr[a].second, lr[c].second) - max(lr[a].first, lr[c].first)+1;
            for (int i = 0; i < n; i++) {
                if (i != a && i != c) {
                    sum *= lr[i].second - lr[i].first + 1;
                }
            }
            cout << sum << endl;
        }
    }
}
