#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

vector<int> p, s, le, ri;

int find(int x) {
  if (x == p[x]) return x;
  return p[x] = find(p[x]);
}

void unite(int x, int y) {
  //x = find(x), y = find(y);
  if (x == y) return;
  if (s[x] < s[y]) swap(x, y);
  s[x] += s[y];
  p[y] = x;
  le[x] = max(le[x], le[y]);
  ri[x] = min(ri[x], ri[y]);
}

const int md = int(1e9) + 7;

ll pw(ll n, int p) {
  if (p == 0) return 1;
  if (p == 1) return n;
  if (p & 1) return pw(n, p - 1) * n % md;
  ll aux = pw(n, p >> 1);
  return aux * aux % md;
}

ll inv(ll n) {
  return pw(n, md - 2);
}

void solve() {
  int n;
  cin >> n;
  p.resize(n); iota(all(p), 0);
  s.resize(n, 1);
  le.resize(n), ri.resize(n);
  vector<int> par(n), dep(n);
  vector<vector<int>> g(n);
  for (int v = 1; v < n; ++v) {
    int pr;
    cin >> pr;
    --pr;
    par[v] = pr;
    g[pr].push_back(v);
  }
  function<void(int, int)> Dfs = [&](int v, int pr) {
    if (v != 0) dep[v] = dep[pr] + 1;
    for (int u : g[v]) if (u != pr) Dfs(u, v);
  };
  Dfs(0, -1);
  vector<int> l(n), r(n);
  ll ans = 1;
  for (int i = 0; i < n; ++i) {
    cin >> l[i] >> r[i];
    ans *= r[i] - l[i] + 1;
    ans %= md;
    le[i] = l[i];
    ri[i] = r[i];
  }
  int m;
  cin >> m;
  while (m--) {
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    --a, --b, --c, --d;
    if (ans == 0) {
      cout << "0\n";
    }
    vector<int> p11, p12, p21, p22;
    while (dep[a] > dep[b]) {
      p11.push_back(a);
      a = par[a];
    }
    while (dep[b] > dep[a]) {
      p12.push_back(b);
      b = par[b];
    }
    while (a != b) {
      p11.push_back(a);
      p12.push_back(b);
      a = par[a];
      b = par[b];
    }
    p11.push_back(a);
    reverse(all(p12));
    for (int x: p12) {
      p11.push_back(x);
    }
    while (dep[c] > dep[d]) {
      p21.push_back(c);
      c = par[c];
    }
    while (dep[d] > dep[c]) {
      p22.push_back(d);
      d = par[d];
    }
    while (c != d) {
      p21.push_back(c);
      p22.push_back(d);
      c = par[c];
      d = par[d];
    }
    p21.push_back(c);
    reverse(all(p22));
    for (int x: p22) {
      p21.push_back(x);
    }
    for (int i = 0; i < size(p11); ++i) {
      int x = find(p11[i]), y = find(p21[i]);
      if (x != y) {
        ans *= inv(ri[x] - le[x] + 1);
        ans %= md;
        ans *= inv(ri[y] - le[y] + 1);
        ans %= md;
        unite(x, y);
        x = find(x);
        if (le[x] > ri[x]) {
          ans = 0;
          break;
        }
        ans *= ri[x] - le[x] + 1;
        ans %= md;
      }
    }
    /*
    vector<int> used(n);
    for (int i = 0; i < n; ++i) {
      int x = find(i);
      if (used[x]) continue;
      used[x] = 1;
      if (le[x] > ri[x]) ans = 0;
      else ans = (ans * (ri[x] - le[x] + 1)) % md;
    }*/
    cout << ans << '\n';
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}