#include <iostream>
#include "array"
#include "climits"
#include "cmath"
#include "algorithm"
#include "vector"
#include "string"
#include "map"
using namespace std;
typedef long long ll;
int mod = 1e9 + 7;
long long pw(long long a, long long b) {
    ll res = 1;
    while (b) {
        if (b % 2) {
            res = res * a % mod;
        }
        a = a * a % mod;
        b /= 2;
    }
    return res;
}
long long div(long long a) {
    return pw(a, mod - 2);
}

long long seg(pair<int, int> a){
    return max(a.second - a.first + 1, 0);
}
struct dsu {
    long long res = 1;
    vector<int> p;
    vector<vector<int>> el;
    vector<pair<int, int>> pepa;
    void init(int n, vector<pair<int, int>> a) {
        p.assign(n, {});
        el.assign(n, {});
        pepa = a;
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            el[i] = {i};
            res = res * seg(pepa[i]) % mod;
        }
    }
    int getv(int v) {
        if (p[v] == v)
            return v;
        return p[v] = getv(p[v]);
    }
    bool mrg(int a, int b) {
        a = getv(a);
        b = getv(b);
        if (a == b)
            return 0;
        if (el[a].size() > el[b].size())
            swap(a, b);
        p[a] = b;
        res = res * div(seg(pepa[a])) % mod * div(seg(pepa[b])) % mod;
        pepa[b] = {max(pepa[a].first, pepa[b].first), min(pepa[a].second, pepa[b].second)};
        res = res * seg(pepa[b]) % mod;
        for (auto i : el[a])
            el[b].push_back(i);
        el[a].clear();
        return 1;
    }
    int ret() {
        return res;
    }
};
vector<vector<int>> binup;
vector<int> depth;
vector<int> path(int a, int b) {
    vector<int> pt;
    while (a != b) {
        pt.push_back(a);
        a = binup[a][0];
    }
    return pt;
}
int lca(int a, int b) {
    if (depth[a] > depth[b])
        swap(a, b);
    for (int i = 19; i >= 0; --i) {
        if (depth[binup[b][i]] >= depth[a]) {
            b = binup[b][i];
        }
    }
    if (depth[a] != depth[b])
        exit(1);
    if (a == b)
        return a;
    for (int i = 19; i >= 0; --i) {
        if (binup[a][i] != binup[b][i]) {
            a = binup[a][i];
            b = binup[b][i];
        }
    }
    return binup[a][0];
}
vector<int> bgpt(int a, int b) {
    int lc = lca(a, b);
    //cerr << lc << endl << a << ' ' << b << endl;
    vector<int> pt1 = path(a, lc), pt2 = path(b, lc);
    pt1.push_back(lc);
    reverse(pt2.begin(), pt2.end());
    for (auto i : pt2)
        pt1.push_back(i);
    return pt1;
}
dsu usd;
vector<vector<int>> go;
void dfs(int v, int p = 0) {
    depth[v] = depth[p] + 1;
    for (int j = 1; j < 20; ++j) {
        binup[v][j] = binup[binup[v][j-1]][j-1];
    }
    for (auto i : go[v])
        dfs(i, v);
}
void solve() {
    int n;
    cin >> n;
    go.assign(n, {});
    depth.assign(n, {});
    binup.assign(n, vector<int>(20));
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        go[x].push_back(i);
        binup[i][0] = x;
    }
    dfs(0);
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    usd.init(n, a);
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;a--;b--;c--;d--;
        vector<int> fp = bgpt(a, b), sp = bgpt(c, d);
        //cout << fp.size() << ' ' << sp.size() << '\n';
        for (int j = 0; j < fp.size(); ++j) {
            //cout << fp[j] << ' ' << sp[j] << '\n';
            usd.mrg(fp[j], sp[j]);
        }
        cout << usd.ret() << '\n';
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}
