#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define int long long
int maxn = 2e5 + 1, t = 0, mod = 1e9 + 7;
vector<vector<int>> g(maxn), binup(20, vector<int>(maxn, 0)), g1(maxn);
vector<int> tin(maxn), tout(maxn);
vector<pair<int, int>> oil(maxn);

void dfs(int u, int p=-1) {
    tin[u] = t++;
    for (auto it: g[u]) {
        if (it != p) {
            dfs(it, u);
        }
    }
    tout[u] = t++;
}

bool ancestor(int u, int v) {
    return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int lca(int u, int v) {
    if (ancestor(u, v)) return u;
    if (ancestor(v, u)) return v;
    for (int i = 19; i >= 0; --i) {
        int t = binup[i][u];
        if (!ancestor(t, v)) {
            u = t;
        }
    }
    return binup[0][u];
}

int f(int i, int j) {
    oil[i] = {max(oil[i].first, oil[j].first), min(oil[i].second, oil[j].second)};
    oil[j] = oil[i];
    return oil[i].second - oil[i].first + 1;
}

vector<int> path(int u, int v) {
    int lca1 = lca(u, v);
    vector<int> a, b;
    while (u != lca1) {
        a.pb(u);
        u = binup[0][u];
    }
    a.pb(lca1);
    while (v != lca1) {
        b.pb(v);
        v = binup[0][v];
    }
    reverse(b.begin(), b.end());
    for (auto it: b) {
        a.pb(it);
    }
    return a;
}

struct DSU{
    vector<int> p, sz;
    set<int> ppp;
    DSU(int n) {
        sz.assign(n + 1, 1);
        p.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            ppp.insert(i);
            p[i] = i;
        }
    }

    int find_p(int n) {
        if (p[n] == n) return n;
        p[n] = find_p(p[n]);
        return p[n];
    }

    void uni(int a, int b) {
        a = find_p(a);
        b = find_p(b);
        if (a == b) return;
        f(a, b);
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        ppp.erase(b);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    tin[0] = -1e9;
    tout[0] = 1e9;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[i].pb(p);
        g[p].pb(i);
        binup[0][i] = p;
    }
    dfs(1);
    for (int i = 1; i < 20; ++i) {
        for (int j = 1; j <= n; ++j) {
            binup[i][j] = binup[i - 1][binup[i - 1][j]];
        }
    }
    for (int i = 1; i <= n; ++i) {
        int l, r;
        cin >> l >> r;
        oil[i] = {l, r};
    }
    cin >> m;
    DSU tree(n);
    for (int zzz = 0; zzz < m; ++zzz) {
        int a, b, c, d, ans = 1;
        cin >> a >> b >> c >> d;
        vector<int> l1 = path(a, b), l2 = path(c, d);
        for (int i = 0; i < l1.size(); ++i) {
            tree.uni(l1[i], l2[i]);
        }
        for (auto it: tree.ppp) {
            ans = (ans * f(it, it)) % mod;
        }
        cout << max(ans, 0ll) << '\n';
    }
}