#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()

mt19937 rng(time(0));

const int mod = 1e9 + 7;

int mul(int a, int b) {
    return (1ll * a * b) % mod;
}

int binpow(int v, int k) {
    if (k == 0) return 1;
    if (k & 1) return mul(v, binpow(v, k - 1));
    int h = binpow(v, k >> 1);
    return mul(h, h);
}

int inv(int x) {
    return binpow(x, mod - 2);
}

vector<int> p;
vector<pii> range;
int prod = 1;

int get(int v) {
    return (p[v] == v ? v : p[v] = get(p[v]));
}

void join(int v, int u) {
    v = get(v), u = get(u);
    if (v == u) return;
    prod = mul(prod, inv(max(0, range[u].Y - range[u].X + 1)));
    prod = mul(prod, inv(max(0, range[v].Y - range[v].X + 1)));
    p[u] = v;
    range[v].X = max(range[v].X, range[u].X);
    range[v].Y = min(range[v].Y, range[u].Y);
    prod = mul(prod, max(0, range[v].Y - range[v].X + 1));
}

vector<vector<int>> gr;
vector<int> tin, tout, parent;

int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (int u : gr[v])
        dfs(u);
    tout[v] = timer++;
}

bool ancestor(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

vector<int> get(int v, int u) {
    int cur = v;
    vector<int> h1, h2;
    while (!ancestor(cur, u)) {
        h1.push_back(cur);
        cur = parent[cur];
    }
    h1.push_back(cur);
    
    cur = u;
    while (!ancestor(cur, v)) {
        h2.push_back(cur);
        cur = parent[cur];
    }
    reverse(All(h2));
    for (int c : h2)
        h1.push_back(c);
    return h1;
}

void solve() {
    int n, anc, a, b, c, d, l, r;
    cin >> n;

    p.resize(n);
    iota(All(p), 0);

    gr.resize(n);
    parent.resize(n);
    tin.resize(n);
    tout.resize(n);
    range.resize(n);
    
    for (int i = 1; i < n; i++) {
        cin >> anc;
        anc--;
        parent[i] = anc;
        gr[anc].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l >> r;
        range[i] = { l, r };
        prod = mul(prod, r - l + 1);
    }
    int m;
    cin >> m;
    while (m--) {
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto p1 = get(a, b);
        auto p2 = get(c, d);

        for (int i = 0; i < p1.size(); i++) {
            join(p1[i], p2[i]);
        }
        cout << prod << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}