#include <bits/stdc++.h>

using namespace std;
#define int long long

const int M = 1e9 + 7;

struct dsu{
    vector <int> p, r;

    void init(int n){
        p.resize(n);
        for (int i = 0; i < n; ++i){
            p[i] = i;
        }
        r.assign(n, 0);
    }

    int get(int a){
        if (p[a] != a) p[a] = get(p[a]);
        return p[a];
    }

    void join(int a, int b){
        int u = get(a), v = get(b);
        if (u != v){
            if (r[u] > r[v]){
                swap(u, v);
            }
            p[u] = v;
            r[v] = max(r[v], r[u] + 1);
        }
    }
};

int f_p(int a, int n){
    if (n == 1) return a;
    int h = f_p(a, n / 2);
    if (n % 2) return a * h % M * h % M;
    else return h * h % M;
}

void solve(){
    int n;
    cin >> n;
    vector <int> p(n);
    p[0] = -1;
    for (int i = 1; i < n; ++i){
        cin >> p[i];
        p[i]--;
    }
    int ans = 1;
    vector <int> l(n), r(n);
    for (int i = 0; i < n; ++i){
        cin >> l[i] >> r[i];
        ans *= r[i] - l[i] + 1;
        ans %= M;
    }
    int m; cin >> m;

    dsu s;
    s.init(n);

    for (int q = 0; q < m; ++q){
        int a, b, c, d; cin >> a >> b >> c >> d;
        if (ans == 0){
            cout << "0\n";
            continue;
        }
        a--; b--; c--; d--;
        if (a < b) swap(a, b);
        if (c < d) swap(c, d);
        while (a != p[b]){
            int u = s.get(a), g = s.get(c);
            if (u != g){
                if (l[u] > r[g] || l[g] > r[u]){
                    ans = 0;
                    break;
                }
                ans *= f_p(r[u] - l[u] + 1, M - 2);
                ans %= M;
                ans *= f_p(r[g] - l[g] + 1, M - 2);
                ans %= M;
                l[u] = l[g] = max(l[u], l[g]);
                r[u] = r[g] = min(r[u], r[g]);
                ans *= (r[u] - l[u] + 1);
                ans %= M;
                s.join(u, g);
            }
            a = p[a];
            c = p[c];
        }
        cout << ans << "\n";
    }
}

int32_t main(){
ios::sync_with_stdio(false);
cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--){
        solve();
    }
}
