#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

template <int M>
struct Modular{
    int value = 0;
    const static int MOD_value = M;
    Modular (int x) {value = x;}
    Modular (ll x) {value = x % M;}

    Modular& operator+=(Modular x) {value += x.value; if (value >= M) value -= M; return *this;}
    Modular& operator-=(Modular x) {value -= x.value; if (value < 0) value += M; return *this;}
    Modular& operator*=(Modular x) {value = 1ll * value * x.value % M; return *this;}

    static Modular binpow(Modular x, int y) {Modular c = 1; while (y) {if (y & 1) c *= x; y >>= 1; x *= x;} return c;}
    static Modular inverse(Modular x) {return binpow(x, M - 2);}

    friend Modular operator+(Modular x, Modular y) {x += y; return x;}
    friend Modular operator-(Modular x, Modular y) {x -= y; return x;}
    friend Modular operator*(Modular x, Modular y) {x *= y; return x;}

    friend istream& operator>>(istream &is, Modular &x) {is >> x.value; return is;}
    friend ostream& operator<<(ostream &os, Modular x) {os << x.value; return os;}
};
const int M = 1000000007;
using mint = Modular<M>;

const int N = 200010;
int par[N], p[N], rnk[N], l[N], r[N];
mint ans = 1;
vector <int> g[N], b[N];
int h[N];

void dfs(int v){
    if (!b[v].empty()) for (int i = 0; i < b[b[v][i]].size(); i++) b[v].push_back(b[b[v][i]][i]);
    for (auto u : g[v]) h[u] = h[v] + 1, b[u].push_back(v), dfs(u);
}

int la(int v, int h0){
    for (int i = b[v].size() - 1; i >= 0; i--) if (i < b[v].size() && h[b[v][i]] >= h0) v = b[v][i];
    return v;
}

int lca(int v, int u){
    v = la(v, h[u]), u = la(u, h[v]);
    for (int i = b[v].size() - 1; i >= 0; i--) if (i < b[v].size() && b[v][i] != b[u][i]) v = b[v][i], u = b[u][i];
    if (v != u) v = par[v];
    return v;
}

int parent(int v){
    if (p[v] != v) p[v] = parent(p[v]);
    return p[v];
}

void merge(int v, int u){
    v = parent(v), u = parent(u);
    if (v == u) return;
    if (rnk[v] > rnk[u]) swap(v, u);
    p[v] = u;
    rnk[u] = max(rnk[u], rnk[v] + 1);
    if (r[v] > l[v]) ans *= mint::inverse(r[v] - l[v]);
    if (r[u] > l[u]) ans *= mint::inverse(r[u] - l[u]);
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    if (l[u] >= r[v]) ans = 0;
    else ans *= r[u] - l[u];
}

int p1[N], p2[N];

int getpath(int st, int fn, int a[]){
    int lc = lca(st, fn), len = h[st] + h[fn] - 2 * h[lc] + 1, i;
    for (i = 0; st != lc; st = par[st], i++) a[i] = st;
    a[i] = lc;
    for (i = len - 1; fn != lc; fn = par[fn], i--) a[i] = fn;
    return len;
}

void solve(){
    int n, m;
    cin >> n;
    for (int i = 1; i < n; i++) cin >> par[i], par[i]--, g[par[i]].push_back(i);
    dfs(0);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i], l[i]--, ans *= r[i] - l[i];
    iota(p, p + n, 0);
    cin >> m;
    while (m--){
        if (ans.value == 0) {
            cout << 0 << endl;
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int len = getpath(a, b, p1);
        getpath(c, d, p2);
        for (int i = 0; i < len; i++) merge(p1[i], p2[i]);
        cout << ans << endl;
    }
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}