#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

ll bp(ll x, ll p) {
    if (p == 0) {
        return 1ll;
    }
    ll a, b;
    if (p % 2 == 0) {
        a = bp(x, p / 2);
        b = a;
    } else {
        a = bp(x, p - 1);
        b = x;
    }
    return (a * b) % mod;
}

struct DSU {
    vector<int> p;
    vector<int> sz;
    vector<pair<int, int>> tpr;
    ll res = 1;

    DSU() {}

    ll dv(ll a, ll b) {
        // TODO REPLACE BY DIV MOD
        if (b <= 0) {
            return a;
        }
        return (a * bp(b, mod - 2)) % mod;
    }

    ll ml(ll a, ll b) {
        if (b <= 0) {
            return 0;
        }
        return (a * b) % mod;
    }

    DSU(vector<pair<int, int>> tpr) : tpr(tpr) {
        p.resize(tpr.size());
        iota(p.begin(), p.end(), 0);
        sz.resize(tpr.size(), 1);
        for (auto &it: tpr) {
            res = ml(res, it.second - it.first + 1);
        }
    }

    int get(int v) {
        if (p[v] == v)
            return v;
        return p[v] = get(p[v]);
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        res = dv(res, tpr[a].second - tpr[a].first + 1);
        res = dv(res, tpr[b].second - tpr[b].first + 1);
        tpr[a].first = max(tpr[a].first, tpr[b].first);
        tpr[a].second = min(tpr[a].second, tpr[b].second);
        p[b] = a;
        res = ml(res, tpr[a].second - tpr[a].first + 1);
    }
};


struct Solution {
    mt19937 rnd;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    void dfs(vector<vector<int>> &g, vector<int> &dp, int v, int p = -1, int dep = 0) {
        dp[v] = dep;
        for (auto &it: g[v]) {
            if (it != p) {
                dfs(g, dp, it, v, dep + 1);
            }
        }
    }

    signed operator()(int TEST = -1) {
        int n;
        cin >> n;
        constexpr int lgs = 19;
        array<vector<int>, lgs> p;
        p.fill(vector<int>(n, -1));
        vector<vector<int>> g(n);
        for (int i = 1; i < n; ++i) {
            cin >> p[0][i];
            p[0][i]--;
            g[i].push_back(p[0][i]);
            g[p[0][i]].push_back(i);
        }
        for (int i = 1; i < lgs; ++i) {
            for (int v = 0; v < n; ++v) {
                if (p[i - 1][v] != -1) {
                    p[i][v] = p[i - 1][p[i - 1][v]];
                }
            }
        }
        vector<int> dep(n);
        dfs(g, dep, 0);
        auto gt = [&](int a, int b) -> int {
            if (dep[a] < dep[b]) {
                swap(a, b);
            }
            int dlt = dep[a] - dep[b];
            for (int lg = 0; lg < lgs; ++lg) {
                if ((dlt >> lg) & 1) {
                    a = p[lg][a];
                    dlt -= (1 << lg);
                }
            }
            if (a == b) {
                return a;
            }
            for (int lg = lgs - 1; lg >= 0; --lg) {
                if (p[lg][a] != p[lg][b]) {
                    a = p[lg][a];
                    b = p[lg][b];
                }
            }
            return p[0][a];
        };
        vector<pair<int, int>> lmt(n);
        for (auto& it : lmt) {
            cin >> it.first >> it.second;
        }
        DSU unity(lmt);
        int q; cin >> q;
        auto handle = [&](int a, int b) -> vector<int> {
            int lca = gt(a, b);
            vector<int> ptha;
            vector<int> pthb;
            while (a != lca) {
                ptha.push_back(a);
                a = p[0][a];
            }
            while (b != lca) {
                pthb.push_back(b);
                b = p[0][b];
            }
            ptha.push_back(lca);
            for (int & it : std::ranges::reverse_view(pthb)) {
                ptha.push_back(it);
            }
            return ptha;
        };
        while (q--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--; b--; c--; d--;
            vector<int> ar = handle(a, b);
            vector<int> br = handle(c, d);
            for (int i = 0; i < (int)ar.size(); ++i) {
                unity.unite(ar[i], br[i]);
            }
            cout << unity.res << "\n";
        }
        return 0;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
#ifdef ILKRAS
//    cin >> t;
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

