
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return (a - b + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}


/*
map<ll, long double> dp[101];

long double solve(int n, vector<int>& arr, int k, ll tmp, int idx, long double eee) {
	if (dp[idx].find(tmp) != dp[idx].end()) {
		return dp[idx][tmp];
	}
	if (idx == n - 1) {
		ll ooo = (k + tmp - 1) / tmp;
		if (arr[idx] < ooo) {
			return 0;
		}
		else {
			eee *= (int)(arr[idx] / ooo);
			eee /= arr[idx];
			return eee;
		}
	}
	long double mx = 0;
	for (int i = 1; i <= arr[idx]; i++) {
		long double new_eee = eee * (int)(arr[idx] / i);
		new_eee /= arr[idx];
		mx = max(mx, solve(n, arr, k, tmp * i, idx + 1, new_eee));
		if (tmp * i >= k) {
			break;
		}
	}
	return dp[idx][tmp] = mx;
}
*/


vector<int> graph[(int)2e5 + 228];
pair<int, int> arr[(int)2e5 + 228];
int tin[(int)2e5 + 228];
int tout[(int)2e5 + 228];
int up[(int)2e5 + 228][20];
int pr[(int)2e5 + 228];
int timer = 0;

void dfs0(int v, int p = 0) {
	up[v][0] = p;
	tin[v] = timer++;
	for (int i = 1; i < 20; i++) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto to : graph[v]) {
		if (to != p) {
			dfs0(to, v);
		}
	}
	tout[v] = timer++;
}

bool is_pr(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
	if (is_pr(a, b)) return a;
	if (is_pr(b, a)) return b;
	for (int i = 19; i >= 0; i--) {
		if (!is_pr(up[a][i], b)) {
			a = up[a][i];
		}
	}
	return up[a][0];
}

pair<int, pair<int, int>> PRRR[(int)2e5 + 228];
int szz[(int)2e5 + 228];

int get_pr(int v) {
	if (v == PRRR[v].first) {
		return v;
	}
	return get_pr(PRRR[v].first);
}

void merge(int a, int b) {
	int u = get_pr(a), v = get_pr(b);
	if (u != v) {
		if (szz[u] < szz[v]) {
			swap(u, v);
		}
		PRRR[v].first = u;
		szz[u] += szz[v];
		PRRR[u].second.first = max(PRRR[v].second.first, PRRR[u].second.first);
		PRRR[u].second.second = min(PRRR[v].second.second, PRRR[u].second.second);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	for (int i = 1; i < n; i++) {
		cin >> pr[i];
		pr[i]--;
		graph[pr[i]].push_back(i);
		graph[i].push_back(pr[i]);
	}
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
	}
	for (int i = 0; i < n; i++) {
		PRRR[i] = { i, arr[i] };
		szz[i] = 1;
	}
	dfs0(0);
	int m;
	cin >> m;
	vector<bool> used(n);
	vector<bool> used1(n);
	int OOO = 1;
	for (int i = 0; i < n; i++) {
		OOO = mulm(OOO, arr[i].second - arr[i].first + 1, (int)1e9 + 7);
	}
	vector<int> obr(n);
	for (int i = 0; i < n; i++) {
		obr[i] = bin_pow(arr[i].second - arr[i].first + 1, (int)1e9 + 7 - 2, (int)1e9 + 7);
	}
	for (int i = 0; i < m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--, c--, d--;
		vector<int> path1, path2;
		if (true) {
			int v1 = lca(a, b);
			int p = a;
			while (v1 != p) {
				path1.push_back(p);
				p = pr[p];
			}
			path1.push_back(v1);
			vector<int> aaa;
			p = b;
			while (v1 != p) {
				aaa.push_back(p);
				p = pr[p];
			}
			reverse(aaa.begin(), aaa.end());
			for (auto el : aaa) {
				path1.push_back(el);
			}
		}
		if (true) {
			int v1 = lca(c, d);
			int p = c;
			while (v1 != p) {
				path2.push_back(p);
				p = pr[p];
			}
			path2.push_back(v1);
			vector<int> aaa;
			p = d;
			while (v1 != p) {
				aaa.push_back(p);
				p = pr[p];
			}
			reverse(aaa.begin(), aaa.end());
			for (auto el : aaa) {
				path2.push_back(el);
			}
		}
		int res = OOO;
		for (int i = 0; i < path1.size(); i++) {
			int v = get_pr(path1[i]);
			if (!used[v]) {
				used[v] = true;
				res = mulm(res, bin_pow(PRRR[v].second.second - PRRR[v].second.first + 1, (int)1e9 + 5, (int)1e9 + 7), (int)1e9 + 7);
			}
			v = get_pr(path2[i]);
			if (!used[v]) {
				used[v] = true;
				res = mulm(res, bin_pow(PRRR[v].second.second - PRRR[v].second.first + 1, (int)1e9 + 5, (int)1e9 + 7), (int)1e9 + 7);
			}
			merge(path1[i], path2[i]);
		}
		for (auto el : path1) {
			used[get_pr(el)] = false;
		}
		for (auto el : path2) {
			used[get_pr(el)] = false;
		}
		vector<int> fff;
		for (auto el : path1) {
			int v = get_pr(el);
			if (v == el && !used[v]) {
				used[v] = true;
				fff.push_back(v);
				if (PRRR[v].second.first > PRRR[v].second.second) {
					res = 0;
				}
				else {
					res = mulm(res, PRRR[v].second.second - PRRR[v].second.first + 1, (int)1e9 + 7);
				}
			}
		}
		for (auto el : path2) {
			int v = get_pr(el);
			if (v == el && !used[v]) {
				used[v] = true;
				fff.push_back(v);
				if (PRRR[v].second.first > PRRR[v].second.second) {
					res = 0;
				}
				else {
					res = mulm(res, PRRR[v].second.second - PRRR[v].second.first + 1, (int)1e9 + 7);
				}
			}
		}
		for (auto el : fff) {
			used[el] = false;
		}
		cout << res << '\n';
		OOO = res;
	}
	/*int n, k;
	cin >> n >> k;
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	long double eee = k;
	cout << fixed << setprecision(10) << solve(n, arr, k, 1, 0, eee) << '\n';
	*/
	
	
	
	/*int n;
	cin >> n;
	vector<vector<int>> arr(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		arr[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> arr[i][j];
		}
	}
	sort(arr.begin(), arr.end(), [](vector<int> a, vector<int> b) {
		return *max_element(a.begin(), a.end()) < *max_element(b.begin(), b.end()); });
	vector<int> dp(n);
	vector<int> maxx(n);
	for (int i = 0; i < n; i++) {
		maxx[i] = *max_element(arr[i].begin(), arr[i].end());
	}
	for (int i = 0; i < n; i++) {
		int MX = -1;
		for (auto el : arr[i]) {
			if (el > MX) {
				MX = el;
				dp[i]++;
			}
		}
		for (int j = 0; j < i; j++) {
			int MX = maxx[j];
			int cntt = 0;
			for (auto el : arr[i]) {
				if (el > MX) {
					cntt++;
					MX = el;
				}
			}
			dp[i] = max(dp[i], dp[j] + cntt);
		}
	}
	cout << *max_element(dp.begin(), dp.end());*/
}