#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;

using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;

vector<vector<int>> g;
vector<int> p, tin, tout, pp, ran;
vector<pair<int, int>> r, rp;
int tt = 0, ans = 1;

void dfs(int v) {
    tin[v] = tt++;
    for (int i: g[v]) {
        dfs(i);
    }
    tout[v] = tt++;
}

bool par(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

vector<int> find(int a, int b) {
    int v = a;
    vector<int> res, q;
    while (!par(v, b)) {
        res.push_back(v);
        v = p[v];
    }
    res.push_back(v);
    v = b;
    while (!par(v, a)) {
        q.push_back(v);
        v = p[v];
    }
    reverse(q.begin(), q.end());
    for (int i: q) res.push_back(i);
    return res;
}

int find(int v) {
    if (v == pp[v]) return v;
    return pp[v] = find(pp[v]);
}

void merge(int v, int u) {
    if (ans == 0) return;
    v = find(v);
    u = find(u);
    if (v == u) return;
    ans /= (rp[v].second - rp[v].first + 1);
    ans /= (rp[u].second - rp[u].first + 1);
    rp[v] = {max(rp[v].first, rp[u].first), min(rp[u].second, rp[v].second)};
    ans *= (max(0ll, rp[v].second - rp[v].first + 1));
    if (ran[v] < ran[u]) swap(v, u);
    pp[u] = v;
    if (ran[v] == ran[u]) ran[v]++;
}

signed main() {
    int n;
    cin >> n;
    g.resize(n + 1);
    p.resize(n + 1);
    tin.resize(n + 1);
    tout.resize(n + 1);
    r.resize(n + 1);
    rp.resize(n + 1);
    pp.resize(n + 1);
    ran.resize(n + 1, 0);
    for (int i = 0; i < n - 1; i++) {
        int pr;
        cin >> pr;
        p[i + 2] = pr;
        g[pr].push_back(i + 2);
    }
    for (int i = 1; i <= n; i++) {
        int x, y;
        cin >> x >> y;
        r[i] = rp[i] = {x, y};
        ans *= (y - x + 1);
        pp[i] = i;
    }
    dfs(1);
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans==0) {
            cout<<0<<'\n';
            continue;
        }
        vector<int> t = find(a, b);
        vector<int> k = find(c, d);
        for (int i = 0; i < t.size(); i++) {
            merge(t[i], k[i]);
        }
        cout << ans % mod << '\n';
    }
}