#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

const int mod = 1000000007;

set<int> t;

int get(int x, vector<int>& p) {
    if (p[x] == x) {
        return x;
    }
    int y = get(p[x], p);
    p[x] = y;
    return y;
}

void merge(int x, int y, vector<int>& l, vector<int>& r, vector<int>& p, vector<int>& rank) {
    x = get(x, p);
    y = get(y, p);
    if (x == y) {
        return;
    }
    if (rank[x] > rank[y]) {
        p[y] = x;
        l[x] = max(l[x], l[y]);
        r[x] = min(r[x], r[y]);
        t.erase(y);
    } else if (rank[y] > rank[x]) {
        p[x] = y;
        l[y] = max(l[x], l[y]);
        r[y] = min(r[x], r[y]);
        t.erase(x);
    } else {
        p[y] = x;
        l[x] = max(l[x], l[y]);
        r[x] = min(r[x], r[y]);
        rank[x]++;
        t.erase(y);
    }
}

void dfs(int s, int p, vector<vector<int>>& g, vector<int>& deep) {
    if (p == -1) {
        deep[s] = 0;
    } else {
        deep[s] = deep[p] + 1;
    }
    for (int i : g[s]) {
        if (i != p) {
            dfs(i, s, g, deep);
        }
    }
}

void solve() {
    int n, q;
    cin >> n;
    vector<vector<int>> g(n);
    vector<int> l(n), r(n), p(n), rank(n, 0), pr(n), deep(n);
    p[0] = 0;
    t.insert(0);
    pr[0] = -1;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x; x--;
        g[x].push_back(i);
        g[i].push_back(x);
        pr[i] = x;
        p[i] = i;
        t.insert(i);
    }
    dfs(0, -1, g, deep);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d; a--; b--; c--; d--;
        vector<int> path1, path2, path3, path4;
        int x = a, y = b;
        while (x != y) {
            if (deep[x] > deep[y]) {
                path1.push_back(x);
                x = pr[x];
            } else {
                path2.push_back(y);
                y = pr[y];
            }
        }
        path1.push_back(x);
        x = c, y = d;
        while (x != y) {
            if (deep[x] > deep[y]) {
                path3.push_back(x);
                x = pr[x];
            } else {
                path4.push_back(y);
                y = pr[y];
            }
        }
        path3.push_back(x);
        for (int i = path2.size() - 1; i >= 0; i--) {
            path1.push_back(path2[i]);
        }
        for (int i = path4.size() - 1; i >= 0; i--) {
            path3.push_back(path4[i]);
        }
        int m = path1.size();
        for (int i = 0; i < m; i++) {
            merge(path1[i], path3[i], l, r, p, rank);
        }
        int ans = 1;
        for (int i : t) {
            ans *= max(0ll, r[i] - l[i] + 1);
            ans %= mod;
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(100);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}