#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int mod = 1000000007;
int n;
vector<vector<int>> g;
vector<int> p;
vector<pair<int, int>> tim;


int power(int a, int b) {
    if (b == 0) return 1;
    if (b % 2 == 0) {
        int r = power(a, b / 2);
        return r * r % mod;
    }
    return power(a, b - 1) * a % mod;
}

int inv(int x) {
    return power(x, mod - 2);
}

pair<int, int> inter(pair<int, int>& f, pair<int, int>& s) {
    return {max(f.first, s.first), min(f.second, s.second)};
}

int len(pair<int, int>& pr) {
    return pr.second - pr.first;
}

struct DSU {
    int n;
    vector<int> parent, sizes;
    vector<pair<int, int>> q;
    DSU() = default;
    DSU(int _n) {
        n = _n;
        parent.resize(n);
        iota(all(parent), 0);
        sizes.assign(n, 1);
        q.resize(n);
    }
    int find(int u) {
        if (parent[u] == u) return u;
        return parent[u] = find(parent[u]);
    }
    int unite(int u, int v) {
        u = find(u), v = find(v);
        if (u == v) return 1;
        if (sizes[u] < sizes[v]) swap(u, v);
        sizes[u] += sizes[v];
        parent[v] = u;
        int res = inv(len(q[u]) * len(q[v]) % mod);
        q[u] = inter(q[u], q[v]);
        res *= len(q[u]);
        return res % mod;
    }
};

DSU t;
int timer = 0;

void calc(int v, int pr) {
    tim[v].first = timer++;
    for (auto u: g[v]) {
        if (u == pr) continue;
        calc(u, v);
    }
    tim[v].second = timer++;
}

vector<int> path(int ai, int bi) {
    vector<int> a, b;
    bool f = false;
    if (tim[ai].first > tim[bi].first) {
        swap(ai, bi);
        f = true;
    }
    while (tim[ai].second < tim[bi].first) {
        a.push_back(ai);
        ai = p[ai];
    }
    while (tim[ai].first != tim[bi].first) {
        b.push_back(bi);
        bi = p[bi];
    }
    b.push_back(bi);
    reverse(all(b));
    for (auto u: b) a.push_back(u);
    if (f) reverse(all(a));
    return a;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    int res = 1;
    p.resize(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        g[p[i]].push_back(i);
    }
    t = DSU(n);
    for (int i = 0; i < n; ++i) {
        int li, ri; cin >> li >> ri;
        t.q[i] = {li, ri + 1};
        res *= ri - li + 1;
        res %= mod;
    }
    tim.resize(n);
    calc(0, -1);
    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int ai, bi, ci, di;
        cin >> ai >> bi >> ci >> di;
        --ai, --bi, --ci, --di;
        if (res == 0) {
            cout << 0 << '\n';
            continue;
        }
        vector<int> p1 = path(ai, bi), p2 = path(ci, di);
        for (int j = 0; j < p1.size(); ++j) {
            res *= t.unite(p1[j], p2[j]);
            res %= mod;
            if (res == 0) break;
        }
        cout << res << '\n';
    }
}