#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

const int MOD = 1e9 + 7;
inline void add(int& a, int b) {
	if ((a += b) >= MOD)
		a -= MOD;
}
inline int mul(int a, int b) {
	return ((ll)a * b) % MOD;
}

inline int binpow(int a, int n) {
	int res = 1;
	while (n) {
		if (n & 1)
			res = mul(res, a);
		a = mul(a, a);
		n >>= 1;
	}
	return res;
}

int res = 1;

struct dsu {
	vector<int> p, s, l, r;
	dsu(int n) {
		p.resize(n);
		iota(all(p), 0);
		s.resize(n, 1);
	}

	int leader(int i) {
		return p[i] == i ? i : p[i] = leader(p[i]);
	}

	void unite(int a, int b) {
		a = leader(a), b = leader(b);
		if (a == b)
			return;
		if (s[a] > s[b])
			swap(a, b);
		s[b] += s[a];
		p[a] = b;

		res = mul(res, binpow(r[b] - l[b] + 1, MOD - 2));
		res = mul(res, binpow(r[a] - l[a] + 1, MOD - 2));

		l[b] = max(l[b], l[a]);
		r[b] = min(r[b], r[a]);
		r[b] = max(r[b], l[b] - 1);

		res = mul(res, r[b] - l[b] + 1);
	}
};


void solve_case() {
	int n; cin >> n;
	vector<int> p(n), l(n), r(n);
	vector<vector<int>> g(n);
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}

	vector<int> h(n, 0);
	function<void(int)> dfs = [&](int v) {
		for (int u : g[v]) {
			h[u] = h[v] + 1;
			dfs(u);
		}
	};
	dfs(0);

	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
		res = mul(res, r[i] - l[i] + 1);
	}

	dsu D(n);
	D.l = l;
	D.r = r;

	int m; cin >> m;
	while (m--) {
		int a, b, c, d; cin >> a >> b >> c >> d;
		a--; b--; c--; d--;

		if (!res) {
			cout << res << "\n";
			continue;
		}

		vector<int> p1, rp1, p2, rp2;
		for (int useless : { 0, 1 }) {
			while (h[a] > h[b]) {
				p1.push_back(a);
				a = p[a];
			}
			while (h[b] > h[a]) {
				rp1.push_back(b);
				b = p[b];
			}
			while (a != b) {
				p1.push_back(a);
				a = p[a];
				rp1.push_back(b);
				b = p[b];
			}

			p1.push_back(a);
			for (int i = sz(rp1) - 1; i >= 0; i--)
				p1.push_back(rp1[i]);

			swap(a, c);
			swap(b, d);
			swap(p1, p2);
			swap(rp1, rp2);
		}

		for (int i = 0; i < sz(p1); i++) {
			D.unite(p1[i], p2[i]);
		}

		cout << res << "\n";
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
