#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
#define int long long

const int mod = 1e9 + 7;
const int inf = 1e9 + 5;

int sm(int a, int b) {
    return (a + b) % mod;
}

int mlt(int a, int b) {
    return (a * b) % mod;
}

int bp(int a, int n) {
    if (!n)
        return 1;
    if (n & 1)
        return mlt(a, bp(a, n - 1));
    int t = bp(a, n / 2);
    return mlt(t, t);
}

int dv(int a, int b) {
    return mlt(a, bp(b, mod - 2));
}


vector<pair<int, int>> v;
vector<int> curgr;

int res = 1;

struct group {
    int l, r;
    set<int> ind;
    group() {
        l = -inf;
        r = inf;
        res = mlt(res, r - l + 1);
    }
    int size() {
        return (int)ind.size();
    }

    void add(int i) {
        res = dv(res, max(0ll, r - l + 1));
        l = max(l, v[i].first);
        r = min(r, v[i].second);
        ind.insert(i);
        res = mlt(res, max(0ll, r - l + 1));
    }
};



void merge(group &a, group &b, int ai, int bi) {
    if (a.size() >= b.size()) {
        for (auto &i: b.ind) {
            a.add(i);
            curgr[i] = ai;
        }
        res = dv(res, max(0ll, b.r - b.l + 1));
    } else {
        for (auto &i : a.ind) {
            b.add(i);
            curgr[i] = bi;
        }
        res = dv(res, max(0ll, a.r - a.l + 1));
    }
}


vector<vector<int>> gr;
vector<int> p;
vector<int> tin;
vector<int> tout;
int timer = 0;
void dfs(int v) {
    tin[v] = timer++;
    for (auto &x : gr[v])
        dfs(x);
    tout[v] = timer++;
}

bool check(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

vector<int> path(int v, int a, bool c) {
    vector<int> result;
    while (1) {
        if (c)
            result.push_back(v);
        if (check(v, a))
            break;
        if (!c)
            result.push_back(v);
        v = p[v];
    }
    return result;
}

vector<int> get_p(int a, int b) {
    auto p1 = path(a, b, 1);
    auto p2 = path(b, a, 0);
    reverse(p2.begin(), p2.end());
    for (auto &x : p2)
        p1.push_back(x);
    return p1;
}


signed main() {
    int n;
    cin >> n;
    tin.resize(n);
    tout.resize(n);
    gr.resize(n);
    p.resize(n, -1);

    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        gr[p[i]].push_back(i);
    }

    dfs(0);

    v.resize(n);
    for (auto &pr : v) {
        cin >> pr.first >> pr.second;
    }

    vector<group> groups(n);
    curgr.resize(n);
    for (int i = 0; i < n; ++i) {
        groups[i].add(i);
        curgr[i] = i;
    }

    int m; cin >> m;

    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        auto ab = get_p(a, b);
        auto cd = get_p(c, d);

        for (int j = 0; j < (int)ab.size(); ++j) {
            if (curgr[ab[j]] != curgr[cd[j]]) {
                merge(groups[curgr[ab[j]]], groups[curgr[cd[j]]], curgr[ab[j]], curgr[cd[j]]);
            }
        }
        cout << res << '\n';
    }



}