#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
#define ll long long

const ll mod = 1e9 + 7;
const int inf = 1e9 + 5;

inline ll sm(ll a, ll b) {
    return (a + b) % mod;
}

inline ll mlt(ll a, ll b) {
    return (a * b) % mod;
}

inline ll bp(ll a, ll n) {
    if (!n)
        return 1;
    if (n & 1)
        return mlt(a, bp(a, n - 1));
    ll t = bp(a, n / 2);
    return mlt(t, t);
}

inline ll dv(ll a, ll b) {
    return mlt(a, bp(b, mod - 2));
}


vector<pair<int, int>> v;
vector<int> curgr;

ll res = 1;

struct group {
    int l, r;
    vector<int> ind;
    group() {
        l = -inf;
        r = inf;
        res = mlt(res, r - l + 1);
    }
    inline int size() {
        return (int)ind.size();
    }

    inline void add(int i) {
        res = dv(res, max(0, r - l + 1));
        l = max(l, v[i].first);
        r = min(r, v[i].second);
        ind.push_back(i);
        res = mlt(res, max(0, r - l + 1));
    }
};



inline void merge(group &a, group &b, int ai, int bi) {
    if (a.size() >= b.size()) {
        for (auto &i: b.ind) {
            a.add(i);
            curgr[i] = ai;
        }
        res = dv(res, max(0, b.r - b.l + 1));
        b.ind = {};
    } else {
        for (auto &i : a.ind) {
            b.add(i);
            curgr[i] = bi;
        }
        res = dv(res, max(0, a.r - a.l + 1));
        a.ind = {};
    }
}


vector<vector<int>> gr;
vector<int> p;
vector<int> tin;
vector<int> tout;
int timer = 0;
inline void dfs(int v) {
    tin[v] = timer++;
    for (auto &x : gr[v])
        dfs(x);
    tout[v] = timer++;
}

inline bool check(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

inline void path(vector<int> &result, int v, int a, bool c) {
    while (1) {
        if (c)
            result.push_back(v);
        if (check(v, a))
            break;
        if (!c)
            result.push_back(v);
        v = p[v];
    }
}

inline void get_p(vector<int> &p1, int a, int b) {
    path(p1, a, b, 1);
    vector<int> p2;
    path(p2, b, a, 0);
    reverse(p2.begin(), p2.end());
    for (auto &x : p2)
        p1.push_back(x);
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    tin.resize(n);
    tout.resize(n);
    gr.resize(n);
    p.resize(n, -1);

    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        gr[p[i]].push_back(i);
    }

    dfs(0);

    v.resize(n);
    for (auto &pr : v) {
        cin >> pr.first >> pr.second;
    }

    vector<group> groups(n);
    curgr.resize(n);
    for (int i = 0; i < n; ++i) {
        groups[i].add(i);
        curgr[i] = i;
    }

    int m; cin >> m;
    vector<int> ab, cd;
    ab.reserve(n);
    cd.reserve(n);
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        ab = {}; get_p(ab, a, b);
        cd = {}; get_p(cd, c, d);

        for (int j = 0; j < (int) ab.size(); ++j) {
            if (curgr[ab[j]] != curgr[cd[j]]) {
                merge(groups[curgr[ab[j]]], groups[curgr[cd[j]]], curgr[ab[j]], curgr[cd[j]]);
            }
        }
        cout << res << '\n';
    }
}