#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<stack>
#include<queue>

using namespace std;

typedef long long ll;

int mod = 1e9 + 7;

vector<int> rt, tree, h;
vector<vector<int>> g;
vector<pair< int, int>> pa;

int find(int a) {
	if (rt[a] == a) return a;
	return rt[a] = find(rt[a]);
}

void onion(int a, int b) {
	a = find(a);
	b = find(b);
	if (a != b) {
		if (a > b) swap(a, b);
		rt[b] = a;
	}
}

int n;

void dfsh(int pos) {
	for (int i : g[pos]) {
		h[i] = h[pos] + 1;
		dfsh(i);
	}
}

int main() {
	cin >> n;
	h.resize(n);
	g.resize(n);
	pa.resize(n);
	rt.resize(n, 0);
	tree.resize(n);
	for (int i = 1; i < n; ++i) {
		rt[i] = i;
		cin >> tree[i];
		tree[i]--;
		g[tree[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> pa[i].first >> pa[i].second;
	}
	dfsh(0);
	
	int m;
	cin >> m;
	set<int> s;
	for (int i = 0; i < n; ++i) s.insert(i);

	for (int i = 0; i < m; ++i) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		vector<int> al, lb, cl, ld;
		while (a != b) {
			if (h[a] >= h[b]) {
				al.push_back(a);
				a = tree[a];
			}
			else {
				lb.push_back(b);
				b = tree[b];
			}
		}
		al.push_back(a);
		reverse(lb.begin(), lb.end());
		for (int i : lb) al.push_back(i);

		while (c != d) {
			if (h[c] >= h[d]) {
				cl.push_back(c);
				c = tree[c];
			}
			else {
				ld.push_back(d);
				d = tree[d];
			}
		}

		cl.push_back(c);
		reverse(ld.begin(), ld.end());
		for (int i : ld) cl.push_back(i);

		if (al.size() != cl.size()) cout << "feuishfsiugW4hfyuherayufghurehiuehghreuihgrhqe";
		
		for (int i = 0; i < (int)al.size(); ++i) {
			int x = find(al[i]);
			int y = find(cl[i]);
			if (x != y) {
				if (x > y) swap(x, y);
				rt[y] = x;
				pa[x].first = max(pa[x].first, pa[y].first);
				pa[x].second = min(pa[x].second, pa[y].second);
				s.erase(y);
			}
		}

		ll ans = 1;
		for (int i : s) {
			if (pa[i].second - pa[i].first + 1 <= 0) ans = 0;
			ans = (ans * (pa[i].second - pa[i].first + 1)) % mod;
		}

		cout << ans << "\n";
	}
	

}