#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <functional>
#include <climits>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>



const int mod = 1000000007;

using namespace std;


using ll = long long;
using dl = long double;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;



template <typename T, typename S>
istream& operator>>(istream& in, pair<T, S>& a)
{
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream& operator<<(ostream& out, pair<T, S>& a)
{
    out << a.first << ' ' << a.second;
    return out;
}
template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (T& x : a) in >> x;
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T>& a)
{
    for (T& x : a) out << x << ' ';
    return out;
}

template <typename T>
struct VEC
{
    T x, y;
    template <typename S>
    VEC(S _x, S _y): x(_x), y(_y) {};
    VEC() {};

};
template <typename T>
VEC<T> operator+(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x + b.x, a.y + b.y);
}
template <typename T>
VEC<T> operator-(VEC<T>& a, VEC<T>& b)
{
    return VEC<T>(a.x - b.x, a.y - b.y);
}
template <typename T>
ll cross(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.x + a.y*b.y;
}
template <typename T>
ll vecp(VEC<T>& a, VEC<T>& b)
{
    return a.x*b.y - a.y*b.x;
}
template <typename T>
T dist2(VEC<T>& a, VEC<T>& b)
{
    return (a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y);
}
template <typename T>
istream& operator >>(istream& in, VEC<T>& a)
{
    in >> a.x >> a.y;
    return in;
}
template <typename T>
ostream& operator <<(ostream& out, VEC<T>& a)
{
    out << a.x << ' ' << a.y;
    return out;
}

template <typename T>
dl angle(VEC<T>& a, VEC<T>& b)
{
    dl ret = atan2((dl)vecp(a, b), (dl)cross(a, b));
    return ret;
}



ll binpow(ll x, ll p, int m)
{
    if (p == 0) return 1;
    ll ret = binpow(x, p>>1, m);
    ret = ret*ret%m;
    if (p&1) ret = ret*x%mod;
    return ret;
}


struct segmtree
{
    vector<int> tree;
    int size;
    void merge()
    {

    }
    void clear()
    {

    }
    void update()
    {

    }
    segmtree() { }
    void build()
    {

    }

};



signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(18);
    


    int t = 1;
    //cin >> t;
next:
    while (t--)
    {
        int n;
        cin >> n;
        vector<int> parent(n-1);
        cin >> parent;

        vector<pll> lrs(n);
        cin >> lrs;

        int m;
        cin >> m;
        vector<vector<int>> infants(m, vector<int>(4));
        cin >> infants;


        
        vector<int> w(n, 1);
        vector<int> leader(n);
        for (int i = 0; i < n; i++)
        {
            leader[i] = i;
        }
        function<int(int)> lead = [&](int a)
        {
            while (leader[a] != a) a = leader[a];
            return a;
        };
        function<void(int, int)> unite = [&](int a, int b)
        {
            a = lead(a), b = lead(b);
            if (w[a] < w[b]) swap(a, b);
            w[a] += w[b];
            leader[b] = a;
        };
        /*
        vector<set<int>> adj(n, set<int>());
        for (int i = 0; i < n-1; i++)
        {
            adj[parent[i]-1].insert(i);
        }
        */
        vector<vector<int>> adj(n, vector<int>());
        for (int i = 0; i < n-1; i++)
        {
            adj[parent[i]-1].push_back(i+1);
            adj[i+1].push_back(parent[i] - 1);
        }

        vector<int> eul;
        vector<int> tin(n), tout(n);
        vector<int> depth(n);
        int px = 0;
        function<void(int, int, int)> dfs = [&](int start, int prev, int d)
        {
            tin[start] = px;
            depth[start] = d;
            eul.push_back(start);
            ++px;
            bool was = false;
            for (int next : adj[start])
            {
                if (next == prev) continue;
                dfs(next, start, d+1);
                eul.push_back(start);
                ++px;
                was = true;
            }
            if (!was)
            {
                tout[start] = px;
                ++px;
                eul.push_back(start);
            }
            else tout[start] = px - 1;
        };
        dfs(0, -1, 0);


        int lgg = 1;
        int sz = eul.size();
        while ((1 << lgg) <= sz) lgg <<= 1;

        vector<vector<int>> sparse(lgg, vector<int>(sz, INT_MAX/100));
        for (int i = 0; i < sz; i++)
        {
            sparse[0][i] = eul[i];
        }
        for (int i = 1; i < lgg; i++)
        {
            for (int j = 0; j < sz - (1 << i) + 1; j++)
            {
                if (sparse[i - 1][j + (1 << (i-1))] >= n || depth[sparse[i - 1][j]] < depth[sparse[i - 1][j + (1 << (i-1))]])
                {
                    sparse[i][j] = sparse[i - 1][j];
                }
                else sparse[i][j] = sparse[i - 1][j + (1 << (i-1))];
            }
        }

        vector<int> two(1000001, 0);
        for (int i = 1, bt = 1; i < 1000001; i++)
        {
            if (i > bt)
            {
                bt <<= 1;
                two[i] = two[i - 1] + 1;
            }
            else two[i] = two[i - 1];
        }
        

        function<int(int, int)> gmin = [&](int l, int r)
        {
            int llg = two[r - l + 1];
            if (sparse[llg][r - (1 << llg) + 1] >= n || depth[sparse[llg][r - (1 << llg) + 1]] > depth[sparse[llg][l]])
            {
                return sparse[llg][l];
            }
            else return sparse[llg][r - (1 << llg) + 1];
        };
        
        function<int(int, int)> lca = [&](int a, int b)
        {
            if (a == b) return a;
            if (tin[b] < tin[a]) swap(a, b);
            if (tout[a] > tin[b]) return a;
            return gmin(tout[a], tin[b]);
        };


        //cout << lca(1, 1);
        



        
        ll ans = 1;
        for (int i = 0; i < n; i++)
        {
            ans = ans*(lrs[i].second - lrs[i].first + 1)%mod;
        }
        
        
        vector<vector<int>> pathes1(m, vector<int>());
        vector<vector<int>> pathes2(m, vector<int>());
        for (int i = 0; i < m; i++)
        {
            int ai = infants[i][0]-1, bi = infants[i][1]-1;
            int p1 = lca(ai, bi);
            while (ai != p1)
            {
                pathes1[i].push_back(ai);
                ai = parent[ai-1] - 1;
            }
            pathes1[i].push_back(p1);
            vector<int> half;
            while (bi != p1)
            {
                half.push_back(bi);
                bi = parent[bi-1] - 1;
            }
            for (auto x = half.rbegin(); x != half.rend(); x++) pathes1[i].push_back(*x);
        }
        for (int i = 0; i < m; i++)
        {
            int ai = infants[i][2]-1, bi = infants[i][3]-1;
            int p1 = lca(ai, bi);
            while (ai != p1)
            {
                pathes2[i].push_back(ai);
                ai = parent[ai-1] - 1;
            }
            pathes2[i].push_back(p1);
            vector<int> half;
            while (bi != p1)
            {
                half.push_back(bi);
                bi = parent[bi-1] - 1;
            }
            for (auto x = half.rbegin(); x != half.rend(); x++) pathes2[i].push_back(*x);
        }





        vector<ll> anses;
        for (int i = 0; i < m; i++)
        {
            if (ans == 0) break;
            for (int j = 0; j < pathes1[i].size() && ans != 0; j++)
            {
                int x = pathes1[i][j], y = pathes2[i][j];
                x = lead(x), y = lead(y);
                if (lead(x) == lead(y)) continue;
                ans = ans*binpow(lrs[x].second - lrs[x].first + 1, mod - 2, mod)%mod;
                ans = ans*binpow(lrs[y].second - lrs[y].first + 1, mod - 2, mod)%mod;
                unite(x, y);
                int u = lead(x);
                lrs[u].first = max(lrs[u].first, max(lrs[x].first, lrs[y].first));
                lrs[u].second = min(lrs[u].second, min(lrs[x].second, lrs[y].second));
                ans = ans*max(0LL, lrs[u].second - lrs[u].first + 1)%mod;
            }
            anses.push_back(ans);
        }
        while (anses.size() != m) anses.push_back(0);
        for (ll x : anses) cout << x << '\n';
        




        

        
        
        
        




    }
    return 0;
}
