#include <bits/stdc++.h>

using namespace std;

// #include "debug.h"
// #define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

typedef long long ll;
typedef long double ld;

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

const int MOD = 1'000'000'007;

int add(int x, int y) {
    return (x + y) % MOD;
}

int sub(int x, int y) {
    return (x - y + MOD) % MOD;
}

int mul(int x, int y) {
    return ll(x) * y % MOD;
}

struct DSU {
    vector<int> p;
    vector<int> l;
    vector<int> r;

    int get(int u) {
        return (p[u] == u ? u : p[u] = get(p[u]));
    }

    bool merge(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return false;
        p[v] = u;
        umax(l[u], l[v]);
        umin(r[u], r[v]);
        return true;
    }

    DSU(int n, const vector<int>& l_, const vector<int>& r_) : p(n), l(l_), r(r_) {
        iota(p.begin(), p.end(), 0);
    }
};

vector<int> get_path(int a, int b, const vector<int>& de, const vector<int>& p) {
    vector<int> path_a, path_b;
    while (de[a] > de[b]) {
        path_a.push_back(a);
        a = p[a];
    }
    while (de[b] > de[a]) {
        path_b.push_back(b);
        b = p[b];
    }
    while (a != b) {
        path_a.push_back(a);
        path_b.push_back(b);
        a = p[a];
        b = p[b];
    }
    vector<int> res;
    for (int x : path_a) res.push_back(x);
    res.push_back(a);
    reverse(path_b.begin(), path_b.end());
    for (int x : path_b) res.push_back(x);
    return res;
}

void dfs_de(int u, vector<int>& de, const vector<vector<int>>& g) {
    for (int v : g[u]) {
        de[v] = de[u] + 1;
        dfs_de(v, de, g);
    }
}

void solve() {
    int n;
    cin >> n;

    vector<int> p(n);
    vector g(n, vector<int>());
    for (int i = 1; i < n; ++i) {
        cin >> p[i];    
        --p[i];
        g[p[i]].push_back(i);
    }

    vector<int> de(n);
    dfs_de(0, de, g);

    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }

    DSU dsu(n, l, r);

    int m;
    cin >> m;
    for (int it = 0; it < m; ++it) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        
        vector<int> path_a = get_path(a, b, de, p);
        vector<int> path_c = get_path(c, d, de, p);

        for (int i = 0; i < sz(path_a); ++i) {
            dsu.merge(path_a[i], path_c[i]);
        }

        int res = 1;
        vector<bool> used(n);
        for (int i = 0; i < n; ++i) {
            int u = dsu.get(i);
            if (used[u]) continue;
            used[u] = true; 
            res = mul(res, max(0, dsu.r[u] - dsu.l[u] + 1));
        }

        cout << res << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}