#pragma GCC optimize("Ofast")
#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007, MAXN = 100'000;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

ll binpow(ll a, ll b) {
	return (b == 0 ? 1 : square(binpow(a, b / 2)) % MOD * (b % 2 ? a : 1) % MOD);
}

ll inv(ll x) {
	return binpow(x, MOD - 2);
}

struct DSU {
	vector<ll> p, sz, l, r;
	DSU(ll n, vector<ll> l, vector<ll> r): l(l), r(r) {
		p.resize(n);
		sz.resize(n, 1);
		for (ll i = 0; i < n; i++) {
			p[i] = i;
		}
	}
	ll get(ll v) {
		return (p[v] == v ? v : p[v] = get(p[v]));
	}
	ll g(ll v) {
		v = get(v);
		return max(0ll, r[v] - l[v] + 1);
	}
	bool unite(ll a, ll b) {
		a = get(a);
		b = get(b);
		if (a == b) {
			return true;
		}
		if (sz[a] < sz[b]) {
			swap(a, b);
		}
		sz[a] += sz[b];
		p[b] = a;
		assign_max(l[a], l[b]);
		assign_min(r[a], r[b]);
		return false;
	}
	bool check(ll a, ll b) {
		return get(a) == get(b);
	}
};

void dfs(ll v, vector<vector<ll>>& arr, vector<ll>& tin, vector<ll>& tout, ll& t) {
	tin[v] = t;
	t++;
	for (auto i : arr[v]) {
		dfs(i, arr, tin, tout, t);
	}
	tout[v] = t;
	t++;
}

ll ans = 1;
DSU dsu(0, vector<ll>(0, 0), vector<ll>(0, 0));

bool unite(ll a, ll b) {
	if (!dsu.check(a, b)) {
		ans *= inv(dsu.g(a));
		ans %= MOD;
		ans *= inv(dsu.g(b));
		ans %= MOD;
		dsu.unite(a, b);
		ans *= dsu.g(a);
		ans %= MOD;
		return true;
	}
	return false;
}

struct block {
	ll ncs[MAXN * 2];
	ll l, r;
	block(ll l, ll r): l(l), r(r) {
		for (ll i = 0; i < 2 * MAXN; i++) {
			ncs[i] = r - l;
		}
	}
	void make(ll ql, ll qr, ll sd) {
		sd += MAXN;
		if (ql <= l && r <= qr) {
			if (ncs[sd] == 0) {
				return;
			}
			ncs[sd] = 0;
		}
		for (ll i = max(l, ql); i < min(r, qr); i++) {
			if (unite(i, i + sd - MAXN)) {
				ncs[sd]--;
			}
		}
	}
};

struct sqrt_dec {
	vector<block> arr;
	ll k = 400;
	sqrt_dec(ll sz) {
		ll nl = 0;
		while (sz > k) {
			arr.emplace_back(nl, nl + k);
			nl += k;
			sz -= k;
		}
		arr.emplace_back(nl, nl + sz);
	}
	void make(ll l, ll r, ll sd) {
		for (auto& i : arr) {
			i.make(l, r, sd);
		}
	}
};

void solve() {
	ll n;
	cin >> n;
	vector<ll> p(n, 0);
	vector<vector<ll>> arr(n);
	bool b = true;
	for (ll i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		if (p[i] != i - 1) {
			b = false;
		}
		arr[p[i]].push_back(i);
	}
	vector<ll> tin(n), tout(n);
	ll t = 0;
	dfs(0, arr, tin, tout, t);
	vector<ll> l(n), r(n);
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dsu = DSU(n, l, r);
	for (ll i = 0; i < n; i++) {
		ans *= dsu.g(i);
		ans %= MOD;
	}
	ll m;
	cin >> m;
	if (b) {
		sqrt_dec sd(n);
		for (ll i = 0; i < m; i++) {
			ll a, b, c, d;
			cin >> a >> b >> c >> d;
			a--;
			c--;
			if (a > b) {
				swap(a, b);
				swap(c, d);
			}
			sd.make(a, b, c - a);
			cout << ans << '\n';
		}
		return;
	}
	for (ll i = 0; i < m; i++) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		while ((tin[a] > tin[b] || tout[a] < tout[b]) && (tin[c] > tin[d] || tout[c] < tout[d])) {
			unite(a, c);
			a = p[a];
			c = p[c];
		}
		while ((tin[b] > tin[a] || tout[b] < tout[a]) && (tin[d] > tin[c] || tout[d] < tout[c])) {
			unite(b, d);
			b = p[b];
			d = p[d];
		}
		vector<ll> n1, n2;
		while (tin[a] > tin[b] || tout[a] < tout[b]) {
			n1.push_back(a);
			a = p[a];
		}
		while (tin[b] > tin[a] || tout[b] < tout[a]) {
			n1.push_back(b);
			b = p[b];
		}
		while (tin[c] > tin[d] || tout[c] < tout[d]) {
			n2.push_back(c);
			c = p[c];
		}
		while (tin[d] > tin[c] || tout[d] < tout[c]) {
			n2.push_back(d);
			d = p[d];
		}
		n1.push_back(a);
		n2.push_back(c);
		for (ll i = 0; i < n1.size(); i++) {
			unite(n1[i], n2.back());
			n2.pop_back();
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
