#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


#pragma GCC optimize("avx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("179")

using namespace std;
#define int long long
const int mod = 1e9 + 7;

const int mn = 200001;
int tin[mn];
int tout[mn];
int timer = 0;
const int l = 18;
int up[mn][l];


void dfs (int v, vector <vector <int>> &gr, int p) {
    tin[v] = timer++;
    up[v][0] = p;
    for (int y = 1; y < l; y++) {
        up[v][y] = up[up[v][y - 1]][y - 1];
    }
    for (auto nw : gr[v]) {
        dfs(nw, gr, v);
    }
    tout[v] = timer++;
}



bool upper(int a, int b) {
    return (tin[a] <= tin[b] and tout[a] >= tout[b]);
}


int lca (int a, int b) {
    if (upper(a, b)) {
        return a;
    }
    if (upper(b, a)) {
        return b;
    }
    int h = a;
    for (int y = l - 1; y > -1; y--) {
        if (!upper(up[h][y], b)) {
            h = up[h][y];
        }
    }
    return up[h][0];
}


int retp(vector <int> &p, int a) {
    if (p[a] == a) {
        return a;
    }
    return p[a] = retp(p, p[a]);
}





signed main() {
    int n;
    cin >> n;
    vector <vector <int>> gr(n);
    vector <vector <int>> nx(n);
    vector <int> pre(n);
    for (int i = 1; i <= n - 1; i++) {
        int pr;
        cin >> pr;
        pr--;
        gr[pr].push_back(i);
        pre[i] = pr;
    }
    dfs(0, gr, 0);
    vector <vector <int>> ans(n);
    for (int i = 0; i < n; i++) {
        int ll, r;
        cin >> ll >> r;
        ans[i] = {ll, r};
    }
    vector <int> p(n);
    vector <int> sz(n, 1);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        int va = a;
        int vc = c;
        vector <int> r1;
        vector <int> r2;
        int lca1 = lca(a, b);
        int lca2 = lca(c, d);
        while (va != lca1) {
            r1.push_back(va);
            va = pre[va];
        }
        r1.push_back(va);
        while (vc != lca2) {
            r2.push_back(vc);
            vc = pre[vc];
        }
        vector <int> end1;
        vector <int> end2;
        va = b;
        vc = d;
        while (va != lca1) {
            end1.push_back(va);
            va = pre[va];
        }
        while (vc != lca2) {
            end2.push_back(vc);
            vc = pre[vc];
        }
        for (int j = (int)end1.size() - 1; j > -1; j--) {
            r1.push_back(end1[j]);
        }
        for (int j = (int)end2.size() - 1; j > -1; j--) {
            r2.push_back(end2[j]);
        }
        for (int j = 0; j < r1.size(); j++) {
            int v = r1[j];
            int u = r2[j];
            v = retp(p, v);
            u = retp(p, u);
            if (sz[v] < sz[u]) {
                swap(v, u);
            }
            p[v] = u;
        }
        map<int, vector <int>> now;
        int a1 = 1;
        for (int j = 0; j < n; j++) {
            int rr = retp(p, j);
            if (now.find(rr) == now.end()) {
                now[rr] = {ans[j][0], ans[j][1]};
            }
            else {
                now[rr][0] = max(now[rr][0], ans[j][0]);
                now[rr][1] = min(now[rr][1], ans[j][1]);
            }
        }
        for (auto el : now) {
            a1 *= max(0, el.second[1] - el.second[0] + 1);
            a1 %= mod;
        }
        cout << a1 << "\n";
    }
}
