#include<bits/stdc++.h>
#define ll long long
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

struct unionfind{
	int N;
	vector<ll> sz, par;
	unionfind() {}
	unionfind(int _N){
		N = _N;
		sz = par = vector<ll>(N + 1);
		for(int i = 1; i <= N; i ++){
			sz[i] = 1;
			par[i] = i;
		}
	}
	int get_root(int u){
		return u == par[u] ? u : get_root(par[u]);
	}
	void join(int u, int v){
		u = get_root(u);
		v = get_root(v);
		if(u == v) return;
		if(sz[u] > sz[v]) swap(u, v);
		sz[v] += sz[u];
		par[u] = v;
	}
};

const ll MOD = 1e9 + 7;

int N, Q;
matrix<int> G;
vector<ll> L, R;
vector<int> path1, path2;

bool find_path(int u, int c, int p = 0){
	if(u == c){
		path1.pb(u);
		return true;
	}
	bool flag = false;
	for(auto v : G[u]){
		if(v == p) continue;
		flag |= find_path(v, c, u);
	}
	if(flag){
		path1.pb(u);
	}
	return flag;
}

int main(){
	cin >> N;
	unionfind dsu(N);
	G = matrix<int>(N + 1);
	L = R = vector<ll>(N + 1);
	for(int i = 2; i <= N; i ++){
		int p; cin >> p;
		G[p].pb(i);
		G[i].pb(p);
	}
	for(int i = 1; i <= N; i ++){
		cin >> L[i] >> R[i];
	}
	cin >> Q;
	for(int i = 0; i < Q; i ++){
		int a, b, c, d; cin >> a >> b >> c >> d;
		path1.clear();
		find_path(a, b);
		path2 = path1;
		path1.clear();
		find_path(c, d);
		int sz = path1.size();
		for(int i = 0; i < sz; i ++){
			dsu.join(path1[i], path2[i]);
		}
		vector<ll> my_left(N + 1, -1), my_right(N + 1, 1e9 + 8);
		for(int u = 1; u <= N; u ++){
			int r = dsu.get_root(u);
			my_left[r] = max(L[u], my_left[r]); 
			my_right[r] = min(R[u], my_right[r]); 
		}
		ll ans = 1;
		for(int u = 1; u <= N; u ++){
			if(my_left[u] == -1) continue;
			ans = (ans * max(my_right[u] - my_left[u] + 1, 0LL)) % MOD;
		}
		cout << ans << endl;
	}
}
/**
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
*/