#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 200100;
const ll mod = 1e9 + 7;
const int k = 20;

vector <int> g[sz];
vector <int> v;
int h[sz], tin[sz], st[sz * 3];
pair <int, int> d[sz][k + 1];
int siz[sz], l[sz], r[sz];
int p[sz], pr[sz];
ll ans;

void dfs(int u, int crt = 0) {
	h[u] = crt;
	v.push_back(u);
	tin[u] = v.size() - 1;
	for (int i : g[u]) {
		dfs(i);
		v.push_back(u);
	}
}

int lca(int l, int r) {
	if (l > r) swap(l, r);
	int len = st[r - l + 1];
	return min(d[l][len], d[r + 1 - (1 << len)][len]).second;
}

vector <int> f(int a, int b) {
	int c = lca(tin[a], tin[b]);
	vector <int> res;
	while (a != c) {
		res.push_back(a);
		a = pr[a];
	}
	res.push_back(c);
	vector <int> x;
	while (b != c) {
		x.push_back(b);
		b = pr[b];
	}
	reverse(x.begin(), x.end());
	for (int i : x) res.push_back(i);
	return res;
}

int head(int x) {
	if (p[x] == -1) return x;
	if (p[x] == x) {
		cout << x << "!!!\n";
		return x;
	}
	p[x] = head(p[x]);
	return p[x];
}

ll bp(ll a, ll p) {
	if (p == 0) return 1;
	if (p % 2) {
		return bp(a, p - 1) * a % mod;
	}
	ll t = bp(a, p / 2);
	return t * t % mod;
}

ll obr(ll a) {
	return bp(a, mod - 2);
}

int main() {
	int n;
	cin >> n;
	for (int i = 2; i <= n; ++i) {
		cin >> pr[i];
		g[pr[i]].push_back(i);
	}
	dfs(1);
	int len = v.size();
	for (int i = 0; i < len; ++i) {
		d[i][0] = { h[v[i]], v[i] };
	}
	st[1] = 0;
	for (int i = 2; i <= len; ++i) {
		st[i] = st[i / 2] + 1;
	}
	for (int i = 1; i <= k; ++i) {
		for (int j = 0; j + (1 << i) <= len; ++j) {
			d[j][i] = min(d[j][i - 1], d[j + (1 << (i - 1))][i - 1]);
		}
	}
	ans = 1;
	for (int i = 1; i <= n; ++i) {
		cin >> l[i] >> r[i];
		ans = ans * (r[i] - l[i] + 1) % mod;
	}
	for (int i = 1; i <= n; ++i) siz[i] = 1, p[i] = -1;
	int m;
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		vector <int> x = f(a, b);
		vector <int> y = f(c, d);
		for (int i = 0; i < x.size(); ++i) {
			int a = head(x[i]);
			int b = head(y[i]);
			if (a == b) continue;
			if (siz[a] > siz[b]) swap(a, b);
			siz[b] += siz[a];
			p[a] = b;
			ans *= obr(r[a] - l[a] + 1);
			ans %= mod;
			ans *= obr(r[b] - l[b] + 1);
			ans %= mod;
			r[b] = min(r[b], r[a]);
			l[b] = max(l[b], l[a]);
			if (l[b] > r[b]) ans = 0;
			ans *= (r[b] - l[b] + 1);
			ans %= mod;
		}
		cout << ans << '\n';
	}
}  