//#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <deque>

using namespace std;
#define int long long
#define ll long long

vector<vector<int>> g;
vector<int> p;
int mod = (int) 1e9 + 7;

vector<int> tin;
vector<int> tout;
int k = 0;
vector<int> h;

void dfs(int now) {
    tin[now] = k;
    k++;

    for (int to : g[now]) {
        dfs(to);
        h[to] = h[now] + 1;
    }
    tout[now] = k;
    k++;
}

struct node {
    int l;
    int r;
};
vector<int> w;
vector<int> par;
vector<node> inf;

void build(int n, vector<node>& v) {
    w.resize(n);
    par.resize(n);
    inf.resize(n);
    for (int i = 0; i < n; i++) {
        par[i] = i;
        w[i] = 1;
        inf[i] = v[i];
    }
}

int get(int a) {
    if (par[a] == a) {
        return a;
    }
    par[a] = get(par[a]);
    return par[a];
}

void merge(int a, int b) {
    int x = get(a);
    int y = get(b);

    if (x == y) {
        return;
    }
    if (w[x] < w[y]) {
        swap(x, y);
    }
    par[y] = x;
    inf[x].l = max(inf[x].l, inf[y].l);
    inf[x].r = min(inf[x].r, inf[y].r);
    if (w[x] == w[y]) {
        w[x]++;
    }
}

vector<vector<int>> up;

int find(int a, int b) {
    int st = (int) up.size() - 1;
    while (!(tin[a] <= tin[b] && tout[a] >= tout[b])) {
        while (st >= 0 && tin[up[st][a]] <= tin[b] && tout[up[st][a]] >= tout[b]) {
            st--;
        }
        if (st < 0) {
            return up[0][a];
        }
        a = up[st][a];
    }
    return a;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<node> v(n);
    p.resize(n);
    g.resize(n, {});
    h.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        v[i] = {l, r};
    }

    tin.resize(n);
    tout.resize(n);
    h[0] = 0;
    dfs(0);

    up.resize(30, vector<int> (n, 0)); // 20
    p[0] = 0;
    for (int i = 0; i < n; i++) {
        up[0][i] = p[i];
    }

    for (int j = 1; j < up.size(); j++) {
        for (int i = 0; i < n; i++) {
            up[j][i] = up[j - 1][up[j - 1][i]];
        }
    }

    build(n, v);
    int ans = 1;
    for (int i = 0; i < n; i++) {
        ans = ((ll) ans * (ll) (inf[i].r - inf[i].l + 1)) % (ll) mod;
    }
    int m;
    cin >> m;
    for (int q = 0; q < m; q++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        vector<int> pa;
        vector<int> pc;

        deque<int> da;
        deque<int> db;
        deque<int> dc;
        deque<int> dd;

        int lcaa = find(a, b);
        int lcac = find(c, d);
        da.push_back(a);
        while (a != lcaa) {
            a = p[a];
            da.push_back(a);
        }
        db.push_front(b);
        while (b != lcaa) {
            b = p[b];
            db.push_front(b);
        }
        db.pop_front();

        for (int el : da) {
            pa.push_back(el);
        }
        for (int el : db) {
            pa.push_back(el);
        }

        dc.push_back(c);
        while (c != lcac) {
            c = p[c];
            dc.push_back(c);
        }
        dd.push_front(d);
        while (d != lcac) {
            d = p[d];
            dd.push_front(d);
        }
        dd.pop_front();

        for (int el : dc) {
            pc.push_back(el);
        }
        for (int el : dd) {
            pc.push_back(el);
        }

        for (int i = 0; i < pa.size(); i++) {
            merge(pa[i], pc[i]);
        }

        ans = 1;
        for (int i = 0; i < n; i++) {
            if (get(i) != i) {
                continue;
            }
            ans = ((ll) ans * (ll) (inf[i].r - inf[i].l + 1)) % (ll) mod;
        }

        cout << ans << '\n';
    }
}

/*

5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

 */