#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl long double
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
vector<int> g[maxn];
int tin[maxn], tout[maxn], p[maxn], T = 1, n;
pii otr[maxn];

void dfs(int v = 0) {
    tin[v] = T++;
    for (int u: g[v])
        dfs(u);
    tout[v] = T;
}

int anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v))return u;
    if (anc(v, u))return v;
    while (!anc(u, v)) u = p[u];
    return u;
}

pii ob(pii otr1, pii otr2) {
    auto [l1, r1] = otr1;
    auto [l2, r2] = otr2;
    if (l1 > l2)swap(l1, l2), swap(r1, r2);
    if (r1 < l2)return {-1, -1};
    int L = l2, R = min(r1, r2);
    return {L, R};
}

vector<int> path(int a, int b) {
    int k = lca(a, b);
    vector<int> p1, p2;
    while (a != k)p1.push_back(a), a = p[a];
    p1.push_back(k);
    while (b != k)p2.push_back(b), b = p[b];
    reverse(all(p2));
    for (int el: p2)p1.push_back(el);
    return p1;
}
int binpow(int a, int N){
    int ans = 1;
    while(N){
        if(N & 1) ans = (ans * a) % mod, N--;
        else a = (a * a) % mod, N /= 2;
    }
    return ans;
}
int ans = 1;
int getl(pii ot){
    auto [l, r] = ot;
    if(l == -1)return 0;
    return r - l + 1;
}
struct DSU {
    vector<int> p, sz;

    void build() {
        p.resize(n), sz.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    int get(int v) {
        if (v == p[v])return v;
        return p[v] = get(p[v]);
    }

    void un(int u, int v) {
        u = get(u), v = get(v);
        if (u == v)return;
        if (sz[u] > sz[v])swap(u, v);
        p[u] = v, sz[v] += sz[u];
        ans *= binpow(getl(otr[u]), mod - 2);
        ans %= mod;
        ans *= binpow(getl(otr[v]), mod - 2);
        ans %= mod;
        otr[v] = ob(otr[v], otr[u]);
        ans *= getl(otr[v]);
        ans %= mod;
    }
};
void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i], p[i]--;
        g[p[i]].push_back(i);
    }
    dfs();
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        otr[i] = {l, r};
        ans = (ans * (r - l + 1)) % mod;
    }
    DSU t;
    t.build();
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto p1 = path(a, b);
        auto p2 = path(c, d);
        int len = sz(p1);
        for (int i = 0; i < len; ++i) {
            t.un(p1[i], p2[i]);
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}