#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>

#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

typedef long long ll;
typedef long double ld;

#define vec vector 
#define pii pair<ll, ll>
#define pll pair<ll, ll>
#define int ll

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

using namespace std;

#pragma warning(disable: 4996)

int n, m;
vec<int> par;
vec<pii> otr;
int now = 0;
map<int, int> ngr;
vec<bool> used;
vec<int> tin, tout;
int timer = 0;
map<int, vec<int>> g;
map<vec<int>, bool> mem;

struct grp {
    int l, r;
    vec<int> vals;
};

map<int, grp> groups;

bool anc(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void dfs(int v) {
    used[v] = 1;
    tin[v] = timer++;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tout[v] = timer++;
}

vec<int> makeway(int a, int b) {
    vec<int> res;
    vec<int> tmp;
    if (anc(a, b)) {
        while (b != a) {
            res.push_back(b);
            b = par[b];
        }
        res.push_back(a);
        reverse(res.begin(), res.end());
    }
    else if (anc(b, a)) {
        while (a != b) {
            res.push_back(a);
            a = par[a];
        }
        res.push_back(b);
    }
    else {
        while (!anc(a, b)) {
            res.push_back(a);
            a = par[a];
        }
        res.push_back(a);

        while (!anc(b, a)) {
            tmp.push_back(b);
            b = par[b];
        }
        reverse(tmp.begin(), tmp.end());
        for (int i = 0; i < tmp.size(); i++) {
            res.push_back(tmp[i]);
        }
    }
    //for (auto elem : res) {
    //    cout << elem << " ";
    //}
    //cout << "\n";
    return res;
}

pii inter(int q, int w) {
    if (groups[q].l < groups[w].l) {
        if (groups[q].r < groups[w].l) {
            return {-1, -1};
        }
        return { groups[w].l, min(groups[w].r, groups[q].r)};
    }
    else if (groups[q].l <= groups[w].r) {
        return {groups[q].l, min(groups[w].r, groups[q].r) };
    }
    else {
        return {-1, -1};
    }
}


bool merge(int q, int w) {
    for (auto elem : groups[w].vals) {
        groups[q].vals.push_back(elem);
        ngr[elem] = q;
    }
    pii tmp = inter(q, w);
    groups.erase(w);
    if (tmp.first == -1 && tmp.second == -1) {
        return 0;
    }
    groups[q].l = tmp.first;
    groups[q].r = tmp.second;
    return 1;
}

void solve() {
    bool ans0 = 0;
    ll prev = -1;
    cin >> n;
    par = vec<int>(n);

    for (int i = 1; i < n; i++) {
        cin >> par[i];
        par[i]--;
        g[par[i]].push_back(i);
    }
    used = vec<bool>(n);
    tin = vec<int>(n);
    tout = vec<int>(n);
    dfs(0);

    otr = vec<pii>(n);
    for (int i = 0; i < n; i++) {
        cin >> otr[i].first >> otr[i].second;
    }
    for (int i = 0; i < n; i++) {
        ngr[i] = i;
        groups[i].vals = {i};
        groups[i].l = otr[i].first;
        groups[i].r = otr[i].second;
    }

    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c  >> d;
        a--;
        b--;
        c--;
        d--;
        if (mem[{a, b, c, d}]) {
            cout << prev << "\n";
            continue;;
        }
        
        vec<int> qwe, asd;
        qwe = makeway(a, b);
        asd = makeway(c, d);
        mem[{a, b, c, d}] = 1;

        for (int i = 0; i < qwe.size(); i++) {
            int q = ngr[qwe[i]], w = ngr[asd[i]];
            if (q != w) {
                bool res = merge(q, w);
                if (!res) {
                    ans0 = 1;
                }
            }
        }
        ll ans = 1;
        if (ans0) {
            cout << 0 << "\n";
            continue;
        }
        for (auto elem : groups) {
            ans *= (elem.second.r - elem.second.l + 1);
            ans %= mod;
        }
        cout << ans << "\n";
        prev = ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}