#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

template<int mod>
struct mint {
    int value;

    mint() : value(0) {

    }

    mint(int _value) : value(_value) {

    }

    mint(const mint& other) : value(other.value) {

    }

    mint operator+(const mint &other) const {
        if (value + other.value >= mod) {
            return mint<mod>(value + other.value - mod);
        }
        return mint<mod>(value + other.value);
    }

    mint operator-(const mint &other) const {
        if (value - other.value < 0) {
            return mint<mod>(value - other.value + mod);
        }
        return mint<mod>(value - other.value);
    }

    mint operator*(const mint &other) const {
        return mint<mod>(value * 1ll * other.value % mod);
    }

    bool operator==(const mint &other) const {
        return value == other.value;
    }

    bool operator!=(const mint &other) const {
        return value != other.value;
    }

    mint pow(ll k) const {
        if (k == 0) return mint<mod>(1);
        if (k % 2 == 0) {
            mint t = pow(k / 2);
            return t * t;
        }
        return *this * pow(k - 1);
    }

    mint inv() const {
        return pow(mod - 2);
    }

    mint operator/(const mint &other) const {
        return *this * other.inv();
    }

    int to_int() {
        return value;
    }
};

typedef mint<1000000009> mint197;

struct dsu {
    vector<int> p, sz;
    vector<int> l, r;
    mint197 ans;

    dsu(int n) {
        ans = mint197(1);

        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
        l.resize(n);
        r.resize(n);
    }

    int get(int v) {
        if (p[v] != v) p[v] = get(p[v]);
        return p[v];
    }

    void unite(int v, int u) {
        v = get(v);
        u = get(u);
        if (v == u) return;
        if (sz[u] < sz[v]) swap(v, u);

        p[v] = u;
        sz[u] += sz[v];
        if (ans != mint197(0)) {
            ans = ans / (r[v] - l[v] + 1);
            ans = ans / (r[u] - l[u] + 1);
            l[u] = max(l[v], l[u]);
            r[u] = min(r[v], r[u]);
            ans = ans * mint197(max(0, r[u] - l[u] + 1));
        }
    }
};

vector<vector<int>> g;

void dfs(int v, int prev, vector<int> &p) {
    p[v] = prev;
    for (int u : g[v]) {
        if (u == prev) continue;
        dfs(u, v, p);
    }
}

void solve() {
    int n, m;
    cin >> n;

    dsu ds(n);

    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int pi;
        cin >> pi;
        g[pi - 1].push_back(i);
        g[i].push_back(pi - 1);
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> ds.l[i] >> ds.r[i];
        ds.ans = ds.ans * mint197(ds.r[i] - ds.l[i] + 1);
    }

    vector<int> p1(n), p2(n);
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;

        dfs(a, -1, p1);
        dfs(c, -1, p2);
        while (b != -1 && d != -1) {
            ds.unite(b, d);
            b = p1[b];
            d = p2[d];
        }

        cout << ds.ans.to_int() << "\n";
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
