#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) <<": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
struct segtree {
    vector<int> tree;
    int size = 1;
    void init(int n) {
        while (size < n) size *= 2;
        tree = vector<int>(2 * size - 1, 0);
    }
    void upd(int i, int a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            upd(i, a, 2 * x + 1, lx, m);
        }
        else {
            upd(i, a, 2 * x + 2, m, rx);
        }
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int l, int r, int x, int lx, int rx) {
        if (rx <= l || lx >= r) {
            return -INF;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int mx1 = get(l, r, 2 * x + 1, lx, m);
        int mx2 = get(l, r, 2 * x + 2, m, rx);
        return max(mx1, mx2);
    }
};

struct cnm {
    vector<int> par, rang;
    void init(int n) {
        for (int i = 0; i < n; i++) {
            rang.pb(0);
            par.pb(i);
        }
    }
    int get(int a) {
        while (par[a] != a) {
            return get(par[a]);
        }
        return par[a];
    }
    void make_union(int a, int b) {
        if (get(a) == get(b)) return;
        a = get(a);
        b = get(b);
        if (rang[a] < rang[b]) swap(a, b);
        rang[a]++;
        par[b] = a;
    }
};
vector<vector<int> > gr;
vector<int> path, gets;
int fl = 0;
void dfs(int u, int p,int fin) {
    path.pb(u);
    if (fin == u && fl == 0) {
        gets = path;
        fl = 1;
    }
    if (fl) return;
    for (auto to : gr[u]) {
        if (to == p) continue;
        dfs(to, u, fin);
    }
    path.pop_back();
}
vector<int> get_path(int st, int fin) {
    fl = 0;
    gets.clear();
    path.clear();
    dfs(st, -1, fin);
    return gets;
}
void solve() {
    int n, m;
    cin >> n;
    cnm cnm;
    cnm.init(n);
    gr = vector<vector<int> >(n);
    vector<pair<int, int> > can;
    for (int i = 1; i < n; i++) {
        int a; cin >> a;
        a--;
        gr[i].pb(a);
        gr[a].pb(i);
    }
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        can.pb({ l,r });
    }
    cin >> m;
    vector<int> all_ans;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector<int> path1 = get_path(a, b);
        vector<int> path2 = get_path(c, d);
        /*
        for (auto c : path1) cout << c << " ";
        cout << endl;
        for (auto c : path2) cout << c << " ";
        cout << endl;
        */
        for (int j = 0; j < path1.size(); j++) {
            cnm.make_union(path1[j], path2[j]);
        }
        vector<vector<int> > all(n);
        for (int i = 0; i < n; i++) {
            int x = cnm.get(i);
            all[x].pb(i);
        }
        int ans = 1;
        for (int j = 0; j < n; j++) {
            if (all[j].size() == 0) continue;
            int cur_l = can[all[j][0]].first, cur_r = can[all[j][0]].second;
            for (int x = 1; x < all[j].size(); x++) {
                int l = can[all[j][x]].first, r = can[all[j][x]].second;
                cur_l = max(cur_l, l);
                cur_r = min(r, cur_r);
            }
            ans *= max(0, cur_r - cur_l + 1);
            ans %= mod;
        }
        cout << ans << '\n';
    }
    /*
    int ans = 1;
    for (int i = 0; i < n; i++) {
        if (all[i].size() == 0) continue;
        int cur_l = can[all[i][0]].first, cur_r = can[all[i][0]].second;
        for (int j = 1; j < all[i].size(); j++) {
            int l = can[all[i][j]].first, r = can[all[i][j]].second;
            cur_l = max(cur_l, l);
            cur_r = min(r, cur_r);
        }
        ans *= max(0, cur_r - cur_l + 1);
        cout << ans << '\n';
    }
    */
    
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}