#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
//#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) <<": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b) {
    return ((ll)a * b) % mod;
}

vector<pair<int, int> > cur_can;
ll ans = 1;
void sliv(int a, int b) {
    ll l1 = cur_can[a].first, r1 = cur_can[a].second;
    ll l2 = cur_can[b].first, r2 = cur_can[b].second;
    ans = mul(ans, rev(max(0, r1 - l1 + 1)));
    ans = mul(ans, rev(max(0, r2 - l2 + 1)));
    ll new_l = max(l1, l2);
    ll new_r = min(r1, r2);
    ans = mul(ans, max(0, new_r - new_l + 1));
    cur_can[a] = { new_l,new_r };
}
struct cnm {
    vector<int> par, rang;
    void init(int n) {
        for (int i = 0; i < n; i++) {
            rang.pb(0);
            par.pb(i);
        }
    }
    int get(int a) {
        while (par[a] != a) {
            return get(par[a]);
        }
        return par[a];
    }
    void make_union(int a, int b) {
        if (get(a) == get(b)) return;
        a = get(a);
        b = get(b);
        if (rang[a] < rang[b]) swap(a, b);
        sliv(a, b);
        rang[a]++;
        par[b] = a;
    }
};
const int MAXN = 2e5 + 10;
const int MAX_LOG = 20;
vector<vector<int> > gr;
int up[MAXN][MAX_LOG];
vector<int> path, gets, in, out;
int fl = 0, timer = 0;
int is_pred(int a, int b) {
    if (in[a] <= in[b] && out[a] >= out[b]) return 1;
    return 0;
}
void make_in_out(int u, int p) {
    in[u] = timer;
    timer++;
    for (auto to : gr[u]) {
        if (to == p) continue;
        up[to][0] = u;
        make_in_out(to, u);
    }
    out[u] = timer;
    timer++;
}
void make_lca(int u, int p) {
    for (int i = 1; i < MAX_LOG; i++) {
        int c = up[u][i - 1];
        int next = up[c][i - 1];
        up[u][i] = next;
    }
    for (auto to : gr[u]) {
        if (to == p) continue;
        make_lca(to, u);
    }
}
int get_lca(int a, int b) {
    if (is_pred(a, b)) return a;
    if (is_pred(b, a)) return b;
    for (int i = 19; i >= 0; i--) {
        int c = up[a][i];
        if (!is_pred(c, b)) {
            a = c;
        }
    }
    return up[a][0];
}
void dfs(int u, int p, int fin) {
    path.pb(u);
    if (fin == u && fl == 0) {
        gets = path;
        fl = 1;
    }
    if (fl) return;
    for (auto to : gr[u]) {
        if (to == p) continue;
        if (!is_pred(to, fin)) continue;
        dfs(to, u, fin);
    }
    path.pop_back();
}
vector<int> get_path(int st, int fin) {
    fl = 0;
    gets.clear();
    path.clear();
    int lca = get_lca(st, fin);
    if (lca == st) {
        dfs(st, -1, fin);
        return gets;
    }
    if (lca == fin) {
        swap(st, fin);
        dfs(st, -1, fin);
        reverse(gets.begin(), gets.end());
        return gets;
    }
    dfs(lca, -1, st);
    vector<int> all = gets;
    reverse(all.begin(), all.end());
    gets.clear();
    path.clear();
    fl = 0;
    dfs(lca, -1, fin);
    for (int i = 1; i < gets.size(); i++) {
        all.pb(gets[i]);
    }
    return all;
}
void solve() {
    int n, m;
    cin >> n;
    cnm cnm;
    cnm.init(n);
    up[0][0] = 0;
    gr = vector<vector<int> >(n);
    vector<pair<int, int> > can;
    in = vector<int>(n, 0);
    out = vector<int>(n, 0);
    for (int i = 1; i < n; i++) {
        int a; cin >> a;
        a--;
        gr[i].pb(a);
        gr[a].pb(i);
    }
    make_in_out(0, -1);
    make_lca(0, -1);
    for (int i = 0; i < n; i++) {
        ll l, r;
        cin >> l >> r;
        can.pb({ l,r });
        ans = mul(ans, (r - l + 1));
    }
    cur_can = can;
    cin >> m;
    vector<int> all_ans;
    for (int i = 0; i < m; i++) {
        int a, b, c, d, fl_a_b = 0, fl_c_d = 0;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector<int> path1 = get_path(a, b);
        vector<int> path2 = get_path(c, d);
        for (int j = 0; j < path1.size(); j++) {
            cnm.make_union(path1[j], path2[j]);
        }
        cout << ans << '\n';
    }

}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}