#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;

int n;
vector<vector<int>> g;

bool find_path(int v, int p, int to, vector<int>& path) {
    if (v == to) {
        path.push_back(v);
        return true;
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        if (find_path(u, v, to, path)) {
            path.push_back(v);
            return true;
        }
    }
    return false;
}

struct DSU {
    vector<int> p;
    vector<pair<int, int>> c;
    vector<int> sz;

    pair<int, int> intersect(pair<int, int> a, pair<int, int> b) {
        int l = max(a.first, b.first);
        int r = min(a.second, b.second);
        return {l, r};
    }

    DSU(vector<pair<int, int>> s) {
        int n = (int)s.size();
        p.resize(n); sz.resize(n, 1); c.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            c[i] = s[i];
        }
    }

    int get_root(int v) {
        if (p[v] == v) return v;
        p[v] = get_root(p[v]);
        return p[v];
    }

    void unio(int a, int b) {
        a = get_root(a);
        b = get_root(b);
        if (a == b) return;
        if (sz[a] > sz[b]) swap(a, b);
        p[a] = b;
        c[b] = intersect(c[a], c[b]);
        sz[b] += sz[a];
    }
};

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p; cin >> p; p--;
        g[i].push_back(p);
        g[p].push_back(i);
    }
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        int l, r; cin >> l >> r;
        c[i] = {l, r};
    }
    DSU d(c);
    int m; cin >> m;
    bool cont = false;
    for (int i = 0; i < m; ++i) {
        int from1, to1, from2, to2; cin >> from1 >> to1 >> from2 >> to2;
        if (cont) {
            cout << "0\n";
            continue;
        }
        from1--; to1--; from2--; to2--;
        vector<int> p1, p2;
        find_path(from1, -1, to1, p1);
        find_path(from2, -1, to2, p2);
        for (int j = 0; j < (int)p1.size(); ++j) {
            d.unio(p1[j], p2[j]);
        }
        vector<int> used(n, 0);
        int ans = 1;
        for (int j = 0; j < n; ++j) {
            int v = d.get_root(j);
            if (used[v]) continue;
            used[v] = 1;
            auto [l, r] = d.c[v];
            if (l > r) {
                cout << "0\n";
                cont = true;
                break;
            }
            ans *= (r - l + 1);
            ans %= MOD;
        }
        if (cont) continue;
        cout << ans << '\n';
    }
    return 0;
}
