#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7, SIZE = 200005;

int fast_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2) return a * fast_pow(a, n - 1) % MOD;
    return fast_pow(a * a % MOD, n / 2);
}

int rmod(int n) {
    return fast_pow(n, MOD - 2);
}

int tin[SIZE], tout[SIZE], cnt[SIZE], L[SIZE], R[SIZE], p[SIZE], prevs[SIZE], sz[SIZE], TT = 0;
int ans = 1;
vector<vector<int>> g;

int is_anc(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void dfs(int u) {
    tin[u] = TT++;
    for (int v: g[u]) {
        dfs(v);
    }
    tout[u] = TT;
}

vector<int> way(int a, int b) {
    if (a == b) return {a};
    vector<int> res1, res2;
    if (is_anc(a, b)) {
        while (b != a) res2.push_back(b), b = p[b];
        res2.push_back(b);
        reverse(res2.begin(), res2.end());
        return res2;
    }
    if (is_anc(b, a)) {
        while (b != a) res1.push_back(a), a = p[a];
        res1.push_back(a);
        return res1;
    }
    while (!is_anc(p[a], b)) res1.push_back(a), a = p[a];
    res1.push_back(a);
    while (!is_anc(b, a)) res2.push_back(b), b = p[b];
    res2.push_back(b);
    reverse(res2.begin(), res2.end());
    for (int i: res2) res1.push_back(i);
    return res1;
}

int get_ind(int u) {
    if (u == prevs[u]) return u;
    return prevs[u] = get_ind(prevs[u]);
}

void merge(int a, int b) {
    a = get_ind(a), b = get_ind(b);
    if (a == b) return;
    if (sz[a] > sz[b]) swap(a, b);
    ans = ans * rmod(cnt[a]) % MOD;
    ans = ans * rmod(cnt[b]) % MOD;
    L[b] = max(L[b], L[a]), R[b] = min(R[b], R[a]);
    cnt[b] = R[b] - L[b] + 1;
    ans = ans * cnt[b] % MOD;
    sz[b] += sz[a], prevs[a] = b;
}

signed main() {
    for (int i = 0; i < SIZE; ++i) prevs[i] = i, sz[i] = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    g.resize(n);
    p[0] = 0;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
        cnt[i] = R[i] - L[i] + 1;
        ans = ans * cnt[i] % MOD;
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
//        if (ans == 0) {
//            cout << ans << endl;
//            continue;
//        }
        a--, b--, c--, d--;
        vector<int> way1 = way(a, b), way2 = way(c, d);
        assert(way1.size() == way2.size());
        for (int i = 0; i < way1.size(); ++i) {
            merge(way1[i], way2[i]);
        }
        cout << ans << endl;
    }

}
