#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define int long long
#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back

const int N = 1e5;
const int mod = 1e9 + 7;

vc <int> g[N];
int l[N], r[N];

vc <int> path;
set <int> comp;
int rt = -1;
bool dfs (int u, int p = -1) {
    if (u == rt) {
        path.pb(u);
        return true;
    }
    for (int v : g[u]) {
        if (v != p && dfs(v, u)) {
            path.pb(u);
            return true;
        }
    }
    return false;
}

int p[N];

int find (int u) {
    return u == p[u] ? u : p[u] = find(p[u]);
}

int unite (int u, int v) {
    u = find(u);
    v = find(v);
    if (u == v)
        return 0;
    p[v] = u;
    comp.erase(v);
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    return 1;
}

void solve () {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v; --v;
        g[i].pb(v);
        g[v].pb(i);
    }
    iota(p, p + n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        comp.insert(i);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d; --a; --b; --c; --d;
        rt = b;
        path.clear();
        dfs(a);
        vc <int> v1 = path;
        rt = d;
        path.clear();
        dfs(c);
        vc <int> v2 = path;
        for (int j = 0; j < sz(v1); ++j) {
            unite(v1[j], v2[j]);
        }
        int res = 1;
        for (int j : comp) {
            if (l[j] > r[j])
                res = 0;
            res = res * (r[j] - l[j] + 1) % mod;
        }
        cout << res << '\n';
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}