#include <bits/extc++.h>
using namespace std;

const int maxn = 1 << 19;
const int inf = 1e9;
const int mod = 1e9 + 7;
int par[maxn];
pair<int, int> rng[maxn];
int tin[maxn];
int tout[maxn];
int timer = 0;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

void dfs(int v, vector<vector<int>> &g) {
    tin[v] = timer++;
    for (int u : g[v]) dfs(u, g);
    tout[v] = timer++;
}

bool isa(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int tree[maxn * 2];
int treer[maxn * 2];
const int pp = 100001;
long long P[maxn];
void upd(int i, int x) {
    i += maxn;
    tree[i] = x;
    treer[i] = x;
    int len = 1;
    while (i > 1) {
        i >>= 1;
        tree[i] = (tree[i * 2] * P[len] + tree[i * 2 + 1]) % mod;
        treer[i] = (treer[i * 2 + 1] * P[len] + treer[i * 2]) % mod;
        len *= 2;
    }
}

int get(int l, int r) {
    l += maxn;
    r += maxn;
    int ansl = 0;
    int ansr = 0;
    int szl = 0, szr = 0;
    int len = 1;
    while (l < r) {
        if (l & 1) {
            szl += len;
            ansl = (ansl * P[len] + tree[l++]) % mod;
        }
        if (r & 1) {
            --r;
            ansr = (tree[r] * P[szr] + ansr) % mod;
            szr += len;
        }
        l >>= 1;
        r >>= 1;
        len *= 2;
    }
    return (ansl * P[szr] + ansr) % mod;
}

int getr(int l, int r) {
    l += maxn;
    r += maxn;
    int ansl = 0;
    int ansr = 0;
    int szl = 0, szr = 0;
    int len = 1;
    while (l < r) {
        if (l & 1) {
            ansl = (ansl + treer[l++] * P[szl]) % mod;
            szl += len;
        }
        if (r & 1) {
            --r;
            ansr = (treer[r] + ansr * P[len]) % mod;
            szr += len;
        }
        l >>= 1;
        r >>= 1;
        len *= 2;
    }
    return (ansl + ansr * P[szl]) % mod;
}

int p[maxn];
int sz[maxn];
vector<int> comp[maxn];
int col(int v) {
    if (v == p[v]) return v;
    return p[v] = col(p[v]);
}

long long ans = 1;

void unite(int u, int v) {
    u = col(u);
    v = col(v);
    if (sz[u] > sz[v]) swap(u, v);
    if (u != v) {
        p[u] = v;
        ans *= bp(rng[u].second - rng[u].first + 1);
        ans %= mod;
        ans *= bp(rng[v].second - rng[v].first + 1);
        ans %= mod;
        sz[v] += sz[u];
        rng[v].first = max(rng[v].first, rng[u].first);
        rng[v].second = min(rng[v].second, rng[u].second);
        if (rng[v].second < rng[v].first) ans = 0;
        ans *= rng[v].second - rng[v].first + 1;
        ans %= mod;
        for (int x : comp[u]) {
            comp[v].push_back(x);
            upd(x, v + 1);
        }
        comp[u].clear();
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    bool bamb = true;
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        sz[i] = 1;
        comp[i] = { i };
        upd(i, i + 1);
    }
    //cout << getr( 3, 4) << endl;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        if (p != i - 1) bamb = false;
        g[p].push_back(i);
        par[i] = p;
    }
    dfs(0, g);
    for (int i = 0; i < n; ++i) {
        cin >> rng[i].first >> rng[i].second;
    }
    for (int i = 0; i < n; ++i) {
        ans *= (rng[i].second - rng[i].first + 1);
        ans %= mod;
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        if (!bamb) {
            vector<int> p11{a}, p12, p21{c}, p22;
            while (a != b) {
                if (!isa(a, b)) {
                    a = par[a];
                    p11.push_back(a);
                } else {
                    p12.push_back(b);
                    b = par[b];
                }
                if (!isa(c, d)) {
                    c = par[c];
                    p21.push_back(c);
                } else {
                    p22.push_back(d);
                    d = par[d];
                }
            }
            reverse(p12.begin(), p12.end());
            reverse(p22.begin(), p22.end());
            for (int i: p12) {
                p11.push_back(i);
            }
            for (int i: p22) {
                p21.push_back(i);
            }
            for (int j = 0; j < p11.size(); ++j) {
                int u = p11[j];
                int v = p21[j];
                unite(u, v);
            }
        } else {
            if (c <= d) {
                swap(a, c);
                swap(b, d);
            }
            if (a >= b && c >= d) {
                swap(a, b);
                swap(c, d);
            }
            if (a <= b && c <= d) {
                while (a <= b) {
                    int l = -1, r = b - a + 1;
                    while (l + 1 < r) {
                        int m = (l + r) / 2;
                        if (get(a, a + m + 1) != get(c, c + m + 1)) {
                            r = m;
                        } else {
                            l = m;
                        }
                    }
                    if (r == b - a + 1) {
                        break;
                    }
                    unite(a + r, c + r);
                    a += r + 1;
                    c += r + 1;
                }
            } else if (a <= b && c >= d) {
                while (a <= b) {
                    int l = -1, r = b - a + 1;
                    while (l + 1 < r) {
                        int m = (l + r) / 2;
                        if (get(a, a + m + 1) != getr(c - m, c + 1)) {
                            r = m;
                        } else {
                            l = m;
                        }
                    }
                    if (r == b - a + 1) {
                        break;
                    }
                    unite(a + r, c - r);
                    a += r + 1;
                    c -= r + 1;
                }
            }
        }
        cout << ans << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    P[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        P[i] = (P[i - 1] * 1ll * pp) % mod;
    }
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
