#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
#pragma GCC optimize("Ofast")
#define int long long 
#define _ << " " << 
#define ld long double
const int MAXN = 2e5 + 10, MAXA = 1e7 + 5, LOG = 25, mod = 1e9 + 7;
int a[MAXN], n, k, l[MAXN], r[MAXN], sz[MAXN], parent[MAXN], h[MAXN], lca[MAXN][LOG];
int d[MAXN];
void prepare() {
	for (int i = 1; i <= n; i++) sz[i] = 1;
	for (int i = 1; i <= n; i++) parent[i] = i;
}
int get(int a) {
	if (parent[a] == a) return a;
	else return parent[a] = get(parent[a]);
}

bool used[MAXN];
void merge(int a, int b){
	int u = get(a);
	int v = get(b);
	if (u != v) {
		if (sz[u] < sz[v]) {
			swap(u, v);
		}
		parent[v] = u;
		sz[u] += sz[v];
		l[u] = max(l[u], l[v]);
		r[u] = min(r[u], r[v]);
		used[v] = true;
	}
}
vector<int> g[MAXN];
void dfs(int u, int p) {
	h[u] = h[p] + 1;
	lca[u][0] = p;
	for (auto v : g[u]) {
		if (v == p) continue;
		dfs(v, u);
	}
}
int getlca(int a, int b) {
	if (a == b) return a;
	if (h[a] < h[b]) swap(a, b);
	for (int i = LOG - 1; i >= 0; i--) {
		int nxta = lca[a][i];
		if (h[b] <= h[nxta]) a = nxta;
	}
	if (a == b) return a;
	for (int i = LOG - 1; i >= 0; i--) {
		int nxta = lca[a][i], nxtb = lca[b][i];
		if (nxta != nxtb) {
			a = nxta;
			b = nxtb;
		}
	}
	return lca[a][0];
}
vector<int> getpath(int a, int b) {
	vector<int> tolca;
	int c = getlca(a, b);
	while (a != c) {
		tolca.push_back(a);
		a = lca[a][0];
	}
	vector<int> ans;
	ans = tolca;
	ans.push_back(c);

	tolca.clear();

	while (b != c) {
		tolca.push_back(b);
		b = lca[b][0];
	}
	reverse(tolca.begin(), tolca.end());
	for (auto v : tolca) ans.push_back(v);
	return ans;
}
int32_t main()
{
	cin >> n;
	prepare();

	for (int i = 2; i <= n; i++) {
		int u;
		cin >> u;
		g[u].push_back(i);
		g[i].push_back(u);
	}
	dfs(1, 1);
	for (int j = 1; j < LOG; j++) {
		for (int i = 1; i <= n; i++) {
			int nxt = lca[i][j - 1];
			lca[i][j] = lca[nxt][j - 1];
		}
	}
	for (int i = 1; i <= n; i++) cin >> l[i] >> r[i];
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		vector<int> fst = getpath(a, b);
		vector<int> sec = getpath(c, d);
		for (int i = 0; i < fst.size(); i++) {
			int u, v;
			u = fst[i];
			v = sec[i];
			merge(u, v);
		}
		int ans = 1;
		for (int i = 1; i <= n; i++) {
			if (used[i]) continue;
			int len = r[i] - l[i] + 1;
			if (len <= 0) len = 0;
			ans *= len;
			ans %= mod;
		}
		cout << ans << '\n';
	}
}