#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define sz(x) (x).size()

const int MOD = 1e9 + 7;
const int maxn = 2e5;

int binpow(int a, int p) {
   if (!p) {
      return 1;
   }
   if (p & 1) {
      return 1ll * a * binpow(a, p - 1) % MOD;
   }
   int res = binpow(a, p >> 1);
   return 1ll * res * res % MOD;
}

int add(int a, int b) {
   if ((a += b) >= MOD) a -= MOD;
   while (a < 0) a += MOD;
   return a;
}

int mul(int a, int b) {
   return 1ll * a * b % MOD;
}

int inv(int x) {
   return binpow(x, MOD - 2);
}

int n, q, anc[maxn];
int l[maxn], r[maxn];
int p[maxn], sizes[maxn], p_l[maxn], p_r[maxn];
int tin[maxn], tout[maxn];

vector<int> g[maxn];

int cur_ans, timer = 0;

void dfs(int v) {
   tin[v] = timer++;
   for (int u : g[v]) {
      if (u != anc[v]) {
         dfs(u);
      }
   }
   tout[v] = timer++;
}

bool ancestor(int a, int b) {
   return (tin[a] <= tin[b] && tout[b] <= tout[a]);
}

vector<int> get_path(int a, int b) {
   vector<int> path;
   while (!ancestor(a, b)) {
      path.push_back(a);
      a = anc[a];
   }
   path.push_back(a);
   vector<int> path_add;
   while (b != a) {
      path_add.push_back(b);
      b = anc[b];
   }
   for (int i = sz(path_add) - 1; i >= 0; i--) {
      path.push_back(path_add[i]);
   }
   return path;
}

void init() {
   cur_ans = 1;
   for (int i = 0; i < n; i++) {
      p[i] = i;
      p_l[i] = l[i];
      p_r[i] = r[i];
      sizes[i] = 1;
      cur_ans = mul(cur_ans, r[i] - l[i] + 1);
   }
   dfs(0);
}

int get(int x) {
   return (p[x] == x ? x : p[x] = get(p[x]));
}

void unite(int x, int y) {
   x = get(x), y = get(y);
   if (x == y) return;
   
   if (sizes[x] < sizes[y]) {
      swap(x, y);
   }
   if (p_r[x] >= p_l[x]) {
      cur_ans = mul(cur_ans, inv(p_r[x] - p_l[x] + 1));
   }
   if (p_r[y] >= p_l[y]) {
      cur_ans = mul(cur_ans, inv(p_r[y] - p_l[y] + 1));
   }
   p[y] = x;
   sizes[x] += sizes[y];
   p_l[x] = max(p_l[x], p_l[y]);
   p_r[x] = min(p_r[y], p_r[x]);
   if (p_r[x] < p_l[x]) {
      cur_ans = 0;
   } else {
      cur_ans = mul(cur_ans, p_r[x] - p_l[x] + 1);
   }
}

void apply(int a, int b, int c, int d) {
   vector<int> path1 = get_path(a, b);
   vector<int> path2 = get_path(c, d);
   assert(sz(path1) == sz(path2));
   for (int i = 0; i < sz(path1); i++) {
      unite(path1[i], path2[i]);
   }
}

int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   
   cin >> n;
   for (int i = 1; i < n; i++) {
      cin >> anc[i];
      g[--anc[i]].push_back(i);
      g[i].push_back(anc[i]);
   }
   for (int i = 0; i < n; i++) {
      cin >> l[i] >> r[i];
   }
   init();
   cin >> q;
   while (q--) {
      int a, b, c, d;
      cin >> a >> b >> c >> d; --a, --b, --c, --d;
      if (cur_ans) {  
         apply(a, b, c, d);
      }
      cout << cur_ans << '\n';
   }
}