#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
using namespace std;

vector<int> a;
vector<int> t;
vector<int> path3;

const int m = 1e9 + 7;

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        t[v] = a[tl] % m;
        return;
    }
    int tm = tl + (tr - tl) / 2;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm, tr);
    t[v] = t[2 * v] * t[2 * v + 1] % m;
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l) {
        return 1;
    }
    if (tl >= l && tr <= r) {
        return t[v];
    }
    int tm = tl + (tr - tl) / 2;
    int a = get(2 * v, tl, tm, l, r);
    int b = get(2 * v + 1, tm, tr, l, r);
    return a * b % m;
}

void update(int v, int tl, int tr, int pos, int x) {
    if (tl + 1 == tr) {
        t[v] = x % m;
    } else {
        int tm = tl + (tr - tl) / 2;
        if (tm >= pos) {
            update(2 * v, tl, tm, pos, x);
        } else {
            update(2 * v + 1, tm, tr, pos, x);
        }
        t[v] = t[2 * v] * t[2 * v + 1] % m;
    }
}

int funcWithPath(vector<int> path1, vector<int> path2, vector<pair<int, int>>& seg) {
    vector<bool> used(a.size(), 0);
    set<int> zeros;
    int ans = 1;
    int i = path1.size() - 1;
    int j = path2.size() - 1;
    while (path1[i] != path1[0]) {
        int z = path1[i];
        int x = path2[j];
        if (seg[x].first != seg[z].first && seg[x].second != seg[z].second) {
            if (seg[x].first > seg[z].second || seg[z].first > seg[x].second) {
                return 0;
            }
            seg[x] = {max(seg[x].first, seg[z].first), min(seg[x].second, seg[z].second)};
            seg[z] = {seg[x].first, seg[x].second};
            cout << seg[x].first << " " << seg[x].second << '\n';
            a[x] = max(0, seg[x].second - seg[x].first + 1);
            a[z] = max(0, seg[z].second - seg[z].first + 1);
            update(1, 0, a.size(), x + 1, a[x]);
            update(1, 0, a.size(), z + 1, a[z]);
        }
        if (!used[x] && !used[z])
            ans *= a[x];
        used[x] = 1;
        used[z] = 1;
        if (ans == 0) {
            return 0;
        }
        ans %= m;
        zeros.insert(x);
        zeros.insert(z);
        i--;
        j--;
    }
    int z = path1[i];
    int x = path2[j];
    if (seg[x].first != seg[z].first && seg[x].second != seg[z].second) {
        seg[x] = {max(seg[x].first, seg[z].first), min(seg[x].second, seg[z].second)};
        seg[z] = {seg[x].first, seg[x].second};
        a[x] = max(0, seg[x].second - seg[x].first + 1);
        a[z] = max(0, seg[z].second - seg[z].first + 1);
        update(1, 0, a.size(), x + 1, a[x]);
        update(1, 0, a.size(), z + 1, a[z]);
    }
    if (!used[x] && !used[z]) {
        ans *= a[x];
    }
    if (ans == 0) {
        return 0;
    }
    ans %= m;
    zeros.insert(x);
    zeros.insert(z);
    int prev = 0;
    int cnt = 0;
    int cur = 0;
    for (auto el : zeros) {
        cur = el;
        if (cnt) prev += 1;
        cnt += 1;
        if (prev != el) {
            int add = get(1, 0, a.size(), prev, el);
            ans *= add;
            ans %= m;
            prev = el + 1;
        }
    }
    int add = get(1, 0, a.size(), cur + 1, a.size());
    ans *= add;
    ans %= m;
    return ans;
}

void dfs(vector<bool>& used, vector<vector<int>>& g, vector<int>& path, int v, int f) {
    used[v] = 1;
    path.push_back(v);
    if (v == f) {
        path3.resize(path.size());
        for (int i = 0; i < path.size(); ++i) {
            path3[i] = path[i];
        }
        return;
    }
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(used, g, path, u, f);
        }
    }
    path.pop_back();
}

vector<int> getPath(int x, int y, vector<vector<int>>& g) {
    vector<int> path;
    vector<bool> used(g.size(), 0);
    dfs(used, g, path, x, y);
    return path3;
}

signed main() {

    int n;
    cin >> n;

    a.resize(n);
    t.resize(4 * n);

    vector<pair<int, int>> seg(n);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        v--;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a[i] = r - l + 1;
        seg[i] = {l, r};
    }

    build(1, 0, n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, y, z, w;
        cin >> x >> y >> z >> w;
        x--;
        y--;
        z--;
        w--;

        vector<int> path1;
        vector<int> path2;
        if (x == 0) {
            path1 = getPath(y, x, g);
        } else {
            path1 = getPath(x, y, g);
            reverse(path1.begin(), path1.end());
        }
        if (z == 0) {
            path2 = getPath(w, z, g);
        } else {
            path2 = getPath(z, w, g);
            reverse(path2.begin(), path2.end());
        }
        cout << funcWithPath(path1, path2, seg) << '\n';
    }
}