#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>

constexpr int N = 2e5 + 5;

namespace hash {
using hash_t = uint64_t;

constexpr hash_t mod = (1ULL << 61) - 1;
#ifdef LOCAL
constexpr hash_t base = 10;
#else
constexpr hash_t base = 1e9 + 2086;
#endif
constexpr uint64_t mul(uint64_t a, uint64_t b) {
    __uint128_t rs = __uint128_t(a) * b;
    uint64_t res = (rs & mod) + (rs >> 61);
    res = (res & mod) + (res >> 61);
    return res;
}

constexpr uint64_t add(uint64_t a, uint64_t b) {
    return a + b - mod * (a + b >= mod);
}

constexpr uint64_t power(uint64_t b, uint64_t e) {
    uint64_t r = 1;
    for (; e > 0; e >>= 1) {
        if (e & 1) {
            r = mul(r, b);
        }
        b = mul(b, b);
    }
    return r;
}

constexpr hash_t r_base = power(base, mod - 2);

hash_t pw[N], r_pw[N];

void init(int n) {
    pw[0] = r_pw[0] = 1;
    for (int i = 1; i <= n; i++) {
        pw[i] = mul(pw[i - 1], base);
        r_pw[i] = mul(r_pw[i - 1], r_base);
    }
}

};  // namespace hash

using hash::hash_t;

struct CUM {
    static constexpr int ans_mod = 1e9 + 7;
    static int add(int a, int b) {
        return a + b - ans_mod * (a + b >= ans_mod);
    }
    static int mul(int a, int b) {
        return a * 1ULL * b % ans_mod;
    }
    static int power(int b, int e) {
        int r = 1;
        for (; e > 0; e >>= 1) {
            if (e & 1) {
                r = mul(r, b);
            }
            b = mul(b, b);
        }
        return r;
    }

    std::vector<std::pair<int, int>> cum;
    std::vector<std::vector<int>> shit;
    std::vector<int> prv;
    int n;

    int ans;

    // template <typename fn_t>
    CUM(std::vector<std::pair<int, int>> cum, const auto& upd) : cum(cum), prv(cum.size(), -1), n(cum.size()) {
        ans = 1;
        for (auto& [l, r] : cum) {
            ans = mul(ans, r - l);
        }
        shit.assign(n, {});
        for (int i = 0; i < n; i++) {
            shit[i] = {i};
            upd(i, i + 1);
        }
    }

    int get(int v) {
        return prv[v] == -1 ? v : prv[v] = get(prv[v]);
    }

    int get_cum(int v) {
        return std::max(0, cum[v].second - cum[v].first);
    }

    void merge(int a, int b, const auto& upd) {
        a = get(a);
        b = get(b);
        assert(a != b);
        if (shit[a].size() < shit[b].size()) {
            std::swap(a, b);
        }
        shit[a].insert(shit[a].end(), shit[b].begin(), shit[b].end());
        for (int v : shit[b]) {
            upd(v, hash::add(a, hash::mod - b));
        }

        prv[b] = a;

        if (ans == 0) {
            return;
        }
        ans = mul(ans, power(get_cum(a), ans_mod - 2));
        ans = mul(ans, power(get_cum(b), ans_mod - 2));

        cum[a].first = std::max(cum[a].first, cum[b].first);
        cum[a].second = std::min(cum[a].second, cum[b].second);

        ans = mul(ans, get_cum(a));
    }
};

struct BIT {
    std::vector<hash_t> data;
    int n;

    BIT(int n) : n(n) {
        data.assign(n, 0);
    }

    void upd(int i, hash_t val) {
        for (; i < n; i |= i + 1) {
            data[i] = hash::add(data[i], val);
        }
    }

    hash_t get(int i) {
        hash_t res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res = hash::add(res, data[i]);
        }
        return res;
    }
};

int32_t main() {
#ifdef LOCAL
    // auto fuck_me_pls = freopen("test.in", "r", stdin);
#endif
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;

    hash::init(n);

    std::vector<int> prv(n);
    std::vector<std::vector<int>> gr(n);
    for (int i = 1; i < n; i++) {
        std::cin >> prv[i];
        prv[i]--;
        gr[prv[i]].push_back(i);
    }
    std::vector<std::pair<int, int>> input(n);
    for (auto& [l, r] : input) {
        std::cin >> l >> r;
        l--;
    }

    std::vector<int> tin_2(n), tout_2(n), depth(n), jmp(n);
    std::vector<int> eul_2;
    std::vector<std::vector<int>> shit(n);
    std::vector<int> tin(n), tout(n), eul;

    auto dfs1 = [&](auto dfs1, int v, int d) -> void {
        depth[v] = d;
        jmp[v] = prv[v];
        tin_2[v] = eul_2.size();
        shit[depth[v]].push_back(eul_2.size());
        eul_2.push_back(v);

        tin[v] = eul.size();
        eul.push_back(v);

        if (d > 1) {
            if (depth[prv[v]] - depth[jmp[prv[v]]] == depth[jmp[prv[v]]] - depth[jmp[jmp[prv[v]]]]) {
                jmp[v] = jmp[jmp[prv[v]]];
            }
        }

        for (int t : gr[v]) {
            dfs1(dfs1, t, d + 1);
            shit[depth[v]].push_back(eul_2.size());
            eul_2.push_back(v);
        }

        tout_2[v] = eul_2.size();
        tout[v] = eul.size();
    };
    dfs1(dfs1, 0, 0);

    auto jump_bin = [&](int v, int d) {
        while (depth[v] > d) {
            if (depth[jmp[v]] >= d) {
                v = jmp[v];
            } else {
                v = prv[v];
            }
        }
        return v;
    };

    auto jump = [&](int v, int d) {
        assert(depth[v] >= d);
        if (depth[v] - d < 10) {
            return jump_bin(v, d);
        }
        auto& vec = shit[d];
        auto it = std::lower_bound(vec.begin(), vec.end(), tin_2[v]);
        assert(it != vec.end());
        int id = *it;
        int res = eul_2[id];

        // assert(res == jump_bin(v, d));

        return res;
    };

    auto lca = [&](int a, int b) {
        if (depth[a] > depth[b]) {
            std::swap(a, b);
        }
        b = jump(b, depth[a]);
        while (a != b) {
            if (jmp[a] != jmp[b]) {
                a = jmp[a];
                b = jmp[b];
            } else {
                a = prv[a];
                b = prv[b];
            }
        }
        return a;
    };

    auto jmp_path = [&](int a, int b, int l, int d) {
        int pt = depth[a] - depth[l];
        if (d <= pt) {
            return jump(a, depth[a] - d);
        } else {
            return jump(b, depth[l] + (d - pt));
        }
    };

    BIT bit(n);
    BIT r_bit(n);
    auto upd = [&](int v, hash_t dlt) {
        hash_t r_dlt = hash::mul(dlt, hash::r_pw[depth[v]]);
        dlt = hash::mul(dlt, hash::pw[depth[v]]);

        bit.upd(tin[v], dlt);
        bit.upd(tout[v], hash::add(0, hash::mod - dlt));

        r_bit.upd(tin[v], r_dlt);
        r_bit.upd(tout[v], hash::add(0, hash::mod - r_dlt));
    };

    auto is_anc = [&](int a, int b) {
        bool res = tin[a] <= tin[b] && tin[b] < tout[a];
        return res;
    };

    auto get_vert_hash = [&](int a, int b) {
        if (is_anc(a, b)) {
            hash_t p1 = a == 0 ? 0 : bit.get(tin[prv[a]]);
            hash_t p2 = bit.get(tin[b]);

            hash_t h = hash::add(p2, hash::mod - p1);
            h = hash::mul(h, hash::r_pw[depth[a]]);
            return h;
        } else if (is_anc(b, a)) {
            hash_t p1 = b == 0 ? 0 : r_bit.get(tin[prv[b]]);
            hash_t p2 = r_bit.get(tin[a]);

            hash_t h = hash::add(p2, hash::mod - p1);
            h = hash::mul(h, hash::pw[depth[b]]);
            h = hash::mul(h, hash::pw[depth[a] - depth[b]]);
            return h;
        }
        assert(!"CUM");
    };

    CUM cum(input, upd);

    int q;
    std::cin >> q;
    std::vector<std::array<int, 4>> quer(q);
    for (auto& [a, b, c, d] : quer) {
        std::cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
    }

    for (auto& [a, b, c, d] : quer) {
        // if (tin_2[a] > tin_2[b]) {
        //     std::swap(a, b);
        // }
        // if (tin_2[c] > tin_2[d]) {
        //     std::swap(c, d);
        // }
        int l1 = lca(a, b);
        int l2 = lca(c, d);

        int ln = depth[a] + depth[b] - 2 * depth[l1];
        ln++;
        std::array<int, 4> ar;
        ar[0] = 0;
        ar[3] = ln - 1;
        ar[1] = depth[a] - depth[l1];
        ar[2] = depth[c] - depth[l2];
        std::sort(ar.begin(), ar.end());

        std::array<std::array<int, 4>, 2> fuck;

        for (int i = 0; i < 4; i++) {
            fuck[0][i] = jmp_path(a, b, l1, ar[i]);
            fuck[1][i] = jmp_path(c, d, l2, ar[i]);
        }

        for (int i = 0; i < 3; i++) {
            int x1 = fuck[0][i], y1 = fuck[0][i + 1];
            int x2 = fuck[1][i], y2 = fuck[1][i + 1];
            int p = ar[i + 1] - ar[i] + 1;

            int dir1 = is_anc(x1, y1) * 2 - 1;
            int dir2 = is_anc(x2, y2) * 2 - 1;

            auto get_shit = [&](int a, int b, int dr, int d) {
                if (dr == 1) {
                    return jump(b, depth[a] + d);
                } else {
                    return jump(a, depth[a] - d);
                }
            };

            while (get_vert_hash(x1, y1) != get_vert_hash(x2, y2)) {
                hash_t cum_1 = get_vert_hash(x1, y1);
                hash_t cum_2 = get_vert_hash(x2, y2);
                hash_t cum_2_ffff = get_vert_hash(x2, y2);
                int beg = 0, end = p;
                while (beg + 1 < end) {
                    int mid = (beg + end) / 2;
                    hash_t h1 = get_vert_hash(x1, get_shit(x1, y1, dir1, mid - 1));
                    hash_t h2 = get_vert_hash(x2, get_shit(x2, y2, dir2, mid - 1));
                    if (h1 == h2) {
                        beg = mid;
                    } else {
                        end = mid;
                    }
                }

                int vtx1 = jmp_path(x1, y1, lca(x1, y1), beg);
                int vtx2 = jmp_path(x2, y2, lca(x2, y2), beg);
                cum.merge(vtx1, vtx2, upd);
            }
        }

        int ans = cum.ans;
        std::cout << ans << "\n";
    }

    return 0;
}
