#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;

int binpow(int n, int k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

vector <int> pr, h;
vector < pair <int, int> > b;
int otv = 1;

int fund(int v){
    return (pr[v] == v) ? v : pr[v] = fund(pr[v]);
}

void unite(int v, int u){
    v = fund(v);
    u = fund(u);
    if(v == u){
        return;
    }

    if(h[v] < h[u]){
        swap(v, u);
    }

    pr[u] = v;
    h[v] += (h[v] == h[u]);

    otv = (otv * binpow(max(0ll, b[v].second - b[v].first + 1), mod - 2)) % mod;
    otv = (otv * binpow(max(0ll, b[u].second - b[u].first + 1), mod - 2)) % mod;

    b[v].first = max(b[v].first, b[u].first);
    b[v].second = min(b[v].second, b[u].second);

    otv = (otv * max(0ll, b[v].second - b[v].first + 1)) % mod;
}

void solve(){
    int n;
    cin >> n;

    b.resize(n);
    pr.resize(n);
    h.resize(n);

    vector < vector <int> > a(n);
    vector <int> p(n);
    for(int i = 1; i < n; ++i){
        int x;
        cin >> x;
        --x;

        p[i] = x;
        a[x].push_back(i);
        a[i].push_back(x);
    }

    for(int i = 0; i < n; ++i){
        cin >> b[i].first >> b[i].second;
        otv = (otv * max(0ll, b[i].second - b[i].first + 1)) % mod;

        pr[i] = i;
        h[i] = 0;
    }

    vector <int> way, put;
    int f = 0;
    function <void(int, int)> dfs = [&](int v, int p){
        way.push_back(v);
        if(v == f){
            put = way;
            return;
        }

        for(auto to : a[v]){
            if(to != p) {
                dfs(to, v);
            }
        }

        way.pop_back();
    };

    int m;
    cin >> m;
    while(m--){
        int x, y, z, t;
        cin >> x >> y >> z >> t;
        --x; --y; --z; --t;

        f = y;
        dfs(x, -1);
        vector <int> c = put;
        way.clear();

        f = t;
        dfs(z, -1);
        vector <int> d = put;
        way.clear();

        for(int i = 0; i < c.size(); ++i){
            unite(c[i], d[i]);
        }

        cout << otv << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}
