#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int add(int a, int b) {
    return (a + b) % MOD;
}

int sub(int a, int b) {
    return ((a - b) % MOD + MOD) % MOD;
}

int binpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int b = binpow(a, n / 2);
        return mul(b, b);
    } else {
        return mul(a, binpow(a, n - 1));
    }
}

int divide(int a, int b) {
    if (b == 0) {
        return 0;
    }
    return mul(a, binpow(b, MOD - 2));
}

pii intersect(pii lhs, pii rhs) {
    pii res = {max(lhs.first, rhs.first), min(lhs.second, rhs.second)};
    if (res.first >= res.second) {
        res = {0, 0};
    }
    return res;
}

struct DSU {
    int n;
    int ans = 1;
    vector<pii> comp;
    vector<int> par;
    vector<int> siz;

    DSU() = default;
    DSU(int n) : n(n), comp(n), par(n), siz(n, 1) {
        iota(all(par), 0);
    }

    int get(int v) {
        if (par[v] == v) {
            return v;
        }
        return par[v] = get(par[v]);
    }

    void add_comp(int v, pii s) {
        comp[v] = s;
        ans = mul(ans, s.second - s.first);
    }

    int unite(int v, int u) {
        v = get(v);
        u = get(u);
        if (v == u) {
            return 0;
        }

        ans = divide(ans, comp[v].second - comp[v].first);
        ans = divide(ans, comp[u].second - comp[u].first);

        if (siz[v] > siz[u]) {
            swap(v, u);
        }
        par[v] = u;
        siz[u] += siz[v];
        comp[u] = intersect(comp[u], comp[v]);

        ans = mul(ans, comp[u].second - comp[u].first);

        return 1;
    }
};

int n;
vector<vector<int>> g;
vector<pii> seg;
vector<int> par;

void dfs(int v, int p) {
    par[v] = p;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}

void solve() {
    cin >> n;
    g.assign(n, {});
    seg.assign(n, {-1, -1});
    par.assign(n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].emplace_back(i);
        g[i].emplace_back(p);
    }

    DSU dsu(n);
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].first >> seg[i].second;
        ++seg[i].second;
        dsu.add_comp(i, seg[i]);
    }
    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        dfs(a, -1);
        vector<int> path;
        int v = b;
        while (v != -1) {
            path.emplace_back(v);
            v = par[v];
        }
        dfs(c, -1);
        int ptr = 0;
        v = d;
        while (v != -1) {
            dsu.unite(v, path[ptr]);
            ++ptr;
            v = par[v];
        }
        cout << dsu.ans << en;
    }
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
