#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 2e9;
const ll MOD = 1e9 + 7;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int ans = 1;
int timer = 0;
vector <int> link;
vector <int> sz;
vector <pair <int, int>> k;
vector <vector <int>> sm;
vector <int> tin, tout;
vector <int> p;

int bin_pow(int a, int n){
    if (n == 0) return 1;
    int g = bin_pow(a, n / 2);
    g *= g;
    g %= MOD;
    if (n % 2 == 1) return (g * a) % MOD;
    return g;
}

pair <int, int> upd(pair <int, int> &a, pair <int, int> &b){
    pair <int, int> c;
    c.first = max(a.first, b.first);
    c.second = min(a.second, b.second);
    return c;
}

int find(int a){
    if (link[a] == a) return a;
    return link[a] = find(link[a]);
}

bool same(int a, int b){
    return find(a) == find(b);
}

void unite(int a, int b){
    a = find(a);
    b = find(b);
    if (same(a, b)) return;
    if (sz[a] < sz[b]) swap(a, b);
    link[b] = a;
    int g = bin_pow(max(k[a].second - k[a].first + 1, 0ll), MOD - 2);
    ans *= g;
    ans %= MOD;
    g = bin_pow(max(k[b].second - k[b].first + 1, 0ll), MOD - 2);
    ans *= g;
    ans %= MOD;
    k[a] = upd(k[a], k[b]);
    sz[a] += sz[b];
    g = max(k[a].second - k[a].first + 1, 0ll);
    ans *= g;
    ans %= MOD;
}

void dfs(int v, int p = -1){
    tin[v] = timer++;
    for (int i = 0; i < sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p) continue;
        dfs(to, v);
    }
    tout[v] = timer++;
}

bool anc(int a, int b){
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void f(int a, int b, int c, int d){
    while (!anc(a, b) && !anc(c, d)){
        unite(a, c);
        a = p[a], c = p[c];
    }
    while (!anc(b, a) && !anc(d, c)){
        unite(b, d);
        b = p[b], d = p[d];
    }
    if (anc(a, b) && anc(c, d)){
        unite(a, c);
    }else if (anc(a, b) && anc(d, c)){
        vector <int> h;
        while (!anc(c, d)){
            h.push_back(c);
            c = p[c];
        }
        h.push_back(d);
        while (!anc(b, a)){
            unite(b, h.back());
            b = p[b], h.pop_back();
        }
        unite(b, h.back());
    }else if (anc(b, a) && anc(c, d)){
        vector <int> h;
        while (!anc(d, c)){
            h.push_back(d);
            d = p[d];
        }
        h.push_back(c);
        while (!anc(a, b)){
            unite(a, h.back());
            a = p[a], h.pop_back();
        }
        unite(a, h.back());
    }
}

signed main(){
    Fast();
    int n;
    cin >> n;
    p.resize(n);
    sm.resize(n);
    sz.resize(n);
    link.resize(n);
    tin.resize(n);
    tout.resize(n);
    k.resize(n);
    p[0] = -1;
    for (int i = 1; i < n; i++){
        cin >> p[i];
        p[i]--;
        sm[p[i]].push_back(i);
        sm[i].push_back(p[i]);
    }
    dfs(0);
    for (int i = 0; i < n; i++){
        int l, r;
        cin >> l >> r;
        k[i] = {l, r};
        ans *= (r - l + 1);
        ans %= MOD;
        sz[i] = 1;
        link[i] = i;
    }
    int m;
    cin >> m;
    for (int _ = 0; _ < m; _++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        f(a, b, c, d);
        cout << ans << endl;
    }
    return 0;
}
