#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = ::int64_t;
const int N = 200000, LOG = 18;
vector<int> g[N];
int h[N], up[LOG][N], l[N], r[N];
void dfs(int v) {
    for (int to : g[v]) {
        up[0][to] = v;
        h[to] = h[v] + 1;
        dfs(to);
    }
}
int getk(int v, int k) {
    for (int i = 0; i < LOG; ++i) {
        if (k & (1 << i)) v = up[i][v];
    }
    return v;
}
int lca(int a, int b) {
    if (h[a] < h[b]) swap(a, b);
    a = getk(a, h[a] - h[b]);
    if (a == b) return a;
    for (int i = LOG - 1; i >= 0; --i) {
        if (up[i][a] != up[i][b]) {
            a = up[i][a], b = up[i][b];
        }
    }
    return up[0][a];
}
int dsu[N];
int get(int v) {
    return dsu[v] < 0 ? v : dsu[v] = get(dsu[v]);
}
const ll MOD = 1e9 + 7;
ll ans = 1;
ll inv(ll x) {
    ll res = 1;
    for (ll pw = MOD - 2; pw > 0; pw >>= 1) {
        if (pw & 1) res = res * x % MOD;
        x = x * x % MOD;
    }
    return res;
}
bool unite(int a, int b) {
    a = get(a), b = get(b);
    if (a == b) return false;
    if (dsu[a] > dsu[b]) swap(a, b);
    ans = ans * inv(r[a] - l[a]) % MOD;
    ans = ans * inv(r[b] - l[b]) % MOD;
    l[a] = max(l[a], l[b]);
    r[a] = min(r[a], r[b]);
    ans = ans * max(0, r[a] - l[a]) % MOD;
    //
    dsu[a] += dsu[b];
    dsu[b] = a;
    return true;
}

void solve() {
    int n;
    cin >> n;
    fill(dsu, dsu + n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].emplace_back(i);
    }
    dfs(0);
    for (int i = 1; i < LOG; ++i) {
        for (int v = 0; v < n; ++v) {
            up[i][v] = up[i - 1][up[i - 1][v]];
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        r[i]++;
        ans = ans * (r[i] - l[i]) % MOD;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        if (ans != 0) {
            vector<int> fl, fr, sl, sr;
            while (a != b) {
                if (h[a] >= h[b]) {
                    fl.emplace_back(a);
                    a = up[0][a];
                } else {
                    fr.emplace_back(b);
                    b = up[0][b];
                }
            }
            fl.emplace_back(a);
            std::reverse(fr.begin(), fr.end());
            for (int x : fr) fl.emplace_back(x);
            while (c != d) {
                if (h[c] >= h[d]) {
                    sl.emplace_back(c);
                    c = up[0][c];
                } else {
                    sr.emplace_back(d);
                    d = up[0][d];
                }
            }
            sl.emplace_back(c);
            std::reverse(sr.begin(), sr.end());
            for (int x : sr) sl.emplace_back(x);
            for (int j = 0; j < sz(fl); ++j) {
                unite(fl[j], sl[j]);
            }
        }
        cout << ans << '\n';
    }
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    while (tt--) solve();
    return 0;
}