#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

const int MOD = 1e9 + 7;

int add(int a, int b){
	a += b;
	if (a >= MOD){
		a -= MOD;
	}
	return a;
}

int sub(int a, int b){
	a -= b;
	if (a < 0){
		a += MOD;
	}
	return a;
}

int mul(int a, int b){
	return (a * 1ll * b) % MOD;
}

int bin_pow(int a, int b){
	if (b == 0){
		return 1;
	}
	if (b % 2 == 1){
		return mul(a, bin_pow(a, b - 1));
	}
	int t = bin_pow(a, b / 2);
	return mul(t, t);
}

pair<int, int> isect(pair<int, int> a, pair<int, int> b){
	return {max(a.first, b.first), min(a.second, b.second)};
}

int len(pair<int, int> a){
	return max((int)0, a.second - a.first + 1);
}

vector<pair<int, int>> a;
vector<pair<int, int>> seg;
vector<int> dsup;
vector<int> dsusz;
int query_res = 1;

int find_parent(int v){
	if (dsup[v] == v){
		return v;
	}
	return dsup[v] = find_parent(dsup[v]);
}

bool unite(int a, int b){
	a = find_parent(a);
	b = find_parent(b);
	if (a == b){
//		cout << "not unite " << a << " " << b << "\n";
		return 0;
	}
	if (dsusz[a] > dsusz[b]){
		swap(a, b);
	}
	dsup[a] = b;
//	cout << "before merging: " << query_res << "\n";
	query_res = mul(query_res, bin_pow(len(seg[a]), MOD - 2));
	query_res = mul(query_res, bin_pow(len(seg[b]), MOD - 2));
	seg[b] = isect(seg[a], seg[b]);
	query_res = mul(query_res, len(seg[b]));
//	cout << "after merging: " << query_res << "\n";
	dsusz[b] += dsusz[a];
	return 1;
}

int main(){
//	ios_base::sync_with_stdio(0);
//	cout.tie(0);
//	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
//	cin >> T;
	while (T--){
		int n;
		cin >> n;
		vector<vector<int>> g(n + 1);
		vector<int> p(n + 1, -1);
		for (int i = 2; i <= n; i++){
			int pp;
			cin >> pp;
			g[pp].push_back(i);
			p[i] = pp;
		}
		a.resize(n + 1);
		seg.resize(n + 1);
		dsusz.resize(n + 1);
		dsup.resize(n + 1);
		for (int i = 1; i <= n; i++){
			cin >> a[i].first >> a[i].second;
		}
		for (int i = 1; i <= n; i++){
			query_res = mul(query_res, len(a[i]));
		}
		for (int i = 1; i <= n; i++){
			dsup[i] = i;
			dsusz[i] = 1;
			seg[i] = a[i];
		}
		vector<int> tin(n + 1);
		vector<int> tout(n + 1);
		int timer = 0;
		function<void(int)> dfs = [&](int v){
			tin[v] = timer++;
			for (auto& u : g[v]){
				dfs(u);
			}
			tout[v] = timer++;
		};
		dfs(1);
		function<bool(int, int)> anc = [&](int v, int u){
			return tin[v] <= tin[u] && tout[v] >= tout[u];
		};
		function<vector<int>(int, int)> get_path = [&](int v, int u){
			vector<int> res;
			while (v != -1 && !anc(v, u)){
				res.push_back(v);
				v = p[v];
			}
//			cout << "here";
			int cursz = res.size();
			while (u != -1 && anc(v, u)){
				res.push_back(u);
				u = p[u];
			}
			reverse(res.begin() + cursz, res.end());
			return res;
		};
		int m;
		cin >> m;
		for (int id = 0; id < m; id++){
//			cout << id << "\n";
			int a, b, c, d;
			cin >> a >> b >> c >> d;
			vector<int> path1 = get_path(a, b);
			vector<int> path2 = get_path(c, d);
//			for (int i = 0; i < path1.size(); i++){
//				cout << path1[i] << " ";
//			}
//			cout << "\n";
//			for (int i = 0; i < path2.size(); i++){
//				cout << path2[i] << " ";
//			}
//			cout << "\n";
			for (int i = 0; i < path1.size(); i++){
				unite(path1[i], path2[i]);
			}
			cout << query_res << "\n";
		}
	}
	return 0;
}
