#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;
const int md = 1e9 + 7;

int add(int a, int b) {
	return a + b < md ? a + b : a + b - md;
}

int sub(int a, int b) {
	return a - b >= 0 ? a - b : a - b + md;
}

int mul(int a, int b) {
	return a * 1ll * b % md;
}

int pw(int a, int n) {
	int ret = 1;
	while (n > 0) {
		if (n & 1) {
			ret = mul(ret, a);
		}
		a = mul(a, a);
		n >>= 1;
	}
	return ret;
}

int inv(int a) {
	return pw(a, md - 2);
}

int n;
int p[N];
vector<int> g[N];
int L[N], R[N];
int sz[N];
int top[N];
int tin[N], tout[N], tmr;
vector<int> ord;
int ans;
int dsu[N];
vector<int> comp[N];

void dfssz(int v) {
	sz[v] = 1;
	for (int u : g[v]) {
		dfssz(u);
		sz[v] += sz[u];
	}
	sort(g[v].begin(), g[v].end(), [&](int u1, int u2) {
		return sz[u1] > sz[u2];
	});
}

void dfshld(int v) {
	tin[v] = tmr++;
	ord.push_back(v);
	for (int u : g[v]) {
		top[u] = u == g[v][0] ? top[v] : u;
		dfshld(u);
	}
	tout[v] = tmr;
}

bool anc(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}

void merge(int v, int u) {
	v = dsu[v];
	u = dsu[u];
	if (v == u) {
		return;
	}
	if (comp[v].size() > comp[u].size()) {
		swap(v, u);
	}
	if (ans != 0) {
		ans = mul(ans, inv(R[v] - L[v] + 1));
		ans = mul(ans, inv(R[u] - L[u] + 1));
	}
	L[u] = max(L[u], L[v]);
	R[u] = min(R[u], R[v]);
	if (ans != 0) {
		if (L[u] > R[u]) {
			ans = 0;
		} else {
			ans = mul(ans, R[u] - L[u] + 1);
		}
	}
	for (int w : comp[v]) {
		dsu[w] = u;
		comp[u].push_back(w);
	}
}

vector<pair<int, int>> getpaths(int v, int u) {
	vector<pair<int, int>> l, r;
	while (top[v] != top[u]) {
		if (!anc(top[v], u)) {
			l.push_back({v, top[v]});
			v = p[top[v]];
		} else {
			r.push_back({top[u], u});
			u = p[top[u]];
		}
	}
	l.push_back({v, u});
	vector<pair<int, int>> ret;
	for (auto pp : l) {
		ret.push_back(pp);
	}
	for (auto pp : r) {
		ret.push_back(pp);
	}
	return ret;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
 		g[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> L[i] >> R[i];
	}
	p[0] = 0;
	dfssz(0);
	top[0] = 0;
	dfshld(0);
	ans = 1;
	for (int i = 0; i < n; ++i) {
		ans = mul(ans, R[i] - L[i] + 1);
	}
	for (int i = 0; i < n; ++i) {
		dsu[i] = i;
		comp[i] = {i};
	}
	int m;
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a, --b, --c, --d;
		auto p1 = getpaths(a, b);
		auto p2 = getpaths(c, d);
		int i = 0, j = 0;
		while (i < (int)p1.size() && j < (int)p2.size()) {
			auto &[v1, u1] = p1[i];
			auto &[v2, u2] = p2[j];
			int len1 = abs(tin[v1] - tin[u1]) + 1;
			int len2 = abs(tin[v2] - tin[u2]) + 1;
			merge(v1, v2);
			if (len1 == 1) {
				++i; 
			} else {
				if (tin[v1] < tin[u1]) {
					v1 = ord[tin[v1] + 1];
				} else {
					v1 = ord[tin[v1] - 1];
				}
			}
			if (len2 == 1) {
				++j;
			} else {
				if (tin[v2] < tin[u2]) {
					v2 = ord[tin[v2] + 1];
				} else {
					v2 = ord[tin[v2] - 1];
				}
			}
		}
		cout << ans << "\n";
	}
	return 0;
}