#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;
const int md = 1e9 + 7;
const int hshp = 1e6 + 3;
const int hshmd = 1e9 + 97;

int hshpw[N];

struct node {
	int len, hsh;
};

node merge(int f, const node &l, const node &r) {
	node ret;
	ret.len = l.len + r.len;
	if (f) {
		ret.hsh = (r.hsh + l.hsh * 1ll * hshpw[r.len]) % hshmd;
	} else {
		ret.hsh = (l.hsh + r.hsh * 1ll * hshpw[l.len]) % hshmd;
	}
	return ret;
}

int add(int a, int b) {
	return a + b < md ? a + b : a + b - md;
}

int sub(int a, int b) {
	return a - b >= 0 ? a - b : a - b + md;
}

int mul(int a, int b) {
	return a * 1ll * b % md;
}

int pw(int a, int n) {
	int ret = 1;
	while (n > 0) {
		if (n & 1) {
			ret = mul(ret, a);
		}
		a = mul(a, a);
		n >>= 1;
	}
	return ret;
}

int inv(int a) {
	return pw(a, md - 2);
}

int n;
int p[N];
vector<int> g[N];
int L[N], R[N];
int sz[N];
int top[N];
int tin[N], tout[N], tmr;
vector<int> ord;
int ans;
int dsu[N];
vector<int> comp[N];
node t[2][2 * N];

node tget(int f, int l, int r) {
	node retl = {0, 0}, retr = {0, 0};
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) {
			retl = merge(f, retl, t[f][l]);
			++l; 
		}
		if (r & 1) {
			--r;
			retr = merge(f, t[f][r], retr);
		}
	}
	return merge(f, retl, retr);
}

void tupd(int f, int i, int x) {
	i += n;
	t[f][i] = {1, x};
	for (i >>= 1; i > 0; i >>= 1) {
		t[f][i] = merge(f, t[f][2 * i], t[f][2 * i + 1]);
	}
}

void tbuild(int f) {
	for (int i = 0; i < n; ++i) {
		t[f][i + n] = {1, dsu[i]};
	}
	for (int i = n - 1; i > 0; --i) {
		t[f][i] = merge(f, t[f][2 * i], t[f][2 * i + 1]);
	}
}

void dfssz(int v) {
	sz[v] = 1;
	for (int u : g[v]) {
		dfssz(u);
		sz[v] += sz[u];
	}
	sort(g[v].begin(), g[v].end(), [&](int u1, int u2) {
		return sz[u1] > sz[u2];
	});
}

void dfshld(int v) {
	tin[v] = tmr++;
	ord.push_back(v);
	for (int u : g[v]) {
		top[u] = u == g[v][0] ? top[v] : u;
		dfshld(u);
	}
	tout[v] = tmr;
}

bool anc(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}
 
void merge(int v, int u) {
	v = dsu[v];
	u = dsu[u];
	if (v == u) {
		return;
	}
	if (comp[v].size() > comp[u].size()) {
		swap(v, u);
	}
	if (ans != 0) {
		ans = mul(ans, inv(R[v] - L[v] + 1));
		ans = mul(ans, inv(R[u] - L[u] + 1));
	}
	L[u] = max(L[u], L[v]);
	R[u] = min(R[u], R[v]);
	if (ans != 0) {
		if (L[u] > R[u]) {
			ans = 0;
		} else {
			ans = mul(ans, R[u] - L[u] + 1);
		}
	}
	for (int w : comp[v]) {
		dsu[w] = u;
		tupd(0, tin[w], u);
		tupd(1, tin[w], u);
		comp[u].push_back(w);
	}
}

vector<pair<int, int>> getpaths(int v, int u) {
	vector<pair<int, int>> l, r;
	while (top[v] != top[u]) {
		if (!anc(top[v], u)) {
			l.push_back({v, top[v]});
			v = p[top[v]];
		} else {
			r.push_back({top[u], u});
			u = p[top[u]];
		}
	}
	l.push_back({v, u});
	vector<pair<int, int>> ret;
	for (auto pp : l) {
		ret.push_back(pp);
	}
	reverse(r.begin(), r.end());
	for (auto pp : r) {
		ret.push_back(pp);
	}
	return ret;
}

int getprefhsh(int v, int u, int len) {
	if (tin[v] < tin[u]) {
		return tget(0, tin[v], tin[v] + len).hsh;
	}
	return tget(1, tin[v] - len + 1, tin[v] + 1).hsh;
}

void go(int &v, int &u, int &i, int d) {
	if (abs(tin[u] - tin[v]) + 1 == d) {
		++i;
	} else {
		if (tin[v] < tin[u]) {
			v = ord[tin[v] + d];
		} else {
			v = ord[tin[v] - d];
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	hshpw[0] = 1;
	for (int i = 1; i < N; ++i) {
		hshpw[i] = 1ll * hshpw[i - 1] * hshp % hshmd;
	}
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
 		g[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> L[i] >> R[i];
	}
	p[0] = 0;
	dfssz(0);
	top[0] = 0;
	dfshld(0);
	ans = 1;
	for (int i = 0; i < n; ++i) {
		ans = mul(ans, R[i] - L[i] + 1);
	}
	for (int i = 0; i < n; ++i) {
		dsu[i] = i;
		comp[i] = {i};
	}
	tbuild(0);
	tbuild(1);
	int m;
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a, --b, --c, --d;
		auto p1 = getpaths(a, b);
		auto p2 = getpaths(c, d);
		int i = 0, j = 0;
		while (i < (int)p1.size() && j < (int)p2.size()) {
			auto &[v1, u1] = p1[i];
			auto &[v2, u2] = p2[j];
			int len1 = abs(tin[v1] - tin[u1]) + 1;
			int len2 = abs(tin[v2] - tin[u2]) + 1;
			int mn = min(len1, len2);
			if (getprefhsh(v1, u1, mn) == getprefhsh(v2, u2, mn)) {
				go(v1, u1, i, mn);
				go(v2, u2, j, mn);
				continue;
			}
			int l = 0, r = mn;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (getprefhsh(v1, u1, mid) == getprefhsh(v2, u2, mn)) {
					l = mid;
				} else {
					r = mid;
				}
			}
			go(v1, u1, i, l);
			go(v2, u2, j, l);
			merge(v1, v2);
			go(v1, u1, i, 1);
			go(v2, u2, j, 1);
		}
		cout << ans << "\n";
	}
	return 0;
}