#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 2e5 + 42;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int binpow(int x, int N) {
    umax(x, 0LL);
    int ans = 1;
    while(N) {
        if(N & 1) ans = (ans * x) % mod;
        x = (x * x) % mod;
        N >>= 1;
    }
    return ans;
}

int n;
int d[MAX], p[MAX];
int l[MAX], r[MAX];
vector<int> adj[MAX];
vector<int> curr;
int ans = 1;

struct DSU {
    vector<int> p, siz, L, R;

    DSU(): p(n + 1), siz(n + 1), L(n + 1), R(n + 1) {}

    void create(int x) {
        p[x] = x;
        siz[x] = 1;
        L[x] = l[x];
        R[x] = r[x];
        ans = (ans * (r[x] - l[x] + 1)) % mod;
    }

    int get(int x) {
        return p[x] = (p[x] == x? x : get(p[x]));
    }

    void unite(int x, int y) {
        x = get(x), y = get(y);
        if(x != y) {
            if(siz[x] < siz[y]) swap(x, y);
            p[y] = x;
            siz[x] += siz[y];
            ans = (ans * binpow(R[x] - L[x] + 1, mod - 2)) % mod;
            ans = (ans * binpow(R[y] - L[y] + 1, mod - 2)) % mod;
            umax(L[x], L[y]);
            umin(R[x], R[y]);
            ans = (ans * (R[x] - L[x] + 1)) % mod;
        }
    }
};

vector<int> get(int a, int b) {
    int u = a, v = b;
    vector<int> pref, suff;
    while(u != v) {
        if(d[u] > d[v]) {
            pref.pb(u);
            u = p[u];
        }
        else {
            suff.pb(v);
            v = p[v];
        }
    }
    pref.pb(u);
    reverse(all(suff));
    for(auto i : suff) pref.pb(i);
    return pref;
}

void solve() {
    cin >> n;
    vector<vector<int>> g(n + 1);
    for(int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].pb(i);
    }
    for(int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
    }
    function<void(int)> calc = [&](int v) {
        for(auto to : g[v]) {
            d[to] = d[v] + 1;
            calc(to);
        }
    };
    calc(1);
    DSU dsu;
    for(int i = 1; i <= n; i++) dsu.create(i);
    int q;
    cin >> q;
    while(q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
//        if(!ans) {
//            cout << "0\n";
//            continue;
//        }
        auto p1 = get(a, b);
        auto p2 = get(c, d);
        assert(sz(p1) == sz(p2));
        int sz = sz(p1);
        for(int i = 0; i < sz; i++) {
            dsu.unite(p1[i], p2[i]);
        }
        cout << ans << '\n';
    }
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
*/

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
