#include <bits/stdc++.h>
#define int long long

using namespace std;


const int MOD = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct dsu {
  vector<int> p;
  vector<int> rank;
  int n;
  dsu(int n) {
    this->n = n;
    p.resize(n);
    rank.resize(n, 1);
    iota(p.begin(), p.end(), 0ll);
  }
  int find_leader(int v) {return p[v] == v ? v : p[v] = find_leader(p[v]);}
  void join(int a, int b) {
    int fa = find_leader(a);
    int fb = find_leader(b);
    if (rnd() % 2) p[fa] = fb;
    else p[fb] = fa;
  }
};

int bpow(int a, int b) {
  if (b == 0) return 1;
  if (b % 2) return a * bpow(a, b - 1) % MOD;
  else {
    int f = bpow(a, b / 2);
    return f * f % MOD;
  }
}

int inv(int b) {
  return bpow(b, MOD - 2);
}

int n;
vector<vector<int>> g;
vector<pair<int, int>> gr;
const int LOG = 19;
vector<vector<int>> up;
vector<int> tin, tout;

int timer = 0;
void dfs(int v, int p) {
  tin[v] = timer++;
  up[v][0] = p;
  for (int l = 1; l < LOG; l++)
    up[v][l] = up[up[v][l - 1]][l - 1];
  for (auto& to : g[v]) {
    if (to == p) continue;
    dfs(to, v);
  }
  tout[v] = timer++;
}

bool is_anc(int a, int b) {
  return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
  if (is_anc(a, b)) return a;
  if (is_anc(b, a)) return b;
  for (int l = LOG - 1; l >= 0; l--) {
    if (!is_anc(up[a][l], b)) {
      a = up[a][l];
    }
  }
  return up[a][0];
}

int intersect(pair<int, int> a, pair<int, int> b) {
  return max(0ll, min(a.second, b.second) - max(a.first, b.first) + 1);
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  cin >> n;
  g.resize(n);
  tin.resize(n);
  tout.resize(n);
  gr.resize(n);
  up.resize(n, vector<int>(LOG));
  for (int i = 1; i < n; i++) {
    int p;
    cin >> p;
    p--;
    g[p].push_back(i);
  }
  dfs(0, 0);
  int cur = 1;
  for (int i = 0; i < n; i++) {
    cin >> gr[i].first >> gr[i].second;
    cur = cur * (gr[i].second - gr[i].first + 1) % MOD;
  }
  dsu dd(n);
  int q;
  cin >> q;
  while (q--) {
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    a--, b--, c--, d--;
    vector<int> path1l, path1r, path2l, path2r;
    int l1 = lca(a, b);
    while (a != l1) {
      path1l.push_back(a);
      a = up[a][0];
    }
    path1l.push_back(a);
    while (b != l1) {
      path1r.push_back(b);
      b = up[b][0];
    }
    reverse(path1r.begin(), path1r.end());
    for (auto& i : path1r) path1l.push_back(i);
    int l2 = lca(c, d);
    while (c != l2) {
      path2l.push_back(c);
      c = up[c][0];
    }
    path2l.push_back(c);
    while (d != l2) {
      path2r.push_back(d);
      d = up[d][0];
    }
    reverse(path2r.begin(), path2r.end());
    for (auto& i : path2r) {
      path2l.push_back(i);
    }
    for (auto& i : path2l)
      i = dd.find_leader(i);
    for (auto& i : path1l)
      i = dd.find_leader(i);
    for (int i = 0; i < path1l.size(); i++) {
      path1l[i] = dd.find_leader(path1l[i]);
      path2l[i] = dd.find_leader(path2l[i]);
      cur = cur * intersect(gr[path2l[i]], gr[path1l[i]]) % MOD;
      int vr = max(0ll, gr[path1l[i]].second - gr[path1l[i]].first + 1);
      cur = cur * inv(vr) % MOD;
      if (path1l[i] != path2l[i]) {
        int vl = max(0ll, gr[path2l[i]].second - gr[path2l[i]].first + 1);
        cur = cur * inv(vl) % MOD;
      }
      dd.join(path1l[i], path2l[i]);
      gr[path2l[i]].first = max(gr[path1l[i]].first, gr[path2l[i]].first);
      gr[path1l[i]].first = gr[path2l[i]].first;
      gr[path2l[i]].second = min(gr[path1l[i]].second, gr[path2l[i]].second);
      gr[path1l[i]].second = gr[path2l[i]].second;
    }
    cout << cur << '\n';
  }
}