#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const ll mod = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


struct modular {
    ll x;

    ll binpow(ll a, ll n) {
        ll ans = 1;

        while (n != 0) {
            if (n & 1) {
                ans *= a;
                ans %= mod;
            }

            a *= a;
            a %= mod;
            n >>= 1;
        }

        return ans;
    }

    ll operator*(const ll a) const{
        return (x * a) % mod;
    }
    void operator*=(const ll a) {
        x = (x * a) % mod;
    }

    ll operator/(const ll a) {
        return (x * binpow(a, mod-2)) % mod;
    }

    void operator/=(const ll a) {
        x = (x * binpow(a, mod-2)) % mod;
    }
};


vpii tinout;

void calc_tinout(const vvi &g, int v) {
    static int time = 0;

    tinout[v].ff = time;

    for (int to : g[v]) {
        time++;
        calc_tinout(g, to);
        time++;
    }

    tinout[v].ss = time;
}


vi path(const vvi &g, const vi &p, int a, int b) {
    vi pa, pb;
    pa.push_back(a);

    while (!(tinout[a].ff <= tinout[b].ff && tinout[b].ss <= tinout[a].ss)) {
        a = p[a];
        pa.push_back(a);
    }
    while (b != a) {
        pb.push_back(b);
        b = p[b];
    }

    reverse(all(pb));
    copy(all(pb), back_inserter(pa));

    return pa;
}


struct dsu {
    vi p, sz;
    int n;

    dsu() {}

    dsu(int _n) {
        n = _n;
        sz.resize(n, 1);
        p.resize(n);
        iota(all(p), 0);
    }

    int pnt(int v) {
        if (v == p[v]) {
            return v;
        }
        return p[v] = pnt(p[v]);
    }

    void unite(int a, int b) {
        a = pnt(a);
        b = pnt(b);

        if (a == b) return;

        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
    }
};

int hui(ll m, ll i) {
    return m * 200000 + i+1;
}


void solve() {
    int n;
    cin >> n;

    vi p(n);
    p[0] = -1;

    vvi g(n);

    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;

        g[p[i]].push_back(i);
    }

    tinout.resize(n);
    calc_tinout(g, 0);

    modular ans;
    ans.x = 1;

    dsu dd(n);
    vll li(n, 0);
    vpll cost(n);

    for (int i = 0; i < n; i++) {
        cin >> cost[i].ff >> cost[i].ss;
        ans *= cost[i].ss - cost[i].ff + 1;
    }

    int m;
    cin >> m;

    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;

        vi w1 = path(g, p, a, b);
        vi w2 = path(g, p, c, d);

        for (int i = 0; i < (int)w1.size(); i++) {
            int p1 = dd.pnt(w1[i]);
            int p2 = dd.pnt(w2[i]);

            li[p1] = hui(m, i);
            ans /= cost[p1].ss - cost[p1].ff + 1;

            if (p1 != p2) {
                li[p2] = hui(m, i);
                ans /= cost[p2].ss - cost[p2].ff + 1;
            }

            int new_l = max(cost[p1].ff, cost[p2].ff);
            int new_r = min(cost[p1].ss, cost[p2].ss);

            dd.unite(p1, p2);
            int cur = dd.pnt(p1);
            li[cur] = m;
            cost[cur].ff = new_l;
            cost[cur].ss = new_r;

            ans *= max(0ll, cost[cur].ss - cost[cur].ff + 1);
        }

        cout << ans.x << '\n';
    }

}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}
