#include <bits/stdc++.h>

#define pb push_back
#define st string
#define ss second
#define ff first
#define all(a) a.begin(), a.end()
#define vout(a) for (auto u : a) cout << u << " ";
#define vec vector
#define ull unsigned long long
#define ld long double
#define ll long long

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using vvvi = vec<vvi>;
using pi = pair<int, int>;
using vpi = vec<pi>;
using vvpi = vec<vpi>;
using vvvpi = vec<vvpi>;

const int M = 1e9 + 7;
ll glans = 1;

struct Node {
    int sz = 1;
    int l;
    int r;
    int cnt;
};

vec<Node> snm;
vi par;

int getpow(int a, int p) {
    if (a == 0) {
        return 0;
    }
    if (p == 0) {
        return 1;
    }
    if (p == 1) {
        return a;
    }
    if (p % 2) {
        return ((ll) a * (ll) getpow(a, p - 1)) % (ll) M;
    }
    int x = getpow(a, p / 2);
    return ((ll) x * (ll) x) % (ll) M;
}

int getroot(int v) {
    if (par[v] == v) {
        return v;
    }
    return par[v] = getroot(par[v]);
}

void merge(int a, int b) {
    int ra = getroot(a);
    int rb = getroot(b);
    if (ra == rb) {
        return;
    }
    int cnt1 = snm[ra].cnt;
    int cnt2 = snm[rb].cnt;
    glans = (glans * (ll) getpow(cnt1, M - 2)) % (ll) M;
    glans = (glans * (ll) getpow(cnt2, M - 2)) % (ll) M;
    if (snm[ra].sz >= snm[rb].sz) {
        snm[ra].sz += snm[rb].sz;
        par[rb] = ra;
        snm[ra].l = max(snm[ra].l, snm[rb].l);
        snm[ra].r = min(snm[ra].r, snm[rb].r);
        snm[ra].cnt = max(0, snm[ra].r - snm[ra].l + 1);
        glans = (glans * (ll) snm[ra].cnt) % (ll) M;
    }
    else {
        snm[rb].sz += snm[ra].sz;
        par[ra] = rb;
        snm[rb].l = max(snm[ra].l, snm[rb].l);
        snm[rb].r = min(snm[ra].r, snm[rb].r);
        snm[rb].cnt = max(0, snm[rb].r - snm[rb].l + 1);
        glans = (glans * (ll) snm[rb].cnt) % (ll) M;
    }
}

vvi g;
vi tin;
vi tout;
int t = 0;

void dfs(int v, int p) {
    tin[v] = t++;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = t++;
}

int check(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int LCA(int a, int b, vi &path, vi &p, int x) {
    while (true) {
        if (check(a, b)) {
            if (!x) {
                path.pb(a);
            }
            return a;
        }
        path.pb(a);
        a = p[a];
    }
}

void solve() {
    int n; cin >> n;
    vi p(n, 0);
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x; cin >> x;
        x--;
        p[i + 1] = x;
        g[x].pb(i + 1);
    }
    vpi boa(n);
    for (int i = 0; i < n; i++) {
        int l, r; cin >> l >> r;
        boa[i] = {l, r};
    }

    snm.resize(n);
    par.resize(n);
    for (int i = 0; i < n; i++) {
        par[i] = i;
        snm[i].cnt = boa[i].ss - boa[i].ff + 1;
        snm[i].l = boa[i].ff;
        snm[i].r = boa[i].ss;
    }

    tin.assign(n, 0);
    tout.assign(n, 0);
    dfs(0, -1);

    for (int i = 0; i < n; i++) {
        glans = (glans * snm[i].cnt) % M;
    }

    int q; cin >> q;
    while (q--) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vi patha;
        vi pathc;
        vi tmp;
        LCA(a, b, patha, p, 0);
        tmp = {};
        LCA(b, a, tmp, p, 1);
        reverse(all(tmp));
        for (auto u : tmp) {
            patha.pb(u);
        }
        LCA(c, d, pathc, p, 0);
        tmp = {};
        LCA(d, c, tmp, p, 1);
        reverse(all(tmp));
        for (auto u : tmp) {
            pathc.pb(u);
        }
        for (int i = 0; i < patha.size(); i++) {
            merge(patha[i], pathc[i]);
        }

        cout << glans << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}
