#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;

vector<vector<int>> g;
vector<int> dep;

const int mod = 1e9 + 7;

void dfs(int v) {
    for (auto u : g[v]) {
        dep[u] = dep[v] + 1;
        dfs(u);
    }
}

ll binpow(ll x, ll p) {
    if (p == 0) {
        return 1;
    }

    ll res = binpow((x * x) % mod, p / 2);
    if (p % 2 == 1) {
        res = (res * x) % mod;
    }
    return res;
}

int inv(int x) {
    return binpow(x, mod - 2);
}

struct DSU {
    vector<int> r, p;
    vector<vector<int>> c;

    DSU() {}
    DSU(int n) {
        r.assign(n, 1);
        p.resize(n);
        iota(all(p), 0);
        c.resize(n);
        for (int i = 0; i < n; i++) c[i] = {i};
    }

    int get(int a) {
        if (p[a] != a) {
            p[a] = get(p[a]);
        }
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return false;
        }

        if (r[a] < r[b]) swap(a, b);
        r[a] += r[b];
        p[b] = a;
        for (auto el : c[b]) c[a].push_back(el);

        return true;
    }
};

const ll P = 239;
vector<int> pw = {1};
struct SegmentTree {
    struct node {
        ll h = 0;
        int len = 0;
    };

    node merge(node& a, node& b) {
        node c;
        c.len = a.len + b.len;
        c.h = a.h * pw[b.len] + b.h;
        c.h %= mod;
        return c;
    }

    int n;
    vector<node> tree;

    void build(int x, int l, int r) {
        if (l + 1 == r) {
            tree[x] = {l, 1};
            return;
        }

        int m = (l + r) / 2;
        build(2 * x + 1, l, m);
        build(2 * x + 2, m, r);
        tree[x] = merge(tree[2 * x + 1], tree[2 * x + 2]);
    }

    SegmentTree(int _n) : n(_n) {
        int SIZE = 1 << (__lg(n) + bool(__builtin_popcount(n) - 1));
        tree.resize(2 * SIZE - 1, {0, 1});
        build(0, 0, n);
    }

    void update(int i, int v, int x, int l, int r) {
        if (l + 1 == r) {
            tree[x].h = v;
            return;
        }

        int m = (l + r) / 2;
        if (i < m) {
            update(i, v, 2 * x + 1, l, m);
        } else {
            update(i, v, 2 * x + 2, m, r);
        }
    }

    node get(int lq, int rq, int x, int l, int r) {
        if (rq <= l || r <= lq) return node();
        if (lq <= l || r <= rq) return tree[x];

        int m = (l + r) / 2;
        node a = get(lq, rq, 2 * x + 1, l, m);
        node b = get(lq, rq, 2 * x + 2, m, r);
        return merge(a, b);
    }

    ll get(int lq, int rq) {
        return get(lq, rq, 0, 0, n).h;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 0; i <= 2e5; i++) {
        pw.push_back((pw.back() * P) % mod);
    }

    bool ok = true;

    int n;
    cin >> n;
    vector<int> p(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        if (p[i] != i - 1) {
            ok = false;
        }
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];

    ll ans = 1;
    for (int i = 0; i < n; i++) ans = (ans * (r[i] - l[i] + 1)) % mod;

    DSU dsu(n);

    if (!ok) {
        dep.assign(n, 0);
        dfs(0);

        auto up = [&](int& v, vector<int>& path) {
            path.push_back(v);
            v = p[v];
        };

        auto get_path = [&](int u, int v, vector<int>& path) {
            vector<int> p1, p2;
            while (dep[u] > dep[v]) up(u, p1);
            while (dep[v] > dep[u]) up(v, p2);
            while (u != v) {
                up(u, p1);
                up(v, p2);
            }
            p1.push_back(u);
            reverse(all(p2));

            int cur = 0;
            path.resize(p1.size() + p2.size());
            for (auto el : p1) path[cur++] = el;
            for (auto el : p2) path[cur++] = el;
        };

        int m;
        cin >> m;

        for (int year = 0; year < m; year++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--; b--; c--; d--;

            if (ans == 0) {
                cout << 0 << '\n';
                continue;
            }

            vector<int> path[2];
            get_path(a, b, path[0]);
            get_path(c, d, path[1]);

            int len = path[0].size();
            for (int i = 0; i < len && ans != 0; i++) {
                if (dsu.get(path[0][i]) == dsu.get(path[1][i])) {
                    continue;
                }

                int a = dsu.get(path[0][i]);
                int b = dsu.get(path[1][i]);

                int nl = max(l[a], l[b]);
                int nr = min(r[a], r[b]);
                nr = max(nr, nl - 1);

                ans = (ans * inv(r[a] - l[a] + 1)) % mod;
                ans = (ans * inv(r[b] - l[b] + 1)) % mod;
                ans = (ans * (nr - nl + 1)) % mod;

                dsu.unite(a, b);
                int root = dsu.get(a);
                l[root] = nl;
                r[root] = nr;
            }

            cout << ans << '\n';
        }
    } else {
        SegmentTree ST(n);
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--; b--; c--; d--;
            if (a > b) swap(a, b);
            if (c > d) swap(c, d);
            if (ans == 0) {
                cout << 0 << '\n';
                continue;
            }

            while (ans != 0) {
                int L = 0;
                int R = d - c + 2;
                while (L + 1 < R) {
                    int m = (L + R) / 2;
                    if (ST.get(a, a + m + 1) == ST.get(c, c + m + 1)) {
                        L = m;
                    } else {
                        R = m;
                    }
                }

                if (L == d - c + 1) break;

                int x = ST.get(a + L + 1, a + L + 2);
                int y = ST.get(c + L + 1, c + L + 2);
                x = dsu.get(x);
                y = dsu.get(y);

                if (dsu.r[x] > dsu.r[y]) {
                    for (auto el : dsu.c[y]) ST.update(el, x, 0, 0, n);
                } else {
                    for (auto el : dsu.c[x]) ST.update(el, y, 0, 0, n);
                }

                int nl = max(l[x], l[y]);
                int nr = min(r[x], r[y]);
                nr = max(nr, nl - 1);

                ans = (ans * inv(r[x] - l[x] + 1)) % mod;
                ans = (ans * inv(r[y] - l[y] + 1)) % mod;
                ans = (ans * (nr - nl + 1)) % mod;

                dsu.unite(x, y);
                int root = dsu.get(x);
                l[root] = nl;
                r[root] = nr;
            }
        }
    }

    return 0;
}