#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;

struct DSU {
    vector<int> p, rnk;

    DSU() {}
    DSU(int n) {
        p.resize(n);
        rnk.resize(n);
        iota(all(p), 0);
    }

    int get(int x) {
        return (p[x] == x ? x : (p[x] = get(p[x])));
    }

    bool merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return false;
        }
        if (rnk[a] < rnk[b]) {
            swap(a, b);
        }
        p[b] = a;
        rnk[a] += rnk[a] == rnk[b];
        return true;
    }
};

vector<vector<int>> g;
vector<int> h;

void dfs(int v, int p) {
    for (int u : g[v]) {
        if (u != p) {
            h[u] = h[v] + 1;
            dfs(u, v);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    g.resize(n);
    h.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0, -1);
    vector<pair<int, int>> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i].X >> w[i].Y;
    }
    DSU dsu(n);
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> aaa, bbb, ccc, ddd;
        while (h[a] > h[b]) {
            aaa.push_back(a);
            a = p[a];
        }
        while (h[b] > h[a]) {
            bbb.push_back(b);
            b = p[b];
        }
        while (h[c] > h[d]) {
            ccc.push_back(c);
            c = p[c];
        }
        while (h[d] > h[c]) {
            ddd.push_back(d);
            d = p[d];
        }
        while (a != b) {
            aaa.push_back(a);
            bbb.push_back(b);
            a = p[a];
            b = p[b];
        }
        aaa.push_back(a);
        while (c != d) {
            ccc.push_back(c);
            ddd.push_back(d);
            c = p[c];
            d = p[d];
        }
        ccc.push_back(c);
        vector<int> first, second;
        first = aaa;
        second = ccc;
        reverse(all(bbb));
        reverse(all(ddd));
        for (int x : bbb) {
            first.push_back(x);
        }
        for (int x : ddd) {
            second.push_back(x);
        }
        for (int i = 0; i < (int)first.size(); i++) {
            int aa = dsu.get(first[i]);
            int cc = dsu.get(second[i]);
            if (aa != cc) {
                pair<int, int> inter = {max(w[aa].X, w[cc].X), min(w[aa].Y, w[cc].Y)};
                dsu.merge(aa, cc);
                int res = dsu.get(aa);
                w[res] = inter;
            }
        }
        int ans = 1;
        for (int i = 0; i < n; i++) {
            if (dsu.p[i] == i) {
                ans = (ans * max(0LL, (w[i].Y - w[i].X + 1))) % MOD;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}