#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(24234);
const ll inf = 1e18;


const ll mod = 1e9 + 7;


ll bin_pow(ll x, ll n){
    if(n == 0){
        return 1;
    }
    ll a = bin_pow(x, n / 2);
    a = (a * a) % mod;
    if(n & 1){
        a = (a * x) % mod;
    }
    return a;
}


ll rev(ll x){
    return bin_pow(x, mod - 2);
}


int n, m;
vector<int> p;
vector<vector<int>> g;
vector<ll> l, r;
vector<int> clr;
vector<vector<int>> clrd;
vector<pair<int, int>> mxmn;
ll rs;
int usdc;
vector<int> h;
vector<int> usd;


void dfs0(int v, int mh){
    h[v] = mh;
    for(auto to: g[v]){
        dfs0(to, mh + 1);
    }
}


void merge(int u, int v){
    if(rs == 0){
        return;
    }
    u = clr[u];
    v = clr[v];
    if(u == v){
        return;
    }
    if(clrd[u].size() > clrd[v].size()){
        swap(u, v);
    }
    rs = (rs * rev(max(0, mxmn[v].second - mxmn[v].first + 1))) % mod;
    rs = (rs * rev(max(0, mxmn[u].second - mxmn[u].first + 1))) % mod;
    mxmn[v] = make_pair(max(mxmn[u].first, mxmn[v].first), min(mxmn[v].second, mxmn[u].second));
    rs = (rs * max(0, mxmn[v].second - mxmn[v].first + 1)) % mod;
    if(rs == 0){
        return;
    }
    for(auto d: clrd[u]){
        clr[d] = v;
        clrd[v].push_back(d);
    }
    clrd[u].clear();
    clrd[u].shrink_to_fit();
}


int lca_slow(int a, int b){
    usdc += 1;
    while(1){
        if(a != -1){
            if(usd[a] == usdc){
                return a;
            }
            usd[a] = usdc;
            a = p[a];
        }
        if(b != -1){
            if(usd[b] == usdc){
                return b;
            }
            usd[b] = usdc;
            b = p[b];
        }
    }
}


void get_way(int a, int b, vector<int> &rs){
    int lc = lca_slow(a, b);
    rs.clear();
    rs.reserve(h[a] + h[b] - 2 * h[lc] + 1);
    while(a != lc){
        rs.push_back(a);
        a = p[a];
    }
    rs.push_back(lc);
    int x = rs.size();
    while(b != lc){
        rs.push_back(b);
        b = p[b];
    }
    reverse(rs.begin() + x, rs.end());
}


ll answer(int a, int b, int c, int d){
    if(rs == 0){
        return 0;
    }
    vector<int> way1, way2;
    get_way(a, b, way1);
    get_way(c, d, way2);
    int sz = way1.size();
    for(int i = 0; i < sz; i += 1){
        int u = way1[i];
        int v = way2[i];
        if(clr[u] != clr[v]){
            merge(u, v);
        }
    }
    return rs;
}


void build(){
    clr.resize(n);
    clrd.assign(n, vector<int>());
    mxmn.resize(n);
    rs = 1;
    for(int i = 0; i < n; i += 1){
        clr[i] = i;
        clrd[i] = {i};
        mxmn[i] = make_pair(l[i], r[i]);
        rs = (rs * max(0ll, r[i] - l[i] + 1)) % mod;
    }
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n;
    p.resize(n);
    p[0] = -1;
    g.assign(n, vector<int>());
    for(int i = 1; i < n; i += 1){
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> l[i] >> r[i];
    }
    usd.assign(n, 1);
    usdc = 0;
    h.resize(n);
    dfs0(0, 0);
    build();
    cin >> m;
    for(int itr = 0; itr < m; itr += 1){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        cout << answer(a, b, c, d) << "\n";
    }
    return 0;
}