#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


struct SGT{
    const ll mod = 1e9 + 7;
    const ll p = 2345;
    int n;
    vector<ll> h, rvh;
    vector<ll> ppws;
    vector<int> sz;


    void upd(int v){
        h[v] = (h[v + v] + ppws[sz[v + v]] * h[v + v + 1]) % mod;
        rvh[v] = (rvh[v + v + 1] + ppws[sz[v + v + 1]] * rvh[v + v]) % mod;
    }


    void build(vector<int> &a){
        n = 1;
        while(n < (int)a.size()){
            n *= 2;
        }
        h.assign(n + n, 0);
        rvh.assign(n + n, 0);
        sz.assign(n + n, 1);
        ppws.resize(n + 1);
        ppws[0] = 1;
        for(int i = 1; i <= n; i += 1){
            ppws[i] = (ppws[i - 1] * p) % mod;
        }
        for(int i = 0; i < (int)a.size(); i += 1){
            h[i + n] = rvh[i + n] = a[i];
        }
        for(int i = n - 1; i > 0; i -= 1){
            sz[i] = sz[i + i] + sz[i + i + 1];
            upd(i);
        }
    }


    ll get_hash(int l, int r){
        l += n;
        r += n + 1;
        ll lhsh = 0;
        ll lsz = 0;
        ll rhsh = 0;
        while(l < r){
            if(l & 1){
                lhsh = (lhsh + h[l] * ppws[lsz]) % mod;
                lsz += sz[l];
                l += 1;
            }
            if(r & 1){
                r -= 1;
                rhsh = (h[r] + rhsh * ppws[sz[r]]) % mod;
            }
            l /= 2;
            r /= 2;
        }
        return (lhsh + rhsh * ppws[lsz]) % mod;
    }


    ll get_rev_hash(int l, int r){
        l += n;
        r += n + 1;
        ll lhsh = 0;
        ll rsz = 0;
        ll rhsh = 0;
        while(l < r){
            if(l & 1){
                lhsh = (rvh[l] + lhsh * ppws[sz[l]]) % mod;
                l += 1;
            }
            if(r & 1){
                r -= 1;
                rhsh = (rhsh + rvh[r] * ppws[rsz]) % mod;
                rsz += sz[r];
            }
            l /= 2;
            r /= 2;
        }
        return (lhsh * ppws[rsz] + rhsh) % mod;
    }


    void chng(int i, int x){
        int v = i + n;
        h[v] = rvh[v] = x;
        for(v /= 2; v > 0; v /= 2){
            upd(v);
        }
    }


    ll super_get_hash(int a, int b){
        if(a <= b){
            return get_hash(a, b);
        }
        return get_rev_hash(b, a);
    }
};


mt19937 rnd(24234);
const ll inf = 1e18;


const ll mod = 1e9 + 7;


ll bin_pow(ll x, ll n){
    if(n == 0){
        return 1;
    }
    ll a = bin_pow(x, n / 2);
    a = (a * a) % mod;
    if(n & 1){
        a = (a * x) % mod;
    }
    return a;
}


ll rev(ll x){
    return bin_pow(x, mod - 2);
}


int n, m;
vector<int> p;
vector<vector<int>> g;
vector<ll> l, r;
vector<int> clr;
vector<vector<int>> clrd;
vector<pair<int, int>> mxmn;
ll rs;
int usdc;
vector<int> h;
vector<int> usd;
int nlg;
vector<vector<int>> bup;
SGT sgt;


void dfs_bup(int v, int p){
    bup[v][0] = p;
    for(int i = 1; i < nlg; i += 1){
        bup[v][i] = bup[bup[v][i - 1]][i - 1];
    }
    for(auto to: g[v]){
        dfs_bup(to, v);
    }
}


void build_bup(){
    nlg = 1;
    while((1 << nlg) < n){
        nlg += 1;
    }
    bup.assign(n, vector<int>(nlg));
    dfs_bup(0, 0);
}


void dfs0(int v, int mh){
    h[v] = mh;
    for(auto to: g[v]){
        dfs0(to, mh + 1);
    }
}


void merge(int u, int v, bool use_sgt = false){
    if(rs == 0){
        return;
    }
    u = clr[u];
    v = clr[v];
    if(u == v){
        return;
    }
    if(clrd[u].size() > clrd[v].size()){
        swap(u, v);
    }
    rs = (rs * rev(max(0, mxmn[v].second - mxmn[v].first + 1))) % mod;
    rs = (rs * rev(max(0, mxmn[u].second - mxmn[u].first + 1))) % mod;
    mxmn[v] = make_pair(max(mxmn[u].first, mxmn[v].first), min(mxmn[v].second, mxmn[u].second));
    rs = (rs * max(0, mxmn[v].second - mxmn[v].first + 1)) % mod;
    if(rs == 0){
        return;
    }
    for(auto d: clrd[u]){
        if(use_sgt){
            sgt.chng(d, v);
        }
        clr[d] = v;
        clrd[v].push_back(d);
    }
    clrd[u].clear();
    clrd[u].shrink_to_fit();
}


int lca(int a, int b){
    if(h[a] < h[b]){
        swap(a, b);
    }
    for(int i = nlg - 1; i >= 0; i -= 1){
        if(h[a] - (1 << i) >= h[b]){
            a = bup[a][i];
        }
    }
    if(a == b){
        return a;
    }
    for(int i = nlg - 1; i >= 0; i -= 1){
        if(bup[a][i] != bup[b][i]){
            a = bup[a][i];
            b = bup[b][i];
        }
    }
    return bup[a][0];
}



int lca_slow(int a, int b){
    usdc += 1;
    while(1){
        if(a != -1){
            if(usd[a] == usdc){
                return a;
            }
            usd[a] = usdc;
            a = p[a];
        }
        if(b != -1){
            if(usd[b] == usdc){
                return b;
            }
            usd[b] = usdc;
            b = p[b];
        }
    }
}


void get_way(int a, int b, vector<int> &rs){
    int lc = lca(a, b);
    rs.clear();
    rs.reserve(h[a] + h[b] - 2 * h[lc] + 1);
    while(a != lc){
        rs.push_back(a);
        a = p[a];
    }
    rs.push_back(lc);
    int x = rs.size();
    while(b != lc){
        rs.push_back(b);
        b = p[b];
    }
    reverse(rs.begin() + x, rs.end());
}


ll answer(int a, int b, int c, int d){
    if(rs == 0){
        return 0;
    }
    vector<int> way1, way2;
    get_way(a, b, way1);
    get_way(c, d, way2);
    int sz = way1.size();
    for(int i = 0; i < sz; i += 1){
        int u = way1[i];
        int v = way2[i];
        if(clr[u] != clr[v]){
            merge(u, v);
        }
    }
    return rs;
}


void build(){
    clr.resize(n);
    clrd.assign(n, vector<int>());
    mxmn.resize(n);
    rs = 1;
    for(int i = 0; i < n; i += 1){
        clr[i] = i;
        clrd[i] = {i};
        mxmn[i] = make_pair(l[i], r[i]);
        rs = (rs * max(0ll, r[i] - l[i] + 1)) % mod;
    }
    build_bup();
}


bool is_bamboo(){
    for(int i = 1; i < n; i += 1){
        if(p[i] != i - 1){
            return false;
        }
    }
    return true;
}



ll answer_bamboo(int a, int b, int c, int d){
    if(rs == 0){
        return 0;
    }
    if(a > b){
        swap(a, b);
        swap(c, d);
    }
    int f = 1;
    if(c > d){
        f = -1;
    }
    while(sgt.super_get_hash(a, b) != sgt.super_get_hash(c, d)){
        int tl = 0;
        int tr = b - a + 1;
        while(tl + 1 < tr){
            int tm = (tl + tr) / 2;
            if(sgt.super_get_hash(a, a + tm - 1) == sgt.super_get_hash(c, c + f * (tm - 1))){
                tl = tm;
            } else{
                tr = tm;
            }
        }
        int u = a + tl;
        int v = c + f * tl;
        merge(u, v, true);
        if(rs == 0){
            return 0;
        }
    }
    return rs;
}


void build_bamboo(){
    sgt.build(clr);
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n;
    p.resize(n);
    p[0] = -1;
    g.assign(n, vector<int>());
    for(int i = 1; i < n; i += 1){
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> l[i] >> r[i];
    }
    usd.assign(n, 0);
    usdc = 1;
    h.resize(n);
    dfs0(0, 0);
    build();
    cin >> m;
    if(is_bamboo()){
        build_bamboo();
        for(int itr = 0; itr < m; itr += 1){
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            --a;
            --b;
            --c;
            --d;
            cout << answer_bamboo(a, b, c, d) << "\n";
        }
        return 0;
    }
    for(int itr = 0; itr < m; itr += 1){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        cout << answer(a, b, c, d) << "\n";
    }
    return 0;
}

/*

8
1 2 3 4 5 6 7
3 7
2 6
3 8
5 10
5 8
2 9
6 8
3 8
4
1 3 8 6
4 1 5 8
1 8 8 1
1 7 2 8


*/