#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define vc vector
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    cout << fixed << setprecision(15);
    int tc = 1;
    //cin >> tc;
    forn(i, tc) solve();
    return 0;
}

vector<vector<int>> gr;
vector<int> par;
vector<pair<ll, ll>> a;
const ll Mod = 1e9 + 7;

ll add(ll x, ll y) {
    ll sm = (x + y) % Mod;
    return sm;
}

ll mul(ll x, ll y) {
    return (x * 1ll * y) % Mod;
}

ll sub(ll x, ll y) {
    ll sm = (x - y + Mod) % Mod;
    return sm;
}

ll binpow(ll b, ll p) {
    if (p == 0) return 1;
    if (p == 1) return b;
    ll ans = binpow(b, p / 2);
    ans = mul(ans, ans);
    if (p % 2) ans = mul(ans, b);
    return ans;
}

ll dv(ll x) {
    return binpow(x, Mod - 2);
}


struct dsu {
    vector<int> p, rng;
    ll ans;
    vector<pair<ll, ll>> b;
    dsu(int n) {
        ans = 1;
        b.resize(n);
        p.resize(n);
        rng.resize(n, 1);
        iota(all(p), 0);
        forn(i, n) {
            b[i] = a[i];
            ll df = max(0ll, a[i].ss - a[i].ff + 1);
            ans = mul(ans, df);
        }
    }

    int get(int v) {
        if (v == p[v]) return v;
        v = get(p[v]);
        return v;
    }

    void unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (ans == 0) return;
        ll df = max(0ll, b[u].ss - b[u].ff + 1);
        ans = mul(ans, dv(df));
        df = max(0ll, b[v].ss - b[v].ff + 1);
        ans = mul(ans, dv(df));
        if (rng[u] < rng[v]) swap(u, v);
        rng[u] += rng[v];
        p[v] = u;
        b[u].ff = max(b[v].ff, b[u].ff);
        b[u].ss = min(b[v].ss, b[u].ss);
        df = max(0ll, b[u].ss - b[u].ff + 1);
        ans = mul(ans, df);
    }
};

const int Log = 20;
vector<int> d;
vector<vector<int>> up;

void dfs(int v, int p) {
    d[v] = d[p] + 1;
    up[0][v] = p;
    for (int adj : gr[v]) {
        dfs(adj, v);
    }
}

int la(int v, int k) {
    forn(i, Log) {
        if (k & (1 << i))
            v = up[i][v];
    }
    return v;
}

int lca(int u, int v) {
    if (d[u] < d[v]) swap(u, v);
    u = la(u, d[u] - d[v]);
    if (u == v) return u;
    for (int i = Log - 1; i >= 0; --i) {
        if (up[i][u] != up[i][v]) {
            u = up[i][u];
            v = up[i][v];
        }
    }
    return up[0][u];
}
void get_path(int u, int v, vector<int> &path) {
    int pk = lca(u, v);
    vector<int> path1, path2;
    while (u != pk) {
        path1.pb(u);
        u = par[u];
    }
    while (v != pk) {
        path2.pb(v);
        v = par[v];
    }
    for (auto x : path1) path.pb(x);
    path.pb(pk);
    reverse(all(path2));
    for (auto x : path2) path.pb(x);
}

void solve() {
    int n;
    cin >> n;
    par.resize(n, -1);
    gr.resize(n);
    a.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        par[i] = p;
        gr[p].pb(i);
    }
    d.resize(n, -1);
    up.resize(Log, vector<int> (n, 0));
    dfs(0, 0);
    for (int k = 1; k < Log; ++k) {
        forn(v, n) up[k][v] = up[k - 1][up[k - 1][v]];
    }
    forn(i, n) cin >> a[i].ff >> a[i].ss;
    dsu st(n);
    int m;
    cin >> m;
    forn(i, m) {
        int x, y, z, w;
        cin >> x >> y >> z >> w;
        --x, --y, --z, --w;
        vector<int> path1, path2;
        get_path(x, y, path1);
        get_path(z, w, path2);
        forn(j, sz(path1)) {
            int u = path1[j];
            int v = path2[j];
            st.unite(u, v);
        }
        cout << st.ans << '\n';
    }
}
