#include <bits/stdc++.h>

#define int long long
const int MAXN = 2e5, INF = 1e9 + 7;
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG B.cpp -o B
using namespace std;

int n, ans = 1;
int p[MAXN], d[MAXN];
pair<int, int> seg[MAXN];
vector<vector<int>> dp;
multiset<pair<int, int>> cur;
int comp[MAXN], r[MAXN];
map<int, int> reve;

void gcdex(int a, int b, int &x, int &y) {
    if (b == 0) {
        x = 1, y = 0;
        return;
    }
    int x1 = 0, y1 = 0;
    gcdex(b, a % b, x1, y1);
    x = y1, y = x1 - y1 * (int)(a / b);
}

int rev(int b) {
    if (b == 0) return 1;
    if (reve.find(b) != reve.end()) return reve[b];
    int x, y;
    gcdex(INF, b, x, y);
    while (y < 0) y += INF;
    return reve[b] = y;
}

int lca(int v, int u) {
    if (d[v] < d[u]) swap(v, u);
    // cerr << v << ' ' << u << "  " << d[v] << " " << d[u] << '\n';
    for (int i = ceil(log2(n)); i >= 0; --i) {
        if (d[dp[v][i]] >= d[u]) v = dp[v][i];
    }
    // cerr << v << ' ' << u << '\n';
    if (v == u) return v;
    for (int i = ceil(log2(n)); i >= 0; --i) {
        if (dp[v][i] != dp[u][i]) v = dp[v][i], u = dp[u][i];
    }
    return p[v];
}

int calc_d(int v) {
    return d[v] = (d[v] == INF) ? calc_d(p[v]) + 1 : d[v];
}

int get(int v) {
    return comp[v] = (comp[v] == v) ? v : get(comp[v]);
}

int get_val(int v) {
    return max(0LL, seg[v].second - seg[v].first + 1);
}

void merge(int v, int u) {
    v = get(v), u = get(u);
    // cerr << v << ' ' << u << '\n';
    if (v == u) return;
    // cur.extract(seg[v]), cur.extract(seg[u]);
    // cerr << get_val(u) << ' ' << rev(get_val(u)) << '\n';
    // cerr << get_val(v) << ' ' << rev(get_val(v)) << '\n';
    ans *= rev(get_val(u));
    ans %= INF;
    ans *= rev(get_val(v));
    ans %= INF;
    if (r[v] == r[u]) r[v]++;
    int lx = max(seg[v].first, seg[u].first);
    int rx = min(seg[v].second, seg[u].second);
    if (r[v] < r[u]) swap(u, v);
    comp[u] = v, seg[v] = {lx, rx};
    ans *= get_val(v);
    ans %= INF;
    // cur.emplace(seg[v]);
}

vector<int> get_path(int a, int b) {
    int lca_ab = lca(a, b);
    // cerr << a << ' ' << b << "   " << lca_ab << '\n';
    vector<int> path, rev;
    while (a != lca_ab) path.push_back(a), a = p[a];
    path.push_back(a);
    while (b != lca_ab) rev.push_back(b), b = p[b];
    for (auto it = rev.rbegin(); it != rev.rend(); ++it) path.push_back(*it);
    return path;
}


void solve() {
    cin >> n;
    dp.resize(n, vector<int>(ceil(log2(n)) + 1));
    for (int i = 1; i < n; ++i) cin >> p[i], p[i]--;
    for (int i = 0; i < n; ++i) cin >> seg[i].first >> seg[i].second, cur.emplace(seg[i]);
    for (int i = 0; i < n; ++i) dp[i][0] = p[i], comp[i] = i, d[i] = INF;
    for (int i = 0; i < n; ++i) ans = (ans * get_val(i)) % INF;
    // cerr << ans << '\n';
    for (int i = 1; i <= ceil(log2(n)); ++i) {
        for (int j = 0; j < n; ++j) dp[j][i] = dp[dp[j][i - 1]][i - 1];
    }
    d[0] = 0;
    for (int i = 0; i < n; ++i) calc_d(i);
    // cerr << "d:  ";
    // for (int i = 0; i < n; ++i) cerr << d[i] << ' ';
    // cerr << '\n';
    int m;
    cin >> m;
    // cerr << lca(4, 6) << '\n';
    // return;
    // cerr << rev(1) << ' ' << rev(2) << ' ' << rev(3) << '\n';
    // return;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> ab = get_path(--a, --b);
        vector<int> cd = get_path(--c, --d);
        assert(ab.size() == cd.size());
        // for (auto j : ab) cerr << j << " ";
        // cerr << '\n';
        // for (auto j : cd) cerr << j << " ";
        // cerr << '\n';
        for (int i = 0; i < (int)ab.size(); ++i) merge(ab[i], cd[i]);
        // for (int i = 0; i < n; ++i) if (get(i) == i) cerr << i << " - " << get_val(i) << '\n';
        // cerr << '\n';
        // cerr << '\n';
        // int ans = 1;
        // for (auto [lx, rx] : cur) ans *= max(0LL, rx - lx + 1), ans %= INF;

        //for (int i = 0; i < n; ++i) if (get(i) == i) ans = (ans * get_val(i)) % INF;
        cout << ans << '\n';
    }

}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
