#include <bits/stdc++.h>

// #define int long long
const int MAXN = 2e5, INF = 1e9 + 7;
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG B.cpp -o B
using namespace std;
using ll = long long;

int n, ans = 1;
int d[MAXN];
pair<int, int> seg[MAXN];
int dp[MAXN][19];
int comp[MAXN], r[MAXN];
unordered_map<int, int> reve;

int mul(int x, int y) {
    return ((ll)x * (ll)y) % (ll)INF;
}

void gcdex(ll a, ll b, ll &x, ll &y) {
    if (b == 0) {
        x = 1, y = 0;
        return;
    }
    ll x1 = 0, y1 = 0;
    gcdex(b, a % b, x1, y1);
    x = y1, y = x1 - y1 * (ll)(a / b);
}

int rev(int b) {
    if (b == 0) return 1;
    if (reve.find(b) != reve.end()) return reve[b];
    ll x, y;
    gcdex(INF, b, x, y);
    while (y < 0) y += INF;
    y %= INF;
    return reve[b] = y;
}

int lca(int v, int u) {
    if (d[v] < d[u]) swap(v, u);
    for (int i = ceil(log2(n)); i >= 0; --i) {
        if (d[dp[v][i]] >= d[u]) v = dp[v][i];
    }
    if (v == u) return v;
    for (int i = ceil(log2(n)); i >= 0; --i) {
        if (dp[v][i] != dp[u][i]) v = dp[v][i], u = dp[u][i];
    }
    return dp[v][0];
}

int calc_d(int v) {
    return d[v] = (d[v] == INF) ? calc_d(dp[v][0]) + 1 : d[v];
}

int get(int v) {
    return comp[v] = (comp[v] == v) ? v : get(comp[v]);
}

int get_val(int v) {
    return max(0, seg[v].second - seg[v].first + 1);
}

void merge(int v, int u) {
    v = get(v), u = get(u);
    if (v == u) return;
    ans = mul(ans, rev(get_val(u)));
    ans = mul(ans, rev(get_val(v)));
    if (r[v] == r[u]) r[v]++;
    int lx = max(seg[v].first, seg[u].first);
    int rx = min(seg[v].second, seg[u].second);
    if (r[v] < r[u]) swap(u, v);
    comp[u] = v, seg[v] = {lx, rx};
    ans = mul(ans, get_val(v));
}

vector<int> get_path(int a, int b) {
    int lca_ab = lca(a, b);
    vector<int> path, rev;
    while (a != lca_ab) path.push_back(a), a = dp[a][0];
    path.push_back(a);
    while (b != lca_ab) rev.push_back(b), b = dp[b][0];
    for (auto it = rev.rbegin(); it != rev.rend(); ++it) path.push_back(*it);
    return path;
}


void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) cin >> dp[i][0], dp[i][0]--;
    for (int i = 0; i < n; ++i) cin >> seg[i].first >> seg[i].second;
    for (int i = 0; i < n; ++i) comp[i] = i, d[i] = INF;
    for (int i = 0; i < n; ++i) ans = (ans * get_val(i)) % INF;
    for (int i = 1; i <= ceil(log2(n)); ++i) {
        for (int j = 0; j < n; ++j) dp[j][i] = dp[dp[j][i - 1]][i - 1];
    }
    d[0] = 0;
    for (int i = 0; i < n; ++i) calc_d(i);
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> ab = get_path(--a, --b);
        vector<int> cd = get_path(--c, --d);
        assert(ab.size() == cd.size());
        for (int i = 0; i < (int)ab.size(); ++i) merge(ab[i], cd[i]);
        cout << ans << '\n';
    }

}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
