#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: fx5mmuap

using namespace std;

const ll inf = 1e18;
const ll MOD = 1e9 + 7;

ll n, ans = 1;
vector<vector<ll>> gr;
vector<ll> p;
vector<ll> l, r;
vector<ll> L, R;

vector<ll> h;
vector<vector<ll>> jmp;
void dfs(ll v, ll pr) {
	jmp[0][v] = pr;
	h[v] = h[pr] + 1;
	for (ll j = 1; j < 20; j++) {
		jmp[j][v] = jmp[j - 1][jmp[j - 1][v]];
	}
	for (auto& to : gr[v]) {
		if (to == pr) continue;
		dfs(to, v);
	}
}

ll fastPow(ll n, ll p) {
	ll res = 1;
	while (p) {
		if (p % 2 == 0) {
			p /= 2;
			n = (n * n) % MOD;
		} else {
			p--;
			res = (res * n) % MOD;
		}
	}
	return res;
}


ll findP(ll x) {
	if (x == p[x]) return x;
	return p[x] = findP(p[x]);
}

void unionSet(ll a, ll b) {
	a = findP(a);
	b = findP(b);
	if (a == b) return;
	ll old = (max(0ll, (R[a] - L[a] + 1)) * max(0ll, (R[b] - L[b] + 1))) % MOD;
	ll New = max(0ll, min(R[a], R[b]) - max(L[a], L[b]) + 1) % MOD;
	if (ans > 0) {
		ans = (ans * fastPow(old, MOD - 2)) % MOD;
		ans = (ans * New) % MOD;
	}
	L[b] = max(L[a], L[b]);
	R[b] = min(R[a], R[b]);
	p[a] = b;
}

void read() {
	cin >> n;
	h = vector<ll>(n, 0);
	gr = vector<vector<ll>>(n);
	for (ll i = 1; i < n; i++) {
		ll x;
		cin >> x;
		x--;
		gr[i].push_back(x);
		gr[x].push_back(i);
	}
	l = r = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	p = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		p[i] = i;
	}
}

ll lca(ll a, ll b) {
	if (h[a] < h[b]) {
		swap(a, b);
	}
	for (ll j = 19; j >= 0; j--) {
		if (h[jmp[j][a]] >= h[b]) {
			a = jmp[j][a];
		}
	}
	if (a == b) {
		return a;
	}
	for (ll j = 19; j >= 0; j--) {
		if (jmp[j][a] != jmp[j][b]) {
			a = jmp[j][a];
			b = jmp[j][b];
		}
	}
	return jmp[0][a];
}

vector<ll> cur;
void getPath(ll v, ll last) {
	ll c = lca(v, last);
	while (v != c) {
		cur.push_back(v);
		v = jmp[0][v];
	}
	vector<ll> t;
	while (last != c) {
		t.push_back(last);
		last = jmp[0][last];
	}
	t.push_back(c);
	reverse(t.begin(), t.end());
	for (auto& to : t) {
		cur.push_back(to);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	
	read();
	jmp = vector<vector<ll>>(20, vector<ll>(n));
	dfs(0, 0);
	ll m;
	cin >> m;
	ans = 1;
	for (ll i = 0; i < n; i++) {
		ans = (ans * max(0ll, r[i] - l[i] + 1)) % MOD;
	}
	L = l;
	R = r;
	while (m--) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--;
		c--, d--;
		getPath(a, b);
		vector<ll> p1 = cur;
		cur.clear();
		getPath(c, d);
		vector<ll> p2 = cur;
		cur.clear();
		ll k = p1.size();
		for (ll i = 0; i < k; i++) {
			unionSet(p1[i], p2[i]);
		}
		cout << ans << "\n";
	}

	return 0;
} 