#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=1e5+6;
const int logN=20;
const int mod=1e9+7;
int n,m;
ll ans=1;
int l[MAXN],r[MAXN];
vector<int>g[MAXN];
ll fastpow(ll x,ll p)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2);
    t*=t;t%=mod;
    if(p%2==1)
    {
        t*=x;
        t%=mod;
    }
    return t;
}
void multiply(ll &a,ll b)
{
    a*=b;a%=mod;
}
void divide(ll &a,ll b)
{
    a*=fastpow(b,mod-2);
    a%=mod;
}
struct dsu
{
    int par[MAXN];
    int sz[MAXN];
    void init()
    {
        for(int i=1;i<MAXN;i++)
        {
            par[i]=i;
            sz[i]=1;
        }
    }
    int getRoot(int u)
    {
        if(par[u]==u)return u;
        return par[u]=getRoot(par[u]);
    }
    void join(int p,int q)
    {
        divide(ans,r[p]-l[p]+1);
        divide(ans,r[q]-l[q]+1);
        if(sz[p]>sz[q])
        {
            r[p]=min(r[p],r[q]);
            l[p]=max(l[p],l[q]);
            multiply(ans,r[p]-l[p]+1);
            sz[p]+=sz[q];
            par[q]=p;
        }
        else
        {
            r[q]=min(r[p],r[q]);
            l[q]=max(l[p],l[q]);
            multiply(ans,r[q]-l[q]+1);
            sz[q]+=sz[p];
            par[p]=q;
        }
    }
}dsu1;
int par[MAXN][logN];
int dep[MAXN];
void precompute()
{
    for(int step=1;step<logN;step++)
    {
        for(int i=1;i<=n;i++)
        {
            par[i][step]=par[par[i][step-1]][step-1];
        }
    }
}
void dfs(int u,int p)
{
    dep[u]=dep[p]+1;
    par[u][0]=p;
    for(auto xd:g[u])
    {
        dfs(xd,u);
    }
}
int lca(int x,int y)
{
    if(dep[x]<dep[y])swap(x,y);
    int dif=dep[x]-dep[y];
    for(int i=0;i<logN;i++)
    {
        if(dif&(1<<i))
        {
            x=par[x][i];
        }
    }
    if(x==y)return x;
    for(int i=logN-1;i>=0;i--)
    {
        if(par[x][i]!=par[y][i])
        {
            x=par[x][i];
            y=par[y][i];
        }
    }
    return par[x][0];
}
vector<int> make_path(int st,int fin,int mid)
{
    vector<int>ret1;
    ret1.push_back(st);
    while(st!=mid)
    {
        st=par[st][0];
        ret1.push_back(st);
    }
    vector<int>ret2;
    while(fin!=mid)
    {
        ret2.push_back(fin);
        fin=par[fin][0];
    }
    reverse(ret2.begin(),ret2.end());
    for(auto xd:ret2)ret1.push_back(xd);
    return ret1;
}
int main()
{
    cin>>n;
    for(int i=2;i<=n;i++)
    {
        int p;cin>>p;
        g[p].push_back(i);
    }
    for(int i=1;i<=n;i++)
    {
        cin>>l[i]>>r[i];
        ans*=(ll)r[i]-l[i]+1;
        ans%=mod;
    }
    cin>>m;
    dfs(1,0);
    precompute();
    dsu1.init();
    for(int i=1;i<=m;i++)
    {
        int a,b,c,d;
        cin>>a>>b>>c>>d;
        int x=lca(a,b);
        int y=lca(c,d);
        vector<int>path1=make_path(a,b,x);
        vector<int>path2=make_path(c,d,y);
        for(int j=0;j<path1.size();j++)
        {
            int v1=path1[j];
            int v2=path2[j];
            int p1=dsu1.getRoot(v1);
            int p2=dsu1.getRoot(v2);
            if(p1==p2)continue;
            dsu1.join(p1,p2);
        }
        cout<<ans<<endl;
    }
return 0;
}
