/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;



struct segtree {
    int sz;
    vector <ll> tree;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz - 1, 0ll);
    }

    void update (int i, ll v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            update(i, v, 2 * x + 1, lx, m);
        }
        else {
            update(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = (tree[2 * x + 1] + tree[2 * x + 2]) % mod;
    }

    ll get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return 0ll;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return (get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx)) % mod;
    }
}; // segtree st;


inline ll binpow (ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a; res %= mod;
        }
        a *= a; a %= mod;
        n >>= 1;
    }
    return res;
}


const int N = 2e5 + 1, k = 20;
const ll base = 1e6 + 3;
ll pw[N], ipw[N], l[N], r[N], ans[N], ANS = 1;

int n, q, p[N], lev[N], dp[N][k], sz[N];
vector <int> g[N];


int lca (int u, int v) {
    if (lev[u] < lev[v]) {
        swap(u, v);
    }
    for (int i = k - 1; i >= 0; --i) {
        if (dp[u][i] != -1 && lev[dp[u][i]] >= lev[v]) {
            u = dp[u][i];
        }
    }
    if (u == v) {
        return u;
    }
    for (int i = k - 1; i >= 0; --i) {
        if (dp[u][i] != dp[v][i]) {
            u = dp[u][i]; v = dp[v][i];
        }
    }
    return p[u];
}


void dfs (int vert, int par, int level) {
    lev[vert] = level;
    sz[vert] = 1;
    for (auto i : g[vert]) {
        if (i != par) {
            dfs(i, vert, level + 1);
            sz[vert] += sz[i];
        }
    }
}

vector <int> A;
int pos[N];
bool heavy[N], heavy_head[N];

bool cmp (int i, int j) {
    return sz[i] > sz[j];
}

void dfs_HLD (int vert, int par) {
    A.pb(vert);
    sort(all(g[vert]), cmp);
    int ind = -1;
    for (auto i : g[vert]) {
        if (i != par) {
            if (ind == -1) {
                ind = i;
            }
            dfs_HLD(i, vert);
        }
    }
    if (ind != -1) {
        heavy[ind] = true;
    }
}

void dfs1 (int vert, int par) { // calc heavy_head
    if (par == -1) {
        if (heavy[vert]) {
            heavy_head[vert] = vert;
        }
    }
    else {
        if (heavy[par]) {
            heavy_head[vert] = heavy_head[par];
        }
        else {
            heavy_head[vert] = vert;
        }
    }
    for (auto i : g[vert]) {
        if (i != par) {
            dfs1(i, vert);
        }
    }
}

// DSU
int head[N], dsu_sz[N];
vector <int> component[N];

void unite (int u, int v) {
    u = head[u]; v = head[v];
    if (dsu_sz[u] < dsu_sz[v]) {
        swap(u, v);
    }
    for (auto i : component[v]) {
        head[i] = u;
        component[u].emplace_back(i);
        ++dsu_sz[u];
        // st.update(pos[i], head[i], 0, 0, n);
    }
    component[v].clear();
    ANS *= binpow(ans[u], mod - 2); ANS %= mod;
    ANS *= binpow(ans[v], mod - 2); ANS %= mod;
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    ans[u] = max(0ll, r[u] - l[u] + 1);
    ANS *= ans[u]; ANS %= mod;
}


inline vector <int> get_path (int a, int b) {
    int L = lca(a, b);
    // debug(L << ' ' << a << ' ' << b);
    vector <int> v1, v2;
    while (a != L) {
        v1.emplace_back(a); a = p[a];
    }
    while (b != L) {
        v2.emplace_back(b); b = p[b];
    }
    reverse(all(v2));
    v1.emplace_back(L);
    for (auto i : v2) {
        v1.emplace_back(i);
    }
    return v1;
}


void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        g[i].pb(p[i]);
        g[p[i]].pb(i);
        dp[i][0] = p[i];
    }
    for (int i = 0; i < n; ++i) {
        head[i] = i; dsu_sz[i] = 1;
        component[i].pb(i);
        cin >> l[i] >> r[i];
        ans[i] = r[i] - l[i] + 1;
        ANS *= ans[i]; ANS %= mod;
    }
    dp[0][0] = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < k; ++j) {
            dp[i][j] = (dp[i][j - 1] == -1 ? -1 : dp[dp[i][j - 1]][j - 1]);
        }
    }
    // HLD
    dfs(0, -1, 0);
    /*
    dfs_HLD(0, -1);
    dfs1(0, -1);
    for (int i = 0; i < n; ++i) {
        pos[A[i]] = i;
    }
    st.init(n);
    for (int i = 0; i < n; ++i) {
        st.update(pos[i], pw[lev[i]] * head[i] % mod, 0, 0, n);
    }
     */
    // return;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        // without HLD
        vector <int> v1 = get_path(a, b), v2 = get_path(c, d);
        for (int i = 0; i < v1.size(); ++i) {
            if (head[v1[i]] != head[v2[i]]) {
                unite(v1[i], v2[i]);
            }
        }
        cout << ANS << endl;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    pw[0] = 1; ipw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = pw[i - 1] * base % mod;
        ipw[i] = binpow(pw[i], mod - 2);
    }
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}

