#include <bits/stdc++.h>
#define int long long

using namespace std;

const int mod = 1e9 + 7;

int pow(int n, int k){
    if (k == 0){
        return 1;
    }
    if (k == 1) return n;
    int res = pow(n, k / 2);
    res = (res * res) % mod;
    if (k % 2){
        res = (res * n) % mod;
    }
    return res;
}


vector<vector<int>> g;
vector<int> path, res;

void dfs(int v, int to, int pr=-1){
    path.push_back(v);
    if (v == to){
        res = path;
        return;
    }
    for (auto u : g[v]){
        if (u == pr) continue;
        dfs(u, to, v);
    }
    path.pop_back();
}

void get(int u, int v){
    path = {}, res = {};
    dfs(u, v);
}

vector<int> par, sz, l, r;
int ans;

int get_root(int v){
    if (par[v] == v) return v;
    par[v] = get_root(par[v]);
    return par[v];
}

bool united(int u, int v){
    return get_root(u) == get_root(v);
}

void unite(int u, int v){
    u = get_root(u), v = get_root(v);
    ans = (ans * pow((r[u] - l[u] + 1), mod - 2)) % mod;
    ans = (ans * pow((r[v] - l[v] + 1), mod - 2)) % mod;
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    l[v] = l[u], r[v] = r[u];
    if (l[u] > r[u]){
        ans = 0;
        return;
    }
    if (sz[u] < sz[v]) swap(u, v);
    sz[u] += sz[v];
    par[v] = u;
    ans = (ans * (r[u] - l[u] + 1)) % mod;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    g.assign(n, vector<int>());
    par.assign(n, 0);
    sz.assign(n, 1);

    for (int i = 0; i < n; i ++){
        par[i] = i;
        sz[i] = 1;
    }

    for (int i = 1; i < n; i ++){
        int p;
        cin >> p;
        p --;
        g[p].push_back(i);
        g[i].push_back(p);
    }

    ans = 1;
    l.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0; i < n; i ++){
        cin >> l[i] >> r[i];
        ans = (ans * (r[i] - l[i] + 1)) % mod;
    }

    int m;
    cin >> m;

    for (int i = 0; i < m; i ++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a --, b --, c --, d --;
        if (ans == 0){
            cout << 0 << endl;
            continue;
        }
        get(a, b);
        vector<int> v1 = res;
        get(c, d);
        vector<int> v2 = res;
        for (int j = 0; j < v1.size(); j ++){
            if (!united(v1[j], v2[j])){
                unite(v1[j], v2[j]);
                if (ans == 0) break;
            }
        }
        cout << ans << endl;
    }
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
 */