#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
int n, p[N], l[N], r[N], par[N], timer, tin[N], tout[N], ans, siz[N], m;
pii seg[N];
vec<int> g[N];

int binpow(int a, int x)
{
    if (x == 0) return 1;
    if (x & 1) return a * binpow(a, x - 1) % mod;
    int bp = binpow(a, x / 2);
    return bp * bp % mod;
}

pii intersection(const pii &a, const pii &b)
{
    return {max(a.f, b.f), min(a.s, b.s)};
}

void init_dsu()
{
    for (int i = 1; i <= n; i++)
    {
        par[i] = i;
        seg[i] = {l[i], r[i]};
        siz[i] = 1;
    }
}

int len(const pii &a)
{
    return max(0ll, a.s - a.f + 1);
}

int getp(int v)
{
    if (par[v] == v) return v;
    return par[v] = getp(par[v]);
}

void merge(int u, int v)
{
    int x = getp(u), y = getp(v);
    if (x == y) return;
    (ans *= binpow(len(seg[x]), mod - 2)) %= mod;
    (ans *= binpow(len(seg[y]), mod - 2)) %= mod;
    if (siz[x] > siz[y]) swap(x, y);
    par[x] = y;
    siz[y] += siz[x];
    siz[x] = 0;
    seg[y] = intersection(seg[x], seg[y]);
    (ans *= len(seg[y])) %= mod;
}

void dfs(int v, int pr = -1)
{
    tin[v] = timer++;
    for (int &to : g[v])
    {
        if (to == pr) continue;
        dfs(to, v);
    }
    tout[v] = timer;
}

bool upper(int u, int v)
{
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

vec<int> get(int a, int b)
{
    vec<int> res;
    int v = a;
    while (!upper(v, b))
    {
        res.pb(v);
        v = p[v];
    }
    res.pb(v);
    vec<int> rev;
    int u = b;
    while (u != v)
    {
        rev.pb(u);
        u = p[u];
    }
    reverse(all(rev));
    for (int i = 0; i < sz(rev); i++) res.pb(rev[i]);
    return res;
}

void solve()
{
    cin >> n;
    for (int i = 2; i <= n; i++)
    {
        cin >> p[i];
        g[i].pb(p[i]);
        g[p[i]].pb(i);
    }
    dfs(1);
    ans = 1;
    for (int i = 1; i <= n; i++)
    {
        cin >> l[i] >> r[i];
        (ans *= (r[i] - l[i] + 1)) %= mod;
    }
    init_dsu();
    cin >> m;
    for (int t = 0; t < m; t++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vec<int> pa, pb;
        pa = get(a, b);
        pb = get(c, d);
        for (int i = 0; i < sz(pa); i++) merge(pa[i], pb[i]);
        cout << ans << "\n";
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
