#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>
#include <math.h>
using namespace std;
typedef long long ll;

vector<pair<ll, ll>> lr;
vector<int> dsu, tin, tout, rng;
vector<vector<int>> gr;

ll mod = 1e9 + 7;
ll res = 1;
int tim = 0;

ll bp(ll a, ll st) {
	ll cur = a;
	ll ans = 1;
	while (st) {
		if (st & 1) ans = ans * cur % mod;
		st /= 2;
		cur = cur * cur % mod;
	}
	return ans;
}

int get(int x) {
	if (dsu[x] == x) {
		return x;
	}
	dsu[x] = get(dsu[x]);
	return dsu[x];
}

void unite(int u, int v) {
	int x = get(u);
	int y = get(v);
	if (x == y) {
		return;
	}
	if (rng[x] < rng[y]) {
		swap(x, y);
	}
	rng[x] += rng[y];
	res = res * bp(lr[x].second - lr[x].first+1, mod - 2) % mod;
	res = res * bp(lr[y].second - lr[y].first+1, mod - 2) % mod;
	lr[x] = { max(lr[x].first, lr[y].first), min(lr[x].second, lr[y].second) };
	dsu[y] = x;
	if (lr[x].first > lr[x].second) {
		res = 0;
	}
	else {
		res = res * (lr[x].second - lr[x].first + 1) % mod;
	}
}

void dfs(int u) {
	tin[u] = tim++;
	for (auto v : gr[u]) {
		dfs(v);
	}
	tout[u] = tim++;
}

bool pr(int x, int y) {
	return tin[x] <= tin[y] && tout[x] >= tout[y];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, a, b, c, d;
	cin >> n;

	gr.resize(n);
	vector<int> p(n);
	rng.resize(n);
	dsu.resize(n);
	lr.resize(n);
	tin.resize(n);
	tout.resize(n);

	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		gr[p[i]].push_back(i);
	}

	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		lr[i] = { l, r };
		dsu[i] = i;
		rng[i] = 1;
		res = (res * (r - l + 1)) % mod;
	}

	dfs(0);

	cin >> m;
	while (m--) {
		cin >> a >> b >> c >> d;
		--a;
		--b;
		--c;
		--d;

		if (res == 0) {
			cout << "0\n";
			continue;
		}

		vector<int> pth1, pth2;

		if (pr(b, a)) {
			while (b != a) {
				pth1.push_back(a);
				a = p[a];
			}
			pth1.push_back(b);
		}
		else {
			while (!pr(a, b)) {
				pth1.push_back(a);
				a = p[a];
			}
			vector<int> pth1r;
			while (b != a) {
				pth1r.push_back(b);
				b = p[b];
			}
			pth1r.push_back(b);
			for (int i = pth1r.size() - 1; i >= 0; --i) {
				pth1.push_back(pth1r[i]);
			}
		}

		if (pr(d, c)) {
			while (d != c) {
				pth2.push_back(c);
				c = p[c];
			}
			pth2.push_back(d);
		}
		else {
			while (!pr(c, d)) {
				pth2.push_back(c);
				c = p[c];
			}
			vector<int> pth2r;
			while (d != c) {
				pth2r.push_back(d);
				d = p[d];
			}
			pth2r.push_back(d);
			for (int i = pth2r.size() - 1; i >= 0; --i) {
				pth2.push_back(pth2r[i]);
			}
		}
		for (int i = 0; i < pth1.size(); ++i) {
			unite(pth1[i], pth2[i]);
		}
		cout << res << '\n';
	}

	return 0;
}