#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

const long long MOD = 1000000007;
int n;
vector<set<int>> g(100000), g2(100000);
vector<int> ls(100000), rs(100000);

vector<int> pre(100000);
vector<bool> used(100000, false);

pair<int, int> dfs(int v){
    used[v] = true;
    int la = ls[v], ra = rs[v];

    for(auto j : g2[v]){
        if(used[j])
            continue;

        pair<int, int> sd = dfs(j);
        la = max(la, sd.first);
        ra = min(ra, sd.second);
    }

    return make_pair(la, ra);
}

void dfs0(int v, int prev1){
    for(auto j : g[v]){
        if(j == prev1)
            continue;

        pre[j] = v;
        dfs0(j, v);
    }
}

void getv(int a, int b, int c, int d){
    for(int i = 0; i < n; i ++)
        pre[i] = -1;

    dfs0(a, -1);

    vector<int> p1;
    int v = b;
    while(v != -1){
        p1.push_back(v);
        v = pre[v];
    }

    for(int i = 0; i < n; i ++)
        pre[i] = -1;

    dfs0(c, -1);

    vector<int> p2;
    v = d;
    while(v != -1){
        p2.push_back(v);
        v = pre[v];
    }

    int y = int(p1.size());
    for(int i = 0; i < y; i ++){
        int u = p1[i], v = p2[i];
        g2[u].insert(v);
        g2[v].insert(u);
    }

}

long long getans(){

    for(int i = 0; i < n; i ++)
        used[i] = false;

    long long ans = 1;
    for(int i = 0; i < n; i ++){
        if(!used[i]){
            pair<int, int> sd =  dfs(i);
            long long kol = max(0, sd.second - sd.first + 1);
            //cout << kol << "Q\n";
            ans = (ans * kol) % MOD;
        }
    }

    return ans;

}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for(int i = 1; i < n; i ++){
        int v;
        cin >> v;

        g[v - 1].insert(i);
        g[i].insert(v - 1);
    }

    for(int i = 0; i < n; i ++)
        cin >> ls[i] >> rs[i];

    int m;
    cin >> m;

    vector<int> ans(m);
    for(int x = 0 ;x < m; x ++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        getv(a - 1, b - 1, c - 1, d - 1);

        ans[x] = getans();

    }

    for(int i = 0; i < m; i ++)
        cout<< ans[i] << "\n";


  return 0;
}
