#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

vector<vector<ll>> graph;
vector<ll> p;
vector<pair<ll, ll>> available;

ll get(ll a) {
    if (p[a] == a) {
        return a;
    }

    return p[a] = get(p[a]);
}

pair<ll, ll> merge_(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first == -1 || b.first == -1) {
        return {-1, -1};
    }

    pair<ll, ll> neww = {max(a.first, b.first), min(a.second, b.second)};
    if (neww.first > neww.second) {
        return {-1, -1};
    }
    return neww;
}

void set_(ll a, ll b) {
    a = get(a);
    b = get(b);

    if (a != b) {
        available[a] = merge_(available[a], available[b]);
        p[b] = a;
    }
}

vector<ll> now;
vector<ll> ans;
void dfs(ll v, ll p, ll find_) {
    now.push_back(v);
    if (v == find_) {
        ans = now;
    }

    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v, find_);
        }
    }
    now.pop_back();
}

void solve() {
    ll n;
    cin >> n;
    graph.resize(n + 1);
    p.resize(n + 1);
    available.resize(n + 1);

    for (ll i = 2; i <= n; ++i) {
        ll p1;
        cin >> p1;
        graph[i].push_back(p1);
        graph[p1].push_back(i);
    }

    vector<pair<ll, ll>> prices(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> prices[i].first >> prices[i].second;
    }

    for (ll i = 1; i <= n; ++i) {
        available[i] = prices[i];
        p[i] = i;
    }

    ll m;
    cin >> m;
    while (m--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;

        ans.clear();
        dfs(a, -1, b);
        vector<ll> p1 = ans;

        ans.clear();
        dfs(c, -1, d);
        vector<ll> p2 = ans;

        for (ll i = 0; i < ans.size(); ++i) {
            set_(p1[i], p2[i]);
        }

        ll ans = 1;
        for (ll i = 1; i <= n; ++i) {
            ll pr = get(i);
            if (pr != i) {
                continue;
            }
            if (available[pr].first == -1) {
                ans = 0;
            } else {
                ans *= available[pr].second - available[pr].first + 1;
                ans %= MOD;
            }
        }

        cout << ans << "\n";


    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
