#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <random>
#include <vector>

using namespace std;

const int MAXN = 2e5 + 7;
vector <int> g[MAXN];
int dep[MAXN];
const int C = 20;
int p[C][MAXN];
int l[MAXN];
int r[MAXN];

int par[MAXN];
int ww[MAXN];

int newid[MAXN];

int wk[MAXN];

vector <int> et;

bool comp(int v, int u) {
	return wk[v] > wk[u];
}

void hld_reorder(int v) {
	et.push_back(v);
	sort(g[v].begin(), g[v].end(), comp);
	for (auto to : g[v])
		hld_reorder(to);
}

inline int getroot(int v) {
	if (par[v] == v)
		return v;
	int t = getroot(par[v]);
	par[v] = t;
	return t;
}

inline void connect(int v, int u) {
	u = getroot(u);
	v = getroot(v);
	if (ww[v] < ww[u]) {
		par[v] = u;
		ww[u] += ww[v];
	} 
	else {
		par[u] = v;
		ww[v] += ww[u];
	}
}

void calc_dep(int v) {
	wk[v] = 1;
	for (int i = 1; i < C; i++)
		if (p[i - 1][v] != -1)
			p[i][v] = p[i - 1][p[i - 1][v]];
	int c = 0;
	for (auto to : g[v]) {
		c++;
		dep[to] = dep[v] + 1;
		wk[v] += wk[to];
		calc_dep(to);
	}
}

const int mod = 1e9 + 7;

int binp(int a, int p = mod - 2) {
	if (p == 0)
		return 1;
	if (p & 1)
		return (1ll * a * binp(a, p - 1)) % mod;
	long long t = binp(a, p / 2);
	return (t * t) % mod;
}

int parent(int v, int h) {
	if (h <= 0)
		return v;
	for (int i = 0; i < C; i++)
		if ((h >> i) & 1)
			v = p[i][v];
	return v;
}

int lca(int v, int u) {
	if (dep[u] > dep[v])
		swap(v, u);
	v = parent(v, dep[v] - dep[u]);
	if (v == u)
		return v;
	for (int i = C - 1; i >= 0; i--) {
		if (p[i][v] != p[i][u]) {
			v = p[i][v];
			u = p[i][u];
		}
	}
	return p[0][v];
}

inline int f(int ll, int rr) {
	if (ll > rr)
		return 0;
	return (rr - ll + 1) % mod;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < C; i++)
		for (int j = 0; j < MAXN; j++)
			p[i][j] = -1;
	for (int i = 1; i < n; i++) {
		cin >> p[0][i];
		p[0][i]--;
		g[p[0][i]].push_back(i);
	}
	dep[0] = 0;
	calc_dep(0);
	hld_reorder(0);
	for (int i = 0; i < n; i++)
		newid[et[i]] = i;
	for (int i = 0; i < n; i++)
		cin >> l[newid[i]] >> r[newid[i]];
	int sumw = 1;
	vector <int> obr(n);
	for (int i1 = 0; i1 < n; i1++) {
		int i = newid[i1];
		sumw = (1ll * sumw * f(l[i], r[i])) % mod;
		obr[i] = binp(f(l[i], r[i]));
	}
	vector <vector <int>> np(C, vector <int> (n, -1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < C; j++) {
			np[j][newid[i]] = p[j][i];
		}
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < C; j++)
			p[j][i] = np[j][i];
	int m;
	cin >> m;
	vector <int> used(n, 0);
	int timer = 0;
	vector <int> newl(n, -1e9);
	vector <int> newr(n, 1e9);
	for (int i = 0; i < n; i++) {
		ww[i] = 1;
		par[i] = i;
	}
	for (int w = 0; w < m; w++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--; b--;
		c--; d--;
		a = newid[a], b = newid[b], c = newid[c], d = newid[d];
		int lc1 = lca(a, b);
		int lc2 = lca(c, d);
		vector <int> ord1;
		vector <int> ord2;
		while (a != lc1) {
			ord1.push_back(a);
			a = p[0][a];
		}
		while (c != lc2) {
			ord2.push_back(c);
			c = p[0][c];
		}
		ord1.push_back(lc1);
		ord2.push_back(lc2);
		vector <int> temp;
		while (b != lc1) {
			temp.push_back(b);
			b = p[0][b];
		}
		reverse(temp.begin(), temp.end());
		for (auto e : temp)
			ord1.push_back(e);
		temp.clear();
		while (d != lc2) {
			temp.push_back(d);
			d = p[0][d];
		}
		reverse(temp.begin(), temp.end());
		for (auto e : temp)
			ord2.push_back(e);
		int sz = (int)ord1.size();

		int ans = sumw;
		timer++;
		for (auto e : ord1) {
			if (used[getroot(e)] < timer) {
				used[getroot(e)] = timer;
				ans = (1ll * ans * obr[getroot(e)]) % mod;
			}
		}
		for (auto e : ord2) {
			if (used[getroot(e)] < timer) {
				used[getroot(e)] = timer;
				ans = (1ll * ans * obr[getroot(e)]) % mod;
			}
		}

		for (int i = 0; i < sz; i++) {
			auto e1 = getroot(ord1[i]);
			auto e2 = getroot(ord2[i]);
			connect(ord1[i], ord2[i]);
			l[e1] = l[e2] = max(l[e1], l[e2]);
			r[e1] = r[e2] = min(r[e1], r[e2]);
		}
		for (int i = 0; i < sz; i++) {
			auto e1 = getroot(ord1[i]);
			auto e2 = getroot(ord2[i]);
			connect(ord1[i], ord2[i]);
			l[e1] = l[e2] = max(l[e1], l[e2]);
			r[e1] = r[e2] = min(r[e1], r[e2]);
		}

		timer++;
		for (auto e1 : ord1) {
			auto e = getroot(e1);
			if (used[getroot(e)] < timer) {
				used[getroot(e)] = timer;
				ans = (1ll * ans * f(l[e], r[e])) % mod;
				obr[e] = binp(f(l[e], r[e]));
			}
		}
		cout << ans << "\n";
		sumw = ans;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}