#include <bits/stdc++.h>
using namespace std;

struct dsu {
    vector<int> par, rank;

    dsu(int n) : par(n), rank(n, 1) {
        iota(par.begin(), par.end(), 0);
    }

    int get(int u) {
        return par[u] == u ? u : (par[u] = get(par[u]));
    }

    void unite(int u, int v) {
        u = get(u), v = get(v);
        if (u != v) {
            if (rank[u] < rank[v]) {
                swap(u, v);
            }
            rank[u] += rank[v];
            par[v] = u;
        }
    }
};

const int MOD = 1e9 + 7;

int main() {
    int n;
    cin >> n;
    vector<int> p(n);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        g[i].push_back(p[i]);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    dsu sets(n);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> path[2];
        auto DFS = [&](int u, int par, int to, int it, auto&& DFS) -> bool {
            path[it].push_back(u);
            if (u == to) {
                return true;
            }
            for (int v : g[u]) {
                if (v == par) {
                    continue;
                }
                if (DFS(v, u, to, it, DFS)) {
                    return true;
                }
            }
            path[it].pop_back();
            return false;
        };
        DFS(a, -1, b,   0, DFS);
        DFS(c, -1, d, 1, DFS);
        for (int j = 0; j < (int)path[0].size(); j++) {
            sets.unite(path[0][j], path[1][j]);
        }
        vector<vector<int>> comp(n);
        for (int i = 0; i < n; i++) {
            comp[sets.get(i)].push_back(i);
        }
        int ans = 1;
        for (int i = 0; i < n; i++) {
            int max_l = -1, min_r = INT_MAX;
            for (int j : comp[i]) {
                max_l = max(max_l, l[j]);
                min_r = min(min_r, r[j]);
            }
            if (max_l != -1) {
                ans = 1ll * ans * max(0, min_r - max_l + 1) % MOD;
            }
        }
        cout << ans << "\n";
    }
}