#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

constexpr int mod = 1e9 + 7;

int binpow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n % 2 == 1) {
            ans = (ans * 1ll * a) % mod;
        }
        a = (a * 1ll * a) % mod;
        n /= 2;
    }
    return ans;
}

struct DSU {
    vector<int> p, sz;
    vector<pair<int, int>> lr;
    int ans = 1;

    DSU(vector<pair<int, int>> lr) : lr(lr) {
        int n = lr.size();
        for (auto [l, r] : lr) {
            ans = (ans * 1ll * (r - l + 1)) % mod;
        }
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
    }

    int get(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) {
            return;
        }
        if (sz[u] < sz[v]) {
            swap(u, v);
        }
        if (lr[u].second < lr[u].first || lr[v].second < lr[v].first) {
            ans = 0;
            return;
        }
        ans = (ans * 1ll * binpow(lr[u].second - lr[u].first + 1, mod - 2)) % mod;
        ans = (ans * 1ll * binpow(lr[v].second - lr[v].first + 1, mod - 2)) % mod;
        lr[u].first = max(lr[u].first, lr[v].first);
        lr[u].second = min(lr[u].second, lr[v].second);
        if (lr[u].second < lr[u].first) {
            ans = 0;
            return;
        }
        ans = (ans * 1ll * (lr[u].second - lr[u].first + 1)) % mod;
        sz[u] += sz[v];
        p[v] = u;
    }
};

vector<vector<int>> g;
vector<int> tin, tout;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = timer;
}

bool is_anc(int p, int v) {
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> par(n, -1);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> par[i];
        --par[i];
        g[par[i]].push_back(i);
    }
    tin.resize(n);
    tout.resize(n);
    dfs(0);
    vector<pair<int, int>> lr(n);
    for (auto &[x, y] : lr) {
        cin >> x >> y;
    }
    int m;
    cin >> m;
    DSU st(lr);
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        vector<int> p1, p2;
        while (!is_anc(a, b)) {
            p1.push_back(a);
            a = par[a];
        }
        p1.push_back(a);
        vector<int> gg1;
        while (!is_anc(b, a)) {
            gg1.push_back(b);
            b = par[b];
        }
        reverse(gg1.begin(), gg1.end());
        for (auto i : gg1) {
            p1.push_back(i);
        }
        while (!is_anc(c, d)) {
            p2.push_back(c);
            c = par[c];
        }
        p2.push_back(c);
        vector<int> gg2;
        while (!is_anc(d, c)) {
            gg2.push_back(d);
            d = par[d];
        }
        reverse(gg2.begin(), gg2.end());
        for (auto i : gg2) {
            p2.push_back(i);
        }
        assert(p1.size() == p2.size());
        for (int i = 0; i < (int) p1.size(); ++i) {
//            cout << p1[i] + 1 << " " << p2[i] + 1 << "\n";
            st.unite(p1[i], p2[i]);
        }
        cout << st.ans << "\n";
//        cout << "\n";
    }
}
