#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
using namespace std;
const string space=" ", slashn="\n";

void set_time(ll v, vector<vector<ll>>& children, vector<ll>& time_in, vector<ll>& time_out, ll& timer) {
    time_in[v] = timer;
    ++timer;
    for (auto child : children[v]) {
        set_time(child, children, time_in, time_out, timer);
    }
    time_out[v] = timer;
    ++timer;
}

void group_min_max(ll v, ll&g_max_l, ll&g_min_r, vector<vector<ll>>& children, vector<bool>& used, vector<ll>& L, vector<ll>& R) {
    used[v] = true;
    g_max_l = max(g_max_l, L[v]);
    g_min_r = min(g_min_r, R[v]);
    for (auto child : children[v]) {
        if (!used[child]) {
            group_min_max(child, g_max_l, g_min_r, children, used, L, R);
        }
    }
}

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0); cout.tie(0);
    const ll MOD = 1000000007;

    ll n; cin >> n;
    vector<ll> parent(n, -1);
    vector<vector<ll>> children(n, vector<ll>());
    for (ll i=1; i<n; ++i) {
        cin >> parent[i];
        --parent[i];

        children[parent[i]].push_back(i);
    }


    ll timer=0;
    vector<ll> time_in(n);
    vector<ll> time_out(n);
    set_time(0, children, time_in, time_out, timer);

//    for (auto el : time_in) {
//        cout << el << space;
//    } cout << slashn;
//
//    for (auto el : time_out) {
//        cout << el << space;
//    } cout << slashn;

    vector<ll> L(n);
    vector<ll> R(n);
    for (int i=0; i<n; ++i) {
        cin >> L[i] >> R[i];
    }

    vector<vector<ll>> eqg(n, vector<ll>());


    ll m; cin >> m;
    for (ll im=0; im<m; ++im) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        //cout << a << space << b << space << c << space << d << slashn;

        // нужно пройти путь от а до б и от ц до д
        ll v1=a, v2=c;
        eqg[a].push_back(c);
        eqg[c].push_back(a);
        //cout << v1 << space << v2 <<slashn;
        while (v1!=b && v2!=d) {
            // следующая вершина на ab
            if (!(time_in[v1]<=time_in[b] && time_out[b]<=time_out[v1])) {
                // в разных поддеревьях
                v1 = parent[v1];
            } else {
                for(auto child : children[v1]) {
                    if (time_in[child]<=time_in[b] && time_out[b]<=time_out[child]) {
                        v1 = child;
                        break;
                    }
                }
            }

            // следующая вершина на cd
            if (!(time_in[v2]<=time_in[d] && time_out[d]<=time_out[v2])) {
                // в разных поддеревьях
                v2 = parent[v2];
            } else {
                for(auto child : children[v2]) {
                    if (time_in[child]<=time_in[d] && time_out[d]<=time_out[child]) {
                        v2 = child;
                        break;
                    }
                }
            }

            eqg[v1].push_back(v2);
            eqg[v2].push_back(v1);
            //cout << v1 << space << v2 <<slashn;

        }

        // все новые ребра добавлены
        vector<bool> used(n, false);
        ll res = 1;
        for (ll i=0; i<n; ++i) {
            if (!used[i]) {
                ll g_max_l=INT64_MIN;
                ll g_min_r = INT64_MAX;
                group_min_max(i, g_max_l, g_min_r, eqg, used, L, R);
                //cout << i << space << g_max_l << space << g_min_r << slashn;
                if (g_max_l > g_min_r) {
                    res = 0;
                    break;
                }
                res *= (g_min_r-g_max_l+1);
            }
        }

        cout << res << slashn;
    }




    return 0;
}
