#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define endl '\n'
#define pb push_back
//#define int long long

const int INF = 1e9 + 7, N = 2e5 + 10;

vec<int> p(N, 1);

struct fenwick {
    int n;
    vec<int> tree;
    void init(int n_) {
        n = n_;
        tree.resize(n + 1);
    }
    void upd(int i, int a) {
        i++;
        for (; i <= n; i += i & -i) tree[i] = max(a, tree[i]);
    }
    int get(int x) {
        int s = 0;
        x++;
        for (; x > 0; x -= x & -x) s = max(s, tree[x]);
        return s;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector {
    ld x, y;
    Vector(ld x_, ld y_) {
        x = x_, y = y_;
    }
    friend Vector operator+(Vector& a, Vector& b) {
        return { a.x + b.x, a.y + b.y };
    }
    friend Vector operator-(Vector& a, Vector& b) {
        return { a.x + b.x, a.y + b.y };
    }
    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }
    friend ld operator%(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }
    ld len() {
        return x * x + y * y;
    }
    ld len2() {
        return sqrt(x * x + y * y);
    }
    void norm() {
        ld l = len2();
        x /= l, y /= l;
    }
};

struct Line {
    ld a, b, c;
    Line(ld a_, ld b_, ld c_) {
        a = a_, b = b_, c = c_;
    }
    ld rast(Vector p) {
        return (a * p.x + b * p.y + c) / ((sqrt(a * a + b * b)));
    }
};

struct Hash {
    vec<int> h;
    int n;
    void init(string& s) {
        n = (int)s.size();
        h.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            h[i] = (h[i - 1] * 37 + s[i] - 'a' + 1) % INF;
        }
    }
    int get(int l, int r) {
        return (((h[r + 1] - h[l] + INF) % INF) * p[N - l - 1]) % INF;
    }
};

bool comp(pair<int, vec<int>>& a, pair<int, vec<int>>& b) {
    return a.first < b.first;
}

ll pow(ll a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return (pow(a, n - 1) * a) % INF;
    ll b = pow(a, n / 2);
    return (b * b) % INF;
}

int n, m;
ll ans = 1;
vec<int> pr(2e5), h(2e5);
vec<vec<int>> g(2e5), gr(2e5, vec<int>(20));
int timer = 0;
vec<int> p2(2e5), mn(2e5), mx(2e5), sz(2e5), tin(2e5), tout(2e5);

void dfs(int v = 0, int pred = 0, int h_ = 0) {
    tin[v] = (timer++);
    gr[v][0] = pred;
    h[v] = h_;
    for (int i = 1; i < 20; ++i) gr[v][i] = gr[gr[v][i - 1]][i - 1];
    for (int i : g[v]) if (i != pred) dfs(i, v, h_ + 1);
    tout[v] = (timer++);
}

bool prov(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
    if (prov(a, b)) return a;
    if (prov(b, a)) return b;
    for (int i = 19; i >= 0; --i) {
        if (!prov(gr[a][i], b)) {
            a = gr[a][i];
        }
    }
    return gr[a][0];
}

int get(int& v) {
    if (v == p2[v]) return v;
    return p2[v] = get(p2[v]);
}

void union_sets(int a, int b) {
    //cout << a << " " << b << endl;
    a = get(a);
    b = get(b);
    if (a != b) {
        if (sz[a] < sz[b]) swap(a, b);
        sz[a] += sz[b];
        p2[b] = a;
        //cout << ans << endl;
        ans *= pow(ll(mx[a] - mn[a] + 1), INF - 2);
        ans %= INF;
        ans *= pow(ll(mx[b] - mn[b] + 1), INF - 2);
        ans %= INF;
        //cout << (mx[a] - mn[a] + 1) << " " << (mx[b] - mn[b] + 1) << " " << ans << " " <<  pow(ll(mx[a] - mn[a] + 1), INF - 2) << " " << pow(ll(mx[b] - mn[b] + 1), INF - 2) <<endl;
        mn[a] = max(mn[a], mn[b]);
        mx[a] = min(mx[a], mx[b]);
        if (mn[a] > mx[a]) ans = 0;
        else ans = (ans * (mx[a] - mn[a] + 1)) % INF;
    }
}

vec<int> e(2e5);

void pyt(int a, int b, int c, int d) {
    int lc = lca(a, b), lc2 = lca(c, d);
    int ind = 0;
    for (int i = a; i != lc; i = pr[i]) e[ind++] = i;
    e[ind++] = lc;
    ind = h[a] + h[b] - 2 * h[lc];
    for (int i = b; i != lc; i = pr[i]) e[ind--] = i;


    ind = 0;
    for (int i = c; i != lc2; i = pr[i]) union_sets(e[ind++], i);
    union_sets(e[ind++], lc2);
    ind = h[a] + h[b] - 2 * h[lc];
    for (int i = d; i != lc2; i = pr[i]) union_sets(e[ind--], i);
    //cout << a << " " << b << " " << c << " " << d << " " << lc << " " << lc2 << endl;
}

void solve() {
    cin >> n;
    bool flag = 1;
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        if (pr[i] != i) flag = 0;
        pr[i]--;
        g[pr[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        p2[i] = i;
        mn[i] = l;
        mx[i] = r;
        sz[i] = 1;
        ans *= (r - l + 1);
        ans %= INF;
    }
    dfs();
    cin >> m;
    if (flag) {
        int cc = 0;
        for (; m > 0; --m) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--; b--; c--; d--;
            if (ans == 0) {
                cout << 0 << endl;
                continue;
            }
            if (cc <= 1000) pyt(a, b, c, d);
            cc++;
            cout << ans << endl;
        }
        return;
    }
    for (; m > 0; --m) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        if (ans == 0) {
            cout << 0 << endl;
            continue;
        }
        pyt(a, b, c, d);
        cout << ans << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}