#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

/*
const int N = 1e5;
ll p[N], sz[N];
ll find(ll v)
{
	if (p[v] == v) return v;
	return p[v] = find(p[v]);
}
void union_s(ll a, ll b)
{
	a = find(a);
	b = find(b);
	if (a != b)
	{
		if (sz[a] < sz[b]) swap(a, b);
		p[b] = a;
		sz[a] += sz[b];
	}
}
*/
/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/

const int N = 2e5;
vector <ll> g[N], f[N];
ll p[N], l[N], r[N], timer = 0, tin[N], tout[N], up[20][N], sz[N], pp[N];
ll find(ll v)
{
	if (pp[v] == v) return v;
	return pp[v] = find(pp[v]);
}
void union_s(ll a, ll b)
{
	a = find(a);
	b = find(b);
	if (a != b)
	{
		if (sz[a] < sz[b]) swap(a, b);
		l[a] = max(l[a], l[b]);
		r[a] = min(r[a], r[b]);
		pp[b] = a;
		sz[a] += sz[b];
	}
}
void dfs(ll v, ll prev)
{
	tin[v] = timer++;
	up[0][v] = prev;
	for (ll i = 1; i < 20; i++)
	{
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	for (auto i : g[v])
	{
		if (i != prev)
		{
			dfs(i, v);
		}
	}
	tout[v] = timer++;
}
bool upper(ll a, ll b)
{
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
ll lca(ll a, ll b)
{
	if (upper(a, b)) return a;
	if (upper(b, a)) return b;
	for (ll i = 19; i >= 0; i--)
	{
		if (!upper(up[i][a], b))
		{
			a = up[i][a];
		}
	}
	return up[0][a];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	for (ll i = 1; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	for (ll i = 0; i < n; i++) cin >> l[i] >> r[i];
	for (ll i = 0; i < n; i++) pp[i] = i;
	for (ll i = 0; i < n; i++) sz[i] = 1;
	dfs(0, 0);
	ll m, mod = 1e9 + 7;
	cin >> m;
	while (m--)
	{
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		vector <bool> used(n);
		a--;
		b--;
		c--;
		d--;
		vector <ll> ab, cd;
		vector <ll> q;
		ll s = lca(a, b);
		while (a != s)
		{
			used[a] = true;
			ab.push_back(a);
			a = p[a];
		}
		while (b != s)
		{
			used[b] = true;
			q.push_back(b);
			b = p[b];
		}
		used[s] = true;
		q.push_back(s);
		while (!q.empty())
		{
			ab.push_back(q.back());
			q.pop_back();
		}
		s = lca(c, d);
		while (c != s)
		{
			used[c] = true;
			cd.push_back(c);
			c = p[c];
		}
		while (d != s)
		{
			used[d] = true;
			q.push_back(d);
			d = p[d];
		}
		used[s] = true;
		q.push_back(s);
		while (!q.empty())
		{
			cd.push_back(q.back());
			q.pop_back();
		}
		ll ans = 1;
		for (ll i = 0; i < ab.size(); i++)
		{
			union_s(ab[i], cd[i]);
		}
		set <ll> vis;
		for (ll i = 0; i < n; i++)
		{
			ll s = find(i);
			if (vis.find(s) == vis.end())
			{
				vis.insert(s);
				if (l[s] > r[s]) ans = 0;
				ans *= (r[s] - l[s] + 1);
				ans %= mod;
			}
		}
		cout << ans << "\n";
	}

	/*
	A
	ll n, k;
	cin >> n >> k;
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	if (n == 1)
	{
		cout << fixed << setprecision(10) << (dl)(a[0] / k) / a[0] * k;
	}
	else if (n == 2)
	{
		dl ans = 0;
		for (ll i = 1; i <= k; i++)
		{
			ll a1 = i, a2 = k / i;
			while (a2 * a1 < k) a2++;
			ans = max(ans, ((dl)(a[0] / a1) / a[0]) * ((dl)(a[1] / a2) / a[1]) * k);
		}
		cout << fixed << setprecision(10) << ans;
	}*/

	return 0;
}
/*
B
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

*/