#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	if (p == 1) return a;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/

bool tt = true;
const int N = 2e5 + 1;
vector <ll> g[N], f[N];
ll p[N], l[N], r[N], timer = 0, tin[N], tout[N], up[19][N], sz[N], pp[N];
ll find(ll v)
{
	if (pp[v] == v) return v;
	return pp[v] = find(pp[v]);
}
ll ans = 1, mod = 1e9 + 7;
set <ll> us;
void union_s(ll a, ll b)
{
	a = find(a);
	b = find(b);
	if (a != b)
	{
		if (sz[a] < sz[b]) swap(a, b);
		/*
		ans *= power(r[a] - l[a] + 1, mod - 2, mod);
		ans %= mod;
		ans *= power(r[b] - l[b] + 1, mod - 2, mod);
		ans %= mod;
		*/
		us.erase(b);
		l[a] = max(l[a], l[b]);
		r[a] = min(r[a], r[b]);
		//ans *= (r[a] - l[a] + 1);
		//ans %= mod;
		if (l[a] > r[a]) tt = false;
		pp[b] = a;
		sz[a] += sz[b];
	}
}
void dfs(ll v, ll prev)
{
	tin[v] = timer++;
	up[0][v] = prev;
	for (ll i = 1; i < 19; i++)
	{
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	for (auto i : g[v])
	{
		if (i != prev)
		{
			dfs(i, v);
		}
	}
	tout[v] = timer++;
}
bool upper(ll a, ll b)
{
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
ll lca(ll a, ll b)
{
	if (upper(a, b)) return a;
	if (upper(b, a)) return b;
	for (ll i = 18; i >= 0; i--)
	{
		if (!upper(up[i][a], b))
		{
			a = up[i][a];
		}
	}
	return up[0][a];
}

/*
vector <ll> tr;
void dfs(ll v, ll cur, bool& f, vector <ll>& y, vector <ll>& used, vector <vector <pair <ll, ll>>>& g)
{
	tr.push_back(v);
	used[v] = 1;
	y[v] = cur;
	for (auto [i, w] : g[v])
	{
		if (used[i] == 0) dfs(i, cur ^ w, f, y, used, g);
		else if (cur != y[i]) f = true;
	}
	used[v] = 2;
	tr.pop_back();
}
void dfsr(ll v, vector <ll>& used, vector <vector <pair <ll, ll>>>& gr)
{
	used[v] = -1;
	for (auto [i, w] : gr[v])
	{
		if (used[i] == 2)
		{
			dfsr(i, used, gr);
		}
	}
}
void dfs_top(ll v, vector <ll>& k, vector <ll>& used, vector <vector <pair <ll, ll>>>& g)
{
	used[v] = -2;
	for (auto [i, w] : g[v])
	{
		if (used[i] == -1)
		{
			dfs_top(i, k, used, g);
		}
	}
	k.push_back(v);
}
*/


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	for (ll i = 1; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	for (ll i = 0; i < n; i++) cin >> l[i] >> r[i];
	ll m;
	for (ll i = 0; i < n; i++)
	{
		us.insert(i);
	}
	for (ll i = 0; i < n; i++) pp[i] = i;
	for (ll i = 0; i < n; i++) sz[i] = 1;
	dfs(0, 0);
	cin >> m;
	while (m--)
	{
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		if (!tt)
		{
			cout << "0\n";
			continue;
		}
		vector <ll> ab, cd, q;
		ll s = lca(a, b);
		while (a != s)
		{
			ab.push_back(a);
			a = p[a];
		}
		ab.push_back(s);
		while (b != s)
		{
			q.push_back(b);
			b = p[b];
		}
		while (!q.empty())
		{
			ab.push_back(q.back());
			q.pop_back();
		}
		s = lca(c, d);
		while (c != s)
		{
			cd.push_back(c);
			c = p[c];
		}
		cd.push_back(s);
		while (d != s)
		{
			q.push_back(d);
			d = p[d];
		}
		while (!q.empty())
		{
			cd.push_back(q.back());
			q.pop_back();
		}
		for (ll i = 0; i < ab.size(); i++)
		{
			union_s(ab[i], cd[i]);
		}
		ans = 1;
		for (auto i : us)
		{
			ans *= (r[i] - l[i] + 1);
			ans %= mod;
		}
		cout << ans << "\n";
	}

	/*
	ll t;
	cin >> t;
	while (t--)
	{
		ll n, m;
		cin >> n >> m;
		vector <vector <pair <ll, ll>>> g(n), gr(n);
		for (ll i = 0; i < m; i++)
		{
			ll u, v, w;
			cin >> u >> v >> w;
			u--;
			v--;
			g[u].push_back({ v, w });
			gr[v].push_back({ u, w });
		}
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		vector <ll> used(n), p(n), y(n);
		bool f = false;
		dfs(a, 0, f, y, used, g);
		if (f) cout << "-1\n";
		else
		{
			dfsr(b, used, gr);
			vector <vector <pair <ll, ll>>> ng(n);
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : g[i])
				{
					if (used[i] == -1 && used[j] == -1)
					{
						ng[i].push_back({j, w});
					}
				}
			}
			swap(g, ng);
			vector <vector <pair <ll, ll>>> ngr(n);
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : gr[i])
				{
					if (used[i] == -1 && used[j] == -1)
					{
						ngr[i].push_back({ j, w });
					}
				}
			}
			swap(gr, ngr);
			vector <ll> k;
			dfs_top(a, k, used, g);
			vector <ll> dp_l(n), dp_r(n);
			dp_l[a] = 1;
			dp_r[b] = 1;
			for (ll i = 0; i < k.size(); i++)
			{
				for (auto [j, w] : gr[k[i]])
				{
					dp_l[k[i]] += dp_l[j];
				}
			}
			for (ll i = (ll)k.size() - 1; i >= 0; i--)
			{
				for (auto [j, w] : g[k[i]])
				{
					dp_r[k[i]] += dp_r[j];
				}
			}
			ll ans = 0;
			for (ll i = 0; i < n; i++)
			{
				for (auto [j, w] : g[i])
				{
					if (dp_l[i] % 2 == 1 && dp_r[j] % 2 == 1)
					{
						ans += w;
					}
				}
			}
			cout << ans << "\n";
		}
	}
	*/

	/*
	A
	ll n, k;
	cin >> n >> k;
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	if (n == 1)
	{
		cout << fixed << setprecision(10) << (dl)(a[0] / k) / a[0] * k;
	}
	else if (n == 2)
	{
		dl ans = 0;
		for (ll i = 1; i <= k; i++)
		{
			ll a1 = i, a2 = k / i;
			while (a2 * a1 < k) a2++;
			ans = max(ans, ((dl)(a[0] / a1) / a[0]) * ((dl)(a[1] / a2) / a[1]) * k);
		}
		cout << fixed << setprecision(10) << ans;
	}*/

	return 0;
}
/*
C

5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4
--------------------------------
B

5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

*/