#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <fstream>
#include <sstream>
using namespace std;

typedef long long ll;
typedef long double dl;

ll power(ll a, ll p, ll mod)
{
	if (p == 0) return 1;
	if (p == 1) return a;
	ll d = power(a, p / 2, mod);
	if (p % 2 == 0) return (d * d) % mod;
	return ((d * d) % mod * a) % mod;
}
ll gcd(ll a, ll b)
{
	if (a == 0 || b == 0) return a + b;
	if (a < b) swap(a, b);
	return gcd(b, a % b);
}
ll lcm(ll a, ll b)
{
	return a / gcd(a, b) * b;
}

/*
const int N = 1e5;
ll t[4 * N];
void build(ll v, ll tl, ll tr)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (r < l) return 0;
	if (tl == l && tr == r) return t[v];
	ll tm = (tl + tr) / 2;
	return get(2 * v, tl, tm, l, min(tm, r)) + get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
}
void upd(ll v, ll tl, ll tr, ll pos)
{
	if (tl == tr) t[v] = 0;
	else
	{
		ll tm = (tl + tr) / 2;
		if (pos <= tm) upd(2 * v, tl, tm, pos);
		else upd(2 * v + 1, tm + 1, tr, pos);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}
*/
/*
const int N = 1000;
vector <ll> g[N];
ll mt[N];
bool try_kuhn(ll v)
{
	for (auto i : g[v])
	{
		if (mt[i] == -1 || mt[i] != -1 && try_kuhn(mt[i]))
		{
			mt[i] = v;
			return true;
		}
	}
	return false;
}
*/
/*
const int N = 1e5;
vector <ll> g[N];
ll sz[N], head[N], tin[N];
void sizes(ll v, ll prev)
{
	sz[v] = 1;
	for (auto i : g[v])
	{
		if (i != prev)
		{
			sizes(i, v);
			sz[v] += sz[i];
		}
	}
}
ll timer = 0;
void hld(ll v, ll prev)
{
	tin[v] = timer++;
	head[v] = v;
	for (auto& i : g[v])
	{
		if (i != prev && sz[i] > sz[g[v][0]])
		{
			swap(i, g[v][0]);
		}
	}
	for (auto i : g[v])
	{
		if (i == g[v][0]) head[i] = head[v];
		else head[i] = i;
		hld(i, v);
	}
}
*/
/*
vector <ll> sufmas(string& s)
{
	ll n = s.size();
	vector <ll> a(n);
	for (ll i = 0; i < n; i++) a[i] = s[i] - 'a' + 1;
	a.push_back(0);
	n++;
	vector <ll> p(n), c(n);
	for (ll i = 0; i < n; i++) c[i] = a[i];

}
*/

bool tt = true;
const int N = 2e5 + 1;
vector <ll> g[N], f[N];
ll p[N], l[N], r[N], timer = 0, tin[N], tout[N], up[19][N], sz[N], pp[N];
ll find(ll v)
{
	if (pp[v] == v) return v;
	return pp[v] = find(pp[v]);
}
ll cnt = 0;
ll ans = 1, mod = 1e9 + 7;
void union_s(ll a, ll b)
{
	a = find(a);
	b = find(b);
	if (a != b)
	{
		if (sz[a] < sz[b]) swap(a, b);
		ans *= power(r[a] - l[a] + 1, mod - 2, mod);
		ans %= mod;
		ans *= power(r[b] - l[b] + 1, mod - 2, mod);
		ans %= mod;
		l[a] = max(l[a], l[b]);
		r[a] = min(r[a], r[b]);
		ans *= (r[a] - l[a] + 1);
		ans %= mod;
		cnt--;
		if (l[a] > r[a])
		{
			tt = false;
			ans = 0;
		}
		pp[b] = a;
		sz[a] += sz[b];
	}
}
void dfs(ll v, ll prev)
{
	tin[v] = timer++;
	up[0][v] = prev;
	for (ll i = 1; i < 19; i++)
	{
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	for (auto i : g[v])
	{
		if (i != prev)
		{
			dfs(i, v);
		}
	}
	tout[v] = timer++;
}
bool upper(ll a, ll b)
{
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}
ll lca(ll a, ll b)
{
	if (upper(a, b)) return a;
	if (upper(b, a)) return b;
	for (ll i = 18; i >= 0; i--)
	{
		if (!upper(up[i][a], b))
		{
			a = up[i][a];
		}
	}
	return up[0][a];
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n;
	cin >> n;
	cnt = n;
	for (ll i = 1; i < n; i++)
	{
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	ll m;
	for (ll i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
		ans *= (r[i] - l[i] + 1);
		ans %= mod;
		pp[i] = i;
		sz[i] = 1;
	}
	dfs(0, 0);
	cin >> m;
	vector <ll> ab, q;
	while (m--)
	{
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		if (ans == 0)
		{
			cout << "0\n";
			continue;
		}
		if (cnt == 1)
		{
			cout << ans << "\n";
			continue;
		}
		ll s = lca(a, b);
		while (a != s)
		{
			ab.push_back(a);
			a = p[a];
		}
		ab.push_back(s);
		while (b != s)
		{
			q.push_back(b);
			b = p[b];
		}
		while (!q.empty())
		{
			ab.push_back(q.back());
			q.pop_back();
		}
		s = lca(c, d);
		ll j = 0;
		while (c != s)
		{
			union_s(ab[j], c);
			j++;
			c = p[c];
		}
		union_s(ab[j], s);
		j++;
		while (d != s)
		{
			q.push_back(d);
			d = p[d];
		}
		while (!q.empty())
		{
			union_s(ab[j], q.back());
			j++;
			q.pop_back();
		}
		ab.clear();
		cout << ans << "\n";
	}

	return 0;
}
/*
*/