#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

const ll D = 1e9 + 7;

vector<int> way;
bool ok;
vector<vector<int>> v;

void dfs(int i, int e, vector<bool>& was) {
	if (i == e) {
		ok = true;
		re;
	}
	if (was[i])re;
	was[i] = true;

	for (auto j : v[i]) {
		way.push_back(j);
		dfs(j, e, was);
		if (ok)re;
		way.pop_back();
	}
}

struct dsu {
	vector<int> v;

	dsu() {}
	dsu(int n) {
		v.resize(n);
		fori(n)
			v[i] = i;
	}

	int get_par(int i) {
		if (v[i] != i) v[i] = get_par(v[i]);
		re v[i];
	}

	void merge(int i1, int i2) {
		int p1 = get_par(i1), p2 = get_par(i2);

		v[p1] = p2;
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int n; cin >> n;
	v.resize(n);
	vector<pair<ll, ll>> cost(n);
	dsu ds(n);

	fori(n - 1) {
		int a; cin >> a;
		v[i + 1].push_back(a - 1);
		v[a - 1].push_back(i + 1);
	}
	cin >> cost;

	int m; cin >> m;
	while (m--) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;

		--a; --b; --c; --d;
		vector<bool> was(n, false);
		way.clear();
		ok = false;

		way.push_back(a);
		dfs(a, b, was);
		vector<int> v1 = way;

		way.clear();
		ok = false;
		fill(all(was), false);

		way.push_back(c);
		dfs(c, d, was);
		vector<int> v2 = way;

		fori(v1.size()) {
			v1[i] = ds.get_par(v1[i]);
			v2[i] = ds.get_par(v2[i]);

			if (v1[i] == v2[i])continue;
			cost[v1[i]].first = max(cost[v1[i]].first, cost[v2[i]].first);
			cost[v1[i]].second = min(cost[v1[i]].second, cost[v2[i]].second);

			ds.merge(v2[i], v1[i]);

			cost[v2[i]].first = 0;
			cost[v2[i]].second = 0;
		}

		ll ans = 1;

		fori(n) {
			ans = (ans * max(0ll, cost[i].second - cost[i].first + 1)) % D;
		}

		cout << ans << "\n";
	}
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
*/