#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

constexpr int N = 2e5 + 3;

template<int MOD>
class MintBase {
 public:
  using Type = MintBase<MOD>;
  MintBase(): x(0) {}
  explicit MintBase(int x) : x(x) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD ? x + rhs.x - MOD : x + rhs.x
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD : x - rhs.x
    };
  }
  Type operator * (const Type & rhs) const {
    return Type(static_cast<int>(1ll * x * rhs.x % MOD));
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return x < rhs.x; }
  bool operator == (const Type & rhs) const { return x == rhs.x; }
  bool operator != (const Type & rhs) const { return x != rhs.x; }

  int x;
};
constexpr int MOD = int(1e9) + 7;
typedef MintBase<MOD> Mint;

template<int MOD1, int MOD2>
class HashBase {
 public:
  using Type = HashBase<MOD1, MOD2>;
  HashBase(): x(0), y(0) {}
  explicit HashBase(int x) : x(x), y(x) {}
  HashBase(int x, int y) : x(x), y(y) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD1 ? x + rhs.x - MOD1 : x + rhs.x,
        y + rhs.y >= MOD2 ? y + rhs.y - MOD2 : y + rhs.y
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD1 : x - rhs.x,
        y - rhs.y < 0 ? y - rhs.y + MOD2 : y - rhs.y
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD1),
        static_cast<int>(1ll * y * rhs.y % MOD2)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return optimization < rhs.optimization; }
  bool operator == (const Type & rhs) const { return optimization == rhs.optimization; }
  bool operator != (const Type & rhs) const { return optimization != rhs.optimization; }

 private:
  union {
    struct { int y, x; };
    ll optimization;
  };
};
typedef HashBase<int(1e9) + 7, int(1e9) + 9> Hash;
Hash P(911, 991), pws[N];

template<int MOD1, int MOD2>
HashBase<MOD1, MOD2> Substr(int l, int r, const vector<HashBase<MOD1, MOD2>> & hash) {
  return hash[r] - hash[l] * pws[r - l];
}

vector<int> ZFunc(const string & s) {
  vector<int> z(s.size());
  int n = static_cast<int>(s.size());
  for (int i = 1, l = 0, r = 0; i < n; ++i) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n && s[z[i]] == s[i + z[i]])
      ++z[i];
    if (i + z[i] > r)
      l = i, r = i + z[i];
  }
  return z;
}

class SegmentTree {
 public:
  SegmentTree(int n) {
    sz = 1;
    while (sz < n) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
  }
  SegmentTree(const vector<ll> & orig) {
    sz = 1;
    while (sz < static_cast<int>(orig.size())) sz *= 2;
    segm.resize(sz * 2, 0);
    add.resize(sz * 2, 0);
    for (int i = 0; i < static_cast<int>(orig.size()); ++i)
      segm[i + sz] = orig[i];
    for (int i = sz - 1; i > 0; --i)
      segm[i] = segm[i << 1] + segm[i << 1 | 1];
  }
  ll Get(int l, int r) {
    return Get(l, r, 1, 0, sz);
  }
  void Update(int l, int r, ll val) {
    Update(l, r, val, 1, 0, sz);
  }

 private:
  void Push(int v, int vl, int vr) {
    if (add[v]) {
      segm[v] += add[v] * (vr - vl);
      if (v < sz) {
        add[v << 1] += add[v];
        add[v << 1 | 1] += add[v];
      }
      add[v] = 0;
    }
  }
  ll Get(int l, int r, int v, int vl, int vr) {
    if (l >= vr || vl >= r) return 0;
    Push(v, vl, vr);
    if (l <= vl && vr <= r) return segm[v];
    int vm = (vl + vr) >> 1;
    return Get(l, r, v << 1, vl, vm) + Get(l, r, v << 1 | 1, vm, vr);
  }
  void Update(int l, int r, ll val, int v, int vl, int vr) {
    Push(v, vl, vr);
    if (l >= vr || vl >= r) return;
    if (l <= vl && vr <= r) {
      add[v] = val;
      Push(v, vl, vr);
      return;
    }
    int vm = (vl + vr) >> 1;
    Update(l, r, val, v << 1, vl, vm);
    Update(l, r, val, v << 1 | 1, vm, vr);
    segm[v] = segm[v << 1] + segm[v << 1 | 1];
  }
 private:
  int sz;
  vector<ll> segm, add;
};


Mint Binpow(Mint m, ll p) {
  Mint ans(1);
  while (p) {
    if (p & 1)
      ans *= m;
    m *= m;
    p >>= 1;
  }
  return ans;
}

constexpr int LG = 18;
vector<int> g[N];
int h[N];
Mint rev[N];
int jmp[LG][N];
int l[N], r[N];

Mint ans;
int p[N], rnk[N], lt[N], rt[N];

void Init(int n) {
  iota(p, p + n, 0);
  fill(rnk, rnk + n, 1);
  for (int i = 0; i < n; ++i)
    lt[i] = l[i], rt[i] = r[i];
}

int Get(int n) {
  return p[n] == n ? n : p[n] = Get(p[n]);
}
void Join(int a, int b) {
  a = Get(a), b = Get(b);
  if (a == b) return;
  if (rnk[a] < rnk[b]) swap(a, b);
  p[b] = a;
  if (rnk[a] == rnk[b]) ++rnk[a];
  ans *= rev[max(0, rt[a] - lt[a] + 1)];
  ans *= rev[max(0, rt[b] - lt[b] + 1)];
  smax(lt[a], lt[b]);
  smin(rt[a], rt[b]);
  ans *= Mint(max(0, rt[a] - lt[a] + 1));
}

void Dfs(int v) {
  for (int u : g[v]) {
    jmp[0][u] = v;
    h[u] = h[v] + 1;
    Dfs(u);
  }
}
int Up(int v, int lvl) {
  for (int i = LG-1; i >= 0; --i)
    if (h[v] - (1 << i) >= lvl)
      v = jmp[i][v];
  return v;
}
int Lca(int u, int v) {
  if (h[u] > h[v]) swap(u, v);
  v = Up(v, h[u]);
  if (u == v) return u;
  for (int i = LG-1; i >= 0; --i)
    if (jmp[i][v] != jmp[i][u]) {
      v = jmp[i][v];
      u = jmp[i][u];
    }
  return jmp[0][v];
}

int ap[N], bp[N];

void Solve() {

  int n;
  cin >> n;
  for (int i = 1, x; i < n; ++i) {
    cin >> x; --x;
    g[x].push_back(i);
  }
  Dfs(0);
  for (int k = 1; k < LG; ++k)
    for (int i = 0; i < n; ++i)
      jmp[k][i] = jmp[k-1][jmp[k-1][i]];
  for (int i = 0; i < n; ++i)
    cin >> l[i] >> r[i];
  int m;
  cin >> m;
  ans = Mint(1);
  for (int v = 0; v < n; ++v) {
    ans *= Mint(max(0, r[v] - l[v] + 1));
  }
  auto Path = [](int u, int v, int * arr) {
    arr[0] = u;
    int ind = 1;
    int l = Lca(u, v);
    while (u != l) {
      u = jmp[0][u];
      arr[ind++] = u;
    }
    int sz = ind;
    while (v != l) {
      arr[ind++] = v;
      v = jmp[0][v];
    }
    if (sz != ind)
      reverse(arr + sz, arr + ind);
    return ind;
  };

  Init(n);
  for (int i = 0; i < m; ++i) {
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    --a, --b, --c, --d;
    if (ans.x == 0) {
      cout << 0 << endl;
      continue;
    }
    if (a == b) {
      Join(a, c);
      cout << ans.x << endl;
      continue;
    }
    int k = Path(a, b, ap);
    assert(k == Path(c, d, bp));
    for (int j = 0; j < k; ++j) {
      int x = ap[j], y = bp[j];
      Join(x, y);
    }
    cout << ans.x << endl;
  }

}


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  pws[0] = Hash(1);
  for (int i = 1; i < N; ++i) {
    pws[i] = pws[i-1] * P;
  }
  for (int i = 1; i < N; ++i) {
    rev[i] = Binpow(Mint(i), MOD-2);
  }

  Solve();

  return 0;
}
