#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

vector<int> p;
int MOD = 1e9 + 7;

pair<bool, vector<int>> get_root_path(int u, int v0) {
    vector<int> path;
    while (u != -1 && u != v0) {
        path.push_back(u);
        u = p[u];
    }
    if (u == v0) {
        path.push_back(u);
        return {true, path};
    }
    return {false, path};
}

vector<int> get_path(int u, int v) {
    if (u == v) {
        return {u};
    }
    auto [found, path] = get_root_path(u, v);
    if (found) {
        return path;
    }
    auto [found2, path2] = get_root_path(v, u);
    std::reverse(path2.begin(), path2.end());
    if (found2) {
        return path2;
    }
    int last;
    while (path.back() == path2.back()) {
        last = path.back();
        path.pop_back();
        path2.pop_back();
    }
    path.push_back(last);
    int ps = path.size();
    path.resize(ps + path2.size() + 1);
    range(i, path2.size()) {
        path[i + ps] = path2[i];
    }
    return path;
}


int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    p.resize(n);
    vector<int> num2group(n);
    vector<set<int>> group2nums(n);
    p[0] = -1;
    num2group[0] = 0;
    group2nums[0] = {0};
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        num2group[i] = i;
        group2nums[i] = {i};
    }
    vector<pair<int, int>> group2minmax(n);
    long long last_ans = 1;
    range(i, n) {
        int l, r;
        cin >> l >> r;
        group2minmax[i] = {l, r};
        last_ans *= (r - l + 1);
        last_ans %= MOD;
    }
    int m;
    cin >> m;
    bool edit = false;
    loop(m) {
        if (last_ans == 0) {
            cout << 0 << endline;
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector<int> path1 = get_path(a, b);
        vector<int> path2 = get_path(c, d);
        range(i, path1.size()) {
            int g1 = num2group[path1[i]],
                    g2 = num2group[path2[i]];
            if (g1 == g2) {
                continue;
            }
            if (group2nums[g1].size() < group2nums[g2].size()) {
                swap(g1, g2);
            }
            for (int num: group2nums[g2]) {
                num2group[num] = g1;
                group2nums[g1].insert(num);
            }
            auto [l1, r1] = group2minmax[g1];
            auto [l2, r2] = group2minmax[g2];
            group2minmax[g1] = {max(l1, l2), min(r1, r2)};
            group2minmax[g2] = {0, 0};
            if (max(l1, l2) > min(r1, r2)) {
                last_ans = 0;
                edit = false;
                break;
            }
            edit = true;
        }
        if (edit) {
            last_ans = 1;
            for (auto [l, r]: group2minmax) {
                last_ans *= (r - l + 1);
                last_ans %= MOD;
            }
            edit = false;
        }
        cout << last_ans << endline;
    }
}
