#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

vector<int> g[MAXN];

pair<int, int> a[MAXN];

vector<int> pred(MAXN, 0);

int bin_pow(int x, int y) {
    if (y == 0) return 1;
    if (~y & 1) return bin_pow((1LL * x * x) % MOD, y / 2);
    return (1LL * x * bin_pow(x, y - 1)) % MOD;
}

const int K = 18;

int up[K + 1][MAXN], dep[MAXN];

void dfs(int v = 1, int pr = -1) {
    up[0][v] = pr;
    for (int i = 0; i < K && up[i][v] != -1; ++i) {
        up[i + 1][v] = up[i][up[i][v]];
    }
    for (auto &to : g[v]) {
        dep[to] = dep[v] + 1;
        dfs(to, v);
    }
}

int lca(int u, int v) {
    if (dep[u] > dep[v]) swap(u, v);
    int diff = dep[v] - dep[u];
    for (int i = 0; i <= K; ++i) {
        if ((diff >> i) & 1) {
            v = up[i][v];
        }
    }
    if (u == v) return u;
    for (int s = K; s >= 0; --s) {
        if (up[s][v] != up[s][u]) {
            v = up[s][v];
            u = up[s][u];
        }
    }
    return up[0][v];
}

vector<int> get_way(int x,int y) {
    vector<int> ans;
    int lc = lca(x, y);
    while (x != lc) {
        ans.push_back(x);
        x = pred[x];
    }
    ans.push_back(lc);
    vector<int> t;
    while (y != lc) {
        t.push_back(y);
        y = pred[y];
    }
    reverse(all(t));
    for (auto &el : t) {
        ans.push_back(el);
    }
    return ans;
}

int get(int l, int r) {
    return max(0, r - l + 1);
}

int ans = 1;

struct DSU {
    vector<int> p, rng, l, r;

    DSU(int n) {
        p.resize(n + 1), rng.resize(n + 1, 1);
        l.resize(n + 1, 0), r.resize(n + 1);
        for (int i = 1; i <= n; ++i) {
            p[i] = i;
            l[i] = a[i].X, r[i] = a[i].Y;
            ans = (1ll * ans * (r[i] - l[i] + 1)) % MOD;
        }
    }

    int fnd(int x) {
        return x == p[x] ? x : p[x] = fnd(p[x]);
    }
    void unite(int x, int y) {
        x = fnd(x), y = fnd(y);
        if (x == y) return;
        if (rng[x] > rng[y]) swap(x, y);
        ans = (1LL * ans * bin_pow(get(l[x], r[x]), MOD - 2)) % MOD;
        ans = (1LL * ans * bin_pow(get(l[y], r[y]), MOD - 2)) % MOD;
        p[x] = y;
        rng[y] += rng[x];
        l[y] = max(l[y], l[x]);
        r[y] = min(r[y], r[x]);
        ans = (1LL * ans * get(l[y], r[y])) % MOD;
    }
};

const int ab = 317;

mt19937 rnd(228);

void solve() {
    int n;
    cin >> n;
    bool f = true;
    for (int i = 2, p; i <= n; ++i) {
        cin >> p;
        g[p].push_back(i);
        pred[i] = p;
        if (p != i - 1) f = false;
    }
    for (int i = 1; i <= n; ++i) {
        cin >> a[i].X >> a[i].Y;
    }
    dfs();
    DSU dsu(n);
    int q;
    cin >> q;
    for (int j = 0; j < q; ++j) {
        int x, y, c, d;
        cin >> x >> y >> c >> d;
        int len = abs(x - y);
        if (f) {
            if (j <= 100) {
                for (int i = 0; i <= len; ++i) {
                    int nx = (x < y ? x + i : x - i);
                    int ny = (c < d ? c + i : c - i);
                    dsu.unite(nx, ny);
                }
            } else {
                for (int i = 0; i < ab && x + i <= y; ++i) {
                    int nx = (x < y ? x + i : x - i);
                    int ny = (c < d ? c + i : c - i);
                    dsu.unite(nx, ny);
                    nx = (x < y ? y - i : y + i);
                    ny = (c < d ? d - i : d + i);
                    dsu.unite(nx, ny);
                }
                for (int jj = 0; jj < ab; ++jj) {
                    int i = rnd() % (y - x + 1);
                    if (x + i <= y && x + i >= x) {
                        int nx = (x < y ? x + i : x - i);
                        int ny = (c < d ? c + i : c - i);
                        dsu.unite(nx, ny);
                        nx = (x < y ? y - i : y + i);
                        ny = (c < d ? d - i : d + i);
                        dsu.unite(nx, ny);
                    }
                }
            }
        } else {
            vector<int> w1 = get_way(x, y), w2 = get_way(c, d);
            for (int i = 0; i < w1.size(); ++i) {
                dsu.unite(w1[i], w2[i]);
            }
        }
        cout << ans << "\n";
    }
}