#include<bits/stdc++.h>
using namespace std;
const long long maxn = 100001;
long long n,m;
long long p[maxn];

long long leader[maxn];
long long rang[maxn];

pair<long long,long long>range[maxn];

vector<long long>v[maxn];
long long used[maxn];

long long query;
vector<long long>x;
vector<long long>y;

long long lamp = 0;
long long mod = 1e9 + 7;

void read()
{
    cin >> n;
    for( long long i = 2; i <= n; i ++ )
    {
        cin >> p[i];
        v[i].push_back(p[i]);
        v[p[i]].push_back(i);
    }

    for( long long i = 1; i <= n; i ++ )
    {
        long long l,r;
        cin >> range[i].first >> range[i].second;
    }
}

void dfs1( long long w, vector<long long>path )
{
    path.push_back(w);
    used[w] = 1;

    if( w == query )
    {
        x = path;
        return;
    }

    long long sz = v[w].size();
    for( long long i = 0; i < sz; i ++ )
    {
        long long nb = v[w][i];
        if( used[nb] == 0 )
        {
            dfs1(nb,path);
        }
    }
    return;
}

void dfs2( long long w, vector<long long>path )
{
    path.push_back(w);
    used[w] = 1;

    if( w == query )
    {
        y = path;
        return;
    }

    long long sz = v[w].size();
    for( long long i = 0; i < sz; i ++ )
    {
        long long nb = v[w][i];
        if( used[nb] == 0 )
        {
            dfs2(nb,path);
        }
    }
    return;
}

void init_dsu()
{
    for( long long i = 1; i <= n; i ++ )
    {
        leader[i] = i;
        rang[i] = 1;
    }
}

long long find_leader( long long w )
{
    if( leader[w] == w ) return w;
    leader[w] = find_leader(leader[w]);
    return leader[w];
}

void DSU( long long a, long long b )
{
    long long la = find_leader(a);
    long long lb = find_leader(b);

    if( la == lb ) return;

    if( rang[lb] > rang[la] ) swap(la,lb);

    rang[la] += rang[lb];
    leader[lb] = la;

    range[la].first = max( range[la].first, range[lb].first );  /// NB!!!!!!!!!!!!!
    range[la].second = min( range[la].second, range[lb].second );  /// NB!!!!!!!!!!!!!

    if( range[la].first > range[la].second ) lamp = 1;
}

void help1( int a, int b, int c, int d )
{
    vector<long long>path;
    memset(used,0,sizeof(used));

    query = b;
    dfs1(a,path);

    memset(used,0,sizeof(used));

    query = d;
    dfs2(c,path);
}

void help2( int a, int b, int c, int d )
{
    x.clear();
    y.clear();

    if( a > b )
    {
        for( int i = a; i <= b; i ++ )
            x.push_back(i);
    }
    else
    {
        for( int i = a; i >= b; i -- )
            x.push_back(i);
    }

    if( c > d )
    {
        for( int i = c; i <= d; i ++ )
            y.push_back(i);
    }
    else
    {
        for( int i = c; i >= d; i -- )
            y.push_back(i);
    }
}
void solve()
{
    cin >> m;
    for( long long i = 1; i <= m; i ++ )
    {
        long long a,b,c,d;
        cin >> a >> b >> c >> d;

        if( lamp == 1 )
        {
            cout << 0 << endl;
            continue;
        }

        if( n <= 300 ) help1(a,b,c,d);
        else help2(a,b,c,d);

        long long sz = x.size();
        for( long long j = 0; j < sz; j ++ )
        {
            long long nb1 = x[j];
            long long nb2 = y[j];

            DSU(nb1,nb2);
        }

        if( lamp == 1 )
        {
            cout << 0 << endl;
            continue;
        }

        long long ans = 1;
        for( long long j = 1; j <= n; j ++ )
        {
            long long lj = find_leader(j);
            if( lj == j )
            {
                ans *= ( range[j].second - range[j].first + 1 );
                ans %= mod;
            }
        }

        cout << ans << endl;
    }
}
int main()
{
    read();
    init_dsu();
    solve();
    return 0;
}
