/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll mod = 1e9 + 7;
const int maxn = 4e5 + 10, maxlog = 21;

ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2 == 1)
            ans = (ans * base) % mod;
        base = (base * base) % mod;
        st /= 2;
    }
    return ans;
}

int n, p[maxn], par_idx[maxn];
ll l[maxn], r[maxn];
vector < int > child[maxn];
bool chain;
void input()
{
    cin >> n;
    chain = true;
    for (int i = 2; i <= n; i ++)
    {
        cin >> p[i];
        if (p[i] != i - 1)
            chain = false;
        par_idx[i] = child[p[i]].size();
        child[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i ++)
        cin >> l[i] >> r[i];
}

int f[2 * maxn], tin[maxn], tout[maxn], timer;
int depth[maxn];

void dfs(int v)
{
    f[++ timer] = v;
    tin[v] = timer;
    for (int u : child[v])
    {
        depth[u] = depth[v] + 1;
        dfs(u);
        f[++ timer] = v;
    }
    tout[v] = timer;
}

int dp[maxlog][maxn * 2], lg[maxn * 2];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
    {
        dp[0][i] = f[i];
        lg[i] = lg[i / 2] + 1;
    }

    for (int j = 1; j < lg[timer]; j ++)
    {
        for (int i = 1; i <= timer - (1 << j) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (depth[dp[j - 1][i + (1 << (j - 1))]] < depth[dp[j][i]])
                dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
        }
    }

}

int lca_visit[maxn];
int get_lca(int v, int u)
{
    /**int sv = v;
    while(v != 1)
    {
        lca_visit[v] = 1;
        v = p[v];

    }
    lca_visit[v] = 1;
    int lca = u;
    while(!lca_visit[lca])
        lca = p[lca];
    while(sv != 1)
    {
        lca_visit[sv] = 0;
        sv = p[sv];

    }
    lca_visit[sv] = 0;
    return lca;*/

    int left = tin[v], right = tin[u];
    if (left > right)
        swap(left, right);
    int len = lg[right - left + 1] - 1;
    int ans = dp[len][left];
    if (depth[dp[len][right - (1 << len) + 1]] < depth[ans])
        ans = dp[len][right - (1 << len) + 1];
    return ans;
}

ll all_ways, inv[maxn];
void get_math()
{
    all_ways = 1;
    for (int i = 1; i <= n; i ++)
    {
        all_ways = (all_ways * (ll)(r[i] - l[i] + 1)) % mod;
        inv[i] = power(r[i] - l[i] + 1, mod - 2);
    }
}

int q;
int path[2][maxn], used[maxn];
ll up[maxn], down[maxn];
int lead[maxn];
int find_leader(int v)
{
    if (lead[v] == v)
        return v;
    return (lead[v] = find_leader(lead[v]));
}

ll pw[maxn];
struct node
{
    ll left_hash, right_hash;
    ll node_size;

    node()
    {
        left_hash = 0;
        right_hash = 0;
        node_size = 0;
    }
};

node tree[4 * maxn];
node merge_node(node lf, node rf)
{
    node mf;
    mf.left_hash = rf.left_hash * pw[lf.node_size] + lf.left_hash;
    mf.right_hash = lf.right_hash * pw[rf.node_size] + rf.right_hash;
    mf.node_size = lf.node_size + rf.node_size;
    return mf;
}

void build_tree(int root, int left, int right)
{
    if (left == right)
    {
        tree[root].left_hash = tree[root].right_hash = find_leader(left);
        tree[root].node_size = 1;
        return;
    }

    int mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
}

void update(int root, int left, int right, int pos)
{
    if (left == right)
    {
        tree[root].left_hash = tree[root].right_hash = find_leader(left);
        tree[root].node_size = 1;
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        update(root * 2, left, mid, pos);
        else
            update(root * 2 + 1, mid + 1, right, pos);

        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
}

node query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return node();
    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return merge_node(query(root * 2, left, mid, qleft, qright),
                      query(root * 2 + 1, mid + 1, right, qleft, qright));
}

vector < int > lead_set[maxn];
void  unite(int v, int u, int type = 0)
{
    v = find_leader(v);
    u = find_leader(u);
    if (v == u)
        return;

    if (rand() % 2)
        swap(v, u);
        if (type)
        {
            if (lead_set[v].size() < lead_set[u].size())
                swap(v, u);
        }
        if (up[v] >= down[v])
        all_ways = (all_ways * power(up[v] - down[v] + 1, mod - 2)) % mod;
                if (up[u] >= down[u])
        all_ways = (all_ways * power(up[u] - down[u] + 1, mod - 2)) % mod;
    lead[u] = v;
    up[v] = min(up[u], up[v]);
    down[v] = max(down[u], down[v]);
    if (type)
    {
        for (int ver : lead_set[u])
        {
            update(1, 1, n, ver);
            lead_set[v].push_back(u);
        }
        lead_set[u].clear();
    }
    all_ways = (all_ways * max((ll)(0), up[v] - down[v] + 1)) % mod;
}

int bef[maxn], aft[maxn];

ll get_hash(int a, int b, int mf)
{
    if (a <= b)
    {
        return query(1, 1, n, a, a + mf - 1).right_hash;
    }
    else
    {
        return query(1, 1, n, a - mf + 1, a).left_hash;
    }
}

int get_pos(int a, int b, int mf)
{
    if (a <= b)
        return a + mf - 1;
    else
    {
        return a - mf + 1;
    }
}

void solve_chain()
{
    pw[0] = 1;
    for (int i = 1; i <= n; i ++)
    {
        pw[i] = pw[i - 1] * mod;
        lead[i] = i;
        up[i] = r[i];
        down[i] = l[i];
        lead_set[i].push_back(i);
    }
     build_tree(1, 1, n);

     cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        while(true)
        {
            int lf = 1, rf = abs(b - a + 1);
            while(lf <= rf)
            {

                int mf = (lf + rf) / 2;
            ll hs1 = get_hash(a, b, mf);
            ll hs2 = get_hash(c, d, mf);
            if (hs1 == hs2)
                lf = mf + 1;
            else
                rf = mf - 1;
            }
            if (lf > abs(b - a + 1))
                break;
            int pos1 = get_pos(a, b, lf);
            int pos2 = get_pos(c, d, lf);
            ///cout << lf << " " << pos1 << " " << pos2 << endl;
            unite(pos1, pos2, 1);
        }
        cout << all_ways << endl;
    }
}


int get_path(int a, int b, int t)
{
    int lca = get_lca(a, b), len = depth[a] + depth[b] - 2 * depth[lca] + 1;
    int front_index = 1, back_index = len;
    while(a != lca)
    {
        path[t][front_index ++] = a;
        ///used[a] = 1;
        a = p[a];
    }
    path[t][front_index ++] = a;
    ///used[a] = 1;

    while(b != lca)
    {
        path[t][back_index --] = b;
        ///used[b] = 1;
        b = p[b];
    }

    return len;
}

void solve_queries()
{
    cin >> q;
    for (int i = 1; i <= n; i ++)
    {
        lead[i] = i;
        up[i] = r[i];
        down[i] = l[i];
    }
    for (int i = 1; i <= q; i ++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int sz = get_path(a, b, 0);
        get_path(c, d, 1);


        for (int j = 1; j <= sz; j ++)
        {
            unite(path[0][j], path[1][j]);

        }


        cout << all_ways << endl;
    }
}


void solve()
{
    input();
    if (chain)
    {
        get_math();
        solve_chain();
        return;
    }
    dfs(1);
    get_math();
    build_sparse_table();

    solve_queries();
}

int main()
{
    ///speed();
    solve();
    return 0;
}
/**
5
1 2 3 4
2 4
1 3
2 4
1 3
4 4
4
1 2 4 3
*/
