#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;
const ll MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

vector<ll> dsu, sz;

ll get(ll a) {
    if (dsu[a] == a)
        return a;
    return dsu[a] = get(dsu[a]);
}

ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    if (b % 2)
        return (binpow(a, b - 1) * a) % MOD;
    ll c = binpow(a, b / 2);
    return (c * c) % MOD;
}

void merge(ll a, ll b) {
    a = get(a);
    b = get(b);
    if (a == b)
        return;
    if (sz[a] >= sz[b]) {
        dsu[b] = a;
        sz[a] += sz[b];
    } else {
        dsu[a] = b;
        sz[b] += sz[a];
    }
}

pair<ll, ll> merge(pair<ll, ll> a, pair<ll, ll> b) {
    if (max(a.first, b.first) > min(a.second, b.second))
        return {0, -1};
    return {max(a.first, b.first), min(a.second, b.second)};
}

ll t = 0;

void dfs(ll s, vector<vector<ll>> &g, vector<ll> &tin, vector<ll> &tout) {
    tin[s] = t++;
    for (ll i: g[s])
        dfs(i, g, tin, tout);
    tout[s] = t++;
}

void upd(ll a, ll b, ll c, ll d, ll &ans, vector<ll> &p, vector<ll> &tin, vector<ll> &tout,
         vector<pair<ll, ll>> &v) {
    vector<ll> f, f1, s, s1;
    while (tin[a] > tin[b] || tout[a] < tout[b]) {
        f.push_back(a);
        a = p[a];
    }
    f.push_back(a);
    while (b != a) {
        f1.push_back(b);
        b = p[b];
    }
    for (ll i = (ll) f1.size() - 1; i >= 0; i--) {
        f.push_back(f1[i]);
    }

    while (tin[c] > tin[d] || tout[c] < tout[d]) {
        s.push_back(c);
        c = p[c];
    }
    s.push_back(c);
    while (c != d) {
        s1.push_back(d);
        d = p[d];
    }
    for (ll i = (ll) s1.size() - 1; i >= 0; i--) {
        s.push_back(s1[i]);
    }
    for (ll i = 0; i < s.size(); i++) {
        if (get(f[i]) == get(s[i]))
            continue;
        ans *= binpow(v[get(f[i])].second - v[get(f[i])].first + 1, MOD - 2);
        ans %= MOD;
        ans *= binpow(v[get(s[i])].second - v[get(s[i])].first + 1, MOD - 2);
        ans %= MOD;
        auto p = merge(v[get(f[i])], v[get(s[i])]);
        merge(f[i], s[i]);
        v[get(f[i])] = p;
        ans *= (p.second - p.first + 1);
        ans %= MOD;
    }

}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> g(n);
    vector<ll> p(n);
    for (ll i = 1; i < n; i++) {
        ll a;
        cin >> a;
        a--;
        p[i] = a;
        g[a].push_back(i);
    }
    vector<pair<ll, ll>> v(n);
    for (auto &[a, b]: v)
        cin >> a >> b;
    ll ans = 1;
    for (auto[a, b]: v) {
        ans *= (b - a + 1);
        ans %= MOD;
    }
    vector<ll> tin(n), tout(n);
    dfs(0, g, tin, tout);
    dsu.resize(n);
    sz.resize(n, 1);
    for (ll i = 0; i < n; i++)
        dsu[i] = i;
    ll m;
    cin >> m;
    while (m--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        upd(a, b, c, d, ans, p, tin, tout, v);
        ans %= MOD;
        cout << ans % MOD << '\n';
    }


}