#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

ld eps = 1e-12;

int main() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (n == 1) {
		if (a[0] >= k) {
			cout << fixed << setprecision(15) << ld(a[0] / k) / ld(a[0]) * k;
		}
		else {
			cout << fixed << setprecision(15) << 0.0;
		}
		return 0;
	}
	if (n == 2) {
		ll b1;
		ld ans = 0;
		for (ll b0 = 1; b0 <= a[0]; b0++) {
			b1 = (k - 1) / b0 + 1;
			ans = max(ans, (a[0] / b0) * (a[1] / b1) / ld(a[0] * a[1]) * ld(k));
		}
		cout << fixed << setprecision(15) << ans;
		return 0;
	}
	sort(a.begin(), a.end());
	vector<ld> prev(k + 1, 0), next(k + 1, 0);
	prev[1] = 1;
	for (ll i = 0; i < n; i++) {
		for (ll j = 1; j <= k; j++) {
			ll b = 1, x;
			ll cnt = 0;
			while (b <= min(a[i], k)) {
				cnt++;
				x = (j - 1) / b + 1;
				if (next[j] > ld(a[i] / b) / ld(a[i]) + eps) {
					break;
				}
				next[j] = max(next[j], prev[x] * ld(a[i] / b) / ld(a[i]));
				if (x == 1) {
					break;
				}
				b = (j - 1) / (x - 1) + 1;
			}
		}
		prev = next;
	}
	cout << fixed << setprecision(15) << prev[k] * k;
}

/*
1 2
5

2 6
5 10

2 7
4 4

2 3
4 5

4 444
57 179 239 2

2 5
2 2

*/