#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void output(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;

void solve() {
    int n, k; cin >> n >> k;
    vector<vector<int>> d(k+1);
    for (int i = 1; i<=k; ++i) {
        for (int j = 1; j*j <= i; ++j) {
            if (i%j) continue;
            d[i].emplace_back(j);
            if (j*j != i) d[i].emplace_back(i/j);
        }
        sort(all(d[i]));
    }
    vector<int> a(n), suf(n); input(a);
    bool fl = false;
    int val = a[0];
    for (int i = 1; i<n; ++i) {
        val *= a[i];
        if (val >= k) fl = true;
    }
    if (!fl && val < k) {
        cout << "0\n";
        return;
    }
    for (int i = n-1; i>=0; --i) {
        suf[i] = (i == n-1 ? a[i] : suf[i+1]*a[i]);
    }
    long double add = k;
    for (int i = 0; i<n; ++i) add /= a[i];
    vector<vector<int>> dp(n, vector<int> (k+1));
    for (int i = 1; i<=min(k, a[0]); ++i) {
        dp[0][i] = a[0]/i;
    }
    for (int i = 1; i<n-1; ++i) {
        for (int j = 1; j<=k; ++j) {
            for (auto lst : d[j]) {
                if (lst > a[i]) break;
                assign_max(dp[i][j], dp[i-1][j/lst]*(a[i]/lst));
            }
        }
    }
    int res = dp[0][k]*(n == 1 ? 1 : suf[1]);
    for (int i = 0; i<n-1; ++i) {
        for (int j = 1; j<k; ++j) {
            assign_max(res, dp[i][j] * (a[i+1]/((k+j-1)/j)) * (i == n-2 ? 1 : suf[i+2]));
        }
    }
    cout << setprecision(20) << (long double)res*add << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
