use std::io::{self, prelude::*};

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());

    let (n, k): (usize, _) = (scan.token(), scan.token::<usize>());
    if k == 1 {
        return writeln!(w, "1");
    }
    if n == 1 {
        let a: usize = scan.token();
        writeln!(w, "{}", (a as f64 / k as f64).floor() * (1.0 / a as f64) * k as f64)
    } else {
        let (a, b): (usize, usize) = (scan.token(), scan.token());
        let mut ans = 0.0;
        for i in 1..=k {
            let c = (k + i - 1) / i;
            let val = (a as f64 / i as f64).floor() * (b as f64 / c as f64).floor() * (a as f64 * b as f64).recip() * k as f64;
            if val > ans {
                ans = val;
            }
        }
        writeln!(w, "{ans}")
    }
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
