#pragma GCC optimize("O3", "Ofast")
#pragma GCC target("avx", "avx2")
#include <bits/stdc++.h>
using namespace std;
const long double eps = 1e-9;

int sign(long double x) {
    if (x > eps) { return 1; }
    if (x < -eps) { return -1; }
    return 0;
}

long double _max(long double a, long double b) {
    if (sign(a - b) == -1) {
        return b;
    }
    return a;
}
vector<pair<int, long double>> tmpDp, dp;

void correct() {
    sort(tmpDp.begin(), tmpDp.end());
    dp.clear();
    for (int i = 0; i < (int)tmpDp.size(); ++i) {
        while (!dp.empty() && dp.back().second <= tmpDp[i].second) {
            dp.pop_back();
        }
        dp.emplace_back(tmpDp[i]);
    }
    tmpDp.clear();
}

void solve() {
    int n;
    long long k;
    cin >> n >> k;
    vector<int> a(n);
    vector<vector<pair<int, int>>> cut(n);
    vector<pair<int, int>> tmp;
    // int maxa = 0;
    tmpDp.clear();
    dp.clear();
    long double part = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        part /= a[i];
        tmp.clear();
        for (int x = 1; x * 1ll * x <= a[i]; ++x) {
            tmp.emplace_back(a[i] / x, x);
            int y = a[i] / x;
            for (int dy = 1; dy >= -1; --dy) {
                if (y + dy >= 1 && y + dy <= a[i] && a[i] / (y + dy) == x) {
                    tmp.emplace_back(x, y + dy);
                    break;
                }
            }
        }
        sort(tmp.begin(), tmp.end());
        for (const auto& [cost, b] : tmp) {
            if (cut[i].empty() || cut[i].back().first != cost) {
                cut[i].emplace_back(cost, b);
            }
            cut[i].back().second = b;
        }
        // maxa = max(maxa, a[i]);
    }
    cout << fixed << setprecision(10);
    if (n <= 2) {
        if (n == 1) {
            if (a[0] < k) {
                cout << 0 << '\n';
            } else {
                cout << int(a[0] / k) * part * k << '\n';
            }
        } else {
            if (a[0] * 1ll * a[1] < k) {
                cout << 0 << '\n';
            } else {
                long long ans = 0;
                for (int b = 1; b <= a[0]; ++b) {
                    int b2 = (k + b - 1) / b;
                    if (b2 <= a[1]) {
                        ans = max(ans, (a[0] / b) * 1ll * (a[1] / b2));
                    }
                }
                cout << ans * part * k << '\n';
            }
        }
        return;
    }
    dp.emplace_back(1, 1);
    for (int i = 0; i < n; ++i) {
        for (int l = 0; l < (int)cut[i].size(); ++l) {
            int cost = cut[i][l].first, b = cut[i][l].second;
            for (int m = 0; m < (int)dp.size(); ++m) {
                tmpDp.emplace_back(min(dp[m].first * 1ll * b, k), dp[m].second * cost);
            }
        }
        correct();
    }
    if (dp.empty() || dp.back().first < k) {
        cout << 0 << '\n';
    } else {
        cout << dp.back().second * k * part << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
