#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 2e9;

int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cout << fixed << setprecision(20);
    if (n == 1) {
        ld ans = 0;
        if (a[0] >= k) {
            ans = max(ans, ((ld)1 / a[0]) * (a[0] / k) * k);
            //cout << (ld)(1 / a[0]) << ' ' << (a[0] / k) * k << '\n';
        }
        cout << ans << '\n';

        return 0;
    }
    if (n == 2) {
        if (a[0] * a[1] < k) {
            cout << 0 << '\n';
            return 0;
        }

        ld ans = 0;
        for (int i = 1; i <= a[0]; ++i) {
            int j = (k + i - 1) / i;
            if (j > a[1] || j < 0) {
                continue;
            }

            ans = max(ans, (a[0] / i) * (a[1] / j) * ((ld)1 / a[0]) * ((ld)1 / a[1]) * k);
        }
        cout << ans << '\n';
        return 0;
    }

    vector<vector<ld>> dp(n + 1, vector<ld>(k + 1, 0));
    dp[0][1] = 1;
    for (ll i = 1; i <= n; ++i) {
        for (ll j = 1; j <= k; ++j) {
            if (dp[i - 1][j] == 0) {
                continue;
            }
            for (ll bi = 1; bi <= a[i - 1]; ++bi) {
                dp[i][min(j * bi, k)] = max(dp[i - 1][j] * (a[i - 1] / bi), dp[i][min(j * bi, k)]);
            }
        }
        for (int j = 1; j <= k; ++j) {
            dp[i][j] /= a[i - 1];
        }
    }

    ld ans = dp[n][k];
    ans *= k;

    cout << ans << '\n';

    return 0;
}
