#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>
#include <chrono>
#include <cassert>
#include <climits>

using namespace std;

using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
istream& operator>>(istream &in, vector <T> &arr) {
    for (T &i: arr) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream &out, const vector <T> &arr) {
    for (const T &i: arr) out << i << ' ';
    return out;
}

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

//#define int int64_t
//#define multitest

#pragma GCC target("fma")
#pragma GCC optimize("O3")
#pragma GCC optimize("trapv")

const long double eps = 1e-12;

vector <int> factorize(int x) {
    vector <int> ans = {1, x};
    int i = 2;
    while (i * i <= x) {
        if (x % i == 0) {
            ans.push_back(i);
            ans.push_back(x / i);
            x /= i;
        }
        ++i;
    }
    sort(all(ans));
    ans.resize(unique(all(ans)) - ans.begin());
    return ans;
}

void solve() {
    int n;
    cin >> n;
    if (n == 2) {
        int k;
        cin >> k;
        int a, b;
        cin >> a >> b;
        if (a > b) swap(a, b);
        long double ans = 0;
        for (int i = 1; i <= k; ++i) {
            int j = (k + i - 1) / i;
            int x = a / i;
            int y = b / j;
            ans = max(ans, ((long double)1 / a) * x * ((long double)1 / b) * y);
        }
        cout << setprecision(20) << fixed;
        cout << ans * k << '\n';
    } else {

    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
    auto start = clock();
#endif
    int t;
#ifdef multitest
    cin >> t;
#else
    t = 1;
#endif
    while (t --> 0) solve();
#ifdef LOCAL
    auto end = clock();
    cerr << "time: " << end - start << endl;
#endif
    return 0;
}
