
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return (a - b + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}

const int base = 179, mod = 1e9 + 7;
vector<int> powww;
vector<int> preff;

void build(string& s) {
	int n = s.size();
	preff.resize(n + 1);
	powww.resize(n + 1);
	powww[0] = 1;
	for (int i = 0; i < n; i++) {
		preff[i + 1] = ((ll)preff[i] * base + (s[i] - 'a') + 1) % mod;
		powww[i + 1] = (ll)powww[i] * base % mod;
	}
}

int hashh(int l, int r) {
	return subm(preff[r], mulm(powww[r - l], preff[l], mod), mod);
}

ll aaa1(int x1, int y1, int x2, int y2) {
	return (ll)x1 * y2 - (ll)x2 * y1;
}

ll aaa2(int x1, int y1, int x2, int y2) {
	return (ll)x1 * x2 + (ll)y1 * y2;
}

bool top(pair<int, int> a) {
	return (a.second > 0 || a.second == 0 && a.first > 0);
}

bool comp(pair<int, int> a, pair<int, int> b) {
	if (top(a) != top(b)) {
		return top(a);
	}
	if (aaa1(a.first, a.second, b.first, b.second) != 0) {
		return aaa2(a.first, a.second, a.first, a.second) < aaa2(b.first, b.first, b.second, b.second);
	} 
	return aaa1(a.first, a.second, b.first, b.second) > 0;
}

vector<pair<int, int>> build(int n, vector<pair<int, int>> arr) {
	int idx = 0;
	for (int i = 0; i < n; i++) {
		if (arr[i].second < arr[idx].second || arr[i].second == arr[idx].second && arr[i].first < arr[idx].first) {
			idx = i;
		}
	}
	vector<pair<int, int>> aaa;
	for (int i = 0; i < n; i++) {
		if (i != idx) {
			aaa.push_back({ arr[i].first - arr[idx].first, arr[i].second - arr[idx].second });
		}
	}
	sort(aaa.begin(), aaa.end(), comp);
	vector<pair<int, int>> res;
	res.push_back({ 0, 0 });
	for (auto el : aaa) {
		while (res.size() > 1 && aaa1(res.back().first - res[res.size() - 2].first, res.back().second - res[res.size() - 2].second,
			el.first - res.back().first, el.second - res.back().second) > 0) {
			res.pop_back();
		}
		res.push_back(el);
	}
	for (auto& el : res) {
		el.first += arr[idx].first;
		el.second += arr[idx].second;
	}
	return res;
}

map<ll, long double> dp[101];

long double solve(int n, vector<int>& arr, int k, ll tmp, int idx, long double eee) {
	if (dp[idx].find(tmp) != dp[idx].end()) {
		return dp[idx][tmp];
	}
	if (idx == n) {
		if (tmp < k) {
			return 0;
		}
		else {
			return eee;
		}
	}
	long double mx = 0;
	for (int i = 1; i <= arr[idx]; i++) {
		long double new_eee = eee * (int)(arr[idx] / i);
		new_eee /= arr[idx];
		mx = max(mx, solve(n, arr, k, tmp * i, idx + 1, new_eee));
		if (tmp * i >= k) {
			break;
		}
	}
	return dp[idx][tmp] = mx;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, k;
	cin >> n >> k;
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	long double eee = k;
	cout << fixed << setprecision(10) << solve(n, arr, k, 1, 0, eee) << '\n';
	
	
	
	
	/*int n;
	cin >> n;
	vector<vector<int>> arr(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		arr[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> arr[i][j];
		}
	}
	sort(arr.begin(), arr.end(), [](vector<int> a, vector<int> b) {
		return *max_element(a.begin(), a.end()) < *max_element(b.begin(), b.end()); });
	vector<int> dp(n);
	vector<int> maxx(n);
	for (int i = 0; i < n; i++) {
		maxx[i] = *max_element(arr[i].begin(), arr[i].end());
	}
	for (int i = 0; i < n; i++) {
		int MX = -1;
		for (auto el : arr[i]) {
			if (el > MX) {
				MX = el;
				dp[i]++;
			}
		}
		for (int j = 0; j < i; j++) {
			int MX = maxx[j];
			int cntt = 0;
			for (auto el : arr[i]) {
				if (el > MX) {
					cntt++;
					MX = el;
				}
			}
			dp[i] = max(dp[i], dp[j] + cntt);
		}
	}
	cout << *max_element(dp.begin(), dp.end());*/
}