#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <stack>
#include <set>

typedef long long llong;
const int MAXNUM = 10000000 + 10;
const int MAXN = 100 + 10;

int n, k;
int a[MAXN];
std::vector <int> possible[MAXN];
std::vector <std::pair <long double, int>> left, right;
void recurse(int num, int idx, int to, long double prodDiv, int prod, std::vector <std::pair <long double, int>> &store)
{
    if (num == to)
    {
        store.push_back({prodDiv, prod});
        return;
    }

    recurse(num + 1, 0, to, prodDiv * (long double)possible[num][idx] / (long double)a[num], prod * (a[num] / possible[num][idx]), store);
    if (idx + 1 < possible[num].size() && 1LL * prod * (a[num] / possible[num][idx]) <= k) recurse(num, idx + 1, to, prodDiv, prod, store);
}

inline int findLOG(int num)
{
    int log = 0;
    while ((1 << log) < num) log++;
    return log;
}

void solve()
{
    std::sort(a + 1, a + 1 + n, std::greater <int> ());
    n = std::min(findLOG(k), n);

    for (int i = 1 ; i <= n ; ++i)
    {
        int sq = sqrt(a[i]);
        for (int j = 1 ; a[i] / j > sq ; ++j)
        {
            possible[i].push_back(a[i] / j);
        }

        for (int j = sq ; j >= 1 ; --j)
        {
            possible[i].push_back(j);
        }
    }

    recurse(1, 0, 1 + n / 2, k, 1, left);
    recurse(1 + n / 2, 0, n + 1, 1.0, 1, right);

    // std::sort(left.begin(), left.end(), [&](const auto &x, const auto &y)
    // {
    //     return x.second < y.second;
    // });

    // std::sort(right.begin(), right.end(), [&](const auto &x, const auto &y)
    // {
    //     return x.second > y.second;
    // });

    int rPtr = -1;
    long double ans = 0.0;
    long double max = 0.0;

    for (const auto &currLeft : left)
    {
        for (const auto &currRight : right)
        {
            if (1LL * currLeft.second * currRight.second >= k)
            {
                ans = std::max(ans, currLeft.first * currRight.first);
            }
        }
    }

    // for (int lPtr = 0 ; lPtr < left.size() ; ++lPtr)
    // {
    //     while (rPtr + 1 < right.size() && 1LL * left[lPtr].second * right[rPtr + 1].second >= k)
    //     {
    //         rPtr++;
    //         max = std::max(max, right[rPtr].first);
    //     }

    //     if (rPtr >= 0)
    //     {
    //         ans = std::max(ans, left[lPtr].first * max);
    //     }
    // }

    std::cout << std::fixed << std::setprecision(12) << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}