#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <stack>
#include <set>

typedef long long llong;
const int MAXNUM = 10000000 + 10;
const int MAXN = 100 + 10;

int n, k;
int a[MAXN];
long double ans;
std::vector <int> possible[MAXN];
std::vector <std::pair <long double, int>> left, right;
void recurse(int num, int idx, long double prodDiv, int prod)
{
    if (num == n + 1 || prod >= k)
    {
        if (prod < k) return;
        ans = std::max(ans, prodDiv);
        return;
    }

    recurse(num + 1, 0, prodDiv * (long double) possible[num][idx] / (long double) a[num], prod * (a[num] / possible[num][idx]));
    if (idx + 1 < possible[num].size() && 1LL * prod * (a[num] / possible[num][idx]) < k) recurse(num, idx + 1, prodDiv, prod);
}

inline int findLOG(int num)
{
    int log = 0;
    while ((1 << log) < num) log++;
    return log;
}

void solve()
{
    std::sort(a + 1, a + 1 + n, std::greater <int> ());
    n = std::min(findLOG(k) + 1, n);

    for (int i = 1 ; i <= n ; ++i)
    {
        int sq = sqrt(a[i]);
        for (int j = 1 ; j <= a[i] ; ++j)
        {
            if (a[i] / j == a[i] / (j + 1)) continue;
            possible[i].push_back(a[i] / j);
        }
    }

    recurse(1, 0, 1.0, 1);

    ans *= k;
    std::cout << std::fixed << std::setprecision(12) << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}