#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

namespace Solven1 {
    void solve(int k, int cnt0) {
        if (k > cnt0) {
            cout << "0\n";
            return;
        }
        cout.precision(10);
        cout << fixed;
        cout << (cnt0 / k) * 1.L / cnt0 * k << "\n";
    }
}

namespace Solven2 {
    void solve(int n, int k, vector<int>& cnt) {
        int bestres = 0;
        for (int i = 1; i <= k; i++) {
            if (i <= cnt[0]) {
                int cnt2 = (k + i - 1) / i;
                if (cnt2 <= cnt[1]) {
                    bestres = max(bestres, (cnt[0] / i) * (cnt[1] / cnt2));
                }
            }
        }
        int ra = 1;
        for (int i = 0; i < n; i++) {
            ra *= cnt[i];
        }
        cout.precision(10);
        cout << fixed;
        cout << bestres * 1.L / ra * k << "\n";
    }
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<int> cnt(n);
    for (int i = 0; i < n; i++) {
        cin >> cnt[i];
    }

    if (n == 1) {
        Solven1::solve(k, cnt[0]);
    } else if (n == 2) {
        Solven2::solve(n, k, cnt);
    }
    return 0;
}
