#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

namespace Solven1 {
    void solve(int k, int cnt0) {
        if (k > cnt0) {
            cout << "0\n";
            return;
        }
        cout.precision(10);
        cout << fixed;
        cout << (cnt0 / k) * 1.L / cnt0 * k << "\n";
    }
}

namespace Solven2 {
    void solve(int n, long long k, vector<long long>& cnt) {
        long long bestres = 0;
        for (int i = 1; i <= max(k, cnt[0]); i++) {
            if (i <= cnt[0]) {
                int cnt2 = (k + i - 1) / i;
                cnt2 = max(1, cnt2);
                if (cnt2 <= cnt[1]) {
                    bestres = max(bestres, (cnt[0] / i) * (cnt[1] / cnt2));
                }
            }
        }
        long long ra = 1;
        for (int i = 0; i < n; i++) {
            ra *= cnt[i];
        }
        cout.precision(10);
        cout << fixed;
        cout << bestres * 1.L / ra * k << "\n";
    }
}

int main() {
    int n;
    int k;
    cin >> n >> k;
    vector<long double> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (n == 1) {
        Solven1::solve(k, (int)a[0]);
        return 0;
    } else if (n == 2) {
        vector<long long> ac(n);
        for (int i = 0; i < n; i++) {
            ac[i] = (long long)a[i];
        }
        Solven2::solve(n, k, ac);
        return 0;
    }

    vector<vector<long double>> dp(n + 1, vector<long double>(k + 1));

    dp[0][1] = 1;

    for (int i = 1; i <= n; i++) {
        dp[i][1] = 1;
        for (int cnt = 1; cnt <= k; cnt++) {
            for (int prevcnt = cnt; prevcnt >= 1; prevcnt--) {
                int ccnt = (cnt + prevcnt - 1) / prevcnt;
                if (ccnt > a[i - 1]) {
                    break;
                }
                dp[i][cnt] = fmaxl(dp[i][cnt], dp[i - 1][prevcnt] * floor(a[i - 1] / ccnt));
            }
        }
    }

    long double res = dp[n][k];

    long double ck = 1.L;
    for (int i = 0; i < n; i++) {
        ck *= a[i];
    }

    ck = 1 / ck;
    ck *= k;
    ck *= dp[n][k];

    cout.precision(10);
    cout << fixed << "\n";
    cout << ck << "\n";
}
