#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

vector<int> factor(int x) {
    vector<int> res;
    for (int i = 2; i * i <= x; ++i) {
        while (x % i == 0) {
            x /= i;
            res.push_back(i);
        }
    }

    if (x != 1) {
        res.push_back(x);
    }
    return res;
}

double solve_2(int n, int k, vector<int> & a) {
    while (a.size() < 2)
        a.push_back(1);
    int res = 0;
    for (int i = 1; i <= a[0]; ++i) {
        int other = (k + i - 1) / i;
        int x = a[0] / i;
        int y = a[1] / other;
        res = max(res, x * y);
    }
    return 1.0 * k * res / a[0] / a[1];
}

vector<int> a;

int base;

const int maxn = 100;
const int maxk = 4e4;

double mem[maxn + 1][maxk + 1];

int suffmul[maxn + 1];

double f(int i, int k) {
    if (i == a.size()) {
        if (k <= 1)
            return base;
        return 0;
    }
    if (k > suffmul[i])
        return 0;

    if (mem[i][k] != 0)
        return mem[i][k];

    auto nxt = [&](int a, int x) {
        if (a / (x + 1) == 0)
            return a + 1;
        return a / (a / (x + 1));
    };
    double res = 0;
    for (int x = 1; x <= a[i]; x = nxt(a[i], x)) {
        int take = a[i] / x;
        res = max(res, f(i + 1, (k + x - 1) / x) * take / a[i]);
    }
    return mem[i][k] = res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    a.resize(n);
    for (int &e: a)
        cin >> e;

    suffmul[n] = 1;
    for (int i = n - 1; i >= 0; --i) {
        if (suffmul[i + 1] < inf)
            suffmul[i] = suffmul[i + 1] * a[i];
        else
            suffmul[i] = inf;
    }

    base = k;

    double r = f(0, k);
    cout << r << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(40);
    cout << fixed;
    solve();

    return 0;
}