#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n, k;
vector<long long> a;

long double ans = 0;

void check(vector<long long>& d, long double cur, long double zn, long long idx, vector<bool>& used)
{
	if (idx == d.size())
	{
		ans = max(ans, cur * k / zn);
		return;
	}
	if (clock() / (double)CLOCKS_PER_SEC >= 1.98)
	{
		cout << fixed << setprecision(20) << ans << "\n";
		exit(0);
	}

	for (long long i = 0; i < a.size(); i++)
	{
		if (a[i] < d[idx] || used[i])
		{
			continue;
		}

		used[i] = true;
		check(d, cur * (long long)(a[i] / d[idx]), zn * a[i], idx + 1, used);
		used[i] = false;
	}
}

void rec(long long idx, long long mul, long long prev, vector<long long>& d)
{
	if (idx == d.size())
	{
		if (mul >= k)
		{
			vector<bool> used(n);
			check(d, 1, 1, 0, used);
		}
		return;
	}
	if (clock() / (double)CLOCKS_PER_SEC >= 1.98)
	{
		cout << fixed << setprecision(20) << ans << "\n";
		exit(0);
	}

	long long here = prev;
	mul /= 2;
	while (mul * (here - 1) < k)
	{
		d[idx] = here;
		if (here > a[a.size() - d.size() + idx])
		{
			break;
		}

		rec(idx + 1, mul * here, here, d);
		here++;
	}
}

void solve()
{
	cin >> n >> k;
	a.resize(n);
	long long mul = 1;
	bool ok = false;
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
		mul *= a[i];
		if (mul >= k)
		{
			ok = true;
		}
	}
	if (!ok)
	{
		cout << 0 << "\n";
		return;
	}
	if (k == 1)
	{
		cout << 1 << "\n";
		return;
	}
	sort(a.begin(), a.end());

	long long lg2 = 0;
	long long kk = k;
	while (kk > 1)
	{
		lg2++;
		kk /= 2;
	}
	if ((1ll << lg2) < k)
	{
		lg2++;
	}

	for (long long notone = 1; notone <= min(n, lg2); notone++)
	{
		vector<long long> d(notone, 2);
		long long mul = (1ll << notone);
		rec(0, mul, 2, d);
	}
	cout << fixed << setprecision(20) << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	/*
		long double mx = 0;
	for (long long a = 1; a <= 57; a++)
	{
		for (long long b = 1; b <= 179; b++)
		{
			for (long long c = 1; c <= 239; c++)
			{
				for (long long d = 1; d <= 2; d++)
				{
					if (a * b * c * d < 444)
					{
						break;
					}

					long double cur = 57 / a;
					cur *= (long long)179 / b;
					cur *= (long long)239 / c;
					cur *= (long long)2 / d;
					cur /= 57.0 * 179.0 * 239.0 * 2.0;
					cur *= 444;
					mx = max(mx, cur);
					if (mx >= 0.97)
					{
						mx += 0;
					}
				}
			}
		}
	}
	*/

	solve();

	return 0;
}

/*























*/