#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

#define int long long

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcd(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<double> dp(k * 2);
    dp[1] = k;
    for (int i = 0; i < n; ++i) {
        vector<double> new_dp(dp.size());
        int now = a[i];
        int pr = 0;
        for (int cnt = now; cnt >= 1; --cnt) {
            int num = a[i] / cnt;
            if (num != pr) {
                double ln = 1.0 / a[i] * (double) num;
                for (int j = 1; j * cnt < dp.size(); ++j) {
                    new_dp[j * cnt] = max(dp[j * cnt], new_dp[j * cnt]);
                    new_dp[j * cnt] = max(new_dp[j * cnt], dp[j] * ln);
                }
            }
            pr = num;
        }
        swap(dp, new_dp);
    }
    double ans = 0;
    for (int i = k; i < dp.size(); ++i) {
        ans = max(ans, dp[i]);
    }
    cout.precision(20);
    cout << ans << "\n";
}