#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


const int MAXA = 2e7 + 1303;

vector<int> primes;
int lp[MAXA];

void prepare(){
    fill(lp, lp + MAXA, -1);
    for (int i = 2; i < MAXA; ++i){
        if (lp[i] == -1){
            lp[i] = i;
            primes.push_back(i);
        }
        for (int j = 0; j < primes.size() && primes[j] < lp[i] && i * primes[j] < MAXA; ++j){
            lp[i * primes[j]] = primes[j];
        }
    }
}

int gcd(int a, int b){
    while (a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(20);
    int n;
    int k;
    cin >> n >> k;
    vector<int> v(n);
    ll mul = 1;
    bool f = false;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        mul *= v[i];
        if (mul >= k) {
            f = true;
        }
    }
    if (!f) {
        cout << 0 << endl;
        return 0;
    }
    if (n <= 2){
        if (n == 1){
            int b0 = k;
            cout << int(v[0] / b0) / (ld)v[0] * (ld)k << endl;
        } else{
            ld mx = 0;
            for (int b0 = 1; b0 <= v[0]; ++b0) {
                int b1 = (k + b0 - 1) / b0;
                mx = max(mx, int(v[0] / b0) * int(v[1] / b1) / (ld)v[0] / (ld)v[1] * (ld)k);
            }
            cout << mx << endl;
        }
        return 0;
    }
#ifdef DEBUG
        cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}