#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


const int MAXA = 2e7 + 1303;

vector<int> primes;
int lp[MAXA];

void prepare(){
    fill(lp, lp + MAXA, -1);
    for (int i = 2; i < MAXA; ++i){
        if (lp[i] == -1){
            lp[i] = i;
            primes.push_back(i);
        }
        for (int j = 0; j < primes.size() && primes[j] < lp[i] && i * primes[j] < MAXA; ++j){
            lp[i * primes[j]] = primes[j];
        }
    }
}

int gcd(int a, int b){
    while (a != 0){
        b %= a;
        swap(a, b);
    }
    return b;
}

ld ans(int i, vector<int> &v, int n, int k){
    if (i == n - 1){
        int b = k;
        return int(v[i] / b) / (ld)v[i];
    }
    int l = 1;
    int r = v[i];
    while (r - l > 5){
        int ml = (2 * l + r) / 3;
        int mr = (l + 2 * r) / 3;
        ld al = ans(i + 1, v, n, (k + ml - 1) / ml) * int(v[i] / ml) / ld(v[i]);
        ld ar = ans(i + 1, v, n, (k + mr - 1) / mr) * int(v[i] / mr) / ld(v[i]);
        if (al > ar){
            r = mr;
        } else{
            l = ml;
        }
    }
    ld mx = 0;
    for (int x = l; x <= r; ++x){
        mx = max(mx, ans(i + 1, v, n, (k + x - 1) / x) * int(v[i] / x) / ld(v[i]));
    }
    return mx;
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    cout.precision(20);
    int n;
    int k;
    cin >> n >> k;
    vector<int> v(n);
    ll mul = 1;
    bool f = false;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        mul *= v[i];
        if (mul >= k) {
            f = true;
        }
    }
    if (!f) {
        cout << 0 << endl;
        return 0;
    }
    cout << ans(0, v, n, k) * (ld)k << endl;
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}