#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

const int N = (int) 2e7;
float dp[N], dp2[N];

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 1; i < k * 2; ++i) {
		dp[i] = 0.0;
		if (i <= a.front()) {
			dp[i] = (a.front() / i) / (float) a.front();
		}
	}
	for (int i = 1; i + 1 < n; ++i) {
		for (int j = 0; j < k * 2; ++j) {
			dp2[j] = 0.0;
		}
		for (int l = 1; l * l <= a[i]; ++l) {
			int b = a[i] / l;
			for (int j = 1; j * l < k * 2; ++j) {
				ckmax(dp2[j * l], dp[j] * b);
			}
		}
		for (int b = 1; b * b <= a[i]; ++b) {
			int l = a[i] / b;
			for (int j = 1; j * l < k * 2; ++j) {
				ckmax(dp2[j * l], dp[j] * b);
			}
		}
		for (int j = 0; j < k * 2; ++j) {
			dp[j] = dp2[j] / (float) a[i];
		}
	}
	float ans = 0.0;
	for (int i = 1; i < k * 2; ++i) {
		int b = (k + i - 1) / i;
		//assert(b * i >= k);
		if (b <= a.back()) {
			ckmax(ans, dp[i] * (a.back() / b) / (float) a.back());
		}
	}
	cout << fixed << setprecision(20) << ans * k << endl;
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
