#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, k;
vector<ld>tree;
void upd(int i, ld x, int l = 0, int r = k, int v = 0) {
	if (i < l || r <= i)
		return;
	if (l + 1 == r) {
		tree[v] = max(tree[v], x);
		return;
	}
	int m = (l + r) / 2;
	upd(i, x, l, m, 2 * v + 1);
	upd(i, x, m, r, 2 * v + 2);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}
ld get(int ql, int qr = k, int l = 0, int r = k, int v = 0) {
	if (ql <= l && r <= qr)
		return tree[v];
	if (qr <= l || r <= ql)
		return 0;
	int m = (l + r) / 2;
	return max(get(ql, qr, l, m, 2 * v + 1), get(ql, qr, m, r, 2 * v + 2));
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	ld ans = 0;
	cin >> n >> k;
	if (k == 1) {
		cout << k;
		return 0;
	}
	vector<ld>dp(k);
	tree.resize(4 * k);
	dp[1] = 1;
	upd(1, 1);
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		ld xld = x;
		for (int cnt = 1; cnt <= x; cnt++) {
			int my_s = (k + cnt - 1) / cnt;
			if (my_s < k)
				ans = max(ans, get(my_s) * (x / cnt) / xld);
		}
		for (int s = k - 1; s >= 1; s--) {
			if (dp[s] == 0)
				continue;
			for (int d = 1; d * d <= s; d++) {
				int v;
				if (d <= x) {
					v = d;
					dp[s] = max(dp[s], dp[s / v] * (x / v) / xld);
					upd(s, dp[s]);
				}
				if (s / d <= x) {
					v = s / d;
					dp[s] = max(dp[s], dp[s / v] * (x / v) / xld);
					upd(s, dp[s]);
				}
			}
		}
	}
	cout << setprecision(10) << fixed << ans * k;
	return 0;
}