#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

void solve() {

    ll n, k;
    cin >> n >> k;

    vector<ll> v(n);
    for (ll& x : v) cin >> x;

    vector<vector<ld>> dp(n, vector<ld>(k + 1, 0));
    for (int i = 0; i < n; i++) {
        for (int j = k; j >= 1; j--) {
            if (i == 0) {
                if (j <= v[i]) dp[i][j] = v[i] / j;
            } else {
                for (ll c = 1; c <= v[i];) {
                    ll d = j / c + ((j / c) * c != j);
                    dp[i][j] = max(dp[i][j], dp[i - 1][d] * (v[i] / c));

                    ll l = c, r = v[i] + 1;
                    while (l < r - 1) {
                        ll m = (l + r) / 2;

                        if (j / m + ((j / m) * m != j) || v[i] / m != v[i] / c) r = m;
                        else l = m;
                    }
                    c = r;
                }
            }
            dp[i][j] /= (ld)v[i];
        }
    }

    ld ans = dp[n - 1][k];
    cout << ans * (ld)k;

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cout << setprecision(10) << fixed;

    solve();

}