#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
//#define endl '\n'
#define pb push_back
#define int long long

const int INF = 2e9 + 333, N = 2e5 + 10;

vec<int> p(N, 1);

struct fenwick{
    int n;
    vec<int> tree;
    void init(int n_) {
        n = n_;
        tree.resize(n + 1);
    }
    void upd(int i, int a) {
        i++;
        for (; i <= n; i += i & -i) tree[i] = max(a, tree[i]);
    }
    int get(int x) {
        int s = 0;
        x++;
        for (; x > 0; x -= x & -x) s = max(s, tree[x]);
        return s;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector{
    ld x, y;
    Vector(ld x_, ld y_) {
        x = x_, y = y_;
    }
    friend Vector operator+(Vector& a, Vector& b) {
        return {a.x + b.x, a.y + b.y};
    }
    friend Vector operator-(Vector& a, Vector& b) {
        return {a.x + b.x, a.y + b.y};
    }
    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }
    friend ld operator%(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }
    ld len() {
        return x * x + y * y;
    }
    ld len2() {
        return sqrt(x * x + y * y);
    }
    void norm() {
        ld l = len2();
        x /= l, y /= l;
    }
};

struct Line {
    ld a, b, c;
    Line(ld a_, ld b_, ld c_) {
        a = a_, b = b_, c = c_;
    }
    ld rast(Vector p) {
        return (a * p.x + b * p.y + c) / ((sqrt(a * a + b * b)));
    }
};

struct Hash{
    vec<int> h;
    int n;
    void init(string& s) {
        n = (int)s.size();
        h.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            h[i] = (h[i - 1] * 37 + s[i] - 'a' + 1) % INF;
        }
    }
    int get(int l, int r) {
        return (((h[r + 1] - h[l] + INF) % INF) * p[N - l - 1]) % INF;
    }
};

bool comp(pair<int, vec<int>>& a, pair<int, vec<int>>& b) {
    return a.first < b.first;
}

void solve() {
    int n;
    cin >> n;
    vec<pair<int, vec<int>>> c(n);
    for (int i = 0; i < n ;++i) {
        int k;
        cin >> k;
        int mx = 0;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            mx = max(x, mx);
            c[i].second.pb(x);
        }
        c[i].first = mx;
    }
    sort(all(c), comp);
    fenwick tree;
    tree.init(N);
    for (int i = 0; i < n; ++i) {
        int ans = 0, pred = 0;
        for (int j : c[i].second) {
            if (pred < j) {
                pred = j;
                ans++;
                ans = max(ans, tree.get(j - 1) + 1);
            }
        }
        tree.upd(c[i].first, ans);
    }
    cout << tree.get(N - 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 1; i < N; ++i) p[i] = (p[i - 1] * 37) % INF;
    solve();
}